/* Mapbox GL JS is licensed under the 3-Clause BSD License. Full text of license: https://github.com/mapbox/mapbox-gl-js/blob/v1.12.1-6/LICENSE.txt 
* Copyright (c) 2016, Mapbox
* Copyright© 2000 - 2023 SuperMap Software Co. Ltd
* 20240919
*/
(function (global, factory) {
typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
typeof define === 'function' && define.amd ? define(factory) :
(global = global || self, global.mapboxgl = factory());
}(this, (function () { 'use strict';

/* eslint-disable */

var shared, worker, mapboxgl;
// define gets called three times: one for each chunk. we rely on the order
// they're imported to know which is which
function define(_, chunk) {
if (!shared) {
    shared = chunk;
} else if (!worker) {
    worker = chunk;
} else {
    var workerBundleString = 'var sharedChunk = {}; (' + shared + ')(sharedChunk); (' + worker + ')(sharedChunk);'

    var sharedChunk = {};
    shared(sharedChunk);
    mapboxgl = chunk(sharedChunk);
    if (typeof window !== 'undefined') {
        mapboxgl.workerUrl = window.URL.createObjectURL(new Blob([workerBundleString], { type: 'text/javascript' }));
    }
}
}


define(["exports"],(function(t){"use strict";function e(t,e){return t(e={exports:{}},e.exports),e.exports}var r=i;function i(t,e,r,i){this.cx=3*t,this.bx=3*(r-t)-this.cx,this.ax=1-this.cx-this.bx,this.cy=3*e,this.by=3*(i-e)-this.cy,this.ay=1-this.cy-this.by,this.p1x=t,this.p1y=i,this.p2x=r,this.p2y=i;}i.prototype.sampleCurveX=function(t){return ((this.ax*t+this.bx)*t+this.cx)*t},i.prototype.sampleCurveY=function(t){return ((this.ay*t+this.by)*t+this.cy)*t},i.prototype.sampleCurveDerivativeX=function(t){return (3*this.ax*t+2*this.bx)*t+this.cx},i.prototype.solveCurveX=function(t,e){var r,i,n,a,s;for(void 0===e&&(e=1e-6),n=t,s=0;s<8;s++){if(a=this.sampleCurveX(n)-t,Math.abs(a)<e)return n;var o=this.sampleCurveDerivativeX(n);if(Math.abs(o)<1e-6)break;n-=a/o;}if((n=t)<(r=0))return r;if(n>(i=1))return i;for(;r<i;){if(a=this.sampleCurveX(n),Math.abs(a-t)<e)return n;t>a?r=n:i=n,n=.5*(i-r)+r;}return n},i.prototype.solve=function(t,e){return this.sampleCurveY(this.solveCurveX(t,e))};var n=a;function a(t,e){this.x=t,this.y=e;}a.prototype={clone:function(){return new a(this.x,this.y)},add:function(t){return this.clone()._add(t)},sub:function(t){return this.clone()._sub(t)},multByPoint:function(t){return this.clone()._multByPoint(t)},divByPoint:function(t){return this.clone()._divByPoint(t)},mult:function(t){return this.clone()._mult(t)},div:function(t){return this.clone()._div(t)},rotate:function(t){return this.clone()._rotate(t)},rotateAround:function(t,e){return this.clone()._rotateAround(t,e)},matMult:function(t){return this.clone()._matMult(t)},unit:function(){return this.clone()._unit()},perp:function(){return this.clone()._perp()},round:function(){return this.clone()._round()},mag:function(){return Math.sqrt(this.x*this.x+this.y*this.y)},equals:function(t){return this.x===t.x&&this.y===t.y},dist:function(t){return Math.sqrt(this.distSqr(t))},distSqr:function(t){var e=t.x-this.x,r=t.y-this.y;return e*e+r*r},angle:function(){return Math.atan2(this.y,this.x)},angleTo:function(t){return Math.atan2(this.y-t.y,this.x-t.x)},angleWith:function(t){return this.angleWithSep(t.x,t.y)},angleWithSep:function(t,e){return Math.atan2(this.x*e-this.y*t,this.x*t+this.y*e)},_matMult:function(t){var e=t[2]*this.x+t[3]*this.y;return this.x=t[0]*this.x+t[1]*this.y,this.y=e,this},_add:function(t){return this.x+=t.x,this.y+=t.y,this},_sub:function(t){return this.x-=t.x,this.y-=t.y,this},_mult:function(t){return this.x*=t,this.y*=t,this},_div:function(t){return this.x/=t,this.y/=t,this},_multByPoint:function(t){return this.x*=t.x,this.y*=t.y,this},_divByPoint:function(t){return this.x/=t.x,this.y/=t.y,this},_unit:function(){return this._div(this.mag()),this},_perp:function(){var t=this.y;return this.y=this.x,this.x=-t,this},_rotate:function(t){var e=Math.cos(t),r=Math.sin(t),i=r*this.x+e*this.y;return this.x=e*this.x-r*this.y,this.y=i,this},_rotateAround:function(t,e){var r=Math.cos(t),i=Math.sin(t),n=e.y+i*(this.x-e.x)+r*(this.y-e.y);return this.x=e.x+r*(this.x-e.x)-i*(this.y-e.y),this.y=n,this},_round:function(){return this.x=Math.round(this.x),this.y=Math.round(this.y),this}},a.convert=function(t){return t instanceof a?t:Array.isArray(t)?new a(t[0],t[1]):t};var s="undefined"!=typeof self?self:{},o=Math.pow(2,53)-1;function u(t,e,i,n){var a=new r(t,e,i,n);return function(t){return a.solve(t)}}var h=u(.25,.1,.25,1);function l(t,e,r){return Math.min(r,Math.max(e,t))}function p(t,e,r){var i=r-e,n=((t-e)%i+i)%i+e;return n===e?r:n}function c(t){for(var e=[],r=arguments.length-1;r-- >0;)e[r]=arguments[r+1];for(var i=0,n=e;i<n.length;i+=1){var a=n[i];for(var s in a)t[s]=a[s];}return t}var f=1;function y(){return f++}function d(){return function t(e){return e?(e^16*Math.random()>>e/4).toString(16):([1e7]+-[1e3]+-4e3+-8e3+-1e11).replace(/[018]/g,t)}()}function m(t){return !!t&&/^[0-9a-f]{8}-[0-9a-f]{4}-[4][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(t)}function v(t,e){t.forEach((function(t){e[t]&&(e[t]=e[t].bind(e));}));}function g(t,e){return -1!==t.indexOf(e,t.length-e.length)}function x(t,e,r){var i={};for(var n in t)i[n]=e.call(r||this,t[n],n,t);return i}function b(t,e,r){var i={};for(var n in t)e.call(r||this,t[n],n,t)&&(i[n]=t[n]);return i}function _(t){return Array.isArray(t)?t.map(_):"object"==typeof t&&t?x(t,_):t}var w={};function M(t){w[t]||("undefined"!=typeof console&&console.warn(t),w[t]=!0);}function S(t,e,r){return (r.y-t.y)*(e.x-t.x)>(e.y-t.y)*(r.x-t.x)}function A(t){for(var e=0,r=0,i=t.length,n=i-1,a=void 0,s=void 0;r<i;n=r++)e+=((s=t[n]).x-(a=t[r]).x)*(a.y+s.y);return e}function k(){return "undefined"!=typeof WorkerGlobalScope&&"undefined"!=typeof self&&self instanceof WorkerGlobalScope}function I(t){var e={};if(t.replace(/(?:^|(?:\s*\,\s*))([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)(?:\=(?:([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)|(?:\"((?:[^"\\]|\\.)*)\")))?/g,(function(t,r,i,n){var a=i||n;return e[r]=!a||a.toLowerCase(),""})),e["max-age"]){var r=parseInt(e["max-age"],10);isNaN(r)?delete e["max-age"]:e["max-age"]=r;}return e}var z=null;function C(t){if(null==z){var e=t.navigator?t.navigator.userAgent:null;z=!!t.safari||!(!e||!(/\b(iPad|iPhone|iPod)\b/.test(e)||e.match("Safari")&&!e.match("Chrome")));}return z}function E(t){try{var e=s[t];return e.setItem("_mapbox_test_",1),e.removeItem("_mapbox_test_"),!0}catch(t){return !1}}var P,B,T,V,L=s.performance&&s.performance.now?s.performance.now.bind(s.performance):Date.now.bind(Date),F=s.requestAnimationFrame||s.mozRequestAnimationFrame||s.webkitRequestAnimationFrame||s.msRequestAnimationFrame,O=s.cancelAnimationFrame||s.mozCancelAnimationFrame||s.webkitCancelAnimationFrame||s.msCancelAnimationFrame,D={now:L,frame:function(t){var e=F(t);return {cancel:function(){return O(e)}}},getImageData:function(t,e){void 0===e&&(e=0);var r=s.document.createElement("canvas"),i=r.getContext("2d");if(!i)throw new Error("failed to create canvas 2d context");return r.width=t.width,r.height=t.height,i.drawImage(t,0,0,t.width,t.height),i.getImageData(-e,-e,t.width+2*e,t.height+2*e)},resolveURL:function(t){return P||(P=s.document.createElement("a")),P.href=t,P.href},hardwareConcurrency:s.navigator&&s.navigator.hardwareConcurrency||4,get devicePixelRatio(){return s.devicePixelRatio},get prefersReducedMotion(){return !!s.matchMedia&&(null==B&&(B=s.matchMedia("(prefers-reduced-motion: reduce)")),B.matches)}},N={API_URL:"https://api.mapbox.com",get EVENTS_URL(){return this.API_URL?0===this.API_URL.indexOf("https://api.mapbox.cn")?"https://events.mapbox.cn/events/v2":0===this.API_URL.indexOf("https://api.mapbox.com")?"https://events.mapbox.com/events/v2":null:null},FEEDBACK_URL:"https://apps.mapbox.com/feedback",REQUIRE_ACCESS_TOKEN:!0,ACCESS_TOKEN:null,MAX_PARALLEL_IMAGE_REQUESTS:16},R={supported:!1,testSupport:function(t){!q&&V&&(j?U(t):T=t);}},q=!1,j=!1;function U(t){var e=t.createTexture();t.bindTexture(t.TEXTURE_2D,e);try{if(t.texImage2D(t.TEXTURE_2D,0,t.RGBA,t.RGBA,t.UNSIGNED_BYTE,V),t.isContextLost())return;R.supported=!0;}catch(t){}t.deleteTexture(e),q=!0;}s.document&&((V=s.document.createElement("img")).onload=function(){T&&U(T),T=null,j=!0;},V.onerror=function(){q=!0,T=null;},V.src="data:image/webp;base64,UklGRh4AAABXRUJQVlA4TBEAAAAvAQAAAAfQ//73v/+BiOh/AAA=");var G="01",K=484813681109536e-20,X=Math.PI/2,H=.017453292519943295,J=57.29577951308232,Z=Math.PI/4,Y=2*Math.PI,W=3.14159265359,Q={greenwich:0,lisbon:-9.131906111111,paris:2.337229166667,bogota:-74.080916666667,madrid:-3.687938888889,rome:12.452333333333,bern:7.439583333333,jakarta:106.807719444444,ferro:-17.666666666667,brussels:4.367975,stockholm:18.058277777778,athens:23.7163375,oslo:10.722916666667},$={ft:{to_meter:.3048},"us-ft":{to_meter:1200/3937}},tt=/[\s_\-\/\(\)]/g;function et(t,e){if(t[e])return t[e];for(var r,i=Object.keys(t),n=e.toLowerCase().replace(tt,""),a=-1;++a<i.length;)if((r=i[a]).toLowerCase().replace(tt,"")===n)return t[r]}function rt(t){var e,r,i,n={},a=t.split("+").map((function(t){return t.trim()})).filter((function(t){return t})).reduce((function(t,e){var r=e.split("=");return r.push(!0),t[r[0].toLowerCase()]=r[1],t}),{}),s={proj:"projName",datum:"datumCode",rf:function(t){n.rf=parseFloat(t);},lat_0:function(t){n.lat0=t*H;},lat_1:function(t){n.lat1=t*H;},lat_2:function(t){n.lat2=t*H;},lat_ts:function(t){n.lat_ts=t*H;},lon_0:function(t){n.long0=t*H;},lon_1:function(t){n.long1=t*H;},lon_2:function(t){n.long2=t*H;},alpha:function(t){n.alpha=parseFloat(t)*H;},gamma:function(t){n.rectified_grid_angle=parseFloat(t);},lonc:function(t){n.longc=t*H;},x_0:function(t){n.x0=parseFloat(t);},y_0:function(t){n.y0=parseFloat(t);},k_0:function(t){n.k0=parseFloat(t);},k:function(t){n.k0=parseFloat(t);},a:function(t){n.a=parseFloat(t);},b:function(t){n.b=parseFloat(t);},r_a:function(){n.R_A=!0;},zone:function(t){n.zone=parseInt(t,10);},south:function(){n.utmSouth=!0;},towgs84:function(t){n.datum_params=t.split(",").map((function(t){return parseFloat(t)}));},to_meter:function(t){n.to_meter=parseFloat(t);},units:function(t){n.units=t;var e=et($,t);e&&(n.to_meter=e.to_meter);},from_greenwich:function(t){n.from_greenwich=t*H;},pm:function(t){var e=et(Q,t);n.from_greenwich=(e||parseFloat(t))*H;},nadgrids:function(t){"@null"===t?n.datumCode="none":n.nadgrids=t;},axis:function(t){3===t.length&&-1!=="ewnsud".indexOf(t.substr(0,1))&&-1!=="ewnsud".indexOf(t.substr(1,1))&&-1!=="ewnsud".indexOf(t.substr(2,1))&&(n.axis=t);},approx:function(){n.approx=!0;}};for(e in a)r=a[e],e in s?"function"==typeof(i=s[e])?i(r):n[i]=r:n[e]=r;return "string"==typeof n.datumCode&&"WGS84"!==n.datumCode&&(n.datumCode=n.datumCode.toLowerCase()),n}var it=/\s/,nt=/[A-Za-z]/,at=/[A-Za-z84_]/,st=/[,\]]/,ot=/[\d\.E\-\+]/;function ut(t){if("string"!=typeof t)throw new Error("not a string");this.text=t.trim(),this.level=0,this.place=0,this.root=null,this.stack=[],this.currentObject=null,this.state=1;}function ht(t,e,r){Array.isArray(e)&&(r.unshift(e),e=null);var i=r.reduce((function(t,e){return lt(e,t),t}),e?{}:t);e&&(t[e]=i);}function lt(t,e){if(Array.isArray(t)){var r=t.shift();if("PARAMETER"===r&&(r=t.shift()),1===t.length)return Array.isArray(t[0])?(e[r]={},void lt(t[0],e[r])):void(e[r]=t[0]);if(t.length)if("TOWGS84"!==r){if("AXIS"===r)return r in e||(e[r]=[]),void e[r].push(t);var i;switch(Array.isArray(r)||(e[r]={}),r){case"UNIT":case"PRIMEM":case"VERT_DATUM":return e[r]={name:t[0].toLowerCase(),convert:t[1]},void(3===t.length&&lt(t[2],e[r]));case"SPHEROID":case"ELLIPSOID":return e[r]={name:t[0],a:t[1],rf:t[2]},void(4===t.length&&lt(t[3],e[r]));case"PROJECTEDCRS":case"PROJCRS":case"GEOGCS":case"GEOCCS":case"PROJCS":case"LOCAL_CS":case"GEODCRS":case"GEODETICCRS":case"GEODETICDATUM":case"EDATUM":case"ENGINEERINGDATUM":case"VERT_CS":case"VERTCRS":case"VERTICALCRS":case"COMPD_CS":case"COMPOUNDCRS":case"ENGINEERINGCRS":case"ENGCRS":case"FITTED_CS":case"LOCAL_DATUM":case"DATUM":return t[0]=["name",t[0]],void ht(e,r,t);default:for(i=-1;++i<t.length;)if(!Array.isArray(t[i]))return lt(t,e[r]);return ht(e,r,t)}}else e[r]=t;else e[r]=!0;}else e[t]=!0;}function pt(t){return .017453292519943295*t}function ct(t){var e=new ut(t).output(),r=e.shift(),i=e.shift();e.unshift(["name",i]),e.unshift(["type",r]);var n={};return lt(e,n),function(t){if("GEOGCS"===t.type?t.projName="longlat":"LOCAL_CS"===t.type?(t.projName="identity",t.local=!0):t.projName="object"==typeof t.PROJECTION?Object.keys(t.PROJECTION)[0]:t.PROJECTION,t.AXIS){for(var e="",r=0,i=t.AXIS.length;r<i;++r){var n=[t.AXIS[r][0].toLowerCase(),t.AXIS[r][1].toLowerCase()];-1!==n[0].indexOf("north")||("y"===n[0]||"lat"===n[0])&&"north"===n[1]?e+="n":-1!==n[0].indexOf("south")||("y"===n[0]||"lat"===n[0])&&"south"===n[1]?e+="s":-1!==n[0].indexOf("east")||("x"===n[0]||"lon"===n[0])&&"east"===n[1]?e+="e":-1===n[0].indexOf("west")&&("x"!==n[0]&&"lon"!==n[0]||"west"!==n[1])||(e+="w");}2===e.length&&(e+="u"),3===e.length&&(t.axis=e);}t.UNIT&&(t.units=t.UNIT.name.toLowerCase(),"metre"===t.units&&(t.units="meter"),t.UNIT.convert&&("GEOGCS"===t.type?t.DATUM&&t.DATUM.SPHEROID&&(t.to_meter=t.UNIT.convert*t.DATUM.SPHEROID.a):t.to_meter=t.UNIT.convert));var a=t.GEOGCS;function s(e){return e*(t.to_meter||1)}"GEOGCS"===t.type&&(a=t),a&&(t.datumCode=a.DATUM?a.DATUM.name.toLowerCase():a.name.toLowerCase(),"d_"===t.datumCode.slice(0,2)&&(t.datumCode=t.datumCode.slice(2)),"new_zealand_geodetic_datum_1949"!==t.datumCode&&"new_zealand_1949"!==t.datumCode||(t.datumCode="nzgd49"),"wgs_1984"!==t.datumCode&&"world_geodetic_system_1984"!==t.datumCode||("Mercator_Auxiliary_Sphere"===t.PROJECTION&&(t.sphere=!0),t.datumCode="wgs84"),"_ferro"===t.datumCode.slice(-6)&&(t.datumCode=t.datumCode.slice(0,-6)),"_jakarta"===t.datumCode.slice(-8)&&(t.datumCode=t.datumCode.slice(0,-8)),~t.datumCode.indexOf("belge")&&(t.datumCode="rnb72"),a.DATUM&&a.DATUM.SPHEROID&&(t.ellps=a.DATUM.SPHEROID.name.replace("_19","").replace(/[Cc]larke\_18/,"clrk"),"international"===t.ellps.toLowerCase().slice(0,13)&&(t.ellps="intl"),t.a=a.DATUM.SPHEROID.a,t.rf=parseFloat(a.DATUM.SPHEROID.rf,10)),a.DATUM&&a.DATUM.TOWGS84&&(t.datum_params=a.DATUM.TOWGS84),~t.datumCode.indexOf("osgb_1936")&&(t.datumCode="osgb36"),~t.datumCode.indexOf("osni_1952")&&(t.datumCode="osni52"),(~t.datumCode.indexOf("tm65")||~t.datumCode.indexOf("geodetic_datum_of_1965"))&&(t.datumCode="ire65"),"ch1903+"===t.datumCode&&(t.datumCode="ch1903"),~t.datumCode.indexOf("israel")&&(t.datumCode="isr93")),t.b&&!isFinite(t.b)&&(t.b=t.a),[["standard_parallel_1","Standard_Parallel_1"],["standard_parallel_1","Latitude of 1st standard parallel"],["standard_parallel_2","Standard_Parallel_2"],["standard_parallel_2","Latitude of 2nd standard parallel"],["false_easting","False_Easting"],["false_easting","False easting"],["false-easting","Easting at false origin"],["false_northing","False_Northing"],["false_northing","False northing"],["false_northing","Northing at false origin"],["central_meridian","Central_Meridian"],["central_meridian","Longitude of natural origin"],["central_meridian","Longitude of false origin"],["latitude_of_origin","Latitude_Of_Origin"],["latitude_of_origin","Central_Parallel"],["latitude_of_origin","Latitude of natural origin"],["latitude_of_origin","Latitude of false origin"],["scale_factor","Scale_Factor"],["k0","scale_factor"],["latitude_of_center","Latitude_Of_Center"],["latitude_of_center","Latitude_of_center"],["lat0","latitude_of_center",pt],["longitude_of_center","Longitude_Of_Center"],["longitude_of_center","Longitude_of_center"],["longc","longitude_of_center",pt],["x0","false_easting",s],["y0","false_northing",s],["long0","central_meridian",pt],["lat0","latitude_of_origin",pt],["lat0","standard_parallel_1",pt],["lat1","standard_parallel_1",pt],["lat2","standard_parallel_2",pt],["azimuth","Azimuth"],["alpha","azimuth",pt],["srsCode","name"]].forEach((function(e){return function(t,e){var r=e[0],i=e[1];!(r in t)&&i in t&&(t[r]=t[i],3===e.length&&(t[r]=e[2](t[r])));}(t,e)})),t.long0||!t.longc||"Albers_Conic_Equal_Area"!==t.projName&&"Lambert_Azimuthal_Equal_Area"!==t.projName||(t.long0=t.longc),t.lat_ts||!t.lat1||"Stereographic_South_Pole"!==t.projName&&"Polar Stereographic (variant B)"!==t.projName||(t.lat0=pt(t.lat1>0?90:-90),t.lat_ts=t.lat1);}(n),n}function ft(t){var e=this;if(2===arguments.length){var r=arguments[1];ft[t]="string"==typeof r?"+"===r.charAt(0)?rt(arguments[1]):ct(arguments[1]):r;}else if(1===arguments.length){if(Array.isArray(t))return t.map((function(t){Array.isArray(t)?ft.apply(e,t):ft(t);}));if("string"==typeof t){if(t in ft)return ft[t]}else "EPSG"in t?ft["EPSG:"+t.EPSG]=t:"ESRI"in t?ft["ESRI:"+t.ESRI]=t:"IAU2000"in t?ft["IAU2000:"+t.IAU2000]=t:console.log(t);return}}ut.prototype.readCharicter=function(){var t=this.text[this.place++];if(4!==this.state)for(;it.test(t);){if(this.place>=this.text.length)return;t=this.text[this.place++];}switch(this.state){case 1:return this.neutral(t);case 2:return this.keyword(t);case 4:return this.quoted(t);case 5:return this.afterquote(t);case 3:return this.number(t);case-1:return}},ut.prototype.afterquote=function(t){if('"'===t)return this.word+='"',void(this.state=4);if(st.test(t))return this.word=this.word.trim(),void this.afterItem(t);throw new Error("havn't handled \""+t+'" in afterquote yet, index '+this.place)},ut.prototype.afterItem=function(t){return ","===t?(null!==this.word&&this.currentObject.push(this.word),this.word=null,void(this.state=1)):"]"===t?(this.level--,null!==this.word&&(this.currentObject.push(this.word),this.word=null),this.state=1,this.currentObject=this.stack.pop(),void(this.currentObject||(this.state=-1))):void 0},ut.prototype.number=function(t){if(!ot.test(t)){if(st.test(t))return this.word=parseFloat(this.word),void this.afterItem(t);throw new Error("havn't handled \""+t+'" in number yet, index '+this.place)}this.word+=t;},ut.prototype.quoted=function(t){'"'!==t?this.word+=t:this.state=5;},ut.prototype.keyword=function(t){if(at.test(t))this.word+=t;else {if("["===t){var e=[];return e.push(this.word),this.level++,null===this.root?this.root=e:this.currentObject.push(e),this.stack.push(this.currentObject),this.currentObject=e,void(this.state=1)}if(!st.test(t))throw new Error("havn't handled \""+t+'" in keyword yet, index '+this.place);this.afterItem(t);}},ut.prototype.neutral=function(t){if(nt.test(t))return this.word=t,void(this.state=2);if('"'===t)return this.word="",void(this.state=4);if(ot.test(t))return this.word=t,void(this.state=3);if(!st.test(t))throw new Error("havn't handled \""+t+'" in neutral yet, index '+this.place);this.afterItem(t);},ut.prototype.output=function(){for(;this.place<this.text.length;)this.readCharicter();if(-1===this.state)return this.root;throw new Error('unable to parse string "'+this.text+'". State is '+this.state)},function(t){t("EPSG:4326","+title=WGS 84 (long/lat) +proj=longlat +ellps=WGS84 +datum=WGS84 +units=degrees"),t("EPSG:4269","+title=NAD83 (long/lat) +proj=longlat +a=6378137.0 +b=6356752.31414036 +ellps=GRS80 +datum=NAD83 +units=degrees"),t("EPSG:3857","+title=WGS 84 / Pseudo-Mercator +proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 +units=m +nadgrids=@null +no_defs"),t.WGS84=t["EPSG:4326"],t["EPSG:3785"]=t["EPSG:3857"],t.GOOGLE=t["EPSG:3857"],t["EPSG:900913"]=t["EPSG:3857"],t["EPSG:102113"]=t["EPSG:3857"];}(ft);var yt=["PROJECTEDCRS","PROJCRS","GEOGCS","GEOCCS","PROJCS","LOCAL_CS","GEODCRS","GEODETICCRS","GEODETICDATUM","ENGCRS","ENGINEERINGCRS"],dt=["3857","900913","3785","102113"];function mt(t){if(!function(t){return "string"==typeof t}(t))return t;if(function(t){return t in ft}(t))return ft[t];if(function(t){return yt.some((function(e){return t.indexOf(e)>-1}))}(t)){var e=ct(t);if(function(t){var e=et(t,"authority");if(e){var r=et(e,"epsg");return r&&dt.indexOf(r)>-1}}(e))return ft["EPSG:3857"];var r=function(t){var e=et(t,"extension");if(e)return et(e,"proj4")}(e);return r?rt(r):e}return function(t){return "+"===t[0]}(t)?rt(t):void 0}function vt(t,e){var r,i;if(t=t||{},!e)return t;for(i in e)void 0!==(r=e[i])&&(t[i]=r);return t}function gt(t,e,r){var i=t*e;return r/Math.sqrt(1-i*i)}function xt(t){return t<0?-1:1}function bt(t){return Math.abs(t)<=W?t:t-xt(t)*Y}function _t(t,e,r){var i=t*r;return i=Math.pow((1-i)/(1+i),.5*t),Math.tan(.5*(X-e))/i}function wt(t,e){for(var r,i,n=.5*t,a=X-2*Math.atan(e),s=0;s<=15;s++)if(r=t*Math.sin(a),a+=i=X-2*Math.atan(e*Math.pow((1-r)/(1+r),n))-a,Math.abs(i)<=1e-10)return a;return -9999}function Mt(t){return t}var St=[{init:function(){var t=this.b/this.a;this.es=1-t*t,"x0"in this||(this.x0=0),"y0"in this||(this.y0=0),this.e=Math.sqrt(this.es),this.lat_ts?this.k0=this.sphere?Math.cos(this.lat_ts):gt(this.e,Math.sin(this.lat_ts),Math.cos(this.lat_ts)):this.k0||(this.k0=this.k?this.k:1);},forward:function(t){var e,r,i=t.x,n=t.y;if(n*J>90&&n*J<-90&&i*J>180&&i*J<-180)return null;if(Math.abs(Math.abs(n)-X)<=1e-10)return null;if(this.sphere)e=this.x0+this.a*this.k0*bt(i-this.long0),r=this.y0+this.a*this.k0*Math.log(Math.tan(Z+.5*n));else {var a=Math.sin(n),s=_t(this.e,n,a);e=this.x0+this.a*this.k0*bt(i-this.long0),r=this.y0-this.a*this.k0*Math.log(s);}return t.x=e,t.y=r,t},inverse:function(t){var e,r,i=t.x-this.x0,n=t.y-this.y0;if(this.sphere)r=X-2*Math.atan(Math.exp(-n/(this.a*this.k0)));else {var a=Math.exp(-n/(this.a*this.k0));if(-9999===(r=wt(this.e,a)))return null}return e=bt(this.long0+i/(this.a*this.k0)),t.x=e,t.y=r,t},names:["Mercator","Popular Visualisation Pseudo Mercator","Mercator_1SP","Mercator_Auxiliary_Sphere","merc"]},{init:function(){},forward:Mt,inverse:Mt,names:["longlat","identity"]}],At={},kt=[];function It(t,e){var r=kt.length;return t.names?(kt[r]=t,t.names.forEach((function(t){At[t.toLowerCase()]=r;})),this):(console.log(e),!0)}var zt={start:function(){St.forEach(It);},add:It,get:function(t){if(!t)return !1;var e=t.toLowerCase();return void 0!==At[e]&&kt[At[e]]?kt[At[e]]:void 0}},Ct={MERIT:{a:6378137,rf:298.257,ellipseName:"MERIT 1983"},SGS85:{a:6378136,rf:298.257,ellipseName:"Soviet Geodetic System 85"},GRS80:{a:6378137,rf:298.257222101,ellipseName:"GRS 1980(IUGG, 1980)"},IAU76:{a:6378140,rf:298.257,ellipseName:"IAU 1976"},airy:{a:6377563.396,b:6356256.91,ellipseName:"Airy 1830"},APL4:{a:6378137,rf:298.25,ellipseName:"Appl. Physics. 1965"},NWL9D:{a:6378145,rf:298.25,ellipseName:"Naval Weapons Lab., 1965"},mod_airy:{a:6377340.189,b:6356034.446,ellipseName:"Modified Airy"},andrae:{a:6377104.43,rf:300,ellipseName:"Andrae 1876 (Den., Iclnd.)"},aust_SA:{a:6378160,rf:298.25,ellipseName:"Australian Natl & S. Amer. 1969"},GRS67:{a:6378160,rf:298.247167427,ellipseName:"GRS 67(IUGG 1967)"},bessel:{a:6377397.155,rf:299.1528128,ellipseName:"Bessel 1841"},bess_nam:{a:6377483.865,rf:299.1528128,ellipseName:"Bessel 1841 (Namibia)"},clrk66:{a:6378206.4,b:6356583.8,ellipseName:"Clarke 1866"},clrk80:{a:6378249.145,rf:293.4663,ellipseName:"Clarke 1880 mod."},clrk80ign:{a:6378249.2,b:6356515,rf:293.4660213,ellipseName:"Clarke 1880 (IGN)"},clrk58:{a:6378293.645208759,rf:294.2606763692654,ellipseName:"Clarke 1858"},CPM:{a:6375738.7,rf:334.29,ellipseName:"Comm. des Poids et Mesures 1799"},delmbr:{a:6376428,rf:311.5,ellipseName:"Delambre 1810 (Belgium)"},engelis:{a:6378136.05,rf:298.2566,ellipseName:"Engelis 1985"},evrst30:{a:6377276.345,rf:300.8017,ellipseName:"Everest 1830"},evrst48:{a:6377304.063,rf:300.8017,ellipseName:"Everest 1948"},evrst56:{a:6377301.243,rf:300.8017,ellipseName:"Everest 1956"},evrst69:{a:6377295.664,rf:300.8017,ellipseName:"Everest 1969"},evrstSS:{a:6377298.556,rf:300.8017,ellipseName:"Everest (Sabah & Sarawak)"},fschr60:{a:6378166,rf:298.3,ellipseName:"Fischer (Mercury Datum) 1960"},fschr60m:{a:6378155,rf:298.3,ellipseName:"Fischer 1960"},fschr68:{a:6378150,rf:298.3,ellipseName:"Fischer 1968"},helmert:{a:6378200,rf:298.3,ellipseName:"Helmert 1906"},hough:{a:6378270,rf:297,ellipseName:"Hough"},intl:{a:6378388,rf:297,ellipseName:"International 1909 (Hayford)"},kaula:{a:6378163,rf:298.24,ellipseName:"Kaula 1961"},lerch:{a:6378139,rf:298.257,ellipseName:"Lerch 1979"},mprts:{a:6397300,rf:191,ellipseName:"Maupertius 1738"},new_intl:{a:6378157.5,b:6356772.2,ellipseName:"New International 1967"},plessis:{a:6376523,rf:6355863,ellipseName:"Plessis 1817 (France)"},krass:{a:6378245,rf:298.3,ellipseName:"Krassovsky, 1942"},SEasia:{a:6378155,b:6356773.3205,ellipseName:"Southeast Asia"},walbeck:{a:6376896,b:6355834.8467,ellipseName:"Walbeck"},WGS60:{a:6378165,rf:298.3,ellipseName:"WGS 60"},WGS66:{a:6378145,rf:298.25,ellipseName:"WGS 66"},WGS7:{a:6378135,rf:298.26,ellipseName:"WGS 72"}},Et=Ct.WGS84={a:6378137,rf:298.257223563,ellipseName:"WGS 84"};Ct.sphere={a:6370997,b:6370997,ellipseName:"Normal Sphere (r=6370997)"};var Pt={wgs84:{towgs84:"0,0,0",ellipse:"WGS84",datumName:"WGS84"},ch1903:{towgs84:"674.374,15.056,405.346",ellipse:"bessel",datumName:"swiss"},ggrs87:{towgs84:"-199.87,74.79,246.62",ellipse:"GRS80",datumName:"Greek_Geodetic_Reference_System_1987"},nad83:{towgs84:"0,0,0",ellipse:"GRS80",datumName:"North_American_Datum_1983"},nad27:{nadgrids:"@conus,@alaska,@ntv2_0.gsb,@ntv1_can.dat",ellipse:"clrk66",datumName:"North_American_Datum_1927"},potsdam:{towgs84:"598.1,73.7,418.2,0.202,0.045,-2.455,6.7",ellipse:"bessel",datumName:"Potsdam Rauenberg 1950 DHDN"},carthage:{towgs84:"-263.0,6.0,431.0",ellipse:"clark80",datumName:"Carthage 1934 Tunisia"},hermannskogel:{towgs84:"577.326,90.129,463.919,5.137,1.474,5.297,2.4232",ellipse:"bessel",datumName:"Hermannskogel"},osni52:{towgs84:"482.530,-130.596,564.557,-1.042,-0.214,-0.631,8.15",ellipse:"airy",datumName:"Irish National"},ire65:{towgs84:"482.530,-130.596,564.557,-1.042,-0.214,-0.631,8.15",ellipse:"mod_airy",datumName:"Ireland 1965"},rassadiran:{towgs84:"-133.63,-157.5,-158.62",ellipse:"intl",datumName:"Rassadiran"},nzgd49:{towgs84:"59.47,-5.04,187.44,0.47,-0.1,1.024,-4.5993",ellipse:"intl",datumName:"New Zealand Geodetic Datum 1949"},osgb36:{towgs84:"446.448,-125.157,542.060,0.1502,0.2470,0.8421,-20.4894",ellipse:"airy",datumName:"Airy 1830"},s_jtsk:{towgs84:"589,76,480",ellipse:"bessel",datumName:"S-JTSK (Ferro)"},beduaram:{towgs84:"-106,-87,188",ellipse:"clrk80",datumName:"Beduaram"},gunung_segara:{towgs84:"-403,684,41",ellipse:"bessel",datumName:"Gunung Segara Jakarta"},rnb72:{towgs84:"106.869,-52.2978,103.724,-0.33657,0.456955,-1.84218,1",ellipse:"intl",datumName:"Reseau National Belge 1972"}},Bt={};function Tt(t){if(0===t.length)return null;var e="@"===t[0];return e&&(t=t.slice(1)),"null"===t?{name:"null",mandatory:!e,grid:null,isNull:!0}:{name:t,mandatory:!e,grid:Bt[t]||null,isNull:!1}}function Vt(t){return t/3600*Math.PI/180}function Lt(t,e,r){return String.fromCharCode.apply(null,new Uint8Array(t.buffer.slice(e,r)))}function Ft(t){return t.map((function(t){return [Vt(t.longitudeShift),Vt(t.latitudeShift)]}))}function Ot(t,e,r){return {name:Lt(t,e+8,e+16).trim(),parent:Lt(t,e+24,e+24+8).trim(),lowerLatitude:t.getFloat64(e+72,r),upperLatitude:t.getFloat64(e+88,r),lowerLongitude:t.getFloat64(e+104,r),upperLongitude:t.getFloat64(e+120,r),latitudeInterval:t.getFloat64(e+136,r),longitudeInterval:t.getFloat64(e+152,r),gridNodeCount:t.getInt32(e+168,r)}}function Dt(t,e,r,i){for(var n=e+176,a=[],s=0;s<r.gridNodeCount;s++){var o={latitudeShift:t.getFloat32(n+16*s,i),longitudeShift:t.getFloat32(n+16*s+4,i),latitudeAccuracy:t.getFloat32(n+16*s+8,i),longitudeAccuracy:t.getFloat32(n+16*s+12,i)};a.push(o);}return a}function Nt(t,e){if(!(this instanceof Nt))return new Nt(t);e=e||function(t){if(t)throw t};var r=mt(t);if("object"==typeof r){var i=Nt.projections.get(r.projName);if(i){if(r.datumCode&&"none"!==r.datumCode){var n=et(Pt,r.datumCode);n&&(r.datum_params=r.datum_params||(n.towgs84?n.towgs84.split(","):null),r.ellps=n.ellipse,r.datumName=n.datumName?n.datumName:r.datumCode);}r.k0=r.k0||1,r.axis=r.axis||"enu",r.ellps=r.ellps||"wgs84",r.lat1=r.lat1||r.lat0;var a,s,o,u,h,l,p=function(t,e,r,i,n){if(!t){var a=et(Ct,i);a||(a=Et),t=a.a,e=a.b,r=a.rf;}return r&&!e&&(e=(1-1/r)*t),(0===r||Math.abs(t-e)<1e-10)&&(n=!0,e=t),{a:t,b:e,rf:r,sphere:n}}(r.a,r.b,r.rf,r.ellps,r.sphere),c=(h=((o=(a=p.a)*a)-(u=(s=p.b)*s))/o,l=0,r.R_A?(o=(a*=1-h*(.16666666666666666+h*(.04722222222222222+.022156084656084655*h)))*a,h=0):l=Math.sqrt(h),{es:h,e:l,ep2:(o-u)/u}),f=function(t){return void 0===t?null:t.split(",").map(Tt)}(r.nadgrids),y=r.datum||function(t,e,r,i,n,a,s){var o={};return o.datum_type=void 0===t||"none"===t?5:4,e&&(o.datum_params=e.map(parseFloat),0===o.datum_params[0]&&0===o.datum_params[1]&&0===o.datum_params[2]||(o.datum_type=1),o.datum_params.length>3&&(0===o.datum_params[3]&&0===o.datum_params[4]&&0===o.datum_params[5]&&0===o.datum_params[6]||(o.datum_type=2,o.datum_params[3]*=K,o.datum_params[4]*=K,o.datum_params[5]*=K,o.datum_params[6]=o.datum_params[6]/1e6+1))),s&&(o.datum_type=3,o.grids=s),o.a=r,o.b=i,o.es=n,o.ep2=a,o}(r.datumCode,r.datum_params,p.a,p.b,c.es,c.ep2,f);vt(this,r),vt(this,i),this.a=p.a,this.b=p.b,this.rf=p.rf,this.sphere=p.sphere,this.es=c.es,this.e=c.e,this.ep2=c.ep2,this.datum=y,this.init(),e(null,this);}else e(t);}else e(t);}function Rt(t,e,r){var i,n,a,s=t.x,o=t.y,u=t.z?t.z:0;if(o<-X&&o>-1.001*X)o=-X;else if(o>X&&o<1.001*X)o=X;else {if(o<-X)return {x:-1/0,y:-1/0,z:t.z};if(o>X)return {x:1/0,y:1/0,z:t.z}}return s>Math.PI&&(s-=2*Math.PI),n=Math.sin(o),a=Math.cos(o),{x:((i=r/Math.sqrt(1-e*(n*n)))+u)*a*Math.cos(s),y:(i+u)*a*Math.sin(s),z:(i*(1-e)+u)*n}}function qt(t,e,r,i){var n,a,s,o,u,h,l,p,c,f,y,d,m,v,g,x=t.x,b=t.y,_=t.z?t.z:0;if(n=Math.sqrt(x*x+b*b),a=Math.sqrt(x*x+b*b+_*_),n/r<1e-12){if(v=0,a/r<1e-12)return g=-i,{x:t.x,y:t.y,z:t.z}}else v=Math.atan2(b,x);s=_/a,p=(o=n/a)*(1-e)*(u=1/Math.sqrt(1-e*(2-e)*o*o)),c=s*u,m=0;do{m++,h=e*(l=r/Math.sqrt(1-e*c*c))/(l+(g=n*p+_*c-l*(1-e*c*c))),d=(y=s*(u=1/Math.sqrt(1-h*(2-h)*o*o)))*p-(f=o*(1-h)*u)*c,p=f,c=y;}while(d*d>1e-24&&m<30);return {x:v,y:Math.atan(y/Math.abs(f)),z:g}}function jt(t){return 1===t||2===t}function Ut(t,e,r){if(null===t.grids||0===t.grids.length)return console.log("Grid shift grids not found"),-1;for(var i={x:-r.x,y:r.y},n={x:Number.NaN,y:Number.NaN},a=[],s=0;s<t.grids.length;s++){var o=t.grids[s];if(a.push(o.name),o.isNull){n=i;break}if(null!==o.grid){var u=o.grid.subgrids[0],h=(Math.abs(u.del[1])+Math.abs(u.del[0]))/1e4;if(!(u.ll[1]-h>i.y||u.ll[0]-h>i.x||u.ll[1]+(u.lim[1]-1)*u.del[1]+h<i.y||u.ll[0]+(u.lim[0]-1)*u.del[0]+h<i.x||(n=Gt(i,e,u),isNaN(n.x))))break}else if(o.mandatory)return console.log("Unable to find mandatory grid '"+o.name+"'"),-1}return isNaN(n.x)?(console.log("Failed to find a grid shift table for location '"+-i.x*J+" "+i.y*J+" tried: '"+a+"'"),-1):(r.x=-n.x,r.y=n.y,0)}function Gt(t,e,r){var i={x:Number.NaN,y:Number.NaN};if(isNaN(t.x))return i;var n={x:t.x,y:t.y};n.x-=r.ll[0],n.y-=r.ll[1],n.x=bt(n.x-Math.PI)+Math.PI;var a=Kt(n,r);if(e){if(isNaN(a.x))return i;a.x=n.x-a.x,a.y=n.y-a.y;var s,o,u=9;do{if(o=Kt(a,r),isNaN(o.x)){console.log("Inverse grid shift iteration failed, presumably at grid edge.  Using first approximation.");break}a.x+=(s={x:n.x-(o.x+a.x),y:n.y-(o.y+a.y)}).x,a.y+=s.y;}while(u--&&Math.abs(s.x)>1e-12&&Math.abs(s.y)>1e-12);if(u<0)return console.log("Inverse grid shift iterator failed to converge."),i;i.x=bt(a.x+r.ll[0]),i.y=a.y+r.ll[1];}else isNaN(a.x)||(i.x=t.x+a.x,i.y=t.y+a.y);return i}function Kt(t,e){var r,i={x:t.x/e.del[0],y:t.y/e.del[1]},n=Math.floor(i.x),a=Math.floor(i.y),s=i.x-1*n,o=i.y-1*a,u={x:Number.NaN,y:Number.NaN};if(n<0||n>=e.lim[0])return u;if(a<0||a>=e.lim[1])return u;var h=e.cvs[r=a*e.lim[0]+n][0],l=e.cvs[r][1];r++;var p=e.cvs[r][0],c=e.cvs[r][1],f=e.cvs[r+=e.lim[0]][0],y=e.cvs[r][1];r--;var d=e.cvs[r][1],m=s*o,v=s*(1-o),g=(1-s)*(1-o),x=(1-s)*o;return u.x=g*h+v*p+x*e.cvs[r][0]+m*f,u.y=g*l+v*c+x*d+m*y,u}function Xt(t,e,r){var i,n,a,s=r.x,o=r.y,u=r.z||0,h={};for(a=0;a<3;a++)if(!e||2!==a||void 0!==r.z)switch(0===a?(i=s,n=-1!=="ew".indexOf(t.axis[a])?"x":"y"):1===a?(i=o,n=-1!=="ns".indexOf(t.axis[a])?"y":"x"):(i=u,n="z"),t.axis[a]){case"e":h[n]=i;break;case"w":h[n]=-i;break;case"n":h[n]=i;break;case"s":h[n]=-i;break;case"u":void 0!==r[n]&&(h.z=i);break;case"d":void 0!==r[n]&&(h.z=-i);break;default:return null}return h}function Ht(t){var e={x:t[0],y:t[1]};return t.length>2&&(e.z=t[2]),t.length>3&&(e.m=t[3]),e}function Jt(t){if("function"==typeof Number.isFinite){if(Number.isFinite(t))return;throw new TypeError("coordinates must be finite numbers")}if("number"!=typeof t||t!=t||!isFinite(t))throw new TypeError("coordinates must be finite numbers")}function Zt(t,e,r,i){var n,a=void 0!==(r=Array.isArray(r)?Ht(r):{x:r.x,y:r.y,z:r.z,m:r.m}).z;if(function(t){Jt(t.x),Jt(t.y);}(r),t.datum&&e.datum&&function(t,e){return (1===t.datum.datum_type||2===t.datum.datum_type||3===t.datum.datum_type)&&"WGS84"!==e.datumCode||(1===e.datum.datum_type||2===e.datum.datum_type||3===e.datum.datum_type)&&"WGS84"!==t.datumCode}(t,e)&&(r=Zt(t,n=new Nt("WGS84"),r,i),t=n),i&&"enu"!==t.axis&&(r=Xt(t,!1,r)),"longlat"===t.projName)r={x:r.x*H,y:r.y*H,z:r.z||0};else if(t.to_meter&&(r={x:r.x*t.to_meter,y:r.y*t.to_meter,z:r.z||0}),!(r=t.inverse(r)))return;if(t.from_greenwich&&(r.x+=t.from_greenwich),r=function(t,e,r){if(function(t,e){return t.datum_type===e.datum_type&&!(t.a!==e.a||Math.abs(t.es-e.es)>5e-11)&&(1===t.datum_type?t.datum_params[0]===e.datum_params[0]&&t.datum_params[1]===e.datum_params[1]&&t.datum_params[2]===e.datum_params[2]:2!==t.datum_type||t.datum_params[0]===e.datum_params[0]&&t.datum_params[1]===e.datum_params[1]&&t.datum_params[2]===e.datum_params[2]&&t.datum_params[3]===e.datum_params[3]&&t.datum_params[4]===e.datum_params[4]&&t.datum_params[5]===e.datum_params[5]&&t.datum_params[6]===e.datum_params[6])}(t,e))return r;if(5===t.datum_type||5===e.datum_type)return r;var i=t.a,n=t.es;if(3===t.datum_type){if(0!==Ut(t,!1,r))return;i=6378137,n=.0066943799901413165;}var a=e.a,s=e.b,o=e.es;return 3===e.datum_type&&(a=6378137,s=6356752.314,o=.0066943799901413165),n!==o||i!==a||jt(t.datum_type)||jt(e.datum_type)?(r=Rt(r,n,i),jt(t.datum_type)&&(r=function(t,e,r){if(1===e)return {x:t.x+r[0],y:t.y+r[1],z:t.z+r[2]};if(2===e){var i=r[3],n=r[4],a=r[5],s=r[6];return {x:s*(t.x-a*t.y+n*t.z)+r[0],y:s*(a*t.x+t.y-i*t.z)+r[1],z:s*(-n*t.x+i*t.y+t.z)+r[2]}}}(r,t.datum_type,t.datum_params)),jt(e.datum_type)&&(r=function(t,e,r){if(1===e)return {x:t.x-r[0],y:t.y-r[1],z:t.z-r[2]};if(2===e){var i=r[3],n=r[4],a=r[5],s=r[6],o=(t.x-r[0])/s,u=(t.y-r[1])/s,h=(t.z-r[2])/s;return {x:o+a*u-n*h,y:-a*o+u+i*h,z:n*o-i*u+h}}}(r,e.datum_type,e.datum_params)),r=qt(r,o,a,s),3!==e.datum_type||0===Ut(e,!0,r)?r:void 0):r}(t.datum,e.datum,r))return e.from_greenwich&&(r={x:r.x-e.from_greenwich,y:r.y,z:r.z||0}),"longlat"===e.projName?r={x:r.x*J,y:r.y*J,z:r.z||0}:(r=e.forward(r),e.to_meter&&(r={x:r.x/e.to_meter,y:r.y/e.to_meter,z:r.z||0})),i&&"enu"!==e.axis?Xt(e,!0,r):(a||delete r.z,r)}(Nt.projections=zt).start();var Yt=Nt("WGS84");function Wt(t,e,r,i){var n,a,s;return Array.isArray(r)?(n=Zt(t,e,r,i)||{x:NaN,y:NaN},r.length>2?void 0!==t.name&&"geocent"===t.name||void 0!==e.name&&"geocent"===e.name?"number"==typeof n.z?[n.x,n.y,n.z].concat(r.splice(3)):[n.x,n.y,r[2]].concat(r.splice(3)):[n.x,n.y].concat(r.splice(2)):[n.x,n.y]):(a=Zt(t,e,r,i),2===(s=Object.keys(r)).length||s.forEach((function(i){if(void 0!==t.name&&"geocent"===t.name||void 0!==e.name&&"geocent"===e.name){if("x"===i||"y"===i||"z"===i)return}else if("x"===i||"y"===i)return;a[i]=r[i];})),a)}function Qt(t){return t instanceof Nt?t:t.oProj?t.oProj:Nt(t)}function $t(t,e,r){t=Qt(t);var i,n=!1;return void 0===e?(e=t,t=Yt,n=!0):(void 0!==e.x||Array.isArray(e))&&(r=e,e=t,t=Yt,n=!0),e=Qt(e),r?Wt(t,e,r):(i={forward:function(r,i){return Wt(t,e,r,i)},inverse:function(r,i){return Wt(e,t,r,i)}},n&&(i.oProj=e),i)}var te=65,ee=73,re=79,ie={forward:ne,inverse:function(t){var e=ue(le(t.toUpperCase()));return e.lat&&e.lon?[e.lon,e.lat,e.lon,e.lat]:[e.left,e.bottom,e.right,e.top]},toPoint:ae};function ne(t,e){return e=e||5,function(t,e){var r,i,n,a,s,o,u,h,l,p,c,f="00000"+t.easting,y="00000"+t.northing;return t.zoneNumber+t.zoneLetter+(l=t.easting,p=t.northing,c=he(t.zoneNumber),r=Math.floor(l/1e5),i=Math.floor(p/1e5)%20,a="AJSAJS".charCodeAt(n=c-1),s="AFAFAF".charCodeAt(n),h=!1,(o=a+r-1)>90&&(o=o-90+te-1,h=!0),(o===ee||a<ee&&o>ee||(o>ee||a<ee)&&h)&&o++,(o===re||a<re&&o>re||(o>re||a<re)&&h)&&++o===ee&&o++,o>90&&(o=o-90+te-1),(u=s+i)>86?(u=u-86+te-1,h=!0):h=!1,(u===ee||s<ee&&u>ee||(u>ee||s<ee)&&h)&&u++,(u===re||s<re&&u>re||(u>re||s<re)&&h)&&++u===ee&&u++,u>86&&(u=u-86+te-1),String.fromCharCode(o)+String.fromCharCode(u))+f.substr(f.length-5,e)+y.substr(y.length-5,e)}(function(t){var e,r,i,n,a,s,o=t.lat,u=t.lon,h=6378137,l=se(o),p=se(u);s=Math.floor((u+180)/6)+1,180===u&&(s=60),o>=56&&o<64&&u>=3&&u<12&&(s=32),o>=72&&o<84&&(u>=0&&u<9?s=31:u>=9&&u<21?s=33:u>=21&&u<33?s=35:u>=33&&u<42&&(s=37)),a=se(6*(s-1)-180+3),e=h/Math.sqrt(1-.00669438*Math.sin(l)*Math.sin(l)),r=Math.tan(l)*Math.tan(l),i=.006739496752268451*Math.cos(l)*Math.cos(l);var c,f,y=.9996*e*((n=Math.cos(l)*(p-a))+(1-r+i)*n*n*n/6+(5-18*r+r*r+72*i-.39089081163157013)*n*n*n*n*n/120)+5e5,d=.9996*(h*(.9983242984503243*l-.002514607064228144*Math.sin(2*l)+2639046602129982e-21*Math.sin(4*l)-3.418046101696858e-9*Math.sin(6*l))+e*Math.tan(l)*(n*n/2+(5-r+9*i+4*i*i)*n*n*n*n/24+(61-58*r+r*r+600*i-2.2240339282485886)*n*n*n*n*n*n/720));return o<0&&(d+=1e7),{northing:Math.round(d),easting:Math.round(y),zoneNumber:s,zoneLetter:(c=o,f="Z",84>=c&&c>=72?f="X":72>c&&c>=64?f="W":64>c&&c>=56?f="V":56>c&&c>=48?f="U":48>c&&c>=40?f="T":40>c&&c>=32?f="S":32>c&&c>=24?f="R":24>c&&c>=16?f="Q":16>c&&c>=8?f="P":8>c&&c>=0?f="N":0>c&&c>=-8?f="M":-8>c&&c>=-16?f="L":-16>c&&c>=-24?f="K":-24>c&&c>=-32?f="J":-32>c&&c>=-40?f="H":-40>c&&c>=-48?f="G":-48>c&&c>=-56?f="F":-56>c&&c>=-64?f="E":-64>c&&c>=-72?f="D":-72>c&&c>=-80&&(f="C"),f)}}({lat:t[1],lon:t[0]}),e)}function ae(t){var e=ue(le(t.toUpperCase()));return e.lat&&e.lon?[e.lon,e.lat]:[(e.left+e.right)/2,(e.top+e.bottom)/2]}function se(t){return t*(Math.PI/180)}function oe(t){return t/Math.PI*180}function ue(t){var e=t.northing,r=t.easting,i=t.zoneLetter,n=t.zoneNumber;if(n<0||n>60)return null;var a,s,o,u,h,l,p,c,f=6378137,y=(1-Math.sqrt(.99330562))/(1+Math.sqrt(.99330562)),d=r-5e5,m=e;i<"N"&&(m-=1e7),l=6*(n-1)-180+3,c=(p=m/.9996/6367449.145945056)+(3*y/2-27*y*y*y/32)*Math.sin(2*p)+(21*y*y/16-55*y*y*y*y/32)*Math.sin(4*p)+151*y*y*y/96*Math.sin(6*p),a=f/Math.sqrt(1-.00669438*Math.sin(c)*Math.sin(c)),s=Math.tan(c)*Math.tan(c),o=.006739496752268451*Math.cos(c)*Math.cos(c),u=.99330562*f/Math.pow(1-.00669438*Math.sin(c)*Math.sin(c),1.5),h=d/(.9996*a);var v=c-a*Math.tan(c)/u*(h*h/2-(5+3*s+10*o-4*o*o-.06065547077041606)*h*h*h*h/24+(61+90*s+298*o+45*s*s-1.6983531815716497-3*o*o)*h*h*h*h*h*h/720);v=oe(v);var g,x=(h-(1+2*s+o)*h*h*h/6+(5-2*o+28*s-3*o*o+.05391597401814761+24*s*s)*h*h*h*h*h/120)/Math.cos(c);if(x=l+oe(x),t.accuracy){var b=ue({northing:t.northing+t.accuracy,easting:t.easting+t.accuracy,zoneLetter:t.zoneLetter,zoneNumber:t.zoneNumber});g={top:b.lat,right:b.lon,bottom:v,left:x};}else g={lat:v,lon:x};return g}function he(t){var e=t%6;return 0===e&&(e=6),e}function le(t){if(t&&0===t.length)throw "MGRSPoint coverting from nothing";for(var e,r=t.length,i=null,n="",a=0;!/[A-Z]/.test(e=t.charAt(a));){if(a>=2)throw "MGRSPoint bad conversion from: "+t;n+=e,a++;}var s=parseInt(n,10);if(0===a||a+3>r)throw "MGRSPoint bad conversion from: "+t;var o=t.charAt(a++);if(o<="A"||"B"===o||"Y"===o||o>="Z"||"I"===o||"O"===o)throw "MGRSPoint zone letter "+o+" not handled: "+t;i=t.substring(a,a+=2);for(var u=he(s),h=function(t,e){for(var r="AJSAJS".charCodeAt(e-1),i=1e5,n=!1;r!==t.charCodeAt(0);){if(++r===ee&&r++,r===re&&r++,r>90){if(n)throw "Bad character: "+t;r=te,n=!0;}i+=1e5;}return i}(i.charAt(0),u),l=function(t,e){if(t>"V")throw "MGRSPoint given invalid Northing "+t;for(var r="AFAFAF".charCodeAt(e-1),i=0,n=!1;r!==t.charCodeAt(0);){if(++r===ee&&r++,r===re&&r++,r>86){if(n)throw "Bad character: "+t;r=te,n=!0;}i+=1e5;}return i}(i.charAt(1),u);l<pe(o);)l+=2e6;var p=r-a;if(p%2!=0)throw "MGRSPoint has to have an even number \nof digits after the zone letter and two 100km letters - front \nhalf for easting meters, second half for \nnorthing meters"+t;var c,f,y,d=p/2,m=0,v=0;return d>0&&(c=1e5/Math.pow(10,d),f=t.substring(a,a+d),m=parseFloat(f)*c,y=t.substring(a+d),v=parseFloat(y)*c),{easting:m+h,northing:v+l,zoneLetter:o,zoneNumber:s,accuracy:c}}function pe(t){var e;switch(t){case"C":e=11e5;break;case"D":e=2e6;break;case"E":e=28e5;break;case"F":e=37e5;break;case"G":e=46e5;break;case"H":e=55e5;break;case"J":e=64e5;break;case"K":e=73e5;break;case"L":e=82e5;break;case"M":e=91e5;break;case"N":e=0;break;case"P":e=8e5;break;case"Q":e=17e5;break;case"R":e=26e5;break;case"S":e=35e5;break;case"T":e=44e5;break;case"U":e=53e5;break;case"V":e=62e5;break;case"W":e=7e6;break;case"X":e=79e5;break;default:e=-1;}if(e>=0)return e;throw "Invalid zone letter: "+t}function ce(t,e,r){if(!(this instanceof ce))return new ce(t,e,r);if(Array.isArray(t))this.x=t[0],this.y=t[1],this.z=t[2]||0;else if("object"==typeof t)this.x=t.x,this.y=t.y,this.z=t.z||0;else if("string"==typeof t&&void 0===e){var i=t.split(",");this.x=parseFloat(i[0],10),this.y=parseFloat(i[1],10),this.z=parseFloat(i[2],10)||0;}else this.x=t,this.y=e,this.z=r||0;console.warn("proj4.Point will be removed in version 3, use proj4.toPoint");}ce.fromMGRS=function(t){return new ce(ae(t))},ce.prototype.toMGRS=function(t){return ne([this.x,this.y],t)};var fe=.01068115234375;function ye(t){var e=[];e[0]=1-t*(.25+t*(.046875+t*(.01953125+t*fe))),e[1]=t*(.75-t*(.046875+t*(.01953125+t*fe)));var r=t*t;return e[2]=r*(.46875-t*(.013020833333333334+.007120768229166667*t)),e[3]=(r*=t)*(.3645833333333333-.005696614583333333*t),e[4]=r*t*.3076171875,e}function de(t,e,r,i){return i[0]*t-(r*=e)*(i[1]+(e*=e)*(i[2]+e*(i[3]+e*i[4])))}function me(t,e,r){for(var i=1/(1-e),n=t,a=20;a;--a){var s=Math.sin(n),o=1-e*s*s;if(n-=o=(de(n,s,Math.cos(n),r)-t)*(o*Math.sqrt(o))*i,Math.abs(o)<1e-10)return n}return n}var ve={init:function(){this.x0=void 0!==this.x0?this.x0:0,this.y0=void 0!==this.y0?this.y0:0,this.long0=void 0!==this.long0?this.long0:0,this.lat0=void 0!==this.lat0?this.lat0:0,this.es&&(this.en=ye(this.es),this.ml0=de(this.lat0,Math.sin(this.lat0),Math.cos(this.lat0),this.en));},forward:function(t){var e,r,i,n=t.y,a=bt(t.x-this.long0),s=Math.sin(n),o=Math.cos(n);if(this.es){var u=o*a,h=Math.pow(u,2),l=this.ep2*Math.pow(o,2),p=Math.pow(l,2),c=Math.abs(o)>1e-10?Math.tan(n):0,f=Math.pow(c,2),y=Math.pow(f,2);e=1-this.es*Math.pow(s,2),u/=Math.sqrt(e);var d=de(n,s,o,this.en);r=this.a*(this.k0*u*(1+h/6*(1-f+l+h/20*(5-18*f+y+14*l-58*f*l+h/42*(61+179*y-y*f-479*f)))))+this.x0,i=this.a*(this.k0*(d-this.ml0+s*a*u/2*(1+h/12*(5-f+9*l+4*p+h/30*(61+y-58*f+270*l-330*f*l+h/56*(1385+543*y-y*f-3111*f))))))+this.y0;}else {var m=o*Math.sin(a);if(Math.abs(Math.abs(m)-1)<1e-10)return 93;if(r=.5*this.a*this.k0*Math.log((1+m)/(1-m))+this.x0,i=o*Math.cos(a)/Math.sqrt(1-Math.pow(m,2)),(m=Math.abs(i))>=1){if(m-1>1e-10)return 93;i=0;}else i=Math.acos(i);n<0&&(i=-i),i=this.a*this.k0*(i-this.lat0)+this.y0;}return t.x=r,t.y=i,t},inverse:function(t){var e,r,i,n,a=1/this.a*(t.x-this.x0),s=1/this.a*(t.y-this.y0);if(this.es)if(r=me(e=this.ml0+s/this.k0,this.es,this.en),Math.abs(r)<X){var o=Math.sin(r),u=Math.cos(r),h=Math.abs(u)>1e-10?Math.tan(r):0,l=this.ep2*Math.pow(u,2),p=Math.pow(l,2),c=Math.pow(h,2),f=Math.pow(c,2);e=1-this.es*Math.pow(o,2);var y=a*Math.sqrt(e)/this.k0,d=Math.pow(y,2);i=r-(e*=h)*d/(1-this.es)*.5*(1-d/12*(5+3*c-9*l*c+l-4*p-d/30*(61+90*c-252*l*c+45*f+46*l-d/56*(1385+3633*c+4095*f+1574*f*c)))),n=bt(this.long0+y*(1-d/6*(1+2*c+l-d/20*(5+28*c+24*f+8*l*c+6*l-d/42*(61+662*c+1320*f+720*f*c))))/u);}else i=X*xt(s),n=0;else {var m=Math.exp(a/this.k0),v=.5*(m-1/m),g=Math.cos(this.lat0+s/this.k0);e=Math.sqrt((1-Math.pow(g,2))/(1+Math.pow(v,2))),i=Math.asin(e),s<0&&(i=-i),n=0===v&&0===g?0:bt(Math.atan2(v,g)+this.long0);}return t.x=n,t.y=i,t},names:["Fast_Transverse_Mercator","Fast Transverse Mercator"]};function ge(t){var e=Math.exp(t);return (e-1/e)/2}function xe(t,e){t=Math.abs(t),e=Math.abs(e);var r=Math.max(t,e),i=Math.min(t,e)/(r||1);return r*Math.sqrt(1+Math.pow(i,2))}function be(t,e){for(var r,i=2*Math.cos(2*e),n=t.length-1,a=t[n],s=0;--n>=0;)r=i*a-s+t[n],s=a,a=r;return e+r*Math.sin(2*e)}function _e(t,e,r){for(var i,n,a=Math.sin(e),s=Math.cos(e),o=ge(r),u=function(t){var e=Math.exp(t);return (e+1/e)/2}(r),h=2*s*u,l=-2*a*o,p=t.length-1,c=t[p],f=0,y=0,d=0;--p>=0;)i=y,n=f,c=h*(y=c)-i-l*(f=d)+t[p],d=l*y-n+h*f;return [(h=a*u)*c-(l=s*o)*d,h*d+l*c]}var we={init:function(){if(!this.approx&&(isNaN(this.es)||this.es<=0))throw new Error('Incorrect elliptical usage. Try using the +approx option in the proj string, or PROJECTION["Fast_Transverse_Mercator"] in the WKT.');this.approx&&(ve.init.apply(this),this.forward=ve.forward,this.inverse=ve.inverse),this.x0=void 0!==this.x0?this.x0:0,this.y0=void 0!==this.y0?this.y0:0,this.long0=void 0!==this.long0?this.long0:0,this.lat0=void 0!==this.lat0?this.lat0:0,this.cgb=[],this.cbg=[],this.utg=[],this.gtu=[];var t=this.es/(1+Math.sqrt(1-this.es)),e=t/(2-t),r=e;this.cgb[0]=e*(2+e*(-2/3+e*(e*(116/45+e*(26/45+e*(-2854/675)))-2))),this.cbg[0]=e*(e*(2/3+e*(4/3+e*(-82/45+e*(32/45+e*(4642/4725)))))-2),this.cgb[1]=(r*=e)*(7/3+e*(e*(-227/45+e*(2704/315+e*(2323/945)))-1.6)),this.cbg[1]=r*(5/3+e*(-16/15+e*(-13/9+e*(904/315+e*(-1522/945))))),this.cgb[2]=(r*=e)*(56/15+e*(-136/35+e*(-1262/105+e*(73814/2835)))),this.cbg[2]=r*(-26/15+e*(34/21+e*(1.6+e*(-12686/2835)))),this.cgb[3]=(r*=e)*(4279/630+e*(-332/35+e*(-399572/14175))),this.cbg[3]=r*(1237/630+e*(e*(-24832/14175)-2.4)),this.cgb[4]=(r*=e)*(4174/315+e*(-144838/6237)),this.cbg[4]=r*(-734/315+e*(109598/31185)),this.cgb[5]=(r*=e)*(601676/22275),this.cbg[5]=r*(444337/155925),r=Math.pow(e,2),this.Qn=this.k0/(1+e)*(1+r*(1/4+r*(1/64+r/256))),this.utg[0]=e*(e*(2/3+e*(-37/96+e*(1/360+e*(81/512+e*(-96199/604800)))))-.5),this.gtu[0]=e*(.5+e*(-2/3+e*(5/16+e*(41/180+e*(-127/288+e*(7891/37800)))))),this.utg[1]=r*(-1/48+e*(-1/15+e*(437/1440+e*(-46/105+e*(1118711/3870720))))),this.gtu[1]=r*(13/48+e*(e*(557/1440+e*(281/630+e*(-1983433/1935360)))-.6)),this.utg[2]=(r*=e)*(-17/480+e*(37/840+e*(209/4480+e*(-5569/90720)))),this.gtu[2]=r*(61/240+e*(-103/140+e*(15061/26880+e*(167603/181440)))),this.utg[3]=(r*=e)*(-4397/161280+e*(11/504+e*(830251/7257600))),this.gtu[3]=r*(49561/161280+e*(-179/168+e*(6601661/7257600))),this.utg[4]=(r*=e)*(-4583/161280+e*(108847/3991680)),this.gtu[4]=r*(34729/80640+e*(-3418889/1995840)),this.utg[5]=(r*=e)*(-20648693/638668800),this.gtu[5]=.6650675310896665*r;var i=be(this.cbg,this.lat0);this.Zb=-this.Qn*(i+function(t,e){for(var r,i=2*Math.cos(e),n=t.length-1,a=t[n],s=0;--n>=0;)r=i*a-s+t[n],s=a,a=r;return Math.sin(e)*r}(this.gtu,2*i));},forward:function(t){var e=bt(t.x-this.long0),r=t.y;r=be(this.cbg,r);var i=Math.sin(r),n=Math.cos(r),a=Math.sin(e),s=Math.cos(e);r=Math.atan2(i,s*n),e=Math.atan2(a*n,xe(i,n*s)),e=function(t){var e=Math.abs(t);return e=function(t){var e=1+t,r=e-1;return 0===r?t:t*Math.log(e)/r}(e*(1+e/(xe(1,e)+1))),t<0?-e:e}(Math.tan(e));var o,u,h=_e(this.gtu,2*r,2*e);return r+=h[0],e+=h[1],Math.abs(e)<=2.623395162778?(o=this.a*(this.Qn*e)+this.x0,u=this.a*(this.Qn*r+this.Zb)+this.y0):(o=1/0,u=1/0),t.x=o,t.y=u,t},inverse:function(t){var e,r,i=1/this.a*(t.x-this.x0),n=1/this.a*(t.y-this.y0);if(n=(n-this.Zb)/this.Qn,i/=this.Qn,Math.abs(i)<=2.623395162778){var a=_e(this.utg,2*n,2*i);n+=a[0],i+=a[1],i=Math.atan(ge(i));var s=Math.sin(n),o=Math.cos(n),u=Math.sin(i),h=Math.cos(i);n=Math.atan2(s*h,xe(u,h*o)),e=bt((i=Math.atan2(u,h*o))+this.long0),r=be(this.cgb,n);}else e=1/0,r=1/0;return t.x=e,t.y=r,t},names:["Extended_Transverse_Mercator","Extended Transverse Mercator","etmerc","Transverse_Mercator","Transverse Mercator","tmerc"]},Me={init:function(){var t=function(t,e){if(void 0===t){if((t=Math.floor(30*(bt(e)+Math.PI)/Math.PI)+1)<0)return 0;if(t>60)return 60}return t}(this.zone,this.long0);if(void 0===t)throw new Error("unknown utm zone");this.lat0=0,this.long0=(6*Math.abs(t)-183)*H,this.x0=5e5,this.y0=this.utmSouth?1e7:0,this.k0=.9996,we.init.apply(this),this.forward=we.forward,this.inverse=we.inverse;},names:["Universal Transverse Mercator System","utm"],dependsOn:"etmerc"};function Se(t,e){return Math.pow((1-t)/(1+t),e)}var Ae={init:function(){var t=Math.sin(this.lat0),e=Math.cos(this.lat0);e*=e,this.rc=Math.sqrt(1-this.es)/(1-this.es*t*t),this.C=Math.sqrt(1+this.es*e*e/(1-this.es)),this.phic0=Math.asin(t/this.C),this.ratexp=.5*this.C*this.e,this.K=Math.tan(.5*this.phic0+Z)/(Math.pow(Math.tan(.5*this.lat0+Z),this.C)*Se(this.e*t,this.ratexp));},forward:function(t){var e=t.x,r=t.y;return t.y=2*Math.atan(this.K*Math.pow(Math.tan(.5*r+Z),this.C)*Se(this.e*Math.sin(r),this.ratexp))-X,t.x=this.C*e,t},inverse:function(t){for(var e=t.x/this.C,r=t.y,i=Math.pow(Math.tan(.5*r+Z)/this.K,1/this.C),n=20;n>0&&(r=2*Math.atan(i*Se(this.e*Math.sin(t.y),-.5*this.e))-X,!(Math.abs(r-t.y)<1e-14));--n)t.y=r;return n?(t.x=e,t.y=r,t):null},names:["gauss"]},ke={init:function(){Ae.init.apply(this),this.rc&&(this.sinc0=Math.sin(this.phic0),this.cosc0=Math.cos(this.phic0),this.R2=2*this.rc,this.title||(this.title="Oblique Stereographic Alternative"));},forward:function(t){var e,r,i,n;return t.x=bt(t.x-this.long0),Ae.forward.apply(this,[t]),e=Math.sin(t.y),r=Math.cos(t.y),i=Math.cos(t.x),t.x=(n=this.k0*this.R2/(1+this.sinc0*e+this.cosc0*r*i))*r*Math.sin(t.x),t.y=n*(this.cosc0*e-this.sinc0*r*i),t.x=this.a*t.x+this.x0,t.y=this.a*t.y+this.y0,t},inverse:function(t){var e,r,i,n,a;if(t.x=(t.x-this.x0)/this.a,t.y=(t.y-this.y0)/this.a,t.x/=this.k0,t.y/=this.k0,a=Math.sqrt(t.x*t.x+t.y*t.y)){var s=2*Math.atan2(a,this.R2);e=Math.sin(s),r=Math.cos(s),n=Math.asin(r*this.sinc0+t.y*e*this.cosc0/a),i=Math.atan2(t.x*e,a*this.cosc0*r-t.y*this.sinc0*e);}else n=this.phic0,i=0;return t.x=i,t.y=n,Ae.inverse.apply(this,[t]),t.x=bt(t.x+this.long0),t},names:["Stereographic_North_Pole","Oblique_Stereographic","Polar_Stereographic","sterea","Oblique Stereographic Alternative","Double_Stereographic"]},Ie={init:function(){this.coslat0=Math.cos(this.lat0),this.sinlat0=Math.sin(this.lat0),this.sphere?1===this.k0&&!isNaN(this.lat_ts)&&Math.abs(this.coslat0)<=1e-10&&(this.k0=.5*(1+xt(this.lat0)*Math.sin(this.lat_ts))):(Math.abs(this.coslat0)<=1e-10&&(this.con=this.lat0>0?1:-1),this.cons=Math.sqrt(Math.pow(1+this.e,1+this.e)*Math.pow(1-this.e,1-this.e)),1===this.k0&&!isNaN(this.lat_ts)&&Math.abs(this.coslat0)<=1e-10&&(this.k0=.5*this.cons*gt(this.e,Math.sin(this.lat_ts),Math.cos(this.lat_ts))/_t(this.e,this.con*this.lat_ts,this.con*Math.sin(this.lat_ts))),this.ms1=gt(this.e,this.sinlat0,this.coslat0),this.X0=2*Math.atan(this.ssfn_(this.lat0,this.sinlat0,this.e))-X,this.cosX0=Math.cos(this.X0),this.sinX0=Math.sin(this.X0));},forward:function(t){var e,r,i,n,a,s,o=t.x,u=t.y,h=Math.sin(u),l=Math.cos(u),p=bt(o-this.long0);return Math.abs(Math.abs(o-this.long0)-Math.PI)<=1e-10&&Math.abs(u+this.lat0)<=1e-10?(t.x=NaN,t.y=NaN,t):this.sphere?(e=2*this.k0/(1+this.sinlat0*h+this.coslat0*l*Math.cos(p)),t.x=this.a*e*l*Math.sin(p)+this.x0,t.y=this.a*e*(this.coslat0*h-this.sinlat0*l*Math.cos(p))+this.y0,t):(r=2*Math.atan(this.ssfn_(u,h,this.e))-X,n=Math.cos(r),i=Math.sin(r),Math.abs(this.coslat0)<=1e-10?(a=_t(this.e,u*this.con,this.con*h),t.x=this.x0+(s=2*this.a*this.k0*a/this.cons)*Math.sin(o-this.long0),t.y=this.y0-this.con*s*Math.cos(o-this.long0),t):(Math.abs(this.sinlat0)<1e-10?(e=2*this.a*this.k0/(1+n*Math.cos(p)),t.y=e*i):(e=2*this.a*this.k0*this.ms1/(this.cosX0*(1+this.sinX0*i+this.cosX0*n*Math.cos(p))),t.y=e*(this.cosX0*i-this.sinX0*n*Math.cos(p))+this.y0),t.x=e*n*Math.sin(p)+this.x0,t))},inverse:function(t){var e,r,i,n;t.x-=this.x0,t.y-=this.y0;var a=Math.sqrt(t.x*t.x+t.y*t.y);if(this.sphere){var s=2*Math.atan(a/(2*this.a*this.k0));return e=this.long0,r=this.lat0,a<=1e-10?(t.x=e,t.y=r,t):(r=Math.asin(Math.cos(s)*this.sinlat0+t.y*Math.sin(s)*this.coslat0/a),e=Math.abs(this.coslat0)<1e-10?bt(this.lat0>0?this.long0+Math.atan2(t.x,-1*t.y):this.long0+Math.atan2(t.x,t.y)):bt(this.long0+Math.atan2(t.x*Math.sin(s),a*this.coslat0*Math.cos(s)-t.y*this.sinlat0*Math.sin(s))),t.x=e,t.y=r,t)}if(Math.abs(this.coslat0)<=1e-10){if(a<=1e-10)return r=this.lat0,t.x=e=this.long0,t.y=r,t;t.x*=this.con,t.y*=this.con,r=this.con*wt(this.e,a*this.cons/(2*this.a*this.k0)),e=this.con*bt(this.con*this.long0+Math.atan2(t.x,-1*t.y));}else i=2*Math.atan(a*this.cosX0/(2*this.a*this.k0*this.ms1)),e=this.long0,a<=1e-10?n=this.X0:(n=Math.asin(Math.cos(i)*this.sinX0+t.y*Math.sin(i)*this.cosX0/a),e=bt(this.long0+Math.atan2(t.x*Math.sin(i),a*this.cosX0*Math.cos(i)-t.y*this.sinX0*Math.sin(i)))),r=-1*wt(this.e,Math.tan(.5*(X+n)));return t.x=e,t.y=r,t},names:["stere","Stereographic_South_Pole","Polar Stereographic (variant B)"],ssfn_:function(t,e,r){return e*=r,Math.tan(.5*(X+t))*Math.pow((1-e)/(1+e),.5*r)}},ze={init:function(){var t=this.lat0;this.lambda0=this.long0;var e=Math.sin(t),r=this.a,i=1/this.rf,n=2*i-Math.pow(i,2),a=this.e=Math.sqrt(n);this.R=this.k0*r*Math.sqrt(1-n)/(1-n*Math.pow(e,2)),this.alpha=Math.sqrt(1+n/(1-n)*Math.pow(Math.cos(t),4)),this.b0=Math.asin(e/this.alpha);var s=Math.log(Math.tan(Math.PI/4+this.b0/2)),o=Math.log(Math.tan(Math.PI/4+t/2)),u=Math.log((1+a*e)/(1-a*e));this.K=s-this.alpha*o+this.alpha*a/2*u;},forward:function(t){var e=Math.log(Math.tan(Math.PI/4-t.y/2)),r=this.e/2*Math.log((1+this.e*Math.sin(t.y))/(1-this.e*Math.sin(t.y))),i=2*(Math.atan(Math.exp(-this.alpha*(e+r)+this.K))-Math.PI/4),n=this.alpha*(t.x-this.lambda0),a=Math.atan(Math.sin(n)/(Math.sin(this.b0)*Math.tan(i)+Math.cos(this.b0)*Math.cos(n))),s=Math.asin(Math.cos(this.b0)*Math.sin(i)-Math.sin(this.b0)*Math.cos(i)*Math.cos(n));return t.y=this.R/2*Math.log((1+Math.sin(s))/(1-Math.sin(s)))+this.y0,t.x=this.R*a+this.x0,t},inverse:function(t){for(var e=(t.x-this.x0)/this.R,r=2*(Math.atan(Math.exp((t.y-this.y0)/this.R))-Math.PI/4),i=Math.asin(Math.cos(this.b0)*Math.sin(r)+Math.sin(this.b0)*Math.cos(r)*Math.cos(e)),n=Math.atan(Math.sin(e)/(Math.cos(this.b0)*Math.cos(e)-Math.sin(this.b0)*Math.tan(r))),a=this.lambda0+n/this.alpha,s=0,o=i,u=-1e3,h=0;Math.abs(o-u)>1e-7;){if(++h>20)return;s=1/this.alpha*(Math.log(Math.tan(Math.PI/4+i/2))-this.K)+this.e*Math.log(Math.tan(Math.PI/4+Math.asin(this.e*Math.sin(o))/2)),u=o,o=2*Math.atan(Math.exp(s))-Math.PI/2;}return t.x=a,t.y=o,t},names:["somerc"]},Ce={init:function(){var t,e,r,i,n,a,s,o,u,h,l,p,c,f=0,y=0,d=0,m=0,v=0,g=0,x=0;this.no_off=(c="object"==typeof(p=this).PROJECTION?Object.keys(p.PROJECTION)[0]:p.PROJECTION,"no_uoff"in p||"no_off"in p||-1!==["Hotine_Oblique_Mercator","Hotine_Oblique_Mercator_Azimuth_Natural_Origin"].indexOf(c)),this.no_rot="no_rot"in this;var b=!1;"alpha"in this&&(b=!0);var _=!1;if("rectified_grid_angle"in this&&(_=!0),b&&(x=this.alpha),_&&(f=this.rectified_grid_angle*H),b||_)y=this.longc;else if(d=this.long1,v=this.lat1,m=this.long2,g=this.lat2,Math.abs(v-g)<=1e-7||(t=Math.abs(v))<=1e-7||Math.abs(t-X)<=1e-7||Math.abs(Math.abs(this.lat0)-X)<=1e-7||Math.abs(Math.abs(g)-X)<=1e-7)throw new Error;var w=1-this.es;e=Math.sqrt(w),Math.abs(this.lat0)>1e-10?(o=Math.sin(this.lat0),r=Math.cos(this.lat0),t=1-this.es*o*o,this.B=r*r,this.B=Math.sqrt(1+this.es*this.B*this.B/w),this.A=this.B*this.k0*e/t,(n=(i=this.B*e/(r*Math.sqrt(t)))*i-1)<=0?n=0:(n=Math.sqrt(n),this.lat0<0&&(n=-n)),this.E=n+=i,this.E*=Math.pow(_t(this.e,this.lat0,o),this.B)):(this.B=1/e,this.A=this.k0,this.E=i=n=1),b||_?(b?(l=Math.asin(Math.sin(x)/i),_||(f=x)):(l=f,x=Math.asin(i*Math.sin(l))),this.lam0=y-Math.asin(.5*(n-1/n)*Math.tan(l))/this.B):(a=Math.pow(_t(this.e,v,Math.sin(v)),this.B),s=Math.pow(_t(this.e,g,Math.sin(g)),this.B),n=this.E/a,u=(s-a)/(s+a),h=((h=this.E*this.E)-s*a)/(h+s*a),(t=d-m)<-Math.pi?m-=Y:t>Math.pi&&(m+=Y),this.lam0=bt(.5*(d+m)-Math.atan(h*Math.tan(.5*this.B*(d-m))/u)/this.B),l=Math.atan(2*Math.sin(this.B*bt(d-this.lam0))/(n-1/n)),f=x=Math.asin(i*Math.sin(l))),this.singam=Math.sin(l),this.cosgam=Math.cos(l),this.sinrot=Math.sin(f),this.cosrot=Math.cos(f),this.rB=1/this.B,this.ArB=this.A*this.rB,this.BrA=1/this.ArB,this.no_off?this.u_0=0:(this.u_0=Math.abs(this.ArB*Math.atan(Math.sqrt(i*i-1)/Math.cos(x))),this.lat0<0&&(this.u_0=-this.u_0)),n=.5*l,this.v_pole_n=this.ArB*Math.log(Math.tan(Z-n)),this.v_pole_s=this.ArB*Math.log(Math.tan(Z+n));},forward:function(t){var e,r,i,n,a,s,o,u,h={};if(t.x=t.x-this.lam0,Math.abs(Math.abs(t.y)-X)>1e-10){if(e=.5*((a=this.E/Math.pow(_t(this.e,t.y,Math.sin(t.y)),this.B))-(s=1/a)),r=.5*(a+s),n=Math.sin(this.B*t.x),i=(e*this.singam-n*this.cosgam)/r,Math.abs(Math.abs(i)-1)<1e-10)throw new Error;u=.5*this.ArB*Math.log((1-i)/(1+i)),s=Math.cos(this.B*t.x),o=Math.abs(s)<1e-7?this.A*t.x:this.ArB*Math.atan2(e*this.cosgam+n*this.singam,s);}else u=t.y>0?this.v_pole_n:this.v_pole_s,o=this.ArB*t.y;return this.no_rot?(h.x=o,h.y=u):(h.x=u*this.cosrot+(o-=this.u_0)*this.sinrot,h.y=o*this.cosrot-u*this.sinrot),h.x=this.a*h.x+this.x0,h.y=this.a*h.y+this.y0,h},inverse:function(t){var e,r,i,n,a,s,o,u={};if(t.x=1/this.a*(t.x-this.x0),t.y=1/this.a*(t.y-this.y0),this.no_rot?(r=t.y,e=t.x):(r=t.x*this.cosrot-t.y*this.sinrot,e=t.y*this.cosrot+t.x*this.sinrot+this.u_0),n=.5*((i=Math.exp(-this.BrA*r))-1/i),a=.5*(i+1/i),o=((s=Math.sin(this.BrA*e))*this.cosgam+n*this.singam)/a,Math.abs(Math.abs(o)-1)<1e-10)u.x=0,u.y=o<0?-X:X;else {if(u.y=this.E/Math.sqrt((1+o)/(1-o)),u.y=wt(this.e,Math.pow(u.y,1/this.B)),u.y===1/0)throw new Error;u.x=-this.rB*Math.atan2(n*this.cosgam-s*this.singam,Math.cos(this.BrA*e));}return u.x+=this.lam0,u},names:["Hotine_Oblique_Mercator","Hotine Oblique Mercator","Hotine_Oblique_Mercator_Azimuth_Natural_Origin","Hotine_Oblique_Mercator_Two_Point_Natural_Origin","Hotine_Oblique_Mercator_Azimuth_Center","Oblique_Mercator","omerc"]},Ee={init:function(){if(this.lat2||(this.lat2=this.lat1),this.k0||(this.k0=1),this.x0=this.x0||0,this.y0=this.y0||0,!(Math.abs(this.lat1+this.lat2)<1e-10)){var t=this.b/this.a;this.e=Math.sqrt(1-t*t);var e=Math.sin(this.lat1),r=Math.cos(this.lat1),i=gt(this.e,e,r),n=_t(this.e,this.lat1,e),a=Math.sin(this.lat2),s=Math.cos(this.lat2),o=gt(this.e,a,s),u=_t(this.e,this.lat2,a),h=_t(this.e,this.lat0,Math.sin(this.lat0));this.ns=Math.abs(this.lat1-this.lat2)>1e-10?Math.log(i/o)/Math.log(n/u):e,isNaN(this.ns)&&(this.ns=e),this.f0=i/(this.ns*Math.pow(n,this.ns)),this.rh=this.a*this.f0*Math.pow(h,this.ns),this.title||(this.title="Lambert Conformal Conic");}},forward:function(t){var e=t.x,r=t.y;Math.abs(2*Math.abs(r)-Math.PI)<=1e-10&&(r=xt(r)*(X-2e-10));var i,n,a=Math.abs(Math.abs(r)-X);if(a>1e-10)i=_t(this.e,r,Math.sin(r)),n=this.a*this.f0*Math.pow(i,this.ns);else {if((a=r*this.ns)<=0)return null;n=0;}var s=this.ns*bt(e-this.long0);return t.x=this.k0*(n*Math.sin(s))+this.x0,t.y=this.k0*(this.rh-n*Math.cos(s))+this.y0,t},inverse:function(t){var e,r,i,n,a,s=(t.x-this.x0)/this.k0,o=this.rh-(t.y-this.y0)/this.k0;this.ns>0?(e=Math.sqrt(s*s+o*o),r=1):(e=-Math.sqrt(s*s+o*o),r=-1);var u=0;if(0!==e&&(u=Math.atan2(r*s,r*o)),0!==e||this.ns>0){if(r=1/this.ns,i=Math.pow(e/(this.a*this.f0),r),-9999===(n=wt(this.e,i)))return null}else n=-X;return a=bt(u/this.ns+this.long0),t.x=a,t.y=n,t},names:["Lambert Tangential Conformal Conic Projection","Lambert_Conformal_Conic","Lambert_Conformal_Conic_1SP","Lambert_Conformal_Conic_2SP","lcc","Lambert Conic Conformal (1SP)","Lambert Conic Conformal (2SP)"]},Pe={init:function(){this.a=6377397.155,this.es=.006674372230614,this.e=Math.sqrt(this.es),this.lat0||(this.lat0=.863937979737193),this.long0||(this.long0=.4334234309119251),this.k0||(this.k0=.9999),this.s45=.785398163397448,this.s90=2*this.s45,this.fi0=this.lat0,this.e2=this.es,this.e=Math.sqrt(this.e2),this.alfa=Math.sqrt(1+this.e2*Math.pow(Math.cos(this.fi0),4)/(1-this.e2)),this.uq=1.04216856380474,this.u0=Math.asin(Math.sin(this.fi0)/this.alfa),this.g=Math.pow((1+this.e*Math.sin(this.fi0))/(1-this.e*Math.sin(this.fi0)),this.alfa*this.e/2),this.k=Math.tan(this.u0/2+this.s45)/Math.pow(Math.tan(this.fi0/2+this.s45),this.alfa)*this.g,this.k1=this.k0,this.n0=this.a*Math.sqrt(1-this.e2)/(1-this.e2*Math.pow(Math.sin(this.fi0),2)),this.s0=1.37008346281555,this.n=Math.sin(this.s0),this.ro0=this.k1*this.n0/Math.tan(this.s0),this.ad=this.s90-this.uq;},forward:function(t){var e,r,i,n,a,s,o,u=t.y,h=bt(t.x-this.long0);return e=Math.pow((1+this.e*Math.sin(u))/(1-this.e*Math.sin(u)),this.alfa*this.e/2),r=2*(Math.atan(this.k*Math.pow(Math.tan(u/2+this.s45),this.alfa)/e)-this.s45),i=-h*this.alfa,n=Math.asin(Math.cos(this.ad)*Math.sin(r)+Math.sin(this.ad)*Math.cos(r)*Math.cos(i)),a=Math.asin(Math.cos(r)*Math.sin(i)/Math.cos(n)),s=this.n*a,o=this.ro0*Math.pow(Math.tan(this.s0/2+this.s45),this.n)/Math.pow(Math.tan(n/2+this.s45),this.n),t.y=o*Math.cos(s)/1,t.x=o*Math.sin(s)/1,this.czech||(t.y*=-1,t.x*=-1),t},inverse:function(t){var e,r,i,n,a,s,o,u=t.x;t.x=t.y,t.y=u,this.czech||(t.y*=-1,t.x*=-1),a=Math.sqrt(t.x*t.x+t.y*t.y),n=Math.atan2(t.y,t.x)/Math.sin(this.s0),i=2*(Math.atan(Math.pow(this.ro0/a,1/this.n)*Math.tan(this.s0/2+this.s45))-this.s45),e=Math.asin(Math.cos(this.ad)*Math.sin(i)-Math.sin(this.ad)*Math.cos(i)*Math.cos(n)),r=Math.asin(Math.cos(i)*Math.sin(n)/Math.cos(e)),t.x=this.long0-r/this.alfa,s=e,o=0;var h=0;do{t.y=2*(Math.atan(Math.pow(this.k,-1/this.alfa)*Math.pow(Math.tan(e/2+this.s45),1/this.alfa)*Math.pow((1+this.e*Math.sin(s))/(1-this.e*Math.sin(s)),this.e/2))-this.s45),Math.abs(s-t.y)<1e-10&&(o=1),s=t.y,h+=1;}while(0===o&&h<15);return h>=15?null:t},names:["Krovak","krovak"]};function Be(t,e,r,i,n){return t*n-e*Math.sin(2*n)+r*Math.sin(4*n)-i*Math.sin(6*n)}function Te(t){return 1-.25*t*(1+t/16*(3+1.25*t))}function Ve(t){return .375*t*(1+.25*t*(1+.46875*t))}function Le(t){return .05859375*t*t*(1+.75*t)}function Fe(t){return t*t*t*(35/3072)}function Oe(t,e,r){var i=e*r;return t/Math.sqrt(1-i*i)}function De(t){return Math.abs(t)<X?t:t-xt(t)*Math.PI}function Ne(t,e,r,i,n){var a,s;a=t/e;for(var o=0;o<15;o++)if(a+=s=(t-(e*a-r*Math.sin(2*a)+i*Math.sin(4*a)-n*Math.sin(6*a)))/(e-2*r*Math.cos(2*a)+4*i*Math.cos(4*a)-6*n*Math.cos(6*a)),Math.abs(s)<=1e-10)return a;return NaN}var Re={init:function(){this.sphere||(this.e0=Te(this.es),this.e1=Ve(this.es),this.e2=Le(this.es),this.e3=Fe(this.es),this.ml0=this.a*Be(this.e0,this.e1,this.e2,this.e3,this.lat0));},forward:function(t){var e,r,i=t.x,n=t.y;if(i=bt(i-this.long0),this.sphere)e=this.a*Math.asin(Math.cos(n)*Math.sin(i)),r=this.a*(Math.atan2(Math.tan(n),Math.cos(i))-this.lat0);else {var a=Math.sin(n),s=Math.cos(n),o=Oe(this.a,this.e,a),u=Math.tan(n)*Math.tan(n),h=i*Math.cos(n),l=h*h,p=this.es*s*s/(1-this.es);e=o*h*(1-l*u*(1/6-(8-u+8*p)*l/120)),r=this.a*Be(this.e0,this.e1,this.e2,this.e3,n)-this.ml0+o*a/s*l*(.5+(5-u+6*p)*l/24);}return t.x=e+this.x0,t.y=r+this.y0,t},inverse:function(t){t.x-=this.x0,t.y-=this.y0;var e,r,i=t.x/this.a,n=t.y/this.a;if(this.sphere){var a=n+this.lat0;e=Math.asin(Math.sin(a)*Math.cos(i)),r=Math.atan2(Math.tan(i),Math.cos(a));}else {var s=Ne(this.ml0/this.a+n,this.e0,this.e1,this.e2,this.e3);if(Math.abs(Math.abs(s)-X)<=1e-10)return t.x=this.long0,t.y=X,n<0&&(t.y*=-1),t;var o=Oe(this.a,this.e,Math.sin(s)),u=o*o*o/this.a/this.a*(1-this.es),h=Math.pow(Math.tan(s),2),l=i*this.a/o,p=l*l;e=s-o*Math.tan(s)/u*l*l*(.5-(1+3*h)*l*l/24),r=l*(1-p*(h/3+(1+3*h)*h*p/15))/Math.cos(s);}return t.x=bt(r+this.long0),t.y=De(e),t},names:["Cassini","Cassini_Soldner","cass"]};function qe(t,e){var r;return t>1e-7?(1-t*t)*(e/(1-(r=t*e)*r)-.5/t*Math.log((1-r)/(1+r))):2*e}var je={init:function(){var t,e=Math.abs(this.lat0);if(this.mode=Math.abs(e-X)<1e-10?this.lat0<0?this.S_POLE:this.N_POLE:Math.abs(e)<1e-10?this.EQUIT:this.OBLIQ,this.es>0)switch(this.qp=qe(this.e,1),this.mmf=.5/(1-this.es),this.apa=function(t){var e,r=[];return r[0]=.3333333333333333*t,r[0]+=.17222222222222222*(e=t*t),r[1]=.06388888888888888*e,r[0]+=.10257936507936508*(e*=t),r[1]+=.0664021164021164*e,r[2]=.016415012942191543*e,r}(this.es),this.mode){case this.N_POLE:case this.S_POLE:this.dd=1;break;case this.EQUIT:this.rq=Math.sqrt(.5*this.qp),this.dd=1/this.rq,this.xmf=1,this.ymf=.5*this.qp;break;case this.OBLIQ:this.rq=Math.sqrt(.5*this.qp),t=Math.sin(this.lat0),this.sinb1=qe(this.e,t)/this.qp,this.cosb1=Math.sqrt(1-this.sinb1*this.sinb1),this.dd=Math.cos(this.lat0)/(Math.sqrt(1-this.es*t*t)*this.rq*this.cosb1),this.ymf=(this.xmf=this.rq)/this.dd,this.xmf*=this.dd;}else this.mode===this.OBLIQ&&(this.sinph0=Math.sin(this.lat0),this.cosph0=Math.cos(this.lat0));},forward:function(t){var e,r,i,n,a,s,o,u,h,l,p=t.x,c=t.y;if(p=bt(p-this.long0),this.sphere){if(a=Math.sin(c),l=Math.cos(c),i=Math.cos(p),this.mode===this.OBLIQ||this.mode===this.EQUIT){if((r=this.mode===this.EQUIT?1+l*i:1+this.sinph0*a+this.cosph0*l*i)<=1e-10)return null;e=(r=Math.sqrt(2/r))*l*Math.sin(p),r*=this.mode===this.EQUIT?a:this.cosph0*a-this.sinph0*l*i;}else if(this.mode===this.N_POLE||this.mode===this.S_POLE){if(this.mode===this.N_POLE&&(i=-i),Math.abs(c+this.lat0)<1e-10)return null;r=Z-.5*c,e=(r=2*(this.mode===this.S_POLE?Math.cos(r):Math.sin(r)))*Math.sin(p),r*=i;}}else {switch(o=0,u=0,h=0,i=Math.cos(p),n=Math.sin(p),a=Math.sin(c),s=qe(this.e,a),this.mode!==this.OBLIQ&&this.mode!==this.EQUIT||(o=s/this.qp,u=Math.sqrt(1-o*o)),this.mode){case this.OBLIQ:h=1+this.sinb1*o+this.cosb1*u*i;break;case this.EQUIT:h=1+u*i;break;case this.N_POLE:h=X+c,s=this.qp-s;break;case this.S_POLE:h=c-X,s=this.qp+s;}if(Math.abs(h)<1e-10)return null;switch(this.mode){case this.OBLIQ:case this.EQUIT:h=Math.sqrt(2/h),r=this.mode===this.OBLIQ?this.ymf*h*(this.cosb1*o-this.sinb1*u*i):(h=Math.sqrt(2/(1+u*i)))*o*this.ymf,e=this.xmf*h*u*n;break;case this.N_POLE:case this.S_POLE:s>=0?(e=(h=Math.sqrt(s))*n,r=i*(this.mode===this.S_POLE?h:-h)):e=r=0;}}return t.x=this.a*e+this.x0,t.y=this.a*r+this.y0,t},inverse:function(t){t.x-=this.x0,t.y-=this.y0;var e,r,i,n,a,s,o,u,h,l,p=t.x/this.a,c=t.y/this.a;if(this.sphere){var f,y=0,d=0;if((r=.5*(f=Math.sqrt(p*p+c*c)))>1)return null;switch(r=2*Math.asin(r),this.mode!==this.OBLIQ&&this.mode!==this.EQUIT||(d=Math.sin(r),y=Math.cos(r)),this.mode){case this.EQUIT:r=Math.abs(f)<=1e-10?0:Math.asin(c*d/f),p*=d,c=y*f;break;case this.OBLIQ:r=Math.abs(f)<=1e-10?this.lat0:Math.asin(y*this.sinph0+c*d*this.cosph0/f),p*=d*this.cosph0,c=(y-Math.sin(r)*this.sinph0)*f;break;case this.N_POLE:c=-c,r=X-r;break;case this.S_POLE:r-=X;}e=0!==c||this.mode!==this.EQUIT&&this.mode!==this.OBLIQ?Math.atan2(p,c):0;}else {if(o=0,this.mode===this.OBLIQ||this.mode===this.EQUIT){if(p/=this.dd,c*=this.dd,(s=Math.sqrt(p*p+c*c))<1e-10)return t.x=this.long0,t.y=this.lat0,t;n=2*Math.asin(.5*s/this.rq),i=Math.cos(n),p*=n=Math.sin(n),this.mode===this.OBLIQ?(a=this.qp*(o=i*this.sinb1+c*n*this.cosb1/s),c=s*this.cosb1*i-c*this.sinb1*n):(a=this.qp*(o=c*n/s),c=s*i);}else if(this.mode===this.N_POLE||this.mode===this.S_POLE){if(this.mode===this.N_POLE&&(c=-c),!(a=p*p+c*c))return t.x=this.long0,t.y=this.lat0,t;o=1-a/this.qp,this.mode===this.S_POLE&&(o=-o);}e=Math.atan2(p,c),l=(u=Math.asin(o))+u,r=u+(h=this.apa)[0]*Math.sin(l)+h[1]*Math.sin(l+l)+h[2]*Math.sin(l+l+l);}return t.x=bt(this.long0+e),t.y=r,t},names:["Lambert Azimuthal Equal Area","Lambert_Azimuthal_Equal_Area","laea"],S_POLE:1,N_POLE:2,EQUIT:3,OBLIQ:4};function Ue(t){return Math.abs(t)>1&&(t=t>1?1:-1),Math.asin(t)}var Ge={init:function(){Math.abs(this.lat1+this.lat2)<1e-10||(this.temp=this.b/this.a,this.es=1-Math.pow(this.temp,2),this.e3=Math.sqrt(this.es),this.sin_po=Math.sin(this.lat1),this.cos_po=Math.cos(this.lat1),this.t1=this.sin_po,this.con=this.sin_po,this.ms1=gt(this.e3,this.sin_po,this.cos_po),this.qs1=qe(this.e3,this.sin_po),this.sin_po=Math.sin(this.lat2),this.cos_po=Math.cos(this.lat2),this.t2=this.sin_po,this.ms2=gt(this.e3,this.sin_po,this.cos_po),this.qs2=qe(this.e3,this.sin_po),this.sin_po=Math.sin(this.lat0),this.cos_po=Math.cos(this.lat0),this.t3=this.sin_po,this.qs0=qe(this.e3,this.sin_po),this.ns0=Math.abs(this.lat1-this.lat2)>1e-10?(this.ms1*this.ms1-this.ms2*this.ms2)/(this.qs2-this.qs1):this.con,this.c=this.ms1*this.ms1+this.ns0*this.qs1,this.rh=this.a*Math.sqrt(this.c-this.ns0*this.qs0)/this.ns0);},forward:function(t){var e=t.x,r=t.y;this.sin_phi=Math.sin(r),this.cos_phi=Math.cos(r);var i=qe(this.e3,this.sin_phi),n=this.a*Math.sqrt(this.c-this.ns0*i)/this.ns0,a=this.ns0*bt(e-this.long0),s=n*Math.sin(a)+this.x0,o=this.rh-n*Math.cos(a)+this.y0;return t.x=s,t.y=o,t},inverse:function(t){var e,r,i,n,a;return t.x-=this.x0,t.y=this.rh-t.y+this.y0,this.ns0>=0?(e=Math.sqrt(t.x*t.x+t.y*t.y),r=1):(e=-Math.sqrt(t.x*t.x+t.y*t.y),r=-1),i=0,0!==e&&(i=Math.atan2(r*t.x,r*t.y)),r=e*this.ns0/this.a,a=this.sphere?Math.asin((this.c-r*r)/(2*this.ns0)):this.phi1z(this.e3,(this.c-r*r)/this.ns0),n=bt(i/this.ns0+this.long0),t.x=n,t.y=a,t},names:["Albers_Conic_Equal_Area","Albers","aea"],phi1z:function(t,e){var r,i,n,a,s=Ue(.5*e);if(t<1e-10)return s;for(var o=t*t,u=1;u<=25;u++)if(s+=a=.5*(n=1-(i=t*(r=Math.sin(s)))*i)*n/Math.cos(s)*(e/(1-o)-r/n+.5/t*Math.log((1-i)/(1+i))),Math.abs(a)<=1e-7)return s;return null}},Ke={init:function(){this.sin_p14=Math.sin(this.lat0),this.cos_p14=Math.cos(this.lat0),this.infinity_dist=1e3*this.a,this.rc=1;},forward:function(t){var e,r,i,n,a,s,o,u=t.y;return i=bt(t.x-this.long0),e=Math.sin(u),r=Math.cos(u),n=Math.cos(i),(a=this.sin_p14*e+this.cos_p14*r*n)>0||Math.abs(a)<=1e-10?(s=this.x0+1*this.a*r*Math.sin(i)/a,o=this.y0+1*this.a*(this.cos_p14*e-this.sin_p14*r*n)/a):(s=this.x0+this.infinity_dist*r*Math.sin(i),o=this.y0+this.infinity_dist*(this.cos_p14*e-this.sin_p14*r*n)),t.x=s,t.y=o,t},inverse:function(t){var e,r,i,n,a,s;return t.x=(t.x-this.x0)/this.a,t.y=(t.y-this.y0)/this.a,t.x/=this.k0,t.y/=this.k0,(e=Math.sqrt(t.x*t.x+t.y*t.y))?(n=Math.atan2(e,this.rc),r=Math.sin(n),s=Ue((i=Math.cos(n))*this.sin_p14+t.y*r*this.cos_p14/e),a=Math.atan2(t.x*r,e*this.cos_p14*i-t.y*this.sin_p14*r),a=bt(this.long0+a)):(s=this.phic0,a=0),t.x=a,t.y=s,t},names:["gnom"]},Xe={init:function(){this.sphere||(this.k0=gt(this.e,Math.sin(this.lat_ts),Math.cos(this.lat_ts)));},forward:function(t){var e,r,i=t.y,n=bt(t.x-this.long0);if(this.sphere)e=this.x0+this.a*n*Math.cos(this.lat_ts),r=this.y0+this.a*Math.sin(i)/Math.cos(this.lat_ts);else {var a=qe(this.e,Math.sin(i));e=this.x0+this.a*this.k0*n,r=this.y0+this.a*a*.5/this.k0;}return t.x=e,t.y=r,t},inverse:function(t){var e,r;return t.x-=this.x0,t.y-=this.y0,this.sphere?(e=bt(this.long0+t.x/this.a/Math.cos(this.lat_ts)),r=Math.asin(t.y/this.a*Math.cos(this.lat_ts))):(r=function(t,e){var r=1-(1-t*t)/(2*t)*Math.log((1-t)/(1+t));if(Math.abs(Math.abs(e)-r)<1e-6)return e<0?-1*X:X;for(var i,n,a,s,o=Math.asin(.5*e),u=0;u<30;u++)if(n=Math.sin(o),a=Math.cos(o),s=t*n,o+=i=Math.pow(1-s*s,2)/(2*a)*(e/(1-t*t)-n/(1-s*s)+.5/t*Math.log((1-s)/(1+s))),Math.abs(i)<=1e-10)return o;return NaN}(this.e,2*t.y*this.k0/this.a),e=bt(this.long0+t.x/(this.a*this.k0))),t.x=e,t.y=r,t},names:["cea"]},He={init:function(){this.x0=this.x0||0,this.y0=this.y0||0,this.lat0=this.lat0||0,this.long0=this.long0||0,this.lat_ts=this.lat_ts||0,this.title=this.title||"Equidistant Cylindrical (Plate Carre)",this.rc=Math.cos(this.lat_ts);},forward:function(t){var e=t.y,r=bt(t.x-this.long0),i=De(e-this.lat0);return t.x=this.x0+this.a*r*this.rc,t.y=this.y0+this.a*i,t},inverse:function(t){var e=t.y;return t.x=bt(this.long0+(t.x-this.x0)/(this.a*this.rc)),t.y=De(this.lat0+(e-this.y0)/this.a),t},names:["Equirectangular","Equidistant_Cylindrical","eqc"]},Je={init:function(){this.temp=this.b/this.a,this.es=1-Math.pow(this.temp,2),this.e=Math.sqrt(this.es),this.e0=Te(this.es),this.e1=Ve(this.es),this.e2=Le(this.es),this.e3=Fe(this.es),this.ml0=this.a*Be(this.e0,this.e1,this.e2,this.e3,this.lat0);},forward:function(t){var e,r,i,n=t.y,a=bt(t.x-this.long0);if(i=a*Math.sin(n),this.sphere)Math.abs(n)<=1e-10?(e=this.a*a,r=-1*this.a*this.lat0):(e=this.a*Math.sin(i)/Math.tan(n),r=this.a*(De(n-this.lat0)+(1-Math.cos(i))/Math.tan(n)));else if(Math.abs(n)<=1e-10)e=this.a*a,r=-1*this.ml0;else {var s=Oe(this.a,this.e,Math.sin(n))/Math.tan(n);e=s*Math.sin(i),r=this.a*Be(this.e0,this.e1,this.e2,this.e3,n)-this.ml0+s*(1-Math.cos(i));}return t.x=e+this.x0,t.y=r+this.y0,t},inverse:function(t){var e,r,i,n,a,s,o,u,h;if(i=t.x-this.x0,n=t.y-this.y0,this.sphere)if(Math.abs(n+this.a*this.lat0)<=1e-10)e=bt(i/this.a+this.long0),r=0;else {var l;for(o=i*i/this.a/this.a+(s=this.lat0+n/this.a)*s,u=s,a=20;a;--a)if(u+=h=-1*(s*(u*(l=Math.tan(u))+1)-u-.5*(u*u+o)*l)/((u-s)/l-1),Math.abs(h)<=1e-10){r=u;break}e=bt(this.long0+Math.asin(i*Math.tan(u)/this.a)/Math.sin(r));}else if(Math.abs(n+this.ml0)<=1e-10)r=0,e=bt(this.long0+i/this.a);else {var p,c,f,y,d;for(o=i*i/this.a/this.a+(s=(this.ml0+n)/this.a)*s,u=s,a=20;a;--a)if(d=this.e*Math.sin(u),p=Math.sqrt(1-d*d)*Math.tan(u),c=this.a*Be(this.e0,this.e1,this.e2,this.e3,u),f=this.e0-2*this.e1*Math.cos(2*u)+4*this.e2*Math.cos(4*u)-6*this.e3*Math.cos(6*u),u-=h=(s*(p*(y=c/this.a)+1)-y-.5*p*(y*y+o))/(this.es*Math.sin(2*u)*(y*y+o-2*s*y)/(4*p)+(s-y)*(p*f-2/Math.sin(2*u))-f),Math.abs(h)<=1e-10){r=u;break}p=Math.sqrt(1-this.es*Math.pow(Math.sin(r),2))*Math.tan(r),e=bt(this.long0+Math.asin(i*p/this.a)/Math.sin(r));}return t.x=e,t.y=r,t},names:["Polyconic","poly"]},Ze={init:function(){this.A=[],this.A[1]=.6399175073,this.A[2]=-.1358797613,this.A[3]=.063294409,this.A[4]=-.02526853,this.A[5]=.0117879,this.A[6]=-.0055161,this.A[7]=.0026906,this.A[8]=-.001333,this.A[9]=67e-5,this.A[10]=-34e-5,this.B_re=[],this.B_im=[],this.B_re[1]=.7557853228,this.B_im[1]=0,this.B_re[2]=.249204646,this.B_im[2]=.003371507,this.B_re[3]=-.001541739,this.B_im[3]=.04105856,this.B_re[4]=-.10162907,this.B_im[4]=.01727609,this.B_re[5]=-.26623489,this.B_im[5]=-.36249218,this.B_re[6]=-.6870983,this.B_im[6]=-1.1651967,this.C_re=[],this.C_im=[],this.C_re[1]=1.3231270439,this.C_im[1]=0,this.C_re[2]=-.577245789,this.C_im[2]=-.007809598,this.C_re[3]=.508307513,this.C_im[3]=-.112208952,this.C_re[4]=-.15094762,this.C_im[4]=.18200602,this.C_re[5]=1.01418179,this.C_im[5]=1.64497696,this.C_re[6]=1.9660549,this.C_im[6]=2.5127645,this.D=[],this.D[1]=1.5627014243,this.D[2]=.5185406398,this.D[3]=-.03333098,this.D[4]=-.1052906,this.D[5]=-.0368594,this.D[6]=.007317,this.D[7]=.0122,this.D[8]=.00394,this.D[9]=-.0013;},forward:function(t){var e,r=(t.y-this.lat0)/K*1e-5,i=t.x-this.long0,n=1,a=0;for(e=1;e<=10;e++)a+=this.A[e]*(n*=r);var s,o=a,u=i,h=1,l=0,p=0,c=0;for(e=1;e<=6;e++)s=l*o+h*u,p=p+this.B_re[e]*(h=h*o-l*u)-this.B_im[e]*(l=s),c=c+this.B_im[e]*h+this.B_re[e]*l;return t.x=c*this.a+this.x0,t.y=p*this.a+this.y0,t},inverse:function(t){var e,r,i=(t.y-this.y0)/this.a,n=(t.x-this.x0)/this.a,a=1,s=0,o=0,u=0;for(e=1;e<=6;e++)r=s*i+a*n,o=o+this.C_re[e]*(a=a*i-s*n)-this.C_im[e]*(s=r),u=u+this.C_im[e]*a+this.C_re[e]*s;for(var h=0;h<this.iterations;h++){var l,p=o,c=u,f=i,y=n;for(e=2;e<=6;e++)l=c*o+p*u,f+=(e-1)*(this.B_re[e]*(p=p*o-c*u)-this.B_im[e]*(c=l)),y+=(e-1)*(this.B_im[e]*p+this.B_re[e]*c);p=1,c=0;var d=this.B_re[1],m=this.B_im[1];for(e=2;e<=6;e++)l=c*o+p*u,d+=e*(this.B_re[e]*(p=p*o-c*u)-this.B_im[e]*(c=l)),m+=e*(this.B_im[e]*p+this.B_re[e]*c);var v=d*d+m*m;o=(f*d+y*m)/v,u=(y*d-f*m)/v;}var g=o,x=u,b=1,_=0;for(e=1;e<=9;e++)_+=this.D[e]*(b*=g);var w=this.lat0+_*K*1e5;return t.x=this.long0+x,t.y=w,t},names:["New_Zealand_Map_Grid","nzmg"]},Ye={init:function(){},forward:function(t){var e=t.y,r=bt(t.x-this.long0),i=this.x0+this.a*r,n=this.y0+this.a*Math.log(Math.tan(Math.PI/4+e/2.5))*1.25;return t.x=i,t.y=n,t},inverse:function(t){t.x-=this.x0,t.y-=this.y0;var e=bt(this.long0+t.x/this.a),r=2.5*(Math.atan(Math.exp(.8*t.y/this.a))-Math.PI/4);return t.x=e,t.y=r,t},names:["Miller_Cylindrical","mill"]},We={init:function(){this.sphere?(this.n=1,this.m=0,this.es=0,this.C_y=Math.sqrt((this.m+1)/this.n),this.C_x=this.C_y/(this.m+1)):this.en=ye(this.es);},forward:function(t){var e,r,i=t.x,n=t.y;if(i=bt(i-this.long0),this.sphere){if(this.m)for(var a=this.n*Math.sin(n),s=20;s;--s){var o=(this.m*n+Math.sin(n)-a)/(this.m+Math.cos(n));if(n-=o,Math.abs(o)<1e-10)break}else n=1!==this.n?Math.asin(this.n*Math.sin(n)):n;e=this.a*this.C_x*i*(this.m+Math.cos(n)),r=this.a*this.C_y*n;}else {var u=Math.sin(n),h=Math.cos(n);r=this.a*de(n,u,h,this.en),e=this.a*i*h/Math.sqrt(1-this.es*u*u);}return t.x=e,t.y=r,t},inverse:function(t){var e,r,i;return t.x-=this.x0,r=t.x/this.a,t.y-=this.y0,e=t.y/this.a,this.sphere?(e/=this.C_y,r/=this.C_x*(this.m+Math.cos(e)),this.m?e=Ue((this.m*e+Math.sin(e))/this.n):1!==this.n&&(e=Ue(Math.sin(e)/this.n)),r=bt(r+this.long0),e=De(e)):(e=me(t.y/this.a,this.es,this.en),(i=Math.abs(e))<X?(i=Math.sin(e),r=bt(this.long0+t.x*Math.sqrt(1-this.es*i*i)/(this.a*Math.cos(e)))):i-1e-10<X&&(r=this.long0)),t.x=r,t.y=e,t},names:["Sinusoidal","sinu"]},Qe={init:function(){},forward:function(t){for(var e=t.y,r=bt(t.x-this.long0),i=e,n=Math.PI*Math.sin(e);;){var a=-(i+Math.sin(i)-n)/(1+Math.cos(i));if(i+=a,Math.abs(a)<1e-10)break}i/=2,Math.PI/2-Math.abs(e)<1e-10&&(r=0);var s=.900316316158*this.a*r*Math.cos(i)+this.x0,o=1.4142135623731*this.a*Math.sin(i)+this.y0;return t.x=s,t.y=o,t},inverse:function(t){var e,r;t.x-=this.x0,t.y-=this.y0,r=t.y/(1.4142135623731*this.a),Math.abs(r)>.999999999999&&(r=.999999999999),e=Math.asin(r);var i=bt(this.long0+t.x/(.900316316158*this.a*Math.cos(e)));i<-Math.PI&&(i=-Math.PI),i>Math.PI&&(i=Math.PI),r=(2*e+Math.sin(2*e))/Math.PI,Math.abs(r)>1&&(r=1);var n=Math.asin(r);return t.x=i,t.y=n,t},names:["Mollweide","moll"]},$e={init:function(){Math.abs(this.lat1+this.lat2)<1e-10||(this.lat2=this.lat2||this.lat1,this.temp=this.b/this.a,this.es=1-Math.pow(this.temp,2),this.e=Math.sqrt(this.es),this.e0=Te(this.es),this.e1=Ve(this.es),this.e2=Le(this.es),this.e3=Fe(this.es),this.sinphi=Math.sin(this.lat1),this.cosphi=Math.cos(this.lat1),this.ms1=gt(this.e,this.sinphi,this.cosphi),this.ml1=Be(this.e0,this.e1,this.e2,this.e3,this.lat1),Math.abs(this.lat1-this.lat2)<1e-10?this.ns=this.sinphi:(this.sinphi=Math.sin(this.lat2),this.cosphi=Math.cos(this.lat2),this.ms2=gt(this.e,this.sinphi,this.cosphi),this.ml2=Be(this.e0,this.e1,this.e2,this.e3,this.lat2),this.ns=(this.ms1-this.ms2)/(this.ml2-this.ml1)),this.g=this.ml1+this.ms1/this.ns,this.ml0=Be(this.e0,this.e1,this.e2,this.e3,this.lat0),this.rh=this.a*(this.g-this.ml0));},forward:function(t){var e,r=t.x,i=t.y;if(this.sphere)e=this.a*(this.g-i);else {var n=Be(this.e0,this.e1,this.e2,this.e3,i);e=this.a*(this.g-n);}var a=this.ns*bt(r-this.long0),s=this.x0+e*Math.sin(a),o=this.y0+this.rh-e*Math.cos(a);return t.x=s,t.y=o,t},inverse:function(t){var e,r,i,n;t.x-=this.x0,t.y=this.rh-t.y+this.y0,this.ns>=0?(r=Math.sqrt(t.x*t.x+t.y*t.y),e=1):(r=-Math.sqrt(t.x*t.x+t.y*t.y),e=-1);var a=0;return 0!==r&&(a=Math.atan2(e*t.x,e*t.y)),this.sphere?(n=bt(this.long0+a/this.ns),i=De(this.g-r/this.a),t.x=n,t.y=i,t):(i=Ne(this.g-r/this.a,this.e0,this.e1,this.e2,this.e3),n=bt(this.long0+a/this.ns),t.x=n,t.y=i,t)},names:["Equidistant_Conic","eqdc"]},tr={init:function(){this.R=this.a;},forward:function(t){var e,r,i=t.y,n=bt(t.x-this.long0);Math.abs(i)<=1e-10&&(e=this.x0+this.R*n,r=this.y0);var a=Ue(2*Math.abs(i/Math.PI));(Math.abs(n)<=1e-10||Math.abs(Math.abs(i)-X)<=1e-10)&&(e=this.x0,r=i>=0?this.y0+Math.PI*this.R*Math.tan(.5*a):this.y0+Math.PI*this.R*-Math.tan(.5*a));var s=.5*Math.abs(Math.PI/n-n/Math.PI),o=s*s,u=Math.sin(a),h=Math.cos(a),l=h/(u+h-1),p=l*(2/u-1),c=p*p,f=Math.PI*this.R*(s*(l-c)+Math.sqrt(o*(l-c)*(l-c)-(c+o)*(l*l-c)))/(c+o);n<0&&(f=-f),e=this.x0+f;var y=o+l;return f=Math.PI*this.R*(p*y-s*Math.sqrt((c+o)*(o+1)-y*y))/(c+o),r=i>=0?this.y0+f:this.y0-f,t.x=e,t.y=r,t},inverse:function(t){var e,r,i,n,a,s,o,u,h,l,p,c;return t.x-=this.x0,t.y-=this.y0,p=Math.PI*this.R,a=(i=t.x/p)*i+(n=t.y/p)*n,p=3*(n*n/(u=-2*(s=-Math.abs(n)*(1+a))+1+2*n*n+a*a)+(2*(o=s-2*n*n+i*i)*o*o/u/u/u-9*s*o/u/u)/27)/(h=(s-o*o/3/u)/u)/(l=2*Math.sqrt(-h/3)),Math.abs(p)>1&&(p=p>=0?1:-1),c=Math.acos(p)/3,r=t.y>=0?(-l*Math.cos(c+Math.PI/3)-o/3/u)*Math.PI:-(-l*Math.cos(c+Math.PI/3)-o/3/u)*Math.PI,e=Math.abs(i)<1e-10?this.long0:bt(this.long0+Math.PI*(a-1+Math.sqrt(1+2*(i*i-n*n)+a*a))/2/i),t.x=e,t.y=r,t},names:["Van_der_Grinten_I","VanDerGrinten","vandg"]},er={init:function(){this.sin_p12=Math.sin(this.lat0),this.cos_p12=Math.cos(this.lat0);},forward:function(t){var e,r,i,n,a,s,o,u,h,l,p,c,f,y,d,m,v,g,x,b,_,w,M=t.x,S=t.y,A=Math.sin(t.y),k=Math.cos(t.y),I=bt(M-this.long0);return this.sphere?Math.abs(this.sin_p12-1)<=1e-10?(t.x=this.x0+this.a*(X-S)*Math.sin(I),t.y=this.y0-this.a*(X-S)*Math.cos(I),t):Math.abs(this.sin_p12+1)<=1e-10?(t.x=this.x0+this.a*(X+S)*Math.sin(I),t.y=this.y0+this.a*(X+S)*Math.cos(I),t):(g=this.sin_p12*A+this.cos_p12*k*Math.cos(I),v=(m=Math.acos(g))?m/Math.sin(m):1,t.x=this.x0+this.a*v*k*Math.sin(I),t.y=this.y0+this.a*v*(this.cos_p12*A-this.sin_p12*k*Math.cos(I)),t):(e=Te(this.es),r=Ve(this.es),i=Le(this.es),n=Fe(this.es),Math.abs(this.sin_p12-1)<=1e-10?(a=this.a*Be(e,r,i,n,X),s=this.a*Be(e,r,i,n,S),t.x=this.x0+(a-s)*Math.sin(I),t.y=this.y0-(a-s)*Math.cos(I),t):Math.abs(this.sin_p12+1)<=1e-10?(a=this.a*Be(e,r,i,n,X),s=this.a*Be(e,r,i,n,S),t.x=this.x0+(a+s)*Math.sin(I),t.y=this.y0+(a+s)*Math.cos(I),t):(o=A/k,u=Oe(this.a,this.e,this.sin_p12),h=Oe(this.a,this.e,A),l=Math.atan((1-this.es)*o+this.es*u*this.sin_p12/(h*k)),x=0===(p=Math.atan2(Math.sin(I),this.cos_p12*Math.tan(l)-this.sin_p12*Math.cos(I)))?Math.asin(this.cos_p12*Math.sin(l)-this.sin_p12*Math.cos(l)):Math.abs(Math.abs(p)-Math.PI)<=1e-10?-Math.asin(this.cos_p12*Math.sin(l)-this.sin_p12*Math.cos(l)):Math.asin(Math.sin(I)*Math.cos(l)/Math.sin(p)),c=this.e*this.sin_p12/Math.sqrt(1-this.es),f=this.e*this.cos_p12*Math.cos(p)/Math.sqrt(1-this.es),t.x=this.x0+(m=u*x*(1-(b=x*x)*(d=f*f)*(1-d)/6+(_=b*x)/8*(y=c*f)*(1-2*d)+(w=_*x)/120*(d*(4-7*d)-3*c*c*(1-7*d))-w*x/48*y))*Math.sin(p),t.y=this.y0+m*Math.cos(p),t))},inverse:function(t){var e,r,i,n,a,s,o,u,h,l,p,c,f,y,d,m,v,g,x,b,_,w,M;if(t.x-=this.x0,t.y-=this.y0,this.sphere){if((e=Math.sqrt(t.x*t.x+t.y*t.y))>2*X*this.a)return;return r=e/this.a,i=Math.sin(r),n=Math.cos(r),a=this.long0,Math.abs(e)<=1e-10?s=this.lat0:(s=Ue(n*this.sin_p12+t.y*i*this.cos_p12/e),o=Math.abs(this.lat0)-X,a=Math.abs(o)<=1e-10?bt(this.lat0>=0?this.long0+Math.atan2(t.x,-t.y):this.long0-Math.atan2(-t.x,t.y)):bt(this.long0+Math.atan2(t.x*i,e*this.cos_p12*n-t.y*this.sin_p12*i))),t.x=a,t.y=s,t}return u=Te(this.es),h=Ve(this.es),l=Le(this.es),p=Fe(this.es),Math.abs(this.sin_p12-1)<=1e-10?(s=Ne(((c=this.a*Be(u,h,l,p,X))-(e=Math.sqrt(t.x*t.x+t.y*t.y)))/this.a,u,h,l,p),a=bt(this.long0+Math.atan2(t.x,-1*t.y)),t.x=a,t.y=s,t):Math.abs(this.sin_p12+1)<=1e-10?(c=this.a*Be(u,h,l,p,X),s=Ne(((e=Math.sqrt(t.x*t.x+t.y*t.y))-c)/this.a,u,h,l,p),a=bt(this.long0+Math.atan2(t.x,t.y)),t.x=a,t.y=s,t):(e=Math.sqrt(t.x*t.x+t.y*t.y),d=Math.atan2(t.x,t.y),f=Oe(this.a,this.e,this.sin_p12),m=Math.cos(d),x=3*this.es*(1-(g=-(v=this.e*this.cos_p12*m)*v/(1-this.es)))*this.sin_p12*this.cos_p12*m/(1-this.es),w=1-g*(_=(b=e/f)-g*(1+g)*Math.pow(b,3)/6-x*(1+3*g)*Math.pow(b,4)/24)*_/2-b*_*_*_/6,y=Math.asin(this.sin_p12*Math.cos(_)+this.cos_p12*Math.sin(_)*m),a=bt(this.long0+Math.asin(Math.sin(d)*Math.sin(_)/Math.cos(y))),M=Math.sin(y),s=Math.atan2((M-this.es*w*this.sin_p12)*Math.tan(y),M*(1-this.es)),t.x=a,t.y=s,t)},names:["Azimuthal_Equidistant","aeqd"]},rr={init:function(){this.sin_p14=Math.sin(this.lat0),this.cos_p14=Math.cos(this.lat0);},forward:function(t){var e,r,i,n,a,s,o,u=t.y;return i=bt(t.x-this.long0),e=Math.sin(u),r=Math.cos(u),n=Math.cos(i),((a=this.sin_p14*e+this.cos_p14*r*n)>0||Math.abs(a)<=1e-10)&&(s=1*this.a*r*Math.sin(i),o=this.y0+1*this.a*(this.cos_p14*e-this.sin_p14*r*n)),t.x=s,t.y=o,t},inverse:function(t){var e,r,i,n,a,s,o;return t.x-=this.x0,t.y-=this.y0,r=Ue((e=Math.sqrt(t.x*t.x+t.y*t.y))/this.a),i=Math.sin(r),n=Math.cos(r),s=this.long0,Math.abs(e)<=1e-10?(o=this.lat0,t.x=s,t.y=o,t):(o=Ue(n*this.sin_p14+t.y*i*this.cos_p14/e),a=Math.abs(this.lat0)-X,Math.abs(a)<=1e-10?(s=bt(this.lat0>=0?this.long0+Math.atan2(t.x,-t.y):this.long0-Math.atan2(-t.x,t.y)),t.x=s,t.y=o,t):(s=bt(this.long0+Math.atan2(t.x*i,e*this.cos_p14*n-t.y*this.sin_p14*i)),t.x=s,t.y=o,t))},names:["ortho"]};function ir(t,e,r,i){var n;return t<1e-10?(i.value=1,n=0):(n=Math.atan2(e,r),Math.abs(n)<=Z?i.value=1:n>Z&&n<=X+Z?(i.value=2,n-=X):n>X+Z||n<=-(X+Z)?(i.value=3,n=n>=0?n-W:n+W):(i.value=4,n+=X)),n}function nr(t,e){var r=t+e;return r<-W?r+=Y:r>+W&&(r-=Y),r}var ar={init:function(){this.x0=this.x0||0,this.y0=this.y0||0,this.lat0=this.lat0||0,this.long0=this.long0||0,this.lat_ts=this.lat_ts||0,this.title=this.title||"Quadrilateralized Spherical Cube",this.face=this.lat0>=X-Z/2?5:this.lat0<=-(X-Z/2)?6:Math.abs(this.long0)<=Z?1:Math.abs(this.long0)<=X+Z?this.long0>0?2:4:3,0!==this.es&&(this.one_minus_f=1-(this.a-this.b)/this.a,this.one_minus_f_squared=this.one_minus_f*this.one_minus_f);},forward:function(t){var e,r,i,n,a,s,o={x:0,y:0},u={value:0};if(t.x-=this.long0,e=0!==this.es?Math.atan(this.one_minus_f_squared*Math.tan(t.y)):t.y,r=t.x,5===this.face)n=X-e,r>=Z&&r<=X+Z?(u.value=1,i=r-X):r>X+Z||r<=-(X+Z)?(u.value=2,i=r>0?r-W:r+W):r>-(X+Z)&&r<=-Z?(u.value=3,i=r+X):(u.value=4,i=r);else if(6===this.face)n=X+e,r>=Z&&r<=X+Z?(u.value=1,i=-r+X):r<Z&&r>=-Z?(u.value=2,i=-r):r<-Z&&r>=-(X+Z)?(u.value=3,i=-r-X):(u.value=4,i=r>0?-r+W:-r-W);else {var h,l,p,c,f,y;2===this.face?r=nr(r,+X):3===this.face?r=nr(r,+W):4===this.face&&(r=nr(r,-X)),c=Math.sin(e),f=Math.cos(e),y=Math.sin(r),h=f*Math.cos(r),l=f*y,p=c,1===this.face?i=ir(n=Math.acos(h),p,l,u):2===this.face?i=ir(n=Math.acos(l),p,-h,u):3===this.face?i=ir(n=Math.acos(-h),p,-l,u):4===this.face?i=ir(n=Math.acos(-l),p,h,u):(n=i=0,u.value=1);}return s=Math.atan(12/W*(i+Math.acos(Math.sin(i)*Math.cos(Z))-X)),a=Math.sqrt((1-Math.cos(n))/(Math.cos(s)*Math.cos(s))/(1-Math.cos(Math.atan(1/Math.cos(i))))),2===u.value?s+=X:3===u.value?s+=W:4===u.value&&(s+=1.5*W),o.x=a*Math.cos(s),o.y=a*Math.sin(s),o.x=o.x*this.a+this.x0,o.y=o.y*this.a+this.y0,t.x=o.x,t.y=o.y,t},inverse:function(t){var e,r,i,n,a,s,o,u,h,l,p,c,f={lam:0,phi:0},y={value:0};if(t.x=(t.x-this.x0)/this.a,t.y=(t.y-this.y0)/this.a,r=Math.atan(Math.sqrt(t.x*t.x+t.y*t.y)),e=Math.atan2(t.y,t.x),t.x>=0&&t.x>=Math.abs(t.y)?y.value=1:t.y>=0&&t.y>=Math.abs(t.x)?(y.value=2,e-=X):t.x<0&&-t.x>=Math.abs(t.y)?(y.value=3,e=e<0?e+W:e-W):(y.value=4,e+=X),h=W/12*Math.tan(e),a=Math.sin(h)/(Math.cos(h)-1/Math.sqrt(2)),s=Math.atan(a),(o=1-(i=Math.cos(e))*i*(n=Math.tan(r))*n*(1-Math.cos(Math.atan(1/Math.cos(s)))))<-1?o=-1:o>1&&(o=1),5===this.face)u=Math.acos(o),f.phi=X-u,f.lam=1===y.value?s+X:2===y.value?s<0?s+W:s-W:3===y.value?s-X:s;else if(6===this.face)u=Math.acos(o),f.phi=u-X,f.lam=1===y.value?-s+X:2===y.value?-s:3===y.value?-s-X:s<0?-s-W:-s+W;else {var d,m,v;h=(d=o)*d,m=(h+=(v=h>=1?0:Math.sqrt(1-h)*Math.sin(s))*v)>=1?0:Math.sqrt(1-h),2===y.value?(h=m,m=-v,v=h):3===y.value?(m=-m,v=-v):4===y.value&&(h=m,m=v,v=-h),2===this.face?(h=d,d=-m,m=h):3===this.face?(d=-d,m=-m):4===this.face&&(h=d,d=m,m=-h),f.phi=Math.acos(-v)-X,f.lam=Math.atan2(m,d),2===this.face?f.lam=nr(f.lam,-X):3===this.face?f.lam=nr(f.lam,-W):4===this.face&&(f.lam=nr(f.lam,+X));}return 0!==this.es&&(l=f.phi<0?1:0,p=Math.tan(f.phi),c=this.b/Math.sqrt(p*p+this.one_minus_f_squared),f.phi=Math.atan(Math.sqrt(this.a*this.a-c*c)/(this.one_minus_f*c)),l&&(f.phi=-f.phi)),f.lam+=this.long0,t.x=f.lam,t.y=f.phi,t},names:["Quadrilateralized Spherical Cube","Quadrilateralized_Spherical_Cube","qsc"]},sr=[[1,22199e-21,-715515e-10,31103e-10],[.9986,-482243e-9,-24897e-9,-13309e-10],[.9954,-83103e-8,-448605e-10,-9.86701e-7],[.99,-.00135364,-59661e-9,36777e-10],[.9822,-.00167442,-449547e-11,-572411e-11],[.973,-.00214868,-903571e-10,1.8736e-8],[.96,-.00305085,-900761e-10,164917e-11],[.9427,-.00382792,-653386e-10,-26154e-10],[.9216,-.00467746,-10457e-8,481243e-11],[.8962,-.00536223,-323831e-10,-543432e-11],[.8679,-.00609363,-113898e-9,332484e-11],[.835,-.00698325,-640253e-10,9.34959e-7],[.7986,-.00755338,-500009e-10,9.35324e-7],[.7597,-.00798324,-35971e-9,-227626e-11],[.7186,-.00851367,-701149e-10,-86303e-10],[.6732,-.00986209,-199569e-9,191974e-10],[.6213,-.010418,883923e-10,624051e-11],[.5722,-.00906601,182e-6,624051e-11],[.5322,-.00677797,275608e-9,624051e-11]],or=[[-520417e-23,.0124,121431e-23,-845284e-16],[.062,.0124,-1.26793e-9,4.22642e-10],[.124,.0124,5.07171e-9,-1.60604e-9],[.186,.0123999,-1.90189e-8,6.00152e-9],[.248,.0124002,7.10039e-8,-2.24e-8],[.31,.0123992,-2.64997e-7,8.35986e-8],[.372,.0124029,9.88983e-7,-3.11994e-7],[.434,.0123893,-369093e-11,-4.35621e-7],[.4958,.0123198,-102252e-10,-3.45523e-7],[.5571,.0121916,-154081e-10,-5.82288e-7],[.6176,.0119938,-241424e-10,-5.25327e-7],[.6769,.011713,-320223e-10,-5.16405e-7],[.7346,.0113541,-397684e-10,-6.09052e-7],[.7903,.0109107,-489042e-10,-104739e-11],[.8435,.0103431,-64615e-9,-1.40374e-9],[.8936,.00969686,-64636e-9,-8547e-9],[.9394,.00840947,-192841e-9,-42106e-10],[.9761,.00616527,-256e-6,-42106e-10],[1,.00328947,-319159e-9,-42106e-10]],ur=function(t,e){return t[0]+e*(t[1]+e*(t[2]+e*t[3]))},hr={init:function(){this.x0=this.x0||0,this.y0=this.y0||0,this.long0=this.long0||0,this.es=0,this.title=this.title||"Robinson";},forward:function(t){var e=bt(t.x-this.long0),r=Math.abs(t.y),i=Math.floor(11.459155902616464*r);i<0?i=0:i>=18&&(i=17);var n={x:ur(sr[i],r=J*(r-.08726646259971647*i))*e,y:ur(or[i],r)};return t.y<0&&(n.y=-n.y),n.x=n.x*this.a*.8487+this.x0,n.y=n.y*this.a*1.3523+this.y0,n},inverse:function(t){var e={x:(t.x-this.x0)/(.8487*this.a),y:Math.abs(t.y-this.y0)/(1.3523*this.a)};if(e.y>=1)e.x/=sr[18][0],e.y=t.y<0?-X:X;else {var r=Math.floor(18*e.y);for(r<0?r=0:r>=18&&(r=17);;)if(or[r][0]>e.y)--r;else {if(!(or[r+1][0]<=e.y))break;++r;}var i=or[r],n=5*(e.y-i[0])/(or[r+1][0]-i[0]);n=function(t,e,r,i){for(var n=e;i;--i){var a=t(n);if(n-=a,Math.abs(a)<1e-10)break}return n}((function(t){return (ur(i,t)-e.y)/function(t,e){return t[1]+e*(2*t[2]+3*e*t[3])}(i,t)}),n,0,100),e.x/=ur(sr[r],n),e.y=(5*r+n)*H,t.y<0&&(e.y=-e.y);}return e.x=bt(e.x+this.long0),e},names:["Robinson","robin"]},lr={init:function(){this.name="geocent";},forward:function(t){return Rt(t,this.es,this.a)},inverse:function(t){return qt(t,this.es,this.a,this.b)},names:["Geocentric","geocentric","geocent","Geocent"]},pr={h:{def:1e5,num:!0},azi:{def:0,num:!0,degrees:!0},tilt:{def:0,num:!0,degrees:!0},long0:{def:0,num:!0},lat0:{def:0,num:!0}},cr={init:function(){if(Object.keys(pr).forEach(function(t){if(void 0===this[t])this[t]=pr[t].def;else {if(pr[t].num&&isNaN(this[t]))throw new Error("Invalid parameter value, must be numeric "+t+" = "+this[t]);pr[t].num&&(this[t]=parseFloat(this[t]));}pr[t].degrees&&(this[t]=this[t]*H);}.bind(this)),Math.abs(Math.abs(this.lat0)-X)<1e-10?this.mode=this.lat0<0?1:0:Math.abs(this.lat0)<1e-10?this.mode=2:(this.mode=3,this.sinph0=Math.sin(this.lat0),this.cosph0=Math.cos(this.lat0)),this.pn1=this.h/this.a,this.pn1<=0||this.pn1>1e10)throw new Error("Invalid height");this.p=1+this.pn1,this.rp=1/this.p,this.h1=1/this.pn1,this.pfact=(this.p+1)*this.h1,this.es=0;var t=this.tilt,e=this.azi;this.cg=Math.cos(e),this.sg=Math.sin(e),this.cw=Math.cos(t),this.sw=Math.sin(t);},forward:function(t){t.x-=this.long0;var e,r,i,n,a=Math.sin(t.y),s=Math.cos(t.y),o=Math.cos(t.x);switch(this.mode){case 3:r=this.sinph0*a+this.cosph0*s*o;break;case 2:r=s*o;break;case 1:r=-a;break;case 0:r=a;}switch(e=(r=this.pn1/(this.p-r))*s*Math.sin(t.x),this.mode){case 3:r*=this.cosph0*a-this.sinph0*s*o;break;case 2:r*=a;break;case 0:r*=-s*o;break;case 1:r*=s*o;}return e=(e*this.cg-r*this.sg)*this.cw*(n=1/((i=r*this.cg+e*this.sg)*this.sw*this.h1+this.cw)),r=i*n,t.x=e*this.a,t.y=r*this.a,t},inverse:function(t){t.x/=this.a,t.y/=this.a;var e,r,i,n={x:t.x,y:t.y};t.x=(e=this.pn1*t.x*(i=1/(this.pn1-t.y*this.sw)))*this.cg+(r=this.pn1*t.y*this.cw*i)*this.sg,t.y=r*this.cg-e*this.sg;var a=xe(t.x,t.y);if(Math.abs(a)<1e-10)n.x=0,n.y=t.y;else {var s,o;switch(o=1-a*a*this.pfact,o=(this.p-Math.sqrt(o))/(this.pn1/a+a/this.pn1),s=Math.sqrt(1-o*o),this.mode){case 3:n.y=Math.asin(s*this.sinph0+t.y*o*this.cosph0/a),t.y=(s-this.sinph0*Math.sin(n.y))*a,t.x*=o*this.cosph0;break;case 2:n.y=Math.asin(t.y*o/a),t.y=s*a,t.x*=o;break;case 0:n.y=Math.asin(s),t.y=-t.y;break;case 1:n.y=-Math.asin(s);}n.x=Math.atan2(t.x,t.y);}return t.x=n.x+this.long0,t.y=n.y,t},names:["Tilted_Perspective","tpers"]},fr={init:function(){if(this.flip_axis="x"===this.sweep?1:0,this.h=Number(this.h),this.radius_g_1=this.h/this.a,this.radius_g_1<=0||this.radius_g_1>1e10)throw new Error;if(this.radius_g=1+this.radius_g_1,this.C=this.radius_g*this.radius_g-1,0!==this.es){var t=1-this.es,e=1/t;this.radius_p=Math.sqrt(t),this.radius_p2=t,this.radius_p_inv2=e,this.shape="ellipse";}else this.radius_p=1,this.radius_p2=1,this.radius_p_inv2=1,this.shape="sphere";this.title||(this.title="Geostationary Satellite View");},forward:function(t){var e,r,i,n,a=t.x,s=t.y;if(a-=this.long0,"ellipse"===this.shape){s=Math.atan(this.radius_p2*Math.tan(s));var o=this.radius_p/xe(this.radius_p*Math.cos(s),Math.sin(s));if(r=o*Math.cos(a)*Math.cos(s),i=o*Math.sin(a)*Math.cos(s),n=o*Math.sin(s),(this.radius_g-r)*r-i*i-n*n*this.radius_p_inv2<0)return t.x=Number.NaN,t.y=Number.NaN,t;e=this.radius_g-r,this.flip_axis?(t.x=this.radius_g_1*Math.atan(i/xe(n,e)),t.y=this.radius_g_1*Math.atan(n/e)):(t.x=this.radius_g_1*Math.atan(i/e),t.y=this.radius_g_1*Math.atan(n/xe(i,e)));}else "sphere"===this.shape&&(e=Math.cos(s),r=Math.cos(a)*e,i=Math.sin(a)*e,n=Math.sin(s),e=this.radius_g-r,this.flip_axis?(t.x=this.radius_g_1*Math.atan(i/xe(n,e)),t.y=this.radius_g_1*Math.atan(n/e)):(t.x=this.radius_g_1*Math.atan(i/e),t.y=this.radius_g_1*Math.atan(n/xe(i,e))));return t.x=t.x*this.a,t.y=t.y*this.a,t},inverse:function(t){var e,r,i,n,a=-1,s=0,o=0;if(t.x=t.x/this.a,t.y=t.y/this.a,"ellipse"===this.shape){this.flip_axis?(o=Math.tan(t.y/this.radius_g_1),s=Math.tan(t.x/this.radius_g_1)*xe(1,o)):(s=Math.tan(t.x/this.radius_g_1),o=Math.tan(t.y/this.radius_g_1)*xe(1,s));var u=o/this.radius_p;if((i=(r=2*this.radius_g*a)*r-4*(e=s*s+u*u+a*a)*this.C)<0)return t.x=Number.NaN,t.y=Number.NaN,t;n=(-r-Math.sqrt(i))/(2*e),a=this.radius_g+n*a,s*=n,o*=n,t.x=Math.atan2(s,a),t.y=Math.atan(o*Math.cos(t.x)/a),t.y=Math.atan(this.radius_p_inv2*Math.tan(t.y));}else if("sphere"===this.shape){if(this.flip_axis?(o=Math.tan(t.y/this.radius_g_1),s=Math.tan(t.x/this.radius_g_1)*Math.sqrt(1+o*o)):(s=Math.tan(t.x/this.radius_g_1),o=Math.tan(t.y/this.radius_g_1)*Math.sqrt(1+s*s)),(i=(r=2*this.radius_g*a)*r-4*(e=s*s+o*o+a*a)*this.C)<0)return t.x=Number.NaN,t.y=Number.NaN,t;n=(-r-Math.sqrt(i))/(2*e),a=this.radius_g+n*a,s*=n,o*=n,t.x=Math.atan2(s,a),t.y=Math.atan(o*Math.cos(t.x)/a);}return t.x=t.x+this.long0,t},names:["Geostationary Satellite View","Geostationary_Satellite","geos"]};$t.defaultDatum="WGS84",$t.Proj=Nt,$t.WGS84=new $t.Proj("WGS84"),$t.Point=ce,$t.toPoint=Ht,$t.defs=ft,$t.nadgrid=function(t,e){var r=new DataView(e),i=function(t){var e=t.getInt32(8,!1);return 11!==e&&(11!==(e=t.getInt32(8,!0))&&console.warn("Failed to detect nadgrid endian-ness, defaulting to little-endian"),!0)}(r),n=function(t,e){return {nFields:t.getInt32(8,e),nSubgridFields:t.getInt32(24,e),nSubgrids:t.getInt32(40,e),shiftType:Lt(t,56,64).trim(),fromSemiMajorAxis:t.getFloat64(120,e),fromSemiMinorAxis:t.getFloat64(136,e),toSemiMajorAxis:t.getFloat64(152,e),toSemiMinorAxis:t.getFloat64(168,e)}}(r,i);n.nSubgrids>1&&console.log("Only single NTv2 subgrids are currently supported, subsequent sub grids are ignored");var a={header:n,subgrids:function(t,e,r){for(var i=[],n=0;n<e.nSubgrids;n++){var a=Ot(t,176,r),s=Dt(t,176,a,r),o=Math.round(1+(a.upperLongitude-a.lowerLongitude)/a.longitudeInterval),u=Math.round(1+(a.upperLatitude-a.lowerLatitude)/a.latitudeInterval);i.push({ll:[Vt(a.lowerLongitude),Vt(a.lowerLatitude)],del:[Vt(a.longitudeInterval),Vt(a.latitudeInterval)],lim:[o,u],count:a.gridNodeCount,cvs:Ft(s)});}return i}(r,n,i)};return Bt[t]=a,a},$t.transform=Zt,$t.mgrs=ie,$t.version="__VERSION__",function(t){t.Proj.projections.add(ve),t.Proj.projections.add(we),t.Proj.projections.add(Me),t.Proj.projections.add(ke),t.Proj.projections.add(Ie),t.Proj.projections.add(ze),t.Proj.projections.add(Ce),t.Proj.projections.add(Ee),t.Proj.projections.add(Pe),t.Proj.projections.add(Re),t.Proj.projections.add(je),t.Proj.projections.add(Ge),t.Proj.projections.add(Ke),t.Proj.projections.add(Xe),t.Proj.projections.add(He),t.Proj.projections.add(Je),t.Proj.projections.add(Ze),t.Proj.projections.add(Ye),t.Proj.projections.add(We),t.Proj.projections.add(Qe),t.Proj.projections.add($e),t.Proj.projections.add(tr),t.Proj.projections.add(er),t.Proj.projections.add(rr),t.Proj.projections.add(ar),t.Proj.projections.add(hr),t.Proj.projections.add(lr),t.Proj.projections.add(cr),t.Proj.projections.add(fr);}($t);var yr=function(t,e){this._transformRequestFn=t,this._customAccessToken=e,this._createSkuToken();};function dr(t){return 0===t.indexOf("mapbox:")}yr.prototype._createSkuToken=function(){var t=function(){for(var t="",e=0;e<10;e++)t+="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"[Math.floor(62*Math.random())];return {token:["1",G,t].join(""),tokenExpiresAt:Date.now()+432e5}}();this._skuToken=t.token,this._skuTokenExpiresAt=t.tokenExpiresAt;},yr.prototype._isSkuTokenExpired=function(){return Date.now()>this._skuTokenExpiresAt},yr.prototype.transformRequest=function(t,e){return this._transformRequestFn&&this._transformRequestFn(t,e)||{url:t}},yr.prototype.normalizeStyleURL=function(t,e){if(!dr(t))return t;var r=xr(t);return r.path="/styles/v1"+r.path,this._makeAPIURL(r,this._customAccessToken||e)},yr.prototype.normalizeGlyphsURL=function(t,e){if(!dr(t))return t;var r=xr(t);return r.path="/fonts/v1"+r.path,this._makeAPIURL(r,this._customAccessToken||e)},yr.prototype.normalizeSourceURL=function(t,e){if(!dr(t))return t;var r=xr(t);return r.path="/v4/"+r.authority+".json",r.params.push("secure"),this._makeAPIURL(r,this._customAccessToken||e)},yr.prototype.normalizeSpriteURL=function(t,e,r,i){var n=xr(t);return n&&!n.protocol&&n.path?(n.path+=""+e+r,n.path):dr(t)?(n.path="/styles/v1"+n.path+"/sprite"+e+r,this._makeAPIURL(n,this._customAccessToken||i)):(n.path+=""+e+r,br(n))},yr.prototype.normalizeTileURL=function(t,e){if(this._isSkuTokenExpired()&&this._createSkuToken(),t&&!dr(t))return t;var r=xr(t);r.path=r.path.replace(/(\.(png|jpg)\d*)(?=$)/,(D.devicePixelRatio>=2||512===e?"@2x":"")+(R.supported?".webp":"$1")),r.path=r.path.replace(/^.+\/v4\//,"/"),r.path="/v4"+r.path;var i=this._customAccessToken||function(t){for(var e=0,r=t;e<r.length;e+=1){var i=r[e].match(/^access_token=(.*)$/);if(i)return i[1]}return null}(r.params)||N.ACCESS_TOKEN;return N.REQUIRE_ACCESS_TOKEN&&i&&this._skuToken&&r.params.push("sku="+this._skuToken),this._makeAPIURL(r,i)},yr.prototype.canonicalizeTileURL=function(t,e){var r=xr(t);if(!r.path.match(/(^\/v4\/)/)||!r.path.match(/\.[\w]+$/))return t;var i="mapbox://tiles/";i+=r.path.replace("/v4/","");var n=r.params;return e&&(n=n.filter((function(t){return !t.match(/^access_token=/)}))),n.length&&(i+="?"+n.join("&")),i},yr.prototype.canonicalizeTileset=function(t,e){for(var r=!!e&&dr(e),i=[],n=0,a=t.tiles||[];n<a.length;n+=1){var s=a[n];vr(s)?i.push(this.canonicalizeTileURL(s,r)):i.push(s);}return i},yr.prototype._makeAPIURL=function(t,e){var r="See https://www.mapbox.com/api-documentation/#access-tokens-and-token-scopes",i=xr(N.API_URL);if(t.protocol=i.protocol,t.authority=i.authority,"/"!==i.path&&(t.path=""+i.path+t.path),!N.REQUIRE_ACCESS_TOKEN)return br(t);if(!(e=e||N.ACCESS_TOKEN))throw new Error("An API access token is required to use Mapbox GL. "+r);if("s"===e[0])throw new Error("Use a public access token (pk.*) with Mapbox GL, not a secret access token (sk.*). "+r);return t.params=t.params.filter((function(t){return -1===t.indexOf("access_token")})),t.params.push("access_token="+e),br(t)};var mr=/^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/|\?|$)/i;function vr(t){return mr.test(t)}var gr=/^(\w+):\/\/([^/?]*)(\/[^?]+)?\??(.+)?/;function xr(t){var e=t.match(gr);return e?{protocol:e[1],authority:e[2],path:e[3]||"/",params:e[4]?e[4].split("&"):[]}:{path:t,params:[]}}function br(t){var e=t.params.length?"?"+t.params.join("&"):"";return t.protocol+"://"+t.authority+t.path+e}function _r(t){if(!t)return null;var e=t.split(".");if(!e||3!==e.length)return null;try{return JSON.parse(decodeURIComponent(s.atob(e[1]).split("").map((function(t){return "%"+("00"+t.charCodeAt(0).toString(16)).slice(-2)})).join("")))}catch(t){return null}}var wr=function(t){this.type=t,this.anonId=null,this.eventData={},this.queue=[],this.pendingRequest=null;};wr.prototype.getStorageKey=function(t){var e,r=_r(N.ACCESS_TOKEN);return e=r&&r.u?s.btoa(encodeURIComponent(r.u).replace(/%([0-9A-F]{2})/g,(function(t,e){return String.fromCharCode(Number("0x"+e))}))):N.ACCESS_TOKEN||"",t?"mapbox.eventData."+t+":"+e:"mapbox.eventData:"+e},wr.prototype.fetchEventData=function(){var t=E("localStorage"),e=this.getStorageKey(),r=this.getStorageKey("uuid");if(t)try{var i=s.localStorage.getItem(e);i&&(this.eventData=JSON.parse(i));var n=s.localStorage.getItem(r);n&&(this.anonId=n);}catch(t){M("Unable to read from LocalStorage");}},wr.prototype.saveEventData=function(){var t=E("localStorage"),e=this.getStorageKey(),r=this.getStorageKey("uuid");if(t)try{s.localStorage.setItem(r,this.anonId),Object.keys(this.eventData).length>=1&&s.localStorage.setItem(e,JSON.stringify(this.eventData));}catch(t){M("Unable to write to LocalStorage");}},wr.prototype.processRequests=function(t){},wr.prototype.postEvent=function(t,e,r,i){var n=this;if(N.EVENTS_URL){var a=xr(N.EVENTS_URL);a.params.push("access_token="+(i||N.ACCESS_TOKEN||""));var s={event:this.type,created:new Date(t).toISOString(),sdkIdentifier:"mapbox-gl-js",sdkVersion:"1.12.1-6",skuId:G,userId:this.anonId},o=e?c(s,e):s,u={url:br(a),headers:{"Content-Type":"text/plain"},body:JSON.stringify([o])};this.pendingRequest=Gr(u,(function(t){n.pendingRequest=null,r(t),n.saveEventData(),n.processRequests(i);}));}},wr.prototype.queueRequest=function(t,e){this.queue.push(t),this.processRequests(e);};var Mr,Sr,Ar=function(t){function e(){t.call(this,"map.load"),this.success={},this.skuToken="";}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.postMapLoadEvent=function(t,e,r,i){this.skuToken=r,(N.EVENTS_URL&&i||N.ACCESS_TOKEN&&Array.isArray(t)&&t.some((function(t){return dr(t)||vr(t)})))&&this.queueRequest({id:e,timestamp:Date.now()},i);},e.prototype.processRequests=function(t){var e=this;if(!this.pendingRequest&&0!==this.queue.length){var r=this.queue.shift(),i=r.id,n=r.timestamp;i&&this.success[i]||(this.anonId||this.fetchEventData(),m(this.anonId)||(this.anonId=d()),this.postEvent(n,{skuToken:this.skuToken},(function(t){t||i&&(e.success[i]=!0);}),t));}},e}(wr),kr=new(function(t){function e(e){t.call(this,"appUserTurnstile"),this._customAccessToken=e;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.postTurnstileEvent=function(t,e){N.EVENTS_URL&&N.ACCESS_TOKEN&&Array.isArray(t)&&t.some((function(t){return dr(t)||vr(t)}))&&this.queueRequest(Date.now(),e);},e.prototype.processRequests=function(t){var e=this;if(!this.pendingRequest&&0!==this.queue.length){this.anonId&&this.eventData.lastSuccess&&this.eventData.tokenU||this.fetchEventData();var r=_r(N.ACCESS_TOKEN),i=r?r.u:N.ACCESS_TOKEN,n=i!==this.eventData.tokenU;m(this.anonId)||(this.anonId=d(),n=!0);var a=this.queue.shift();if(this.eventData.lastSuccess){var s=new Date(this.eventData.lastSuccess),o=new Date(a),u=(a-this.eventData.lastSuccess)/864e5;n=n||u>=1||u<-1||s.getDate()!==o.getDate();}else n=!0;if(!n)return this.processRequests();this.postEvent(a,{"enabled.telemetry":!1},(function(t){t||(e.eventData.lastSuccess=a,e.eventData.tokenU=i);}),t);}},e}(wr)),Ir=kr.postTurnstileEvent.bind(kr),zr=new Ar,Cr=zr.postMapLoadEvent.bind(zr),Er=500,Pr=50;function Br(){s.caches&&!Mr&&(Mr=s.caches.open("mapbox-tiles"));}function Tr(t){var e=t.indexOf("?");return e<0?t:t.slice(0,e)}var Vr,Lr=1/0;function Fr(){return null==Vr&&(Vr=s.OffscreenCanvas&&new s.OffscreenCanvas(1,1).getContext("2d")&&"function"==typeof s.createImageBitmap),Vr}var Or={Unknown:"Unknown",Style:"Style",Source:"Source",Tile:"Tile",Glyphs:"Glyphs",SpriteImage:"SpriteImage",SpriteJSON:"SpriteJSON",Image:"Image"};"function"==typeof Object.freeze&&Object.freeze(Or);var Dr=function(t){function e(e,r,i){401===r&&vr(i)&&(e+=": you may have provided an invalid Mapbox access token. See https://www.mapbox.com/api-documentation/#access-tokens-and-token-scopes"),t.call(this,e),this.status=r,this.url=i,this.name=this.constructor.name,this.message=e;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.toString=function(){return this.name+": "+this.message+" ("+this.status+"): "+this.url},e}(Error),Nr=k()?function(){return self.worker&&self.worker.referrer}:function(){return ("blob:"===s.location.protocol?s.parent:s).location.href};var Rr,qr,jr=function(t,e){if(!(/^file:/.test(r=t.url)||/^file:/.test(Nr())&&!/^\w+:/.test(r))){if(s.fetch&&s.Request&&s.AbortController&&s.Request.prototype.hasOwnProperty("signal"))return function(t,e){var r,i=new s.AbortController,n=new s.Request(t.url,{method:t.method||"GET",body:t.body,credentials:t.credentials,headers:t.headers,referrer:Nr(),signal:i.signal}),a=!1,o=!1,u=(r=n.url).indexOf("sku=")>0&&vr(r);"json"===t.type&&n.headers.set("Accept","application/json");var h=function(r,i,a){if(!o){if(r&&"SecurityError"!==r.message&&M(r),i&&a)return l(i);var h=Date.now();s.fetch(n).then((function(r){if(r.ok){var i=u?r.clone():null;return l(r,i,h)}return e(new Dr(r.statusText,r.status,t.url))})).catch((function(t){20!==t.code&&e(new Error(t.message));}));}},l=function(r,i,u){("arrayBuffer"===t.type?r.arrayBuffer():"json"===t.type?r.json():r.text()).then((function(t){o||(i&&u&&function(t,e,r){if(Br(),Mr){var i={status:e.status,statusText:e.statusText,headers:new s.Headers};e.headers.forEach((function(t,e){return i.headers.set(e,t)}));var n=I(e.headers.get("Cache-Control")||"");n["no-store"]||(n["max-age"]&&i.headers.set("Expires",new Date(r+1e3*n["max-age"]).toUTCString()),new Date(i.headers.get("Expires")).getTime()-r<42e4||function(t,e){if(void 0===Sr)try{new Response(new ReadableStream),Sr=!0;}catch(t){Sr=!1;}Sr?e(t.body):t.blob().then(e);}(e,(function(e){var r=new s.Response(e,i);Br(),Mr&&Mr.then((function(e){return e.put(Tr(t.url),r)})).catch((function(t){return M(t.message)}));})));}}(n,i,u),a=!0,e(null,t,r.headers.get("Cache-Control"),r.headers.get("Expires")));})).catch((function(t){o||e(new Error(t.message));}));};return u?function(t,e){if(Br(),!Mr)return e(null);var r=Tr(t.url);Mr.then((function(t){t.match(r).then((function(i){var n=function(t){if(!t)return !1;var e=new Date(t.headers.get("Expires")||0),r=I(t.headers.get("Cache-Control")||"");return e>Date.now()&&!r["no-cache"]}(i);t.delete(r),n&&t.put(r,i.clone()),e(null,i,n);})).catch(e);})).catch(e);}(n,h):h(null,null),{cancel:function(){o=!0,a||i.abort();}}}(t,e);if(k()&&self.worker&&self.worker.actor)return self.worker.actor.send("getResource",t,e,void 0,!0)}var r;return function(t,e){var r=new s.XMLHttpRequest;for(var i in r.open(t.method||"GET",t.url,!0),"arrayBuffer"===t.type&&(r.responseType="arraybuffer"),t.headers)r.setRequestHeader(i,t.headers[i]);return "json"===t.type&&(r.responseType="text",r.setRequestHeader("Accept","application/json")),r.withCredentials="include"===t.credentials,r.onerror=function(){e(new Error(r.statusText));},r.onload=function(){if((r.status>=200&&r.status<300||0===r.status)&&null!==r.response){var i=r.response;if("json"===t.type)try{i=JSON.parse(r.response);}catch(t){return e(t)}e(null,i,r.getResponseHeader("Cache-Control"),r.getResponseHeader("Expires"));}else e(new Dr(r.statusText,r.status,t.url));},r.send(t.body),{cancel:function(){return r.abort()}}}(t,e)},Ur=function(t,e){return jr(c(t,{type:"arrayBuffer"}),e)},Gr=function(t,e){return jr(c(t,{method:"POST"}),e)};Rr=[],qr=0;var Kr=function(t,e){if(R.supported&&(t.headers||(t.headers={}),t.headers.accept="image/webp,*/*"),qr>=N.MAX_PARALLEL_IMAGE_REQUESTS){var r={requestParameters:t,callback:e,cancelled:!1,cancel:function(){this.cancelled=!0;}};return Rr.push(r),r}qr++;var i=!1,n=function(){if(!i)for(i=!0,qr--;Rr.length&&qr<N.MAX_PARALLEL_IMAGE_REQUESTS;){var t=Rr.shift();t.cancelled||(t.cancel=Kr(t.requestParameters,t.callback).cancel);}},a=Ur(t,(function(t,r,i,a){n(),t?e(t):r&&(Fr()?function(t,e){var r=new s.Blob([new Uint8Array(t)],{type:"image/png"});s.createImageBitmap(r).then((function(t){e(null,t);})).catch((function(t){e(new Error("Could not load image because of "+t.message+". Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported."));}));}(r,e):function(t,e,r,i){var n=new s.Image,a=s.URL;n.onload=function(){e(null,n),a.revokeObjectURL(n.src);},n.onerror=function(){return e(new Error("Could not load image. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported."))};var o=new s.Blob([new Uint8Array(t)],{type:"image/png"});n.cacheControl=r,n.expires=i,n.src=t.byteLength?a.createObjectURL(o):"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAC0lEQVQYV2NgAAIAAAUAAarVyFEAAAAASUVORK5CYII=";}(r,e,i,a));}));return {cancel:function(){a.cancel(),n();}}},Xr=Hr;function Hr(t,e,r){var i=this.cells=[];if(t instanceof ArrayBuffer){this.arrayBuffer=t;var n=new Int32Array(this.arrayBuffer);t=n[0],this.d=(e=n[1])+2*(r=n[2]);for(var a=0;a<this.d*this.d;a++){var s=n[3+a],o=n[3+a+1];i.push(s===o?null:n.subarray(s,o));}var u=n[3+i.length+1];this.keys=n.subarray(n[3+i.length],u),this.bboxes=n.subarray(u),this.insert=this._insertReadonly;}else {this.d=e+2*r;for(var h=0;h<this.d*this.d;h++)i.push([]);this.keys=[],this.bboxes=[];}this.n=e,this.extent=t,this.padding=r,this.scale=e/t,this.uid=0;var l=r/e*t;this.min=-l,this.max=t+l;}Hr.prototype.insert=function(t,e,r,i,n){this._forEachCell(e,r,i,n,this._insertCell,this.uid++),this.keys.push(t),this.bboxes.push(e),this.bboxes.push(r),this.bboxes.push(i),this.bboxes.push(n);},Hr.prototype._insertReadonly=function(){throw "Cannot insert into a GridIndex created from an ArrayBuffer."},Hr.prototype._insertCell=function(t,e,r,i,n,a){this.cells[n].push(a);},Hr.prototype.query=function(t,e,r,i,n){var a=this.min,s=this.max;if(t<=a&&e<=a&&s<=r&&s<=i&&!n)return Array.prototype.slice.call(this.keys);var o=[];return this._forEachCell(t,e,r,i,this._queryCell,o,{},n),o},Hr.prototype._queryCell=function(t,e,r,i,n,a,s,o){var u=this.cells[n];if(null!==u)for(var h=this.keys,l=this.bboxes,p=0;p<u.length;p++){var c=u[p];if(void 0===s[c]){var f=4*c;(o?o(l[f+0],l[f+1],l[f+2],l[f+3]):t<=l[f+2]&&e<=l[f+3]&&r>=l[f+0]&&i>=l[f+1])?(s[c]=!0,a.push(h[c])):s[c]=!1;}}},Hr.prototype._forEachCell=function(t,e,r,i,n,a,s,o){for(var u=this._convertToCellCoord(t),h=this._convertToCellCoord(e),l=this._convertToCellCoord(r),p=this._convertToCellCoord(i),c=u;c<=l;c++)for(var f=h;f<=p;f++){var y=this.d*f+c;if((!o||o(this._convertFromCellCoord(c),this._convertFromCellCoord(f),this._convertFromCellCoord(c+1),this._convertFromCellCoord(f+1)))&&n.call(this,t,e,r,i,y,a,s,o))return}},Hr.prototype._convertFromCellCoord=function(t){return (t-this.padding)/this.scale},Hr.prototype._convertToCellCoord=function(t){return Math.max(0,Math.min(this.d-1,Math.floor(t*this.scale)+this.padding))},Hr.prototype.toArrayBuffer=function(){if(this.arrayBuffer)return this.arrayBuffer;for(var t=this.cells,e=3+this.cells.length+1+1,r=0,i=0;i<this.cells.length;i++)r+=this.cells[i].length;var n=new Int32Array(e+r+this.keys.length+this.bboxes.length);n[0]=this.extent,n[1]=this.n,n[2]=this.padding;for(var a=e,s=0;s<t.length;s++){var o=t[s];n[3+s]=a,n.set(o,a),a+=o.length;}return n[3+t.length]=a,n.set(this.keys,a),n[3+t.length+1]=a+=this.keys.length,n.set(this.bboxes,a),a+=this.bboxes.length,n.buffer};var Jr=e((function(t,e){var r={transparent:[0,0,0,0],aliceblue:[240,248,255,1],antiquewhite:[250,235,215,1],aqua:[0,255,255,1],aquamarine:[127,255,212,1],azure:[240,255,255,1],beige:[245,245,220,1],bisque:[255,228,196,1],black:[0,0,0,1],blanchedalmond:[255,235,205,1],blue:[0,0,255,1],blueviolet:[138,43,226,1],brown:[165,42,42,1],burlywood:[222,184,135,1],cadetblue:[95,158,160,1],chartreuse:[127,255,0,1],chocolate:[210,105,30,1],coral:[255,127,80,1],cornflowerblue:[100,149,237,1],cornsilk:[255,248,220,1],crimson:[220,20,60,1],cyan:[0,255,255,1],darkblue:[0,0,139,1],darkcyan:[0,139,139,1],darkgoldenrod:[184,134,11,1],darkgray:[169,169,169,1],darkgreen:[0,100,0,1],darkgrey:[169,169,169,1],darkkhaki:[189,183,107,1],darkmagenta:[139,0,139,1],darkolivegreen:[85,107,47,1],darkorange:[255,140,0,1],darkorchid:[153,50,204,1],darkred:[139,0,0,1],darksalmon:[233,150,122,1],darkseagreen:[143,188,143,1],darkslateblue:[72,61,139,1],darkslategray:[47,79,79,1],darkslategrey:[47,79,79,1],darkturquoise:[0,206,209,1],darkviolet:[148,0,211,1],deeppink:[255,20,147,1],deepskyblue:[0,191,255,1],dimgray:[105,105,105,1],dimgrey:[105,105,105,1],dodgerblue:[30,144,255,1],firebrick:[178,34,34,1],floralwhite:[255,250,240,1],forestgreen:[34,139,34,1],fuchsia:[255,0,255,1],gainsboro:[220,220,220,1],ghostwhite:[248,248,255,1],gold:[255,215,0,1],goldenrod:[218,165,32,1],gray:[128,128,128,1],green:[0,128,0,1],greenyellow:[173,255,47,1],grey:[128,128,128,1],honeydew:[240,255,240,1],hotpink:[255,105,180,1],indianred:[205,92,92,1],indigo:[75,0,130,1],ivory:[255,255,240,1],khaki:[240,230,140,1],lavender:[230,230,250,1],lavenderblush:[255,240,245,1],lawngreen:[124,252,0,1],lemonchiffon:[255,250,205,1],lightblue:[173,216,230,1],lightcoral:[240,128,128,1],lightcyan:[224,255,255,1],lightgoldenrodyellow:[250,250,210,1],lightgray:[211,211,211,1],lightgreen:[144,238,144,1],lightgrey:[211,211,211,1],lightpink:[255,182,193,1],lightsalmon:[255,160,122,1],lightseagreen:[32,178,170,1],lightskyblue:[135,206,250,1],lightslategray:[119,136,153,1],lightslategrey:[119,136,153,1],lightsteelblue:[176,196,222,1],lightyellow:[255,255,224,1],lime:[0,255,0,1],limegreen:[50,205,50,1],linen:[250,240,230,1],magenta:[255,0,255,1],maroon:[128,0,0,1],mediumaquamarine:[102,205,170,1],mediumblue:[0,0,205,1],mediumorchid:[186,85,211,1],mediumpurple:[147,112,219,1],mediumseagreen:[60,179,113,1],mediumslateblue:[123,104,238,1],mediumspringgreen:[0,250,154,1],mediumturquoise:[72,209,204,1],mediumvioletred:[199,21,133,1],midnightblue:[25,25,112,1],mintcream:[245,255,250,1],mistyrose:[255,228,225,1],moccasin:[255,228,181,1],navajowhite:[255,222,173,1],navy:[0,0,128,1],oldlace:[253,245,230,1],olive:[128,128,0,1],olivedrab:[107,142,35,1],orange:[255,165,0,1],orangered:[255,69,0,1],orchid:[218,112,214,1],palegoldenrod:[238,232,170,1],palegreen:[152,251,152,1],paleturquoise:[175,238,238,1],palevioletred:[219,112,147,1],papayawhip:[255,239,213,1],peachpuff:[255,218,185,1],peru:[205,133,63,1],pink:[255,192,203,1],plum:[221,160,221,1],powderblue:[176,224,230,1],purple:[128,0,128,1],rebeccapurple:[102,51,153,1],red:[255,0,0,1],rosybrown:[188,143,143,1],royalblue:[65,105,225,1],saddlebrown:[139,69,19,1],salmon:[250,128,114,1],sandybrown:[244,164,96,1],seagreen:[46,139,87,1],seashell:[255,245,238,1],sienna:[160,82,45,1],silver:[192,192,192,1],skyblue:[135,206,235,1],slateblue:[106,90,205,1],slategray:[112,128,144,1],slategrey:[112,128,144,1],snow:[255,250,250,1],springgreen:[0,255,127,1],steelblue:[70,130,180,1],tan:[210,180,140,1],teal:[0,128,128,1],thistle:[216,191,216,1],tomato:[255,99,71,1],turquoise:[64,224,208,1],violet:[238,130,238,1],wheat:[245,222,179,1],white:[255,255,255,1],whitesmoke:[245,245,245,1],yellow:[255,255,0,1],yellowgreen:[154,205,50,1]};function i(t){return (t=Math.round(t))<0?0:t>255?255:t}function n(t){return i("%"===t[t.length-1]?parseFloat(t)/100*255:parseInt(t))}function a(t){return (e="%"===t[t.length-1]?parseFloat(t)/100:parseFloat(t))<0?0:e>1?1:e;var e;}function s(t,e,r){return r<0?r+=1:r>1&&(r-=1),6*r<1?t+(e-t)*r*6:2*r<1?e:3*r<2?t+(e-t)*(2/3-r)*6:t}try{e.parseCSSColor=function(t){var e,o=t.replace(/ /g,"").toLowerCase();if(o in r)return r[o].slice();if("#"===o[0])return 4===o.length?(e=parseInt(o.substr(1),16))>=0&&e<=4095?[(3840&e)>>4|(3840&e)>>8,240&e|(240&e)>>4,15&e|(15&e)<<4,1]:null:7===o.length&&(e=parseInt(o.substr(1),16))>=0&&e<=16777215?[(16711680&e)>>16,(65280&e)>>8,255&e,1]:null;var u=o.indexOf("("),h=o.indexOf(")");if(-1!==u&&h+1===o.length){var l=o.substr(0,u),p=o.substr(u+1,h-(u+1)).split(","),c=1;switch(l){case"rgba":if(4!==p.length)return null;c=a(p.pop());case"rgb":return 3!==p.length?null:[n(p[0]),n(p[1]),n(p[2]),c];case"hsla":if(4!==p.length)return null;c=a(p.pop());case"hsl":if(3!==p.length)return null;var f=(parseFloat(p[0])%360+360)%360/360,y=a(p[1]),d=a(p[2]),m=d<=.5?d*(y+1):d+y-d*y,v=2*d-m;return [i(255*s(v,m,f+1/3)),i(255*s(v,m,f)),i(255*s(v,m,f-1/3)),c];default:return null}}return null};}catch(t){}})).parseCSSColor,Zr=function(t,e,r,i){void 0===i&&(i=1),this.r=t,this.g=e,this.b=r,this.a=i;};function Yr(t){for(var e=[],r=arguments.length-1;r-- >0;)e[r]=arguments[r+1];for(var i=0,n=e;i<n.length;i+=1){var a=n[i];for(var s in a)t[s]=a[s];}return t}Zr.parse=function(t){if(t){if(t instanceof Zr)return t;if("string"==typeof t){var e=Jr(t);if(e)return new Zr(e[0]/255*e[3],e[1]/255*e[3],e[2]/255*e[3],e[3])}}},Zr.prototype.toString=function(){var t=this.toArray(),e=t[1],r=t[2],i=t[3];return "rgba("+Math.round(t[0])+","+Math.round(e)+","+Math.round(r)+","+i+")"},Zr.prototype.toArray=function(){var t=this.a;return 0===t?[0,0,0,0]:[255*this.r/t,255*this.g/t,255*this.b/t,t]},Zr.black=new Zr(0,0,0,1),Zr.white=new Zr(1,1,1,1),Zr.transparent=new Zr(0,0,0,0),Zr.red=new Zr(1,0,0,1);var Wr=function(t){function e(e,r){t.call(this,r),this.message=r,this.key=e;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e}(Error),Qr=function(t,e){void 0===e&&(e=[]),this.parent=t,this.bindings={};for(var r=0,i=e;r<i.length;r+=1){var n=i[r];this.bindings[n[0]]=n[1];}};Qr.prototype.concat=function(t){return new Qr(this,t)},Qr.prototype.get=function(t){if(this.bindings[t])return this.bindings[t];if(this.parent)return this.parent.get(t);throw new Error(t+" not found in scope.")},Qr.prototype.has=function(t){return !!this.bindings[t]||!!this.parent&&this.parent.has(t)};var $r={kind:"null"},ti={kind:"number"},ei={kind:"string"},ri={kind:"boolean"},ii={kind:"color"},ni={kind:"object"},ai={kind:"value"},si={kind:"collator"},oi={kind:"formatted"},ui={kind:"resolvedImage"};function hi(t,e){return {kind:"array",itemType:t,N:e}}function li(t){if("array"===t.kind){var e=li(t.itemType);return "number"==typeof t.N?"array<"+e+", "+t.N+">":"value"===t.itemType.kind?"array":"array<"+e+">"}return t.kind}var pi=[$r,ti,ei,ri,ii,oi,ni,hi(ai),ui];function ci(t,e){if("error"===e.kind)return null;if("array"===t.kind){if("array"===e.kind&&(0===e.N&&"value"===e.itemType.kind||!ci(t.itemType,e.itemType))&&("number"!=typeof t.N||t.N===e.N))return null}else {if(t.kind===e.kind)return null;if("value"===t.kind)for(var r=0,i=pi;r<i.length;r+=1)if(!ci(i[r],e))return null}return "Expected "+li(t)+" but found "+li(e)+" instead."}function fi(t,e){return e.some((function(e){return e.kind===t.kind}))}function yi(t,e){return e.some((function(e){return "null"===e?null===t:"array"===e?Array.isArray(t):"object"===e?t&&!Array.isArray(t)&&"object"==typeof t:e===typeof t}))}var di=function(t,e,r){this.sensitivity=t?e?"variant":"case":e?"accent":"base",this.locale=r,this.collator=new Intl.Collator(this.locale?this.locale:[],{sensitivity:this.sensitivity,usage:"search"});};di.prototype.compare=function(t,e){return this.collator.compare(t,e)},di.prototype.resolvedLocale=function(){return new Intl.Collator(this.locale?this.locale:[]).resolvedOptions().locale};var mi=function(t,e,r,i,n){this.text=t,this.image=e,this.scale=r,this.fontStack=i,this.textColor=n;},vi=function(t){this.sections=t;};vi.fromString=function(t){return new vi([new mi(t,null,null,null,null)])},vi.prototype.isEmpty=function(){return 0===this.sections.length||!this.sections.some((function(t){return 0!==t.text.length||t.image&&0!==t.image.name.length}))},vi.factory=function(t){return t instanceof vi?t:vi.fromString(t)},vi.prototype.toString=function(){return 0===this.sections.length?"":this.sections.map((function(t){return t.text})).join("")},vi.prototype.serialize=function(){for(var t=["format"],e=0,r=this.sections;e<r.length;e+=1){var i=r[e];if(i.image)t.push(["image",i.image.name]);else {t.push(i.text);var n={};i.fontStack&&(n["text-font"]=["literal",i.fontStack.split(",")]),i.scale&&(n["font-scale"]=i.scale),i.textColor&&(n["text-color"]=["rgba"].concat(i.textColor.toArray())),t.push(n);}}return t};var gi=function(t){this.name=t.name,this.available=t.available;};function xi(t,e,r,i){return "number"==typeof t&&t>=0&&t<=255&&"number"==typeof e&&e>=0&&e<=255&&"number"==typeof r&&r>=0&&r<=255?void 0===i||"number"==typeof i&&i>=0&&i<=1?null:"Invalid rgba value ["+[t,e,r,i].join(", ")+"]: 'a' must be between 0 and 1.":"Invalid rgba value ["+("number"==typeof i?[t,e,r,i]:[t,e,r]).join(", ")+"]: 'r', 'g', and 'b' must be between 0 and 255."}function bi(t){if(null===t)return !0;if("string"==typeof t)return !0;if("boolean"==typeof t)return !0;if("number"==typeof t)return !0;if(t instanceof Zr)return !0;if(t instanceof di)return !0;if(t instanceof vi)return !0;if(t instanceof gi)return !0;if(Array.isArray(t)){for(var e=0,r=t;e<r.length;e+=1)if(!bi(r[e]))return !1;return !0}if("object"==typeof t){for(var i in t)if(!bi(t[i]))return !1;return !0}return !1}function _i(t){if(null===t)return $r;if("string"==typeof t)return ei;if("boolean"==typeof t)return ri;if("number"==typeof t)return ti;if(t instanceof Zr)return ii;if(t instanceof di)return si;if(t instanceof vi)return oi;if(t instanceof gi)return ui;if(Array.isArray(t)){for(var e,r=t.length,i=0,n=t;i<n.length;i+=1){var a=_i(n[i]);if(e){if(e===a)continue;e=ai;break}e=a;}return hi(e||ai,r)}return ni}function wi(t){var e=typeof t;return null===t?"":"string"===e||"number"===e||"boolean"===e?String(t):t instanceof Zr||t instanceof vi||t instanceof gi?t.toString():JSON.stringify(t)}gi.prototype.toString=function(){return this.name},gi.fromString=function(t){return t?new gi({name:t,available:!1}):null},gi.prototype.serialize=function(){return ["image",this.name]};var Mi=function(t,e){this.type=t,this.value=e;};Mi.parse=function(t,e){if(2!==t.length)return e.error("'literal' expression requires exactly one argument, but found "+(t.length-1)+" instead.");if(!bi(t[1]))return e.error("invalid value");var r=t[1],i=_i(r),n=e.expectedType;return "array"!==i.kind||0!==i.N||!n||"array"!==n.kind||"number"==typeof n.N&&0!==n.N||(i=n),new Mi(i,r)},Mi.prototype.evaluate=function(){return this.value},Mi.prototype.eachChild=function(){},Mi.prototype.outputDefined=function(){return !0},Mi.prototype.serialize=function(){return "array"===this.type.kind||"object"===this.type.kind?["literal",this.value]:this.value instanceof Zr?["rgba"].concat(this.value.toArray()):this.value instanceof vi?this.value.serialize():this.value};var Si=function(t){this.name="ExpressionEvaluationError",this.message=t;};Si.prototype.toJSON=function(){return this.message};var Ai={string:ei,number:ti,boolean:ri,object:ni},ki=function(t,e){this.type=t,this.args=e;};ki.parse=function(t,e){if(t.length<2)return e.error("Expected at least one argument.");var r,i=1,n=t[0];if("array"===n){var a,s;if(t.length>2){var o=t[1];if("string"!=typeof o||!(o in Ai)||"object"===o)return e.error('The item type argument of "array" must be one of string, number, boolean',1);a=Ai[o],i++;}else a=ai;if(t.length>3){if(null!==t[2]&&("number"!=typeof t[2]||t[2]<0||t[2]!==Math.floor(t[2])))return e.error('The length argument to "array" must be a positive integer literal',2);s=t[2],i++;}r=hi(a,s);}else r=Ai[n];for(var u=[];i<t.length;i++){var h=e.parse(t[i],i,ai);if(!h)return null;u.push(h);}return new ki(r,u)},ki.prototype.evaluate=function(t){for(var e=0;e<this.args.length;e++){var r=this.args[e].evaluate(t);if(!ci(this.type,_i(r)))return r;if(e===this.args.length-1)throw new Si("Expected value to be of type "+li(this.type)+", but found "+li(_i(r))+" instead.")}return null},ki.prototype.eachChild=function(t){this.args.forEach(t);},ki.prototype.outputDefined=function(){return this.args.every((function(t){return t.outputDefined()}))},ki.prototype.serialize=function(){var t=this.type,e=[t.kind];if("array"===t.kind){var r=t.itemType;if("string"===r.kind||"number"===r.kind||"boolean"===r.kind){e.push(r.kind);var i=t.N;("number"==typeof i||this.args.length>1)&&e.push(i);}}return e.concat(this.args.map((function(t){return t.serialize()})))};var Ii=function(t){this.type=oi,this.sections=t;};Ii.parse=function(t,e){if(t.length<2)return e.error("Expected at least one argument.");var r=t[1];if(!Array.isArray(r)&&"object"==typeof r)return e.error("First argument must be an image or text section.");for(var i=[],n=!1,a=1;a<=t.length-1;++a){var s=t[a];if(n&&"object"==typeof s&&!Array.isArray(s)){n=!1;var o=null;if(s["font-scale"]&&!(o=e.parse(s["font-scale"],1,ti)))return null;var u=null;if(s["text-font"]&&!(u=e.parse(s["text-font"],1,hi(ei))))return null;var h=null;if(s["text-color"]&&!(h=e.parse(s["text-color"],1,ii)))return null;var l=i[i.length-1];l.scale=o,l.font=u,l.textColor=h;}else {var p=e.parse(t[a],1,ai);if(!p)return null;var c=p.type.kind;if("string"!==c&&"value"!==c&&"null"!==c&&"resolvedImage"!==c)return e.error("Formatted text type must be 'string', 'value', 'image' or 'null'.");n=!0,i.push({content:p,scale:null,font:null,textColor:null});}}return new Ii(i)},Ii.prototype.evaluate=function(t){return new vi(this.sections.map((function(e){var r=e.content.evaluate(t);return _i(r)===ui?new mi("",r,null,null,null):new mi(wi(r),null,e.scale?e.scale.evaluate(t):null,e.font?e.font.evaluate(t).join(","):null,e.textColor?e.textColor.evaluate(t):null)})))},Ii.prototype.eachChild=function(t){for(var e=0,r=this.sections;e<r.length;e+=1){var i=r[e];t(i.content),i.scale&&t(i.scale),i.font&&t(i.font),i.textColor&&t(i.textColor);}},Ii.prototype.outputDefined=function(){return !1},Ii.prototype.serialize=function(){for(var t=["format"],e=0,r=this.sections;e<r.length;e+=1){var i=r[e];t.push(i.content.serialize());var n={};i.scale&&(n["font-scale"]=i.scale.serialize()),i.font&&(n["text-font"]=i.font.serialize()),i.textColor&&(n["text-color"]=i.textColor.serialize()),t.push(n);}return t};var zi=function(t){this.type=ui,this.input=t;};zi.parse=function(t,e){if(2!==t.length)return e.error("Expected two arguments.");var r=e.parse(t[1],1,ei);return r?new zi(r):e.error("No image name provided.")},zi.prototype.evaluate=function(t){var e=this.input.evaluate(t),r=gi.fromString(e);return r&&t.availableImages&&(r.available=t.availableImages.indexOf(e)>-1),r},zi.prototype.eachChild=function(t){t(this.input);},zi.prototype.outputDefined=function(){return !1},zi.prototype.serialize=function(){return ["image",this.input.serialize()]};var Ci={"to-boolean":ri,"to-color":ii,"to-number":ti,"to-string":ei},Ei=function(t,e){this.type=t,this.args=e;};Ei.parse=function(t,e){if(t.length<2)return e.error("Expected at least one argument.");var r=t[0];if(("to-boolean"===r||"to-string"===r)&&2!==t.length)return e.error("Expected one argument.");for(var i=Ci[r],n=[],a=1;a<t.length;a++){var s=e.parse(t[a],a,ai);if(!s)return null;n.push(s);}return new Ei(i,n)},Ei.prototype.evaluate=function(t){if("boolean"===this.type.kind)return Boolean(this.args[0].evaluate(t));if("color"===this.type.kind){for(var e,r,i=0,n=this.args;i<n.length;i+=1){if(r=null,(e=n[i].evaluate(t))instanceof Zr)return e;if("string"==typeof e){var a=t.parseColor(e);if(a)return a}else if(Array.isArray(e)&&!(r=e.length<3||e.length>4?"Invalid rbga value "+JSON.stringify(e)+": expected an array containing either three or four numeric values.":xi(e[0],e[1],e[2],e[3])))return new Zr(e[0]/255,e[1]/255,e[2]/255,e[3])}throw new Si(r||"Could not parse color from value '"+("string"==typeof e?e:String(JSON.stringify(e)))+"'")}if("number"===this.type.kind){for(var s=null,o=0,u=this.args;o<u.length;o+=1){if(null===(s=u[o].evaluate(t)))return 0;var h=Number(s);if(!isNaN(h))return h}throw new Si("Could not convert "+JSON.stringify(s)+" to number.")}return "formatted"===this.type.kind?vi.fromString(wi(this.args[0].evaluate(t))):"resolvedImage"===this.type.kind?gi.fromString(wi(this.args[0].evaluate(t))):wi(this.args[0].evaluate(t))},Ei.prototype.eachChild=function(t){this.args.forEach(t);},Ei.prototype.outputDefined=function(){return this.args.every((function(t){return t.outputDefined()}))},Ei.prototype.serialize=function(){if("formatted"===this.type.kind)return new Ii([{content:this.args[0],scale:null,font:null,textColor:null}]).serialize();if("resolvedImage"===this.type.kind)return new zi(this.args[0]).serialize();var t=["to-"+this.type.kind];return this.eachChild((function(e){t.push(e.serialize());})),t};var Pi=["Unknown","Point","LineString","Polygon"],Bi=function(){this.globals=null,this.feature=null,this.featureState=null,this.formattedSection=null,this._parseColorCache={},this.availableImages=null,this.canonical=null;};Bi.prototype.id=function(){return this.feature&&"id"in this.feature?this.feature.id:null},Bi.prototype.geometryType=function(){return this.feature?"number"==typeof this.feature.type?Pi[this.feature.type]:this.feature.type:null},Bi.prototype.geometry=function(){return this.feature&&"geometry"in this.feature?this.feature.geometry:null},Bi.prototype.canonicalID=function(){return this.canonical},Bi.prototype.properties=function(){return this.feature&&this.feature.properties||{}},Bi.prototype.parseColor=function(t){var e=this._parseColorCache[t];return e||(e=this._parseColorCache[t]=Zr.parse(t)),e};var Ti=function(t,e,r,i){this.name=t,this.type=e,this._evaluate=r,this.args=i;};Ti.prototype.evaluate=function(t){return this._evaluate(t,this.args)},Ti.prototype.eachChild=function(t){this.args.forEach(t);},Ti.prototype.outputDefined=function(){return !1},Ti.prototype.serialize=function(){return [this.name].concat(this.args.map((function(t){return t.serialize()})))},Ti.parse=function(t,e){var r,i=t[0],n=Ti.definitions[i];if(!n)return e.error('Unknown expression "'+i+'". If you wanted a literal array, use ["literal", [...]].',0);for(var a=Array.isArray(n)?n[0]:n.type,s=Array.isArray(n)?[[n[1],n[2]]]:n.overloads,o=s.filter((function(e){var r=e[0];return !Array.isArray(r)||r.length===t.length-1})),u=null,h=0,l=o;h<l.length;h+=1){var p=l[h],c=p[0],f=p[1];u=new en(e.registry,e.path,null,e.scope);for(var y=[],d=!1,m=1;m<t.length;m++){var v=t[m],g=Array.isArray(c)?c[m-1]:c.type,x=u.parse(v,1+y.length,g);if(!x){d=!0;break}y.push(x);}if(!d)if(Array.isArray(c)&&c.length!==y.length)u.error("Expected "+c.length+" arguments, but found "+y.length+" instead.");else {for(var b=0;b<y.length;b++){var _=Array.isArray(c)?c[b]:c.type,w=y[b];u.concat(b+1).checkSubtype(_,w.type);}if(0===u.errors.length)return new Ti(i,a,f,y)}}if(1===o.length)(r=e.errors).push.apply(r,u.errors);else {for(var M=(o.length?o:s).map((function(t){var e;return e=t[0],Array.isArray(e)?"("+e.map(li).join(", ")+")":"("+li(e.type)+"...)"})).join(" | "),S=[],A=1;A<t.length;A++){var k=e.parse(t[A],1+S.length);if(!k)return null;S.push(li(k.type));}e.error("Expected arguments of type "+M+", but found ("+S.join(", ")+") instead.");}return null},Ti.register=function(t,e){for(var r in Ti.definitions=e,e)t[r]=Ti;};var Vi=function(t,e,r){this.type=si,this.locale=r,this.caseSensitive=t,this.diacriticSensitive=e;};function Li(t,e){t[0]=Math.min(t[0],e[0]),t[1]=Math.min(t[1],e[1]),t[2]=Math.max(t[2],e[0]),t[3]=Math.max(t[3],e[1]);}function Fi(t,e){return !(t[0]<=e[0]||t[2]>=e[2]||t[1]<=e[1]||t[3]>=e[3])}function Oi(t,e){var r=(180+t[0])/360,i=(180-180/Math.PI*Math.log(Math.tan(Math.PI/4+t[1]*Math.PI/360)))/360,n=Math.pow(2,e.z);return [Math.round(r*n*8192),Math.round(i*n*8192)]}function Di(t,e,r){return e[1]>t[1]!=r[1]>t[1]&&t[0]<(r[0]-e[0])*(t[1]-e[1])/(r[1]-e[1])+e[0]}function Ni(t,e){for(var r,i,n,a,s,o,u,h=!1,l=0,p=e.length;l<p;l++)for(var c=e[l],f=0,y=c.length;f<y-1;f++){if((a=(r=t)[0]-(i=c[f])[0])*(u=r[1]-(n=c[f+1])[1])-(o=r[0]-n[0])*(s=r[1]-i[1])==0&&a*o<=0&&s*u<=0)return !1;Di(t,c[f],c[f+1])&&(h=!h);}return h}function Ri(t,e){for(var r=0;r<e.length;r++)if(Ni(t,e[r]))return !0;return !1}function qi(t,e,r,i){var n=i[0]-r[0],a=i[1]-r[1],s=(t[0]-r[0])*a-n*(t[1]-r[1]),o=(e[0]-r[0])*a-n*(e[1]-r[1]);return s>0&&o<0||s<0&&o>0}function ji(t,e,r){for(var i=0,n=r;i<n.length;i+=1)for(var a=n[i],s=0;s<a.length-1;++s)if(0!=(p=[(l=a[s+1])[0]-(h=a[s])[0],l[1]-h[1]])[0]*(c=[(u=e)[0]-(o=t)[0],u[1]-o[1]])[1]-p[1]*c[0]&&qi(o,u,h,l)&&qi(h,l,o,u))return !0;var o,u,h,l,p,c;return !1}function Ui(t,e){for(var r=0;r<t.length;++r)if(!Ni(t[r],e))return !1;for(var i=0;i<t.length-1;++i)if(ji(t[i],t[i+1],e))return !1;return !0}function Gi(t,e){for(var r=0;r<e.length;r++)if(Ui(t,e[r]))return !0;return !1}function Ki(t,e,r){for(var i=[],n=0;n<t.length;n++){for(var a=[],s=0;s<t[n].length;s++){var o=Oi(t[n][s],r);Li(e,o),a.push(o);}i.push(a);}return i}function Xi(t,e,r){for(var i=[],n=0;n<t.length;n++){var a=Ki(t[n],e,r);i.push(a);}return i}function Hi(t,e,r,i){if(t[0]<r[0]||t[0]>r[2]){var n=.5*i,a=t[0]-r[0]>n?-i:r[0]-t[0]>n?i:0;0===a&&(a=t[0]-r[2]>n?-i:r[2]-t[0]>n?i:0),t[0]+=a;}Li(e,t);}function Ji(t,e,r,i){for(var n=8192*Math.pow(2,i.z),a=[8192*i.x,8192*i.y],s=[],o=0,u=t;o<u.length;o+=1)for(var h=0,l=u[o];h<l.length;h+=1){var p=l[h],c=[p.x+a[0],p.y+a[1]];Hi(c,e,r,n),s.push(c);}return s}function Zi(t,e,r,i){for(var n,a=8192*Math.pow(2,i.z),s=[8192*i.x,8192*i.y],o=[],u=0,h=t;u<h.length;u+=1){for(var l=[],p=0,c=h[u];p<c.length;p+=1){var f=c[p],y=[f.x+s[0],f.y+s[1]];Li(e,y),l.push(y);}o.push(l);}if(e[2]-e[0]<=a/2){(n=e)[0]=n[1]=1/0,n[2]=n[3]=-1/0;for(var d=0,m=o;d<m.length;d+=1)for(var v=0,g=m[d];v<g.length;v+=1)Hi(g[v],e,r,a);}return o}Vi.parse=function(t,e){if(2!==t.length)return e.error("Expected one argument.");var r=t[1];if("object"!=typeof r||Array.isArray(r))return e.error("Collator options argument must be an object.");var i=e.parse(void 0!==r["case-sensitive"]&&r["case-sensitive"],1,ri);if(!i)return null;var n=e.parse(void 0!==r["diacritic-sensitive"]&&r["diacritic-sensitive"],1,ri);if(!n)return null;var a=null;return r.locale&&!(a=e.parse(r.locale,1,ei))?null:new Vi(i,n,a)},Vi.prototype.evaluate=function(t){return new di(this.caseSensitive.evaluate(t),this.diacriticSensitive.evaluate(t),this.locale?this.locale.evaluate(t):null)},Vi.prototype.eachChild=function(t){t(this.caseSensitive),t(this.diacriticSensitive),this.locale&&t(this.locale);},Vi.prototype.outputDefined=function(){return !1},Vi.prototype.serialize=function(){var t={};return t["case-sensitive"]=this.caseSensitive.serialize(),t["diacritic-sensitive"]=this.diacriticSensitive.serialize(),this.locale&&(t.locale=this.locale.serialize()),["collator",t]};var Yi=function(t,e){this.type=ri,this.geojson=t,this.geometries=e;};function Wi(t){if(t instanceof Ti){if("get"===t.name&&1===t.args.length)return !1;if("feature-state"===t.name)return !1;if("has"===t.name&&1===t.args.length)return !1;if("properties"===t.name||"geometry-type"===t.name||"id"===t.name)return !1;if(/^filter-/.test(t.name))return !1}if(t instanceof Yi)return !1;var e=!0;return t.eachChild((function(t){e&&!Wi(t)&&(e=!1);})),e}function Qi(t){if(t instanceof Ti&&"feature-state"===t.name)return !1;var e=!0;return t.eachChild((function(t){e&&!Qi(t)&&(e=!1);})),e}function $i(t,e){if(t instanceof Ti&&e.indexOf(t.name)>=0)return !1;var r=!0;return t.eachChild((function(t){r&&!$i(t,e)&&(r=!1);})),r}Yi.parse=function(t,e){if(2!==t.length)return e.error("'within' expression requires exactly one argument, but found "+(t.length-1)+" instead.");if(bi(t[1])){var r=t[1];if("FeatureCollection"===r.type)for(var i=0;i<r.features.length;++i){var n=r.features[i].geometry.type;if("Polygon"===n||"MultiPolygon"===n)return new Yi(r,r.features[i].geometry)}else if("Feature"===r.type){var a=r.geometry.type;if("Polygon"===a||"MultiPolygon"===a)return new Yi(r,r.geometry)}else if("Polygon"===r.type||"MultiPolygon"===r.type)return new Yi(r,r)}return e.error("'within' expression requires valid geojson object that contains polygon geometry type.")},Yi.prototype.evaluate=function(t){if(null!=t.geometry()&&null!=t.canonicalID()){if("Point"===t.geometryType())return function(t,e){var r=[1/0,1/0,-1/0,-1/0],i=[1/0,1/0,-1/0,-1/0],n=t.canonicalID();if("Polygon"===e.type){var a=Ki(e.coordinates,i,n),s=Ji(t.geometry(),r,i,n);if(!Fi(r,i))return !1;for(var o=0,u=s;o<u.length;o+=1)if(!Ni(u[o],a))return !1}if("MultiPolygon"===e.type){var h=Xi(e.coordinates,i,n),l=Ji(t.geometry(),r,i,n);if(!Fi(r,i))return !1;for(var p=0,c=l;p<c.length;p+=1)if(!Ri(c[p],h))return !1}return !0}(t,this.geometries);if("LineString"===t.geometryType())return function(t,e){var r=[1/0,1/0,-1/0,-1/0],i=[1/0,1/0,-1/0,-1/0],n=t.canonicalID();if("Polygon"===e.type){var a=Ki(e.coordinates,i,n),s=Zi(t.geometry(),r,i,n);if(!Fi(r,i))return !1;for(var o=0,u=s;o<u.length;o+=1)if(!Ui(u[o],a))return !1}if("MultiPolygon"===e.type){var h=Xi(e.coordinates,i,n),l=Zi(t.geometry(),r,i,n);if(!Fi(r,i))return !1;for(var p=0,c=l;p<c.length;p+=1)if(!Gi(c[p],h))return !1}return !0}(t,this.geometries)}return !1},Yi.prototype.eachChild=function(){},Yi.prototype.outputDefined=function(){return !0},Yi.prototype.serialize=function(){return ["within",this.geojson]};var tn=function(t,e){this.type=e.type,this.name=t,this.boundExpression=e;};tn.parse=function(t,e){if(2!==t.length||"string"!=typeof t[1])return e.error("'var' expression requires exactly one string literal argument.");var r=t[1];return e.scope.has(r)?new tn(r,e.scope.get(r)):e.error('Unknown variable "'+r+'". Make sure "'+r+'" has been bound in an enclosing "let" expression before using it.',1)},tn.prototype.evaluate=function(t){return this.boundExpression.evaluate(t)},tn.prototype.eachChild=function(){},tn.prototype.outputDefined=function(){return !1},tn.prototype.serialize=function(){return ["var",this.name]};var en=function(t,e,r,i,n){void 0===e&&(e=[]),void 0===i&&(i=new Qr),void 0===n&&(n=[]),this.registry=t,this.path=e,this.key=e.map((function(t){return "["+t+"]"})).join(""),this.scope=i,this.errors=n,this.expectedType=r;};function rn(t,e){for(var r,i=t.length-1,n=0,a=i,s=0;n<=a;)if((r=t[s=Math.floor((n+a)/2)])<=e){if(s===i||e<t[s+1])return s;n=s+1;}else {if(!(r>e))throw new Si("Input is not a number.");a=s-1;}return 0}en.prototype.parse=function(t,e,r,i,n){return void 0===n&&(n={}),e?this.concat(e,r,i)._parse(t,n):this._parse(t,n)},en.prototype._parse=function(t,e){function r(t,e,r){return "assert"===r?new ki(e,[t]):"coerce"===r?new Ei(e,[t]):t}if(null!==t&&"string"!=typeof t&&"boolean"!=typeof t&&"number"!=typeof t||(t=["literal",t]),Array.isArray(t)){if(0===t.length)return this.error('Expected an array with at least one element. If you wanted a literal array, use ["literal", []].');var i=t[0];if("string"!=typeof i)return this.error("Expression name must be a string, but found "+typeof i+' instead. If you wanted a literal array, use ["literal", [...]].',0),null;var n=this.registry[i];if(n){var a=n.parse(t,this);if(!a)return null;if(this.expectedType){var s=this.expectedType,o=a.type;if("string"!==s.kind&&"number"!==s.kind&&"boolean"!==s.kind&&"object"!==s.kind&&"array"!==s.kind||"value"!==o.kind)if("color"!==s.kind&&"formatted"!==s.kind&&"resolvedImage"!==s.kind||"value"!==o.kind&&"string"!==o.kind){if(this.checkSubtype(s,o))return null}else a=r(a,s,e.typeAnnotation||"coerce");else a=r(a,s,e.typeAnnotation||"assert");}if(!(a instanceof Mi)&&"resolvedImage"!==a.type.kind&&function t(e){if(e instanceof tn)return t(e.boundExpression);if(e instanceof Ti&&"error"===e.name)return !1;if(e instanceof Vi)return !1;if(e instanceof Yi)return !1;var r=e instanceof Ei||e instanceof ki,i=!0;return e.eachChild((function(e){i=r?i&&t(e):i&&e instanceof Mi;})),!!i&&Wi(e)&&$i(e,["zoom","heatmap-density","line-progress","accumulated","is-supported-script"])}(a)){var u=new Bi;try{a=new Mi(a.type,a.evaluate(u));}catch(t){return this.error(t.message),null}}return a}return this.error('Unknown expression "'+i+'". If you wanted a literal array, use ["literal", [...]].',0)}return this.error(void 0===t?"'undefined' value invalid. Use null instead.":"object"==typeof t?'Bare objects invalid. Use ["literal", {...}] instead.':"Expected an array, but found "+typeof t+" instead.")},en.prototype.concat=function(t,e,r){var i="number"==typeof t?this.path.concat(t):this.path,n=r?this.scope.concat(r):this.scope;return new en(this.registry,i,e||null,n,this.errors)},en.prototype.error=function(t){for(var e=[],r=arguments.length-1;r-- >0;)e[r]=arguments[r+1];var i=""+this.key+e.map((function(t){return "["+t+"]"})).join("");this.errors.push(new Wr(i,t));},en.prototype.checkSubtype=function(t,e){var r=ci(t,e);return r&&this.error(r),r};var nn=function(t,e,r){this.type=t,this.input=e,this.labels=[],this.outputs=[];for(var i=0,n=r;i<n.length;i+=1){var a=n[i],s=a[1];this.labels.push(a[0]),this.outputs.push(s);}};function an(t,e,r){return t*(1-r)+e*r}nn.parse=function(t,e){if(t.length-1<4)return e.error("Expected at least 4 arguments, but found only "+(t.length-1)+".");if((t.length-1)%2!=0)return e.error("Expected an even number of arguments.");var r=e.parse(t[1],1,ti);if(!r)return null;var i=[],n=null;e.expectedType&&"value"!==e.expectedType.kind&&(n=e.expectedType);for(var a=1;a<t.length;a+=2){var s=1===a?-1/0:t[a],o=t[a+1],u=a,h=a+1;if("number"!=typeof s)return e.error('Input/output pairs for "step" expressions must be defined using literal numeric values (not computed expressions) for the input values.',u);if(i.length&&i[i.length-1][0]>=s)return e.error('Input/output pairs for "step" expressions must be arranged with input values in strictly ascending order.',u);var l=e.parse(o,h,n);if(!l)return null;n=n||l.type,i.push([s,l]);}return new nn(n,r,i)},nn.prototype.evaluate=function(t){var e=this.labels,r=this.outputs;if(1===e.length)return r[0].evaluate(t);var i=this.input.evaluate(t);if(i<=e[0])return r[0].evaluate(t);var n=e.length;return i>=e[n-1]?r[n-1].evaluate(t):r[rn(e,i)].evaluate(t)},nn.prototype.eachChild=function(t){t(this.input);for(var e=0,r=this.outputs;e<r.length;e+=1)t(r[e]);},nn.prototype.outputDefined=function(){return this.outputs.every((function(t){return t.outputDefined()}))},nn.prototype.serialize=function(){for(var t=["step",this.input.serialize()],e=0;e<this.labels.length;e++)e>0&&t.push(this.labels[e]),t.push(this.outputs[e].serialize());return t};var sn=Object.freeze({__proto__:null,number:an,color:function(t,e,r){return new Zr(an(t.r,e.r,r),an(t.g,e.g,r),an(t.b,e.b,r),an(t.a,e.a,r))},array:function(t,e,r){return t.map((function(t,i){return an(t,e[i],r)}))}}),on=6/29*3*(6/29),un=Math.PI/180,hn=180/Math.PI;function ln(t){return t>.008856451679035631?Math.pow(t,1/3):t/on+4/29}function pn(t){return t>6/29?t*t*t:on*(t-4/29)}function cn(t){return 255*(t<=.0031308?12.92*t:1.055*Math.pow(t,1/2.4)-.055)}function fn(t){return (t/=255)<=.04045?t/12.92:Math.pow((t+.055)/1.055,2.4)}function yn(t){var e=fn(t.r),r=fn(t.g),i=fn(t.b),n=ln((.4124564*e+.3575761*r+.1804375*i)/.95047),a=ln((.2126729*e+.7151522*r+.072175*i)/1);return {l:116*a-16,a:500*(n-a),b:200*(a-ln((.0193339*e+.119192*r+.9503041*i)/1.08883)),alpha:t.a}}function dn(t){var e=(t.l+16)/116,r=isNaN(t.a)?e:e+t.a/500,i=isNaN(t.b)?e:e-t.b/200;return e=1*pn(e),r=.95047*pn(r),i=1.08883*pn(i),new Zr(cn(3.2404542*r-1.5371385*e-.4985314*i),cn(-.969266*r+1.8760108*e+.041556*i),cn(.0556434*r-.2040259*e+1.0572252*i),t.alpha)}function mn(t,e,r){var i=e-t;return t+r*(i>180||i<-180?i-360*Math.round(i/360):i)}var vn={forward:yn,reverse:dn,interpolate:function(t,e,r){return {l:an(t.l,e.l,r),a:an(t.a,e.a,r),b:an(t.b,e.b,r),alpha:an(t.alpha,e.alpha,r)}}},gn={forward:function(t){var e=yn(t),r=e.l,i=e.a,n=e.b,a=Math.atan2(n,i)*hn;return {h:a<0?a+360:a,c:Math.sqrt(i*i+n*n),l:r,alpha:t.a}},reverse:function(t){var e=t.h*un,r=t.c;return dn({l:t.l,a:Math.cos(e)*r,b:Math.sin(e)*r,alpha:t.alpha})},interpolate:function(t,e,r){return {h:mn(t.h,e.h,r),c:an(t.c,e.c,r),l:an(t.l,e.l,r),alpha:an(t.alpha,e.alpha,r)}}},xn=Object.freeze({__proto__:null,lab:vn,hcl:gn}),bn=function(t,e,r,i,n){this.type=t,this.operator=e,this.interpolation=r,this.input=i,this.labels=[],this.outputs=[];for(var a=0,s=n;a<s.length;a+=1){var o=s[a],u=o[1];this.labels.push(o[0]),this.outputs.push(u);}};function _n(t,e,r,i){var n=i-r,a=t-r;return 0===n?0:1===e?a/n:(Math.pow(e,a)-1)/(Math.pow(e,n)-1)}bn.interpolationFactor=function(t,e,i,n){var a=0;if("exponential"===t.name)a=_n(e,t.base,i,n);else if("linear"===t.name)a=_n(e,1,i,n);else if("cubic-bezier"===t.name){var s=t.controlPoints;a=new r(s[0],s[1],s[2],s[3]).solve(_n(e,1,i,n));}return a},bn.parse=function(t,e){var r=t[0],i=t[1],n=t[2],a=t.slice(3);if(!Array.isArray(i)||0===i.length)return e.error("Expected an interpolation type expression.",1);if("linear"===i[0])i={name:"linear"};else if("exponential"===i[0]){var s=i[1];if("number"!=typeof s)return e.error("Exponential interpolation requires a numeric base.",1,1);i={name:"exponential",base:s};}else {if("cubic-bezier"!==i[0])return e.error("Unknown interpolation type "+String(i[0]),1,0);var o=i.slice(1);if(4!==o.length||o.some((function(t){return "number"!=typeof t||t<0||t>1})))return e.error("Cubic bezier interpolation requires four numeric arguments with values between 0 and 1.",1);i={name:"cubic-bezier",controlPoints:o};}if(t.length-1<4)return e.error("Expected at least 4 arguments, but found only "+(t.length-1)+".");if((t.length-1)%2!=0)return e.error("Expected an even number of arguments.");if(!(n=e.parse(n,2,ti)))return null;var u=[],h=null;"interpolate-hcl"===r||"interpolate-lab"===r?h=ii:e.expectedType&&"value"!==e.expectedType.kind&&(h=e.expectedType);for(var l=0;l<a.length;l+=2){var p=a[l],c=a[l+1],f=l+3,y=l+4;if("number"!=typeof p)return e.error('Input/output pairs for "interpolate" expressions must be defined using literal numeric values (not computed expressions) for the input values.',f);if(u.length&&u[u.length-1][0]>=p)return e.error('Input/output pairs for "interpolate" expressions must be arranged with input values in strictly ascending order.',f);var d=e.parse(c,y,h);if(!d)return null;h=h||d.type,u.push([p,d]);}return "number"===h.kind||"color"===h.kind||"array"===h.kind&&"number"===h.itemType.kind&&"number"==typeof h.N?new bn(h,r,i,n,u):e.error("Type "+li(h)+" is not interpolatable.")},bn.prototype.evaluate=function(t){var e=this.labels,r=this.outputs;if(1===e.length)return r[0].evaluate(t);var i=this.input.evaluate(t);if(i<=e[0])return r[0].evaluate(t);var n=e.length;if(i>=e[n-1])return r[n-1].evaluate(t);var a=rn(e,i),s=bn.interpolationFactor(this.interpolation,i,e[a],e[a+1]),o=r[a].evaluate(t),u=r[a+1].evaluate(t);return "interpolate"===this.operator?sn[this.type.kind.toLowerCase()](o,u,s):"interpolate-hcl"===this.operator?gn.reverse(gn.interpolate(gn.forward(o),gn.forward(u),s)):vn.reverse(vn.interpolate(vn.forward(o),vn.forward(u),s))},bn.prototype.eachChild=function(t){t(this.input);for(var e=0,r=this.outputs;e<r.length;e+=1)t(r[e]);},bn.prototype.outputDefined=function(){return this.outputs.every((function(t){return t.outputDefined()}))},bn.prototype.serialize=function(){var t;t="linear"===this.interpolation.name?["linear"]:"exponential"===this.interpolation.name?1===this.interpolation.base?["linear"]:["exponential",this.interpolation.base]:["cubic-bezier"].concat(this.interpolation.controlPoints);for(var e=[this.operator,t,this.input.serialize()],r=0;r<this.labels.length;r++)e.push(this.labels[r],this.outputs[r].serialize());return e};var wn=function(t,e){this.type=t,this.args=e;};wn.parse=function(t,e){if(t.length<2)return e.error("Expectected at least one argument.");var r=null,i=e.expectedType;i&&"value"!==i.kind&&(r=i);for(var n=[],a=0,s=t.slice(1);a<s.length;a+=1){var o=e.parse(s[a],1+n.length,r,void 0,{typeAnnotation:"omit"});if(!o)return null;r=r||o.type,n.push(o);}var u=i&&n.some((function(t){return ci(i,t.type)}));return new wn(u?ai:r,n)},wn.prototype.evaluate=function(t){for(var e,r=null,i=0,n=0,a=this.args;n<a.length&&(i++,(r=a[n].evaluate(t))&&r instanceof gi&&!r.available&&(e||(e=r.name),r=null,i===this.args.length&&(r=e)),null===r);n+=1);return r},wn.prototype.eachChild=function(t){this.args.forEach(t);},wn.prototype.outputDefined=function(){return this.args.every((function(t){return t.outputDefined()}))},wn.prototype.serialize=function(){var t=["coalesce"];return this.eachChild((function(e){t.push(e.serialize());})),t};var Mn=function(t,e){this.type=e.type,this.bindings=[].concat(t),this.result=e;};Mn.prototype.evaluate=function(t){return this.result.evaluate(t)},Mn.prototype.eachChild=function(t){for(var e=0,r=this.bindings;e<r.length;e+=1)t(r[e][1]);t(this.result);},Mn.parse=function(t,e){if(t.length<4)return e.error("Expected at least 3 arguments, but found "+(t.length-1)+" instead.");for(var r=[],i=1;i<t.length-1;i+=2){var n=t[i];if("string"!=typeof n)return e.error("Expected string, but found "+typeof n+" instead.",i);if(/[^a-zA-Z0-9_]/.test(n))return e.error("Variable names must contain only alphanumeric characters or '_'.",i);var a=e.parse(t[i+1],i+1);if(!a)return null;r.push([n,a]);}var s=e.parse(t[t.length-1],t.length-1,e.expectedType,r);return s?new Mn(r,s):null},Mn.prototype.outputDefined=function(){return this.result.outputDefined()},Mn.prototype.serialize=function(){for(var t=["let"],e=0,r=this.bindings;e<r.length;e+=1){var i=r[e];t.push(i[0],i[1].serialize());}return t.push(this.result.serialize()),t};var Sn=function(t,e,r){this.type=t,this.index=e,this.input=r;};Sn.parse=function(t,e){if(3!==t.length)return e.error("Expected 2 arguments, but found "+(t.length-1)+" instead.");var r=e.parse(t[1],1,ti),i=e.parse(t[2],2,hi(e.expectedType||ai));return r&&i?new Sn(i.type.itemType,r,i):null},Sn.prototype.evaluate=function(t){var e=this.index.evaluate(t),r=this.input.evaluate(t);if(e<0)throw new Si("Array index out of bounds: "+e+" < 0.");if(e>=r.length)throw new Si("Array index out of bounds: "+e+" > "+(r.length-1)+".");if(e!==Math.floor(e))throw new Si("Array index must be an integer, but found "+e+" instead.");return r[e]},Sn.prototype.eachChild=function(t){t(this.index),t(this.input);},Sn.prototype.outputDefined=function(){return !1},Sn.prototype.serialize=function(){return ["at",this.index.serialize(),this.input.serialize()]};var An=function(t,e){this.type=ri,this.needle=t,this.haystack=e;};An.parse=function(t,e){if(3!==t.length)return e.error("Expected 2 arguments, but found "+(t.length-1)+" instead.");var r=e.parse(t[1],1,ai),i=e.parse(t[2],2,ai);return r&&i?fi(r.type,[ri,ei,ti,$r,ai])?new An(r,i):e.error("Expected first argument to be of type boolean, string, number or null, but found "+li(r.type)+" instead"):null},An.prototype.evaluate=function(t){var e=this.needle.evaluate(t),r=this.haystack.evaluate(t);if(!r)return !1;if(!yi(e,["boolean","string","number","null"]))throw new Si("Expected first argument to be of type boolean, string, number or null, but found "+li(_i(e))+" instead.");if(!yi(r,["string","array"]))throw new Si("Expected second argument to be of type array or string, but found "+li(_i(r))+" instead.");return r.indexOf(e)>=0},An.prototype.eachChild=function(t){t(this.needle),t(this.haystack);},An.prototype.outputDefined=function(){return !0},An.prototype.serialize=function(){return ["in",this.needle.serialize(),this.haystack.serialize()]};var kn=function(t,e,r){this.type=ti,this.needle=t,this.haystack=e,this.fromIndex=r;};kn.parse=function(t,e){if(t.length<=2||t.length>=5)return e.error("Expected 3 or 4 arguments, but found "+(t.length-1)+" instead.");var r=e.parse(t[1],1,ai),i=e.parse(t[2],2,ai);if(!r||!i)return null;if(!fi(r.type,[ri,ei,ti,$r,ai]))return e.error("Expected first argument to be of type boolean, string, number or null, but found "+li(r.type)+" instead");if(4===t.length){var n=e.parse(t[3],3,ti);return n?new kn(r,i,n):null}return new kn(r,i)},kn.prototype.evaluate=function(t){var e=this.needle.evaluate(t),r=this.haystack.evaluate(t);if(!yi(e,["boolean","string","number","null"]))throw new Si("Expected first argument to be of type boolean, string, number or null, but found "+li(_i(e))+" instead.");if(!yi(r,["string","array"]))throw new Si("Expected second argument to be of type array or string, but found "+li(_i(r))+" instead.");if(this.fromIndex){var i=this.fromIndex.evaluate(t);return r.indexOf(e,i)}return r.indexOf(e)},kn.prototype.eachChild=function(t){t(this.needle),t(this.haystack),this.fromIndex&&t(this.fromIndex);},kn.prototype.outputDefined=function(){return !1},kn.prototype.serialize=function(){if(null!=this.fromIndex&&void 0!==this.fromIndex){var t=this.fromIndex.serialize();return ["index-of",this.needle.serialize(),this.haystack.serialize(),t]}return ["index-of",this.needle.serialize(),this.haystack.serialize()]};var In=function(t,e,r,i,n,a){this.inputType=t,this.type=e,this.input=r,this.cases=i,this.outputs=n,this.otherwise=a;};In.parse=function(t,e){if(t.length<5)return e.error("Expected at least 4 arguments, but found only "+(t.length-1)+".");if(t.length%2!=1)return e.error("Expected an even number of arguments.");var r,i;e.expectedType&&"value"!==e.expectedType.kind&&(i=e.expectedType);for(var n={},a=[],s=2;s<t.length-1;s+=2){var o=t[s],u=t[s+1];Array.isArray(o)||(o=[o]);var h=e.concat(s);if(0===o.length)return h.error("Expected at least one branch label.");for(var l=0,p=o;l<p.length;l+=1){var c=p[l];if("number"!=typeof c&&"string"!=typeof c)return h.error("Branch labels must be numbers or strings.");if("number"==typeof c&&Math.abs(c)>Number.MAX_SAFE_INTEGER)return h.error("Branch labels must be integers no larger than "+Number.MAX_SAFE_INTEGER+".");if("number"==typeof c&&Math.floor(c)!==c)return h.error("Numeric branch labels must be integer values.");if(r){if(h.checkSubtype(r,_i(c)))return null}else r=_i(c);if(void 0!==n[String(c)])return h.error("Branch labels must be unique.");n[String(c)]=a.length;}var f=e.parse(u,s,i);if(!f)return null;i=i||f.type,a.push(f);}var y=e.parse(t[1],1,ai);if(!y)return null;var d=e.parse(t[t.length-1],t.length-1,i);return d?"value"!==y.type.kind&&e.concat(1).checkSubtype(r,y.type)?null:new In(r,i,y,n,a,d):null},In.prototype.evaluate=function(t){var e=this.input.evaluate(t);return (_i(e)===this.inputType&&this.outputs[this.cases[e]]||this.otherwise).evaluate(t)},In.prototype.eachChild=function(t){t(this.input),this.outputs.forEach(t),t(this.otherwise);},In.prototype.outputDefined=function(){return this.outputs.every((function(t){return t.outputDefined()}))&&this.otherwise.outputDefined()},In.prototype.serialize=function(){for(var t=this,e=["match",this.input.serialize()],r=[],i={},n=0,a=Object.keys(this.cases).sort();n<a.length;n+=1){var s=a[n];void 0===(p=i[this.cases[s]])?(i[this.cases[s]]=r.length,r.push([this.cases[s],[s]])):r[p][1].push(s);}for(var o=function(e){return "number"===t.inputType.kind?Number(e):e},u=0,h=r;u<h.length;u+=1){var l=h[u],p=l[0],c=l[1];e.push(1===c.length?o(c[0]):c.map(o)),e.push(this.outputs[outputIndex$1].serialize());}return e.push(this.otherwise.serialize()),e};var zn=function(t,e,r){this.type=t,this.branches=e,this.otherwise=r;};zn.parse=function(t,e){if(t.length<4)return e.error("Expected at least 3 arguments, but found only "+(t.length-1)+".");if(t.length%2!=0)return e.error("Expected an odd number of arguments.");var r;e.expectedType&&"value"!==e.expectedType.kind&&(r=e.expectedType);for(var i=[],n=1;n<t.length-1;n+=2){var a=e.parse(t[n],n,ri);if(!a)return null;var s=e.parse(t[n+1],n+1,r);if(!s)return null;i.push([a,s]),r=r||s.type;}var o=e.parse(t[t.length-1],t.length-1,r);return o?new zn(r,i,o):null},zn.prototype.evaluate=function(t){for(var e=0,r=this.branches;e<r.length;e+=1){var i=r[e],n=i[1];if(i[0].evaluate(t))return n.evaluate(t)}return this.otherwise.evaluate(t)},zn.prototype.eachChild=function(t){for(var e=0,r=this.branches;e<r.length;e+=1){var i=r[e],n=i[1];t(i[0]),t(n);}t(this.otherwise);},zn.prototype.outputDefined=function(){return this.branches.every((function(t){return t[1].outputDefined()}))&&this.otherwise.outputDefined()},zn.prototype.serialize=function(){var t=["case"];return this.eachChild((function(e){t.push(e.serialize());})),t};var Cn=function(t,e,r,i){this.type=t,this.input=e,this.beginIndex=r,this.endIndex=i;};function En(t,e){return "=="===t||"!="===t?"boolean"===e.kind||"string"===e.kind||"number"===e.kind||"null"===e.kind||"value"===e.kind:"string"===e.kind||"number"===e.kind||"value"===e.kind}function Pn(t,e,r,i){return 0===i.compare(e,r)}function Bn(t,e,r){var i="=="!==t&&"!="!==t;return function(){function n(t,e,r){this.type=ri,this.lhs=t,this.rhs=e,this.collator=r,this.hasUntypedArgument="value"===t.type.kind||"value"===e.type.kind;}return n.parse=function(t,e){if(3!==t.length&&4!==t.length)return e.error("Expected two or three arguments.");var r=t[0],a=e.parse(t[1],1,ai);if(!a)return null;if(!En(r,a.type))return e.concat(1).error('"'+r+"\" comparisons are not supported for type '"+li(a.type)+"'.");var s=e.parse(t[2],2,ai);if(!s)return null;if(!En(r,s.type))return e.concat(2).error('"'+r+"\" comparisons are not supported for type '"+li(s.type)+"'.");if(a.type.kind!==s.type.kind&&"value"!==a.type.kind&&"value"!==s.type.kind)return e.error("Cannot compare types '"+li(a.type)+"' and '"+li(s.type)+"'.");i&&("value"===a.type.kind&&"value"!==s.type.kind?a=new ki(s.type,[a]):"value"!==a.type.kind&&"value"===s.type.kind&&(s=new ki(a.type,[s])));var o=null;if(4===t.length){if("string"!==a.type.kind&&"string"!==s.type.kind&&"value"!==a.type.kind&&"value"!==s.type.kind)return e.error("Cannot use collator to compare non-string types.");if(!(o=e.parse(t[3],3,si)))return null}return new n(a,s,o)},n.prototype.evaluate=function(n){var a=this.lhs.evaluate(n),s=this.rhs.evaluate(n);if(i&&this.hasUntypedArgument){var o=_i(a),u=_i(s);if(o.kind!==u.kind||"string"!==o.kind&&"number"!==o.kind)throw new Si('Expected arguments for "'+t+'" to be (string, string) or (number, number), but found ('+o.kind+", "+u.kind+") instead.")}if(this.collator&&!i&&this.hasUntypedArgument){var h=_i(a),l=_i(s);if("string"!==h.kind||"string"!==l.kind)return e(n,a,s)}return this.collator?r(n,a,s,this.collator.evaluate(n)):e(n,a,s)},n.prototype.eachChild=function(t){t(this.lhs),t(this.rhs),this.collator&&t(this.collator);},n.prototype.outputDefined=function(){return !0},n.prototype.serialize=function(){var e=[t];return this.eachChild((function(t){e.push(t.serialize());})),e},n}()}Cn.parse=function(t,e){if(t.length<=2||t.length>=5)return e.error("Expected 3 or 4 arguments, but found "+(t.length-1)+" instead.");var r=e.parse(t[1],1,ai),i=e.parse(t[2],2,ti);if(!r||!i)return null;if(!fi(r.type,[hi(ai),ei,ai]))return e.error("Expected first argument to be of type array or string, but found "+li(r.type)+" instead");if(4===t.length){var n=e.parse(t[3],3,ti);return n?new Cn(r.type,r,i,n):null}return new Cn(r.type,r,i)},Cn.prototype.evaluate=function(t){var e=this.input.evaluate(t),r=this.beginIndex.evaluate(t);if(!yi(e,["string","array"]))throw new Si("Expected first argument to be of type array or string, but found "+li(_i(e))+" instead.");if(this.endIndex){var i=this.endIndex.evaluate(t);return e.slice(r,i)}return e.slice(r)},Cn.prototype.eachChild=function(t){t(this.input),t(this.beginIndex),this.endIndex&&t(this.endIndex);},Cn.prototype.outputDefined=function(){return !1},Cn.prototype.serialize=function(){if(null!=this.endIndex&&void 0!==this.endIndex){var t=this.endIndex.serialize();return ["slice",this.input.serialize(),this.beginIndex.serialize(),t]}return ["slice",this.input.serialize(),this.beginIndex.serialize()]};var Tn=Bn("==",(function(t,e,r){return e===r}),Pn),Vn=Bn("!=",(function(t,e,r){return e!==r}),(function(t,e,r,i){return !Pn(0,e,r,i)})),Ln=Bn("<",(function(t,e,r){return e<r}),(function(t,e,r,i){return i.compare(e,r)<0})),Fn=Bn(">",(function(t,e,r){return e>r}),(function(t,e,r,i){return i.compare(e,r)>0})),On=Bn("<=",(function(t,e,r){return e<=r}),(function(t,e,r,i){return i.compare(e,r)<=0})),Dn=Bn(">=",(function(t,e,r){return e>=r}),(function(t,e,r,i){return i.compare(e,r)>=0})),Nn=function(t,e,r,i,n){this.type=ei,this.number=t,this.locale=e,this.currency=r,this.minFractionDigits=i,this.maxFractionDigits=n;};Nn.parse=function(t,e){if(3!==t.length)return e.error("Expected two arguments.");var r=e.parse(t[1],1,ti);if(!r)return null;var i=t[2];if("object"!=typeof i||Array.isArray(i))return e.error("NumberFormat options argument must be an object.");var n=null;if(i.locale&&!(n=e.parse(i.locale,1,ei)))return null;var a=null;if(i.currency&&!(a=e.parse(i.currency,1,ei)))return null;var s=null;if(i["min-fraction-digits"]&&!(s=e.parse(i["min-fraction-digits"],1,ti)))return null;var o=null;return i["max-fraction-digits"]&&!(o=e.parse(i["max-fraction-digits"],1,ti))?null:new Nn(r,n,a,s,o)},Nn.prototype.evaluate=function(t){return new Intl.NumberFormat(this.locale?this.locale.evaluate(t):[],{style:this.currency?"currency":"decimal",currency:this.currency?this.currency.evaluate(t):void 0,minimumFractionDigits:this.minFractionDigits?this.minFractionDigits.evaluate(t):void 0,maximumFractionDigits:this.maxFractionDigits?this.maxFractionDigits.evaluate(t):void 0}).format(this.number.evaluate(t))},Nn.prototype.eachChild=function(t){t(this.number),this.locale&&t(this.locale),this.currency&&t(this.currency),this.minFractionDigits&&t(this.minFractionDigits),this.maxFractionDigits&&t(this.maxFractionDigits);},Nn.prototype.outputDefined=function(){return !1},Nn.prototype.serialize=function(){var t={};return this.locale&&(t.locale=this.locale.serialize()),this.currency&&(t.currency=this.currency.serialize()),this.minFractionDigits&&(t["min-fraction-digits"]=this.minFractionDigits.serialize()),this.maxFractionDigits&&(t["max-fraction-digits"]=this.maxFractionDigits.serialize()),["number-format",this.number.serialize(),t]};var Rn=function(t){this.type=ti,this.input=t;};Rn.parse=function(t,e){if(2!==t.length)return e.error("Expected 1 argument, but found "+(t.length-1)+" instead.");var r=e.parse(t[1],1);return r?"array"!==r.type.kind&&"string"!==r.type.kind&&"value"!==r.type.kind?e.error("Expected argument of type string or array, but found "+li(r.type)+" instead."):new Rn(r):null},Rn.prototype.evaluate=function(t){var e=this.input.evaluate(t);if("string"==typeof e)return e.length;if(Array.isArray(e))return e.length;throw new Si("Expected value to be of type string or array, but found "+li(_i(e))+" instead.")},Rn.prototype.eachChild=function(t){t(this.input);},Rn.prototype.outputDefined=function(){return !1},Rn.prototype.serialize=function(){var t=["length"];return this.eachChild((function(e){t.push(e.serialize());})),t};var qn={"==":Tn,"!=":Vn,">":Fn,"<":Ln,">=":Dn,"<=":On,array:ki,at:Sn,boolean:ki,case:zn,coalesce:wn,collator:Vi,format:Ii,image:zi,in:An,"index-of":kn,interpolate:bn,"interpolate-hcl":bn,"interpolate-lab":bn,length:Rn,let:Mn,literal:Mi,match:In,number:ki,"number-format":Nn,object:ki,slice:Cn,step:nn,string:ki,"to-boolean":Ei,"to-color":Ei,"to-number":Ei,"to-string":Ei,var:tn,within:Yi};function jn(t,e){var r=e[0],i=e[1],n=e[2],a=e[3];r=r.evaluate(t),i=i.evaluate(t),n=n.evaluate(t);var s=a?a.evaluate(t):1,o=xi(r,i,n,s);if(o)throw new Si(o);return new Zr(r/255*s,i/255*s,n/255*s,s)}function Un(t,e){return t in e}function Gn(t,e){var r=e[t];return void 0===r?null:r}function Kn(t){return {type:t}}function Xn(t){return {result:"success",value:t}}function Hn(t){return {result:"error",value:t}}function Jn(t){return "data-driven"===t["property-type"]||"cross-faded-data-driven"===t["property-type"]}function Zn(t){return !!t.expression&&t.expression.parameters.indexOf("zoom")>-1}function Yn(t){return !!t.expression&&t.expression.interpolated}function Wn(t){return t instanceof Number?"number":t instanceof String?"string":t instanceof Boolean?"boolean":Array.isArray(t)?"array":null===t?"null":typeof t}function Qn(t){return "object"==typeof t&&null!==t&&!Array.isArray(t)}function $n(t){return t}function ta(t,e,r){return void 0!==t?t:void 0!==e?e:void 0!==r?r:void 0}function ea(t,e,r,i,n){return ta(typeof r===n?i[r]:void 0,t.default,e.default)}function ra(t,e,r){if("number"!==Wn(r))return ta(t.default,e.default);var i=t.stops.length;if(1===i)return t.stops[0][1];if(r<=t.stops[0][0])return t.stops[0][1];if(r>=t.stops[i-1][0])return t.stops[i-1][1];var n=rn(t.stops.map((function(t){return t[0]})),r);return t.stops[n][1]}function ia(t,e,r){var i=void 0!==t.base?t.base:1;if("number"!==Wn(r))return ta(t.default,e.default);var n=t.stops.length;if(1===n)return t.stops[0][1];if(r<=t.stops[0][0])return t.stops[0][1];if(r>=t.stops[n-1][0])return t.stops[n-1][1];var a=rn(t.stops.map((function(t){return t[0]})),r),s=function(t,e,r,i){var n=i-r,a=t-r;return 0===n?0:1===e?a/n:(Math.pow(e,a)-1)/(Math.pow(e,n)-1)}(r,i,t.stops[a][0],t.stops[a+1][0]),o=t.stops[a][1],u=t.stops[a+1][1],h=sn[e.type]||$n;if(t.colorSpace&&"rgb"!==t.colorSpace){var l=xn[t.colorSpace];h=function(t,e){return l.reverse(l.interpolate(l.forward(t),l.forward(e),s))};}return "function"==typeof o.evaluate?{evaluate:function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];var r=o.evaluate.apply(void 0,t),i=u.evaluate.apply(void 0,t);if(void 0!==r&&void 0!==i)return h(r,i,s)}}:h(o,u,s)}function na(t,e,r){return "color"===e.type?r=Zr.parse(r):"formatted"===e.type?r=vi.fromString(r.toString()):"resolvedImage"===e.type?r=gi.fromString(r.toString()):Wn(r)===e.type||"enum"===e.type&&e.values[r]||(r=void 0),ta(r,t.default,e.default)}Ti.register(qn,{error:[{kind:"error"},[ei],function(t,e){throw new Si(e[0].evaluate(t))}],typeof:[ei,[ai],function(t,e){return li(_i(e[0].evaluate(t)))}],"to-rgba":[hi(ti,4),[ii],function(t,e){return e[0].evaluate(t).toArray()}],rgb:[ii,[ti,ti,ti],jn],rgba:[ii,[ti,ti,ti,ti],jn],has:{type:ri,overloads:[[[ei],function(t,e){return Un(e[0].evaluate(t),t.properties())}],[[ei,ni],function(t,e){var r=e[1];return Un(e[0].evaluate(t),r.evaluate(t))}]]},get:{type:ai,overloads:[[[ei],function(t,e){return Gn(e[0].evaluate(t),t.properties())}],[[ei,ni],function(t,e){var r=e[1];return Gn(e[0].evaluate(t),r.evaluate(t))}]]},"feature-state":[ai,[ei],function(t,e){return Gn(e[0].evaluate(t),t.featureState||{})}],properties:[ni,[],function(t){return t.properties()}],"geometry-type":[ei,[],function(t){return t.geometryType()}],id:[ai,[],function(t){return t.id()}],zoom:[ti,[],function(t){return t.globals.zoom}],"heatmap-density":[ti,[],function(t){return t.globals.heatmapDensity||0}],"line-progress":[ti,[],function(t){return t.globals.lineProgress||0}],accumulated:[ai,[],function(t){return void 0===t.globals.accumulated?null:t.globals.accumulated}],"+":[ti,Kn(ti),function(t,e){for(var r=0,i=0,n=e;i<n.length;i+=1)r+=n[i].evaluate(t);return r}],"*":[ti,Kn(ti),function(t,e){for(var r=1,i=0,n=e;i<n.length;i+=1)r*=n[i].evaluate(t);return r}],"-":{type:ti,overloads:[[[ti,ti],function(t,e){var r=e[1];return e[0].evaluate(t)-r.evaluate(t)}],[[ti],function(t,e){return -e[0].evaluate(t)}]]},"/":[ti,[ti,ti],function(t,e){var r=e[1];return e[0].evaluate(t)/r.evaluate(t)}],"%":[ti,[ti,ti],function(t,e){var r=e[1];return e[0].evaluate(t)%r.evaluate(t)}],ln2:[ti,[],function(){return Math.LN2}],pi:[ti,[],function(){return Math.PI}],e:[ti,[],function(){return Math.E}],"^":[ti,[ti,ti],function(t,e){var r=e[1];return Math.pow(e[0].evaluate(t),r.evaluate(t))}],sqrt:[ti,[ti],function(t,e){return Math.sqrt(e[0].evaluate(t))}],log10:[ti,[ti],function(t,e){return Math.log(e[0].evaluate(t))/Math.LN10}],ln:[ti,[ti],function(t,e){return Math.log(e[0].evaluate(t))}],log2:[ti,[ti],function(t,e){return Math.log(e[0].evaluate(t))/Math.LN2}],sin:[ti,[ti],function(t,e){return Math.sin(e[0].evaluate(t))}],cos:[ti,[ti],function(t,e){return Math.cos(e[0].evaluate(t))}],tan:[ti,[ti],function(t,e){return Math.tan(e[0].evaluate(t))}],asin:[ti,[ti],function(t,e){return Math.asin(e[0].evaluate(t))}],acos:[ti,[ti],function(t,e){return Math.acos(e[0].evaluate(t))}],atan:[ti,[ti],function(t,e){return Math.atan(e[0].evaluate(t))}],min:[ti,Kn(ti),function(t,e){return Math.min.apply(Math,e.map((function(e){return e.evaluate(t)})))}],max:[ti,Kn(ti),function(t,e){return Math.max.apply(Math,e.map((function(e){return e.evaluate(t)})))}],abs:[ti,[ti],function(t,e){return Math.abs(e[0].evaluate(t))}],round:[ti,[ti],function(t,e){var r=e[0].evaluate(t);return r<0?-Math.round(-r):Math.round(r)}],floor:[ti,[ti],function(t,e){return Math.floor(e[0].evaluate(t))}],ceil:[ti,[ti],function(t,e){return Math.ceil(e[0].evaluate(t))}],"filter-==":[ri,[ei,ai],function(t,e){var r=e[0],i=e[1];return t.properties()[r.value]===i.value}],"filter-id-==":[ri,[ai],function(t,e){var r=e[0];return t.id()===r.value}],"filter-type-==":[ri,[ei],function(t,e){var r=e[0];return t.geometryType()===r.value}],"filter-<":[ri,[ei,ai],function(t,e){var r=e[0],i=e[1],n=t.properties()[r.value],a=i.value;return typeof n==typeof a&&n<a}],"filter-id-<":[ri,[ai],function(t,e){var r=e[0],i=t.id(),n=r.value;return typeof i==typeof n&&i<n}],"filter->":[ri,[ei,ai],function(t,e){var r=e[0],i=e[1],n=t.properties()[r.value],a=i.value;return typeof n==typeof a&&n>a}],"filter-id->":[ri,[ai],function(t,e){var r=e[0],i=t.id(),n=r.value;return typeof i==typeof n&&i>n}],"filter-<=":[ri,[ei,ai],function(t,e){var r=e[0],i=e[1],n=t.properties()[r.value],a=i.value;return typeof n==typeof a&&n<=a}],"filter-id-<=":[ri,[ai],function(t,e){var r=e[0],i=t.id(),n=r.value;return typeof i==typeof n&&i<=n}],"filter->=":[ri,[ei,ai],function(t,e){var r=e[0],i=e[1],n=t.properties()[r.value],a=i.value;return typeof n==typeof a&&n>=a}],"filter-id->=":[ri,[ai],function(t,e){var r=e[0],i=t.id(),n=r.value;return typeof i==typeof n&&i>=n}],"filter-has":[ri,[ai],function(t,e){return e[0].value in t.properties()}],"filter-has-id":[ri,[],function(t){return null!==t.id()&&void 0!==t.id()}],"filter-type-in":[ri,[hi(ei)],function(t,e){return e[0].value.indexOf(t.geometryType())>=0}],"filter-id-in":[ri,[hi(ai)],function(t,e){return e[0].value.indexOf(t.id())>=0}],"filter-in-small":[ri,[ei,hi(ai)],function(t,e){var r=e[0];return e[1].value.indexOf(t.properties()[r.value])>=0}],"filter-in-large":[ri,[ei,hi(ai)],function(t,e){var r=e[0],i=e[1];return function(t,e,r,i){for(;r<=i;){var n=r+i>>1;if(e[n]===t)return !0;e[n]>t?i=n-1:r=n+1;}return !1}(t.properties()[r.value],i.value,0,i.value.length-1)}],all:{type:ri,overloads:[[[ri,ri],function(t,e){var r=e[1];return e[0].evaluate(t)&&r.evaluate(t)}],[Kn(ri),function(t,e){for(var r=0,i=e;r<i.length;r+=1)if(!i[r].evaluate(t))return !1;return !0}]]},any:{type:ri,overloads:[[[ri,ri],function(t,e){var r=e[1];return e[0].evaluate(t)||r.evaluate(t)}],[Kn(ri),function(t,e){for(var r=0,i=e;r<i.length;r+=1)if(i[r].evaluate(t))return !0;return !1}]]},"!":[ri,[ri],function(t,e){return !e[0].evaluate(t)}],"is-supported-script":[ri,[ei],function(t,e){var r=t.globals&&t.globals.isSupportedScript;return !r||r(e[0].evaluate(t))}],upcase:[ei,[ei],function(t,e){return e[0].evaluate(t).toUpperCase()}],downcase:[ei,[ei],function(t,e){return e[0].evaluate(t).toLowerCase()}],concat:[ei,Kn(ai),function(t,e){return e.map((function(e){return wi(e.evaluate(t))})).join("")}],"resolved-locale":[ei,[si],function(t,e){return e[0].evaluate(t).resolvedLocale()}]});var aa=function(t,e){this.expression=t,this._warningHistory={},this._evaluator=new Bi,this._defaultValue=e?function(t){return "color"===t.type&&Qn(t.default)?new Zr(0,0,0,0):"color"===t.type?Zr.parse(t.default)||null:void 0===t.default?null:t.default}(e):null,this._enumValues=e&&"enum"===e.type?e.values:null;};function sa(t){return Array.isArray(t)&&t.length>0&&"string"==typeof t[0]&&t[0]in qn}function oa(t,e){var r=new en(qn,[],e?function(t){var e={color:ii,string:ei,number:ti,enum:ei,boolean:ri,formatted:oi,resolvedImage:ui};return "array"===t.type?hi(e[t.value]||ai,t.length):e[t.type]}(e):void 0),i=r.parse(t,void 0,void 0,void 0,e&&"string"===e.type?{typeAnnotation:"coerce"}:void 0);return i?Xn(new aa(i,e)):Hn(r.errors)}aa.prototype.evaluateWithoutErrorHandling=function(t,e,r,i,n,a){return this._evaluator.globals=t,this._evaluator.feature=e,this._evaluator.featureState=r,this._evaluator.canonical=i,this._evaluator.availableImages=n||null,this._evaluator.formattedSection=a,this.expression.evaluate(this._evaluator)},aa.prototype.evaluate=function(t,e,r,i,n,a){this._evaluator.globals=t,this._evaluator.feature=e||null,this._evaluator.featureState=r||null,this._evaluator.canonical=i,this._evaluator.availableImages=n||null,this._evaluator.formattedSection=a||null;try{var s=this.expression.evaluate(this._evaluator);if(null==s||"number"==typeof s&&s!=s)return this._defaultValue;if(this._enumValues&&!(s in this._enumValues))throw new Si("Expected value to be one of "+Object.keys(this._enumValues).map((function(t){return JSON.stringify(t)})).join(", ")+", but found "+JSON.stringify(s)+" instead.");return s}catch(t){return this._warningHistory[t.message]||(this._warningHistory[t.message]=!0,"undefined"!=typeof console&&console.warn(t.message)),this._defaultValue}};var ua=function(t,e){this.kind=t,this._styleExpression=e,this.isStateDependent="constant"!==t&&!Qi(e.expression);};ua.prototype.evaluateWithoutErrorHandling=function(t,e,r,i,n,a){return this._styleExpression.evaluateWithoutErrorHandling(t,e,r,i,n,a)},ua.prototype.evaluate=function(t,e,r,i,n,a){return this._styleExpression.evaluate(t,e,r,i,n,a)};var ha=function(t,e,r,i){this.kind=t,this.zoomStops=r,this._styleExpression=e,this.isStateDependent="camera"!==t&&!Qi(e.expression),this.interpolationType=i;};function la(t,e){if("error"===(t=oa(t,e)).result)return t;var r=t.value.expression,i=Wi(r);if(!i&&!Jn(e))return Hn([new Wr("","data expressions not supported")]);var n=$i(r,["zoom"]);if(!n&&!Zn(e))return Hn([new Wr("","zoom expressions not supported")]);var a=function t(e){var r=null;if(e instanceof Mn)r=t(e.result);else if(e instanceof wn)for(var i=0,n=e.args;i<n.length&&!(r=t(n[i]));i+=1);else (e instanceof nn||e instanceof bn)&&e.input instanceof Ti&&"zoom"===e.input.name&&(r=e);return r instanceof Wr||e.eachChild((function(e){var i=t(e);i instanceof Wr?r=i:!r&&i?r=new Wr("",'"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.'):r&&i&&r!==i&&(r=new Wr("",'Only one zoom-based "step" or "interpolate" subexpression may be used in an expression.'));})),r}(r);return a||n?a instanceof Wr?Hn([a]):a instanceof bn&&!Yn(e)?Hn([new Wr("",'"interpolate" expressions cannot be used with this property')]):Xn(a?new ha(i?"camera":"composite",t.value,a.labels,a instanceof bn?a.interpolation:void 0):new ua(i?"constant":"source",t.value)):Hn([new Wr("",'"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.')])}ha.prototype.evaluateWithoutErrorHandling=function(t,e,r,i,n,a){return this._styleExpression.evaluateWithoutErrorHandling(t,e,r,i,n,a)},ha.prototype.evaluate=function(t,e,r,i,n,a){return this._styleExpression.evaluate(t,e,r,i,n,a)},ha.prototype.interpolationFactor=function(t,e,r){return this.interpolationType?bn.interpolationFactor(this.interpolationType,t,e,r):0};var pa=function(t,e){this._parameters=t,this._specification=e,Yr(this,function t(e,r){var i,n,a,s="color"===r.type,o=e.stops&&"object"==typeof e.stops[0][0],u=o||!(o||void 0!==e.property),h=e.type||(Yn(r)?"exponential":"interval");if(s&&((e=Yr({},e)).stops&&(e.stops=e.stops.map((function(t){return [t[0],Zr.parse(t[1])]}))),e.default=Zr.parse(e.default?e.default:r.default)),e.colorSpace&&"rgb"!==e.colorSpace&&!xn[e.colorSpace])throw new Error("Unknown color space: "+e.colorSpace);if("exponential"===h)i=ia;else if("interval"===h)i=ra;else if("categorical"===h){i=ea,n=Object.create(null);for(var l=0,p=e.stops;l<p.length;l+=1){var c=p[l];n[c[0]]=c[1];}a=typeof e.stops[0][0];}else {if("identity"!==h)throw new Error('Unknown function type "'+h+'"');i=na;}if(o){for(var f={},y=[],d=0;d<e.stops.length;d++){var m=e.stops[d],v=m[0].zoom;void 0===f[v]&&(f[v]={zoom:v,type:e.type,property:e.property,default:e.default,stops:[]},y.push(v)),f[v].stops.push([m[0].value,m[1]]);}for(var g=[],x=0,b=y;x<b.length;x+=1){var _=b[x];g.push([f[_].zoom,t(f[_],r)]);}var w={name:"linear"};return {kind:"composite",interpolationType:w,interpolationFactor:bn.interpolationFactor.bind(void 0,w),zoomStops:g.map((function(t){return t[0]})),evaluate:function(t,i){var n=t.zoom;return ia({stops:g,base:e.base},r,n).evaluate(n,i)}}}if(u){var M="exponential"===h?{name:"exponential",base:void 0!==e.base?e.base:1}:null;return {kind:"camera",interpolationType:M,interpolationFactor:bn.interpolationFactor.bind(void 0,M),zoomStops:e.stops.map((function(t){return t[0]})),evaluate:function(t){return i(e,r,t.zoom,n,a)}}}return {kind:"source",evaluate:function(t,s){var o=s&&s.properties?s.properties[e.property]:void 0;return void 0===o?ta(e.default,r.default):i(e,r,o,n,a)}}}(this._parameters,this._specification));};pa.deserialize=function(t){return new pa(t._parameters,t._specification)},pa.serialize=function(t){return {_parameters:t._parameters,_specification:t._specification}};var ca=s.ImageData,fa=s.ImageBitmap,ya={};function da(t,e,r){void 0===r&&(r={}),Object.defineProperty(e,"_classRegistryKey",{value:t,writeable:!1}),ya[t]={klass:e,omit:r.omit||[],shallow:r.shallow||[]};}for(var ma in da("Object",Object),Xr.serialize=function(t,e){var r=t.toArrayBuffer();return e&&e.push(r),{buffer:r}},Xr.deserialize=function(t){return new Xr(t.buffer)},da("Grid",Xr),da("Color",Zr),da("Error",Error),da("ResolvedImage",gi),da("StylePropertyFunction",pa),da("StyleExpression",aa,{omit:["_evaluator"]}),da("ZoomDependentExpression",ha),da("ZoomConstantExpression",ua),da("CompoundExpression",Ti,{omit:["_evaluate"]}),qn)qn[ma]._classRegistryKey||da("Expression_"+ma,qn[ma]);function va(t){return t&&"undefined"!=typeof ArrayBuffer&&(t instanceof ArrayBuffer||t.constructor&&"ArrayBuffer"===t.constructor.name)}function ga(t){return fa&&t instanceof fa}function xa(t,e){if(null==t||"boolean"==typeof t||"number"==typeof t||"string"==typeof t||t instanceof Boolean||t instanceof Number||t instanceof String||t instanceof Date||t instanceof RegExp)return t;if(va(t)||ga(t))return e&&e.push(t),t;if(ArrayBuffer.isView(t)){var r=t;return e&&e.push(r.buffer),r}if(t instanceof ca)return e&&e.push(t.data.buffer),t;if(Array.isArray(t)){for(var i=[],n=0,a=t;n<a.length;n+=1)i.push(xa(a[n],e));return i}if("object"==typeof t){var s=t.constructor,o=s._classRegistryKey;if(!o)throw new Error("can't serialize object of unregistered class");var u=s.serialize?s.serialize(t,e):{};if(!s.serialize){for(var h in t)if(t.hasOwnProperty(h)&&!(ya[o].omit.indexOf(h)>=0)){var l=t[h];u[h]=ya[o].shallow.indexOf(h)>=0?l:xa(l,e);}t instanceof Error&&(u.message=t.message);}if(u.$name)throw new Error("$name property is reserved for worker serialization logic.");return "Object"!==o&&(u.$name=o),u}throw new Error("can't serialize object of type "+typeof t)}function ba(t){if(null==t||"boolean"==typeof t||"number"==typeof t||"string"==typeof t||t instanceof Boolean||t instanceof Number||t instanceof String||t instanceof Date||t instanceof RegExp||va(t)||ga(t)||ArrayBuffer.isView(t)||t instanceof ca)return t;if(Array.isArray(t))return t.map(ba);if("object"==typeof t){var e=t.$name||"Object",r=ya[e].klass;if(!r)throw new Error("can't deserialize unregistered class "+e);if(r.deserialize)return r.deserialize(t);for(var i=Object.create(r.prototype),n=0,a=Object.keys(t);n<a.length;n+=1){var s=a[n];if("$name"!==s){var o=t[s];i[s]=ya[e].shallow.indexOf(s)>=0?o:ba(o);}}return i}throw new Error("can't deserialize object of type "+typeof t)}function _a(t,e,r,i){var n=e.width,a=e.height;if(i){if(i instanceof Uint8ClampedArray)i=new Uint8Array(i.buffer);else if(i.length!==n*a*r)throw new RangeError("mismatched image size")}else i=new Uint8Array(n*a*r);return t.width=n,t.height=a,t.data=i,t}function wa(t,e,r){var i=e.width,n=e.height;if(i!==t.width||n!==t.height){var a=_a({},{width:i,height:n},r);Ma(t,a,{x:0,y:0},{x:0,y:0},{width:Math.min(t.width,i),height:Math.min(t.height,n)},r),t.width=i,t.height=n,t.data=a.data;}}function Ma(t,e,r,i,n,a){if(0===n.width||0===n.height)return e;if(n.width>t.width||n.height>t.height||r.x>t.width-n.width||r.y>t.height-n.height)throw new RangeError("out of range source coordinates for image copy");if(n.width>e.width||n.height>e.height||i.x>e.width-n.width||i.y>e.height-n.height)throw new RangeError("out of range destination coordinates for image copy");for(var s=t.data,o=e.data,u=0;u<n.height;u++)for(var h=((r.y+u)*t.width+r.x)*a,l=((i.y+u)*e.width+i.x)*a,p=0;p<n.width*a;p++)o[l+p]=s[h+p];return e}var Sa=function(t,e){_a(this,t,1,e);};Sa.prototype.resize=function(t){wa(this,t,1);},Sa.prototype.clone=function(){return new Sa({width:this.width,height:this.height},new Uint8Array(this.data))},Sa.copy=function(t,e,r,i,n){Ma(t,e,r,i,n,1);};var Aa=function(t,e){_a(this,t,4,e);};function ka(t,e,r){r[t]&&-1!==r[t].indexOf(e)||(r[t]=r[t]||[],r[t].push(e));}function Ia(t,e,r){if(r&&r[t]){var i=r[t].indexOf(e);-1!==i&&r[t].splice(i,1);}}Aa.prototype.resize=function(t){wa(this,t,4);},Aa.prototype.replace=function(t,e){e?this.data.set(t):this.data=t instanceof Uint8ClampedArray?new Uint8Array(t.buffer):t;},Aa.prototype.clone=function(){return new Aa({width:this.width,height:this.height},new Uint8Array(this.data))},Aa.copy=function(t,e,r,i,n){Ma(t,e,r,i,n,4);},da("AlphaImage",Sa),da("RGBAImage",Aa);var za=function(t,e){void 0===e&&(e={}),c(this,e),this.type=t;},Ca=function(t){function e(e,r){void 0===r&&(r={}),t.call(this,"error",c({error:e},r));}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e}(za),Ea=function(){};Ea.prototype.on=function(t,e){return this._listeners=this._listeners||{},ka(t,e,this._listeners),this},Ea.prototype.off=function(t,e){return Ia(t,e,this._listeners),Ia(t,e,this._oneTimeListeners),this},Ea.prototype.once=function(t,e){return this._oneTimeListeners=this._oneTimeListeners||{},ka(t,e,this._oneTimeListeners),this},Ea.prototype.fire=function(t,e){"string"==typeof t&&(t=new za(t,e||{}));var r=t.type;if(this.listens(r)){t.target=this;for(var i=0,n=this._listeners&&this._listeners[r]?this._listeners[r].slice():[];i<n.length;i+=1)n[i].call(this,t);for(var a=0,s=this._oneTimeListeners&&this._oneTimeListeners[r]?this._oneTimeListeners[r].slice():[];a<s.length;a+=1){var o=s[a];Ia(r,o,this._oneTimeListeners),o.call(this,t);}var u=this._eventedParent;u&&(c(t,"function"==typeof this._eventedParentData?this._eventedParentData():this._eventedParentData),u.fire(t));}else t instanceof Ca&&console.error(t.error);return this},Ea.prototype.listens=function(t){return this._listeners&&this._listeners[t]&&this._listeners[t].length>0||this._oneTimeListeners&&this._oneTimeListeners[t]&&this._oneTimeListeners[t].length>0||this._eventedParent&&this._eventedParent.listens(t)},Ea.prototype.setEventedParent=function(t,e){return this._eventedParent=t,this._eventedParentData=e,this};var Pa={$version:8,$root:{version:{required:!0,type:"enum",values:[8]},name:{type:"string"},metadata:{type:"*"},center:{type:"array",value:"number"},zoom:{type:"number"},bearing:{type:"number",default:0,period:360,units:"degrees"},pitch:{type:"number",default:0,units:"degrees"},light:{type:"light"},sources:{required:!0,type:"sources"},sprite:{type:"stringobject"},glyphs:{type:"stringobject"},transition:{type:"transition"},layers:{required:!0,type:"array",value:"layer"}},sources:{"*":{type:"source"}},source:["source_vector","source_raster","source_raster_dem","source_geojson","source_video","source_image"],source_vector:{type:{required:!0,type:"enum",values:{vector:{}}},url:{type:"string"},tiles:{type:"array",value:"string"},bounds:{type:"array",value:"number",length:4,default:[-180,-85.051129,180,85.051129]},scheme:{type:"enum",values:{xyz:{},tms:{}},default:"xyz"},minzoom:{type:"number",default:0},maxzoom:{type:"number",default:22},attribution:{type:"string"},promoteId:{type:"promoteId"},volatile:{type:"boolean",default:!1},"*":{type:"*"}},source_raster:{type:{required:!0,type:"enum",values:{raster:{}}},url:{type:"string"},tiles:{type:"array",value:"string"},bounds:{type:"array",value:"number",length:4,default:[-180,-85.051129,180,85.051129]},minzoom:{type:"number",default:0},maxzoom:{type:"number",default:22},tileSize:{type:"number",default:512,units:"pixels"},scheme:{type:"enum",values:{xyz:{},tms:{}},default:"xyz"},attribution:{type:"string"},volatile:{type:"boolean",default:!1},"*":{type:"*"}},source_raster_dem:{type:{required:!0,type:"enum",values:{"raster-dem":{}}},url:{type:"string"},tiles:{type:"array",value:"string"},bounds:{type:"array",value:"number",length:4,default:[-180,-85.051129,180,85.051129]},minzoom:{type:"number",default:0},maxzoom:{type:"number",default:22},tileSize:{type:"number",default:512,units:"pixels"},attribution:{type:"string"},encoding:{type:"enum",values:{terrarium:{},mapbox:{}},default:"mapbox"},volatile:{type:"boolean",default:!1},"*":{type:"*"}},source_geojson:{type:{required:!0,type:"enum",values:{geojson:{}}},data:{type:"*"},maxzoom:{type:"number",default:18},attribution:{type:"string"},customprj:{type:"*"},buffer:{type:"number",default:128,maximum:512,minimum:0},filter:{type:"*"},tolerance:{type:"number",default:.375},cluster:{type:"boolean",default:!1},clusterRadius:{type:"number",default:50,minimum:0},clusterMaxZoom:{type:"number"},clusterMinPoints:{type:"number"},clusterProperties:{type:"*"},lineMetrics:{type:"boolean",default:!1},generateId:{type:"boolean",default:!1},promoteId:{type:"promoteId"}},source_video:{type:{required:!0,type:"enum",values:{video:{}}},urls:{required:!0,type:"array",value:"string"},coordinates:{required:!0,type:"array",length:4,value:{type:"array",length:2,value:"number"}},drawImageCallback:{type:"*"}},source_image:{type:{required:!0,type:"enum",values:{image:{}}},url:{required:!0,type:"string"},coordinates:{required:!0,type:"array",length:4,value:{type:"array",length:2,value:"number"}}},layer:{id:{type:"string",required:!0},type:{type:"enum",values:{fill:{},line:{},symbol:{},circle:{},heatmap:{},"fill-extrusion":{},raster:{},hillshade:{},background:{}},required:!0},metadata:{type:"*"},source:{type:"string"},"source-layer":{type:"string"},minzoom:{type:"number",minimum:0,maximum:24},maxzoom:{type:"number",minimum:0,maximum:24},filter:{type:"filter"},layout:{type:"layout"},paint:{type:"paint"}},layout:["layout_fill","layout_line","layout_circle","layout_heatmap","layout_fill-extrusion","layout_symbol","layout_raster","layout_hillshade","layout_background"],layout_background:{visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_fill:{"fill-sort-key":{type:"number",expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_circle:{"circle-sort-key":{type:"number",expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_heatmap:{visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},"layout_fill-extrusion":{visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_line:{"line-cap":{type:"enum",values:{butt:{},round:{},square:{}},default:"butt",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"line-join":{type:"enum",values:{bevel:{},round:{},miter:{}},default:"miter",expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"line-miter-limit":{type:"number",default:2,requires:[{"line-join":"miter"}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"line-round-limit":{type:"number",default:1.05,requires:[{"line-join":"round"}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"line-sort-key":{type:"number",expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_symbol:{"symbol-placement":{type:"enum",values:{point:{},line:{},"line-center":{}},default:"point",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"symbol-spacing":{type:"number",default:250,minimum:1,units:"pixels",requires:[{"symbol-placement":"line"}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"symbol-avoid-edges":{type:"boolean",default:!1,expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"symbol-sort-key":{type:"number",expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"symbol-z-order":{type:"enum",values:{auto:{},"viewport-y":{},source:{}},default:"auto",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-allow-overlap":{type:"boolean",default:!1,requires:["icon-image"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-ignore-placement":{type:"boolean",default:!1,requires:["icon-image"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-optional":{type:"boolean",default:!1,requires:["icon-image","text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-rotation-alignment":{type:"enum",values:{map:{},viewport:{},auto:{}},default:"auto",requires:["icon-image"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-size":{type:"number",default:1,minimum:0,units:"factor of the original icon size",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-text-fit":{type:"enum",values:{none:{},width:{},height:{},both:{}},default:"none",requires:["icon-image","text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-text-fit-padding":{type:"array",value:"number",length:4,default:[0,0,0,0],units:"pixels",requires:["icon-image","text-field",{"icon-text-fit":["both","width","height"]}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"icon-image":{type:"resolvedImage",tokens:!0,expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-rotate":{type:"number",default:0,period:360,units:"degrees",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-padding":{type:"number",default:2,minimum:0,units:"pixels",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"icon-keep-upright":{type:"boolean",default:!1,requires:["icon-image",{"icon-rotation-alignment":"map"},{"symbol-placement":["line","line-center"]}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"icon-offset":{type:"array",value:"number",length:2,default:[0,0],requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-anchor":{type:"enum",values:{center:{},left:{},right:{},top:{},bottom:{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},default:"center",requires:["icon-image"],expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"icon-pitch-alignment":{type:"enum",values:{map:{},viewport:{},auto:{}},default:"auto",requires:["icon-image"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-pitch-alignment":{type:"enum",values:{map:{},viewport:{},auto:{}},default:"auto",requires:["text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-rotation-alignment":{type:"enum",values:{map:{},viewport:{},auto:{}},default:"auto",requires:["text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-field":{type:"formatted",default:"",tokens:!0,expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-font":{type:"array",value:"string",default:["Open Sans Regular","Arial Unicode MS Regular"],requires:["text-field"],expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-size":{type:"number",default:16,minimum:0,units:"pixels",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-max-width":{type:"number",default:10,minimum:0,units:"ems",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-line-height":{type:"number",default:1.2,units:"ems",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-letter-spacing":{type:"number",default:0,units:"ems",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-justify":{type:"enum",values:{auto:{},left:{},center:{},right:{}},default:"center",requires:["text-field"],expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-radial-offset":{type:"number",units:"ems",default:0,requires:["text-field"],"property-type":"data-driven",expression:{interpolated:!0,parameters:["zoom","feature"]}},"text-variable-anchor":{type:"array",value:"enum",values:{center:{},left:{},right:{},top:{},bottom:{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},requires:["text-field",{"symbol-placement":["point"]}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-anchor":{type:"enum",values:{center:{},left:{},right:{},top:{},bottom:{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},default:"center",requires:["text-field",{"!":"text-variable-anchor"}],expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-max-angle":{type:"number",default:45,units:"degrees",requires:["text-field",{"symbol-placement":["line","line-center"]}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-writing-mode":{type:"array",value:"enum",values:{horizontal:{},vertical:{}},requires:["text-field",{"symbol-placement":["point"]}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-rotate":{type:"number",default:0,period:360,units:"degrees",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-padding":{type:"number",default:2,minimum:0,units:"pixels",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-keep-upright":{type:"boolean",default:!0,requires:["text-field",{"text-rotation-alignment":"map"},{"symbol-placement":["line","line-center"]}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-transform":{type:"enum",values:{none:{},uppercase:{},lowercase:{}},default:"none",requires:["text-field"],expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-offset":{type:"array",value:"number",units:"ems",length:2,default:[0,0],requires:["text-field",{"!":"text-radial-offset"}],expression:{interpolated:!0,parameters:["zoom","feature"]},"property-type":"data-driven"},"text-allow-overlap":{type:"boolean",default:!1,requires:["text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-ignore-placement":{type:"boolean",default:!1,requires:["text-field"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-optional":{type:"boolean",default:!1,requires:["text-field","icon-image"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_raster:{visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},layout_hillshade:{visibility:{type:"enum",values:{visible:{},none:{}},default:"visible","property-type":"constant"}},filter:{type:"array",value:"*"},filter_operator:{type:"enum",values:{"==":{},"!=":{},">":{},">=":{},"<":{},"<=":{},in:{},"!in":{},all:{},any:{},none:{},has:{},"!has":{},within:{}}},geometry_type:{type:"enum",values:{Point:{},LineString:{},Polygon:{}}},function:{expression:{type:"expression"},stops:{type:"array",value:"function_stop"},base:{type:"number",default:1,minimum:0},property:{type:"string",default:"$zoom"},type:{type:"enum",values:{identity:{},exponential:{},interval:{},categorical:{}},default:"exponential"},colorSpace:{type:"enum",values:{rgb:{},lab:{},hcl:{}},default:"rgb"},default:{type:"*",required:!1}},function_stop:{type:"array",minimum:0,maximum:24,value:["number","color"],length:2},expression:{type:"array",value:"*",minimum:1},light:{anchor:{type:"enum",default:"viewport",values:{map:{},viewport:{}},"property-type":"data-constant",transition:!1,expression:{interpolated:!1,parameters:["zoom"]}},position:{type:"array",default:[1.15,210,30],length:3,value:"number","property-type":"data-constant",transition:!0,expression:{interpolated:!0,parameters:["zoom"]}},color:{type:"color","property-type":"data-constant",default:"#ffffff",expression:{interpolated:!0,parameters:["zoom"]},transition:!0},intensity:{type:"number","property-type":"data-constant",default:.5,minimum:0,maximum:1,expression:{interpolated:!0,parameters:["zoom"]},transition:!0}},paint:["paint_fill","paint_line","paint_circle","paint_heatmap","paint_fill-extrusion","paint_symbol","paint_raster","paint_hillshade","paint_background"],paint_fill:{"fill-antialias":{type:"boolean",default:!0,expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"fill-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-color":{type:"color",default:"#000000",transition:!0,requires:[{"!":"fill-pattern"}],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-outline-color":{type:"color",transition:!0,requires:[{"!":"fill-pattern"},{"fill-antialias":!0}],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"fill-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["fill-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"fill-pattern":{type:"resolvedImage",transition:!0,expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"cross-faded-data-driven"}},"paint_fill-extrusion":{"fill-extrusion-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"fill-extrusion-color":{type:"color",default:"#000000",transition:!0,requires:[{"!":"fill-extrusion-pattern"}],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"fill-extrusion-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["fill-extrusion-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"fill-extrusion-pattern":{type:"resolvedImage",transition:!0,expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"cross-faded-data-driven"},"fill-extrusion-height":{type:"number",default:0,minimum:0,units:"meters",transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-base":{type:"number",default:0,minimum:0,units:"meters",transition:!0,requires:["fill-extrusion-height"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-vertical-gradient":{type:"boolean",default:!0,transition:!1,expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"}},paint_line:{"line-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-color":{type:"color",default:"#000000",transition:!0,requires:[{"!":"line-pattern"}],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"line-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["line-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"line-width":{type:"number",default:1,minimum:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-gap-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-offset":{type:"number",default:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-blur":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-dasharray":{type:"array",value:"number",minimum:0,transition:!0,units:"line widths",requires:[{"!":"line-pattern"}],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"cross-faded"},"line-pattern":{type:"resolvedImage",transition:!0,expression:{interpolated:!1,parameters:["zoom","feature"]},"property-type":"cross-faded-data-driven"},"line-gradient":{type:"color",transition:!1,requires:[{"!":"line-dasharray"},{"!":"line-pattern"},{source:"geojson",has:{lineMetrics:!0}}],expression:{interpolated:!0,parameters:["line-progress"]},"property-type":"color-ramp"}},paint_circle:{"circle-radius":{type:"number",default:5,minimum:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-color":{type:"color",default:"#000000",transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-blur":{type:"number",default:0,transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"circle-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["circle-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"circle-pitch-scale":{type:"enum",values:{map:{},viewport:{}},default:"map",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"circle-pitch-alignment":{type:"enum",values:{map:{},viewport:{}},default:"viewport",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"circle-stroke-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-stroke-color":{type:"color",default:"#000000",transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-stroke-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"}},paint_heatmap:{"heatmap-radius":{type:"number",default:30,minimum:1,transition:!0,units:"pixels",expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"heatmap-weight":{type:"number",default:1,minimum:0,transition:!1,expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"heatmap-intensity":{type:"number",default:1,minimum:0,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"heatmap-color":{type:"color",default:["interpolate",["linear"],["heatmap-density"],0,"rgba(0, 0, 255, 0)",.1,"royalblue",.3,"cyan",.5,"lime",.7,"yellow",1,"red"],transition:!1,expression:{interpolated:!0,parameters:["heatmap-density"]},"property-type":"color-ramp"},"heatmap-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},paint_symbol:{"icon-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-color":{type:"color",default:"#000000",transition:!0,requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-color":{type:"color",default:"rgba(0, 0, 0, 0)",transition:!0,requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-blur":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",requires:["icon-image"],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"icon-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["icon-image","icon-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"text-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-color":{type:"color",default:"#000000",transition:!0,overridable:!0,requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-color":{type:"color",default:"rgba(0, 0, 0, 0)",transition:!0,requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-width":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-blur":{type:"number",default:0,minimum:0,transition:!0,units:"pixels",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-translate":{type:"array",value:"number",length:2,default:[0,0],transition:!0,units:"pixels",requires:["text-field"],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"text-translate-anchor":{type:"enum",values:{map:{},viewport:{}},default:"map",requires:["text-field","text-translate"],expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"}},paint_raster:{"raster-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-hue-rotate":{type:"number",default:0,period:360,transition:!0,units:"degrees",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-brightness-min":{type:"number",default:0,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-brightness-max":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-saturation":{type:"number",default:0,minimum:-1,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-contrast":{type:"number",default:0,minimum:-1,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"raster-resampling":{type:"enum",values:{linear:{},nearest:{}},default:"linear",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"raster-fade-duration":{type:"number",default:300,minimum:0,transition:!1,units:"milliseconds",expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},paint_hillshade:{"hillshade-illumination-direction":{type:"number",default:335,minimum:0,maximum:359,transition:!1,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-illumination-anchor":{type:"enum",values:{map:{},viewport:{}},default:"viewport",expression:{interpolated:!1,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-exaggeration":{type:"number",default:.5,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-shadow-color":{type:"color",default:"#000000",transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-highlight-color":{type:"color",default:"#FFFFFF",transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"hillshade-accent-color":{type:"color",default:"#000000",transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},paint_background:{"background-color":{type:"color",default:"#000000",transition:!0,requires:[{"!":"background-pattern"}],expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"},"background-pattern":{type:"resolvedImage",transition:!0,expression:{interpolated:!1,parameters:["zoom"]},"property-type":"cross-faded"},"background-opacity":{type:"number",default:1,minimum:0,maximum:1,transition:!0,expression:{interpolated:!0,parameters:["zoom"]},"property-type":"data-constant"}},transition:{duration:{type:"number",default:300,minimum:0,units:"milliseconds"},delay:{type:"number",default:0,minimum:0,units:"milliseconds"}},"property-type":{"data-driven":{type:"property-type"},"cross-faded":{type:"property-type"},"cross-faded-data-driven":{type:"property-type"},"color-ramp":{type:"property-type"},"data-constant":{type:"property-type"},constant:{type:"property-type"}},promoteId:{"*":{type:"string"}}},Ba=function(t,e,r,i){this.message=(t?t+": ":"")+r,i&&(this.identifier=i),null!=e&&e.__line__&&(this.line=e.__line__);};function Ta(t){var e=t.value;return e?[new Ba(t.key,e,"constants have been deprecated as of v8")]:[]}function Va(t){return t instanceof Number||t instanceof String||t instanceof Boolean?t.valueOf():t}function La(t){if(Array.isArray(t))return t.map(La);if(t instanceof Object&&!(t instanceof Number||t instanceof String||t instanceof Boolean)){var e={};for(var r in t)e[r]=La(t[r]);return e}return Va(t)}function Fa(t){var e=t.key,r=t.value,i=t.valueSpec||{},n=t.objectElementValidators||{},a=t.style,s=t.styleSpec,o=[],u=Wn(r);if("object"!==u)return [new Ba(e,r,"object expected, "+u+" found")];for(var h in r){var l=h.split(".")[0],p=i[l]||i["*"],c=void 0;if(n[l])c=n[l];else if(i[l])c=os;else if(n["*"])c=n["*"];else {if(!i["*"]){o.push(new Ba(e,r[h],'unknown property "'+h+'"'));continue}c=os;}o=o.concat(c({key:(e?e+".":e)+h,value:r[h],valueSpec:p,style:a,styleSpec:s,object:r,objectKey:h},r));}for(var f in i)n[f]||i[f].required&&void 0===i[f].default&&void 0===r[f]&&o.push(new Ba(e,r,'missing required property "'+f+'"'));return o}function Oa(t){var e=t.value,r=t.valueSpec,i=t.style,n=t.styleSpec,a=t.key,s=t.arrayElementValidator||os;if("array"!==Wn(e))return [new Ba(a,e,"array expected, "+Wn(e)+" found")];if(r.length&&e.length!==r.length)return [new Ba(a,e,"array length "+r.length+" expected, length "+e.length+" found")];if(r["min-length"]&&e.length<r["min-length"])return [new Ba(a,e,"array length at least "+r["min-length"]+" expected, length "+e.length+" found")];var o={type:r.value,values:r.values};n.$version<7&&(o.function=r.function),"object"===Wn(r.value)&&(o=r.value);for(var u=[],h=0;h<e.length;h++)u=u.concat(s({array:e,arrayIndex:h,value:e[h],valueSpec:o,style:i,styleSpec:n,key:a+"["+h+"]"}));return u}function Da(t){var e=t.key,r=t.value,i=t.valueSpec,n=Wn(r);return "number"===n&&r!=r&&(n="NaN"),"number"!==n?[new Ba(e,r,"number expected, "+n+" found")]:"minimum"in i&&r<i.minimum?[new Ba(e,r,r+" is less than the minimum value "+i.minimum)]:"maximum"in i&&r>i.maximum?[new Ba(e,r,r+" is greater than the maximum value "+i.maximum)]:[]}function Na(t){var e,r,i,n=t.valueSpec,a=Va(t.value.type),s={},o="categorical"!==a&&void 0===t.value.property,u=!o,h="array"===Wn(t.value.stops)&&"array"===Wn(t.value.stops[0])&&"object"===Wn(t.value.stops[0][0]),l=Fa({key:t.key,value:t.value,valueSpec:t.styleSpec.function,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{stops:function(t){if("identity"===a)return [new Ba(t.key,t.value,'identity function may not have a "stops" property')];var e=[],r=t.value;return e=e.concat(Oa({key:t.key,value:r,valueSpec:t.valueSpec,style:t.style,styleSpec:t.styleSpec,arrayElementValidator:p})),"array"===Wn(r)&&0===r.length&&e.push(new Ba(t.key,r,"array must have at least one stop")),e},default:function(t){return os({key:t.key,value:t.value,valueSpec:n,style:t.style,styleSpec:t.styleSpec})}}});return "identity"===a&&o&&l.push(new Ba(t.key,t.value,'missing required property "property"')),"identity"===a||t.value.stops||l.push(new Ba(t.key,t.value,'missing required property "stops"')),"exponential"===a&&t.valueSpec.expression&&!Yn(t.valueSpec)&&l.push(new Ba(t.key,t.value,"exponential functions not supported")),t.styleSpec.$version>=8&&(u&&!Jn(t.valueSpec)?l.push(new Ba(t.key,t.value,"property functions not supported")):o&&!Zn(t.valueSpec)&&l.push(new Ba(t.key,t.value,"zoom functions not supported"))),"categorical"!==a&&!h||void 0!==t.value.property||l.push(new Ba(t.key,t.value,'"property" property is required')),l;function p(t){var e=[],a=t.value,o=t.key;if("array"!==Wn(a))return [new Ba(o,a,"array expected, "+Wn(a)+" found")];if(2!==a.length)return [new Ba(o,a,"array length 2 expected, length "+a.length+" found")];if(h){if("object"!==Wn(a[0]))return [new Ba(o,a,"object expected, "+Wn(a[0])+" found")];if(void 0===a[0].zoom)return [new Ba(o,a,"object stop key must have zoom")];if(void 0===a[0].value)return [new Ba(o,a,"object stop key must have value")];if(i&&i>Va(a[0].zoom))return [new Ba(o,a[0].zoom,"stop zoom values must appear in ascending order")];Va(a[0].zoom)!==i&&(i=Va(a[0].zoom),r=void 0,s={}),e=e.concat(Fa({key:o+"[0]",value:a[0],valueSpec:{zoom:{}},style:t.style,styleSpec:t.styleSpec,objectElementValidators:{zoom:Da,value:c}}));}else e=e.concat(c({key:o+"[0]",value:a[0],valueSpec:{},style:t.style,styleSpec:t.styleSpec},a));return sa(La(a[1]))?e.concat([new Ba(o+"[1]",a[1],"expressions are not allowed in function stops.")]):e.concat(os({key:o+"[1]",value:a[1],valueSpec:n,style:t.style,styleSpec:t.styleSpec}))}function c(t,i){var o=Wn(t.value),u=Va(t.value),h=null!==t.value?t.value:i;if(e){if(o!==e)return [new Ba(t.key,h,o+" stop domain type must match previous stop domain type "+e)]}else e=o;if("number"!==o&&"string"!==o&&"boolean"!==o)return [new Ba(t.key,h,"stop domain value must be a number, string, or boolean")];if("number"!==o&&"categorical"!==a){var l="number expected, "+o+" found";return Jn(n)&&void 0===a&&(l+='\nIf you intended to use a categorical function, specify `"type": "categorical"`.'),[new Ba(t.key,h,l)]}return "categorical"!==a||"number"!==o||isFinite(u)&&Math.floor(u)===u?"categorical"!==a&&"number"===o&&void 0!==r&&u<r?[new Ba(t.key,h,"stop domain values must appear in ascending order")]:(r=u,"categorical"===a&&u in s?[new Ba(t.key,h,"stop domain values must be unique")]:(s[u]=!0,[])):[new Ba(t.key,h,"integer expected, found "+u)]}}function Ra(t){var e=("property"===t.expressionContext?la:oa)(La(t.value),t.valueSpec);if("error"===e.result)return e.value.map((function(e){return new Ba(""+t.key+e.key,t.value,e.message)}));var r=e.value.expression||e.value._styleExpression.expression;if("property"===t.expressionContext&&"text-font"===t.propertyKey&&!r.outputDefined())return [new Ba(t.key,t.value,'Invalid data expression for "'+t.propertyKey+'". Output values must be contained as literals within the expression.')];if("property"===t.expressionContext&&"layout"===t.propertyType&&!Qi(r))return [new Ba(t.key,t.value,'"feature-state" data expressions are not supported with layout properties.')];if("filter"===t.expressionContext&&!Qi(r))return [new Ba(t.key,t.value,'"feature-state" data expressions are not supported with filters.')];if(t.expressionContext&&0===t.expressionContext.indexOf("cluster")){if(!$i(r,["zoom","feature-state"]))return [new Ba(t.key,t.value,'"zoom" and "feature-state" expressions are not supported with cluster properties.')];if("cluster-initial"===t.expressionContext&&!Wi(r))return [new Ba(t.key,t.value,"Feature data expressions are not supported with initial expression part of cluster properties.")]}return []}function qa(t){var e=t.key,r=t.value,i=t.valueSpec,n=[];return Array.isArray(i.values)?-1===i.values.indexOf(Va(r))&&n.push(new Ba(e,r,"expected one of ["+i.values.join(", ")+"], "+JSON.stringify(r)+" found")):-1===Object.keys(i.values).indexOf(Va(r))&&n.push(new Ba(e,r,"expected one of ["+Object.keys(i.values).join(", ")+"], "+JSON.stringify(r)+" found")),n}function ja(t){if(!0===t||!1===t)return !0;if(!Array.isArray(t)||0===t.length)return !1;switch(t[0]){case"has":return t.length>=2&&"$id"!==t[1]&&"$type"!==t[1];case"in":return t.length>=3&&("string"!=typeof t[1]||Array.isArray(t[2]));case"!in":case"!has":case"none":return !1;case"==":case"!=":case">":case">=":case"<":case"<=":return 3!==t.length||Array.isArray(t[1])||Array.isArray(t[2]);case"any":case"all":for(var e=0,r=t.slice(1);e<r.length;e+=1){var i=r[e];if(!ja(i)&&"boolean"!=typeof i)return !1}return !0;default:return !0}}var Ua={type:"boolean",default:!1,transition:!1,"property-type":"data-driven",expression:{interpolated:!1,parameters:["zoom","feature"]}};function Ga(t){if(null==t)return {filter:function(){return !0},needGeometry:!1};ja(t)||(t=Xa(t));var e=oa(t,Ua);if("error"===e.result)throw new Error(e.value.map((function(t){return t.key+": "+t.message})).join(", "));return {filter:function(t,r,i){return e.value.evaluate(t,r,{},i)},needGeometry:function t(e){if(!Array.isArray(e))return !1;if("within"===e[0])return !0;for(var r=1;r<e.length;r++)if(t(e[r]))return !0;return !1}(t)}}function Ka(t,e){return t<e?-1:t>e?1:0}function Xa(t){if(!t)return !0;var e,r=t[0];return t.length<=1?"any"!==r:"=="===r?Ha(t[1],t[2],"=="):"!="===r?Ya(Ha(t[1],t[2],"==")):"<"===r||">"===r||"<="===r||">="===r?Ha(t[1],t[2],r):"any"===r?(e=t.slice(1),["any"].concat(e.map(Xa))):"all"===r?["all"].concat(t.slice(1).map(Xa)):"none"===r?["all"].concat(t.slice(1).map(Xa).map(Ya)):"in"===r?Ja(t[1],t.slice(2)):"!in"===r?Ya(Ja(t[1],t.slice(2))):"has"===r?Za(t[1]):"!has"===r?Ya(Za(t[1])):"within"!==r||t}function Ha(t,e,r){switch(t){case"$type":return ["filter-type-"+r,e];case"$id":return ["filter-id-"+r,e];default:return ["filter-"+r,t,e]}}function Ja(t,e){if(0===e.length)return !1;switch(t){case"$type":return ["filter-type-in",["literal",e]];case"$id":return ["filter-id-in",["literal",e]];default:return e.length>200&&!e.some((function(t){return typeof t!=typeof e[0]}))?["filter-in-large",t,["literal",e.sort(Ka)]]:["filter-in-small",t,["literal",e]]}}function Za(t){switch(t){case"$type":return !0;case"$id":return ["filter-has-id"];default:return ["filter-has",t]}}function Ya(t){return ["!",t]}function Wa(t){return ja(La(t.value))?Ra(Yr({},t,{expressionContext:"filter",valueSpec:{value:"boolean"}})):function t(e){var r=e.value,i=e.key;if("array"!==Wn(r))return [new Ba(i,r,"array expected, "+Wn(r)+" found")];var n,a=e.styleSpec,s=[];if(r.length<1)return [new Ba(i,r,"filter array must have at least 1 element")];switch(s=s.concat(qa({key:i+"[0]",value:r[0],valueSpec:a.filter_operator,style:e.style,styleSpec:e.styleSpec})),Va(r[0])){case"<":case"<=":case">":case">=":r.length>=2&&"$type"===Va(r[1])&&s.push(new Ba(i,r,'"$type" cannot be use with operator "'+r[0]+'"'));case"==":case"!=":3!==r.length&&s.push(new Ba(i,r,'filter array for operator "'+r[0]+'" must have 3 elements'));case"in":case"!in":r.length>=2&&"string"!==(n=Wn(r[1]))&&s.push(new Ba(i+"[1]",r[1],"string expected, "+n+" found"));for(var o=2;o<r.length;o++)n=Wn(r[o]),"$type"===Va(r[1])?s=s.concat(qa({key:i+"["+o+"]",value:r[o],valueSpec:a.geometry_type,style:e.style,styleSpec:e.styleSpec})):"string"!==n&&"number"!==n&&"boolean"!==n&&s.push(new Ba(i+"["+o+"]",r[o],"string, number, or boolean expected, "+n+" found"));break;case"any":case"all":case"none":for(var u=1;u<r.length;u++)s=s.concat(t({key:i+"["+u+"]",value:r[u],style:e.style,styleSpec:e.styleSpec}));break;case"has":case"!has":n=Wn(r[1]),2!==r.length?s.push(new Ba(i,r,'filter array for "'+r[0]+'" operator must have 2 elements')):"string"!==n&&s.push(new Ba(i+"[1]",r[1],"string expected, "+n+" found"));break;case"within":n=Wn(r[1]),2!==r.length?s.push(new Ba(i,r,'filter array for "'+r[0]+'" operator must have 2 elements')):"object"!==n&&s.push(new Ba(i+"[1]",r[1],"object expected, "+n+" found"));}return s}(t)}function Qa(t,e){var r=t.key,i=t.style,n=t.styleSpec,a=t.value,s=t.objectKey,o=n[e+"_"+t.layerType];if(!o)return [];var u=s.match(/^(.*)-transition$/);if("paint"===e&&u&&o[u[1]]&&o[u[1]].transition)return os({key:r,value:a,valueSpec:n.transition,style:i,styleSpec:n});var h,l=t.valueSpec||o[s];return l?"string"===Wn(a)&&Jn(l)&&!l.tokens&&(h=/^{([^}]+)}$/.exec(a))?[new Ba(r,a,'"'+s+'" does not support interpolation syntax\nUse an identity property function instead: `{ "type": "identity", "property": '+JSON.stringify(h[1])+" }`.")]:[].concat(os({key:t.key,value:a,valueSpec:l,style:i,styleSpec:n,expressionContext:"property",propertyType:e,propertyKey:s})):[new Ba(r,a,'unknown property "'+s+'"')]}function $a(t){return Qa(t,"paint")}function ts(t){return Qa(t,"layout")}function es(t){var e=[],r=t.value,i=t.key,n=t.style,a=t.styleSpec;r.type||r.ref||e.push(new Ba(i,r,'either "type" or "ref" is required'));var s,o=Va(r.type),u=Va(r.ref);if(r.id)for(var h=Va(r.id),l=0;l<t.arrayIndex;l++){var p=n.layers[l];Va(p.id)===h&&e.push(new Ba(i,r.id,'duplicate layer id "'+r.id+'", previously used at line '+p.id.__line__));}if("ref"in r)["type","source","source-layer","filter","layout"].forEach((function(t){t in r&&e.push(new Ba(i,r[t],'"'+t+'" is prohibited for ref layers'));})),n.layers.forEach((function(t){Va(t.id)===u&&(s=t);})),s?s.ref?e.push(new Ba(i,r.ref,"ref cannot reference another ref layer")):o=Va(s.type):e.push(new Ba(i,r.ref,'ref layer "'+u+'" not found'));else if("background"!==o)if(r.source){var c=n.sources&&n.sources[r.source],f=c&&Va(c.type);c?"vector"===f&&"raster"===o?e.push(new Ba(i,r.source,'layer "'+r.id+'" requires a raster source')):"raster"===f&&"raster"!==o?e.push(new Ba(i,r.source,'layer "'+r.id+'" requires a vector source')):"vector"!==f||r["source-layer"]?"raster-dem"===f&&"hillshade"!==o?e.push(new Ba(i,r.source,"raster-dem source can only be used with layer type 'hillshade'.")):"line"!==o||!r.paint||!r.paint["line-gradient"]||"geojson"===f&&c.lineMetrics||e.push(new Ba(i,r,'layer "'+r.id+'" specifies a line-gradient, which requires a GeoJSON source with `lineMetrics` enabled.')):e.push(new Ba(i,r,'layer "'+r.id+'" must specify a "source-layer"')):e.push(new Ba(i,r.source,'source "'+r.source+'" not found'));}else e.push(new Ba(i,r,'missing required property "source"'));return e=e.concat(Fa({key:i,value:r,valueSpec:a.layer,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{"*":function(){return []},type:function(){return os({key:i+".type",value:r.type,valueSpec:a.layer.type,style:t.style,styleSpec:t.styleSpec,object:r,objectKey:"type"})},filter:Wa,layout:function(t){return Fa({layer:r,key:t.key,value:t.value,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{"*":function(t){return ts(Yr({layerType:o},t))}}})},paint:function(t){return Fa({layer:r,key:t.key,value:t.value,style:t.style,styleSpec:t.styleSpec,objectElementValidators:{"*":function(t){return $a(Yr({layerType:o},t))}}})}}}))}function rs(t){var e=t.value,r=t.key,i=Wn(e);return "string"!==i?[new Ba(r,e,"string expected, "+i+" found")]:[]}var is={promoteId:function(t){var e=t.key,r=t.value;if("string"===Wn(r))return rs({key:e,value:r});var i=[];for(var n in r)i.push.apply(i,rs({key:e+"."+n,value:r[n]}));return i}};function ns(t){var e=t.value,r=t.key,i=t.styleSpec,n=t.style;if(!e.type)return [new Ba(r,e,'"type" is required')];var a,s=Va(e.type);switch(s){case"vector":case"raster":case"raster-dem":return Fa({key:r,value:e,valueSpec:i["source_"+s.replace("-","_")],style:t.style,styleSpec:i,objectElementValidators:is});case"geojson":if(a=Fa({key:r,value:e,valueSpec:i.source_geojson,style:n,styleSpec:i,objectElementValidators:is}),e.cluster)for(var o in e.clusterProperties){var u=e.clusterProperties[o],h=u[0],l="string"==typeof h?[h,["accumulated"],["get",o]]:h;a.push.apply(a,Ra({key:r+"."+o+".map",value:u[1],expressionContext:"cluster-map"})),a.push.apply(a,Ra({key:r+"."+o+".reduce",value:l,expressionContext:"cluster-reduce"}));}return a;case"video":return Fa({key:r,value:e,valueSpec:i.source_video,style:n,styleSpec:i});case"image":return Fa({key:r,value:e,valueSpec:i.source_image,style:n,styleSpec:i});case"canvas":return [new Ba(r,null,"Please use runtime APIs to add canvas sources, rather than including them in stylesheets.","source.canvas")];default:return qa({key:r+".type",value:e.type,valueSpec:{values:["vector","raster","raster-dem","geojson","video","image"]},style:n,styleSpec:i})}}function as(t){var e=t.value,r=t.styleSpec,i=r.light,n=t.style,a=[],s=Wn(e);if(void 0===e)return a;if("object"!==s)return a.concat([new Ba("light",e,"object expected, "+s+" found")]);for(var o in e){var u=o.match(/^(.*)-transition$/);a=a.concat(u&&i[u[1]]&&i[u[1]].transition?os({key:o,value:e[o],valueSpec:r.transition,style:n,styleSpec:r}):i[o]?os({key:o,value:e[o],valueSpec:i[o],style:n,styleSpec:r}):[new Ba(o,e[o],'unknown property "'+o+'"')]);}return a}var ss={"*":function(){return []},array:Oa,boolean:function(t){var e=t.value,r=t.key,i=Wn(e);return "boolean"!==i?[new Ba(r,e,"boolean expected, "+i+" found")]:[]},number:Da,color:function(t){var e=t.key,r=t.value,i=Wn(r);return "string"!==i?[new Ba(e,r,"color expected, "+i+" found")]:null===Jr(r)?[new Ba(e,r,'color expected, "'+r+'" found')]:[]},constants:Ta,enum:qa,filter:Wa,function:Na,layer:es,object:Fa,source:ns,light:as,string:rs,formatted:function(t){return 0===rs(t).length?[]:Ra(t)},resolvedImage:function(t){return 0===rs(t).length?[]:Ra(t)},stringobject:function(t){var e=t.value,r=t.key,i=Wn(e);if("string"==i)return [];if("object"==i){var n=[];for(var a in e){var s=Wn(e[a]);"string"!==s&&n.push(new Ba(a,e[a],"string expected, "+s+" found"));}return n}return [new Ba(r,e,"string expected, "+i+" found")]}};function os(t){var e=t.value,r=t.valueSpec,i=t.styleSpec;return r.expression&&Qn(Va(e))?Na(t):r.expression&&sa(La(e))?Ra(t):r.type&&ss[r.type]?ss[r.type](t):Fa(Yr({},t,{valueSpec:r.type?i[r.type]:r}))}function us(t,e){void 0===e&&(e=Pa);var r=[];return r=r.concat(os({key:"",value:t,valueSpec:e.$root,styleSpec:e,style:t,objectElementValidators:{"*":function(){return []}}})),t.constants&&(r=r.concat(Ta({key:"constants",value:t.constants,style:t,styleSpec:e}))),hs(r)}function hs(t){return [].concat(t).sort((function(t,e){return t.line-e.line}))}function ls(t){return function(){for(var e=[],r=arguments.length;r--;)e[r]=arguments[r];return hs(t.apply(this,e))}}us.source=ls(ns),us.light=ls(as),us.layer=ls(es),us.filter=ls(Wa),us.paintProperty=ls($a),us.layoutProperty=ls(ts);var ps=us,cs=ps.light,fs=ps.paintProperty,ys=ps.layoutProperty;function ds(t,e){var r=!1;if(e&&e.length)for(var i=0,n=e;i<n.length;i+=1)t.fire(new Ca(new Error(n[i].message))),r=!0;return r}var ms=function(){this.first=!0;};ms.prototype.update=function(t,e){var r=Math.floor(t);return this.first?(this.first=!1,this.lastIntegerZoom=r,this.lastIntegerZoomTime=0,this.lastZoom=t,this.lastFloorZoom=r,!0):(this.lastFloorZoom>r?(this.lastIntegerZoom=r+1,this.lastIntegerZoomTime=e):this.lastFloorZoom<r&&(this.lastIntegerZoom=r,this.lastIntegerZoomTime=e),t!==this.lastZoom&&(this.lastZoom=t,this.lastFloorZoom=r,!0))};var vs={"Latin-1 Supplement":function(t){return t>=128&&t<=255},Arabic:function(t){return t>=1536&&t<=1791},"Arabic Supplement":function(t){return t>=1872&&t<=1919},"Arabic Extended-A":function(t){return t>=2208&&t<=2303},"Hangul Jamo":function(t){return t>=4352&&t<=4607},"Unified Canadian Aboriginal Syllabics":function(t){return t>=5120&&t<=5759},Khmer:function(t){return t>=6016&&t<=6143},"Unified Canadian Aboriginal Syllabics Extended":function(t){return t>=6320&&t<=6399},"General Punctuation":function(t){return t>=8192&&t<=8303},"Letterlike Symbols":function(t){return t>=8448&&t<=8527},"Number Forms":function(t){return t>=8528&&t<=8591},"Miscellaneous Technical":function(t){return t>=8960&&t<=9215},"Control Pictures":function(t){return t>=9216&&t<=9279},"Optical Character Recognition":function(t){return t>=9280&&t<=9311},"Enclosed Alphanumerics":function(t){return t>=9312&&t<=9471},"Geometric Shapes":function(t){return t>=9632&&t<=9727},"Miscellaneous Symbols":function(t){return t>=9728&&t<=9983},"Miscellaneous Symbols and Arrows":function(t){return t>=11008&&t<=11263},"CJK Radicals Supplement":function(t){return t>=11904&&t<=12031},"Kangxi Radicals":function(t){return t>=12032&&t<=12255},"Ideographic Description Characters":function(t){return t>=12272&&t<=12287},"CJK Symbols and Punctuation":function(t){return t>=12288&&t<=12351},Hiragana:function(t){return t>=12352&&t<=12447},Katakana:function(t){return t>=12448&&t<=12543},Bopomofo:function(t){return t>=12544&&t<=12591},"Hangul Compatibility Jamo":function(t){return t>=12592&&t<=12687},Kanbun:function(t){return t>=12688&&t<=12703},"Bopomofo Extended":function(t){return t>=12704&&t<=12735},"CJK Strokes":function(t){return t>=12736&&t<=12783},"Katakana Phonetic Extensions":function(t){return t>=12784&&t<=12799},"Enclosed CJK Letters and Months":function(t){return t>=12800&&t<=13055},"CJK Compatibility":function(t){return t>=13056&&t<=13311},"CJK Unified Ideographs Extension A":function(t){return t>=13312&&t<=19903},"Yijing Hexagram Symbols":function(t){return t>=19904&&t<=19967},"CJK Unified Ideographs":function(t){return t>=19968&&t<=40959},"Yi Syllables":function(t){return t>=40960&&t<=42127},"Yi Radicals":function(t){return t>=42128&&t<=42191},"Hangul Jamo Extended-A":function(t){return t>=43360&&t<=43391},"Hangul Syllables":function(t){return t>=44032&&t<=55215},"Hangul Jamo Extended-B":function(t){return t>=55216&&t<=55295},"Private Use Area":function(t){return t>=57344&&t<=63743},"CJK Compatibility Ideographs":function(t){return t>=63744&&t<=64255},"Arabic Presentation Forms-A":function(t){return t>=64336&&t<=65023},"Vertical Forms":function(t){return t>=65040&&t<=65055},"CJK Compatibility Forms":function(t){return t>=65072&&t<=65103},"Small Form Variants":function(t){return t>=65104&&t<=65135},"Arabic Presentation Forms-B":function(t){return t>=65136&&t<=65279},"Halfwidth and Fullwidth Forms":function(t){return t>=65280&&t<=65519}};function gs(t){for(var e=0,r=t;e<r.length;e+=1)if(xs(r[e].charCodeAt(0)))return !0;return !1}function xs(t){return !(746!==t&&747!==t&&(t<4352||!(vs["Bopomofo Extended"](t)||vs.Bopomofo(t)||vs["CJK Compatibility Forms"](t)&&!(t>=65097&&t<=65103)||vs["CJK Compatibility Ideographs"](t)||vs["CJK Compatibility"](t)||vs["CJK Radicals Supplement"](t)||vs["CJK Strokes"](t)||!(!vs["CJK Symbols and Punctuation"](t)||t>=12296&&t<=12305||t>=12308&&t<=12319||12336===t)||vs["CJK Unified Ideographs Extension A"](t)||vs["CJK Unified Ideographs"](t)||vs["Enclosed CJK Letters and Months"](t)||vs["Hangul Compatibility Jamo"](t)||vs["Hangul Jamo Extended-A"](t)||vs["Hangul Jamo Extended-B"](t)||vs["Hangul Jamo"](t)||vs["Hangul Syllables"](t)||vs.Hiragana(t)||vs["Ideographic Description Characters"](t)||vs.Kanbun(t)||vs["Kangxi Radicals"](t)||vs["Katakana Phonetic Extensions"](t)||vs.Katakana(t)&&12540!==t||!(!vs["Halfwidth and Fullwidth Forms"](t)||65288===t||65289===t||65293===t||t>=65306&&t<=65310||65339===t||65341===t||65343===t||t>=65371&&t<=65503||65507===t||t>=65512&&t<=65519)||!(!vs["Small Form Variants"](t)||t>=65112&&t<=65118||t>=65123&&t<=65126)||vs["Unified Canadian Aboriginal Syllabics"](t)||vs["Unified Canadian Aboriginal Syllabics Extended"](t)||vs["Vertical Forms"](t)||vs["Yijing Hexagram Symbols"](t)||vs["Yi Syllables"](t)||vs["Yi Radicals"](t))))}function bs(t){return !(xs(t)||function(t){return !!(vs["Latin-1 Supplement"](t)&&(167===t||169===t||174===t||177===t||188===t||189===t||190===t||215===t||247===t)||vs["General Punctuation"](t)&&(8214===t||8224===t||8225===t||8240===t||8241===t||8251===t||8252===t||8258===t||8263===t||8264===t||8265===t||8273===t)||vs["Letterlike Symbols"](t)||vs["Number Forms"](t)||vs["Miscellaneous Technical"](t)&&(t>=8960&&t<=8967||t>=8972&&t<=8991||t>=8996&&t<=9e3||9003===t||t>=9085&&t<=9114||t>=9150&&t<=9165||9167===t||t>=9169&&t<=9179||t>=9186&&t<=9215)||vs["Control Pictures"](t)&&9251!==t||vs["Optical Character Recognition"](t)||vs["Enclosed Alphanumerics"](t)||vs["Geometric Shapes"](t)||vs["Miscellaneous Symbols"](t)&&!(t>=9754&&t<=9759)||vs["Miscellaneous Symbols and Arrows"](t)&&(t>=11026&&t<=11055||t>=11088&&t<=11097||t>=11192&&t<=11243)||vs["CJK Symbols and Punctuation"](t)||vs.Katakana(t)||vs["Private Use Area"](t)||vs["CJK Compatibility Forms"](t)||vs["Small Form Variants"](t)||vs["Halfwidth and Fullwidth Forms"](t)||8734===t||8756===t||8757===t||t>=9984&&t<=10087||t>=10102&&t<=10131||65532===t||65533===t)}(t))}function _s(t){return t>=1424&&t<=2303||vs["Arabic Presentation Forms-A"](t)||vs["Arabic Presentation Forms-B"](t)}function ws(t,e){return !(!e&&_s(t)||t>=2304&&t<=3583||t>=3840&&t<=4255||vs.Khmer(t))}function Ms(t){for(var e=0,r=t;e<r.length;e+=1)if(_s(r[e].charCodeAt(0)))return !0;return !1}var Ss=null,As="unavailable",ks=null,Is=function(t){t&&"string"==typeof t&&t.indexOf("NetworkError")>-1&&(As="error"),Ss&&Ss(t);};function zs(){Cs.fire(new za("pluginStateChange",{pluginStatus:As,pluginURL:ks}));}var Cs=new Ea,Es=function(){return As},Ps=function(){if("deferred"!==As||!ks)throw new Error("rtl-text-plugin cannot be downloaded unless a pluginURL is specified");As="loading",zs(),ks&&Ur({url:ks},(function(t){t?Is(t):(As="loaded",zs());}));},Bs={applyArabicShaping:null,processBidirectionalText:null,processStyledBidirectionalText:null,isLoaded:function(){return "loaded"===As||null!=Bs.applyArabicShaping},isLoading:function(){return "loading"===As},setState:function(t){As=t.pluginStatus,ks=t.pluginURL;},isParsed:function(){return null!=Bs.applyArabicShaping&&null!=Bs.processBidirectionalText&&null!=Bs.processStyledBidirectionalText},getPluginURL:function(){return ks}},Ts=function(t,e){this.zoom=t,e?(this.now=e.now,this.fadeDuration=e.fadeDuration,this.zoomHistory=e.zoomHistory,this.transition=e.transition):(this.now=0,this.fadeDuration=0,this.zoomHistory=new ms,this.transition={});};Ts.prototype.isSupportedScript=function(t){return function(t,e){for(var r=0,i=t;r<i.length;r+=1)if(!ws(i[r].charCodeAt(0),e))return !1;return !0}(t,Bs.isLoaded())},Ts.prototype.crossFadingFactor=function(){return 0===this.fadeDuration?1:Math.min((this.now-this.zoomHistory.lastIntegerZoomTime)/this.fadeDuration,1)},Ts.prototype.getCrossfadeParameters=function(){var t=this.zoom,e=t-Math.floor(t),r=this.crossFadingFactor();return t>this.zoomHistory.lastIntegerZoom?{fromScale:2,toScale:1,t:e+(1-e)*r}:{fromScale:.5,toScale:1,t:1-(1-r)*e}};var Vs=function(t,e){this.property=t,this.value=e,this.expression=function(t,e){if(Qn(t))return new pa(t,e);if(sa(t)){var r=la(t,e);if("error"===r.result)throw new Error(r.value.map((function(t){return t.key+": "+t.message})).join(", "));return r.value}var i=t;return "string"==typeof t&&"color"===e.type&&(i=Zr.parse(t)),{kind:"constant",evaluate:function(){return i}}}(void 0===e?t.specification.default:e,t.specification);};Vs.prototype.isDataDriven=function(){return "source"===this.expression.kind||"composite"===this.expression.kind},Vs.prototype.possiblyEvaluate=function(t,e,r){return this.property.possiblyEvaluate(this,t,e,r)};var Ls=function(t){this.property=t,this.value=new Vs(t,void 0);};Ls.prototype.transitioned=function(t,e){return new Os(this.property,this.value,e,c({},t.transition,this.transition),t.now)},Ls.prototype.untransitioned=function(){return new Os(this.property,this.value,null,{},0)};var Fs=function(t){this._properties=t,this._values=Object.create(t.defaultTransitionablePropertyValues);};Fs.prototype.getValue=function(t){return _(this._values[t].value.value)},Fs.prototype.setValue=function(t,e){this._values.hasOwnProperty(t)||(this._values[t]=new Ls(this._values[t].property)),this._values[t].value=new Vs(this._values[t].property,null===e?void 0:_(e));},Fs.prototype.getTransition=function(t){return _(this._values[t].transition)},Fs.prototype.setTransition=function(t,e){this._values.hasOwnProperty(t)||(this._values[t]=new Ls(this._values[t].property)),this._values[t].transition=_(e)||void 0;},Fs.prototype.serialize=function(){for(var t={},e=0,r=Object.keys(this._values);e<r.length;e+=1){var i=r[e],n=this.getValue(i);void 0!==n&&(t[i]=n);var a=this.getTransition(i);void 0!==a&&(t[i+"-transition"]=a);}return t},Fs.prototype.transitioned=function(t,e){for(var r=new Ds(this._properties),i=0,n=Object.keys(this._values);i<n.length;i+=1){var a=n[i];r._values[a]=this._values[a].transitioned(t,e._values[a]);}return r},Fs.prototype.untransitioned=function(){for(var t=new Ds(this._properties),e=0,r=Object.keys(this._values);e<r.length;e+=1){var i=r[e];t._values[i]=this._values[i].untransitioned();}return t};var Os=function(t,e,r,i,n){this.property=t,this.value=e,this.begin=n+i.delay||0,this.end=this.begin+i.duration||0,t.specification.transition&&(i.delay||i.duration)&&(this.prior=r);};Os.prototype.possiblyEvaluate=function(t,e,r){var i=t.now||0,n=this.value.possiblyEvaluate(t,e,r),a=this.prior;if(a){if(i>this.end)return this.prior=null,n;if(this.value.isDataDriven())return this.prior=null,n;if(i<this.begin)return a.possiblyEvaluate(t,e,r);var s=(i-this.begin)/(this.end-this.begin);return this.property.interpolate(a.possiblyEvaluate(t,e,r),n,function(t){if(t<=0)return 0;if(t>=1)return 1;var e=t*t,r=e*t;return 4*(t<.5?r:3*(t-e)+r-.75)}(s))}return n};var Ds=function(t){this._properties=t,this._values=Object.create(t.defaultTransitioningPropertyValues);};Ds.prototype.possiblyEvaluate=function(t,e,r){for(var i=new qs(this._properties),n=0,a=Object.keys(this._values);n<a.length;n+=1){var s=a[n];i._values[s]=this._values[s].possiblyEvaluate(t,e,r);}return i},Ds.prototype.hasTransition=function(){for(var t=0,e=Object.keys(this._values);t<e.length;t+=1)if(this._values[e[t]].prior)return !0;return !1};var Ns=function(t){this._properties=t,this._values=Object.create(t.defaultPropertyValues);};Ns.prototype.getValue=function(t){return _(this._values[t].value)},Ns.prototype.setValue=function(t,e){this._values[t]=new Vs(this._values[t].property,null===e?void 0:_(e));},Ns.prototype.serialize=function(){for(var t={},e=0,r=Object.keys(this._values);e<r.length;e+=1){var i=r[e],n=this.getValue(i);void 0!==n&&(t[i]=n);}return t},Ns.prototype.possiblyEvaluate=function(t,e,r){for(var i=new qs(this._properties),n=0,a=Object.keys(this._values);n<a.length;n+=1){var s=a[n];i._values[s]=this._values[s].possiblyEvaluate(t,e,r);}return i};var Rs=function(t,e,r){this.property=t,this.value=e,this.parameters=r;};Rs.prototype.isConstant=function(){return "constant"===this.value.kind},Rs.prototype.constantOr=function(t){return "constant"===this.value.kind?this.value.value:t},Rs.prototype.evaluate=function(t,e,r,i){return this.property.evaluate(this.value,this.parameters,t,e,r,i)};var qs=function(t){this._properties=t,this._values=Object.create(t.defaultPossiblyEvaluatedValues);};qs.prototype.get=function(t){return this._values[t]};var js=function(t){this.specification=t;};js.prototype.possiblyEvaluate=function(t,e){return t.expression.evaluate(e)},js.prototype.interpolate=function(t,e,r){var i=sn[this.specification.type];return i?i(t,e,r):t};var Us=function(t,e){this.specification=t,this.overrides=e;};Us.prototype.possiblyEvaluate=function(t,e,r,i){return new Rs(this,"constant"===t.expression.kind||"camera"===t.expression.kind?{kind:"constant",value:t.expression.evaluate(e,null,{},r,i)}:t.expression,e)},Us.prototype.interpolate=function(t,e,r){if("constant"!==t.value.kind||"constant"!==e.value.kind)return t;if(void 0===t.value.value||void 0===e.value.value)return new Rs(this,{kind:"constant",value:void 0},t.parameters);var i=sn[this.specification.type];return i?new Rs(this,{kind:"constant",value:i(t.value.value,e.value.value,r)},t.parameters):t},Us.prototype.evaluate=function(t,e,r,i,n,a){return "constant"===t.kind?t.value:t.evaluate(e,r,i,n,a)};var Gs=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.possiblyEvaluate=function(t,e,r,i){if(void 0===t.value)return new Rs(this,{kind:"constant",value:void 0},e);if("constant"===t.expression.kind){var n=t.expression.evaluate(e,null,{},r,i),a="resolvedImage"===t.property.specification.type&&"string"!=typeof n?n.name:n,s=this._calculate(a,a,a,e);return new Rs(this,{kind:"constant",value:s},e)}if("camera"===t.expression.kind){var o=this._calculate(t.expression.evaluate({zoom:e.zoom-1}),t.expression.evaluate({zoom:e.zoom}),t.expression.evaluate({zoom:e.zoom+1}),e);return new Rs(this,{kind:"constant",value:o},e)}return new Rs(this,t.expression,e)},e.prototype.evaluate=function(t,e,r,i,n,a){if("source"===t.kind){var s=t.evaluate(e,r,i,n,a);return this._calculate(s,s,s,e)}return "composite"===t.kind?this._calculate(t.evaluate({zoom:Math.floor(e.zoom)-1},r,i),t.evaluate({zoom:Math.floor(e.zoom)},r,i),t.evaluate({zoom:Math.floor(e.zoom)+1},r,i),e):t.value},e.prototype._calculate=function(t,e,r,i){return i.zoom>i.zoomHistory.lastIntegerZoom?{from:t,to:e}:{from:r,to:e}},e.prototype.interpolate=function(t){return t},e}(Us),Ks=function(t){this.specification=t;};Ks.prototype.possiblyEvaluate=function(t,e,r,i){if(void 0!==t.value){if("constant"===t.expression.kind){var n=t.expression.evaluate(e,null,{},r,i);return this._calculate(n,n,n,e)}return this._calculate(t.expression.evaluate(new Ts(Math.floor(e.zoom-1),e)),t.expression.evaluate(new Ts(Math.floor(e.zoom),e)),t.expression.evaluate(new Ts(Math.floor(e.zoom+1),e)),e)}},Ks.prototype._calculate=function(t,e,r,i){return i.zoom>i.zoomHistory.lastIntegerZoom?{from:t,to:e}:{from:r,to:e}},Ks.prototype.interpolate=function(t){return t};var Xs=function(t){this.specification=t;};Xs.prototype.possiblyEvaluate=function(t,e,r,i){return !!t.expression.evaluate(e,null,{},r,i)},Xs.prototype.interpolate=function(){return !1};var Hs=function(t){for(var e in this.properties=t,this.defaultPropertyValues={},this.defaultTransitionablePropertyValues={},this.defaultTransitioningPropertyValues={},this.defaultPossiblyEvaluatedValues={},this.overridableProperties=[],t){var r=t[e];r.specification.overridable&&this.overridableProperties.push(e);var i=this.defaultPropertyValues[e]=new Vs(r,void 0),n=this.defaultTransitionablePropertyValues[e]=new Ls(r);this.defaultTransitioningPropertyValues[e]=n.untransitioned(),this.defaultPossiblyEvaluatedValues[e]=i.possiblyEvaluate({});}};da("DataDrivenProperty",Us),da("DataConstantProperty",js),da("CrossFadedDataDrivenProperty",Gs),da("CrossFadedProperty",Ks),da("ColorRampProperty",Xs);var Js=function(t){function e(e,r){if(t.call(this),this.id=e.id,this.type=e.type,this._featureFilter={filter:function(){return !0},needGeometry:!1},"custom"!==e.type&&(this.metadata=(e=e).metadata,this.minzoom=e.minzoom,this.maxzoom=e.maxzoom,"background"!==e.type&&(this.source=e.source,this.sourceLayer=e["source-layer"],this.filter=e.filter),r.layout&&(this._unevaluatedLayout=new Ns(r.layout)),r.paint)){for(var i in this._transitionablePaint=new Fs(r.paint),e.paint)this.setPaintProperty(i,e.paint[i],{validate:!1});for(var n in e.layout)this.setLayoutProperty(n,e.layout[n],{validate:!1});this._transitioningPaint=this._transitionablePaint.untransitioned(),this.paint=new qs(r.paint);}}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getCrossfadeParameters=function(){return this._crossfadeParameters},e.prototype.getLayoutProperty=function(t){return "visibility"===t?this.visibility:this._unevaluatedLayout.getValue(t)},e.prototype.setLayoutProperty=function(t,e,r){void 0===r&&(r={}),null!=e&&this._validate(ys,"layers."+this.id+".layout."+t,t,e,r)||("visibility"!==t?this._unevaluatedLayout.setValue(t,e):this.visibility=e);},e.prototype.getPaintProperty=function(t){return g(t,"-transition")?this._transitionablePaint.getTransition(t.slice(0,-"-transition".length)):this._transitionablePaint.getValue(t)},e.prototype.setPaintProperty=function(t,e,r){if(void 0===r&&(r={}),null!=e&&this._validate(fs,"layers."+this.id+".paint."+t,t,e,r))return !1;if(g(t,"-transition"))return this._transitionablePaint.setTransition(t.slice(0,-"-transition".length),e||void 0),!1;var i=this._transitionablePaint._values[t],n="cross-faded-data-driven"===i.property.specification["property-type"],a=i.value.isDataDriven(),s=i.value;this._transitionablePaint.setValue(t,e),this._handleSpecialPaintPropertyUpdate(t);var o=this._transitionablePaint._values[t].value;return o.isDataDriven()||a||n||this._handleOverridablePaintPropertyUpdate(t,s,o)},e.prototype._handleSpecialPaintPropertyUpdate=function(t){},e.prototype._handleOverridablePaintPropertyUpdate=function(t,e,r){return !1},e.prototype.isHidden=function(t){return !!(this.minzoom&&t<this.minzoom)||!!(this.maxzoom&&t>=this.maxzoom)||"none"===this.visibility},e.prototype.updateTransitions=function(t){this._transitioningPaint=this._transitionablePaint.transitioned(t,this._transitioningPaint);},e.prototype.hasTransition=function(){return this._transitioningPaint.hasTransition()},e.prototype.recalculate=function(t,e){t.getCrossfadeParameters&&(this._crossfadeParameters=t.getCrossfadeParameters()),this._unevaluatedLayout&&(this.layout=this._unevaluatedLayout.possiblyEvaluate(t,void 0,e)),this.paint=this._transitioningPaint.possiblyEvaluate(t,void 0,e);},e.prototype.serialize=function(){var t={id:this.id,type:this.type,source:this.source,"source-layer":this.sourceLayer,metadata:this.metadata,minzoom:this.minzoom,maxzoom:this.maxzoom,filter:this.filter,layout:this._unevaluatedLayout&&this._unevaluatedLayout.serialize(),paint:this._transitionablePaint&&this._transitionablePaint.serialize()};return this.visibility&&(t.layout=t.layout||{},t.layout.visibility=this.visibility),b(t,(function(t,e){return !(void 0===t||"layout"===e&&!Object.keys(t).length||"paint"===e&&!Object.keys(t).length)}))},e.prototype._validate=function(t,e,r,i,n){return void 0===n&&(n={}),(!n||!1!==n.validate)&&ds(this,t.call(ps,{key:e,layerType:this.type,objectKey:r,value:i,styleSpec:Pa,style:{glyphs:!0,sprite:!0}}))},e.prototype.is3D=function(){return !1},e.prototype.isTileClipped=function(){return !1},e.prototype.hasOffscreenPass=function(){return !1},e.prototype.resize=function(){},e.prototype.isStateDependent=function(){for(var t in this.paint._values){var e=this.paint.get(t);if(e instanceof Rs&&Jn(e.property.specification)&&("source"===e.value.kind||"composite"===e.value.kind)&&e.value.isStateDependent)return !0}return !1},e}(Ea),Zs={Int8:Int8Array,Uint8:Uint8Array,Int16:Int16Array,Uint16:Uint16Array,Int32:Int32Array,Uint32:Uint32Array,Float32:Float32Array},Ys=function(t,e){this._structArray=t,this._pos1=e*this.size,this._pos2=this._pos1/2,this._pos4=this._pos1/4,this._pos8=this._pos1/8;},Ws=function(){this.isTransferred=!1,this.capacity=-1,this.resize(0);};function Qs(t,e){void 0===e&&(e=1);var r=0,i=0;return {members:t.map((function(t){var n=Zs[t.type].BYTES_PER_ELEMENT,a=r=$s(r,Math.max(e,n)),s=t.components||1;return i=Math.max(i,n),r+=n*s,{name:t.name,type:t.type,components:s,offset:a}})),size:$s(r,Math.max(i,e)),alignment:e}}function $s(t,e){return Math.ceil(t/e)*e}Ws.serialize=function(t,e){return t._trim(),e&&(t.isTransferred=!0,e.push(t.arrayBuffer)),{length:t.length,arrayBuffer:t.arrayBuffer}},Ws.deserialize=function(t){var e=Object.create(this.prototype);return e.arrayBuffer=t.arrayBuffer,e.length=t.length,e.capacity=t.arrayBuffer.byteLength/e.bytesPerElement,e._refreshViews(),e},Ws.prototype._trim=function(){this.length!==this.capacity&&(this.capacity=this.length,this.arrayBuffer=this.arrayBuffer.slice(0,this.length*this.bytesPerElement),this._refreshViews());},Ws.prototype.clear=function(){this.length=0;},Ws.prototype.resize=function(t){this.reserve(t),this.length=t;},Ws.prototype.reserve=function(t){if(t>this.capacity){this.capacity=Math.max(t,Math.floor(5*this.capacity),128),this.arrayBuffer=new ArrayBuffer(this.capacity*this.bytesPerElement);var e=this.uint8;this._refreshViews(),e&&this.uint8.set(e);}},Ws.prototype._refreshViews=function(){throw new Error("_refreshViews() must be implemented by each concrete StructArray layout")};var to=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e){var r=this.length;return this.resize(r+1),this.emplace(r,t,e)},e.prototype.emplace=function(t,e,r){var i=2*t;return this.int16[i+0]=e,this.int16[i+1]=r,t},e}(Ws);to.prototype.bytesPerElement=4,da("StructArrayLayout2i4",to);var eo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i){var n=this.length;return this.resize(n+1),this.emplace(n,t,e,r,i)},e.prototype.emplace=function(t,e,r,i,n){var a=4*t;return this.int16[a+0]=e,this.int16[a+1]=r,this.int16[a+2]=i,this.int16[a+3]=n,t},e}(Ws);eo.prototype.bytesPerElement=8,da("StructArrayLayout4i8",eo);var ro=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i,n,a){var s=this.length;return this.resize(s+1),this.emplace(s,t,e,r,i,n,a)},e.prototype.emplace=function(t,e,r,i,n,a,s){var o=6*t;return this.int16[o+0]=e,this.int16[o+1]=r,this.int16[o+2]=i,this.int16[o+3]=n,this.int16[o+4]=a,this.int16[o+5]=s,t},e}(Ws);ro.prototype.bytesPerElement=12,da("StructArrayLayout2i4i12",ro);var io=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i,n,a){var s=this.length;return this.resize(s+1),this.emplace(s,t,e,r,i,n,a)},e.prototype.emplace=function(t,e,r,i,n,a,s){var o=4*t,u=8*t;return this.int16[o+0]=e,this.int16[o+1]=r,this.uint8[u+4]=i,this.uint8[u+5]=n,this.uint8[u+6]=a,this.uint8[u+7]=s,t},e}(Ws);io.prototype.bytesPerElement=8,da("StructArrayLayout2i4ub8",io);var no=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e){var r=this.length;return this.resize(r+1),this.emplace(r,t,e)},e.prototype.emplace=function(t,e,r){var i=2*t;return this.float32[i+0]=e,this.float32[i+1]=r,t},e}(Ws);no.prototype.bytesPerElement=8,da("StructArrayLayout2f8",no);var ao=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i,n,a,s,o,u,h){var l=this.length;return this.resize(l+1),this.emplace(l,t,e,r,i,n,a,s,o,u,h)},e.prototype.emplace=function(t,e,r,i,n,a,s,o,u,h,l){var p=10*t;return this.uint16[p+0]=e,this.uint16[p+1]=r,this.uint16[p+2]=i,this.uint16[p+3]=n,this.uint16[p+4]=a,this.uint16[p+5]=s,this.uint16[p+6]=o,this.uint16[p+7]=u,this.uint16[p+8]=h,this.uint16[p+9]=l,t},e}(Ws);ao.prototype.bytesPerElement=20,da("StructArrayLayout10ui20",ao);var so=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i,n,a,s,o,u,h,l,p){var c=this.length;return this.resize(c+1),this.emplace(c,t,e,r,i,n,a,s,o,u,h,l,p)},e.prototype.emplace=function(t,e,r,i,n,a,s,o,u,h,l,p,c){var f=12*t;return this.int16[f+0]=e,this.int16[f+1]=r,this.int16[f+2]=i,this.int16[f+3]=n,this.uint16[f+4]=a,this.uint16[f+5]=s,this.uint16[f+6]=o,this.uint16[f+7]=u,this.int16[f+8]=h,this.int16[f+9]=l,this.int16[f+10]=p,this.int16[f+11]=c,t},e}(Ws);so.prototype.bytesPerElement=24,da("StructArrayLayout4i4ui4i24",so);var oo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r){var i=this.length;return this.resize(i+1),this.emplace(i,t,e,r)},e.prototype.emplace=function(t,e,r,i){var n=3*t;return this.float32[n+0]=e,this.float32[n+1]=r,this.float32[n+2]=i,t},e}(Ws);oo.prototype.bytesPerElement=12,da("StructArrayLayout3f12",oo);var uo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t){var e=this.length;return this.resize(e+1),this.emplace(e,t)},e.prototype.emplace=function(t,e){return this.uint32[1*t+0]=e,t},e}(Ws);uo.prototype.bytesPerElement=4,da("StructArrayLayout1ul4",uo);var ho=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i,n,a,s,o,u){var h=this.length;return this.resize(h+1),this.emplace(h,t,e,r,i,n,a,s,o,u)},e.prototype.emplace=function(t,e,r,i,n,a,s,o,u,h){var l=10*t,p=5*t;return this.int16[l+0]=e,this.int16[l+1]=r,this.int16[l+2]=i,this.int16[l+3]=n,this.int16[l+4]=a,this.int16[l+5]=s,this.uint32[p+3]=o,this.uint16[l+8]=u,this.uint16[l+9]=h,t},e}(Ws);ho.prototype.bytesPerElement=20,da("StructArrayLayout6i1ul2ui20",ho);var lo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i,n,a){var s=this.length;return this.resize(s+1),this.emplace(s,t,e,r,i,n,a)},e.prototype.emplace=function(t,e,r,i,n,a,s){var o=6*t;return this.int16[o+0]=e,this.int16[o+1]=r,this.int16[o+2]=i,this.int16[o+3]=n,this.int16[o+4]=a,this.int16[o+5]=s,t},e}(Ws);lo.prototype.bytesPerElement=12,da("StructArrayLayout2i2i2i12",lo);var po=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i,n){var a=this.length;return this.resize(a+1),this.emplace(a,t,e,r,i,n)},e.prototype.emplace=function(t,e,r,i,n,a){var s=4*t,o=8*t;return this.float32[s+0]=e,this.float32[s+1]=r,this.float32[s+2]=i,this.int16[o+6]=n,this.int16[o+7]=a,t},e}(Ws);po.prototype.bytesPerElement=16,da("StructArrayLayout2f1f2i16",po);var co=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i){var n=this.length;return this.resize(n+1),this.emplace(n,t,e,r,i)},e.prototype.emplace=function(t,e,r,i,n){var a=12*t,s=3*t;return this.uint8[a+0]=e,this.uint8[a+1]=r,this.float32[s+1]=i,this.float32[s+2]=n,t},e}(Ws);co.prototype.bytesPerElement=12,da("StructArrayLayout2ub2f12",co);var fo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r){var i=this.length;return this.resize(i+1),this.emplace(i,t,e,r)},e.prototype.emplace=function(t,e,r,i){var n=3*t;return this.uint16[n+0]=e,this.uint16[n+1]=r,this.uint16[n+2]=i,t},e}(Ws);fo.prototype.bytesPerElement=6,da("StructArrayLayout3ui6",fo);var yo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i,n,a,s,o,u,h,l,p,c,f,y,d,m){var v=this.length;return this.resize(v+1),this.emplace(v,t,e,r,i,n,a,s,o,u,h,l,p,c,f,y,d,m)},e.prototype.emplace=function(t,e,r,i,n,a,s,o,u,h,l,p,c,f,y,d,m,v){var g=24*t,x=12*t,b=48*t;return this.int16[g+0]=e,this.int16[g+1]=r,this.uint16[g+2]=i,this.uint16[g+3]=n,this.uint32[x+2]=a,this.uint32[x+3]=s,this.uint32[x+4]=o,this.uint16[g+10]=u,this.uint16[g+11]=h,this.uint16[g+12]=l,this.float32[x+7]=p,this.float32[x+8]=c,this.uint8[b+36]=f,this.uint8[b+37]=y,this.uint8[b+38]=d,this.uint32[x+10]=m,this.int16[g+22]=v,t},e}(Ws);yo.prototype.bytesPerElement=48,da("StructArrayLayout2i2ui3ul3ui2f3ub1ul1i48",yo);var mo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i,n,a,s,o,u,h,l,p,c,f,y,d,m,v,g,x,b,_,w,M,S,A,k,I){var z=this.length;return this.resize(z+1),this.emplace(z,t,e,r,i,n,a,s,o,u,h,l,p,c,f,y,d,m,v,g,x,b,_,w,M,S,A,k,I)},e.prototype.emplace=function(t,e,r,i,n,a,s,o,u,h,l,p,c,f,y,d,m,v,g,x,b,_,w,M,S,A,k,I,z){var C=34*t,E=17*t;return this.int16[C+0]=e,this.int16[C+1]=r,this.int16[C+2]=i,this.int16[C+3]=n,this.int16[C+4]=a,this.int16[C+5]=s,this.int16[C+6]=o,this.int16[C+7]=u,this.uint16[C+8]=h,this.uint16[C+9]=l,this.uint16[C+10]=p,this.uint16[C+11]=c,this.uint16[C+12]=f,this.uint16[C+13]=y,this.uint16[C+14]=d,this.uint16[C+15]=m,this.uint16[C+16]=v,this.uint16[C+17]=g,this.uint16[C+18]=x,this.uint16[C+19]=b,this.uint16[C+20]=_,this.uint16[C+21]=w,this.uint16[C+22]=M,this.uint32[E+12]=S,this.float32[E+13]=A,this.float32[E+14]=k,this.float32[E+15]=I,this.float32[E+16]=z,t},e}(Ws);mo.prototype.bytesPerElement=68,da("StructArrayLayout8i15ui1ul4f68",mo);var vo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t){var e=this.length;return this.resize(e+1),this.emplace(e,t)},e.prototype.emplace=function(t,e){return this.float32[1*t+0]=e,t},e}(Ws);vo.prototype.bytesPerElement=4,da("StructArrayLayout1f4",vo);var go=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.int16=new Int16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r){var i=this.length;return this.resize(i+1),this.emplace(i,t,e,r)},e.prototype.emplace=function(t,e,r,i){var n=3*t;return this.int16[n+0]=e,this.int16[n+1]=r,this.int16[n+2]=i,t},e}(Ws);go.prototype.bytesPerElement=6,da("StructArrayLayout3i6",go);var xo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint32=new Uint32Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r){var i=this.length;return this.resize(i+1),this.emplace(i,t,e,r)},e.prototype.emplace=function(t,e,r,i){var n=4*t;return this.uint32[2*t+0]=e,this.uint16[n+2]=r,this.uint16[n+3]=i,t},e}(Ws);xo.prototype.bytesPerElement=8,da("StructArrayLayout1ul2ui8",xo);var bo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e){var r=this.length;return this.resize(r+1),this.emplace(r,t,e)},e.prototype.emplace=function(t,e,r){var i=2*t;return this.uint16[i+0]=e,this.uint16[i+1]=r,t},e}(Ws);bo.prototype.bytesPerElement=4,da("StructArrayLayout2ui4",bo);var _o=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.uint16=new Uint16Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t){var e=this.length;return this.resize(e+1),this.emplace(e,t)},e.prototype.emplace=function(t,e){return this.uint16[1*t+0]=e,t},e}(Ws);_o.prototype.bytesPerElement=2,da("StructArrayLayout1ui2",_o);var wo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._refreshViews=function(){this.uint8=new Uint8Array(this.arrayBuffer),this.float32=new Float32Array(this.arrayBuffer);},e.prototype.emplaceBack=function(t,e,r,i){var n=this.length;return this.resize(n+1),this.emplace(n,t,e,r,i)},e.prototype.emplace=function(t,e,r,i,n){var a=4*t;return this.float32[a+0]=e,this.float32[a+1]=r,this.float32[a+2]=i,this.float32[a+3]=n,t},e}(Ws);wo.prototype.bytesPerElement=16,da("StructArrayLayout4f16",wo);var Mo=function(t){function e(){t.apply(this,arguments);}t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e;var r={anchorPointX:{configurable:!0},anchorPointY:{configurable:!0},x1:{configurable:!0},y1:{configurable:!0},x2:{configurable:!0},y2:{configurable:!0},featureIndex:{configurable:!0},sourceLayerIndex:{configurable:!0},bucketIndex:{configurable:!0},anchorPoint:{configurable:!0}};return r.anchorPointX.get=function(){return this._structArray.int16[this._pos2+0]},r.anchorPointY.get=function(){return this._structArray.int16[this._pos2+1]},r.x1.get=function(){return this._structArray.int16[this._pos2+2]},r.y1.get=function(){return this._structArray.int16[this._pos2+3]},r.x2.get=function(){return this._structArray.int16[this._pos2+4]},r.y2.get=function(){return this._structArray.int16[this._pos2+5]},r.featureIndex.get=function(){return this._structArray.uint32[this._pos4+3]},r.sourceLayerIndex.get=function(){return this._structArray.uint16[this._pos2+8]},r.bucketIndex.get=function(){return this._structArray.uint16[this._pos2+9]},r.anchorPoint.get=function(){return new n(this.anchorPointX,this.anchorPointY)},Object.defineProperties(e.prototype,r),e}(Ys);Mo.prototype.size=20;var So=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.get=function(t){return new Mo(this,t)},e}(ho);da("CollisionBoxArray",So);var Ao=function(t){function e(){t.apply(this,arguments);}t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e;var r={anchorX:{configurable:!0},anchorY:{configurable:!0},glyphStartIndex:{configurable:!0},numGlyphs:{configurable:!0},vertexStartIndex:{configurable:!0},lineStartIndex:{configurable:!0},lineLength:{configurable:!0},segment:{configurable:!0},lowerSize:{configurable:!0},upperSize:{configurable:!0},lineOffsetX:{configurable:!0},lineOffsetY:{configurable:!0},writingMode:{configurable:!0},placedOrientation:{configurable:!0},hidden:{configurable:!0},crossTileID:{configurable:!0},associatedIconIndex:{configurable:!0}};return r.anchorX.get=function(){return this._structArray.int16[this._pos2+0]},r.anchorY.get=function(){return this._structArray.int16[this._pos2+1]},r.glyphStartIndex.get=function(){return this._structArray.uint16[this._pos2+2]},r.numGlyphs.get=function(){return this._structArray.uint16[this._pos2+3]},r.vertexStartIndex.get=function(){return this._structArray.uint32[this._pos4+2]},r.lineStartIndex.get=function(){return this._structArray.uint32[this._pos4+3]},r.lineLength.get=function(){return this._structArray.uint32[this._pos4+4]},r.segment.get=function(){return this._structArray.uint16[this._pos2+10]},r.lowerSize.get=function(){return this._structArray.uint16[this._pos2+11]},r.upperSize.get=function(){return this._structArray.uint16[this._pos2+12]},r.lineOffsetX.get=function(){return this._structArray.float32[this._pos4+7]},r.lineOffsetY.get=function(){return this._structArray.float32[this._pos4+8]},r.writingMode.get=function(){return this._structArray.uint8[this._pos1+36]},r.placedOrientation.get=function(){return this._structArray.uint8[this._pos1+37]},r.placedOrientation.set=function(t){this._structArray.uint8[this._pos1+37]=t;},r.hidden.get=function(){return this._structArray.uint8[this._pos1+38]},r.hidden.set=function(t){this._structArray.uint8[this._pos1+38]=t;},r.crossTileID.get=function(){return this._structArray.uint32[this._pos4+10]},r.crossTileID.set=function(t){this._structArray.uint32[this._pos4+10]=t;},r.associatedIconIndex.get=function(){return this._structArray.int16[this._pos2+22]},Object.defineProperties(e.prototype,r),e}(Ys);Ao.prototype.size=48;var ko=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.get=function(t){return new Ao(this,t)},e}(yo);da("PlacedSymbolArray",ko);var Io=function(t){function e(){t.apply(this,arguments);}t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e;var r={anchorX:{configurable:!0},anchorY:{configurable:!0},rightJustifiedTextSymbolIndex:{configurable:!0},centerJustifiedTextSymbolIndex:{configurable:!0},leftJustifiedTextSymbolIndex:{configurable:!0},verticalPlacedTextSymbolIndex:{configurable:!0},placedIconSymbolIndex:{configurable:!0},verticalPlacedIconSymbolIndex:{configurable:!0},key:{configurable:!0},textBoxStartIndex:{configurable:!0},textBoxEndIndex:{configurable:!0},verticalTextBoxStartIndex:{configurable:!0},verticalTextBoxEndIndex:{configurable:!0},iconBoxStartIndex:{configurable:!0},iconBoxEndIndex:{configurable:!0},verticalIconBoxStartIndex:{configurable:!0},verticalIconBoxEndIndex:{configurable:!0},featureIndex:{configurable:!0},numHorizontalGlyphVertices:{configurable:!0},numVerticalGlyphVertices:{configurable:!0},numIconVertices:{configurable:!0},numVerticalIconVertices:{configurable:!0},useRuntimeCollisionCircles:{configurable:!0},crossTileID:{configurable:!0},textBoxScale:{configurable:!0},textOffset0:{configurable:!0},textOffset1:{configurable:!0},collisionCircleDiameter:{configurable:!0}};return r.anchorX.get=function(){return this._structArray.int16[this._pos2+0]},r.anchorY.get=function(){return this._structArray.int16[this._pos2+1]},r.rightJustifiedTextSymbolIndex.get=function(){return this._structArray.int16[this._pos2+2]},r.centerJustifiedTextSymbolIndex.get=function(){return this._structArray.int16[this._pos2+3]},r.leftJustifiedTextSymbolIndex.get=function(){return this._structArray.int16[this._pos2+4]},r.verticalPlacedTextSymbolIndex.get=function(){return this._structArray.int16[this._pos2+5]},r.placedIconSymbolIndex.get=function(){return this._structArray.int16[this._pos2+6]},r.verticalPlacedIconSymbolIndex.get=function(){return this._structArray.int16[this._pos2+7]},r.key.get=function(){return this._structArray.uint16[this._pos2+8]},r.textBoxStartIndex.get=function(){return this._structArray.uint16[this._pos2+9]},r.textBoxEndIndex.get=function(){return this._structArray.uint16[this._pos2+10]},r.verticalTextBoxStartIndex.get=function(){return this._structArray.uint16[this._pos2+11]},r.verticalTextBoxEndIndex.get=function(){return this._structArray.uint16[this._pos2+12]},r.iconBoxStartIndex.get=function(){return this._structArray.uint16[this._pos2+13]},r.iconBoxEndIndex.get=function(){return this._structArray.uint16[this._pos2+14]},r.verticalIconBoxStartIndex.get=function(){return this._structArray.uint16[this._pos2+15]},r.verticalIconBoxEndIndex.get=function(){return this._structArray.uint16[this._pos2+16]},r.featureIndex.get=function(){return this._structArray.uint16[this._pos2+17]},r.numHorizontalGlyphVertices.get=function(){return this._structArray.uint16[this._pos2+18]},r.numVerticalGlyphVertices.get=function(){return this._structArray.uint16[this._pos2+19]},r.numIconVertices.get=function(){return this._structArray.uint16[this._pos2+20]},r.numVerticalIconVertices.get=function(){return this._structArray.uint16[this._pos2+21]},r.useRuntimeCollisionCircles.get=function(){return this._structArray.uint16[this._pos2+22]},r.crossTileID.get=function(){return this._structArray.uint32[this._pos4+12]},r.crossTileID.set=function(t){this._structArray.uint32[this._pos4+12]=t;},r.textBoxScale.get=function(){return this._structArray.float32[this._pos4+13]},r.textOffset0.get=function(){return this._structArray.float32[this._pos4+14]},r.textOffset1.get=function(){return this._structArray.float32[this._pos4+15]},r.collisionCircleDiameter.get=function(){return this._structArray.float32[this._pos4+16]},Object.defineProperties(e.prototype,r),e}(Ys);Io.prototype.size=68;var zo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.get=function(t){return new Io(this,t)},e}(mo);da("SymbolInstanceArray",zo);var Co=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getoffsetX=function(t){return this.float32[1*t+0]},e}(vo);da("GlyphOffsetArray",Co);var Eo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getx=function(t){return this.int16[3*t+0]},e.prototype.gety=function(t){return this.int16[3*t+1]},e.prototype.gettileUnitDistanceFromAnchor=function(t){return this.int16[3*t+2]},e}(go);da("SymbolLineVertexArray",Eo);var Po=function(t){function e(){t.apply(this,arguments);}t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e;var r={featureIndex:{configurable:!0},sourceLayerIndex:{configurable:!0},bucketIndex:{configurable:!0}};return r.featureIndex.get=function(){return this._structArray.uint32[this._pos4+0]},r.sourceLayerIndex.get=function(){return this._structArray.uint16[this._pos2+2]},r.bucketIndex.get=function(){return this._structArray.uint16[this._pos2+3]},Object.defineProperties(e.prototype,r),e}(Ys);Po.prototype.size=8;var Bo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.get=function(t){return new Po(this,t)},e}(xo);da("FeatureIndexArray",Bo);var To=Qs([{name:"a_pos",components:2,type:"Int16"}],4).members,Vo=function(t){void 0===t&&(t=[]),this.segments=t;};function Lo(t,e){return 256*(t=l(Math.floor(t),0,255))+l(Math.floor(e),0,255)}Vo.prototype.prepareSegment=function(t,e,r,i){var n=this.segments[this.segments.length-1];return t>Vo.MAX_VERTEX_ARRAY_LENGTH&&M("Max vertices per segment is "+Vo.MAX_VERTEX_ARRAY_LENGTH+": bucket requested "+t),(!n||n.vertexLength+t>Vo.MAX_VERTEX_ARRAY_LENGTH||n.sortKey!==i)&&(n={vertexOffset:e.length,primitiveOffset:r.length,vertexLength:0,primitiveLength:0},void 0!==i&&(n.sortKey=i),this.segments.push(n)),n},Vo.prototype.get=function(){return this.segments},Vo.prototype.destroy=function(){for(var t=0,e=this.segments;t<e.length;t+=1){var r=e[t];for(var i in r.vaos)r.vaos[i].destroy();}},Vo.simpleSegment=function(t,e,r,i){return new Vo([{vertexOffset:t,primitiveOffset:e,vertexLength:r,primitiveLength:i,vaos:{},sortKey:0}])},Vo.MAX_VERTEX_ARRAY_LENGTH=Math.pow(2,16)-1,da("SegmentVector",Vo);var Fo=Qs([{name:"a_pattern_from",components:4,type:"Uint16"},{name:"a_pattern_to",components:4,type:"Uint16"},{name:"a_pixel_ratio_from",components:1,type:"Uint16"},{name:"a_pixel_ratio_to",components:1,type:"Uint16"}]),Oo=e((function(t){t.exports=function(t,e){var r,i,n,a,s,o,u,h;for(i=t.length-(r=3&t.length),n=e,s=3432918353,o=461845907,h=0;h<i;)u=255&t.charCodeAt(h)|(255&t.charCodeAt(++h))<<8|(255&t.charCodeAt(++h))<<16|(255&t.charCodeAt(++h))<<24,++h,n=27492+(65535&(a=5*(65535&(n=(n^=u=(65535&(u=(u=(65535&u)*s+(((u>>>16)*s&65535)<<16)&4294967295)<<15|u>>>17))*o+(((u>>>16)*o&65535)<<16)&4294967295)<<13|n>>>19))+((5*(n>>>16)&65535)<<16)&4294967295))+((58964+(a>>>16)&65535)<<16);switch(u=0,r){case 3:u^=(255&t.charCodeAt(h+2))<<16;case 2:u^=(255&t.charCodeAt(h+1))<<8;case 1:n^=u=(65535&(u=(u=(65535&(u^=255&t.charCodeAt(h)))*s+(((u>>>16)*s&65535)<<16)&4294967295)<<15|u>>>17))*o+(((u>>>16)*o&65535)<<16)&4294967295;}return n^=t.length,n=2246822507*(65535&(n^=n>>>16))+((2246822507*(n>>>16)&65535)<<16)&4294967295,n=3266489909*(65535&(n^=n>>>13))+((3266489909*(n>>>16)&65535)<<16)&4294967295,(n^=n>>>16)>>>0};})),Do=e((function(t){t.exports=function(t,e){for(var r,i=t.length,n=e^i,a=0;i>=4;)r=1540483477*(65535&(r=255&t.charCodeAt(a)|(255&t.charCodeAt(++a))<<8|(255&t.charCodeAt(++a))<<16|(255&t.charCodeAt(++a))<<24))+((1540483477*(r>>>16)&65535)<<16),n=1540483477*(65535&n)+((1540483477*(n>>>16)&65535)<<16)^(r=1540483477*(65535&(r^=r>>>24))+((1540483477*(r>>>16)&65535)<<16)),i-=4,++a;switch(i){case 3:n^=(255&t.charCodeAt(a+2))<<16;case 2:n^=(255&t.charCodeAt(a+1))<<8;case 1:n=1540483477*(65535&(n^=255&t.charCodeAt(a)))+((1540483477*(n>>>16)&65535)<<16);}return n=1540483477*(65535&(n^=n>>>13))+((1540483477*(n>>>16)&65535)<<16),(n^=n>>>15)>>>0};})),No=Oo,Ro=Do;No.murmur3=Oo,No.murmur2=Ro;var qo=function(){this.ids=[],this.positions=[],this.indexed=!1;};qo.prototype.add=function(t,e,r,i){this.ids.push(Uo(t)),this.positions.push(e,r,i);},qo.prototype.getPositions=function(t){for(var e=Uo(t),r=0,i=this.ids.length-1;r<i;){var n=r+i>>1;this.ids[n]>=e?i=n:r=n+1;}for(var a=[];this.ids[r]===e;)a.push({index:this.positions[3*r],start:this.positions[3*r+1],end:this.positions[3*r+2]}),r++;return a},qo.serialize=function(t,e){var r=new Float64Array(t.ids),i=new Uint32Array(t.positions);return function t(e,r,i,n){for(;i<n;){for(var a=e[i+n>>1],s=i-1,o=n+1;;){do{s++;}while(e[s]<a);do{o--;}while(e[o]>a);if(s>=o)break;Go(e,s,o),Go(r,3*s,3*o),Go(r,3*s+1,3*o+1),Go(r,3*s+2,3*o+2);}o-i<n-o?(t(e,r,i,o),i=o+1):(t(e,r,o+1,n),n=o);}}(r,i,0,r.length-1),e&&e.push(r.buffer,i.buffer),{ids:r,positions:i}},qo.deserialize=function(t){var e=new qo;return e.ids=t.ids,e.positions=t.positions,e.indexed=!0,e};var jo=Math.pow(2,53)-1;function Uo(t){var e=+t;return !isNaN(e)&&e<=jo?e:No(String(t))}function Go(t,e,r){var i=t[e];t[e]=t[r],t[r]=i;}da("FeaturePositionMap",qo);var Ko=function(t,e){this.gl=t.gl,this.location=e;},Xo=function(t){function e(e,r){t.call(this,e,r),this.current=0;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.set=function(t){this.current!==t&&(this.current=t,this.gl.uniform1i(this.location,t));},e}(Ko),Ho=function(t){function e(e,r){t.call(this,e,r),this.current=0;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.set=function(t){this.current!==t&&(this.current=t,this.gl.uniform1f(this.location,t));},e}(Ko),Jo=function(t){function e(e,r){t.call(this,e,r),this.current=[0,0];}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.set=function(t){t[0]===this.current[0]&&t[1]===this.current[1]||(this.current=t,this.gl.uniform2f(this.location,t[0],t[1]));},e}(Ko),Zo=function(t){function e(e,r){t.call(this,e,r),this.current=[0,0,0];}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.set=function(t){t[0]===this.current[0]&&t[1]===this.current[1]&&t[2]===this.current[2]||(this.current=t,this.gl.uniform3f(this.location,t[0],t[1],t[2]));},e}(Ko),Yo=function(t){function e(e,r){t.call(this,e,r),this.current=[0,0,0,0];}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.set=function(t){t[0]===this.current[0]&&t[1]===this.current[1]&&t[2]===this.current[2]&&t[3]===this.current[3]||(this.current=t,this.gl.uniform4f(this.location,t[0],t[1],t[2],t[3]));},e}(Ko),Wo=function(t){function e(e,r){t.call(this,e,r),this.current=Zr.transparent;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.set=function(t){t.r===this.current.r&&t.g===this.current.g&&t.b===this.current.b&&t.a===this.current.a||(this.current=t,this.gl.uniform4f(this.location,t.r,t.g,t.b,t.a));},e}(Ko),Qo=new Float32Array(16),$o=function(t){function e(e,r){t.call(this,e,r),this.current=Qo;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.set=function(t){if(t[12]!==this.current[12]||t[0]!==this.current[0])return this.current=t,void this.gl.uniformMatrix4fv(this.location,!1,t);for(var e=1;e<16;e++)if(t[e]!==this.current[e]){this.current=t,this.gl.uniformMatrix4fv(this.location,!1,t);break}},e}(Ko);function tu(t){return [Lo(255*t.r,255*t.g),Lo(255*t.b,255*t.a)]}var eu=function(t,e,r){this.value=t,this.uniformNames=e.map((function(t){return "u_"+t})),this.type=r;};eu.prototype.setUniform=function(t,e,r){t.set(r.constantOr(this.value));},eu.prototype.getBinding=function(t,e,r){return "color"===this.type?new Wo(t,e):new Ho(t,e)};var ru=function(t,e){this.uniformNames=e.map((function(t){return "u_"+t})),this.patternFrom=null,this.patternTo=null,this.pixelRatioFrom=1,this.pixelRatioTo=1;};ru.prototype.setConstantPatternPositions=function(t,e){this.pixelRatioFrom=e.pixelRatio,this.pixelRatioTo=t.pixelRatio,this.patternFrom=e.tlbr,this.patternTo=t.tlbr;},ru.prototype.setUniform=function(t,e,r,i){var n="u_pattern_to"===i?this.patternTo:"u_pattern_from"===i?this.patternFrom:"u_pixel_ratio_to"===i?this.pixelRatioTo:"u_pixel_ratio_from"===i?this.pixelRatioFrom:null;n&&t.set(n);},ru.prototype.getBinding=function(t,e,r){return "u_pattern"===r.substr(0,9)?new Yo(t,e):new Ho(t,e)};var iu=function(t,e,r,i){this.expression=t,this.type=r,this.maxValue=0,this.paintVertexAttributes=e.map((function(t){return {name:"a_"+t,type:"Float32",components:"color"===r?2:1,offset:0}})),this.paintVertexArray=new i;};iu.prototype.populatePaintArray=function(t,e,r,i,n){var a=this.paintVertexArray.length,s=this.expression.evaluate(new Ts(0),e,{},i,[],n);this.paintVertexArray.resize(t),this._setPaintValue(a,t,s);},iu.prototype.updatePaintArray=function(t,e,r,i){var n=this.expression.evaluate({zoom:0},r,i);this._setPaintValue(t,e,n);},iu.prototype._setPaintValue=function(t,e,r){if("color"===this.type)for(var i=tu(r),n=t;n<e;n++)this.paintVertexArray.emplace(n,i[0],i[1]);else {for(var a=t;a<e;a++)this.paintVertexArray.emplace(a,r);this.maxValue=Math.max(this.maxValue,Math.abs(r));}},iu.prototype.upload=function(t){this.paintVertexArray&&this.paintVertexArray.arrayBuffer&&(this.paintVertexBuffer&&this.paintVertexBuffer.buffer?this.paintVertexBuffer.updateData(this.paintVertexArray):this.paintVertexBuffer=t.createVertexBuffer(this.paintVertexArray,this.paintVertexAttributes,this.expression.isStateDependent));},iu.prototype.destroy=function(){this.paintVertexBuffer&&this.paintVertexBuffer.destroy();};var nu=function(t,e,r,i,n,a){this.expression=t,this.uniformNames=e.map((function(t){return "u_"+t+"_t"})),this.type=r,this.useIntegerZoom=i,this.zoom=n,this.maxValue=0,this.paintVertexAttributes=e.map((function(t){return {name:"a_"+t,type:"Float32",components:"color"===r?4:2,offset:0}})),this.paintVertexArray=new a;};nu.prototype.populatePaintArray=function(t,e,r,i,n){var a=this.expression.evaluate(new Ts(this.zoom),e,{},i,[],n),s=this.expression.evaluate(new Ts(this.zoom+1),e,{},i,[],n),o=this.paintVertexArray.length;this.paintVertexArray.resize(t),this._setPaintValue(o,t,a,s);},nu.prototype.updatePaintArray=function(t,e,r,i){var n=this.expression.evaluate({zoom:this.zoom},r,i),a=this.expression.evaluate({zoom:this.zoom+1},r,i);this._setPaintValue(t,e,n,a);},nu.prototype._setPaintValue=function(t,e,r,i){if("color"===this.type)for(var n=tu(r),a=tu(i),s=t;s<e;s++)this.paintVertexArray.emplace(s,n[0],n[1],a[0],a[1]);else {for(var o=t;o<e;o++)this.paintVertexArray.emplace(o,r,i);this.maxValue=Math.max(this.maxValue,Math.abs(r),Math.abs(i));}},nu.prototype.upload=function(t){this.paintVertexArray&&this.paintVertexArray.arrayBuffer&&(this.paintVertexBuffer&&this.paintVertexBuffer.buffer?this.paintVertexBuffer.updateData(this.paintVertexArray):this.paintVertexBuffer=t.createVertexBuffer(this.paintVertexArray,this.paintVertexAttributes,this.expression.isStateDependent));},nu.prototype.destroy=function(){this.paintVertexBuffer&&this.paintVertexBuffer.destroy();},nu.prototype.setUniform=function(t,e){var r=this.useIntegerZoom?Math.floor(e.zoom):e.zoom,i=l(this.expression.interpolationFactor(r,this.zoom,this.zoom+1),0,1);t.set(i);},nu.prototype.getBinding=function(t,e,r){return new Ho(t,e)};var au=function(t,e,r,i,n,a){this.expression=t,this.type=e,this.useIntegerZoom=r,this.zoom=i,this.layerId=a,this.zoomInPaintVertexArray=new n,this.zoomOutPaintVertexArray=new n;};au.prototype.populatePaintArray=function(t,e,r){var i=this.zoomInPaintVertexArray.length;this.zoomInPaintVertexArray.resize(t),this.zoomOutPaintVertexArray.resize(t),this._setPaintValues(i,t,e.patterns&&e.patterns[this.layerId],r);},au.prototype.updatePaintArray=function(t,e,r,i,n){this._setPaintValues(t,e,r.patterns&&r.patterns[this.layerId],n);},au.prototype._setPaintValues=function(t,e,r,i){if(i&&r){var n=i[r.min],a=i[r.mid],s=i[r.max];if(n&&a&&s)for(var o=t;o<e;o++)this.zoomInPaintVertexArray.emplace(o,a.tl[0],a.tl[1],a.br[0],a.br[1],n.tl[0],n.tl[1],n.br[0],n.br[1],a.pixelRatio,n.pixelRatio),this.zoomOutPaintVertexArray.emplace(o,a.tl[0],a.tl[1],a.br[0],a.br[1],s.tl[0],s.tl[1],s.br[0],s.br[1],a.pixelRatio,s.pixelRatio);}},au.prototype.upload=function(t){this.zoomInPaintVertexArray&&this.zoomInPaintVertexArray.arrayBuffer&&this.zoomOutPaintVertexArray&&this.zoomOutPaintVertexArray.arrayBuffer&&(this.zoomInPaintVertexBuffer=t.createVertexBuffer(this.zoomInPaintVertexArray,Fo.members,this.expression.isStateDependent),this.zoomOutPaintVertexBuffer=t.createVertexBuffer(this.zoomOutPaintVertexArray,Fo.members,this.expression.isStateDependent));},au.prototype.destroy=function(){this.zoomOutPaintVertexBuffer&&this.zoomOutPaintVertexBuffer.destroy(),this.zoomInPaintVertexBuffer&&this.zoomInPaintVertexBuffer.destroy();};var su=function(t,e,r){this.binders={},this._buffers=[];var i=[];for(var n in t.paint._values)if(r(n)){var a=t.paint.get(n);if(a instanceof Rs&&Jn(a.property.specification)){var s=uu(n,t.type),o=a.value,u=a.property.specification.type,h=a.property.useIntegerZoom,l=a.property.specification["property-type"],p="cross-faded"===l||"cross-faded-data-driven"===l;if("constant"===o.kind)this.binders[n]=p?new ru(o.value,s):new eu(o.value,s,u),i.push("/u_"+n);else if("source"===o.kind||p){var c=hu(n,u,"source");this.binders[n]=p?new au(o,u,h,e,c,t.id):new iu(o,s,u,c),i.push("/a_"+n);}else {var f=hu(n,u,"composite");this.binders[n]=new nu(o,s,u,h,e,f),i.push("/z_"+n);}}}this.cacheKey=i.sort().join("");};su.prototype.getMaxValue=function(t){var e=this.binders[t];return e instanceof iu||e instanceof nu?e.maxValue:0},su.prototype.populatePaintArrays=function(t,e,r,i,n){for(var a in this.binders){var s=this.binders[a];(s instanceof iu||s instanceof nu||s instanceof au)&&s.populatePaintArray(t,e,r,i,n);}},su.prototype.setConstantPatternPositions=function(t,e){for(var r in this.binders){var i=this.binders[r];i instanceof ru&&i.setConstantPatternPositions(t,e);}},su.prototype.updatePaintArrays=function(t,e,r,i,n){var a=!1;for(var s in t)for(var o=0,u=e.getPositions(s);o<u.length;o+=1){var h=u[o],l=r.feature(h.index);for(var p in this.binders){var c=this.binders[p];if((c instanceof iu||c instanceof nu||c instanceof au)&&!0===c.expression.isStateDependent){var f=i.paint.get(p);c.expression=f.value,c.updatePaintArray(h.start,h.end,l,t[s],n),a=!0;}}}return a},su.prototype.defines=function(){var t=[];for(var e in this.binders){var r=this.binders[e];(r instanceof eu||r instanceof ru)&&t.push.apply(t,r.uniformNames.map((function(t){return "#define HAS_UNIFORM_"+t})));}return t},su.prototype.getBinderAttributes=function(){var t=[];for(var e in this.binders){var r=this.binders[e];if(r instanceof iu||r instanceof nu)for(var i=0;i<r.paintVertexAttributes.length;i++)t.push(r.paintVertexAttributes[i].name);else if(r instanceof au)for(var n=0;n<Fo.members.length;n++)t.push(Fo.members[n].name);}return t},su.prototype.getBinderUniforms=function(){var t=[];for(var e in this.binders){var r=this.binders[e];if(r instanceof eu||r instanceof ru||r instanceof nu)for(var i=0,n=r.uniformNames;i<n.length;i+=1)t.push(n[i]);}return t},su.prototype.getPaintVertexBuffers=function(){return this._buffers},su.prototype.getUniforms=function(t,e){var r=[];for(var i in this.binders){var n=this.binders[i];if(n instanceof eu||n instanceof ru||n instanceof nu)for(var a=0,s=n.uniformNames;a<s.length;a+=1){var o=s[a];if(e[o]){var u=n.getBinding(t,e[o],o);r.push({name:o,property:i,binding:u});}}}return r},su.prototype.setUniforms=function(t,e,r,i){for(var n=0,a=e;n<a.length;n+=1){var s=a[n],o=s.name,u=s.property;this.binders[u].setUniform(s.binding,i,r.get(u),o);}},su.prototype.updatePaintBuffers=function(t){for(var e in this._buffers=[],this.binders){var r=this.binders[e];if(t&&r instanceof au){var i=2===t.fromScale?r.zoomInPaintVertexBuffer:r.zoomOutPaintVertexBuffer;i&&this._buffers.push(i);}else (r instanceof iu||r instanceof nu)&&r.paintVertexBuffer&&this._buffers.push(r.paintVertexBuffer);}},su.prototype.upload=function(t){for(var e in this.binders){var r=this.binders[e];(r instanceof iu||r instanceof nu||r instanceof au)&&r.upload(t);}this.updatePaintBuffers();},su.prototype.destroy=function(){for(var t in this.binders){var e=this.binders[t];(e instanceof iu||e instanceof nu||e instanceof au)&&e.destroy();}};var ou=function(t,e,r){void 0===r&&(r=function(){return !0}),this.programConfigurations={};for(var i=0,n=t;i<n.length;i+=1){var a=n[i];this.programConfigurations[a.id]=new su(a,e,r);}this.needsUpload=!1,this._featureMap=new qo,this._bufferOffset=0;};function uu(t,e){return {"text-opacity":["opacity"],"icon-opacity":["opacity"],"text-color":["fill_color"],"icon-color":["fill_color"],"text-halo-color":["halo_color"],"icon-halo-color":["halo_color"],"text-halo-blur":["halo_blur"],"icon-halo-blur":["halo_blur"],"text-halo-width":["halo_width"],"icon-halo-width":["halo_width"],"line-gap-width":["gapwidth"],"line-pattern":["pattern_to","pattern_from","pixel_ratio_to","pixel_ratio_from"],"fill-pattern":["pattern_to","pattern_from","pixel_ratio_to","pixel_ratio_from"],"fill-extrusion-pattern":["pattern_to","pattern_from","pixel_ratio_to","pixel_ratio_from"]}[t]||[t.replace(e+"-","").replace(/-/g,"_")]}function hu(t,e,r){var i={color:{source:no,composite:wo},number:{source:vo,composite:no}},n=function(t){return {"line-pattern":{source:ao,composite:ao},"fill-pattern":{source:ao,composite:ao},"fill-extrusion-pattern":{source:ao,composite:ao}}[t]}(t);return n&&n[r]||i[e][r]}ou.prototype.populatePaintArrays=function(t,e,r,i,n,a){for(var s in this.programConfigurations)this.programConfigurations[s].populatePaintArrays(t,e,i,n,a);void 0!==e.id&&this._featureMap.add(e.id,r,this._bufferOffset,t),this._bufferOffset=t,this.needsUpload=!0;},ou.prototype.updatePaintArrays=function(t,e,r,i){for(var n=0,a=r;n<a.length;n+=1){var s=a[n];this.needsUpload=this.programConfigurations[s.id].updatePaintArrays(t,this._featureMap,e,s,i)||this.needsUpload;}},ou.prototype.get=function(t){return this.programConfigurations[t]},ou.prototype.upload=function(t){if(this.needsUpload){for(var e in this.programConfigurations)this.programConfigurations[e].upload(t);this.needsUpload=!1;}},ou.prototype.destroy=function(){for(var t in this.programConfigurations)this.programConfigurations[t].destroy();},da("ConstantBinder",eu),da("CrossFadedConstantBinder",ru),da("SourceExpressionBinder",iu),da("CrossFadedCompositeBinder",au),da("CompositeExpressionBinder",nu),da("ProgramConfiguration",su,{omit:["_buffers"]}),da("ProgramConfigurationSet",ou);var lu=Math.pow(2,14)-1,pu=-lu-1;function cu(t){for(var e=8192/t.extent,r=t.loadGeometry(),i=0;i<r.length;i++)for(var n=r[i],a=0;a<n.length;a++){var s=n[a],o=Math.round(s.x*e),u=Math.round(s.y*e);s.x=l(o,pu,lu),s.y=l(u,pu,lu),(o<s.x||o>s.x+1||u<s.y||u>s.y+1)&&M("Geometry exceeds allowed extent, reduce your vector tile buffer size");}return r}function fu(t,e,r,i,n){t.emplaceBack(2*e+(i+1)/2,2*r+(n+1)/2);}var yu=function(t){this.zoom=t.zoom,this.overscaling=t.overscaling,this.layers=t.layers,this.layerIds=this.layers.map((function(t){return t.id})),this.index=t.index,this.hasPattern=!1,this.layoutVertexArray=new to,this.indexArray=new fo,this.segments=new Vo,this.programConfigurations=new ou(t.layers,t.zoom),this.stateDependentLayerIds=this.layers.filter((function(t){return t.isStateDependent()})).map((function(t){return t.id}));};function du(t,e){for(var r=0;r<t.length;r++)if(Su(e,t[r]))return !0;for(var i=0;i<e.length;i++)if(Su(t,e[i]))return !0;return !!xu(t,e)}function mu(t,e,r){return !!Su(t,e)||!!_u(e,t,r)}function vu(t,e){if(1===t.length)return Mu(e,t[0]);for(var r=0;r<e.length;r++)for(var i=e[r],n=0;n<i.length;n++)if(Su(t,i[n]))return !0;for(var a=0;a<t.length;a++)if(Mu(e,t[a]))return !0;for(var s=0;s<e.length;s++)if(xu(t,e[s]))return !0;return !1}function gu(t,e,r){if(t.length>1){if(xu(t,e))return !0;for(var i=0;i<e.length;i++)if(_u(e[i],t,r))return !0}for(var n=0;n<t.length;n++)if(_u(t[n],e,r))return !0;return !1}function xu(t,e){if(0===t.length||0===e.length)return !1;for(var r=0;r<t.length-1;r++)for(var i=t[r],n=t[r+1],a=0;a<e.length-1;a++)if(bu(i,n,e[a],e[a+1]))return !0;return !1}function bu(t,e,r,i){return S(t,r,i)!==S(e,r,i)&&S(t,e,r)!==S(t,e,i)}function _u(t,e,r){var i=r*r;if(1===e.length)return t.distSqr(e[0])<i;for(var n=1;n<e.length;n++)if(wu(t,e[n-1],e[n])<i)return !0;return !1}function wu(t,e,r){var i=e.distSqr(r);if(0===i)return t.distSqr(e);var n=((t.x-e.x)*(r.x-e.x)+(t.y-e.y)*(r.y-e.y))/i;return t.distSqr(n<0?e:n>1?r:r.sub(e)._mult(n)._add(e))}function Mu(t,e){for(var r,i,n,a=!1,s=0;s<t.length;s++)for(var o=0,u=(r=t[s]).length-1;o<r.length;u=o++)(i=r[o]).y>e.y!=(n=r[u]).y>e.y&&e.x<(n.x-i.x)*(e.y-i.y)/(n.y-i.y)+i.x&&(a=!a);return a}function Su(t,e){for(var r=!1,i=0,n=t.length-1;i<t.length;n=i++){var a=t[i],s=t[n];a.y>e.y!=s.y>e.y&&e.x<(s.x-a.x)*(e.y-a.y)/(s.y-a.y)+a.x&&(r=!r);}return r}function Au(t,e,r){var i=r[0],n=r[2];if(t.x<i.x&&e.x<i.x||t.x>n.x&&e.x>n.x||t.y<i.y&&e.y<i.y||t.y>n.y&&e.y>n.y)return !1;var a=S(t,e,r[0]);return a!==S(t,e,r[1])||a!==S(t,e,r[2])||a!==S(t,e,r[3])}function ku(t,e,r){var i=e.paint.get(t).value;return "constant"===i.kind?i.value:r.programConfigurations.get(e.id).getMaxValue(t)}function Iu(t){return Math.sqrt(t[0]*t[0]+t[1]*t[1])}function zu(t,e,r,i,a){if(!e[0]&&!e[1])return t;var s=n.convert(e)._mult(a);"viewport"===r&&s._rotate(-i);for(var o=[],u=0;u<t.length;u++)o.push(t[u].sub(s));return o}yu.prototype.populate=function(t,e,r){var i=this.layers[0],n=[],a=null;"circle"===i.type&&(a=i.layout.get("circle-sort-key"));for(var s=0,o=t;s<o.length;s+=1){var u=o[s],h=u.feature,l=u.id,p=u.index,c=u.sourceLayerIndex,f=this.layers[0]._featureFilter.needGeometry,y={type:h.type,id:l,properties:h.properties,geometry:f?cu(h):[]};if(this.layers[0]._featureFilter.filter(new Ts(this.zoom),y,r)){f||(y.geometry=cu(h));var d=a?a.evaluate(y,{},r):void 0;n.push({id:l,properties:h.properties,type:h.type,sourceLayerIndex:c,index:p,geometry:y.geometry,patterns:{},sortKey:d});}}a&&n.sort((function(t,e){return t.sortKey-e.sortKey}));for(var m=0,v=n;m<v.length;m+=1){var g=v[m],x=g.geometry,b=g.index,_=g.sourceLayerIndex,w=t[b].feature;this.addFeature(g,x,b,r),e.featureIndex.insert(w,x,b,_,this.index);}},yu.prototype.update=function(t,e,r){this.stateDependentLayers.length&&this.programConfigurations.updatePaintArrays(t,e,this.stateDependentLayers,r);},yu.prototype.isEmpty=function(){return 0===this.layoutVertexArray.length},yu.prototype.uploadPending=function(){return !this.uploaded||this.programConfigurations.needsUpload},yu.prototype.upload=function(t){this.uploaded||(this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,To),this.indexBuffer=t.createIndexBuffer(this.indexArray)),this.programConfigurations.upload(t),this.uploaded=!0;},yu.prototype.destroy=function(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy());},yu.prototype.addFeature=function(t,e,r,i){for(var n=0,a=e;n<a.length;n+=1)for(var s=0,o=a[n];s<o.length;s+=1){var u=o[s],h=u.x,l=u.y;if(!(h<0||h>=8192||l<0||l>=8192)){var p=this.segments.prepareSegment(4,this.layoutVertexArray,this.indexArray,t.sortKey),c=p.vertexLength;fu(this.layoutVertexArray,h,l,-1,-1),fu(this.layoutVertexArray,h,l,1,-1),fu(this.layoutVertexArray,h,l,1,1),fu(this.layoutVertexArray,h,l,-1,1),this.indexArray.emplaceBack(c,c+1,c+2),this.indexArray.emplaceBack(c,c+3,c+2),p.vertexLength+=4,p.primitiveLength+=2;}}this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,t,r,{},i);},da("CircleBucket",yu,{omit:["layers"]});var Cu=new Hs({"circle-sort-key":new Us(Pa.layout_circle["circle-sort-key"])}),Eu={paint:new Hs({"circle-radius":new Us(Pa.paint_circle["circle-radius"]),"circle-color":new Us(Pa.paint_circle["circle-color"]),"circle-blur":new Us(Pa.paint_circle["circle-blur"]),"circle-opacity":new Us(Pa.paint_circle["circle-opacity"]),"circle-translate":new js(Pa.paint_circle["circle-translate"]),"circle-translate-anchor":new js(Pa.paint_circle["circle-translate-anchor"]),"circle-pitch-scale":new js(Pa.paint_circle["circle-pitch-scale"]),"circle-pitch-alignment":new js(Pa.paint_circle["circle-pitch-alignment"]),"circle-stroke-width":new Us(Pa.paint_circle["circle-stroke-width"]),"circle-stroke-color":new Us(Pa.paint_circle["circle-stroke-color"]),"circle-stroke-opacity":new Us(Pa.paint_circle["circle-stroke-opacity"])}),layout:Cu},Pu="undefined"!=typeof Float32Array?Float32Array:Array;function Bu(t){return t[0]=1,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=1,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=1,t[11]=0,t[12]=0,t[13]=0,t[14]=0,t[15]=1,t}function Tu(t,e,r){var i=e[0],n=e[1],a=e[2],s=e[3],o=e[4],u=e[5],h=e[6],l=e[7],p=e[8],c=e[9],f=e[10],y=e[11],d=e[12],m=e[13],v=e[14],g=e[15],x=r[0],b=r[1],_=r[2],w=r[3];return t[0]=x*i+b*o+_*p+w*d,t[1]=x*n+b*u+_*c+w*m,t[2]=x*a+b*h+_*f+w*v,t[3]=x*s+b*l+_*y+w*g,t[4]=(x=r[4])*i+(b=r[5])*o+(_=r[6])*p+(w=r[7])*d,t[5]=x*n+b*u+_*c+w*m,t[6]=x*a+b*h+_*f+w*v,t[7]=x*s+b*l+_*y+w*g,t[8]=(x=r[8])*i+(b=r[9])*o+(_=r[10])*p+(w=r[11])*d,t[9]=x*n+b*u+_*c+w*m,t[10]=x*a+b*h+_*f+w*v,t[11]=x*s+b*l+_*y+w*g,t[12]=(x=r[12])*i+(b=r[13])*o+(_=r[14])*p+(w=r[15])*d,t[13]=x*n+b*u+_*c+w*m,t[14]=x*a+b*h+_*f+w*v,t[15]=x*s+b*l+_*y+w*g,t}Math.hypot||(Math.hypot=function(){for(var t=arguments,e=0,r=arguments.length;r--;)e+=t[r]*t[r];return Math.sqrt(e)});var Vu,Lu=Tu;function Fu(t,e,r){var i=e[0],n=e[1],a=e[2],s=e[3];return t[0]=r[0]*i+r[4]*n+r[8]*a+r[12]*s,t[1]=r[1]*i+r[5]*n+r[9]*a+r[13]*s,t[2]=r[2]*i+r[6]*n+r[10]*a+r[14]*s,t[3]=r[3]*i+r[7]*n+r[11]*a+r[15]*s,t}Vu=new Pu(3),Pu!=Float32Array&&(Vu[0]=0,Vu[1]=0,Vu[2]=0),function(){var t=new Pu(4);Pu!=Float32Array&&(t[0]=0,t[1]=0,t[2]=0,t[3]=0);}();var Ou=(function(){var t=new Pu(2);Pu!=Float32Array&&(t[0]=0,t[1]=0);}(),function(t){function e(e){t.call(this,e,Eu);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.createBucket=function(t){return new yu(t)},e.prototype.queryRadius=function(t){var e=t;return ku("circle-radius",this,e)+ku("circle-stroke-width",this,e)+Iu(this.paint.get("circle-translate"))},e.prototype.queryIntersectsFeature=function(t,e,r,i,n,a,s,o){for(var u=zu(t,this.paint.get("circle-translate"),this.paint.get("circle-translate-anchor"),a.angle,s),h=this.paint.get("circle-radius").evaluate(e,r)+this.paint.get("circle-stroke-width").evaluate(e,r),l="map"===this.paint.get("circle-pitch-alignment"),p=l?u:function(t,e){return t.map((function(t){return Du(t,e)}))}(u,o),c=l?h*s:h,f=0,y=i;f<y.length;f+=1)for(var d=0,m=y[f];d<m.length;d+=1){var v=m[d],g=l?v:Du(v,o),x=c,b=Fu([],[v.x,v.y,0,1],o);if("viewport"===this.paint.get("circle-pitch-scale")&&"map"===this.paint.get("circle-pitch-alignment")?x*=b[3]/a.cameraToCenterDistance:"map"===this.paint.get("circle-pitch-scale")&&"viewport"===this.paint.get("circle-pitch-alignment")&&(x*=a.cameraToCenterDistance/b[3]),mu(p,g,x))return !0}return !1},e}(Js));function Du(t,e){var r=Fu([],[t.x,t.y,0,1],e);return new n(r[0]/r[3],r[1]/r[3])}var Nu=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e}(yu);da("HeatmapBucket",Nu,{omit:["layers"]});var Ru={paint:new Hs({"heatmap-radius":new Us(Pa.paint_heatmap["heatmap-radius"]),"heatmap-weight":new Us(Pa.paint_heatmap["heatmap-weight"]),"heatmap-intensity":new js(Pa.paint_heatmap["heatmap-intensity"]),"heatmap-color":new Xs(Pa.paint_heatmap["heatmap-color"]),"heatmap-opacity":new js(Pa.paint_heatmap["heatmap-opacity"])})};function qu(t){var e={},r=t.resolution||256,i=t.clips?t.clips.length:1,n=t.image||new Aa({width:r,height:i}),a=function(r,i,a){e[t.evaluationKey]=a;var s=t.expression.evaluate(e);n.data[r+i+0]=Math.floor(255*s.r/s.a),n.data[r+i+1]=Math.floor(255*s.g/s.a),n.data[r+i+2]=Math.floor(255*s.b/s.a),n.data[r+i+3]=Math.floor(255*s.a);};if(t.clips)for(var s=0,o=0;s<i;++s,o+=4*r)for(var u=0,h=0;u<r;u++,h+=4){var l=u/(r-1),p=t.clips[s];a(o,h,p.start*(1-l)+p.end*l);}else for(var c=0,f=0;c<r;c++,f+=4)a(0,f,c/(r-1));return n}var ju=function(t){function e(e){t.call(this,e,Ru),this._updateColorRamp();}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.createBucket=function(t){return new Nu(t)},e.prototype._handleSpecialPaintPropertyUpdate=function(t){"heatmap-color"===t&&this._updateColorRamp();},e.prototype._updateColorRamp=function(){this.colorRamp=qu({expression:this._transitionablePaint._values["heatmap-color"].value.expression,evaluationKey:"heatmapDensity",image:this.colorRamp}),this.colorRampTexture=null;},e.prototype.resize=function(){this.heatmapFbo&&(this.heatmapFbo.destroy(),this.heatmapFbo=null);},e.prototype.queryRadius=function(){return 0},e.prototype.queryIntersectsFeature=function(){return !1},e.prototype.hasOffscreenPass=function(){return 0!==this.paint.get("heatmap-opacity")&&"none"!==this.visibility},e}(Js),Uu={paint:new Hs({"hillshade-illumination-direction":new js(Pa.paint_hillshade["hillshade-illumination-direction"]),"hillshade-illumination-anchor":new js(Pa.paint_hillshade["hillshade-illumination-anchor"]),"hillshade-exaggeration":new js(Pa.paint_hillshade["hillshade-exaggeration"]),"hillshade-shadow-color":new js(Pa.paint_hillshade["hillshade-shadow-color"]),"hillshade-highlight-color":new js(Pa.paint_hillshade["hillshade-highlight-color"]),"hillshade-accent-color":new js(Pa.paint_hillshade["hillshade-accent-color"])})},Gu=function(t){function e(e){t.call(this,e,Uu);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.hasOffscreenPass=function(){return 0!==this.paint.get("hillshade-exaggeration")&&"none"!==this.visibility},e}(Js),Ku=Qs([{name:"a_pos",components:2,type:"Int16"}],4).members,Xu=Ju,Hu=Ju;function Ju(t,e,r){r=r||2;var i,n,a,s,o,u,h,l=e&&e.length,p=l?e[0]*r:t.length,c=Zu(t,0,p,r,!0),f=[];if(!c||c.next===c.prev)return f;if(l&&(c=function(t,e,r,i){var n,a,s,o=[];for(n=0,a=e.length;n<a;n++)(s=Zu(t,e[n]*i,n<a-1?e[n+1]*i:t.length,i,!1))===s.next&&(s.steiner=!0),o.push(sh(s));for(o.sort(rh),n=0;n<o.length;n++)ih(o[n],r),r=Yu(r,r.next);return r}(t,e,c,r)),t.length>80*r){i=a=t[0],n=s=t[1];for(var y=r;y<p;y+=r)(o=t[y])<i&&(i=o),(u=t[y+1])<n&&(n=u),o>a&&(a=o),u>s&&(s=u);h=0!==(h=Math.max(a-i,s-n))?1/h:0;}return Wu(c,f,r,i,n,h),f}function Zu(t,e,r,i,n){var a,s;if(n===xh(t,e,r,i)>0)for(a=e;a<r;a+=i)s=mh(a,t[a],t[a+1],s);else for(a=r-i;a>=e;a-=i)s=mh(a,t[a],t[a+1],s);return s&&lh(s,s.next)&&(vh(s),s=s.next),s}function Yu(t,e){if(!t)return t;e||(e=t);var r,i=t;do{if(r=!1,i.steiner||!lh(i,i.next)&&0!==hh(i.prev,i,i.next))i=i.next;else {if(vh(i),(i=e=i.prev)===i.next)break;r=!0;}}while(r||i!==e);return e}function Wu(t,e,r,i,n,a,s){if(t){!s&&a&&function(t,e,r,i){var n=t;do{null===n.z&&(n.z=ah(n.x,n.y,e,r,i)),n.prevZ=n.prev,n.nextZ=n.next,n=n.next;}while(n!==t);n.prevZ.nextZ=null,n.prevZ=null,function(t){var e,r,i,n,a,s,o,u,h=1;do{for(r=t,t=null,a=null,s=0;r;){for(s++,i=r,o=0,e=0;e<h&&(o++,i=i.nextZ);e++);for(u=h;o>0||u>0&&i;)0!==o&&(0===u||!i||r.z<=i.z)?(n=r,r=r.nextZ,o--):(n=i,i=i.nextZ,u--),a?a.nextZ=n:t=n,n.prevZ=a,a=n;r=i;}a.nextZ=null,h*=2;}while(s>1)}(n);}(t,i,n,a);for(var o,u,h=t;t.prev!==t.next;)if(o=t.prev,u=t.next,a?$u(t,i,n,a):Qu(t))e.push(o.i/r),e.push(t.i/r),e.push(u.i/r),vh(t),t=u.next,h=u.next;else if((t=u)===h){s?1===s?Wu(t=th(Yu(t),e,r),e,r,i,n,a,2):2===s&&eh(t,e,r,i,n,a):Wu(Yu(t),e,r,i,n,a,1);break}}}function Qu(t){var e=t.prev,r=t,i=t.next;if(hh(e,r,i)>=0)return !1;for(var n=t.next.next;n!==t.prev;){if(oh(e.x,e.y,r.x,r.y,i.x,i.y,n.x,n.y)&&hh(n.prev,n,n.next)>=0)return !1;n=n.next;}return !0}function $u(t,e,r,i){var n=t.prev,a=t,s=t.next;if(hh(n,a,s)>=0)return !1;for(var o=n.x>a.x?n.x>s.x?n.x:s.x:a.x>s.x?a.x:s.x,u=n.y>a.y?n.y>s.y?n.y:s.y:a.y>s.y?a.y:s.y,h=ah(n.x<a.x?n.x<s.x?n.x:s.x:a.x<s.x?a.x:s.x,n.y<a.y?n.y<s.y?n.y:s.y:a.y<s.y?a.y:s.y,e,r,i),l=ah(o,u,e,r,i),p=t.prevZ,c=t.nextZ;p&&p.z>=h&&c&&c.z<=l;){if(p!==t.prev&&p!==t.next&&oh(n.x,n.y,a.x,a.y,s.x,s.y,p.x,p.y)&&hh(p.prev,p,p.next)>=0)return !1;if(p=p.prevZ,c!==t.prev&&c!==t.next&&oh(n.x,n.y,a.x,a.y,s.x,s.y,c.x,c.y)&&hh(c.prev,c,c.next)>=0)return !1;c=c.nextZ;}for(;p&&p.z>=h;){if(p!==t.prev&&p!==t.next&&oh(n.x,n.y,a.x,a.y,s.x,s.y,p.x,p.y)&&hh(p.prev,p,p.next)>=0)return !1;p=p.prevZ;}for(;c&&c.z<=l;){if(c!==t.prev&&c!==t.next&&oh(n.x,n.y,a.x,a.y,s.x,s.y,c.x,c.y)&&hh(c.prev,c,c.next)>=0)return !1;c=c.nextZ;}return !0}function th(t,e,r){var i=t;do{var n=i.prev,a=i.next.next;!lh(n,a)&&ph(n,i,i.next,a)&&yh(n,a)&&yh(a,n)&&(e.push(n.i/r),e.push(i.i/r),e.push(a.i/r),vh(i),vh(i.next),i=t=a),i=i.next;}while(i!==t);return Yu(i)}function eh(t,e,r,i,n,a){var s=t;do{for(var o=s.next.next;o!==s.prev;){if(s.i!==o.i&&uh(s,o)){var u=dh(s,o);return s=Yu(s,s.next),u=Yu(u,u.next),Wu(s,e,r,i,n,a),void Wu(u,e,r,i,n,a)}o=o.next;}s=s.next;}while(s!==t)}function rh(t,e){return t.x-e.x}function ih(t,e){if(e=function(t,e){var r,i=e,n=t.x,a=t.y,s=-1/0;do{if(a<=i.y&&a>=i.next.y&&i.next.y!==i.y){var o=i.x+(a-i.y)*(i.next.x-i.x)/(i.next.y-i.y);if(o<=n&&o>s){if(s=o,o===n){if(a===i.y)return i;if(a===i.next.y)return i.next}r=i.x<i.next.x?i:i.next;}}i=i.next;}while(i!==e);if(!r)return null;if(n===s)return r;var u,h=r,l=r.x,p=r.y,c=1/0;i=r;do{n>=i.x&&i.x>=l&&n!==i.x&&oh(a<p?n:s,a,l,p,a<p?s:n,a,i.x,i.y)&&(u=Math.abs(a-i.y)/(n-i.x),yh(i,t)&&(u<c||u===c&&(i.x>r.x||i.x===r.x&&nh(r,i)))&&(r=i,c=u)),i=i.next;}while(i!==h);return r}(t,e)){var r=dh(e,t);Yu(e,e.next),Yu(r,r.next);}}function nh(t,e){return hh(t.prev,t,e.prev)<0&&hh(e.next,t,t.next)<0}function ah(t,e,r,i,n){return (t=1431655765&((t=858993459&((t=252645135&((t=16711935&((t=32767*(t-r)*n)|t<<8))|t<<4))|t<<2))|t<<1))|(e=1431655765&((e=858993459&((e=252645135&((e=16711935&((e=32767*(e-i)*n)|e<<8))|e<<4))|e<<2))|e<<1))<<1}function sh(t){var e=t,r=t;do{(e.x<r.x||e.x===r.x&&e.y<r.y)&&(r=e),e=e.next;}while(e!==t);return r}function oh(t,e,r,i,n,a,s,o){return (n-s)*(e-o)-(t-s)*(a-o)>=0&&(t-s)*(i-o)-(r-s)*(e-o)>=0&&(r-s)*(a-o)-(n-s)*(i-o)>=0}function uh(t,e){return t.next.i!==e.i&&t.prev.i!==e.i&&!function(t,e){var r=t;do{if(r.i!==t.i&&r.next.i!==t.i&&r.i!==e.i&&r.next.i!==e.i&&ph(r,r.next,t,e))return !0;r=r.next;}while(r!==t);return !1}(t,e)&&(yh(t,e)&&yh(e,t)&&function(t,e){var r=t,i=!1,n=(t.x+e.x)/2,a=(t.y+e.y)/2;do{r.y>a!=r.next.y>a&&r.next.y!==r.y&&n<(r.next.x-r.x)*(a-r.y)/(r.next.y-r.y)+r.x&&(i=!i),r=r.next;}while(r!==t);return i}(t,e)&&(hh(t.prev,t,e.prev)||hh(t,e.prev,e))||lh(t,e)&&hh(t.prev,t,t.next)>0&&hh(e.prev,e,e.next)>0)}function hh(t,e,r){return (e.y-t.y)*(r.x-e.x)-(e.x-t.x)*(r.y-e.y)}function lh(t,e){return t.x===e.x&&t.y===e.y}function ph(t,e,r,i){var n=fh(hh(t,e,r)),a=fh(hh(t,e,i)),s=fh(hh(r,i,t)),o=fh(hh(r,i,e));return n!==a&&s!==o||!(0!==n||!ch(t,r,e))||!(0!==a||!ch(t,i,e))||!(0!==s||!ch(r,t,i))||!(0!==o||!ch(r,e,i))}function ch(t,e,r){return e.x<=Math.max(t.x,r.x)&&e.x>=Math.min(t.x,r.x)&&e.y<=Math.max(t.y,r.y)&&e.y>=Math.min(t.y,r.y)}function fh(t){return t>0?1:t<0?-1:0}function yh(t,e){return hh(t.prev,t,t.next)<0?hh(t,e,t.next)>=0&&hh(t,t.prev,e)>=0:hh(t,e,t.prev)<0||hh(t,t.next,e)<0}function dh(t,e){var r=new gh(t.i,t.x,t.y),i=new gh(e.i,e.x,e.y),n=t.next,a=e.prev;return t.next=e,e.prev=t,r.next=n,n.prev=r,i.next=r,r.prev=i,a.next=i,i.prev=a,i}function mh(t,e,r,i){var n=new gh(t,e,r);return i?(n.next=i.next,n.prev=i,i.next.prev=n,i.next=n):(n.prev=n,n.next=n),n}function vh(t){t.next.prev=t.prev,t.prev.next=t.next,t.prevZ&&(t.prevZ.nextZ=t.nextZ),t.nextZ&&(t.nextZ.prevZ=t.prevZ);}function gh(t,e,r){this.i=t,this.x=e,this.y=r,this.prev=null,this.next=null,this.z=null,this.prevZ=null,this.nextZ=null,this.steiner=!1;}function xh(t,e,r,i){for(var n=0,a=e,s=r-i;a<r;a+=i)n+=(t[s]-t[a])*(t[a+1]+t[s+1]),s=a;return n}function bh(t,e,r,i,n){!function t(e,r,i,n,a){for(;n>i;){if(n-i>600){var s=n-i+1,o=r-i+1,u=Math.log(s),h=.5*Math.exp(2*u/3),l=.5*Math.sqrt(u*h*(s-h)/s)*(o-s/2<0?-1:1);t(e,r,Math.max(i,Math.floor(r-o*h/s+l)),Math.min(n,Math.floor(r+(s-o)*h/s+l)),a);}var p=e[r],c=i,f=n;for(_h(e,i,r),a(e[n],p)>0&&_h(e,i,n);c<f;){for(_h(e,c,f),c++,f--;a(e[c],p)<0;)c++;for(;a(e[f],p)>0;)f--;}0===a(e[i],p)?_h(e,i,f):_h(e,++f,n),f<=r&&(i=f+1),r<=f&&(n=f-1);}}(t,e,r||0,i||t.length-1,n||wh);}function _h(t,e,r){var i=t[e];t[e]=t[r],t[r]=i;}function wh(t,e){return t<e?-1:t>e?1:0}function Mh(t,e){var r=t.length;if(r<=1)return [t];for(var i,n,a=[],s=0;s<r;s++){var o=A(t[s]);0!==o&&(t[s].area=Math.abs(o),void 0===n&&(n=o<0),n===o<0?(i&&a.push(i),i=[t[s]]):i.push(t[s]));}if(i&&a.push(i),e>1)for(var u=0;u<a.length;u++)a[u].length<=e||(bh(a[u],e,1,a[u].length-1,Sh),a[u]=a[u].slice(0,e));return a}function Sh(t,e){return e.area-t.area}function Ah(t,e,r){for(var i=r.patternDependencies,n=!1,a=0,s=e;a<s.length;a+=1){var o=s[a].paint.get(t+"-pattern");o.isConstant()||(n=!0);var u=o.constantOr(null);u&&(n=!0,i[u.to]=!0,i[u.from]=!0);}return n}function kh(t,e,r,i,n){for(var a=n.patternDependencies,s=0,o=e;s<o.length;s+=1){var u=o[s],h=u.paint.get(t+"-pattern").value;if("constant"!==h.kind){var l=h.evaluate({zoom:i-1},r,{},n.availableImages),p=h.evaluate({zoom:i},r,{},n.availableImages),c=h.evaluate({zoom:i+1},r,{},n.availableImages);p=p&&p.name?p.name:p,c=c&&c.name?c.name:c,a[l=l&&l.name?l.name:l]=!0,a[p]=!0,a[c]=!0,r.patterns[u.id]={min:l,mid:p,max:c};}}return r}Ju.deviation=function(t,e,r,i){var n=e&&e.length,a=Math.abs(xh(t,0,n?e[0]*r:t.length,r));if(n)for(var s=0,o=e.length;s<o;s++)a-=Math.abs(xh(t,e[s]*r,s<o-1?e[s+1]*r:t.length,r));var u=0;for(s=0;s<i.length;s+=3){var h=i[s]*r,l=i[s+1]*r,p=i[s+2]*r;u+=Math.abs((t[h]-t[p])*(t[l+1]-t[h+1])-(t[h]-t[l])*(t[p+1]-t[h+1]));}return 0===a&&0===u?0:Math.abs((u-a)/a)},Ju.flatten=function(t){for(var e=t[0][0].length,r={vertices:[],holes:[],dimensions:e},i=0,n=0;n<t.length;n++){for(var a=0;a<t[n].length;a++)for(var s=0;s<e;s++)r.vertices.push(t[n][a][s]);n>0&&r.holes.push(i+=t[n-1].length);}return r},Xu.default=Hu;var Ih=function(t){this.zoom=t.zoom,this.overscaling=t.overscaling,this.layers=t.layers,this.layerIds=this.layers.map((function(t){return t.id})),this.index=t.index,this.hasPattern=!1,this.patternFeatures=[],this.layoutVertexArray=new to,this.indexArray=new fo,this.indexArray2=new bo,this.programConfigurations=new ou(t.layers,t.zoom),this.segments=new Vo,this.segments2=new Vo,this.stateDependentLayerIds=this.layers.filter((function(t){return t.isStateDependent()})).map((function(t){return t.id}));};Ih.prototype.populate=function(t,e,r){this.hasPattern=Ah("fill",this.layers,e);for(var i=this.layers[0].layout.get("fill-sort-key"),n=[],a=0,s=t;a<s.length;a+=1){var o=s[a],u=o.feature,h=o.id,l=o.index,p=o.sourceLayerIndex,c=this.layers[0]._featureFilter.needGeometry,f={type:u.type,id:h,properties:u.properties,geometry:c?cu(u):[]};if(this.layers[0]._featureFilter.filter(new Ts(this.zoom),f,r)){c||(f.geometry=cu(u));var y=i?i.evaluate(f,{},r,e.availableImages):void 0;n.push({id:h,properties:u.properties,type:u.type,sourceLayerIndex:p,index:l,geometry:f.geometry,patterns:{},sortKey:y});}}i&&n.sort((function(t,e){return t.sortKey-e.sortKey}));for(var d=0,m=n;d<m.length;d+=1){var v=m[d],g=v.geometry,x=v.index,b=v.sourceLayerIndex;if(this.hasPattern){var _=kh("fill",this.layers,v,this.zoom,e);this.patternFeatures.push(_);}else this.addFeature(v,g,x,r,{});e.featureIndex.insert(t[x].feature,g,x,b,this.index);}},Ih.prototype.update=function(t,e,r){this.stateDependentLayers.length&&this.programConfigurations.updatePaintArrays(t,e,this.stateDependentLayers,r);},Ih.prototype.addFeatures=function(t,e,r){for(var i=0,n=this.patternFeatures;i<n.length;i+=1){var a=n[i];this.addFeature(a,a.geometry,a.index,e,r);}},Ih.prototype.isEmpty=function(){return 0===this.layoutVertexArray.length},Ih.prototype.uploadPending=function(){return !this.uploaded||this.programConfigurations.needsUpload},Ih.prototype.upload=function(t){this.uploaded||(this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,Ku),this.indexBuffer=t.createIndexBuffer(this.indexArray),this.indexBuffer2=t.createIndexBuffer(this.indexArray2)),this.programConfigurations.upload(t),this.uploaded=!0;},Ih.prototype.destroy=function(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.indexBuffer2.destroy(),this.programConfigurations.destroy(),this.segments.destroy(),this.segments2.destroy());},Ih.prototype.addFeature=function(t,e,r,i,n){for(var a=0,s=Mh(e,500);a<s.length;a+=1){for(var o=s[a],u=0,h=0,l=o;h<l.length;h+=1)u+=l[h].length;for(var p=this.segments.prepareSegment(u,this.layoutVertexArray,this.indexArray),c=p.vertexLength,f=[],y=[],d=0,m=o;d<m.length;d+=1){var v=m[d];if(0!==v.length){v!==o[0]&&y.push(f.length/2);var g=this.segments2.prepareSegment(v.length,this.layoutVertexArray,this.indexArray2),x=g.vertexLength;this.layoutVertexArray.emplaceBack(v[0].x,v[0].y),this.indexArray2.emplaceBack(x+v.length-1,x),f.push(v[0].x),f.push(v[0].y);for(var b=1;b<v.length;b++)this.layoutVertexArray.emplaceBack(v[b].x,v[b].y),this.indexArray2.emplaceBack(x+b-1,x+b),f.push(v[b].x),f.push(v[b].y);g.vertexLength+=v.length,g.primitiveLength+=v.length;}}for(var _=Xu(f,y),w=0;w<_.length;w+=3)this.indexArray.emplaceBack(c+_[w],c+_[w+1],c+_[w+2]);p.vertexLength+=u,p.primitiveLength+=_.length/3;}this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,t,r,n,i);},da("FillBucket",Ih,{omit:["layers","patternFeatures"]});var zh=new Hs({"fill-sort-key":new Us(Pa.layout_fill["fill-sort-key"])}),Ch={paint:new Hs({"fill-antialias":new js(Pa.paint_fill["fill-antialias"]),"fill-opacity":new Us(Pa.paint_fill["fill-opacity"]),"fill-color":new Us(Pa.paint_fill["fill-color"]),"fill-outline-color":new Us(Pa.paint_fill["fill-outline-color"]),"fill-translate":new js(Pa.paint_fill["fill-translate"]),"fill-translate-anchor":new js(Pa.paint_fill["fill-translate-anchor"]),"fill-pattern":new Gs(Pa.paint_fill["fill-pattern"])}),layout:zh},Eh=function(t){function e(e){t.call(this,e,Ch);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.recalculate=function(e,r){t.prototype.recalculate.call(this,e,r);var i=this.paint._values["fill-outline-color"];"constant"===i.value.kind&&void 0===i.value.value&&(this.paint._values["fill-outline-color"]=this.paint._values["fill-color"]);},e.prototype.createBucket=function(t){return new Ih(t)},e.prototype.queryRadius=function(){return Iu(this.paint.get("fill-translate"))},e.prototype.queryIntersectsFeature=function(t,e,r,i,n,a,s){return vu(zu(t,this.paint.get("fill-translate"),this.paint.get("fill-translate-anchor"),a.angle,s),i)},e.prototype.isTileClipped=function(){return !0},e}(Js),Ph=Qs([{name:"a_pos",components:2,type:"Int16"},{name:"a_normal_ed",components:4,type:"Int16"}],4).members,Bh=Th;function Th(t,e,r,i,n){this.properties={},this.extent=r,this.type=0,this._pbf=t,this._geometry=-1,this._keys=i,this._values=n,t.readFields(Vh,this,e);}function Vh(t,e,r){1==t?e.id=r.readVarint():2==t?function(t,e){for(var r=t.readVarint()+t.pos;t.pos<r;){var i=e._keys[t.readVarint()],n=e._values[t.readVarint()];e.properties[i]=n;}}(r,e):3==t?e.type=r.readVarint():4==t&&(e._geometry=r.pos);}function Lh(t){for(var e,r,i=0,n=0,a=t.length,s=a-1;n<a;s=n++)i+=((r=t[s]).x-(e=t[n]).x)*(e.y+r.y);return i}Th.types=["Unknown","Point","LineString","Polygon"],Th.prototype.loadGeometry=function(){var t=this._pbf;t.pos=this._geometry;for(var e,r=t.readVarint()+t.pos,i=1,a=0,s=0,o=0,u=[];t.pos<r;){if(a<=0){var h=t.readVarint();i=7&h,a=h>>3;}if(a--,1===i||2===i)s+=t.readSVarint(),o+=t.readSVarint(),1===i&&(e&&u.push(e),e=[]),e.push(new n(s,o));else {if(7!==i)throw new Error("unknown command "+i);e&&e.push(e[0].clone());}}return e&&u.push(e),u},Th.prototype.bbox=function(){var t=this._pbf;t.pos=this._geometry;for(var e=t.readVarint()+t.pos,r=1,i=0,n=0,a=0,s=1/0,o=-1/0,u=1/0,h=-1/0;t.pos<e;){if(i<=0){var l=t.readVarint();r=7&l,i=l>>3;}if(i--,1===r||2===r)(n+=t.readSVarint())<s&&(s=n),n>o&&(o=n),(a+=t.readSVarint())<u&&(u=a),a>h&&(h=a);else if(7!==r)throw new Error("unknown command "+r)}return [s,u,o,h]},Th.prototype.toGeoJSON=function(t,e,r,i){var n,a,s=this.extent*Math.pow(2,r),o=this.extent*t,u=this.extent*e,h=this.loadGeometry(),l=Th.types[this.type];function p(t){for(var e=0;e<t.length;e++){var r=t[e];t[e]=i((r.x+o)/s,(r.y+u)/s);}}switch(this.type){case 1:var c=[];for(n=0;n<h.length;n++)c[n]=h[n][0];p(h=c);break;case 2:for(n=0;n<h.length;n++)p(h[n]);break;case 3:for(h=function(t){var e=t.length;if(e<=1)return [t];for(var r,i,n=[],a=0;a<e;a++){var s=Lh(t[a]);0!==s&&(void 0===i&&(i=s<0),i===s<0?(r&&n.push(r),r=[t[a]]):r.push(t[a]));}return r&&n.push(r),n}(h),n=0;n<h.length;n++)for(a=0;a<h[n].length;a++)p(h[n][a]);}1===h.length?h=h[0]:l="Multi"+l;var f={type:"Feature",geometry:{type:l,coordinates:h},properties:this.properties};return "id"in this&&(f.id=this.id),f};var Fh=Oh;function Oh(t,e){this.version=1,this.name=null,this.extent=4096,this.length=0,this._pbf=t,this._keys=[],this._values=[],this._features=[],t.readFields(Dh,this,e),this.length=this._features.length;}function Dh(t,e,r){15===t?e.version=r.readVarint():1===t?e.name=r.readString():5===t?e.extent=r.readVarint():2===t?e._features.push(r.pos):3===t?e._keys.push(r.readString()):4===t&&e._values.push(function(t){for(var e=null,r=t.readVarint()+t.pos;t.pos<r;){var i=t.readVarint()>>3;e=1===i?t.readString():2===i?t.readFloat():3===i?t.readDouble():4===i?t.readVarint64():5===i?t.readVarint():6===i?t.readSVarint():7===i?t.readBoolean():null;}return e}(r));}function Nh(t,e,r){if(3===t){var i=new Fh(r,r.readVarint()+r.pos);i.length&&(e[i.name]=i);}}Oh.prototype.feature=function(t){if(t<0||t>=this._features.length)throw new Error("feature index out of bounds");this._pbf.pos=this._features[t];var e=this._pbf.readVarint()+this._pbf.pos;return new Bh(this._pbf,e,this.extent,this._keys,this._values)};var Rh=function(t,e){this.layers=t.readFields(Nh,{},e);},qh=Fh,jh={VectorTile:Rh,VectorTileFeature:Bh,VectorTileLayer:qh},Uh=jh.VectorTileFeature.types,Gh=Math.pow(2,13);function Kh(t,e,r,i,n,a,s,o){t.emplaceBack(e,r,2*Math.floor(i*Gh)+s,n*Gh*2,a*Gh*2,Math.round(o));}var Xh=function(t){this.zoom=t.zoom,this.overscaling=t.overscaling,this.layers=t.layers,this.layerIds=this.layers.map((function(t){return t.id})),this.index=t.index,this.hasPattern=!1,this.layoutVertexArray=new ro,this.indexArray=new fo,this.programConfigurations=new ou(t.layers,t.zoom),this.segments=new Vo,this.stateDependentLayerIds=this.layers.filter((function(t){return t.isStateDependent()})).map((function(t){return t.id}));};function Hh(t,e){return t.x===e.x&&(t.x<0||t.x>8192)||t.y===e.y&&(t.y<0||t.y>8192)}Xh.prototype.populate=function(t,e,r){this.features=[],this.hasPattern=Ah("fill-extrusion",this.layers,e);for(var i=0,n=t;i<n.length;i+=1){var a=n[i],s=a.feature,o=a.id,u=a.index,h=a.sourceLayerIndex,l=this.layers[0]._featureFilter.needGeometry,p={type:s.type,id:o,properties:s.properties,geometry:l?cu(s):[]};if(this.layers[0]._featureFilter.filter(new Ts(this.zoom),p,r)){var c={id:o,sourceLayerIndex:h,index:u,geometry:l?p.geometry:cu(s),properties:s.properties,type:s.type,patterns:{}};this.hasPattern?this.features.push(kh("fill-extrusion",this.layers,c,this.zoom,e)):this.addFeature(c,c.geometry,u,r,{}),e.featureIndex.insert(s,c.geometry,u,h,this.index,!0);}}},Xh.prototype.addFeatures=function(t,e,r){for(var i=0,n=this.features;i<n.length;i+=1){var a=n[i];this.addFeature(a,a.geometry,a.index,e,r);}},Xh.prototype.update=function(t,e,r){this.stateDependentLayers.length&&this.programConfigurations.updatePaintArrays(t,e,this.stateDependentLayers,r);},Xh.prototype.isEmpty=function(){return 0===this.layoutVertexArray.length},Xh.prototype.uploadPending=function(){return !this.uploaded||this.programConfigurations.needsUpload},Xh.prototype.upload=function(t){this.uploaded||(this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,Ph),this.indexBuffer=t.createIndexBuffer(this.indexArray)),this.programConfigurations.upload(t),this.uploaded=!0;},Xh.prototype.destroy=function(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy());},Xh.prototype.addFeature=function(t,e,r,i,n){for(var a=0,s=Mh(e,500);a<s.length;a+=1){for(var o=s[a],u=0,h=0,l=o;h<l.length;h+=1)u+=l[h].length;for(var p=this.segments.prepareSegment(4,this.layoutVertexArray,this.indexArray),c=0,f=o;c<f.length;c+=1){var y=f[c];if(0!==y.length&&!((B=y).every((function(t){return t.x<0}))||B.every((function(t){return t.x>8192}))||B.every((function(t){return t.y<0}))||B.every((function(t){return t.y>8192}))))for(var d=0,m=0;m<y.length;m++){var v=y[m];if(m>=1){var g=y[m-1];if(!Hh(v,g)){p.vertexLength+4>Vo.MAX_VERTEX_ARRAY_LENGTH&&(p=this.segments.prepareSegment(4,this.layoutVertexArray,this.indexArray));var x=v.sub(g)._perp()._unit(),b=g.dist(v);d+b>32768&&(d=0),Kh(this.layoutVertexArray,v.x,v.y,x.x,x.y,0,0,d),Kh(this.layoutVertexArray,v.x,v.y,x.x,x.y,0,1,d),Kh(this.layoutVertexArray,g.x,g.y,x.x,x.y,0,0,d+=b),Kh(this.layoutVertexArray,g.x,g.y,x.x,x.y,0,1,d);var _=p.vertexLength;this.indexArray.emplaceBack(_,_+2,_+1),this.indexArray.emplaceBack(_+1,_+2,_+3),p.vertexLength+=4,p.primitiveLength+=2;}}}}if(p.vertexLength+u>Vo.MAX_VERTEX_ARRAY_LENGTH&&(p=this.segments.prepareSegment(u,this.layoutVertexArray,this.indexArray)),"Polygon"===Uh[t.type]){for(var w=[],M=[],S=p.vertexLength,A=0,k=o;A<k.length;A+=1){var I=k[A];if(0!==I.length){I!==o[0]&&M.push(w.length/2);for(var z=0;z<I.length;z++){var C=I[z];Kh(this.layoutVertexArray,C.x,C.y,0,0,1,1,0),w.push(C.x),w.push(C.y);}}}for(var E=Xu(w,M),P=0;P<E.length;P+=3)this.indexArray.emplaceBack(S+E[P],S+E[P+2],S+E[P+1]);p.primitiveLength+=E.length/3,p.vertexLength+=u;}}var B;this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,t,r,n,i);},da("FillExtrusionBucket",Xh,{omit:["layers","features"]});var Jh={paint:new Hs({"fill-extrusion-opacity":new js(Pa["paint_fill-extrusion"]["fill-extrusion-opacity"]),"fill-extrusion-color":new Us(Pa["paint_fill-extrusion"]["fill-extrusion-color"]),"fill-extrusion-translate":new js(Pa["paint_fill-extrusion"]["fill-extrusion-translate"]),"fill-extrusion-translate-anchor":new js(Pa["paint_fill-extrusion"]["fill-extrusion-translate-anchor"]),"fill-extrusion-pattern":new Gs(Pa["paint_fill-extrusion"]["fill-extrusion-pattern"]),"fill-extrusion-height":new Us(Pa["paint_fill-extrusion"]["fill-extrusion-height"]),"fill-extrusion-base":new Us(Pa["paint_fill-extrusion"]["fill-extrusion-base"]),"fill-extrusion-vertical-gradient":new js(Pa["paint_fill-extrusion"]["fill-extrusion-vertical-gradient"])})},Zh=function(t){function e(e){t.call(this,e,Jh);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.createBucket=function(t){return new Xh(t)},e.prototype.queryRadius=function(){return Iu(this.paint.get("fill-extrusion-translate"))},e.prototype.is3D=function(){return !0},e.prototype.queryIntersectsFeature=function(t,e,r,i,a,s,o,u){var h=zu(t,this.paint.get("fill-extrusion-translate"),this.paint.get("fill-extrusion-translate-anchor"),s.angle,o),l=this.paint.get("fill-extrusion-height").evaluate(e,r),p=this.paint.get("fill-extrusion-base").evaluate(e,r),c=function(t,e,r,i){for(var a=[],s=0,o=t;s<o.length;s+=1){var u=o[s],h=[u.x,u.y,0,1];Fu(h,h,e),a.push(new n(h[0]/h[3],h[1]/h[3]));}return a}(h,u),f=function(t,e,r,i){for(var a=[],s=[],o=i[8]*e,u=i[9]*e,h=i[10]*e,l=i[11]*e,p=i[8]*r,c=i[9]*r,f=i[10]*r,y=i[11]*r,d=0,m=t;d<m.length;d+=1){for(var v=[],g=[],x=0,b=m[d];x<b.length;x+=1){var _=b[x],w=_.x,M=_.y,S=i[0]*w+i[4]*M+i[12],A=i[1]*w+i[5]*M+i[13],k=i[2]*w+i[6]*M+i[14],I=i[3]*w+i[7]*M+i[15],z=k+h,C=I+l,E=S+p,P=A+c,B=k+f,T=I+y,V=new n((S+o)/C,(A+u)/C);V.z=z/C,v.push(V);var L=new n(E/T,P/T);L.z=B/T,g.push(L);}a.push(v),s.push(g);}return [a,s]}(i,p,l,u);return function(t,e,r){var i=1/0;vu(r,e)&&(i=Wh(r,e[0]));for(var n=0;n<e.length;n++)for(var a=e[n],s=t[n],o=0;o<a.length-1;o++){var u=a[o],h=[u,a[o+1],s[o+1],s[o],u];du(r,h)&&(i=Math.min(i,Wh(r,h)));}return i!==1/0&&i}(f[0],f[1],c)},e}(Js);function Yh(t,e){return t.x*e.x+t.y*e.y}function Wh(t,e){if(1===t.length){for(var r,i=0,n=e[i++];!r||n.equals(r);)if(!(r=e[i++]))return 1/0;for(;i<e.length;i++){var a=e[i],s=t[0],o=r.sub(n),u=a.sub(n),h=s.sub(n),l=Yh(o,o),p=Yh(o,u),c=Yh(u,u),f=Yh(h,o),y=Yh(h,u),d=l*c-p*p,m=(c*f-p*y)/d,v=(l*y-p*f)/d,g=n.z*(1-m-v)+r.z*m+a.z*v;if(isFinite(g))return g}return 1/0}for(var x=1/0,b=0,_=e;b<_.length;b+=1)x=Math.min(x,_[b].z);return x}var Qh=Qs([{name:"a_pos_normal",components:2,type:"Int16"},{name:"a_data",components:4,type:"Uint8"}],4).members,$h=Qs([{name:"a_uv_x",components:1,type:"Float32"},{name:"a_split_index",components:1,type:"Float32"}]).members,tl=jh.VectorTileFeature.types,el=Math.cos(Math.PI/180*37.5),rl=Math.pow(2,14)/.5,il=function(t){var e=this;this.zoom=t.zoom,this.overscaling=t.overscaling,this.layers=t.layers,this.layerIds=this.layers.map((function(t){return t.id})),this.index=t.index,this.hasPattern=!1,this.patternFeatures=[],this.lineClipsArray=[],this.gradients={},this.layers.forEach((function(t){e.gradients[t.id]={};})),this.layoutVertexArray=new io,this.layoutVertexArray2=new no,this.indexArray=new fo,this.programConfigurations=new ou(t.layers,t.zoom),this.segments=new Vo,this.maxLineLength=0,this.stateDependentLayerIds=this.layers.filter((function(t){return t.isStateDependent()})).map((function(t){return t.id}));};il.prototype.populate=function(t,e,r){this.hasPattern=Ah("line",this.layers,e);for(var i=this.layers[0].layout.get("line-sort-key"),n=[],a=0,s=t;a<s.length;a+=1){var o=s[a],u=o.feature,h=o.id,l=o.index,p=o.sourceLayerIndex,c=this.layers[0]._featureFilter.needGeometry,f={type:u.type,id:h,properties:u.properties,geometry:c?cu(u):[]};if(this.layers[0]._featureFilter.filter(new Ts(this.zoom),f,r)){c||(f.geometry=cu(u));var y=i?i.evaluate(f,{},r):void 0;n.push({id:h,properties:u.properties,type:u.type,sourceLayerIndex:p,index:l,geometry:f.geometry,patterns:{},sortKey:y});}}i&&n.sort((function(t,e){return t.sortKey-e.sortKey}));for(var d=0,m=n;d<m.length;d+=1){var v=m[d],g=v.geometry,x=v.index,b=v.sourceLayerIndex;if(this.hasPattern){var _=kh("line",this.layers,v,this.zoom,e);this.patternFeatures.push(_);}else this.addFeature(v,g,x,r,{});e.featureIndex.insert(t[x].feature,g,x,b,this.index);}},il.prototype.update=function(t,e,r){this.stateDependentLayers.length&&this.programConfigurations.updatePaintArrays(t,e,this.stateDependentLayers,r);},il.prototype.addFeatures=function(t,e,r){for(var i=0,n=this.patternFeatures;i<n.length;i+=1){var a=n[i];this.addFeature(a,a.geometry,a.index,e,r);}},il.prototype.isEmpty=function(){return 0===this.layoutVertexArray.length},il.prototype.uploadPending=function(){return !this.uploaded||this.programConfigurations.needsUpload},il.prototype.upload=function(t){this.uploaded||(0!==this.layoutVertexArray2.length&&(this.layoutVertexBuffer2=t.createVertexBuffer(this.layoutVertexArray2,$h)),this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,Qh),this.indexBuffer=t.createIndexBuffer(this.indexArray)),this.programConfigurations.upload(t),this.uploaded=!0;},il.prototype.destroy=function(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy());},il.prototype.lineFeatureClips=function(t){if(t.properties&&t.properties.hasOwnProperty("mapbox_clip_start")&&t.properties.hasOwnProperty("mapbox_clip_end"))return {start:+t.properties.mapbox_clip_start,end:+t.properties.mapbox_clip_end}},il.prototype.addFeature=function(t,e,r,i,n){var a=this.layers[0].layout,s=a.get("line-join").evaluate(t,{}),o=a.get("line-cap"),u=a.get("line-miter-limit"),h=a.get("line-round-limit");this.lineClips=this.lineFeatureClips(t);for(var l=0,p=e;l<p.length;l+=1)this.addLine(p[l],t,s,o,u,h);this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length,t,r,n,i);},il.prototype.addLine=function(t,e,r,i,n,a){if(this.distance=0,this.scaledDistance=0,this.totalDistance=0,this.lineClips){this.lineClipsArray.push(this.lineClips);for(var s=0;s<t.length-1;s++)this.totalDistance+=t[s].dist(t[s+1]);this.updateScaledDistance(),this.maxLineLength=Math.max(this.maxLineLength,this.totalDistance);}for(var o="Polygon"===tl[e.type],u=t.length;u>=2&&t[u-1].equals(t[u-2]);)u--;for(var h=0;h<u-1&&t[h].equals(t[h+1]);)h++;if(!(u<(o?3:2))){"bevel"===r&&(n=1.05);var l,p=this.overscaling<=16?122880/(512*this.overscaling):0,c=this.segments.prepareSegment(10*u,this.layoutVertexArray,this.indexArray),f=void 0,y=void 0,d=void 0,m=void 0;this.e1=this.e2=-1,o&&(m=t[h].sub(l=t[u-2])._unit()._perp());for(var v=h;v<u;v++)if(!(y=v===u-1?o?t[h+1]:void 0:t[v+1])||!t[v].equals(y)){m&&(d=m),l&&(f=l),l=t[v],m=y?y.sub(l)._unit()._perp():d;var g=(d=d||m).add(m);0===g.x&&0===g.y||g._unit();var x=d.x*m.x+d.y*m.y,b=g.x*m.x+g.y*m.y,_=0!==b?1/b:1/0,w=2*Math.sqrt(2-2*b),M=b<el&&f&&y,S=d.x*m.y-d.y*m.x>0;if(M&&v>h){var A=l.dist(f);if(A>2*p){var k=l.sub(l.sub(f)._mult(p/A)._round());this.updateDistance(f,k),this.addCurrentVertex(k,d,0,0,c),f=k;}}var I=f&&y,z=I?r:o?"butt":i;if(I&&"round"===z&&(_<a?z="miter":_<=2&&(z="fakeround")),"miter"===z&&_>n&&(z="bevel"),"bevel"===z&&(_>2&&(z="flipbevel"),_<n&&(z="miter")),f&&this.updateDistance(f,l),"miter"===z)g._mult(_),this.addCurrentVertex(l,g,0,0,c);else if("flipbevel"===z){if(_>100)g=m.mult(-1);else {var C=_*d.add(m).mag()/d.sub(m).mag();g._perp()._mult(C*(S?-1:1));}this.addCurrentVertex(l,g,0,0,c),this.addCurrentVertex(l,g.mult(-1),0,0,c);}else if("bevel"===z||"fakeround"===z){var E=-Math.sqrt(_*_-1),P=S?E:0,B=S?0:E;if(f&&this.addCurrentVertex(l,d,P,B,c),"fakeround"===z)for(var T=Math.round(180*w/Math.PI/20),V=1;V<T;V++){var L=V/T;if(.5!==L){var F=L-.5;L+=L*F*(L-1)*((1.0904+x*(x*(3.55645-1.43519*x)-3.2452))*F*F+(.848013+x*(.215638*x-1.06021)));}var O=m.sub(d)._mult(L)._add(d)._unit()._mult(S?-1:1);this.addHalfVertex(l,O.x,O.y,!1,S,0,c);}y&&this.addCurrentVertex(l,m,-P,-B,c);}else if("butt"===z)this.addCurrentVertex(l,g,0,0,c);else if("square"===z){var D=f?1:-1;this.addCurrentVertex(l,g,D,D,c);}else "round"===z&&(f&&(this.addCurrentVertex(l,d,0,0,c),this.addCurrentVertex(l,d,1,1,c,!0)),y&&(this.addCurrentVertex(l,m,-1,-1,c,!0),this.addCurrentVertex(l,m,0,0,c)));if(M&&v<u-1){var N=l.dist(y);if(N>2*p){var R=l.add(y.sub(l)._mult(p/N)._round());this.updateDistance(l,R),this.addCurrentVertex(R,m,0,0,c),l=R;}}}}},il.prototype.addCurrentVertex=function(t,e,r,i,n,a){void 0===a&&(a=!1);var s=e.y*i-e.x,o=-e.y-e.x*i;this.addHalfVertex(t,e.x+e.y*r,e.y-e.x*r,a,!1,r,n),this.addHalfVertex(t,s,o,a,!0,-i,n),this.distance>rl/2&&0===this.totalDistance&&(this.distance=0,this.addCurrentVertex(t,e,r,i,n,a));},il.prototype.addHalfVertex=function(t,e,r,i,n,a,s){var o=.5*(this.lineClips?this.scaledDistance*(rl-1):this.scaledDistance);this.layoutVertexArray.emplaceBack((t.x<<1)+(i?1:0),(t.y<<1)+(n?1:0),Math.round(63*e)+128,Math.round(63*r)+128,1+(0===a?0:a<0?-1:1)|(63&o)<<2,o>>6),this.lineClips&&this.layoutVertexArray2.emplaceBack((this.scaledDistance-this.lineClips.start)/(this.lineClips.end-this.lineClips.start),this.lineClipsArray.length);var u=s.vertexLength++;this.e1>=0&&this.e2>=0&&(this.indexArray.emplaceBack(this.e1,this.e2,u),s.primitiveLength++),n?this.e2=u:this.e1=u;},il.prototype.updateScaledDistance=function(){this.scaledDistance=this.lineClips?this.lineClips.start+(this.lineClips.end-this.lineClips.start)*this.distance/this.totalDistance:this.distance;},il.prototype.updateDistance=function(t,e){this.distance+=t.dist(e),this.updateScaledDistance();},da("LineBucket",il,{omit:["layers","patternFeatures"]});var nl=new Hs({"line-cap":new js(Pa.layout_line["line-cap"]),"line-join":new Us(Pa.layout_line["line-join"]),"line-miter-limit":new js(Pa.layout_line["line-miter-limit"]),"line-round-limit":new js(Pa.layout_line["line-round-limit"]),"line-sort-key":new Us(Pa.layout_line["line-sort-key"])}),al={paint:new Hs({"line-opacity":new Us(Pa.paint_line["line-opacity"]),"line-color":new Us(Pa.paint_line["line-color"]),"line-translate":new js(Pa.paint_line["line-translate"]),"line-translate-anchor":new js(Pa.paint_line["line-translate-anchor"]),"line-width":new Us(Pa.paint_line["line-width"]),"line-gap-width":new Us(Pa.paint_line["line-gap-width"]),"line-offset":new Us(Pa.paint_line["line-offset"]),"line-blur":new Us(Pa.paint_line["line-blur"]),"line-dasharray":new Ks(Pa.paint_line["line-dasharray"]),"line-pattern":new Gs(Pa.paint_line["line-pattern"]),"line-gradient":new Xs(Pa.paint_line["line-gradient"])}),layout:nl},sl=new(function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.possiblyEvaluate=function(e,r){return r=new Ts(Math.floor(r.zoom),{now:r.now,fadeDuration:r.fadeDuration,zoomHistory:r.zoomHistory,transition:r.transition}),t.prototype.possiblyEvaluate.call(this,e,r)},e.prototype.evaluate=function(e,r,i,n){return r=c({},r,{zoom:Math.floor(r.zoom)}),t.prototype.evaluate.call(this,e,r,i,n)},e}(Us))(al.paint.properties["line-width"].specification);sl.useIntegerZoom=!0;var ol=function(t){function e(e){t.call(this,e,al),this.gradientVersion=0;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._handleSpecialPaintPropertyUpdate=function(t){"line-gradient"===t&&(this.stepInterpolant=this._transitionablePaint._values["line-gradient"].value.expression._styleExpression.expression instanceof nn,this.gradientVersion=(this.gradientVersion+1)%o);},e.prototype.gradientExpression=function(){return this._transitionablePaint._values["line-gradient"].value.expression},e.prototype.recalculate=function(e,r){t.prototype.recalculate.call(this,e,r),this.paint._values["line-floorwidth"]=sl.possiblyEvaluate(this._transitioningPaint._values["line-width"].value,e);},e.prototype.createBucket=function(t){return new il(t)},e.prototype.queryRadius=function(t){var e=t,r=ul(ku("line-width",this,e),ku("line-gap-width",this,e)),i=ku("line-offset",this,e);return r/2+Math.abs(i)+Iu(this.paint.get("line-translate"))},e.prototype.queryIntersectsFeature=function(t,e,r,i,a,s,o){var u=zu(t,this.paint.get("line-translate"),this.paint.get("line-translate-anchor"),s.angle,o),h=o/2*ul(this.paint.get("line-width").evaluate(e,r),this.paint.get("line-gap-width").evaluate(e,r)),l=this.paint.get("line-offset").evaluate(e,r);return l&&(i=function(t,e){for(var r=[],i=new n(0,0),a=0;a<t.length;a++){for(var s=t[a],o=[],u=0;u<s.length;u++){var h=s[u],l=s[u+1],p=0===u?i:h.sub(s[u-1])._unit()._perp(),c=u===s.length-1?i:l.sub(h)._unit()._perp(),f=p._add(c)._unit();f._mult(1/(f.x*c.x+f.y*c.y)),o.push(f._mult(e)._add(h));}r.push(o);}return r}(i,l*o)),function(t,e,r){for(var i=0;i<e.length;i++){var n=e[i];if(t.length>=3)for(var a=0;a<n.length;a++)if(Su(t,n[a]))return !0;if(gu(t,n,r))return !0}return !1}(u,i,h)},e.prototype.isTileClipped=function(){return !0},e}(Js);function ul(t,e){return e>0?e+2*t:t}var hl=Qs([{name:"a_pos_offset",components:4,type:"Int16"},{name:"a_data",components:4,type:"Uint16"},{name:"a_pixeloffset",components:4,type:"Int16"}],4),ll=Qs([{name:"a_projected_pos",components:3,type:"Float32"}],4),pl=(Qs([{name:"a_fade_opacity",components:1,type:"Uint32"}],4),Qs([{name:"a_placed",components:2,type:"Uint8"},{name:"a_shift",components:2,type:"Float32"}])),cl=(Qs([{type:"Int16",name:"anchorPointX"},{type:"Int16",name:"anchorPointY"},{type:"Int16",name:"x1"},{type:"Int16",name:"y1"},{type:"Int16",name:"x2"},{type:"Int16",name:"y2"},{type:"Uint32",name:"featureIndex"},{type:"Uint16",name:"sourceLayerIndex"},{type:"Uint16",name:"bucketIndex"}]),Qs([{name:"a_pos",components:2,type:"Int16"},{name:"a_anchor_pos",components:2,type:"Int16"},{name:"a_extrude",components:2,type:"Int16"}],4)),fl=Qs([{name:"a_pos",components:2,type:"Float32"},{name:"a_radius",components:1,type:"Float32"},{name:"a_flags",components:2,type:"Int16"}],4);function yl(t,e,r){return t.sections.forEach((function(t){t.text=function(t,e,r){var i=e.layout.get("text-transform").evaluate(r,{});return "uppercase"===i?t=t.toLocaleUpperCase():"lowercase"===i&&(t=t.toLocaleLowerCase()),Bs.applyArabicShaping&&(t=Bs.applyArabicShaping(t)),t}(t.text,e,r);})),t}Qs([{name:"triangle",components:3,type:"Uint16"}]),Qs([{type:"Int16",name:"anchorX"},{type:"Int16",name:"anchorY"},{type:"Uint16",name:"glyphStartIndex"},{type:"Uint16",name:"numGlyphs"},{type:"Uint32",name:"vertexStartIndex"},{type:"Uint32",name:"lineStartIndex"},{type:"Uint32",name:"lineLength"},{type:"Uint16",name:"segment"},{type:"Uint16",name:"lowerSize"},{type:"Uint16",name:"upperSize"},{type:"Float32",name:"lineOffsetX"},{type:"Float32",name:"lineOffsetY"},{type:"Uint8",name:"writingMode"},{type:"Uint8",name:"placedOrientation"},{type:"Uint8",name:"hidden"},{type:"Uint32",name:"crossTileID"},{type:"Int16",name:"associatedIconIndex"}]),Qs([{type:"Int16",name:"anchorX"},{type:"Int16",name:"anchorY"},{type:"Int16",name:"rightJustifiedTextSymbolIndex"},{type:"Int16",name:"centerJustifiedTextSymbolIndex"},{type:"Int16",name:"leftJustifiedTextSymbolIndex"},{type:"Int16",name:"verticalPlacedTextSymbolIndex"},{type:"Int16",name:"placedIconSymbolIndex"},{type:"Int16",name:"verticalPlacedIconSymbolIndex"},{type:"Uint16",name:"key"},{type:"Uint16",name:"textBoxStartIndex"},{type:"Uint16",name:"textBoxEndIndex"},{type:"Uint16",name:"verticalTextBoxStartIndex"},{type:"Uint16",name:"verticalTextBoxEndIndex"},{type:"Uint16",name:"iconBoxStartIndex"},{type:"Uint16",name:"iconBoxEndIndex"},{type:"Uint16",name:"verticalIconBoxStartIndex"},{type:"Uint16",name:"verticalIconBoxEndIndex"},{type:"Uint16",name:"featureIndex"},{type:"Uint16",name:"numHorizontalGlyphVertices"},{type:"Uint16",name:"numVerticalGlyphVertices"},{type:"Uint16",name:"numIconVertices"},{type:"Uint16",name:"numVerticalIconVertices"},{type:"Uint16",name:"useRuntimeCollisionCircles"},{type:"Uint32",name:"crossTileID"},{type:"Float32",name:"textBoxScale"},{type:"Float32",components:2,name:"textOffset"},{type:"Float32",name:"collisionCircleDiameter"}]),Qs([{type:"Float32",name:"offsetX"}]),Qs([{type:"Int16",name:"x"},{type:"Int16",name:"y"},{type:"Int16",name:"tileUnitDistanceFromAnchor"}]);var dl={"!":"︕","#":"＃",$:"＄","%":"％","&":"＆","(":"︵",")":"︶","*":"＊","+":"＋",",":"︐","-":"︲",".":"・","/":"／",":":"︓",";":"︔","<":"︿","=":"＝",">":"﹀","?":"︖","@":"＠","[":"﹇","\\":"＼","]":"﹈","^":"＾",_:"︳","`":"｀","{":"︷","|":"―","}":"︸","~":"～","¢":"￠","£":"￡","¥":"￥","¦":"￤","¬":"￢","¯":"￣","–":"︲","—":"︱","‘":"﹃","’":"﹄","“":"﹁","”":"﹂","…":"︙","‧":"・","₩":"￦","、":"︑","。":"︒","〈":"︿","〉":"﹀","《":"︽","》":"︾","「":"﹁","」":"﹂","『":"﹃","』":"﹄","【":"︻","】":"︼","〔":"︹","〕":"︺","〖":"︗","〗":"︘","！":"︕","（":"︵","）":"︶","，":"︐","－":"︲","．":"・","：":"︓","；":"︔","＜":"︿","＞":"﹀","？":"︖","［":"﹇","］":"﹈","＿":"︳","｛":"︷","｜":"―","｝":"︸","｟":"︵","｠":"︶","｡":"︒","｢":"﹁","｣":"﹂"},ml=function(t,e,r,i,n){var a,s,o=8*n-i-1,u=(1<<o)-1,h=u>>1,l=-7,p=r?n-1:0,c=r?-1:1,f=t[e+p];for(p+=c,a=f&(1<<-l)-1,f>>=-l,l+=o;l>0;a=256*a+t[e+p],p+=c,l-=8);for(s=a&(1<<-l)-1,a>>=-l,l+=i;l>0;s=256*s+t[e+p],p+=c,l-=8);if(0===a)a=1-h;else {if(a===u)return s?NaN:1/0*(f?-1:1);s+=Math.pow(2,i),a-=h;}return (f?-1:1)*s*Math.pow(2,a-i)},vl=function(t,e,r,i,n,a){var s,o,u,h=8*a-n-1,l=(1<<h)-1,p=l>>1,c=23===n?Math.pow(2,-24)-Math.pow(2,-77):0,f=i?0:a-1,y=i?1:-1,d=e<0||0===e&&1/e<0?1:0;for(e=Math.abs(e),isNaN(e)||e===1/0?(o=isNaN(e)?1:0,s=l):(s=Math.floor(Math.log(e)/Math.LN2),e*(u=Math.pow(2,-s))<1&&(s--,u*=2),(e+=s+p>=1?c/u:c*Math.pow(2,1-p))*u>=2&&(s++,u/=2),s+p>=l?(o=0,s=l):s+p>=1?(o=(e*u-1)*Math.pow(2,n),s+=p):(o=e*Math.pow(2,p-1)*Math.pow(2,n),s=0));n>=8;t[r+f]=255&o,f+=y,o/=256,n-=8);for(s=s<<n|o,h+=n;h>0;t[r+f]=255&s,f+=y,s/=256,h-=8);t[r+f-y]|=128*d;},gl=xl;function xl(t){this.buf=ArrayBuffer.isView&&ArrayBuffer.isView(t)?t:new Uint8Array(t||0),this.pos=0,this.type=0,this.length=this.buf.length;}xl.Varint=0,xl.Fixed64=1,xl.Bytes=2,xl.Fixed32=5;var bl="undefined"==typeof TextDecoder?null:new TextDecoder("utf8");function _l(t){return t.type===xl.Bytes?t.readVarint()+t.pos:t.pos+1}function wl(t,e,r){return r?4294967296*e+(t>>>0):4294967296*(e>>>0)+(t>>>0)}function Ml(t,e,r){var i=e<=16383?1:e<=2097151?2:e<=268435455?3:Math.floor(Math.log(e)/(7*Math.LN2));r.realloc(i);for(var n=r.pos-1;n>=t;n--)r.buf[n+i]=r.buf[n];}function Sl(t,e){for(var r=0;r<t.length;r++)e.writeVarint(t[r]);}function Al(t,e){for(var r=0;r<t.length;r++)e.writeSVarint(t[r]);}function kl(t,e){for(var r=0;r<t.length;r++)e.writeFloat(t[r]);}function Il(t,e){for(var r=0;r<t.length;r++)e.writeDouble(t[r]);}function zl(t,e){for(var r=0;r<t.length;r++)e.writeBoolean(t[r]);}function Cl(t,e){for(var r=0;r<t.length;r++)e.writeFixed32(t[r]);}function El(t,e){for(var r=0;r<t.length;r++)e.writeSFixed32(t[r]);}function Pl(t,e){for(var r=0;r<t.length;r++)e.writeFixed64(t[r]);}function Bl(t,e){for(var r=0;r<t.length;r++)e.writeSFixed64(t[r]);}function Tl(t,e){return (t[e]|t[e+1]<<8|t[e+2]<<16)+16777216*t[e+3]}function Vl(t,e,r){t[r]=e,t[r+1]=e>>>8,t[r+2]=e>>>16,t[r+3]=e>>>24;}function Ll(t,e){return (t[e]|t[e+1]<<8|t[e+2]<<16)+(t[e+3]<<24)}function Fl(t,e,r){1===t&&r.readMessage(Ol,e);}function Ol(t,e,r){if(3===t){var i=r.readMessage(Dl,{}),n=i.width,a=i.height,s=i.left,o=i.top,u=i.advance;e.push({id:i.id,bitmap:new Sa({width:n+6,height:a+6},i.bitmap),metrics:{width:n,height:a,left:s,top:o,advance:u}});}}function Dl(t,e,r){1===t?e.id=r.readVarint():2===t?e.bitmap=r.readBytes():3===t?e.width=r.readVarint():4===t?e.height=r.readVarint():5===t?e.left=r.readSVarint():6===t?e.top=r.readSVarint():7===t&&(e.advance=r.readVarint());}function Nl(t){for(var e=0,r=0,i=0,n=t;i<n.length;i+=1){var a=n[i];e+=a.w*a.h,r=Math.max(r,a.w);}t.sort((function(t,e){return e.h-t.h}));for(var s=[{x:0,y:0,w:Math.max(Math.ceil(Math.sqrt(e/.95)),r),h:1/0}],o=0,u=0,h=0,l=t;h<l.length;h+=1)for(var p=l[h],c=s.length-1;c>=0;c--){var f=s[c];if(!(p.w>f.w||p.h>f.h)){if(p.x=f.x,p.y=f.y,u=Math.max(u,p.y+p.h),o=Math.max(o,p.x+p.w),p.w===f.w&&p.h===f.h){var y=s.pop();c<s.length&&(s[c]=y);}else p.h===f.h?(f.x+=p.w,f.w-=p.w):p.w===f.w?(f.y+=p.h,f.h-=p.h):(s.push({x:f.x+p.w,y:f.y,w:f.w-p.w,h:p.h}),f.y+=p.h,f.h-=p.h);break}}return {w:o,h:u,fill:e/(o*u)||0}}xl.prototype={destroy:function(){this.buf=null;},readFields:function(t,e,r){for(r=r||this.length;this.pos<r;){var i=this.readVarint(),n=i>>3,a=this.pos;this.type=7&i,t(n,e,this),this.pos===a&&this.skip(i);}return e},readMessage:function(t,e){return this.readFields(t,e,this.readVarint()+this.pos)},readFixed32:function(){var t=Tl(this.buf,this.pos);return this.pos+=4,t},readSFixed32:function(){var t=Ll(this.buf,this.pos);return this.pos+=4,t},readFixed64:function(){var t=Tl(this.buf,this.pos)+4294967296*Tl(this.buf,this.pos+4);return this.pos+=8,t},readSFixed64:function(){var t=Tl(this.buf,this.pos)+4294967296*Ll(this.buf,this.pos+4);return this.pos+=8,t},readFloat:function(){var t=ml(this.buf,this.pos,!0,23,4);return this.pos+=4,t},readDouble:function(){var t=ml(this.buf,this.pos,!0,52,8);return this.pos+=8,t},readVarint:function(t){var e,r,i=this.buf;return e=127&(r=i[this.pos++]),r<128?e:(e|=(127&(r=i[this.pos++]))<<7,r<128?e:(e|=(127&(r=i[this.pos++]))<<14,r<128?e:(e|=(127&(r=i[this.pos++]))<<21,r<128?e:function(t,e,r){var i,n,a=r.buf;if(i=(112&(n=a[r.pos++]))>>4,n<128)return wl(t,i,e);if(i|=(127&(n=a[r.pos++]))<<3,n<128)return wl(t,i,e);if(i|=(127&(n=a[r.pos++]))<<10,n<128)return wl(t,i,e);if(i|=(127&(n=a[r.pos++]))<<17,n<128)return wl(t,i,e);if(i|=(127&(n=a[r.pos++]))<<24,n<128)return wl(t,i,e);if(i|=(1&(n=a[r.pos++]))<<31,n<128)return wl(t,i,e);throw new Error("Expected varint not more than 10 bytes")}(e|=(15&(r=i[this.pos]))<<28,t,this))))},readVarint64:function(){return this.readVarint(!0)},readSVarint:function(){var t=this.readVarint();return t%2==1?(t+1)/-2:t/2},readBoolean:function(){return Boolean(this.readVarint())},readString:function(){var t=this.readVarint()+this.pos,e=this.pos;return this.pos=t,t-e>=12&&bl?function(t,e,r){return bl.decode(t.subarray(e,r))}(this.buf,e,t):function(t,e,r){for(var i="",n=e;n<r;){var a,s,o,u=t[n],h=null,l=u>239?4:u>223?3:u>191?2:1;if(n+l>r)break;1===l?u<128&&(h=u):2===l?128==(192&(a=t[n+1]))&&(h=(31&u)<<6|63&a)<=127&&(h=null):3===l?(s=t[n+2],128==(192&(a=t[n+1]))&&128==(192&s)&&((h=(15&u)<<12|(63&a)<<6|63&s)<=2047||h>=55296&&h<=57343)&&(h=null)):4===l&&(s=t[n+2],o=t[n+3],128==(192&(a=t[n+1]))&&128==(192&s)&&128==(192&o)&&((h=(15&u)<<18|(63&a)<<12|(63&s)<<6|63&o)<=65535||h>=1114112)&&(h=null)),null===h?(h=65533,l=1):h>65535&&(h-=65536,i+=String.fromCharCode(h>>>10&1023|55296),h=56320|1023&h),i+=String.fromCharCode(h),n+=l;}return i}(this.buf,e,t)},readBytes:function(){var t=this.readVarint()+this.pos,e=this.buf.subarray(this.pos,t);return this.pos=t,e},readPackedVarint:function(t,e){if(this.type!==xl.Bytes)return t.push(this.readVarint(e));var r=_l(this);for(t=t||[];this.pos<r;)t.push(this.readVarint(e));return t},readPackedSVarint:function(t){if(this.type!==xl.Bytes)return t.push(this.readSVarint());var e=_l(this);for(t=t||[];this.pos<e;)t.push(this.readSVarint());return t},readPackedBoolean:function(t){if(this.type!==xl.Bytes)return t.push(this.readBoolean());var e=_l(this);for(t=t||[];this.pos<e;)t.push(this.readBoolean());return t},readPackedFloat:function(t){if(this.type!==xl.Bytes)return t.push(this.readFloat());var e=_l(this);for(t=t||[];this.pos<e;)t.push(this.readFloat());return t},readPackedDouble:function(t){if(this.type!==xl.Bytes)return t.push(this.readDouble());var e=_l(this);for(t=t||[];this.pos<e;)t.push(this.readDouble());return t},readPackedFixed32:function(t){if(this.type!==xl.Bytes)return t.push(this.readFixed32());var e=_l(this);for(t=t||[];this.pos<e;)t.push(this.readFixed32());return t},readPackedSFixed32:function(t){if(this.type!==xl.Bytes)return t.push(this.readSFixed32());var e=_l(this);for(t=t||[];this.pos<e;)t.push(this.readSFixed32());return t},readPackedFixed64:function(t){if(this.type!==xl.Bytes)return t.push(this.readFixed64());var e=_l(this);for(t=t||[];this.pos<e;)t.push(this.readFixed64());return t},readPackedSFixed64:function(t){if(this.type!==xl.Bytes)return t.push(this.readSFixed64());var e=_l(this);for(t=t||[];this.pos<e;)t.push(this.readSFixed64());return t},skip:function(t){var e=7&t;if(e===xl.Varint)for(;this.buf[this.pos++]>127;);else if(e===xl.Bytes)this.pos=this.readVarint()+this.pos;else if(e===xl.Fixed32)this.pos+=4;else {if(e!==xl.Fixed64)throw new Error("Unimplemented type: "+e);this.pos+=8;}},writeTag:function(t,e){this.writeVarint(t<<3|e);},realloc:function(t){for(var e=this.length||16;e<this.pos+t;)e*=2;if(e!==this.length){var r=new Uint8Array(e);r.set(this.buf),this.buf=r,this.length=e;}},finish:function(){return this.length=this.pos,this.pos=0,this.buf.subarray(0,this.length)},writeFixed32:function(t){this.realloc(4),Vl(this.buf,t,this.pos),this.pos+=4;},writeSFixed32:function(t){this.realloc(4),Vl(this.buf,t,this.pos),this.pos+=4;},writeFixed64:function(t){this.realloc(8),Vl(this.buf,-1&t,this.pos),Vl(this.buf,Math.floor(t*(1/4294967296)),this.pos+4),this.pos+=8;},writeSFixed64:function(t){this.realloc(8),Vl(this.buf,-1&t,this.pos),Vl(this.buf,Math.floor(t*(1/4294967296)),this.pos+4),this.pos+=8;},writeVarint:function(t){(t=+t||0)>268435455||t<0?function(t,e){var r,i;if(t>=0?(r=t%4294967296|0,i=t/4294967296|0):(i=~(-t/4294967296),4294967295^(r=~(-t%4294967296))?r=r+1|0:(r=0,i=i+1|0)),t>=0x10000000000000000||t<-0x10000000000000000)throw new Error("Given varint doesn't fit into 10 bytes");e.realloc(10),function(t,e,r){r.buf[r.pos++]=127&t|128,t>>>=7,r.buf[r.pos++]=127&t|128,t>>>=7,r.buf[r.pos++]=127&t|128,t>>>=7,r.buf[r.pos++]=127&t|128,r.buf[r.pos]=127&(t>>>=7);}(r,0,e),function(t,e){var r=(7&t)<<4;e.buf[e.pos++]|=r|((t>>>=3)?128:0),t&&(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),t&&(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),t&&(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),t&&(e.buf[e.pos++]=127&t|((t>>>=7)?128:0),t&&(e.buf[e.pos++]=127&t)))));}(i,e);}(t,this):(this.realloc(4),this.buf[this.pos++]=127&t|(t>127?128:0),t<=127||(this.buf[this.pos++]=127&(t>>>=7)|(t>127?128:0),t<=127||(this.buf[this.pos++]=127&(t>>>=7)|(t>127?128:0),t<=127||(this.buf[this.pos++]=t>>>7&127))));},writeSVarint:function(t){this.writeVarint(t<0?2*-t-1:2*t);},writeBoolean:function(t){this.writeVarint(Boolean(t));},writeString:function(t){t=String(t),this.realloc(4*t.length),this.pos++;var e=this.pos;this.pos=function(t,e,r){for(var i,n,a=0;a<e.length;a++){if((i=e.charCodeAt(a))>55295&&i<57344){if(!n){i>56319||a+1===e.length?(t[r++]=239,t[r++]=191,t[r++]=189):n=i;continue}if(i<56320){t[r++]=239,t[r++]=191,t[r++]=189,n=i;continue}i=n-55296<<10|i-56320|65536,n=null;}else n&&(t[r++]=239,t[r++]=191,t[r++]=189,n=null);i<128?t[r++]=i:(i<2048?t[r++]=i>>6|192:(i<65536?t[r++]=i>>12|224:(t[r++]=i>>18|240,t[r++]=i>>12&63|128),t[r++]=i>>6&63|128),t[r++]=63&i|128);}return r}(this.buf,t,this.pos);var r=this.pos-e;r>=128&&Ml(e,r,this),this.pos=e-1,this.writeVarint(r),this.pos+=r;},writeFloat:function(t){this.realloc(4),vl(this.buf,t,this.pos,!0,23,4),this.pos+=4;},writeDouble:function(t){this.realloc(8),vl(this.buf,t,this.pos,!0,52,8),this.pos+=8;},writeBytes:function(t){var e=t.length;this.writeVarint(e),this.realloc(e);for(var r=0;r<e;r++)this.buf[this.pos++]=t[r];},writeRawMessage:function(t,e){this.pos++;var r=this.pos;t(e,this);var i=this.pos-r;i>=128&&Ml(r,i,this),this.pos=r-1,this.writeVarint(i),this.pos+=i;},writeMessage:function(t,e,r){this.writeTag(t,xl.Bytes),this.writeRawMessage(e,r);},writePackedVarint:function(t,e){e.length&&this.writeMessage(t,Sl,e);},writePackedSVarint:function(t,e){e.length&&this.writeMessage(t,Al,e);},writePackedBoolean:function(t,e){e.length&&this.writeMessage(t,zl,e);},writePackedFloat:function(t,e){e.length&&this.writeMessage(t,kl,e);},writePackedDouble:function(t,e){e.length&&this.writeMessage(t,Il,e);},writePackedFixed32:function(t,e){e.length&&this.writeMessage(t,Cl,e);},writePackedSFixed32:function(t,e){e.length&&this.writeMessage(t,El,e);},writePackedFixed64:function(t,e){e.length&&this.writeMessage(t,Pl,e);},writePackedSFixed64:function(t,e){e.length&&this.writeMessage(t,Bl,e);},writeBytesField:function(t,e){this.writeTag(t,xl.Bytes),this.writeBytes(e);},writeFixed32Field:function(t,e){this.writeTag(t,xl.Fixed32),this.writeFixed32(e);},writeSFixed32Field:function(t,e){this.writeTag(t,xl.Fixed32),this.writeSFixed32(e);},writeFixed64Field:function(t,e){this.writeTag(t,xl.Fixed64),this.writeFixed64(e);},writeSFixed64Field:function(t,e){this.writeTag(t,xl.Fixed64),this.writeSFixed64(e);},writeVarintField:function(t,e){this.writeTag(t,xl.Varint),this.writeVarint(e);},writeSVarintField:function(t,e){this.writeTag(t,xl.Varint),this.writeSVarint(e);},writeStringField:function(t,e){this.writeTag(t,xl.Bytes),this.writeString(e);},writeFloatField:function(t,e){this.writeTag(t,xl.Fixed32),this.writeFloat(e);},writeDoubleField:function(t,e){this.writeTag(t,xl.Fixed64),this.writeDouble(e);},writeBooleanField:function(t,e){this.writeVarintField(t,Boolean(e));}};var Rl=function(t,e){var r=e.pixelRatio,i=e.version,n=e.stretchX,a=e.stretchY,s=e.content;this.paddedRect=t,this.pixelRatio=r,this.stretchX=n,this.stretchY=a,this.content=s,this.version=i;},ql={tl:{configurable:!0},br:{configurable:!0},tlbr:{configurable:!0},displaySize:{configurable:!0}};ql.tl.get=function(){return [this.paddedRect.x+1,this.paddedRect.y+1]},ql.br.get=function(){return [this.paddedRect.x+this.paddedRect.w-1,this.paddedRect.y+this.paddedRect.h-1]},ql.tlbr.get=function(){return this.tl.concat(this.br)},ql.displaySize.get=function(){return [(this.paddedRect.w-2)/this.pixelRatio,(this.paddedRect.h-2)/this.pixelRatio]},Object.defineProperties(Rl.prototype,ql);var jl=function(t,e){var r={},i={};this.haveRenderCallbacks=[];var n=[];this.addImages(t,r,n),this.addImages(e,i,n);var a=Nl(n),s=new Aa({width:a.w||1,height:a.h||1});for(var o in t){var u=t[o],h=r[o].paddedRect;Aa.copy(u.data,s,{x:0,y:0},{x:h.x+1,y:h.y+1},u.data);}for(var l in e){var p=e[l],c=i[l].paddedRect,f=c.x+1,y=c.y+1,d=p.data.width,m=p.data.height;Aa.copy(p.data,s,{x:0,y:0},{x:f,y:y},p.data),Aa.copy(p.data,s,{x:0,y:m-1},{x:f,y:y+m},{width:d,height:1}),Aa.copy(p.data,s,{x:0,y:0},{x:f,y:y-1},{width:d,height:1}),Aa.copy(p.data,s,{x:d-1,y:0},{x:f+d,y:y},{width:1,height:m}),Aa.copy(p.data,s,{x:0,y:0},{x:f-1,y:y},{width:1,height:m}),Aa.copy(p.data,s,{x:0,y:0},{x:0,y:y-1},{width:1,height:1}),Aa.copy(p.data,s,{x:d-1,y:0},{x:f+d,y:y-1},{width:1,height:1}),Aa.copy(p.data,s,{x:d-1,y:m-1},{x:f+d,y:y+m},{width:1,height:1}),Aa.copy(p.data,s,{x:0,y:m-1},{x:0,y:y+m},{width:1,height:1});}this.image=s,this.iconPositions=r,this.patternPositions=i;};jl.prototype.addImages=function(t,e,r){for(var i in t){var n=t[i],a={x:0,y:0,w:n.data.width+2,h:n.data.height+2};r.push(a),e[i]=new Rl(a,n),n.hasRenderCallback&&this.haveRenderCallbacks.push(i);}},jl.prototype.patchUpdatedImages=function(t,e){for(var r in t.dispatchRenderCallbacks(this.haveRenderCallbacks),t.updatedImages)this.patchUpdatedImage(this.iconPositions[r],t.getImage(r),e),this.patchUpdatedImage(this.patternPositions[r],t.getImage(r),e);},jl.prototype.patchUpdatedImage=function(t,e,r){if(t&&e&&t.version!==e.version){t.version=e.version;var i=t.tl;r.update(e.data,void 0,{x:i[0],y:i[1]});}},da("ImagePosition",Rl),da("ImageAtlas",jl);var Ul={horizontal:1,vertical:2,horizontalOnly:3},Gl=function(){this.scale=1,this.fontStack="",this.imageName=null;};Gl.forText=function(t,e){var r=new Gl;return r.scale=t||1,r.fontStack=e,r},Gl.forImage=function(t){var e=new Gl;return e.imageName=t,e};var Kl=function(){this.text="",this.sectionIndex=[],this.sections=[],this.imageSectionID=null;};function Xl(t,e,r,i,n,a,s,o,u,h,l,p,c,f,y,d){var m,v=Kl.fromFeature(t,n);p===Ul.vertical&&v.verticalizePunctuation();var g=Bs.processBidirectionalText,x=Bs.processStyledBidirectionalText;if(g&&1===v.sections.length){m=[];for(var b=0,_=g(v.toString(),$l(v,h,a,e,i,f,y));b<_.length;b+=1){var w=_[b],M=new Kl;M.text=w,M.sections=v.sections;for(var S=0;S<w.length;S++)M.sectionIndex.push(0);m.push(M);}}else if(x){m=[];for(var A=0,k=x(v.text,v.sectionIndex,$l(v,h,a,e,i,f,y));A<k.length;A+=1){var I=k[A],z=new Kl;z.text=I[0],z.sectionIndex=I[1],z.sections=v.sections,m.push(z);}}else m=function(t,e){for(var r=[],i=t.text,n=0,a=0,s=e;a<s.length;a+=1){var o=s[a];r.push(t.substring(n,o)),n=o;}return n<i.length&&r.push(t.substring(n,i.length)),r}(v,$l(v,h,a,e,i,f,y));var C=[],E={positionedLines:C,text:v.toString(),top:l[1],bottom:l[1],left:l[0],right:l[0],writingMode:p,iconsInText:!1,verticalizable:!1};return function(t,e,r,i,n,a,s,o,u,h,l,p){for(var c=0,f=-17,y=0,d=0,m="right"===o?1:"left"===o?0:.5,v=0,g=0,x=n;g<x.length;g+=1){var b=x[g];b.trim();var _=b.getMaxScale(),w=24*(_-1),M={positionedGlyphs:[],lineOffset:0};t.positionedLines[v]=M;var S=M.positionedGlyphs,A=0;if(b.length()){for(var k=0;k<b.length();k++){var I=b.getSection(k),z=b.getSectionIndex(k),C=b.getCharCode(k),E=0,P=null,B=null,T=null,V=24,L=!(u===Ul.horizontal||!l&&!xs(C)||l&&(Hl[C]||(G=C,vs.Arabic(G)||vs["Arabic Supplement"](G)||vs["Arabic Extended-A"](G)||vs["Arabic Presentation Forms-A"](G)||vs["Arabic Presentation Forms-B"](G))));if(I.imageName){var F=i[I.imageName];if(!F)continue;T=I.imageName,t.iconsInText=t.iconsInText||!0,B=F.paddedRect;var O=F.displaySize;I.scale=24*I.scale/p,E=w+(24-O[1]*I.scale),V=(P={width:O[0],height:O[1],left:1,top:-3,advance:L?O[1]:O[0]}).advance;var D=L?O[0]*I.scale-24*_:O[1]*I.scale-24*_;D>0&&D>A&&(A=D);}else {var N=r[I.fontStack],R=N&&N[C];if(R&&R.rect)B=R.rect,P=R.metrics;else {var q=e[I.fontStack],j=q&&q[C];if(!j)continue;P=j.metrics;}E=24*(_-I.scale);}L?(t.verticalizable=!0,S.push({glyph:C,imageName:T,x:c,y:f+E,vertical:L,scale:I.scale,fontStack:I.fontStack,sectionIndex:z,metrics:P,rect:B}),c+=V*I.scale+h):(S.push({glyph:C,imageName:T,x:c,y:f+E,vertical:L,scale:I.scale,fontStack:I.fontStack,sectionIndex:z,metrics:P,rect:B}),c+=P.advance*I.scale+h);}0!==S.length&&(y=Math.max(c-h,y),ep(S,0,S.length-1,m,A)),c=0;var U=a*_+A;M.lineOffset=Math.max(A,w),f+=U,d=Math.max(U,d),++v;}else f+=a,++v;}var G,K=f- -17,X=tp(s),H=X.horizontalAlign,J=X.verticalAlign;(function(t,e,r,i,n,a,s,o,u){var h,l=(e-r)*n;h=a!==s?-o*i- -17:(-i*u+.5)*s;for(var p=0,c=t;p<c.length;p+=1)for(var f=0,y=c[p].positionedGlyphs;f<y.length;f+=1){var d=y[f];d.x+=l,d.y+=h;}})(t.positionedLines,m,H,J,y,d,a,K,n.length),t.top+=-J*K,t.bottom=t.top+K,t.left+=-H*y,t.right=t.left+y;}(E,e,r,i,m,s,o,u,p,h,c,d),!function(t){for(var e=0,r=t;e<r.length;e+=1)if(0!==r[e].positionedGlyphs.length)return !1;return !0}(C)&&E}Kl.fromFeature=function(t,e){for(var r=new Kl,i=0;i<t.sections.length;i++){var n=t.sections[i];n.image?r.addImageSection(n):r.addTextSection(n,e);}return r},Kl.prototype.length=function(){return this.text.length},Kl.prototype.getSection=function(t){return this.sections[this.sectionIndex[t]]},Kl.prototype.getSectionIndex=function(t){return this.sectionIndex[t]},Kl.prototype.getCharCode=function(t){return this.text.charCodeAt(t)},Kl.prototype.verticalizePunctuation=function(){this.text=function(t){for(var e="",r=0;r<t.length;r++){var i=t.charCodeAt(r+1)||null,n=t.charCodeAt(r-1)||null;e+=i&&bs(i)&&!dl[t[r+1]]||n&&bs(n)&&!dl[t[r-1]]||!dl[t[r]]?t[r]:dl[t[r]];}return e}(this.text);},Kl.prototype.trim=function(){for(var t=0,e=0;e<this.text.length&&Hl[this.text.charCodeAt(e)];e++)t++;for(var r=this.text.length,i=this.text.length-1;i>=0&&i>=t&&Hl[this.text.charCodeAt(i)];i--)r--;this.text=this.text.substring(t,r),this.sectionIndex=this.sectionIndex.slice(t,r);},Kl.prototype.substring=function(t,e){var r=new Kl;return r.text=this.text.substring(t,e),r.sectionIndex=this.sectionIndex.slice(t,e),r.sections=this.sections,r},Kl.prototype.toString=function(){return this.text},Kl.prototype.getMaxScale=function(){var t=this;return this.sectionIndex.reduce((function(e,r){return Math.max(e,t.sections[r].scale)}),0)},Kl.prototype.addTextSection=function(t,e){this.text+=t.text,this.sections.push(Gl.forText(t.scale,t.fontStack||e));for(var r=this.sections.length-1,i=0;i<t.text.length;++i)this.sectionIndex.push(r);},Kl.prototype.addImageSection=function(t){var e=t.image?t.image.name:"";if(0!==e.length){var r=this.getNextImageSectionCharCode();r?(this.text+=String.fromCharCode(r),this.sections.push(Gl.forImage(e)),this.sectionIndex.push(this.sections.length-1)):M("Reached maximum number of images 6401");}else M("Can't add FormattedSection with an empty image.");},Kl.prototype.getNextImageSectionCharCode=function(){return this.imageSectionID?this.imageSectionID>=63743?null:++this.imageSectionID:(this.imageSectionID=57344,this.imageSectionID)};var Hl={9:!0,10:!0,11:!0,12:!0,13:!0,32:!0},Jl={};function Zl(t,e,r,i,n,a){if(e.imageName){var s=i[e.imageName];return s?s.displaySize[0]*e.scale*24/a+n:0}var o=r[e.fontStack],u=o&&o[t];return u?u.metrics.advance*e.scale+n:0}function Yl(t,e,r,i){var n=Math.pow(t-e,2);return i?t<e?n/2:2*n:n+Math.abs(r)*r}function Wl(t,e,r){var i=0;return 10===t&&(i-=1e4),r&&(i+=150),40!==t&&65288!==t||(i+=50),41!==e&&65289!==e||(i+=50),i}function Ql(t,e,r,i,n,a){for(var s=null,o=Yl(e,r,n,a),u=0,h=i;u<h.length;u+=1){var l=h[u],p=Yl(e-l.x,r,n,a)+l.badness;p<=o&&(s=l,o=p);}return {index:t,x:e,priorBreak:s,badness:o}}function $l(t,e,r,i,n,a,s){if("point"!==a)return [];if(!t)return [];for(var o,u=[],h=function(t,e,r,i,n,a){for(var s=0,o=0;o<t.length();o++){var u=t.getSection(o);s+=Zl(t.getCharCode(o),u,i,n,e,a);}return s/Math.max(1,Math.ceil(s/r))}(t,e,r,i,n,s),l=t.text.indexOf("​")>=0,p=0,c=0;c<t.length();c++){var f=t.getSection(c),y=t.getCharCode(c);if(Hl[y]||(p+=Zl(y,f,i,n,e,s)),c<t.length()-1){var d=!((o=y)<11904||!(vs["Bopomofo Extended"](o)||vs.Bopomofo(o)||vs["CJK Compatibility Forms"](o)||vs["CJK Compatibility Ideographs"](o)||vs["CJK Compatibility"](o)||vs["CJK Radicals Supplement"](o)||vs["CJK Strokes"](o)||vs["CJK Symbols and Punctuation"](o)||vs["CJK Unified Ideographs Extension A"](o)||vs["CJK Unified Ideographs"](o)||vs["Enclosed CJK Letters and Months"](o)||vs["Halfwidth and Fullwidth Forms"](o)||vs.Hiragana(o)||vs["Ideographic Description Characters"](o)||vs["Kangxi Radicals"](o)||vs["Katakana Phonetic Extensions"](o)||vs.Katakana(o)||vs["Vertical Forms"](o)||vs["Yi Radicals"](o)||vs["Yi Syllables"](o)));(Jl[y]||d||f.imageName)&&u.push(Ql(c+1,p,h,u,Wl(y,t.getCharCode(c+1),d&&l),!1));}}return function t(e){return e?t(e.priorBreak).concat(e.index):[]}(Ql(t.length(),p,h,u,0,!0))}function tp(t){var e=.5,r=.5;switch(t){case"right":case"top-right":case"bottom-right":e=1;break;case"left":case"top-left":case"bottom-left":e=0;}switch(t){case"bottom":case"bottom-right":case"bottom-left":r=1;break;case"top":case"top-right":case"top-left":r=0;}return {horizontalAlign:e,verticalAlign:r}}function ep(t,e,r,i,n){if(i||n)for(var a=t[r],s=(t[r].x+a.metrics.advance*a.scale)*i,o=e;o<=r;o++)t[o].x-=s,t[o].y+=n;}function rp(t,e,r,i,n,a){var s,o=t.image;if(o.content){var u=o.content,h=o.pixelRatio||1;s=[u[0]/h,u[1]/h,o.displaySize[0]-u[2]/h,o.displaySize[1]-u[3]/h];}var l,p,c,f,y=e.left*a,d=e.right*a;"width"===r||"both"===r?(f=n[0]+y-i[3],p=n[0]+d+i[1]):p=(f=n[0]+(y+d-o.displaySize[0])/2)+o.displaySize[0];var m=e.top*a,v=e.bottom*a;return "height"===r||"both"===r?(l=n[1]+m-i[0],c=n[1]+v+i[2]):c=(l=n[1]+(m+v-o.displaySize[1])/2)+o.displaySize[1],{image:o,top:l,right:p,bottom:c,left:f,collisionPadding:s}}Jl[10]=!0,Jl[32]=!0,Jl[38]=!0,Jl[40]=!0,Jl[41]=!0,Jl[43]=!0,Jl[45]=!0,Jl[47]=!0,Jl[173]=!0,Jl[183]=!0,Jl[8203]=!0,Jl[8208]=!0,Jl[8211]=!0,Jl[8231]=!0;var ip=function(t){function e(e,r,i,n){t.call(this,e,r),this.angle=i,void 0!==n&&(this.segment=n);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.clone=function(){return new e(this.x,this.y,this.angle,this.segment)},e}(n);function np(t,e){var r=e.expression;if("constant"===r.kind)return {kind:"constant",layoutSize:r.evaluate(new Ts(t+1))};if("source"===r.kind)return {kind:"source"};for(var i=r.zoomStops,n=r.interpolationType,a=0;a<i.length&&i[a]<=t;)a++;for(var s=a=Math.max(0,a-1);s<i.length&&i[s]<t+1;)s++;s=Math.min(i.length-1,s);var o=i[a],u=i[s];return "composite"===r.kind?{kind:"composite",minZoom:o,maxZoom:u,interpolationType:n}:{kind:"camera",minZoom:o,maxZoom:u,minSize:r.evaluate(new Ts(o)),maxSize:r.evaluate(new Ts(u)),interpolationType:n}}function ap(t,e,r){var i=e.uSize,n=r.lowerSize;return "source"===t.kind?n/128:"composite"===t.kind?an(n/128,r.upperSize/128,e.uSizeT):i}function sp(t,e){var r=0,i=0;if("constant"===t.kind)i=t.layoutSize;else if("source"!==t.kind){var n=t.interpolationType,a=n?l(bn.interpolationFactor(n,e,t.minZoom,t.maxZoom),0,1):0;"camera"===t.kind?i=an(t.minSize,t.maxSize,a):r=a;}return {uSizeT:r,uSize:i}}da("Anchor",ip);var op=Object.freeze({__proto__:null,getSizeData:np,evaluateSizeForFeature:ap,evaluateSizeForZoom:sp,SIZE_PACK_FACTOR:128});function up(t,e,r,i,n){if(void 0===e.segment)return !0;for(var a=e,s=e.segment+1,o=0;o>-r/2;){if(--s<0)return !1;o-=t[s].dist(a),a=t[s];}o+=t[s].dist(t[s+1]),s++;for(var u=[],h=0;o<r/2;){var l=t[s],p=t[s+1];if(!p)return !1;var c=t[s-1].angleTo(l)-l.angleTo(p);for(c=Math.abs((c+3*Math.PI)%(2*Math.PI)-Math.PI),u.push({distance:o,angleDelta:c}),h+=c;o-u[0].distance>i;)h-=u.shift().angleDelta;if(h>n)return !1;s++,o+=l.dist(p);}return !0}function hp(t){for(var e=0,r=0;r<t.length-1;r++)e+=t[r].dist(t[r+1]);return e}function lp(t,e,r){return t?.6*e*r:0}function pp(t,e){return Math.max(t?t.right-t.left:0,e?e.right-e.left:0)}function cp(t,e,r,i,n,a){for(var s=lp(r,n,a),o=pp(r,i)*a,u=0,h=hp(t)/2,l=0;l<t.length-1;l++){var p=t[l],c=t[l+1],f=p.dist(c);if(u+f>h){var y=(h-u)/f,d=an(p.x,c.x,y),m=an(p.y,c.y,y),v=new ip(d,m,c.angleTo(p),l);return v._round(),!s||up(t,v,o,s,e)?v:void 0}u+=f;}}function fp(t,e,r,i,n,a,s,o,u){var h=lp(i,a,s),l=pp(i,n),p=l*s,c=0===t[0].x||t[0].x===u||0===t[0].y||t[0].y===u;return e-p<e/4&&(e=p+e/4),function t(e,r,i,n,a,s,o,u,h){for(var l=s/2,p=hp(e),c=0,f=r-i,y=[],d=0;d<e.length-1;d++){for(var m=e[d],v=e[d+1],g=m.dist(v),x=v.angleTo(m);f+i<c+g;){var b=((f+=i)-c)/g,_=an(m.x,v.x,b),w=an(m.y,v.y,b);if(_>=0&&_<h&&w>=0&&w<h&&f-l>=0&&f+l<=p){var M=new ip(_,w,x,d);M._round(),n&&!up(e,M,s,n,a)||y.push(M);}}c+=g;}return u||y.length||o||(y=t(e,c/2,i,n,a,s,o,!0,h)),y}(t,c?e/2*o%e:(l/2+2*a)*s*o%e,e,h,r,p,c,!1,u)}function yp(t,e,r,i,a){for(var s=[],o=0;o<t.length;o++)for(var u=t[o],h=void 0,l=0;l<u.length-1;l++){var p=u[l],c=u[l+1];p.x<e&&c.x<e||(p.x<e?p=new n(e,p.y+(e-p.x)/(c.x-p.x)*(c.y-p.y))._round():c.x<e&&(c=new n(e,p.y+(e-p.x)/(c.x-p.x)*(c.y-p.y))._round()),p.y<r&&c.y<r||(p.y<r?p=new n(p.x+(r-p.y)/(c.y-p.y)*(c.x-p.x),r)._round():c.y<r&&(c=new n(p.x+(r-p.y)/(c.y-p.y)*(c.x-p.x),r)._round()),p.x>=i&&c.x>=i||(p.x>=i?p=new n(i,p.y+(i-p.x)/(c.x-p.x)*(c.y-p.y))._round():c.x>=i&&(c=new n(i,p.y+(i-p.x)/(c.x-p.x)*(c.y-p.y))._round()),p.y>=a&&c.y>=a||(p.y>=a?p=new n(p.x+(a-p.y)/(c.y-p.y)*(c.x-p.x),a)._round():c.y>=a&&(c=new n(p.x+(a-p.y)/(c.y-p.y)*(c.x-p.x),a)._round()),h&&p.equals(h[h.length-1])||s.push(h=[p]),h.push(c)))));}return s}function dp(t,e,r,i){var a=[],s=t.image,o=s.pixelRatio,u=s.paddedRect.w-2,h=s.paddedRect.h-2,l=t.right-t.left,p=t.bottom-t.top,c=s.stretchX||[[0,u]],f=s.stretchY||[[0,h]],y=function(t,e){return t+e[1]-e[0]},d=c.reduce(y,0),m=f.reduce(y,0),v=u-d,g=h-m,x=0,b=d,_=0,w=m,M=0,S=v,A=0,k=g;if(s.content&&i){var I=s.content;x=mp(c,0,I[0]),_=mp(f,0,I[1]),b=mp(c,I[0],I[2]),w=mp(f,I[1],I[3]),M=I[0]-x,A=I[1]-_,S=I[2]-I[0]-b,k=I[3]-I[1]-w;}var z=function(i,a,u,h){var c=gp(i.stretch-x,b,l,t.left),f=xp(i.fixed-M,S,i.stretch,d),y=gp(a.stretch-_,w,p,t.top),v=xp(a.fixed-A,k,a.stretch,m),g=gp(u.stretch-x,b,l,t.left),I=xp(u.fixed-M,S,u.stretch,d),z=gp(h.stretch-_,w,p,t.top),C=xp(h.fixed-A,k,h.stretch,m),E=new n(c,y),P=new n(g,y),B=new n(g,z),T=new n(c,z),V=new n(f/o,v/o),L=new n(I/o,C/o),F=e*Math.PI/180;if(F){var O=Math.sin(F),D=Math.cos(F),N=[D,-O,O,D];E._matMult(N),P._matMult(N),T._matMult(N),B._matMult(N);}var R=i.stretch+i.fixed,q=a.stretch+a.fixed;return {tl:E,tr:P,bl:T,br:B,tex:{x:s.paddedRect.x+1+R,y:s.paddedRect.y+1+q,w:u.stretch+u.fixed-R,h:h.stretch+h.fixed-q},writingMode:void 0,glyphOffset:[0,0],sectionIndex:0,pixelOffsetTL:V,pixelOffsetBR:L,minFontScaleX:S/o/l,minFontScaleY:k/o/p,isSDF:r}};if(i&&(s.stretchX||s.stretchY))for(var C=vp(c,v,d),E=vp(f,g,m),P=0;P<C.length-1;P++)for(var B=C[P],T=C[P+1],V=0;V<E.length-1;V++)a.push(z(B,E[V],T,E[V+1]));else a.push(z({fixed:0,stretch:-1},{fixed:0,stretch:-1},{fixed:0,stretch:u+1},{fixed:0,stretch:h+1}));return a}function mp(t,e,r){for(var i=0,n=0,a=t;n<a.length;n+=1){var s=a[n];i+=Math.max(e,Math.min(r,s[1]))-Math.max(e,Math.min(r,s[0]));}return i}function vp(t,e,r){for(var i=[{fixed:-1,stretch:0}],n=0,a=t;n<a.length;n+=1){var s=a[n],o=s[0],u=s[1],h=i[i.length-1];i.push({fixed:o-h.stretch,stretch:h.stretch}),i.push({fixed:o-h.stretch,stretch:h.stretch+(u-o)});}return i.push({fixed:e+1,stretch:r}),i}function gp(t,e,r,i){return t/e*r+i}function xp(t,e,r,i){return t-e*r/i}var bp=function(t,e,r,i,a,s,o,u,h,l){if(this.boxStartIndex=t.length,h){var p=s.top,c=s.bottom,f=s.collisionPadding;f&&(p-=f[1],c+=f[3]);var y=c-p;y>0&&(y=Math.max(10,y),this.circleDiameter=y);}else {var d=s.top*o-u,m=s.bottom*o+u,v=s.left*o-u,g=s.right*o+u,x=s.collisionPadding;if(x&&(v-=x[0]*o,d-=x[1]*o,g+=x[2]*o,m+=x[3]*o),l){var b=new n(v,d),_=new n(g,d),w=new n(v,m),M=new n(g,m),S=l*Math.PI/180;b._rotate(S),_._rotate(S),w._rotate(S),M._rotate(S),v=Math.min(b.x,_.x,w.x,M.x),g=Math.max(b.x,_.x,w.x,M.x),d=Math.min(b.y,_.y,w.y,M.y),m=Math.max(b.y,_.y,w.y,M.y);}t.emplaceBack(e.x,e.y,v,d,g,m,r,i,a);}this.boxEndIndex=t.length;},_p=function(t,e){if(void 0===t&&(t=[]),void 0===e&&(e=wp),this.data=t,this.length=this.data.length,this.compare=e,this.length>0)for(var r=(this.length>>1)-1;r>=0;r--)this._down(r);};function wp(t,e){return t<e?-1:t>e?1:0}function Mp(t,e,r){void 0===e&&(e=1),void 0===r&&(r=!1);for(var i=1/0,a=1/0,s=-1/0,o=-1/0,u=t[0],h=0;h<u.length;h++){var l=u[h];(!h||l.x<i)&&(i=l.x),(!h||l.y<a)&&(a=l.y),(!h||l.x>s)&&(s=l.x),(!h||l.y>o)&&(o=l.y);}var p=Math.min(s-i,o-a),c=p/2,f=new _p([],Sp);if(0===p)return new n(i,a);for(var y=i;y<s;y+=p)for(var d=a;d<o;d+=p)f.push(new Ap(y+c,d+c,c,t));for(var m=function(t){for(var e=0,r=0,i=0,n=t[0],a=0,s=n.length,o=s-1;a<s;o=a++){var u=n[a],h=n[o],l=u.x*h.y-h.x*u.y;r+=(u.x+h.x)*l,i+=(u.y+h.y)*l,e+=3*l;}return new Ap(r/e,i/e,0,t)}(t),v=f.length;f.length;){var g=f.pop();(g.d>m.d||!m.d)&&(m=g,r&&console.log("found best %d after %d probes",Math.round(1e4*g.d)/1e4,v)),g.max-m.d<=e||(f.push(new Ap(g.p.x-(c=g.h/2),g.p.y-c,c,t)),f.push(new Ap(g.p.x+c,g.p.y-c,c,t)),f.push(new Ap(g.p.x-c,g.p.y+c,c,t)),f.push(new Ap(g.p.x+c,g.p.y+c,c,t)),v+=4);}return r&&(console.log("num probes: "+v),console.log("best distance: "+m.d)),m.p}function Sp(t,e){return e.max-t.max}function Ap(t,e,r,i){this.p=new n(t,e),this.h=r,this.d=function(t,e){for(var r=!1,i=1/0,n=0;n<e.length;n++)for(var a=e[n],s=0,o=a.length,u=o-1;s<o;u=s++){var h=a[s],l=a[u];h.y>t.y!=l.y>t.y&&t.x<(l.x-h.x)*(t.y-h.y)/(l.y-h.y)+h.x&&(r=!r),i=Math.min(i,wu(t,h,l));}return (r?1:-1)*Math.sqrt(i)}(this.p,i),this.max=this.d+this.h*Math.SQRT2;}_p.prototype.push=function(t){this.data.push(t),this.length++,this._up(this.length-1);},_p.prototype.pop=function(){if(0!==this.length){var t=this.data[0],e=this.data.pop();return this.length--,this.length>0&&(this.data[0]=e,this._down(0)),t}},_p.prototype.peek=function(){return this.data[0]},_p.prototype._up=function(t){for(var e=this.data,r=this.compare,i=e[t];t>0;){var n=t-1>>1,a=e[n];if(r(i,a)>=0)break;e[t]=a,t=n;}e[t]=i;},_p.prototype._down=function(t){for(var e=this.data,r=this.compare,i=this.length>>1,n=e[t];t<i;){var a=1+(t<<1),s=e[a],o=a+1;if(o<this.length&&r(e[o],s)<0&&(a=o,s=e[o]),r(s,n)>=0)break;e[t]=s,t=a;}e[t]=n;};var kp=Number.POSITIVE_INFINITY;function Ip(t,e){return e[1]!==kp?function(t,e,r){var i=0,n=0;switch(e=Math.abs(e),r=Math.abs(r),t){case"top-right":case"top-left":case"top":n=r-7;break;case"bottom-right":case"bottom-left":case"bottom":n=7-r;}switch(t){case"top-right":case"bottom-right":case"right":i=-e;break;case"top-left":case"bottom-left":case"left":i=e;}return [i,n]}(t,e[0],e[1]):function(t,e){var r=0,i=0;e<0&&(e=0);var n=e/Math.sqrt(2);switch(t){case"top-right":case"top-left":i=n-7;break;case"bottom-right":case"bottom-left":i=7-n;break;case"bottom":i=7-e;break;case"top":i=e-7;}switch(t){case"top-right":case"bottom-right":r=-n;break;case"top-left":case"bottom-left":r=n;break;case"left":r=e;break;case"right":r=-e;}return [r,i]}(t,e[0])}function zp(t){switch(t){case"right":case"top-right":case"bottom-right":return "right";case"left":case"top-left":case"bottom-left":return "left"}return "center"}function Cp(t,e,r,i,a,s,o,u,h,l,p,c,f,y,d){var m=function(t,e,r,i,a,s,o,u){for(var h=i.layout.get("text-rotate").evaluate(s,{})*Math.PI/180,l=[],p=0,c=e.positionedLines;p<c.length;p+=1)for(var f=c[p],y=0,d=f.positionedGlyphs;y<d.length;y+=1){var m=d[y];if(m.rect){var v=m.rect||{},g=4,x=!0,b=1,_=0,w=(a||u)&&m.vertical,M=m.metrics.advance*m.scale/2;if(u&&e.verticalizable&&(_=f.lineOffset/2-(m.imageName?-(24-m.metrics.width*m.scale)/2:24*(m.scale-1))),m.imageName){var S=o[m.imageName];x=S.sdf,g=1/(b=S.pixelRatio);}var A=a?[m.x+M,m.y]:[0,0],k=a?[0,0]:[m.x+M+r[0],m.y+r[1]-_],I=[0,0];w&&(I=k,k=[0,0]);var z=m.metrics.isDoubleResolution?2:1,C=(m.metrics.left-g)*m.scale-M+k[0],E=(-m.metrics.top-g)*m.scale+k[1],P=C+v.w/z*m.scale/b,B=E+v.h/z*m.scale/b,T=new n(C,E),V=new n(P,E),L=new n(C,B),F=new n(P,B);if(w){var O=new n(-M,M- -17),D=-Math.PI/2,N=12-M,R=new n(22-N,-(m.imageName?N:0)),q=new(Function.prototype.bind.apply(n,[null].concat(I)));T._rotateAround(D,O)._add(R)._add(q),V._rotateAround(D,O)._add(R)._add(q),L._rotateAround(D,O)._add(R)._add(q),F._rotateAround(D,O)._add(R)._add(q);}if(h){var j=Math.sin(h),U=Math.cos(h),G=[U,-j,j,U];T._matMult(G),V._matMult(G),L._matMult(G),F._matMult(G);}var K=new n(0,0),X=new n(0,0);l.push({tl:T,tr:V,bl:L,br:F,tex:v,writingMode:e.writingMode,glyphOffset:A,sectionIndex:m.sectionIndex,isSDF:x,pixelOffsetTL:K,pixelOffsetBR:X,minFontScaleX:0,minFontScaleY:0});}}return l}(0,r,u,a,s,o,i,t.allowVerticalPlacement),v=t.textSizeData,g=null;"source"===v.kind?(g=[128*a.layout.get("text-size").evaluate(o,{})])[0]>32640&&M(t.layerIds[0]+': Value for "text-size" is >= 255. Reduce your "text-size".'):"composite"===v.kind&&((g=[128*y.compositeTextSizes[0].evaluate(o,{},d),128*y.compositeTextSizes[1].evaluate(o,{},d)])[0]>32640||g[1]>32640)&&M(t.layerIds[0]+': Value for "text-size" is >= 255. Reduce your "text-size".'),t.addSymbols(t.text,m,g,u,s,o,l,e,h.lineStartIndex,h.lineLength,f,d);for(var x=0,b=p;x<b.length;x+=1)c[b[x]]=t.text.placedSymbolArray.length-1;return 4*m.length}function Ep(t){for(var e in t)return t[e];return null}function Pp(t,e,r,i){var n=t.compareText;if(e in n){for(var a=n[e],s=a.length-1;s>=0;s--)if(i.dist(a[s])<r)return !0}else n[e]=[];return n[e].push(i),!1}var Bp=jh.VectorTileFeature.types,Tp=[{name:"a_fade_opacity",components:1,type:"Uint8",offset:0}];function Vp(t,e,r,i,n,a,s,o,u,h,l,p,c){var f=o?Math.min(32640,Math.round(o[0])):0,y=o?Math.min(32640,Math.round(o[1])):0;t.emplaceBack(e,r,Math.round(32*i),Math.round(32*n),a,s,(f<<1)+(u?1:0),y,16*h,16*l,256*p,256*c);}function Lp(t,e,r){t.emplaceBack(e.x,e.y,r),t.emplaceBack(e.x,e.y,r),t.emplaceBack(e.x,e.y,r),t.emplaceBack(e.x,e.y,r);}function Fp(t){for(var e=0,r=t.sections;e<r.length;e+=1)if(Ms(r[e].text))return !0;return !1}var Op=function(t){this.layoutVertexArray=new so,this.indexArray=new fo,this.programConfigurations=t,this.segments=new Vo,this.dynamicLayoutVertexArray=new oo,this.opacityVertexArray=new uo,this.placedSymbolArray=new ko;};Op.prototype.isEmpty=function(){return 0===this.layoutVertexArray.length&&0===this.indexArray.length&&0===this.dynamicLayoutVertexArray.length&&0===this.opacityVertexArray.length},Op.prototype.upload=function(t,e,r,i){this.isEmpty()||(r&&(this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,hl.members),this.indexBuffer=t.createIndexBuffer(this.indexArray,e),this.dynamicLayoutVertexBuffer=t.createVertexBuffer(this.dynamicLayoutVertexArray,ll.members,!0),this.opacityVertexBuffer=t.createVertexBuffer(this.opacityVertexArray,Tp,!0),this.opacityVertexBuffer.itemSize=1),(r||i)&&this.programConfigurations.upload(t));},Op.prototype.destroy=function(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.programConfigurations.destroy(),this.segments.destroy(),this.dynamicLayoutVertexBuffer.destroy(),this.opacityVertexBuffer.destroy());},da("SymbolBuffers",Op);var Dp=function(t,e,r){this.layoutVertexArray=new t,this.layoutAttributes=e,this.indexArray=new r,this.segments=new Vo,this.collisionVertexArray=new co;};Dp.prototype.upload=function(t){this.layoutVertexBuffer=t.createVertexBuffer(this.layoutVertexArray,this.layoutAttributes),this.indexBuffer=t.createIndexBuffer(this.indexArray),this.collisionVertexBuffer=t.createVertexBuffer(this.collisionVertexArray,pl.members,!0);},Dp.prototype.destroy=function(){this.layoutVertexBuffer&&(this.layoutVertexBuffer.destroy(),this.indexBuffer.destroy(),this.segments.destroy(),this.collisionVertexBuffer.destroy());},da("CollisionBuffers",Dp);var Np=function(t){this.collisionBoxArray=t.collisionBoxArray,this.zoom=t.zoom,this.overscaling=t.overscaling,this.layers=t.layers,this.layerIds=this.layers.map((function(t){return t.id})),this.index=t.index,this.pixelRatio=t.pixelRatio,this.sourceLayerIndex=t.sourceLayerIndex,this.hasPattern=!1,this.hasRTLText=!1,this.sortKeyRanges=[],this.collisionCircleArray=[],this.placementInvProjMatrix=Bu([]),this.placementViewportMatrix=Bu([]);var e=this.layers[0]._unevaluatedLayout._values;this.textSizeData=np(this.zoom,e["text-size"]),this.iconSizeData=np(this.zoom,e["icon-size"]);var r=this.layers[0].layout,i=r.get("symbol-sort-key"),n=r.get("symbol-z-order");this.sortFeaturesByKey="viewport-y"!==n&&void 0!==i.constantOr(1),this.sortFeaturesByY=("viewport-y"===n||"auto"===n&&!this.sortFeaturesByKey)&&(r.get("text-allow-overlap")||r.get("icon-allow-overlap")||r.get("text-ignore-placement")||r.get("icon-ignore-placement")),"point"===r.get("symbol-placement")&&(this.writingModes=r.get("text-writing-mode").map((function(t){return Ul[t]}))),this.stateDependentLayerIds=this.layers.filter((function(t){return t.isStateDependent()})).map((function(t){return t.id})),this.sourceID=t.sourceID;};Np.prototype.createArrays=function(){this.text=new Op(new ou(this.layers,this.zoom,(function(t){return /^text/.test(t)}))),this.icon=new Op(new ou(this.layers,this.zoom,(function(t){return /^icon/.test(t)}))),this.glyphOffsetArray=new Co,this.lineVertexArray=new Eo,this.symbolInstances=new zo;},Np.prototype.calculateGlyphDependencies=function(t,e,r,i,n){for(var a=0;a<t.length;a++)if(e[t.charCodeAt(a)]=!0,(r||i)&&n){var s=dl[t.charAt(a)];s&&(e[s.charCodeAt(0)]=!0);}},Np.prototype.populate=function(t,e,r){var i=this.layers[0],n=i.layout,a=n.get("text-font"),s=n.get("text-field"),o=n.get("icon-image"),u=("constant"!==s.value.kind||s.value.value instanceof vi&&!s.value.value.isEmpty()||s.value.value.toString().length>0)&&("constant"!==a.value.kind||a.value.value.length>0),h="constant"!==o.value.kind||!!o.value.value||Object.keys(o.parameters).length>0,l=n.get("symbol-sort-key");if(this.features=[],u||h){for(var p=e.iconDependencies,c=e.glyphDependencies,f=e.availableImages,y=new Ts(this.zoom),d=0,m=t;d<m.length;d+=1){var v=m[d],g=v.feature,x=v.id,b=v.index,_=v.sourceLayerIndex,w=i._featureFilter.needGeometry,M={type:g.type,id:x,properties:g.properties,geometry:w?cu(g):[]};if(i._featureFilter.filter(y,M,r)){w||(M.geometry=cu(g));var S=void 0;if(u){var A=i.getValueAndResolveTokens("text-field",M,r,f),k=vi.factory(A);Fp(k)&&(this.hasRTLText=!0),(!this.hasRTLText||"unavailable"===Es()||this.hasRTLText&&Bs.isParsed())&&(S=yl(k,i,M));}var I=void 0;if(h){var z=i.getValueAndResolveTokens("icon-image",M,r,f);I=z instanceof gi?z:gi.fromString(z);}if(S||I){var C=this.sortFeaturesByKey?l.evaluate(M,{},r):void 0,E={id:x,text:S,icon:I,index:b,sourceLayerIndex:_,geometry:cu(g),properties:g.properties,type:Bp[g.type],sortKey:C};if(this.features.push(E),I&&(p[I.name]=!0),S){var P=a.evaluate(M,{},r).join(","),B="map"===n.get("text-rotation-alignment")&&"point"!==n.get("symbol-placement");this.allowVerticalPlacement=this.writingModes&&this.writingModes.indexOf(Ul.vertical)>=0;for(var T=0,V=S.sections;T<V.length;T+=1){var L=V[T];if(L.image)p[L.image.name]=!0;else {var F=gs(S.toString()),O=L.fontStack||P,D=c[O]=c[O]||{};this.calculateGlyphDependencies(L.text,D,B,this.allowVerticalPlacement,F);}}}}}}"line"===n.get("symbol-placement")&&(this.features=function(t){var e={},r={},i=[],n=0;function a(e){i.push(t[e]),n++;}function s(t,e,n){var a=r[t];return delete r[t],r[e]=a,i[a].geometry[0].pop(),i[a].geometry[0]=i[a].geometry[0].concat(n[0]),a}function o(t,r,n){var a=e[r];return delete e[r],e[t]=a,i[a].geometry[0].shift(),i[a].geometry[0]=n[0].concat(i[a].geometry[0]),a}function u(t,e,r){var i=r?e[0][e[0].length-1]:e[0][0];return t+":"+i.x+":"+i.y}for(var h=0;h<t.length;h++){var l=t[h],p=l.geometry,c=l.text?l.text.toString():null;if(c){var f=u(c,p),y=u(c,p,!0);if(f in r&&y in e&&r[f]!==e[y]){var d=o(f,y,p),m=s(f,y,i[d].geometry);delete e[f],delete r[y],r[u(c,i[m].geometry,!0)]=m,i[d].geometry=null;}else f in r?s(f,y,p):y in e?o(f,y,p):(a(h),e[f]=n-1,r[y]=n-1);}else a(h);}return i.filter((function(t){return t.geometry}))}(this.features)),this.sortFeaturesByKey&&this.features.sort((function(t,e){return t.sortKey-e.sortKey}));}},Np.prototype.update=function(t,e,r){this.stateDependentLayers.length&&(this.text.programConfigurations.updatePaintArrays(t,e,this.layers,r),this.icon.programConfigurations.updatePaintArrays(t,e,this.layers,r));},Np.prototype.isEmpty=function(){return 0===this.symbolInstances.length&&!this.hasRTLText},Np.prototype.uploadPending=function(){return !this.uploaded||this.text.programConfigurations.needsUpload||this.icon.programConfigurations.needsUpload},Np.prototype.upload=function(t){!this.uploaded&&this.hasDebugData()&&(this.textCollisionBox.upload(t),this.iconCollisionBox.upload(t)),this.text.upload(t,this.sortFeaturesByY,!this.uploaded,this.text.programConfigurations.needsUpload),this.icon.upload(t,this.sortFeaturesByY,!this.uploaded,this.icon.programConfigurations.needsUpload),this.uploaded=!0;},Np.prototype.destroyDebugData=function(){this.textCollisionBox.destroy(),this.iconCollisionBox.destroy();},Np.prototype.destroy=function(){this.text.destroy(),this.icon.destroy(),this.hasDebugData()&&this.destroyDebugData();},Np.prototype.addToLineVertexArray=function(t,e){var r=this.lineVertexArray.length;if(void 0!==t.segment){for(var i=t.dist(e[t.segment+1]),n=t.dist(e[t.segment]),a={},s=t.segment+1;s<e.length;s++)a[s]={x:e[s].x,y:e[s].y,tileUnitDistanceFromAnchor:i},s<e.length-1&&(i+=e[s+1].dist(e[s]));for(var o=t.segment||0;o>=0;o--)a[o]={x:e[o].x,y:e[o].y,tileUnitDistanceFromAnchor:n},o>0&&(n+=e[o-1].dist(e[o]));for(var u=0;u<e.length;u++){var h=a[u];this.lineVertexArray.emplaceBack(h.x,h.y,h.tileUnitDistanceFromAnchor);}}return {lineStartIndex:r,lineLength:this.lineVertexArray.length-r}},Np.prototype.addSymbols=function(t,e,r,i,n,a,s,o,u,h,l,p){for(var c=t.indexArray,f=t.layoutVertexArray,y=t.segments.prepareSegment(4*e.length,f,c,a.sortKey),d=this.glyphOffsetArray.length,m=y.vertexLength,v=this.allowVerticalPlacement&&s===Ul.vertical?Math.PI/2:0,g=a.text&&a.text.sections,x=0;x<e.length;x++){var b=e[x],_=b.tl,w=b.tr,M=b.bl,S=b.br,A=b.tex,k=b.pixelOffsetTL,I=b.pixelOffsetBR,z=b.minFontScaleX,C=b.minFontScaleY,E=b.glyphOffset,P=b.isSDF,B=b.sectionIndex,T=y.vertexLength,V=E[1];Vp(f,o.x,o.y,_.x,V+_.y,A.x,A.y,r,P,k.x,k.y,z,C),Vp(f,o.x,o.y,w.x,V+w.y,A.x+A.w,A.y,r,P,I.x,k.y,z,C),Vp(f,o.x,o.y,M.x,V+M.y,A.x,A.y+A.h,r,P,k.x,I.y,z,C),Vp(f,o.x,o.y,S.x,V+S.y,A.x+A.w,A.y+A.h,r,P,I.x,I.y,z,C),Lp(t.dynamicLayoutVertexArray,o,v),c.emplaceBack(T,T+1,T+2),c.emplaceBack(T+1,T+2,T+3),y.vertexLength+=4,y.primitiveLength+=2,this.glyphOffsetArray.emplaceBack(E[0]),x!==e.length-1&&B===e[x+1].sectionIndex||t.programConfigurations.populatePaintArrays(f.length,a,a.index,{},p,g&&g[B]);}t.placedSymbolArray.emplaceBack(o.x,o.y,d,this.glyphOffsetArray.length-d,m,u,h,o.segment,r?r[0]:0,r?r[1]:0,i[0],i[1],s,0,!1,0,l);},Np.prototype._addCollisionDebugVertex=function(t,e,r,i,n,a){return e.emplaceBack(0,0),t.emplaceBack(r.x,r.y,i,n,Math.round(a.x),Math.round(a.y))},Np.prototype.addCollisionDebugVertices=function(t,e,r,i,a,s,o){var u=a.segments.prepareSegment(4,a.layoutVertexArray,a.indexArray),h=u.vertexLength,l=a.layoutVertexArray,p=a.collisionVertexArray,c=o.anchorX,f=o.anchorY;this._addCollisionDebugVertex(l,p,s,c,f,new n(t,e)),this._addCollisionDebugVertex(l,p,s,c,f,new n(r,e)),this._addCollisionDebugVertex(l,p,s,c,f,new n(r,i)),this._addCollisionDebugVertex(l,p,s,c,f,new n(t,i)),u.vertexLength+=4;var y=a.indexArray;y.emplaceBack(h,h+1),y.emplaceBack(h+1,h+2),y.emplaceBack(h+2,h+3),y.emplaceBack(h+3,h),u.primitiveLength+=4;},Np.prototype.addDebugCollisionBoxes=function(t,e,r,i){for(var n=t;n<e;n++){var a=this.collisionBoxArray.get(n);this.addCollisionDebugVertices(a.x1,a.y1,a.x2,a.y2,i?this.textCollisionBox:this.iconCollisionBox,a.anchorPoint,r);}},Np.prototype.generateCollisionDebugBuffers=function(){this.hasDebugData()&&this.destroyDebugData(),this.textCollisionBox=new Dp(lo,cl.members,bo),this.iconCollisionBox=new Dp(lo,cl.members,bo);for(var t=0;t<this.symbolInstances.length;t++){var e=this.symbolInstances.get(t);this.addDebugCollisionBoxes(e.textBoxStartIndex,e.textBoxEndIndex,e,!0),this.addDebugCollisionBoxes(e.verticalTextBoxStartIndex,e.verticalTextBoxEndIndex,e,!0),this.addDebugCollisionBoxes(e.iconBoxStartIndex,e.iconBoxEndIndex,e,!1),this.addDebugCollisionBoxes(e.verticalIconBoxStartIndex,e.verticalIconBoxEndIndex,e,!1);}},Np.prototype._deserializeCollisionBoxesForSymbol=function(t,e,r,i,n,a,s,o,u){for(var h={},l=e;l<r;l++){var p=t.get(l);h.textBox={x1:p.x1,y1:p.y1,x2:p.x2,y2:p.y2,anchorPointX:p.anchorPointX,anchorPointY:p.anchorPointY},h.textFeatureIndex=p.featureIndex;break}for(var c=i;c<n;c++){var f=t.get(c);h.verticalTextBox={x1:f.x1,y1:f.y1,x2:f.x2,y2:f.y2,anchorPointX:f.anchorPointX,anchorPointY:f.anchorPointY},h.verticalTextFeatureIndex=f.featureIndex;break}for(var y=a;y<s;y++){var d=t.get(y);h.iconBox={x1:d.x1,y1:d.y1,x2:d.x2,y2:d.y2,anchorPointX:d.anchorPointX,anchorPointY:d.anchorPointY},h.iconFeatureIndex=d.featureIndex;break}for(var m=o;m<u;m++){var v=t.get(m);h.verticalIconBox={x1:v.x1,y1:v.y1,x2:v.x2,y2:v.y2,anchorPointX:v.anchorPointX,anchorPointY:v.anchorPointY},h.verticalIconFeatureIndex=v.featureIndex;break}return h},Np.prototype.deserializeCollisionBoxes=function(t){this.collisionArrays=[];for(var e=0;e<this.symbolInstances.length;e++){var r=this.symbolInstances.get(e);this.collisionArrays.push(this._deserializeCollisionBoxesForSymbol(t,r.textBoxStartIndex,r.textBoxEndIndex,r.verticalTextBoxStartIndex,r.verticalTextBoxEndIndex,r.iconBoxStartIndex,r.iconBoxEndIndex,r.verticalIconBoxStartIndex,r.verticalIconBoxEndIndex));}},Np.prototype.hasTextData=function(){return this.text.segments.get().length>0},Np.prototype.hasIconData=function(){return this.icon.segments.get().length>0},Np.prototype.hasDebugData=function(){return this.textCollisionBox&&this.iconCollisionBox},Np.prototype.hasTextCollisionBoxData=function(){return this.hasDebugData()&&this.textCollisionBox.segments.get().length>0},Np.prototype.hasIconCollisionBoxData=function(){return this.hasDebugData()&&this.iconCollisionBox.segments.get().length>0},Np.prototype.addIndicesForPlacedSymbol=function(t,e){for(var r=t.placedSymbolArray.get(e),i=r.vertexStartIndex+4*r.numGlyphs,n=r.vertexStartIndex;n<i;n+=4)t.indexArray.emplaceBack(n,n+1,n+2),t.indexArray.emplaceBack(n+1,n+2,n+3);},Np.prototype.getSortedSymbolIndexes=function(t){if(this.sortedAngle===t&&void 0!==this.symbolInstanceIndexes)return this.symbolInstanceIndexes;for(var e=Math.sin(t),r=Math.cos(t),i=[],n=[],a=[],s=0;s<this.symbolInstances.length;++s){a.push(s);var o=this.symbolInstances.get(s);i.push(0|Math.round(e*o.anchorX+r*o.anchorY)),n.push(o.featureIndex);}return a.sort((function(t,e){return i[t]-i[e]||n[e]-n[t]})),a},Np.prototype.addToSortKeyRanges=function(t,e){var r=this.sortKeyRanges[this.sortKeyRanges.length-1];r&&r.sortKey===e?r.symbolInstanceEnd=t+1:this.sortKeyRanges.push({sortKey:e,symbolInstanceStart:t,symbolInstanceEnd:t+1});},Np.prototype.sortFeatures=function(t){var e=this;if(this.sortFeaturesByY&&this.sortedAngle!==t&&!(this.text.segments.get().length>1||this.icon.segments.get().length>1)){this.symbolInstanceIndexes=this.getSortedSymbolIndexes(t),this.sortedAngle=t,this.text.indexArray.clear(),this.icon.indexArray.clear(),this.featureSortOrder=[];for(var r=0,i=this.symbolInstanceIndexes;r<i.length;r+=1){var n=this.symbolInstances.get(i[r]);this.featureSortOrder.push(n.featureIndex),[n.rightJustifiedTextSymbolIndex,n.centerJustifiedTextSymbolIndex,n.leftJustifiedTextSymbolIndex].forEach((function(t,r,i){t>=0&&i.indexOf(t)===r&&e.addIndicesForPlacedSymbol(e.text,t);})),n.verticalPlacedTextSymbolIndex>=0&&this.addIndicesForPlacedSymbol(this.text,n.verticalPlacedTextSymbolIndex),n.placedIconSymbolIndex>=0&&this.addIndicesForPlacedSymbol(this.icon,n.placedIconSymbolIndex),n.verticalPlacedIconSymbolIndex>=0&&this.addIndicesForPlacedSymbol(this.icon,n.verticalPlacedIconSymbolIndex);}this.text.indexBuffer&&this.text.indexBuffer.updateData(this.text.indexArray),this.icon.indexBuffer&&this.icon.indexBuffer.updateData(this.icon.indexArray);}},da("SymbolBucket",Np,{omit:["layers","collisionBoxArray","features","compareText"]}),Np.MAX_GLYPHS=65535,Np.addDynamicAttributes=Lp;var Rp=new Hs({"symbol-placement":new js(Pa.layout_symbol["symbol-placement"]),"symbol-spacing":new js(Pa.layout_symbol["symbol-spacing"]),"symbol-avoid-edges":new js(Pa.layout_symbol["symbol-avoid-edges"]),"symbol-sort-key":new Us(Pa.layout_symbol["symbol-sort-key"]),"symbol-z-order":new js(Pa.layout_symbol["symbol-z-order"]),"icon-allow-overlap":new js(Pa.layout_symbol["icon-allow-overlap"]),"icon-ignore-placement":new js(Pa.layout_symbol["icon-ignore-placement"]),"icon-optional":new js(Pa.layout_symbol["icon-optional"]),"icon-rotation-alignment":new js(Pa.layout_symbol["icon-rotation-alignment"]),"icon-size":new Us(Pa.layout_symbol["icon-size"]),"icon-text-fit":new js(Pa.layout_symbol["icon-text-fit"]),"icon-text-fit-padding":new js(Pa.layout_symbol["icon-text-fit-padding"]),"icon-image":new Us(Pa.layout_symbol["icon-image"]),"icon-rotate":new Us(Pa.layout_symbol["icon-rotate"]),"icon-padding":new js(Pa.layout_symbol["icon-padding"]),"icon-keep-upright":new js(Pa.layout_symbol["icon-keep-upright"]),"icon-offset":new Us(Pa.layout_symbol["icon-offset"]),"icon-anchor":new Us(Pa.layout_symbol["icon-anchor"]),"icon-pitch-alignment":new js(Pa.layout_symbol["icon-pitch-alignment"]),"text-pitch-alignment":new js(Pa.layout_symbol["text-pitch-alignment"]),"text-rotation-alignment":new js(Pa.layout_symbol["text-rotation-alignment"]),"text-field":new Us(Pa.layout_symbol["text-field"]),"text-font":new Us(Pa.layout_symbol["text-font"]),"text-size":new Us(Pa.layout_symbol["text-size"]),"text-max-width":new Us(Pa.layout_symbol["text-max-width"]),"text-line-height":new js(Pa.layout_symbol["text-line-height"]),"text-letter-spacing":new Us(Pa.layout_symbol["text-letter-spacing"]),"text-justify":new Us(Pa.layout_symbol["text-justify"]),"text-radial-offset":new Us(Pa.layout_symbol["text-radial-offset"]),"text-variable-anchor":new js(Pa.layout_symbol["text-variable-anchor"]),"text-anchor":new Us(Pa.layout_symbol["text-anchor"]),"text-max-angle":new js(Pa.layout_symbol["text-max-angle"]),"text-writing-mode":new js(Pa.layout_symbol["text-writing-mode"]),"text-rotate":new Us(Pa.layout_symbol["text-rotate"]),"text-padding":new js(Pa.layout_symbol["text-padding"]),"text-keep-upright":new js(Pa.layout_symbol["text-keep-upright"]),"text-transform":new Us(Pa.layout_symbol["text-transform"]),"text-offset":new Us(Pa.layout_symbol["text-offset"]),"text-allow-overlap":new js(Pa.layout_symbol["text-allow-overlap"]),"text-ignore-placement":new js(Pa.layout_symbol["text-ignore-placement"]),"text-optional":new js(Pa.layout_symbol["text-optional"])}),qp={paint:new Hs({"icon-opacity":new Us(Pa.paint_symbol["icon-opacity"]),"icon-color":new Us(Pa.paint_symbol["icon-color"]),"icon-halo-color":new Us(Pa.paint_symbol["icon-halo-color"]),"icon-halo-width":new Us(Pa.paint_symbol["icon-halo-width"]),"icon-halo-blur":new Us(Pa.paint_symbol["icon-halo-blur"]),"icon-translate":new js(Pa.paint_symbol["icon-translate"]),"icon-translate-anchor":new js(Pa.paint_symbol["icon-translate-anchor"]),"text-opacity":new Us(Pa.paint_symbol["text-opacity"]),"text-color":new Us(Pa.paint_symbol["text-color"],{runtimeType:ii,getOverride:function(t){return t.textColor},hasOverride:function(t){return !!t.textColor}}),"text-halo-color":new Us(Pa.paint_symbol["text-halo-color"]),"text-halo-width":new Us(Pa.paint_symbol["text-halo-width"]),"text-halo-blur":new Us(Pa.paint_symbol["text-halo-blur"]),"text-translate":new js(Pa.paint_symbol["text-translate"]),"text-translate-anchor":new js(Pa.paint_symbol["text-translate-anchor"])}),layout:Rp},jp=function(t){this.type=t.property.overrides?t.property.overrides.runtimeType:$r,this.defaultValue=t;};jp.prototype.evaluate=function(t){if(t.formattedSection){var e=this.defaultValue.property.overrides;if(e&&e.hasOverride(t.formattedSection))return e.getOverride(t.formattedSection)}return t.feature&&t.featureState?this.defaultValue.evaluate(t.feature,t.featureState):this.defaultValue.property.specification.default},jp.prototype.eachChild=function(t){this.defaultValue.isConstant()||t(this.defaultValue.value._styleExpression.expression);},jp.prototype.outputDefined=function(){return !1},jp.prototype.serialize=function(){return null},da("FormatSectionOverride",jp,{omit:["defaultValue"]});var Up=function(t){function e(e){t.call(this,e,qp);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.recalculate=function(e,r){if(t.prototype.recalculate.call(this,e,r),"auto"===this.layout.get("icon-rotation-alignment")&&(this.layout._values["icon-rotation-alignment"]="point"!==this.layout.get("symbol-placement")?"map":"viewport"),"auto"===this.layout.get("text-rotation-alignment")&&(this.layout._values["text-rotation-alignment"]="point"!==this.layout.get("symbol-placement")?"map":"viewport"),"auto"===this.layout.get("text-pitch-alignment")&&(this.layout._values["text-pitch-alignment"]=this.layout.get("text-rotation-alignment")),"auto"===this.layout.get("icon-pitch-alignment")&&(this.layout._values["icon-pitch-alignment"]=this.layout.get("icon-rotation-alignment")),"point"===this.layout.get("symbol-placement")){var i=this.layout.get("text-writing-mode");if(i){for(var n=[],a=0,s=i;a<s.length;a+=1){var o=s[a];n.indexOf(o)<0&&n.push(o);}this.layout._values["text-writing-mode"]=n;}else this.layout._values["text-writing-mode"]=["horizontal"];}this._setPaintOverrides();},e.prototype.getValueAndResolveTokens=function(t,e,r,i){var n=this.layout.get(t).evaluate(e,{},r,i),a=this._unevaluatedLayout._values[t];return a.isDataDriven()||sa(a.value)||!n?n:function(t,e){return e.replace(/{([^{}]+)}/g,(function(e,r){return r in t?String(t[r]):""}))}(e.properties,n)},e.prototype.createBucket=function(t){return new Np(t)},e.prototype.queryRadius=function(){return 0},e.prototype.queryIntersectsFeature=function(){return !1},e.prototype._setPaintOverrides=function(){for(var t=0,r=qp.paint.overridableProperties;t<r.length;t+=1){var i=r[t];if(e.hasPaintOverride(this.layout,i)){var n,a=this.paint.get(i),s=new jp(a),o=new aa(s,a.property.specification);n="constant"===a.value.kind||"source"===a.value.kind?new ua("source",o):new ha("composite",o,a.value.zoomStops,a.value._interpolationType),this.paint._values[i]=new Rs(a.property,n,a.parameters);}}},e.prototype._handleOverridablePaintPropertyUpdate=function(t,r,i){return !(!this.layout||r.isDataDriven()||i.isDataDriven())&&e.hasPaintOverride(this.layout,t)},e.hasPaintOverride=function(t,e){var r=t.get("text-field"),i=qp.paint.properties[e],n=!1,a=function(t){for(var e=0,r=t;e<r.length;e+=1)if(i.overrides&&i.overrides.hasOverride(r[e]))return void(n=!0)};if("constant"===r.value.kind&&r.value.value instanceof vi)a(r.value.value.sections);else if("source"===r.value.kind){var s=function(t){n||(t instanceof Mi&&_i(t.value)===oi?a(t.value.sections):t instanceof Ii?a(t.sections):t.eachChild(s));},o=r.value;o._styleExpression&&s(o._styleExpression.expression);}return n},e}(Js),Gp={paint:new Hs({"background-color":new js(Pa.paint_background["background-color"]),"background-pattern":new Ks(Pa.paint_background["background-pattern"]),"background-opacity":new js(Pa.paint_background["background-opacity"])})},Kp=function(t){function e(e){t.call(this,e,Gp);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e}(Js),Xp={paint:new Hs({"raster-opacity":new js(Pa.paint_raster["raster-opacity"]),"raster-hue-rotate":new js(Pa.paint_raster["raster-hue-rotate"]),"raster-brightness-min":new js(Pa.paint_raster["raster-brightness-min"]),"raster-brightness-max":new js(Pa.paint_raster["raster-brightness-max"]),"raster-saturation":new js(Pa.paint_raster["raster-saturation"]),"raster-contrast":new js(Pa.paint_raster["raster-contrast"]),"raster-resampling":new js(Pa.paint_raster["raster-resampling"]),"raster-fade-duration":new js(Pa.paint_raster["raster-fade-duration"])})},Hp=function(t){function e(e){t.call(this,e,Xp);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e}(Js),Jp=function(t){function e(e){t.call(this,e,{}),this.implementation=e;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.is3D=function(){return "3d"===this.implementation.renderingMode},e.prototype.hasOffscreenPass=function(){return void 0!==this.implementation.prerender},e.prototype.recalculate=function(){},e.prototype.updateTransitions=function(){},e.prototype.hasTransition=function(){},e.prototype.serialize=function(){},e.prototype.onAdd=function(t){this.implementation.onAdd&&this.implementation.onAdd(t,t.painter.context.gl);},e.prototype.onRemove=function(t){this.implementation.onRemove&&this.implementation.onRemove(t,t.painter.context.gl);},e}(Js),Zp={circle:Ou,heatmap:ju,hillshade:Gu,fill:Eh,"fill-extrusion":Zh,line:ol,symbol:Up,background:Kp,raster:Hp},Yp=s.HTMLImageElement,Wp=s.HTMLCanvasElement,Qp=s.HTMLVideoElement,$p=s.ImageData,tc=s.ImageBitmap,ec=function(t,e,r,i){this.context=t,this.format=r,this.texture=t.gl.createTexture(),this.update(e,i);};ec.prototype.update=function(t,e,r){var i=t.width,n=t.height,a=!(this.size&&this.size[0]===i&&this.size[1]===n||r),s=this.context,o=s.gl;if(this.useMipmap=Boolean(e&&e.useMipmap),o.bindTexture(o.TEXTURE_2D,this.texture),s.pixelStoreUnpackFlipY.set(!1),s.pixelStoreUnpack.set(1),s.pixelStoreUnpackPremultiplyAlpha.set(this.format===o.RGBA&&(!e||!1!==e.premultiply)),a)this.size=[i,n],t instanceof Yp||t instanceof Wp||t instanceof Qp||t instanceof $p||tc&&t instanceof tc?o.texImage2D(o.TEXTURE_2D,0,this.format,this.format,o.UNSIGNED_BYTE,t):o.texImage2D(o.TEXTURE_2D,0,this.format,i,n,0,this.format,o.UNSIGNED_BYTE,t.data);else {var u=r||{x:0,y:0},h=u.x,l=u.y;t instanceof Yp||t instanceof Wp||t instanceof Qp||t instanceof $p||tc&&t instanceof tc?o.texSubImage2D(o.TEXTURE_2D,0,h,l,o.RGBA,o.UNSIGNED_BYTE,t):o.texSubImage2D(o.TEXTURE_2D,0,h,l,i,n,o.RGBA,o.UNSIGNED_BYTE,t.data);}this.useMipmap&&this.isSizePowerOfTwo()&&o.generateMipmap(o.TEXTURE_2D);},ec.prototype.bind=function(t,e,r){var i=this.context.gl;i.bindTexture(i.TEXTURE_2D,this.texture),r!==i.LINEAR_MIPMAP_NEAREST||this.isSizePowerOfTwo()||(r=i.LINEAR),t!==this.filter&&(i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MAG_FILTER,t),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_MIN_FILTER,r||t),this.filter=t),e!==this.wrap&&(i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_S,e),i.texParameteri(i.TEXTURE_2D,i.TEXTURE_WRAP_T,e),this.wrap=e);},ec.prototype.isSizePowerOfTwo=function(){return this.size[0]===this.size[1]&&Math.log(this.size[0])/Math.LN2%1==0},ec.prototype.destroy=function(){this.context.gl.deleteTexture(this.texture),this.texture=null;};var rc=function(t){var e=this;this._callback=t,this._triggered=!1,"undefined"!=typeof MessageChannel&&(this._channel=new MessageChannel,this._channel.port2.onmessage=function(){e._triggered=!1,e._callback();});};rc.prototype.trigger=function(){var t=this;this._triggered||(this._triggered=!0,this._channel?this._channel.port1.postMessage(!0):setTimeout((function(){t._triggered=!1,t._callback();}),0));},rc.prototype.remove=function(){delete this._channel,this._callback=function(){};};var ic=function(t,e,r){this.target=t,this.parent=e,this.mapId=r,this.callbacks={},this.tasks={},this.taskQueue=[],this.cancelCallbacks={},v(["receive","process"],this),this.invoker=new rc(this.process),this.target.addEventListener("message",this.receive,!1),this.globalScope=k()?t:s;};ic.prototype.send=function(t,e,r,i,n,a){var s=this;void 0===n&&(n=!1);var o=Math.round(1e18*Math.random()).toString(36).substring(0,10);r&&(this.callbacks[o]=r);var u=C(this.globalScope)?void 0:[];return this.target.postMessage({sourceId:a,id:o,type:t,hasCallback:!!r,targetMapId:i,mustQueue:n,sourceMapId:this.mapId,data:xa(e,u)},u),{cancel:function(){r&&delete s.callbacks[o],s.target.postMessage({id:o,type:"<cancel>",targetMapId:i,sourceMapId:s.mapId});}}},ic.prototype.receive=function(t){var e=t.data,r=e.id;if(r&&(!e.targetMapId||this.mapId===e.targetMapId))if("<cancel>"===e.type){delete this.tasks[r];var i=this.cancelCallbacks[r];delete this.cancelCallbacks[r],i&&i();}else k()||e.mustQueue?(this.tasks[r]=e,this.taskQueue.push(r),this.invoker.trigger()):this.processTask(r,e);},ic.prototype.process=function(){if(this.taskQueue.length){var t=this.taskQueue.shift(),e=this.tasks[t];delete this.tasks[t],this.taskQueue.length&&this.invoker.trigger(),e&&this.processTask(t,e);}},ic.prototype.processTask=function(t,e){var r=this;if("<response>"===e.type){var i=this.callbacks[t];delete this.callbacks[t],i&&(e.error?i(ba(e.error)):i(null,ba(e.data)));}else {var n=!1,a=C(this.globalScope)?void 0:[],s=e.hasCallback?function(e,i){n=!0,delete r.cancelCallbacks[t],r.target.postMessage({id:t,type:"<response>",sourceMapId:r.mapId,error:e?xa(e):null,data:xa(i,a)},a);}:function(t){n=!0;},o=null,u=ba(e.data);if(this.parent[e.type])o=this.parent[e.type](e.sourceMapId,u,s,e.sourceId);else if(this.parent.getWorkerSource){var h=e.type.split(".");o=this.parent.getWorkerSource(e.sourceMapId,h[0],u.source,u.crs)[h[1]](u,s);}else s(new Error("Could not find function "+e.type));!n&&o&&o.cancel&&(this.cancelCallbacks[t]=o.cancel);}},ic.prototype.remove=function(){this.invoker.remove(),this.target.removeEventListener("message",this.receive,!1);};var nc=function(t,e){t&&(e?this.setSouthWest(t).setNorthEast(e):4===t.length?this.setSouthWest([t[0],t[1]]).setNorthEast([t[2],t[3]]):this.setSouthWest(t[0]).setNorthEast(t[1]));};nc.prototype.setNorthEast=function(t){return this._ne=t instanceof ac?new ac(t.lng,t.lat):ac.convert(t),this},nc.prototype.setSouthWest=function(t){return this._sw=t instanceof ac?new ac(t.lng,t.lat):ac.convert(t),this},nc.prototype.extend=function(t){var e,r,i=this._sw,n=this._ne;if(t instanceof ac)e=t,r=t;else {if(!(t instanceof nc))return Array.isArray(t)?4===t.length||t.every(Array.isArray)?this.extend(nc.convert(t)):this.extend(ac.convert(t)):this;if(r=t._ne,!(e=t._sw)||!r)return this}return i||n?(i.lng=Math.min(e.lng,i.lng),i.lat=Math.min(e.lat,i.lat),n.lng=Math.max(r.lng,n.lng),n.lat=Math.max(r.lat,n.lat)):(this._sw=new ac(e.lng,e.lat),this._ne=new ac(r.lng,r.lat)),this},nc.prototype.getCenter=function(){return new ac((this._sw.lng+this._ne.lng)/2,(this._sw.lat+this._ne.lat)/2)},nc.prototype.getSouthWest=function(){return this._sw},nc.prototype.getNorthEast=function(){return this._ne},nc.prototype.getNorthWest=function(){return new ac(this.getWest(),this.getNorth())},nc.prototype.getSouthEast=function(){return new ac(this.getEast(),this.getSouth())},nc.prototype.getWest=function(){return this._sw.lng},nc.prototype.getSouth=function(){return this._sw.lat},nc.prototype.getEast=function(){return this._ne.lng},nc.prototype.getNorth=function(){return this._ne.lat},nc.prototype.toArray=function(){return [this._sw.toArray(),this._ne.toArray()]},nc.prototype.toString=function(){return "LngLatBounds("+this._sw.toString()+", "+this._ne.toString()+")"},nc.prototype.isEmpty=function(){return !(this._sw&&this._ne)},nc.prototype.contains=function(t){var e=ac.convert(t),r=e.lng,i=e.lat,n=this._sw.lng<=r&&r<=this._ne.lng;return this._sw.lng>this._ne.lng&&(n=this._sw.lng>=r&&r>=this._ne.lng),this._sw.lat<=i&&i<=this._ne.lat&&n},nc.convert=function(t){return !t||t instanceof nc?t:new nc(t)};var ac=function(t,e){if(isNaN(t)||isNaN(e))throw new Error("Invalid LngLat object: ("+t+", "+e+")");this.lng=+t,this.lat=+e;};ac.prototype.wrap=function(){return new ac(p(this.lng,-180,180),this.lat)},ac.prototype.toArray=function(){return [this.lng,this.lat]},ac.prototype.toString=function(){return "LngLat("+this.lng+", "+this.lat+")"},ac.prototype.distanceTo=function(t){var e=Math.PI/180,r=this.lat*e,i=t.lat*e,n=Math.sin(r)*Math.sin(i)+Math.cos(r)*Math.cos(i)*Math.cos((t.lng-this.lng)*e);return 6371008.8*Math.acos(Math.min(n,1))},ac.prototype.toBounds=function(t){void 0===t&&(t=0);var e=360*t/40075017,r=e/Math.cos(Math.PI/180*this.lat);return new nc(new ac(this.lng-r,this.lat-e),new ac(this.lng+r,this.lat+e))},ac.convert=function(t){if(t instanceof ac)return t;if(Array.isArray(t)&&(2===t.length||3===t.length))return new ac(Number(t[0]),Number(t[1]));if(!Array.isArray(t)&&"object"==typeof t&&null!==t)return new ac(Number("lng"in t?t.lng:t.lon),Number(t.lat));throw new Error("`LngLatLike` argument must be specified as a LngLat instance, an object {lng: <lng>, lat: <lat>}, an object {lon: <lng>, lat: <lat>}, or an array of [<lng>, <lat>]")};var sc=2*Math.PI*6371008.8;function oc(t){return sc*Math.cos(t*Math.PI/180)}function uc(t,e){return t/oc(e)}function hc(t){return 360/Math.PI*Math.atan(Math.exp((180-360*t)*Math.PI/180))-90}var lc=function(t,e,r){void 0===r&&(r=0),this.x=+t,this.y=+e,this.z=+r;};lc.fromLngLat=function(t,e){void 0===e&&(e=0);var r=ac.convert(t);return new lc((180+r.lng)/360,(180-180/Math.PI*Math.log(Math.tan(Math.PI/4+r.lat*Math.PI/360)))/360,uc(e,r.lat))},lc.prototype.toLngLat=function(){return new ac(360*this.x-180,hc(this.y))},lc.prototype.toAltitude=function(){return this.z*oc(hc(this.y))},lc.prototype.meterInMercatorCoordinateUnits=function(){return 1/sc*(t=hc(this.y),1/Math.cos(t*Math.PI/180));var t;};var pc=function(t,e,r,i){this.z=t,this.x=e,this.y=r,this.key=yc(0,t,t,e,r),i&&(this.indexExtent=i,this.worldWidth=i[2]-i[0],this.worldHeight=i[3]-i[1]);};pc.prototype.equals=function(t){return this.z===t.z&&this.x===t.x&&this.y===t.y},pc.prototype.getTileBBox=function(){var t=Math.pow(2,this.z);return this.indexExtent[0]+this.worldWidth*this.x/t+","+(this.indexExtent[3]-this.worldHeight*(this.y+1)/t)+","+(this.indexExtent[0]+this.worldWidth*(this.x+1)/t)+","+(this.indexExtent[3]-this.worldHeight*this.y/t)},pc.prototype.url=function(t,e,r,i,n){var a=this.getTileBBox(),s=function(t,e,r){for(var i,n="",a=t;a>0;a--)n+=(e&(i=1<<a-1)?1:0)+(r&i?2:0);return n}(this.z,this.x,this.y);r=r||0;var o=t[(this.x+this.y)%t.length].replace("{prefix}",(this.x%16).toString(16)+(this.y%16).toString(16)).replace("{z}",String(this.z-r)).replace("{x}",String(this.x)).replace("{y}",String("tms"===e?Math.pow(2,this.z)-this.y-1:this.y)).replace("{quadkey}",s).replace("{bbox-epsg-3857}",a).replace("{bbox}",a).replace("{width}",i).replace("{height}",i);if(this.getViewBounds){var u=this.getViewBounds();u&&(o=o.replace("{viewBounds}",u));}if(this.getTileBBoxReverseXY){var h=this.getTileBBoxReverseXY();h&&(o=o.replace("{bbox-wms-1.3.0}",h));}return n&&(o=o.replace("{scale}",n)),o},pc.prototype.getTilePoint=function(t){var e=Math.pow(2,this.z);return new n(8192*(t.x*e-this.x),8192*(t.y*e-this.y))},pc.prototype.toString=function(){return this.z+"/"+this.x+"/"+this.y},pc.prototype.getTileBBoxReverseXY=function(){var t=Math.pow(2,this.z);return this.indexExtent[3]-this.worldHeight*(this.y+1)/t+","+(this.indexExtent[0]+this.worldWidth*this.x/t)+","+(this.indexExtent[3]-this.worldHeight*this.y/t)+","+(this.indexExtent[0]+this.worldWidth*(this.x+1)/t)},pc.prototype.getViewBounds=function(){var t=Math.pow(2,this.z);return '{"leftBottom":{"x":'+(this.indexExtent[0]+this.worldWidth*this.x/t)+',"y":'+(this.indexExtent[3]-this.worldHeight*(this.y+1)/t)+'},"rightTop":{"x":'+(this.indexExtent[0]+this.worldWidth*(this.x+1)/t)+',"y": '+(this.indexExtent[3]-this.worldHeight*this.y/t)+"}}"};var cc=function(t,e){this.wrap=t,this.canonical=e,this.key=yc(t,e.z,e.z,e.x,e.y);},fc=function(t,e,r,i,n,a){this.overscaledZ=t,this.wrap=e,this.canonical=new pc(r,+i,+n,a),this.key=yc(e,t,r,i,n);};function yc(t,e,r,i,n){(t*=2)<0&&(t=-1*t-1);var a=1<<r;return (a*a*t+a*n+i).toString(36)+r.toString(36)+e.toString(36)}fc.prototype.equals=function(t){return this.overscaledZ===t.overscaledZ&&this.wrap===t.wrap&&this.canonical.equals(t.canonical)},fc.prototype.scaledTo=function(t){var e=this.canonical.z-t;return t>this.canonical.z?new fc(t,this.wrap,this.canonical.z,this.canonical.x,this.canonical.y,this.canonical.indexExtent):new fc(t,this.wrap,t,this.canonical.x>>e,this.canonical.y>>e,this.canonical.indexExtent)},fc.prototype.calculateScaledKey=function(t,e){var r=this.canonical.z-t;return t>this.canonical.z?yc(this.wrap*+e,t,this.canonical.z,this.canonical.x,this.canonical.y):yc(this.wrap*+e,t,t,this.canonical.x>>r,this.canonical.y>>r)},fc.prototype.isChildOf=function(t){if(t.wrap!==this.wrap)return !1;var e=this.canonical.z-t.canonical.z;return 0===t.overscaledZ||t.overscaledZ<this.overscaledZ&&t.canonical.x===this.canonical.x>>e&&t.canonical.y===this.canonical.y>>e},fc.prototype.children=function(t){if(this.overscaledZ>=t)return [new fc(this.overscaledZ+1,this.wrap,this.canonical.z,this.canonical.x,this.canonical.y,this.canonical.indexExtent)];var e=this.canonical.z+1,r=2*this.canonical.x,i=2*this.canonical.y;return [new fc(e,this.wrap,e,r,i,this.canonical.indexExtent),new fc(e,this.wrap,e,r+1,i,this.canonical.indexExtent),new fc(e,this.wrap,e,r,i+1,this.canonical.indexExtent),new fc(e,this.wrap,e,r+1,i+1,this.canonical.indexExtent)]},fc.prototype.isLessThan=function(t){return this.wrap<t.wrap||!(this.wrap>t.wrap)&&(this.overscaledZ<t.overscaledZ||!(this.overscaledZ>t.overscaledZ)&&(this.canonical.x<t.canonical.x||!(this.canonical.x>t.canonical.x)&&this.canonical.y<t.canonical.y))},fc.prototype.wrapped=function(){return new fc(this.overscaledZ,0,this.canonical.z,this.canonical.x,this.canonical.y,this.canonical.indexExtent)},fc.prototype.unwrapTo=function(t){return new fc(this.overscaledZ,t,this.canonical.z,this.canonical.x,this.canonical.y,this.canonical.indexExtent)},fc.prototype.overscaleFactor=function(){return Math.pow(2,this.overscaledZ-this.canonical.z)},fc.prototype.toUnwrapped=function(){return new cc(this.wrap,this.canonical)},fc.prototype.toString=function(){return this.overscaledZ+"/"+this.canonical.x+"/"+this.canonical.y},fc.prototype.getTilePoint=function(t){return this.canonical.getTilePoint(new lc(t.x-this.wrap,t.y))},da("CanonicalTileID",pc),da("OverscaledTileID",fc,{omit:["posMatrix"]});var dc=function(t,e,r){if(this.uid=t,e.height!==e.width)throw new RangeError("DEM tiles must be square");if(r&&"mapbox"!==r&&"terrarium"!==r)return M('"'+r+'" is not a valid encoding type. Valid types include "mapbox" and "terrarium".');this.stride=e.height;var i=this.dim=e.height-2;this.data=new Uint32Array(e.data.buffer),this.encoding=r||"mapbox";for(var n=0;n<i;n++)this.data[this._idx(-1,n)]=this.data[this._idx(0,n)],this.data[this._idx(i,n)]=this.data[this._idx(i-1,n)],this.data[this._idx(n,-1)]=this.data[this._idx(n,0)],this.data[this._idx(n,i)]=this.data[this._idx(n,i-1)];this.data[this._idx(-1,-1)]=this.data[this._idx(0,0)],this.data[this._idx(i,-1)]=this.data[this._idx(i-1,0)],this.data[this._idx(-1,i)]=this.data[this._idx(0,i-1)],this.data[this._idx(i,i)]=this.data[this._idx(i-1,i-1)];};dc.prototype.get=function(t,e){var r=new Uint8Array(this.data.buffer),i=4*this._idx(t,e);return ("terrarium"===this.encoding?this._unpackTerrarium:this._unpackMapbox)(r[i],r[i+1],r[i+2])},dc.prototype.getUnpackVector=function(){return "terrarium"===this.encoding?[256,1,1/256,32768]:[6553.6,25.6,.1,1e4]},dc.prototype._idx=function(t,e){if(t<-1||t>=this.dim+1||e<-1||e>=this.dim+1)throw new RangeError("out of range source coordinates for DEM data");return (e+1)*this.stride+(t+1)},dc.prototype._unpackMapbox=function(t,e,r){return (256*t*256+256*e+r)/10-1e4},dc.prototype._unpackTerrarium=function(t,e,r){return 256*t+e+r/256-32768},dc.prototype.getPixels=function(){return new Aa({width:this.stride,height:this.stride},new Uint8Array(this.data.buffer))},dc.prototype.backfillBorder=function(t,e,r){if(this.dim!==t.dim)throw new Error("dem dimension mismatch");var i=e*this.dim,n=e*this.dim+this.dim,a=r*this.dim,s=r*this.dim+this.dim;switch(e){case-1:i=n-1;break;case 1:n=i+1;}switch(r){case-1:a=s-1;break;case 1:s=a+1;}for(var o=-e*this.dim,u=-r*this.dim,h=a;h<s;h++)for(var l=i;l<n;l++)this.data[this._idx(l,h)]=t.data[this._idx(l+o,h+u)];},da("DEMData",dc);var mc=function(t){this._stringToNumber={},this._numberToString=[];for(var e=0;e<t.length;e++){var r=t[e];this._stringToNumber[r]=e,this._numberToString[e]=r;}};mc.prototype.encode=function(t){return this._stringToNumber[t]},mc.prototype.decode=function(t){return this._numberToString[t]};var vc=function(t,e,r,i,n,a){this.type="Feature",this._vectorTileFeature=t,t._z=e,t._x=r,t._y=i,this.properties=t.properties,this.id=n,this.crs=a;},gc={geometry:{configurable:!0}};gc.geometry.get=function(){var t=this;return void 0===this._geometry&&(this._geometry=this._vectorTileFeature.toGeoJSON(this._vectorTileFeature._x,this._vectorTileFeature._y,this._vectorTileFeature._z,(function(e,r){if(t.crs){var i=t.crs.toLngLat(e,r);return [i.lng,i.lat]}return console.log(vc.toLngLat),vc.toLngLat(e,r)})).geometry),this._geometry},gc.geometry.set=function(t){this._geometry=t;},vc.prototype.toJSON=function(){var t={geometry:this.geometry};for(var e in this)"_geometry"!==e&&"_vectorTileFeature"!==e&&(t[e]=this[e]);return t},Object.defineProperties(vc.prototype,gc);var xc=function(){this.state={},this.stateChanges={},this.deletedStates={};};xc.prototype.updateState=function(t,e,r){var i=String(e);if(this.stateChanges[t]=this.stateChanges[t]||{},this.stateChanges[t][i]=this.stateChanges[t][i]||{},c(this.stateChanges[t][i],r),null===this.deletedStates[t])for(var n in this.deletedStates[t]={},this.state[t])n!==i&&(this.deletedStates[t][n]=null);else if(this.deletedStates[t]&&null===this.deletedStates[t][i])for(var a in this.deletedStates[t][i]={},this.state[t][i])r[a]||(this.deletedStates[t][i][a]=null);else for(var s in r)this.deletedStates[t]&&this.deletedStates[t][i]&&null===this.deletedStates[t][i][s]&&delete this.deletedStates[t][i][s];},xc.prototype.removeFeatureState=function(t,e,r){if(null!==this.deletedStates[t]){var i=String(e);if(this.deletedStates[t]=this.deletedStates[t]||{},r&&void 0!==e)null!==this.deletedStates[t][i]&&(this.deletedStates[t][i]=this.deletedStates[t][i]||{},this.deletedStates[t][i][r]=null);else if(void 0!==e)if(this.stateChanges[t]&&this.stateChanges[t][i])for(r in this.deletedStates[t][i]={},this.stateChanges[t][i])this.deletedStates[t][i][r]=null;else this.deletedStates[t][i]=null;else this.deletedStates[t]=null;}},xc.prototype.getState=function(t,e){var r=String(e),i=c({},(this.state[t]||{})[r],(this.stateChanges[t]||{})[r]);if(null===this.deletedStates[t])return {};if(this.deletedStates[t]){var n=this.deletedStates[t][e];if(null===n)return {};for(var a in n)delete i[a];}return i},xc.prototype.initializeTileState=function(t,e){t.setFeatureState(this.state,e);},xc.prototype.coalesceChanges=function(t,e){var r={};for(var i in this.stateChanges){this.state[i]=this.state[i]||{};var n={};for(var a in this.stateChanges[i])this.state[i][a]||(this.state[i][a]={}),c(this.state[i][a],this.stateChanges[i][a]),n[a]=this.state[i][a];r[i]=n;}for(var s in this.deletedStates){this.state[s]=this.state[s]||{};var o={};if(null===this.deletedStates[s])for(var u in this.state[s])o[u]={},this.state[s][u]={};else for(var h in this.deletedStates[s]){if(null===this.deletedStates[s][h])this.state[s][h]={};else for(var l=0,p=Object.keys(this.deletedStates[s][h]);l<p.length;l+=1)delete this.state[s][h][p[l]];o[h]=this.state[s][h];}r[s]=r[s]||{},c(r[s],o);}if(this.stateChanges={},this.deletedStates={},0!==Object.keys(r).length)for(var f in t)t[f].setFeatureState(r,e);};var bc=function(t,e){this.tileID=t,this.x=t.canonical.x,this.y=t.canonical.y,this.z=t.canonical.z,this.grid=new Xr(8192,16,0),this.grid3D=new Xr(8192,16,0),this.featureIndexArray=new Bo,this.promoteId=e;};function _c(t,e,r,i,n){return x(t,(function(t,a){var s=e instanceof qs?e.get(a):null;return s&&s.evaluate?s.evaluate(r,i,n):s}))}function wc(t){for(var e=1/0,r=1/0,i=-1/0,n=-1/0,a=0,s=t;a<s.length;a+=1){var o=s[a];e=Math.min(e,o.x),r=Math.min(r,o.y),i=Math.max(i,o.x),n=Math.max(n,o.y);}return {minX:e,minY:r,maxX:i,maxY:n}}function Mc(t,e){return e-t}bc.prototype.insert=function(t,e,r,i,n,a){var s=this.featureIndexArray.length;this.featureIndexArray.emplaceBack(r,i,n);for(var o=a?this.grid3D:this.grid,u=0;u<e.length;u++){for(var h=e[u],l=[1/0,1/0,-1/0,-1/0],p=0;p<h.length;p++){var c=h[p];l[0]=Math.min(l[0],c.x),l[1]=Math.min(l[1],c.y),l[2]=Math.max(l[2],c.x),l[3]=Math.max(l[3],c.y);}l[0]<8192&&l[1]<8192&&l[2]>=0&&l[3]>=0&&o.insert(s,l[0],l[1],l[2],l[3]);}},bc.prototype.loadVTLayers=function(){return this.vtLayers||(this.vtLayers=new jh.VectorTile(new gl(this.rawTileData)).layers,this.sourceLayerCoder=new mc(this.vtLayers?Object.keys(this.vtLayers).sort():["_geojsonTileLayer"])),this.vtLayers},bc.prototype.query=function(t,e,r,i){var a=this;this.loadVTLayers();for(var s=t.params||{},o=8192/t.tileSize/t.scale,u=Ga(s.filter),h=t.queryGeometry,l=t.queryPadding*o,p=wc(h),c=this.grid.query(p.minX-l,p.minY-l,p.maxX+l,p.maxY+l),f=wc(t.cameraQueryGeometry),y=this.grid3D.query(f.minX-l,f.minY-l,f.maxX+l,f.maxY+l,(function(e,r,i,a){return function(t,e,r,i,a){for(var s=0,o=t;s<o.length;s+=1){var u=o[s];if(e<=u.x&&r<=u.y&&i>=u.x&&a>=u.y)return !0}var h=[new n(e,r),new n(e,a),new n(i,a),new n(i,r)];if(t.length>2)for(var l=0,p=h;l<p.length;l+=1)if(Su(t,p[l]))return !0;for(var c=0;c<t.length-1;c++)if(Au(t[c],t[c+1],h))return !0;return !1}(t.cameraQueryGeometry,e-l,r-l,i+l,a+l)})),d=0,m=y;d<m.length;d+=1)c.push(m[d]);c.sort(Mc);for(var v,g={},x=function(n){var l=c[n];if(l!==v){v=l;var p=a.featureIndexArray.get(l),f=null;a.loadMatchingFeature(g,p.bucketIndex,p.sourceLayerIndex,p.featureIndex,u,s.layers,s.availableImages,e,r,i,(function(e,r,i){return f||(f=cu(e)),r.queryIntersectsFeature(h,e,i,f,a.z,t.transform,o,t.pixelPosMatrix)}),t.transform.crs);}},b=0;b<c.length;b++)x(b);return g},bc.prototype.loadMatchingFeature=function(t,e,r,i,n,a,s,o,u,h,l,p){var c=this.bucketLayerIDs[e];if(!a||function(t,e){for(var r=0;r<t.length;r++)if(e.indexOf(t[r])>=0)return !0;return !1}(a,c)){var f=this.sourceLayerCoder.decode(r),y=this.vtLayers[f].feature(i);if(n.filter(new Ts(this.tileID.overscaledZ),y))for(var d=this.getId(y,f),m=0;m<c.length;m++){var v=c[m];if(!(a&&a.indexOf(v)<0)){var g=o[v];if(g){var x={};void 0!==d&&h&&(x=h.getState(g.sourceLayer||"_geojsonTileLayer",d));var b=u[v];b.paint=_c(b.paint,g.paint,y,x,s),b.layout=_c(b.layout,g.layout,y,x,s);var _=!l||l(y,g,x);if(_){var w=new vc(y,this.z,this.x,this.y,d,p);w.layer=b;var M=t[v];void 0===M&&(M=t[v]=[]),M.push({featureIndex:i,feature:w,intersectionZ:_});}}}}}},bc.prototype.lookupSymbolFeatures=function(t,e,r,i,n,a,s,o,u){var h={};this.loadVTLayers();for(var l=Ga(n),p=0,c=t;p<c.length;p+=1)this.loadMatchingFeature(h,r,i,c[p],l,a,s,o,e,void 0,void 0,u);return h},bc.prototype.hasLayer=function(t){for(var e=0,r=this.bucketLayerIDs;e<r.length;e+=1)for(var i=0,n=r[e];i<n.length;i+=1)if(t===n[i])return !0;return !1},bc.prototype.getId=function(t,e){var r=t.id;return this.promoteId&&"boolean"==typeof(r=t.properties["string"==typeof this.promoteId?this.promoteId:this.promoteId[e]])&&(r=Number(r)),r},da("FeatureIndex",bc,{omit:["rawTileData","sourceLayerCoder"]});var Sc=function(t,e){this.tileID=t,this.uid=y(),this.uses=0,this.tileSize=e,this.buckets={},this.expirationTime=null,this.queryPadding=0,this.hasSymbolBuckets=!1,this.hasRTLText=!1,this.dependencies={},this.expiredRequestCount=0,this.state="loading";};Sc.prototype.registerFadeDuration=function(t){var e=t+this.timeAdded;e<D.now()||this.fadeEndTime&&e<this.fadeEndTime||(this.fadeEndTime=e);},Sc.prototype.wasRequested=function(){return "errored"===this.state||"loaded"===this.state||"reloading"===this.state},Sc.prototype.loadVectorData=function(t,e,r){if(this.hasData()&&this.unloadVectorData(),this.state="loaded",t){for(var i in t.featureIndex&&(this.latestFeatureIndex=t.featureIndex,t.rawTileData?(this.latestRawTileData=t.rawTileData,this.latestFeatureIndex.rawTileData=t.rawTileData):this.latestRawTileData&&(this.latestFeatureIndex.rawTileData=this.latestRawTileData)),this.collisionBoxArray=t.collisionBoxArray,this.buckets=function(t,e){var r={};if(!e)return r;for(var i=function(){var t=a[n],i=t.layerIds.map((function(t){return e.getLayer(t)})).filter(Boolean);if(0!==i.length){t.layers=i,t.stateDependentLayerIds&&(t.stateDependentLayers=t.stateDependentLayerIds.map((function(t){return i.filter((function(e){return e.id===t}))[0]})));for(var s=0,o=i;s<o.length;s+=1)r[o[s].id]=t;}},n=0,a=t;n<a.length;n+=1)i();return r}(t.buckets,e.style),this.hasSymbolBuckets=!1,this.buckets){var n=this.buckets[i];if(n instanceof Np){if(this.hasSymbolBuckets=!0,!r)break;n.justReloaded=!0;}}if(this.hasRTLText=!1,this.hasSymbolBuckets)for(var a in this.buckets){var s=this.buckets[a];if(s instanceof Np&&s.hasRTLText){this.hasRTLText=!0,Bs.isLoading()||Bs.isLoaded()||"deferred"!==Es()||Ps();break}}for(var o in this.queryPadding=0,this.buckets){var u=this.buckets[o];this.queryPadding=Math.max(this.queryPadding,e.style.getLayer(o).queryRadius(u));}t.imageAtlas&&(this.imageAtlas=t.imageAtlas),t.glyphAtlasImage&&(this.glyphAtlasImage=t.glyphAtlasImage);}else this.collisionBoxArray=new So;},Sc.prototype.unloadVectorData=function(){for(var t in this.buckets)this.buckets[t].destroy();this.buckets={},this.imageAtlasTexture&&this.imageAtlasTexture.destroy(),this.imageAtlas&&(this.imageAtlas=null),this.glyphAtlasTexture&&this.glyphAtlasTexture.destroy(),this.latestFeatureIndex=null,this.state="unloaded";},Sc.prototype.getBucket=function(t){return this.buckets[t.id]},Sc.prototype.upload=function(t){for(var e in this.buckets){var r=this.buckets[e];r.uploadPending()&&r.upload(t);}var i=t.gl;this.imageAtlas&&!this.imageAtlas.uploaded&&(this.imageAtlasTexture=new ec(t,this.imageAtlas.image,i.RGBA),this.imageAtlas.uploaded=!0),this.glyphAtlasImage&&(this.glyphAtlasTexture=new ec(t,this.glyphAtlasImage,i.ALPHA),this.glyphAtlasImage=null);},Sc.prototype.prepare=function(t){this.imageAtlas&&this.imageAtlas.patchUpdatedImages(t,this.imageAtlasTexture);},Sc.prototype.queryRenderedFeatures=function(t,e,r,i,n,a,s,o,u,h){return this.latestFeatureIndex&&this.latestFeatureIndex.rawTileData?this.latestFeatureIndex.query({queryGeometry:i,cameraQueryGeometry:n,scale:a,tileSize:this.tileSize,pixelPosMatrix:h,transform:o,params:s,queryPadding:this.queryPadding*u},t,e,r):{}},Sc.prototype.querySourceFeatures=function(t,e,r){var i=this.latestFeatureIndex;if(i&&i.rawTileData){var n=i.loadVTLayers(),a=e?e.sourceLayer:"",s=n._geojsonTileLayer||n[a];if(s)for(var o=Ga(e&&e.filter),u=this.tileID.canonical,h=u.z,l=u.x,p=u.y,c={z:h,x:l,y:p},f=0;f<s.length;f++){var y=s.feature(f);if(o.filter(new Ts(this.tileID.overscaledZ),y)){var d=i.getId(y,a),m=new vc(y,h,l,p,d,r);m.tile=c,t.push(m);}}}},Sc.prototype.hasData=function(){return "loaded"===this.state||"reloading"===this.state||"expired"===this.state},Sc.prototype.patternsLoaded=function(){return this.imageAtlas&&!!Object.keys(this.imageAtlas.patternPositions).length},Sc.prototype.setExpiryData=function(t){var e=this.expirationTime;if(t.cacheControl){var r=I(t.cacheControl);r["max-age"]&&(this.expirationTime=Date.now()+1e3*r["max-age"]);}else t.expires&&(this.expirationTime=new Date(t.expires).getTime());if(this.expirationTime){var i=Date.now(),n=!1;if(this.expirationTime>i)n=!1;else if(e)if(this.expirationTime<e)n=!0;else {var a=this.expirationTime-e;a?this.expirationTime=i+Math.max(a,3e4):n=!0;}else n=!0;n?(this.expiredRequestCount++,this.state="expired"):this.expiredRequestCount=0;}},Sc.prototype.getExpiryTimeout=function(){if(this.expirationTime)return this.expiredRequestCount?1e3*(1<<Math.min(this.expiredRequestCount-1,31)):Math.min(this.expirationTime-(new Date).getTime(),Math.pow(2,31)-1)},Sc.prototype.setFeatureState=function(t,e){if(this.latestFeatureIndex&&this.latestFeatureIndex.rawTileData&&0!==Object.keys(t).length){var r=this.latestFeatureIndex.loadVTLayers();for(var i in this.buckets)if(e.style.hasLayer(i)){var n=this.buckets[i],a=n.layers[0].sourceLayer||"_geojsonTileLayer",s=r[a],o=t[a];if(s&&o&&0!==Object.keys(o).length){n.update(o,s,this.imageAtlas&&this.imageAtlas.patternPositions||{});var u=e&&e.style&&e.style.getLayer(i);u&&(this.queryPadding=Math.max(this.queryPadding,u.queryRadius(n)));}}}},Sc.prototype.holdingForFade=function(){return void 0!==this.symbolFadeHoldUntil},Sc.prototype.symbolFadeFinished=function(){return !this.symbolFadeHoldUntil||this.symbolFadeHoldUntil<D.now()},Sc.prototype.clearFadeHold=function(){this.symbolFadeHoldUntil=void 0;},Sc.prototype.setHoldDuration=function(t){this.symbolFadeHoldUntil=D.now()+t;},Sc.prototype.setDependencies=function(t,e){for(var r={},i=0,n=e;i<n.length;i+=1)r[n[i]]=!0;this.dependencies[t]=r;},Sc.prototype.hasDependency=function(t,e){for(var r=0,i=t;r<i.length;r+=1){var n=this.dependencies[i[r]];if(n)for(var a=0,s=e;a<s.length;a+=1)if(n[s[a]])return !0}return !1};var Ac=s.performance,kc=function(t){this._marks={start:[t.url,"start"].join("#"),end:[t.url,"end"].join("#"),measure:t.url.toString()},Ac.mark(this._marks.start);};kc.prototype.finish=function(){Ac.mark(this._marks.end);var t=Ac.getEntriesByName(this._marks.measure);return 0===t.length&&(Ac.measure(this._marks.measure,this._marks.start,this._marks.end),t=Ac.getEntriesByName(this._marks.measure),Ac.clearMarks(this._marks.start),Ac.clearMarks(this._marks.end),Ac.clearMeasures(this._marks.measure)),t},t.Actor=ic,t.AlphaImage=Sa,t.CanonicalTileID=pc,t.CollisionBoxArray=So,t.Color=Zr,t.DEMData=dc,t.DataConstantProperty=js,t.DictionaryCoder=mc,t.EXTENT=8192,t.ErrorEvent=Ca,t.EvaluationParameters=Ts,t.Event=za,t.Evented=Ea,t.Feature=vc,t.FeatureIndex=bc,t.FillBucket=Ih,t.FillExtrusionBucket=Xh,t.ImageAtlas=jl,t.ImagePosition=Rl,t.LineBucket=il,t.LngLat=ac,t.LngLatBounds=nc,t.MercatorCoordinate=lc,t.ONE_EM=24,t.OverscaledTileID=fc,t.Point=n,t.Point$1=n,t.Properties=Hs,t.Protobuf=gl,t.RGBAImage=Aa,t.RequestManager=yr,t.RequestPerformance=kc,t.ResourceType=Or,t.SegmentVector=Vo,t.SourceFeatureState=xc,t.StructArrayLayout1ui2=_o,t.StructArrayLayout2f1f2i16=po,t.StructArrayLayout2i4=to,t.StructArrayLayout3ui6=fo,t.StructArrayLayout4i8=eo,t.SymbolBucket=Np,t.Texture=ec,t.Tile=Sc,t.Transitionable=Fs,t.Uniform1f=Ho,t.Uniform1i=Xo,t.Uniform2f=Jo,t.Uniform3f=Zo,t.Uniform4f=Yo,t.UniformColor=Wo,t.UniformMatrix4f=$o,t.UnwrappedTileID=cc,t.ValidationError=Ba,t.VectorTile=Rh,t.VectorTileLayer=qh,t.WritingMode=Ul,t.ZoomHistory=ms,t.add=function(t,e,r){return t[0]=e[0]+r[0],t[1]=e[1]+r[1],t[2]=e[2]+r[2],t},t.addDynamicAttributes=Lp,t.aea=Ge,t.aeqd=er,t.asyncAll=function(t,e,r){if(!t.length)return r(null,[]);var i=t.length,n=new Array(t.length),a=null;t.forEach((function(t,s){e(t,(function(t,e){t&&(a=t),n[s]=e,0==--i&&r(a,n);}));}));},t.bezier=u,t.bindAll=v,t.browser=D,t.cacheEntryPossiblyAdded=function(t){++Lr>Pr&&(t.getActor().send("enforceCacheSizeLimit",Er),Lr=0);},t.cass=Re,t.cea=Xe,t.clamp=l,t.clearTileCache=function(t){var e=s.caches.delete("mapbox-tiles");t&&e.catch(t).then((function(){return t()}));},t.clipLine=yp,t.clone=function(t){var e=new Pu(16);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},t.clone$1=_,t.clone$2=function(t){var e=new Pu(3);return e[0]=t[0],e[1]=t[1],e[2]=t[2],e},t.collisionCircleLayout=fl,t.config=N,t.create=function(){var t=new Pu(16);return Pu!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=0,t[12]=0,t[13]=0,t[14]=0),t[0]=1,t[5]=1,t[10]=1,t[15]=1,t},t.create$1=function(){var t=new Pu(9);return Pu!=Float32Array&&(t[1]=0,t[2]=0,t[3]=0,t[5]=0,t[6]=0,t[7]=0),t[0]=1,t[4]=1,t[8]=1,t},t.create$2=function(){var t=new Pu(4);return Pu!=Float32Array&&(t[1]=0,t[2]=0),t[0]=1,t[3]=1,t},t.createCommonjsModule=e,t.createExpression=oa,t.createLayout=Qs,t.createStyleLayer=function(t){return "custom"===t.type?new Jp(t):new Zp[t.type](t)},t.cross=function(t,e,r){var i=e[0],n=e[1],a=e[2],s=r[0],o=r[1],u=r[2];return t[0]=n*u-a*o,t[1]=a*s-i*u,t[2]=i*o-n*s,t},t.deepEqual=function t(e,r){if(Array.isArray(e)){if(!Array.isArray(r)||e.length!==r.length)return !1;for(var i=0;i<e.length;i++)if(!t(e[i],r[i]))return !1;return !0}if("object"==typeof e&&null!==e&&null!==r){if("object"!=typeof r)return !1;if(Object.keys(e).length!==Object.keys(r).length)return !1;for(var n in e)if(!t(e[n],r[n]))return !1;return !0}return e===r},t.dot=function(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]},t.dot$1=function(t,e){return t[0]*e[0]+t[1]*e[1]+t[2]*e[2]+t[3]*e[3]},t.ease=h,t.emitValidationErrors=ds,t.endsWith=g,t.enforceCacheSizeLimit=function(t){Br(),Mr&&Mr.then((function(e){e.keys().then((function(r){for(var i=0;i<r.length-t;i++)e.delete(r[i]);}));}));},t.eqc=He,t.eqdc=$e,t.etmerc=we,t.evaluateSizeForFeature=ap,t.evaluateSizeForZoom=sp,t.evaluateVariableOffset=Ip,t.evented=Cs,t.extend=c,t.featureFilter=Ga,t.filterObject=b,t.fromRotation=function(t,e){var r=Math.sin(e),i=Math.cos(e);return t[0]=i,t[1]=r,t[2]=0,t[3]=-r,t[4]=i,t[5]=0,t[6]=0,t[7]=0,t[8]=1,t},t.geocent=lr,t.geos=fr,t.getAnchorAlignment=tp,t.getAnchorJustification=zp,t.getArrayBuffer=Ur,t.getImage=Kr,t.getJSON=function(t,e){return jr(c(t,{type:"json"}),e)},t.getRTLTextPluginStatus=Es,t.getReferrer=Nr,t.getVideo=function(t,e){var r,i,n=s.document.createElement("video");n.muted=!0,n.onloadstart=function(){e(null,n);};for(var a=0;a<t.length;a++){var o=s.document.createElement("source");r=t[a],i=void 0,(i=s.document.createElement("a")).href=r,(i.protocol!==s.document.location.protocol||i.host!==s.document.location.host)&&(n.crossOrigin="Anonymous"),o.src=t[a],n.appendChild(o);}return {cancel:function(){}}},t.gnom=Ke,t.identity=Bu,t.invert=function(t,e){var r=e[0],i=e[1],n=e[2],a=e[3],s=e[4],o=e[5],u=e[6],h=e[7],l=e[8],p=e[9],c=e[10],f=e[11],y=e[12],d=e[13],m=e[14],v=e[15],g=r*o-i*s,x=r*u-n*s,b=r*h-a*s,_=i*u-n*o,w=i*h-a*o,M=n*h-a*u,S=l*d-p*y,A=l*m-c*y,k=l*v-f*y,I=p*m-c*d,z=p*v-f*d,C=c*v-f*m,E=g*C-x*z+b*I+_*k-w*A+M*S;return E?(t[0]=(o*C-u*z+h*I)*(E=1/E),t[1]=(n*z-i*C-a*I)*E,t[2]=(d*M-m*w+v*_)*E,t[3]=(c*w-p*M-f*_)*E,t[4]=(u*k-s*C-h*A)*E,t[5]=(r*C-n*k+a*A)*E,t[6]=(m*b-y*M-v*x)*E,t[7]=(l*M-c*b+f*x)*E,t[8]=(s*z-o*k+h*S)*E,t[9]=(i*k-r*z-a*S)*E,t[10]=(y*w-d*b+v*g)*E,t[11]=(p*b-l*w-f*g)*E,t[12]=(o*A-s*I-u*S)*E,t[13]=(r*I-i*A+n*S)*E,t[14]=(d*x-y*_-m*g)*E,t[15]=(l*_-p*x+c*g)*E,t):null},t.isChar=vs,t.isMapboxURL=dr,t.keysDifference=function(t,e){var r=[];for(var i in t)i in e||r.push(i);return r},t.krovak=Pe,t.laea=je,t.lcc=Ee,t.makeRequest=jr,t.mapObject=x,t.mercatorZfromAltitude=uc,t.mill=Ye,t.moll=Qe,t.mul=Lu,t.multiply=Tu,t.mvt=jh,t.nextPowerOfTwo=function(t){return t<=1?1:Math.pow(2,Math.ceil(Math.log(t)/Math.LN2))},t.normalize=function(t,e){var r=e[0],i=e[1],n=e[2],a=r*r+i*i+n*n;return a>0&&(a=1/Math.sqrt(a)),t[0]=e[0]*a,t[1]=e[1]*a,t[2]=e[2]*a,t},t.number=an,t.nzmg=Ze,t.offscreenCanvasSupported=Fr,t.omerc=Ce,t.ortho=function(t,e,r,i,n,a,s){var o=1/(e-r),u=1/(i-n),h=1/(a-s);return t[0]=-2*o,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=-2*u,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[10]=2*h,t[11]=0,t[12]=(e+r)*o,t[13]=(n+i)*u,t[14]=(s+a)*h,t[15]=1,t},t.ortho$1=rr,t.parseCode=mt,t.parseGlyphPBF=function(t){return new gl(t).readFields(Fl,[])},t.pbf=gl,t.performSymbolLayout=function(t,e,r,i,n,a,s){t.createArrays(),t.tilePixelRatio=8192/(512*t.overscaling),t.compareText={},t.iconsNeedLinear=!1;var o=t.layers[0].layout,u=t.layers[0]._unevaluatedLayout._values,h={};if("composite"===t.textSizeData.kind){var l=t.textSizeData,p=l.maxZoom;h.compositeTextSizes=[u["text-size"].possiblyEvaluate(new Ts(l.minZoom),s),u["text-size"].possiblyEvaluate(new Ts(p),s)];}if("composite"===t.iconSizeData.kind){var c=t.iconSizeData,f=c.maxZoom;h.compositeIconSizes=[u["icon-size"].possiblyEvaluate(new Ts(c.minZoom),s),u["icon-size"].possiblyEvaluate(new Ts(f),s)];}h.layoutTextSize=u["text-size"].possiblyEvaluate(new Ts(t.zoom+1),s),h.layoutIconSize=u["icon-size"].possiblyEvaluate(new Ts(t.zoom+1),s),h.textMaxSize=u["text-size"].possiblyEvaluate(new Ts(18));for(var y=24*o.get("text-line-height"),d="map"===o.get("text-rotation-alignment")&&"point"!==o.get("symbol-placement"),m=o.get("text-keep-upright"),v=o.get("text-size"),g=function(){var a=b[x],u=o.get("text-font").evaluate(a,{},s).join(","),l=v.evaluate(a,{},s),p=h.layoutTextSize.evaluate(a,{},s),c=h.layoutIconSize.evaluate(a,{},s),f={horizontal:{},vertical:void 0},g=a.text,_=[0,0];if(g){var w=g.toString(),S=24*o.get("text-letter-spacing").evaluate(a,{},s),A=function(t){for(var e=0,r=t;e<r.length;e+=1)if(i=r[e].charCodeAt(0),vs.Arabic(i)||vs["Arabic Supplement"](i)||vs["Arabic Extended-A"](i)||vs["Arabic Presentation Forms-A"](i)||vs["Arabic Presentation Forms-B"](i))return !1;var i;return !0}(w)?S:0,k=o.get("text-anchor").evaluate(a,{},s),I=o.get("text-variable-anchor");if(!I){var z=o.get("text-radial-offset").evaluate(a,{},s);_=z?Ip(k,[24*z,kp]):o.get("text-offset").evaluate(a,{},s).map((function(t){return 24*t}));}var C=d?"center":o.get("text-justify").evaluate(a,{},s),E=o.get("symbol-placement"),P="point"===E?24*o.get("text-max-width").evaluate(a,{},s):0,B=function(){t.allowVerticalPlacement&&gs(w)&&(f.vertical=Xl(g,e,r,n,u,P,y,k,"left",A,_,Ul.vertical,!0,E,p,l));};if(!d&&I){for(var T="auto"===C?I.map((function(t){return zp(t)})):[C],V=!1,L=0;L<T.length;L++){var F=T[L];if(!f.horizontal[F])if(V)f.horizontal[F]=f.horizontal[0];else {var O=Xl(g,e,r,n,u,P,y,"center",F,A,_,Ul.horizontal,!1,E,p,l);O&&(f.horizontal[F]=O,V=1===O.positionedLines.length);}}B();}else {"auto"===C&&(C=zp(k));var D=Xl(g,e,r,n,u,P,y,k,C,A,_,Ul.horizontal,!1,E,p,l);D&&(f.horizontal[C]=D),B(),gs(w)&&d&&m&&(f.vertical=Xl(g,e,r,n,u,P,y,k,C,A,_,Ul.vertical,!1,E,p,l));}}var N=void 0,R=!1;if(a.icon&&a.icon.name){var q=i[a.icon.name];q&&(N=function(t,e,r){var i=tp(r),n=e[0]-t.displaySize[0]*i.horizontalAlign,a=e[1]-t.displaySize[1]*i.verticalAlign;return {image:t,top:a,bottom:a+t.displaySize[1],left:n,right:n+t.displaySize[0]}}(n[a.icon.name],o.get("icon-offset").evaluate(a,{},s),o.get("icon-anchor").evaluate(a,{},s)),R=q.sdf,void 0===t.sdfIcons?t.sdfIcons=q.sdf:t.sdfIcons!==q.sdf&&M("Style sheet warning: Cannot mix SDF and non-SDF icons in one buffer"),(q.pixelRatio!==t.pixelRatio||0!==o.get("icon-rotate").constantOr(1))&&(t.iconsNeedLinear=!0));}var j=Ep(f.horizontal)||f.vertical;t.iconsInText=!!j&&j.iconsInText,(j||N)&&function(t,e,r,i,n,a,s,o,u,h,l){var p=a.textMaxSize.evaluate(e,{});void 0===p&&(p=s);var c,f=t.layers[0].layout,y=f.get("icon-offset").evaluate(e,{},l),d=Ep(r.horizontal),m=s/24,v=t.tilePixelRatio*m,g=t.tilePixelRatio*p/24,x=t.tilePixelRatio*o,b=t.tilePixelRatio*f.get("symbol-spacing"),_=f.get("text-padding")*t.tilePixelRatio,w=f.get("icon-padding")*t.tilePixelRatio,S=f.get("text-max-angle")/180*Math.PI,A="map"===f.get("text-rotation-alignment")&&"point"!==f.get("symbol-placement"),k="map"===f.get("icon-rotation-alignment")&&"point"!==f.get("symbol-placement"),I=f.get("symbol-placement"),z=b/2,C=f.get("icon-text-fit");i&&"none"!==C&&(t.allowVerticalPlacement&&r.vertical&&(c=rp(i,r.vertical,C,f.get("icon-text-fit-padding"),y,m)),d&&(i=rp(i,d,C,f.get("icon-text-fit-padding"),y,m)));var E=function(o,p){p.x<0||p.x>=8192||p.y<0||p.y>=8192||function(t,e,r,i,n,a,s,o,u,h,l,p,c,f,y,d,m,v,g,x,b,_,w,S,A){var k,I,z,C,E,P=t.addToLineVertexArray(e,r),B=0,T=0,V=0,L=0,F=-1,O=-1,D={},N=No(""),R=0,q=0;if(void 0===o._unevaluatedLayout.getValue("text-radial-offset")?(R=(k=o.layout.get("text-offset").evaluate(b,{},S).map((function(t){return 24*t})))[0],q=k[1]):(R=24*o.layout.get("text-radial-offset").evaluate(b,{},S),q=kp),t.allowVerticalPlacement&&i.vertical){var j=o.layout.get("text-rotate").evaluate(b,{},S)+90;C=new bp(u,e,h,l,p,i.vertical,c,f,y,j),s&&(E=new bp(u,e,h,l,p,s,m,v,y,j));}if(n){var U=o.layout.get("icon-rotate").evaluate(b,{}),G="none"!==o.layout.get("icon-text-fit"),K=dp(n,U,w,G),X=s?dp(s,U,w,G):void 0;z=new bp(u,e,h,l,p,n,m,v,!1,U),B=4*K.length;var H=t.iconSizeData,J=null;"source"===H.kind?(J=[128*o.layout.get("icon-size").evaluate(b,{})])[0]>32640&&M(t.layerIds[0]+': Value for "icon-size" is >= 255. Reduce your "icon-size".'):"composite"===H.kind&&((J=[128*_.compositeIconSizes[0].evaluate(b,{},S),128*_.compositeIconSizes[1].evaluate(b,{},S)])[0]>32640||J[1]>32640)&&M(t.layerIds[0]+': Value for "icon-size" is >= 255. Reduce your "icon-size".'),t.addSymbols(t.icon,K,J,x,g,b,!1,e,P.lineStartIndex,P.lineLength,-1,S),F=t.icon.placedSymbolArray.length-1,X&&(T=4*X.length,t.addSymbols(t.icon,X,J,x,g,b,Ul.vertical,e,P.lineStartIndex,P.lineLength,-1,S),O=t.icon.placedSymbolArray.length-1);}for(var Z in i.horizontal){var Y=i.horizontal[Z];if(!I){N=No(Y.text);var W=o.layout.get("text-rotate").evaluate(b,{},S);I=new bp(u,e,h,l,p,Y,c,f,y,W);}var Q=1===Y.positionedLines.length;if(V+=Cp(t,e,Y,a,o,y,b,d,P,i.vertical?Ul.horizontal:Ul.horizontalOnly,Q?Object.keys(i.horizontal):[Z],D,F,_,S),Q)break}i.vertical&&(L+=Cp(t,e,i.vertical,a,o,y,b,d,P,Ul.vertical,["vertical"],D,O,_,S));var $=I?I.boxStartIndex:t.collisionBoxArray.length,tt=I?I.boxEndIndex:t.collisionBoxArray.length,et=C?C.boxStartIndex:t.collisionBoxArray.length,rt=C?C.boxEndIndex:t.collisionBoxArray.length,it=z?z.boxStartIndex:t.collisionBoxArray.length,nt=z?z.boxEndIndex:t.collisionBoxArray.length,at=E?E.boxStartIndex:t.collisionBoxArray.length,st=E?E.boxEndIndex:t.collisionBoxArray.length,ot=-1,ut=function(t,e){return t&&t.circleDiameter?Math.max(t.circleDiameter,e):e};ot=ut(I,ot),ot=ut(C,ot),ot=ut(z,ot);var ht=(ot=ut(E,ot))>-1?1:0;ht&&(ot*=A/24),t.glyphOffsetArray.length>=Np.MAX_GLYPHS&&M("Too many glyphs being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907"),void 0!==b.sortKey&&t.addToSortKeyRanges(t.symbolInstances.length,b.sortKey),t.symbolInstances.emplaceBack(e.x,e.y,D.right>=0?D.right:-1,D.center>=0?D.center:-1,D.left>=0?D.left:-1,D.vertical||-1,F,O,N,$,tt,et,rt,it,nt,at,st,h,V,L,B,T,ht,0,c,R,q,ot);}(t,p,o,r,i,n,c,t.layers[0],t.collisionBoxArray,e.index,e.sourceLayerIndex,t.index,v,_,A,u,x,w,k,y,e,a,h,l,s);};if("line"===I)for(var P=0,B=yp(e.geometry,0,0,8192,8192);P<B.length;P+=1)for(var T=B[P],V=0,L=fp(T,b,S,r.vertical||d,i,24,g,t.overscaling,8192);V<L.length;V+=1){var F=L[V];d&&Pp(t,d.text,z,F)||E(T,F);}else if("line-center"===I)for(var O=0,D=e.geometry;O<D.length;O+=1){var N=D[O];if(N.length>1){var R=cp(N,S,r.vertical||d,i,24,g);R&&E(N,R);}}else if("Polygon"===e.type)for(var q=0,j=Mh(e.geometry,0);q<j.length;q+=1){var U=j[q],G=Mp(U,16);E(U[0],new ip(G.x,G.y,0));}else if("LineString"===e.type)for(var K=0,X=e.geometry;K<X.length;K+=1){var H=X[K];E(H,new ip(H[0].x,H[0].y,0));}else if("Point"===e.type)for(var J=0,Z=e.geometry;J<Z.length;J+=1)for(var Y=0,W=Z[J];Y<W.length;Y+=1){var Q=W[Y];E([Q],new ip(Q.x,Q.y,0));}}(t,a,f,N,i,h,p,c,_,R,s);},x=0,b=t.features;x<b.length;x+=1)g();a&&t.generateCollisionDebugBuffers();},t.perspective=function(t,e,r,i,n){var a,s=1/Math.tan(e/2);return t[0]=s/r,t[1]=0,t[2]=0,t[3]=0,t[4]=0,t[5]=s,t[6]=0,t[7]=0,t[8]=0,t[9]=0,t[11]=-1,t[12]=0,t[13]=0,t[15]=0,null!=n&&n!==1/0?(t[10]=(n+i)*(a=1/(i-n)),t[14]=2*n*i*a):(t[10]=-1,t[14]=-2*i),t},t.pick=function(t,e){for(var r={},i=0;i<e.length;i++){var n=e[i];n in t&&(r[n]=t[n]);}return r},t.plugin=Bs,t.poly=Je,t.polygonIntersectsPolygon=du,t.postMapLoadEvent=Cr,t.postTurnstileEvent=Ir,t.potpack=Nl,t.proj4=$t,t.qsc=ar,t.refProperties=["type","source","source-layer","minzoom","maxzoom","filter","layout"],t.register=da,t.registerForPluginStateChange=function(t){return t({pluginStatus:As,pluginURL:ks}),Cs.on("pluginStateChange",t),t},t.renderColorRamp=qu,t.robin=hr,t.rotate=function(t,e,r){var i=e[0],n=e[1],a=e[2],s=e[3],o=Math.sin(r),u=Math.cos(r);return t[0]=i*u+a*o,t[1]=n*u+s*o,t[2]=i*-o+a*u,t[3]=n*-o+s*u,t},t.rotateX=function(t,e,r){var i=Math.sin(r),n=Math.cos(r),a=e[4],s=e[5],o=e[6],u=e[7],h=e[8],l=e[9],p=e[10],c=e[11];return e!==t&&(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[4]=a*n+h*i,t[5]=s*n+l*i,t[6]=o*n+p*i,t[7]=u*n+c*i,t[8]=h*n-a*i,t[9]=l*n-s*i,t[10]=p*n-o*i,t[11]=c*n-u*i,t},t.rotateZ=function(t,e,r){var i=Math.sin(r),n=Math.cos(r),a=e[0],s=e[1],o=e[2],u=e[3],h=e[4],l=e[5],p=e[6],c=e[7];return e!==t&&(t[8]=e[8],t[9]=e[9],t[10]=e[10],t[11]=e[11],t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15]),t[0]=a*n+h*i,t[1]=s*n+l*i,t[2]=o*n+p*i,t[3]=u*n+c*i,t[4]=h*n-a*i,t[5]=l*n-s*i,t[6]=p*n-o*i,t[7]=c*n-u*i,t},t.scale=function(t,e,r){var i=r[0],n=r[1],a=r[2];return t[0]=e[0]*i,t[1]=e[1]*i,t[2]=e[2]*i,t[3]=e[3]*i,t[4]=e[4]*n,t[5]=e[5]*n,t[6]=e[6]*n,t[7]=e[7]*n,t[8]=e[8]*a,t[9]=e[9]*a,t[10]=e[10]*a,t[11]=e[11]*a,t[12]=e[12],t[13]=e[13],t[14]=e[14],t[15]=e[15],t},t.scale$1=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t[3]=e[3]*r,t},t.scale$2=function(t,e,r){return t[0]=e[0]*r,t[1]=e[1]*r,t[2]=e[2]*r,t},t.setCacheLimits=function(t,e){Er=t,Pr=e;},t.setRTLTextPlugin=function(t,e,r){if(void 0===r&&(r=!1),"deferred"===As||"loading"===As||"loaded"===As)throw new Error("setRTLTextPlugin cannot be called multiple times.");ks=D.resolveURL(t),As="deferred",Ss=e,zs(),r||Ps();},t.sinu=We,t.somerc=ze,t.sphericalToCartesian=function(t){var e=t[0],r=t[1],i=t[2];return r+=90,r*=Math.PI/180,i*=Math.PI/180,{x:e*Math.cos(r)*Math.sin(i),y:e*Math.sin(r)*Math.sin(i),z:e*Math.cos(i)}},t.sqrLen=function(t){var e=t[0],r=t[1];return e*e+r*r},t.stere=Ie,t.sterea=ke,t.styleSpec=Pa,t.sub=function(t,e,r){return t[0]=e[0]-r[0],t[1]=e[1]-r[1],t[2]=e[2]-r[2],t},t.symbolSize=op,t.tmerc=ve,t.tpers=cr,t.transformMat3=function(t,e,r){var i=e[0],n=e[1],a=e[2];return t[0]=i*r[0]+n*r[3]+a*r[6],t[1]=i*r[1]+n*r[4]+a*r[7],t[2]=i*r[2]+n*r[5]+a*r[8],t},t.transformMat4=Fu,t.translate=function(t,e,r){var i,n,a,s,o,u,h,l,p,c,f,y,d=r[0],m=r[1],v=r[2];return e===t?(t[12]=e[0]*d+e[4]*m+e[8]*v+e[12],t[13]=e[1]*d+e[5]*m+e[9]*v+e[13],t[14]=e[2]*d+e[6]*m+e[10]*v+e[14],t[15]=e[3]*d+e[7]*m+e[11]*v+e[15]):(n=e[1],a=e[2],s=e[3],o=e[4],u=e[5],h=e[6],l=e[7],p=e[8],c=e[9],f=e[10],y=e[11],t[0]=i=e[0],t[1]=n,t[2]=a,t[3]=s,t[4]=o,t[5]=u,t[6]=h,t[7]=l,t[8]=p,t[9]=c,t[10]=f,t[11]=y,t[12]=i*d+o*m+p*v+e[12],t[13]=n*d+u*m+c*v+e[13],t[14]=a*d+h*m+f*v+e[14],t[15]=s*d+l*m+y*v+e[15]),t},t.triggerPluginCompletionEvent=Is,t.unWrapLng=function(t,e,r,i,n){return 180-(i-e)/((i-r)/(180-t))},t.uniqueId=y,t.utm=Me,t.validateCustomStyleLayer=function(t){var e=[],r=t.id;return void 0===r&&e.push({message:"layers."+r+': missing required property "id"'}),void 0===t.render&&e.push({message:"layers."+r+': missing required method "render"'}),t.renderingMode&&"2d"!==t.renderingMode&&"3d"!==t.renderingMode&&e.push({message:"layers."+r+': property "renderingMode" must be either "2d" or "3d"'}),e},t.validateLight=cs,t.validateStyle=ps,t.values=function(t){var e=[];for(var r in t)e.push(t[r]);return e},t.vandg=tr,t.version="1.12.1-6",t.warnOnce=M,t.webpSupported=R,t.window=s,t.wrap=p;}));

define(["./shared","@supermapgis/tile-decryptor"],(function(e,t){"use strict";function r(e){var t=typeof e;if("number"===t||"boolean"===t||"string"===t||null==e)return JSON.stringify(e);if(Array.isArray(e)){for(var o="[",i=0,n=e;i<n.length;i+=1)o+=r(n[i])+",";return o+"]"}for(var s=Object.keys(e).sort(),a="{",l=0;l<s.length;l++)a+=JSON.stringify(s[l])+":"+r(e[s[l]])+",";return a+"}"}function o(t){for(var o="",i=0,n=e.refProperties;i<n.length;i+=1)o+="/"+r(t[n[i]]);return o}t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;var i=function(e){this.keyCache={},e&&this.replace(e);};i.prototype.replace=function(e){this._layerConfigs={},this._layers={},this.update(e,[]);},i.prototype.update=function(t,r){for(var i=this,n=0,s=t;n<s.length;n+=1){var a=s[n];this._layerConfigs[a.id]=a;var l=this._layers[a.id]=e.createStyleLayer(a);l._featureFilter=e.featureFilter(l.filter),this.keyCache[a.id]&&delete this.keyCache[a.id];}for(var u=0,h=r;u<h.length;u+=1){var p=h[u];delete this.keyCache[p],delete this._layerConfigs[p],delete this._layers[p];}this.familiesBySource={};for(var c=0,f=function(e,t){for(var r={},i=0;i<e.length;i++){var n=t&&t[e[i].id]||o(e[i]);t&&(t[e[i].id]=n);var s=r[n];s||(s=r[n]=[]),s.push(e[i]);}var a=[];for(var l in r)a.push(r[l]);return a}(e.values(this._layerConfigs),this.keyCache);c<f.length;c+=1){var d=f[c].map((function(e){return i._layers[e.id]})),g=d[0];if("none"!==g.visibility){var v=g.source||"",m=this.familiesBySource[v];m||(m=this.familiesBySource[v]={});var y=g.sourceLayer||"_geojsonTileLayer",x=m[y];x||(x=m[y]=[]),x.push(d);}}};var n=function(t){var r={},o=[];for(var i in t){var n=t[i],s=r[i]={};for(var a in n){var l=n[+a];if(l&&0!==l.bitmap.width&&0!==l.bitmap.height){var u={x:0,y:0,w:l.bitmap.width+2,h:l.bitmap.height+2};o.push(u),s[a]={rect:u,metrics:l.metrics};}}}var h=e.potpack(o),p=new e.AlphaImage({width:h.w||1,height:h.h||1});for(var c in t){var f=t[c];for(var d in f){var g=f[+d];if(g&&0!==g.bitmap.width&&0!==g.bitmap.height){var v=r[c][d].rect;e.AlphaImage.copy(g.bitmap,p,{x:0,y:0},{x:v.x+1,y:v.y+1},g.bitmap);}}}this.image=p,this.positions=r;};e.register("GlyphAtlas",n);var s=function(t){this.tileID=new e.OverscaledTileID(t.tileID.overscaledZ,t.tileID.wrap,t.tileID.canonical.z,t.tileID.canonical.x,t.tileID.canonical.y,t.tileID.canonical.indexExtent),this.uid=t.uid,this.zoom=t.zoom,this.pixelRatio=t.pixelRatio,this.tileSize=t.tileSize,this.source=t.source,this.overscaling=this.tileID.overscaleFactor(),this.showCollisionBoxes=t.showCollisionBoxes,this.collectResourceTiming=!!t.collectResourceTiming,this.returnDependencies=!!t.returnDependencies,this.promoteId=t.promoteId;};function a(t,r,o){for(var i=new e.EvaluationParameters(r),n=0,s=t;n<s.length;n+=1)s[n].recalculate(i,o);}function l(r,o){var i=e.getArrayBuffer(r.request,(function(i,n,s,a){if(i)o(i);else if(n){if(r.decryptOptions){var l=Object.assign({},r.decryptOptions,{arrayBuffer:n});n=t(l);}o(null,{vectorTile:new e.mvt.VectorTile(new e.pbf(n)),rawData:n,cacheControl:s,expires:a});}}));return function(){i.cancel(),o();}}s.prototype.parse=function(t,r,o,i,s){var l=this;this.status="parsing",this.data=t,this.collisionBoxArray=new e.CollisionBoxArray;var u=new e.DictionaryCoder(Object.keys(t.layers).sort()),h=new e.FeatureIndex(this.tileID,this.promoteId);h.bucketLayerIDs=[];var p,c,f,d,g={},v={featureIndex:h,iconDependencies:{},patternDependencies:{},glyphDependencies:{},availableImages:o},m=r.familiesBySource[this.source];for(var y in m){var x=t.layers[y];if(x){1===x.version&&e.warnOnce('Vector tile source "'+this.source+'" layer "'+y+'" does not use vector tile spec v2 and therefore may have some rendering errors.');for(var w=u.encode(y),S=[],b=0;b<x.length;b++){var _=x.feature(b),I=h.getId(_,y);S.push({feature:_,id:I,index:b,sourceLayerIndex:w});}for(var M=0,P=m[y];M<P.length;M+=1){var k=P[M],C=k[0];C.minzoom&&this.zoom<Math.floor(C.minzoom)||C.maxzoom&&this.zoom>=C.maxzoom||"none"!==C.visibility&&(a(k,this.zoom,o),(g[C.id]=C.createBucket({index:h.bucketLayerIDs.length,layers:k,zoom:this.zoom,pixelRatio:this.pixelRatio,overscaling:this.overscaling,collisionBoxArray:this.collisionBoxArray,sourceLayerIndex:w,sourceID:this.source})).populate(S,v,this.tileID.canonical),h.bucketLayerIDs.push(k.map((function(e){return e.id}))));}}}var T=e.mapObject(v.glyphDependencies,(function(e){return Object.keys(e).map(Number)}));Object.keys(T).length?i.send("getGlyphs",{uid:this.uid,stacks:T},(function(e,t){p||(p=e,c=t,D.call(l));}),!1,this.source):c={};var L=Object.keys(v.iconDependencies);L.length?i.send("getImages",{icons:L,source:this.source,tileID:this.tileID,type:"icons"},(function(e,t){p||(p=e,f=t,D.call(l));}),!1,this.source):f={};var j=Object.keys(v.patternDependencies);function D(){if(p)return s(p);if(c&&f&&d){var t=new n(c),r=new e.ImageAtlas(f,d);for(var i in g){var l=g[i];l instanceof e.SymbolBucket?(a(l.layers,this.zoom,o),e.performSymbolLayout(l,c,t.positions,f,r.iconPositions,this.showCollisionBoxes,this.tileID.canonical)):l.hasPattern&&(l instanceof e.LineBucket||l instanceof e.FillBucket||l instanceof e.FillExtrusionBucket)&&(a(l.layers,this.zoom,o),l.addFeatures(v,this.tileID.canonical,r.patternPositions));}this.status="done",s(null,{buckets:e.values(g).filter((function(e){return !e.isEmpty()})),featureIndex:h,collisionBoxArray:this.collisionBoxArray,glyphAtlasImage:t.image,imageAtlas:r,glyphMap:this.returnDependencies?c:null,iconMap:this.returnDependencies?f:null,glyphPositions:this.returnDependencies?t.positions:null});}}j.length?i.send("getImages",{icons:j,source:this.source,tileID:this.tileID,type:"patterns"},(function(e,t){p||(p=e,d=t,D.call(l));}),!1,this.source):d={},D.call(this);};var u=function(e,t,r,o){this.actor=e,this.layerIndex=t,this.availableImages=r,this.loadVectorData=o||l,this.loading={},this.loaded={};};u.prototype.loadTile=function(t,r){var o=this,i=t.uid;this.loading||(this.loading={});var n=!!(t&&t.request&&t.request.collectResourceTiming)&&new e.RequestPerformance(t.request),a=this.loading[i]=new s(t);a.abort=this.loadVectorData(t,(function(t,s){if(delete o.loading[i],t||!s)return a.status="done",o.loaded[i]=a,r(t);var l=s.rawData,u={};s.expires&&(u.expires=s.expires),s.cacheControl&&(u.cacheControl=s.cacheControl);var h={};if(n){var p=n.finish();p&&(h.resourceTiming=JSON.parse(JSON.stringify(p)));}a.vectorTile=s.vectorTile,a.parse(s.vectorTile,o.layerIndex,o.availableImages,o.actor,(function(t,o){if(t||!o)return r(t);r(null,e.extend({rawTileData:l.slice(0)},o,u,h));})),o.loaded=o.loaded||{},o.loaded[i]=a;}));},u.prototype.reloadTile=function(e,t){var r=this,o=this.loaded,i=e.uid,n=this;if(o&&o[i]){var s=o[i];s.showCollisionBoxes=e.showCollisionBoxes;var a=function(e,o){var i=s.reloadCallback;i&&(delete s.reloadCallback,s.parse(s.vectorTile,n.layerIndex,r.availableImages,n.actor,i)),t(e,o);};"parsing"===s.status?s.reloadCallback=a:"done"===s.status&&(s.vectorTile?s.parse(s.vectorTile,this.layerIndex,this.availableImages,this.actor,a):a());}},u.prototype.abortTile=function(e,t){var r=this.loading,o=e.uid;r&&r[o]&&r[o].abort&&(r[o].abort(),delete r[o]),t();},u.prototype.removeTile=function(e,t){var r=this.loaded,o=e.uid;r&&r[o]&&delete r[o],t();};var h=e.window.ImageBitmap,p=function(){this.loaded={};};function c(e,t){if(0!==e.length){f(e[0],t);for(var r=1;r<e.length;r++)f(e[r],!t);}}function f(e,t){for(var r=0,o=0,i=0,n=e.length,s=n-1;i<n;s=i++){var a=(e[i][0]-e[s][0])*(e[s][1]+e[i][1]),l=r+a;o+=Math.abs(r)>=Math.abs(a)?r-l+a:a-l+r,r=l;}r+o>=0!=!!t&&e.reverse();}p.prototype.loadTile=function(t,r){var o=t.uid,i=t.encoding,n=t.rawImageData,s=h&&n instanceof h?this.getImageData(n):n,a=new e.DEMData(o,s,i);this.loaded=this.loaded||{},this.loaded[o]=a,r(null,a);},p.prototype.getImageData=function(t){this.offscreenCanvas&&this.offscreenCanvasContext||(this.offscreenCanvas=new OffscreenCanvas(t.width,t.height),this.offscreenCanvasContext=this.offscreenCanvas.getContext("2d")),this.offscreenCanvas.width=t.width,this.offscreenCanvas.height=t.height,this.offscreenCanvasContext.drawImage(t,0,0,t.width,t.height);var r=this.offscreenCanvasContext.getImageData(-1,-1,t.width+2,t.height+2);return this.offscreenCanvasContext.clearRect(0,0,this.offscreenCanvas.width,this.offscreenCanvas.height),new e.RGBAImage({width:r.width,height:r.height},r.data)},p.prototype.removeTile=function(e){var t=this.loaded,r=e.uid;t&&t[r]&&delete t[r];};var d=e.mvt.VectorTileFeature.prototype.toGeoJSON,g=function(t){this._feature=t,this.extent=e.EXTENT,this.type=t.type,this.properties=t.tags,"id"in t&&!isNaN(t.id)&&(this.id=parseInt(t.id,10));};g.prototype.loadGeometry=function(){if(1===this._feature.type){for(var t=[],r=0,o=this._feature.geometry;r<o.length;r+=1){var i=o[r];t.push([new e.Point$1(i[0],i[1])]);}return t}for(var n=[],s=0,a=this._feature.geometry;s<a.length;s+=1){for(var l=[],u=0,h=a[s];u<h.length;u+=1){var p=h[u];l.push(new e.Point$1(p[0],p[1]));}n.push(l);}return n},g.prototype.toGeoJSON=function(e,t,r){return d.call(this,e,t,r)};var v=function(t){this.layers={_geojsonTileLayer:this},this.name="_geojsonTileLayer",this.extent=e.EXTENT,this.length=t.length,this._features=t;};v.prototype.feature=function(e){return new g(this._features[e])};var m=w;function w(e,t,r,o,i){this.properties={},this.extent=r,this.type=0,this._pbf=e,this._geometry=-1,this._keys=o,this._values=i,e.readFields(S,this,t);}function S(e,t,r){1==e?t.id=r.readVarint():2==e?function(e,t){for(var r=e.readVarint()+e.pos;e.pos<r;){var o=t._keys[e.readVarint()],i=t._values[e.readVarint()];t.properties[o]=i;}}(r,t):3==e?t.type=r.readVarint():4==e&&(t._geometry=r.pos);}function b(e){for(var t,r,o=0,i=0,n=e.length,s=n-1;i<n;s=i++)o+=((r=e[s]).x-(t=e[i]).x)*(t.y+r.y);return o}w.types=["Unknown","Point","LineString","Polygon"],w.prototype.loadGeometry=function(){var t=this._pbf;t.pos=this._geometry;for(var r,o=t.readVarint()+t.pos,i=1,n=0,s=0,a=0,l=[];t.pos<o;){if(n<=0){var u=t.readVarint();i=7&u,n=u>>3;}if(n--,1===i||2===i)s+=t.readSVarint(),a+=t.readSVarint(),1===i&&(r&&l.push(r),r=[]),r.push(new e.Point$1(s,a));else {if(7!==i)throw new Error("unknown command "+i);r&&r.push(r[0].clone());}}return r&&l.push(r),l},w.prototype.bbox=function(){var e=this._pbf;e.pos=this._geometry;for(var t=e.readVarint()+e.pos,r=1,o=0,i=0,n=0,s=1/0,a=-1/0,l=1/0,u=-1/0;e.pos<t;){if(o<=0){var h=e.readVarint();r=7&h,o=h>>3;}if(o--,1===r||2===r)(i+=e.readSVarint())<s&&(s=i),i>a&&(a=i),(n+=e.readSVarint())<l&&(l=n),n>u&&(u=n);else if(7!==r)throw new Error("unknown command "+r)}return [s,l,a,u]},w.prototype.toGeoJSON=function(e,t,r){var o,i,n=this.extent*Math.pow(2,r),s=this.extent*e,a=this.extent*t,l=this.loadGeometry(),u=w.types[this.type];function h(e){for(var t=0;t<e.length;t++){var r=e[t],o=180-360*(r.y+a)/n,i=yLat&&yLat(r.y+a,n);e[t]=[360*(r.x+s)/n-180,i||360/Math.PI*Math.atan(Math.exp(o*Math.PI/180))-90];}}switch(this.type){case 1:var p=[];for(o=0;o<l.length;o++)p[o]=l[o][0];h(l=p);break;case 2:for(o=0;o<l.length;o++)h(l[o]);break;case 3:for(l=function(e){var t=e.length;if(t<=1)return [e];for(var r,o,i=[],n=0;n<t;n++){var s=b(e[n]);0!==s&&(void 0===o&&(o=s<0),o===s<0?(r&&i.push(r),r=[e[n]]):r.push(e[n]));}return r&&i.push(r),i}(l),o=0;o<l.length;o++)for(i=0;i<l[o].length;i++)h(l[o][i]);}1===l.length?l=l[0]:u="Multi"+u;var c={type:"Feature",geometry:{type:u,coordinates:l},properties:this.properties};return "id"in this&&(c.id=this.id),c};var _=I;function I(e,t){this.version=1,this.name=null,this.extent=4096,this.length=0,this._pbf=e,this._keys=[],this._values=[],this._features=[],e.readFields(M,this,t),this.length=this._features.length;}function M(e,t,r){15===e?t.version=r.readVarint():1===e?t.name=r.readString():5===e?t.extent=r.readVarint():2===e?t._features.push(r.pos):3===e?t._keys.push(r.readString()):4===e&&t._values.push(function(e){for(var t=null,r=e.readVarint()+e.pos;e.pos<r;){var o=e.readVarint()>>3;t=1===o?e.readString():2===o?e.readFloat():3===o?e.readDouble():4===o?e.readVarint64():5===o?e.readVarint():6===o?e.readSVarint():7===o?e.readBoolean():null;}return t}(r));}function P(e,t,r){if(3===e){var o=new _(r,r.readVarint()+r.pos);o.length&&(t[o.name]=o);}}I.prototype.feature=function(e){if(e<0||e>=this._features.length)throw new Error("feature index out of bounds");this._pbf.pos=this._features[e];var t=this._pbf.readVarint()+this._pbf.pos;return new m(this._pbf,t,this.extent,this._keys,this._values)};var k={VectorTile:function(e,t){this.layers=e.readFields(P,{},t);},VectorTileFeature:m,VectorTileLayer:_}.VectorTileFeature,C=T;function T(e,t){this.options=t||{},this.features=e,this.length=e.length;}function L(e,t){this.id="number"==typeof e.id?e.id:void 0,this.type=e.type,this.rawGeometry=1===e.type?[e.geometry]:e.geometry,this.properties=e.tags,this.extent=t||4096;}T.prototype.feature=function(e){return new L(this.features[e],this.options.extent)},L.prototype.loadGeometry=function(){var t=this.rawGeometry;this.geometry=[];for(var r=0;r<t.length;r++){for(var o=t[r],i=[],n=0;n<o.length;n++)i.push(new e.Point$1(o[n][0],o[n][1]));this.geometry.push(i);}return this.geometry},L.prototype.bbox=function(){this.geometry||this.loadGeometry();for(var e=this.geometry,t=1/0,r=-1/0,o=1/0,i=-1/0,n=0;n<e.length;n++)for(var s=e[n],a=0;a<s.length;a++){var l=s[a];t=Math.min(t,l.x),r=Math.max(r,l.x),o=Math.min(o,l.y),i=Math.max(i,l.y);}return [t,o,r,i]},L.prototype.toGeoJSON=k.prototype.toGeoJSON;var j=O,D=C;function O(t){var r=new e.pbf;return function(e,t){for(var r in e.layers)t.writeMessage(3,z,e.layers[r]);}(t,r),r.finish()}function z(e,t){var r;t.writeVarintField(15,e.version||1),t.writeStringField(1,e.name||""),t.writeVarintField(5,e.extent||4096);var o={keys:[],values:[],keycache:{},valuecache:{}};for(r=0;r<e.length;r++)o.feature=e.feature(r),t.writeMessage(2,V,o);var i=o.keys;for(r=0;r<i.length;r++)t.writeStringField(3,i[r]);var n=o.values;for(r=0;r<n.length;r++)t.writeMessage(4,J,n[r]);}function V(e,t){var r=e.feature;void 0!==r.id&&t.writeVarintField(1,r.id),t.writeMessage(2,E,e),t.writeVarintField(3,r.type),t.writeMessage(4,B,r);}function E(e,t){var r=e.feature,o=e.keys,i=e.values,n=e.keycache,s=e.valuecache;for(var a in r.properties){var l=n[a];void 0===l&&(o.push(a),n[a]=l=o.length-1),t.writeVarint(l);var u=r.properties[a],h=typeof u;"string"!==h&&"boolean"!==h&&"number"!==h&&(u=JSON.stringify(u));var p=h+":"+u,c=s[p];void 0===c&&(i.push(u),s[p]=c=i.length-1),t.writeVarint(c);}}function F(e,t){return (t<<3)+(7&e)}function N(e){return e<<1^e>>31}function B(e,t){for(var r=e.loadGeometry(),o=e.type,i=0,n=0,s=r.length,a=0;a<s;a++){var l=r[a],u=1;1===o&&(u=l.length),t.writeVarint(F(1,u));for(var h=3===o?l.length-1:l.length,p=0;p<h;p++){1===p&&1!==o&&t.writeVarint(F(2,h-1));var c=l[p].x-i,f=l[p].y-n;t.writeVarint(N(c)),t.writeVarint(N(f)),i+=c,n+=f;}3===o&&t.writeVarint(F(7,1));}}function J(e,t){var r=typeof e;"string"===r?t.writeStringField(1,e):"boolean"===r?t.writeBooleanField(7,e):"number"===r&&(e%1!=0?t.writeDoubleField(3,e):e<0?t.writeSVarintField(6,e):t.writeVarintField(5,e));}function G(e,t,r,o){Z(e,r,o),Z(t,2*r,2*o),Z(t,2*r+1,2*o+1);}function Z(e,t,r){var o=e[t];e[t]=e[r],e[r]=o;}function A(e,t,r,o){var i=e-r,n=t-o;return i*i+n*n}j.fromVectorTileJs=O,j.fromGeojsonVt=function(e,t){t=t||{};var r={};for(var o in e)r[o]=new C(e[o].features,t),r[o].name=o,r[o].version=t.version,r[o].extent=t.extent;return O({layers:r})},j.GeoJSONWrapper=D;var Y=function(e){return e[0]},X=function(e){return e[1]},W=function(e,t,r,o,i){void 0===t&&(t=Y),void 0===r&&(r=X),void 0===o&&(o=64),void 0===i&&(i=Float64Array),this.nodeSize=o,this.points=e;for(var n=e.length<65536?Uint16Array:Uint32Array,s=this.ids=new n(e.length),a=this.coords=new i(2*e.length),l=0;l<e.length;l++)s[l]=l,a[2*l]=t(e[l]),a[2*l+1]=r(e[l]);!function e(t,r,o,i,n,s){if(!(n-i<=o)){var a=i+n>>1;!function e(t,r,o,i,n,s){for(;n>i;){if(n-i>600){var a=n-i+1,l=o-i+1,u=Math.log(a),h=.5*Math.exp(2*u/3),p=.5*Math.sqrt(u*h*(a-h)/a)*(l-a/2<0?-1:1);e(t,r,o,Math.max(i,Math.floor(o-l*h/a+p)),Math.min(n,Math.floor(o+(a-l)*h/a+p)),s);}var c=r[2*o+s],f=i,d=n;for(G(t,r,i,o),r[2*n+s]>c&&G(t,r,i,n);f<d;){for(G(t,r,f,d),f++,d--;r[2*f+s]<c;)f++;for(;r[2*d+s]>c;)d--;}r[2*i+s]===c?G(t,r,i,d):G(t,r,++d,n),d<=o&&(i=d+1),o<=d&&(n=d-1);}}(t,r,a,i,n,s%2),e(t,r,o,i,a-1,s+1),e(t,r,o,a+1,n,s+1);}}(s,a,o,0,s.length-1,0);};W.prototype.range=function(e,t,r,o){return function(e,t,r,o,i,n,s){for(var a,l,u=[0,e.length-1,0],h=[];u.length;){var p=u.pop(),c=u.pop(),f=u.pop();if(c-f<=s)for(var d=f;d<=c;d++)l=t[2*d+1],(a=t[2*d])>=r&&a<=i&&l>=o&&l<=n&&h.push(e[d]);else {var g=Math.floor((f+c)/2);l=t[2*g+1],(a=t[2*g])>=r&&a<=i&&l>=o&&l<=n&&h.push(e[g]);var v=(p+1)%2;(0===p?r<=a:o<=l)&&(u.push(f),u.push(g-1),u.push(v)),(0===p?i>=a:n>=l)&&(u.push(g+1),u.push(c),u.push(v));}}return h}(this.ids,this.coords,e,t,r,o,this.nodeSize)},W.prototype.within=function(e,t,r){return function(e,t,r,o,i,n){for(var s=[0,e.length-1,0],a=[],l=i*i;s.length;){var u=s.pop(),h=s.pop(),p=s.pop();if(h-p<=n)for(var c=p;c<=h;c++)A(t[2*c],t[2*c+1],r,o)<=l&&a.push(e[c]);else {var f=Math.floor((p+h)/2),d=t[2*f],g=t[2*f+1];A(d,g,r,o)<=l&&a.push(e[f]);var v=(u+1)%2;(0===u?r-i<=d:o-i<=g)&&(s.push(p),s.push(f-1),s.push(v)),(0===u?r+i>=d:o+i>=g)&&(s.push(f+1),s.push(h),s.push(v));}}return a}(this.ids,this.coords,e,t,r,this.nodeSize)};var R={minZoom:0,maxZoom:16,minPoints:2,radius:40,extent:512,nodeSize:64,log:!1,generateId:!1,reduce:null,map:function(e){return e}},q=function(e){this.options=re(Object.create(R),e),this.trees=new Array(this.options.maxZoom+1);};function U(e,t,r,o,i){return {x:e,y:t,zoom:1/0,id:r,parentId:-1,numPoints:o,properties:i}}function $(e,t,r){var o,i,n=e.geometry.coordinates,s=n[0],a=n[1];return {x:(i="object"==typeof customConvertPoint?customConvertPoint.projectXY(s,a,r):[(o=s,o/360+.5),Q(a)])[0],y:i[1],zoom:1/0,index:t,parentId:-1}}function K(e,t){var r;return r="object"==typeof customConvertPoint?customConvertPoint.toLngLat(e.x,e.y,t):[ee(x),te(y)],{type:"Feature",id:e.id,properties:H(e),geometry:{type:"Point",coordinates:r}}}function H(e){var t=e.numPoints,r=t>=1e4?Math.round(t/1e3)+"k":t>=1e3?Math.round(t/100)/10+"k":t;return re(re({},e.properties),{cluster:!0,cluster_id:e.id,point_count:t,point_count_abbreviated:r})}function Q(e){var t=Math.sin(e*Math.PI/180),r=.5-.25*Math.log((1+t)/(1-t))/Math.PI;return r<0?0:r>1?1:r}function ee(e){return 360*(e-.5)}function te(e){var t=(180-360*e)*Math.PI/180;return 360*Math.atan(Math.exp(t))/Math.PI-90}function re(e,t){for(var r in t)e[r]=t[r];return e}function oe(e){return e.x}function ie(e){return e.y}function ne(e,t,r,o,i,n){var s=i-r,a=n-o;if(0!==s||0!==a){var l=((e-r)*s+(t-o)*a)/(s*s+a*a);l>1?(r=i,o=n):l>0&&(r+=s*l,o+=a*l);}return (s=e-r)*s+(a=t-o)*a}function se(e,t,r,o){var i={id:void 0===e?null:e,type:t,geometry:r,tags:o,minX:1/0,minY:1/0,maxX:-1/0,maxY:-1/0};return function(e){var t=e.geometry,r=e.type;if("Point"===r||"MultiPoint"===r||"LineString"===r)ae(e,t);else if("Polygon"===r||"MultiLineString"===r)for(var o=0;o<t.length;o++)ae(e,t[o]);else if("MultiPolygon"===r)for(o=0;o<t.length;o++)for(var i=0;i<t[o].length;i++)ae(e,t[o][i]);}(i),i}function ae(e,t){for(var r=0;r<t.length;r+=3)e.minX=Math.min(e.minX,t[r]),e.minY=Math.min(e.minY,t[r+1]),e.maxX=Math.max(e.maxX,t[r]),e.maxY=Math.max(e.maxY,t[r+1]);}function le(e,t,r,o){if(t.geometry){var i=t.geometry.coordinates,n=t.geometry.type,s=Math.pow(r.tolerance/((1<<r.maxZoom)*r.extent),2),a=[],l=t.id;if(r.promoteId?l=t.properties[r.promoteId]:r.generateId&&(l=o||0),"Point"===n)ue(i,a,r.proj4Projection);else if("MultiPoint"===n)for(var u=0;u<i.length;u++)ue(i[u],a,r.proj4Projection);else if("LineString"===n)he(i,a,s,!1,r.proj4Projection);else if("MultiLineString"===n){if(r.lineMetrics){for(u=0;u<i.length;u++)he(i[u],a=[],s,!1,r.proj4Projection),e.push(se(l,"LineString",a,t.properties));return}pe(i,a,s,!1,r.proj4Projection);}else if("Polygon"===n)pe(i,a,s,!0,r.proj4Projection);else {if("MultiPolygon"!==n){if("GeometryCollection"===n){for(u=0;u<t.geometry.geometries.length;u++)le(e,{id:l,geometry:t.geometry.geometries[u],properties:t.properties},r,o);return}throw new Error("Input data is not a valid GeoJSON object.")}for(u=0;u<i.length;u++){var h=[];pe(i[u],h,s,!0,r.proj4Projection),a.push(h);}}e.push(se(l,n,a,t.properties));}}function ue(e,t,r){var o=Math.min(85.051129,Math.max(-85.051129,e[1])),i="object"==typeof customConvertPoint?customConvertPoint.projectXY(e[0],o,r):e,n=i[0];e[0]>180&&n<1?n+=1:e[0]<-180&&n>-1&&(n-=1),t.push(n),t.push(i[1]),t.push(0);}function he(e,t,r,o,i){for(var n,s,a=0,l=0;l<e.length;l++){var u=[];ue(e[l],u,i);var h=u[0],p=u[1];t.push(h),t.push(p),t.push(0),l>0&&(a+=o?(n*p-h*s)/2:Math.sqrt(Math.pow(h-n,2)+Math.pow(p-s,2))),n=h,s=p;}var c=t.length-3;t[2]=1,function e(t,r,o,i){for(var n,s=i,a=o-r>>1,l=o-r,u=t[r],h=t[r+1],p=t[o],c=t[o+1],f=r+3;f<o;f+=3){var d=ne(t[f],t[f+1],u,h,p,c);if(d>s)n=f,s=d;else if(d===s){var g=Math.abs(f-a);g<l&&(n=f,l=g);}}s>i&&(n-r>3&&e(t,r,n,i),t[n+2]=s,o-n>3&&e(t,n,o,i));}(t,0,c,r),t[c+2]=1,t.size=Math.abs(a),t.start=0,t.end=t.size;}function pe(e,t,r,o,i){for(var n=0;n<e.length;n++){var s=[];he(e[n],s,r,o,i),t.push(s);}}function ce(e,t,r,o,i,n,s,a){if(o/=t,n>=(r/=t)&&s<o)return e;if(s<r||n>=o)return null;for(var l=[],u=0;u<e.length;u++){var h=e[u],p=h.geometry,c=h.type,f=0===i?h.minX:h.minY,d=0===i?h.maxX:h.maxY;if(f>=r&&d<o)l.push(h);else if(!(d<r||f>=o)){var g=[];if("Point"===c||"MultiPoint"===c)fe(p,g,r,o,i);else if("LineString"===c)de(p,g,r,o,i,!1,a.lineMetrics);else if("MultiLineString"===c)ve(p,g,r,o,i,!1);else if("Polygon"===c)ve(p,g,r,o,i,!0);else if("MultiPolygon"===c)for(var v=0;v<p.length;v++){var m=[];ve(p[v],m,r,o,i,!0),m.length&&g.push(m);}if(g.length){if(a.lineMetrics&&"LineString"===c){for(v=0;v<g.length;v++)l.push(se(h.id,c,g[v],h.tags));continue}"LineString"!==c&&"MultiLineString"!==c||(1===g.length?(c="LineString",g=g[0]):c="MultiLineString"),"Point"!==c&&"MultiPoint"!==c||(c=3===g.length?"Point":"MultiPoint"),l.push(se(h.id,c,g,h.tags));}}}return l.length?l:null}function fe(e,t,r,o,i){for(var n=0;n<e.length;n+=3){var s=e[n+i];s>=r&&s<=o&&(t.push(e[n]),t.push(e[n+1]),t.push(e[n+2]));}}function de(e,t,r,o,i,n,s){for(var a,l,u=ge(e),h=0===i?ye:xe,p=e.start,c=0;c<e.length-3;c+=3){var f=e[c],d=e[c+1],g=e[c+2],v=e[c+3],m=e[c+4],y=0===i?f:d,x=0===i?v:m,w=!1;s&&(a=Math.sqrt(Math.pow(f-v,2)+Math.pow(d-m,2))),y<r?x>r&&(l=h(u,f,d,v,m,r),s&&(u.start=p+a*l)):y>o?x<o&&(l=h(u,f,d,v,m,o),s&&(u.start=p+a*l)):me(u,f,d,g),x<r&&y>=r&&(l=h(u,f,d,v,m,r),w=!0),x>o&&y<=o&&(l=h(u,f,d,v,m,o),w=!0),!n&&w&&(s&&(u.end=p+a*l),t.push(u),u=ge(e)),s&&(p+=a);}var S=e.length-3;f=e[S],d=e[S+1],g=e[S+2],(y=0===i?f:d)>=r&&y<=o&&me(u,f,d,g),S=u.length-3,n&&S>=3&&(u[S]!==u[0]||u[S+1]!==u[1])&&me(u,u[0],u[1],u[2]),u.length&&t.push(u);}function ge(e){var t=[];return t.size=e.size,t.start=e.start,t.end=e.end,t}function ve(e,t,r,o,i,n){for(var s=0;s<e.length;s++)de(e[s],t,r,o,i,n,!1);}function me(e,t,r,o){e.push(t),e.push(r),e.push(o);}function ye(e,t,r,o,i,n){var s=(n-t)/(o-t);return e.push(n),e.push(r+(i-r)*s),e.push(1),s}function xe(e,t,r,o,i,n){var s=(n-r)/(i-r);return e.push(t+(o-t)*s),e.push(n),e.push(1),s}function we(e,t){for(var r=[],o=0;o<e.length;o++){var i,n=e[o],s=n.type;if("Point"===s||"MultiPoint"===s||"LineString"===s)i=Se(n.geometry,t);else if("MultiLineString"===s||"Polygon"===s){i=[];for(var a=0;a<n.geometry.length;a++)i.push(Se(n.geometry[a],t));}else if("MultiPolygon"===s)for(i=[],a=0;a<n.geometry.length;a++){for(var l=[],u=0;u<n.geometry[a].length;u++)l.push(Se(n.geometry[a][u],t));i.push(l);}r.push(se(n.id,s,i,n.tags));}return r}function Se(e,t){var r=[];r.size=e.size,void 0!==e.start&&(r.start=e.start,r.end=e.end);for(var o=0;o<e.length;o+=3)r.push(e[o]+t,e[o+1],e[o+2]);return r}function be(e,t){if(e.transformed)return e;var r,o,i,n=1<<e.z,s=e.x,a=e.y;for(r=0;r<e.features.length;r++){var l=e.features[r],u=l.geometry,h=l.type;if(l.geometry=[],1===h)for(o=0;o<u.length;o+=2)l.geometry.push(_e(u[o],u[o+1],t,n,s,a));else for(o=0;o<u.length;o++){var p=[];for(i=0;i<u[o].length;i+=2)p.push(_e(u[o][i],u[o][i+1],t,n,s,a));l.geometry.push(p);}}return e.transformed=!0,e}function _e(e,t,r,o,i,n){return [Math.round(r*(e*o-i)),Math.round(r*(t*o-n))]}function Ie(e,t,r,o,i){for(var n=t===i.maxZoom?0:i.tolerance/((1<<t)*i.extent),s={features:[],numPoints:0,numSimplified:0,numFeatures:0,source:null,x:r,y:o,z:t,transformed:!1,minX:2,minY:1,maxX:-1,maxY:0},a=0;a<e.length;a++){s.numFeatures++,Me(s,e[a],n,i);var l=e[a].minX,u=e[a].minY,h=e[a].maxX,p=e[a].maxY;l<s.minX&&(s.minX=l),u<s.minY&&(s.minY=u),h>s.maxX&&(s.maxX=h),p>s.maxY&&(s.maxY=p);}return s}function Me(e,t,r,o){var i=t.geometry,n=t.type,s=[];if("Point"===n||"MultiPoint"===n)for(var a=0;a<i.length;a+=3)s.push(i[a]),s.push(i[a+1]),e.numPoints++,e.numSimplified++;else if("LineString"===n)Pe(s,i,e,r,!1,!1);else if("MultiLineString"===n||"Polygon"===n)for(a=0;a<i.length;a++)Pe(s,i[a],e,r,"Polygon"===n,0===a);else if("MultiPolygon"===n)for(var l=0;l<i.length;l++){var u=i[l];for(a=0;a<u.length;a++)Pe(s,u[a],e,r,!0,0===a);}if(s.length){var h=t.tags||null;if("LineString"===n&&o.lineMetrics){for(var p in h={},t.tags)h[p]=t.tags[p];h.mapbox_clip_start=i.start/i.size,h.mapbox_clip_end=i.end/i.size;}var c={geometry:s,type:"Polygon"===n||"MultiPolygon"===n?3:"LineString"===n||"MultiLineString"===n?2:1,tags:h};null!==t.id&&(c.id=t.id),e.features.push(c);}}function Pe(e,t,r,o,i,n){var s=o*o;if(o>0&&t.size<(i?s:o))r.numPoints+=t.length/3;else {for(var a=[],l=0;l<t.length;l+=3)(0===o||t[l+2]>s)&&(r.numSimplified++,a.push(t[l]),a.push(t[l+1])),r.numPoints++;i&&function(e,t){for(var r=0,o=0,i=e.length,n=i-2;o<i;n=o,o+=2)r+=(e[o]-e[n])*(e[o+1]+e[n+1]);if(r>0===t)for(o=0,i=e.length;o<i/2;o+=2){var s=e[o],a=e[o+1];e[o]=e[i-2-o],e[o+1]=e[i-1-o],e[i-2-o]=s,e[i-1-o]=a;}}(a,n),e.push(a);}}function ke(e,t){var r=(t=this.options=function(e,t){for(var r in t)e[r]=t[r];return e}(Object.create(this.options),t)).debug;if(r&&console.time("preprocess data"),t.maxZoom<0||t.maxZoom>24)throw new Error("maxZoom should be in the 0-24 range");if(t.promoteId&&t.generateId)throw new Error("promoteId and generateId cannot be used together.");var o=function(e,t){if(t.customprj&&"undefined"==typeof customConvertPoint)try{importScripts(t.customprj);}catch(e){console.log(e);}if(!t.customprj&&"undefined"!=typeof customConvertPoint)try{customConvertPoint=void 0;}catch(e){console.log(e);}var r=[];if("FeatureCollection"===e.type)for(var o=0;o<e.features.length;o++)le(r,e.features[o],t,o);else le(r,"Feature"===e.type?e:{geometry:e},t);return r}(e,t);this.tiles={},this.tileCoords=[],r&&(console.timeEnd("preprocess data"),console.log("index: maxZoom: %d, maxPoints: %d",t.indexMaxZoom,t.indexMaxPoints),console.time("generate tiles"),this.stats={},this.total=0),(o=function(e,t){var r=t.buffer/t.extent,o=e,i=ce(e,1,-1-r,r,0,-1,2,t),n=ce(e,1,1-r,2+r,0,-1,2,t);return (i||n)&&(o=ce(e,1,-r,1+r,0,-1,2,t)||[],i&&(o=we(i,1).concat(o)),n&&(o=o.concat(we(n,-1)))),o}(o,t)).length&&this.splitTile(o,0,0,0),r&&(o.length&&console.log("features: %d, points: %d",this.tiles[0].numFeatures,this.tiles[0].numPoints),console.timeEnd("generate tiles"),console.log("tiles generated:",this.total,JSON.stringify(this.stats)));}function Ce(e,t,r){return 32*((1<<e)*r+t)+e}function Te(e,t){var r=e.tileID.canonical;if(!this._geoJSONIndex)return t(null,null);var o=this._geoJSONIndex.getTile(r.z,r.x,r.y);if(!o)return t(null,null);var i=new v(o.features),n=j(i);0===n.byteOffset&&n.byteLength===n.buffer.byteLength||(n=new Uint8Array(n)),t(null,{vectorTile:i,rawData:n.buffer});}q.prototype.load=function(e){var t=this.options,r=t.log,o=t.minZoom,i=t.maxZoom,n=t.nodeSize;r&&console.time("total time");var s="prepare "+e.length+" points";r&&console.time(s),this.points=e;for(var a=[],l=0;l<e.length;l++)e[l].geometry&&a.push($(e[l],l,this.options.proj4Projection));console.log(a),this.trees[i+1]=new W(a,oe,ie,n,Float32Array),r&&console.timeEnd(s);for(var u=i;u>=o;u--){var h=+Date.now();a=this._cluster(a,u),this.trees[u]=new W(a,oe,ie,n,Float32Array),r&&console.log("z%d: %d clusters in %dms",u,a.length,+Date.now()-h);}return r&&console.timeEnd("total time"),this},q.prototype.getClusters=function(e,t){var r=((e[0]+180)%360+360)%360-180,o=Math.max(-90,Math.min(90,e[1])),i=180===e[2]?180:((e[2]+180)%360+360)%360-180,n=Math.max(-90,Math.min(90,e[3]));if(e[2]-e[0]>=360)r=-180,i=180;else if(r>i){var s=this.getClusters([r,o,180,n],t),a=this.getClusters([-180,o,i,n],t);return s.concat(a)}for(var l=this.trees[this._limitZoom(t)],u=lngLatXY(r,o),h=lngLatXY(r,i),p=[],c=0,f=l.range(u[0],h[1],h[0],u[1]);c<f.length;c+=1){var d=l.points[f[c]];p.push(d.numPoints?K(d,this.options.proj4Projection):this.points[d.index]);}return p},q.prototype.getChildren=function(e){var t=this._getOriginId(e),r=this._getOriginZoom(e),o="No cluster with the specified id.",i=this.trees[r];if(!i)throw new Error(o);var n=i.points[t];if(!n)throw new Error(o);for(var s=this.options.radius/(this.options.extent*Math.pow(2,r-1)),a=[],l=0,u=i.within(n.x,n.y,s);l<u.length;l+=1){var h=i.points[u[l]];h.parentId===e&&a.push(h.numPoints?K(h,this.options.proj4Projection):this.points[h.index]);}if(0===a.length)throw new Error(o);return a},q.prototype.getLeaves=function(e,t,r){var o=[];return this._appendLeaves(o,e,t=t||10,r=r||0,0),o},q.prototype.getTile=function(e,t,r){var o=this.trees[this._limitZoom(e)],i=Math.pow(2,e),n=this.options,s=n.radius/n.extent,a=(r-s)/i,l=(r+1+s)/i,u={features:[]};return this._addTileFeatures(o.range((t-s)/i,a,(t+1+s)/i,l),o.points,t,r,i,u),0===t&&this._addTileFeatures(o.range(1-s/i,a,1,l),o.points,i,r,i,u),t===i-1&&this._addTileFeatures(o.range(0,a,s/i,l),o.points,-1,r,i,u),u.features.length?u:null},q.prototype.getClusterExpansionZoom=function(e){for(var t=this._getOriginZoom(e)-1;t<=this.options.maxZoom;){var r=this.getChildren(e);if(t++,1!==r.length)break;e=r[0].properties.cluster_id;}return t},q.prototype._appendLeaves=function(e,t,r,o,i){for(var n=0,s=this.getChildren(t);n<s.length;n+=1){var a=s[n],l=a.properties;if(l&&l.cluster?i+l.point_count<=o?i+=l.point_count:i=this._appendLeaves(e,l.cluster_id,r,o,i):i<o?i++:e.push(a),e.length===r)break}return i},q.prototype._addTileFeatures=function(e,t,r,o,i,n){for(var s=0,a=e;s<a.length;s+=1){var l=t[a[s]],u=l.numPoints,h={type:1,geometry:[[Math.round(this.options.extent*(l.x*i-r)),Math.round(this.options.extent*(l.y*i-o))]],tags:u?H(l):this.points[l.index].properties},p=void 0;u?p=l.id:this.options.generateId?p=l.index:this.points[l.index].id&&(p=this.points[l.index].id),void 0!==p&&(h.id=p),n.features.push(h);}},q.prototype._limitZoom=function(e){return Math.max(this.options.minZoom,Math.min(+e,this.options.maxZoom+1))},q.prototype._cluster=function(e,t){for(var r=[],o=this.options,i=o.reduce,n=o.minPoints,s=o.radius/(o.extent*Math.pow(2,t)),a=0;a<e.length;a++){var l=e[a];if(!(l.zoom<=t)){l.zoom=t;for(var u=this.trees[t+1],h=u.within(l.x,l.y,s),p=l.numPoints||1,c=p,f=0,d=h;f<d.length;f+=1){var g=u.points[d[f]];g.zoom>t&&(c+=g.numPoints||1);}if(c>=n){for(var v=l.x*p,m=l.y*p,y=i&&p>1?this._map(l,!0):null,x=(a<<5)+(t+1)+this.points.length,w=0,S=h;w<S.length;w+=1){var b=u.points[S[w]];if(!(b.zoom<=t)){b.zoom=t;var _=b.numPoints||1;v+=b.x*_,m+=b.y*_,b.parentId=x,i&&(y||(y=this._map(l,!0)),i(y,this._map(b)));}}l.parentId=x,r.push(U(v/c,m/c,x,c,y));}else if(r.push(l),c>1)for(var I=0,M=h;I<M.length;I+=1){var P=u.points[M[I]];P.zoom<=t||(P.zoom=t,r.push(P));}}}return r},q.prototype._getOriginId=function(e){return e-this.points.length>>5},q.prototype._getOriginZoom=function(e){return (e-this.points.length)%32},q.prototype._map=function(e,t){if(e.numPoints)return t?re({},e.properties):e.properties;var r=this.points[e.index].properties,o=this.options.map(r);return t&&o===r?re({},o):o},ke.prototype.options={maxZoom:14,indexMaxZoom:5,indexMaxPoints:1e5,tolerance:3,extent:4096,buffer:64,lineMetrics:!1,promoteId:null,generateId:!1,debug:0},ke.prototype.splitTile=function(e,t,r,o,i,n,s){for(var a=[e,t,r,o],l=this.options,u=l.debug;a.length;){o=a.pop(),r=a.pop(),t=a.pop(),e=a.pop();var h=1<<t,p=Ce(t,r,o),c=this.tiles[p];if(!c&&(u>1&&console.time("creation"),c=this.tiles[p]=Ie(e,t,r,o,l),this.tileCoords.push({z:t,x:r,y:o}),u)){u>1&&(console.log("tile z%d-%d-%d (features: %d, points: %d, simplified: %d)",t,r,o,c.numFeatures,c.numPoints,c.numSimplified),console.timeEnd("creation"));var f="z"+t;this.stats[f]=(this.stats[f]||0)+1,this.total++;}if(c.source=e,i){if(t===l.maxZoom||t===i)continue;var d=1<<i-t;if(r!==Math.floor(n/d)||o!==Math.floor(s/d))continue}else if(t===l.indexMaxZoom||c.numPoints<=l.indexMaxPoints)continue;if(c.source=null,0!==e.length){u>1&&console.time("clipping");var g,v,m,y,x,w,S=.5*l.buffer/l.extent,b=.5-S,_=.5+S,I=1+S;g=v=m=y=null,x=ce(e,h,r-S,r+_,0,c.minX,c.maxX,l),w=ce(e,h,r+b,r+I,0,c.minX,c.maxX,l),e=null,x&&(g=ce(x,h,o-S,o+_,1,c.minY,c.maxY,l),v=ce(x,h,o+b,o+I,1,c.minY,c.maxY,l),x=null),w&&(m=ce(w,h,o-S,o+_,1,c.minY,c.maxY,l),y=ce(w,h,o+b,o+I,1,c.minY,c.maxY,l),w=null),u>1&&console.timeEnd("clipping"),a.push(g||[],t+1,2*r,2*o),a.push(v||[],t+1,2*r,2*o+1),a.push(m||[],t+1,2*r+1,2*o),a.push(y||[],t+1,2*r+1,2*o+1);}}},ke.prototype.getTile=function(e,t,r){var o=this.options,i=o.extent,n=o.debug;if(e<0||e>24)return null;var s=1<<e,a=Ce(e,t=(t%s+s)%s,r);if(this.tiles[a])return be(this.tiles[a],i);n>1&&console.log("drilling down to z%d-%d-%d",e,t,r);for(var l,u=e,h=t,p=r;!l&&u>0;)u--,h=Math.floor(h/2),p=Math.floor(p/2),l=this.tiles[Ce(u,h,p)];return l&&l.source?(n>1&&console.log("found parent tile z%d-%d-%d",u,h,p),n>1&&console.time("drilling down"),this.splitTile(l.source,u,h,p,e,t,r),n>1&&console.timeEnd("drilling down"),this.tiles[a]?be(this.tiles[a],i):null):null};var Le=function(t){function r(e,r,o,i,n){t.call(this,e,r,o,Te),i&&(this.loadGeoJSON=i),this.projction=n;}return t&&(r.__proto__=t),(r.prototype=Object.create(t&&t.prototype)).constructor=r,r.prototype.loadData=function(e,t){this._pendingCallback&&this._pendingCallback(null,{abandoned:!0}),this._pendingCallback=t,this._pendingLoadDataParams=e,this._state&&"Idle"!==this._state?this._state="NeedsLoadData":(this._state="Coalescing",this._loadData());},r.prototype._loadData=function(){var t=this;if(this._pendingCallback&&this._pendingLoadDataParams){var r=this._pendingCallback,o=this._pendingLoadDataParams;delete this._pendingCallback,delete this._pendingLoadDataParams;var i=!!(o&&o.request&&o.request.collectResourceTiming)&&new e.RequestPerformance(o.request);this.loadGeoJSON(o,(function(n,s){if(n||!s)return r(n);if("object"!=typeof s)return r(new Error("Input data given to '"+o.source+"' is not a valid GeoJSON object."));!function e(t,r){var o,i=t&&t.type;if("FeatureCollection"===i)for(o=0;o<t.features.length;o++)e(t.features[o],r);else if("GeometryCollection"===i)for(o=0;o<t.geometries.length;o++)e(t.geometries[o],r);else if("Feature"===i)e(t.geometry,r);else if("Polygon"===i)c(t.coordinates,r);else if("MultiPolygon"===i)for(o=0;o<t.coordinates.length;o++)c(t.coordinates[o],r);return t}(s,!0);try{if(o.superclusterOptions.customprj)try{importScripts(o.superclusterOptions.customprj);}catch(e){console.log(o);}if(o.filter){var a=e.createExpression(o.filter,{type:"boolean","property-type":"data-driven",overridable:!1,transition:!1});if("error"===a.result)throw new Error(a.value.map((function(e){return e.key+": "+e.message})).join(", "));var l=s.features.filter((function(e){return a.value.evaluate({zoom:0},e)}));s={type:"FeatureCollection",features:l};}var u=o.geojsonVtOptions;u.proj4Projection=t.projction,o.superclusterOptions.proj4Projection=t.projction,t._geoJSONIndex=o.cluster?new q(function(t){var r=t.superclusterOptions,o=t.clusterProperties;if(!o||!r)return r;for(var i={},n={},s={accumulated:null,zoom:0},a={properties:null},l=Object.keys(o),u=0,h=l;u<h.length;u+=1){var p=h[u],c=o[p],f=c[0],d=e.createExpression(c[1]),g=e.createExpression("string"==typeof f?[f,["accumulated"],["get",p]]:f);i[p]=d.value,n[p]=g.value;}return r.map=function(e){a.properties=e;for(var t={},r=0,o=l;r<o.length;r+=1){var n=o[r];t[n]=i[n].evaluate(s,a);}return t},r.reduce=function(e,t){a.properties=t;for(var r=0,o=l;r<o.length;r+=1){var i=o[r];s.accumulated=e[i],e[i]=n[i].evaluate(s,a);}},r}(o)).load(s.features):function(e,t){return new ke(e,t)}(s,u);}catch(n){return r(n)}t.loaded={};var h={};if(h.data=s,i){var p=i.finish();p&&(h.resourceTiming={},h.resourceTiming[o.source]=JSON.parse(JSON.stringify(p)));}r(null,h);}));}},r.prototype.coalesce=function(){"Coalescing"===this._state?this._state="Idle":"NeedsLoadData"===this._state&&(this._state="Coalescing",this._loadData());},r.prototype.reloadTile=function(e,r){var o=this.loaded;return o&&o[e.uid]?t.prototype.reloadTile.call(this,e,r):this.loadTile(e,r)},r.prototype.loadGeoJSON=function(t,r){if(t.request)e.getJSON(t.request,r);else {if("string"!=typeof t.data)return r(new Error("Input data given to '"+t.source+"' is not a valid GeoJSON object."));try{return r(null,JSON.parse(t.data))}catch(e){return r(new Error("Input data given to '"+t.source+"' is not a valid GeoJSON object."))}}},r.prototype.removeSource=function(e,t){this._pendingCallback&&this._pendingCallback(null,{abandoned:!0}),t();},r.prototype.getClusterExpansionZoom=function(e,t){try{t(null,this._geoJSONIndex.getClusterExpansionZoom(e.clusterId));}catch(e){t(e);}},r.prototype.getClusterChildren=function(e,t){try{t(null,this._geoJSONIndex.getChildren(e.clusterId));}catch(e){t(e);}},r.prototype.getClusterLeaves=function(e,t){try{t(null,this._geoJSONIndex.getLeaves(e.clusterId,e.limit,e.offset));}catch(e){t(e);}},r}(u),je=function(t){var r=this;this.self=t,this.actor=new e.Actor(t,this),this.layerIndexes={},this.availableImages={},this.workerSourceTypes={vector:u,geojson:Le},this.workerSources={},this.demWorkerSources={},this.self.registerWorkerSource=function(e,t){if(r.workerSourceTypes[e])throw new Error('Worker source with name "'+e+'" already registered.');r.workerSourceTypes[e]=t;},this.self.registerRTLTextPlugin=function(t){if(e.plugin.isParsed())throw new Error("RTL text plugin already registered.");e.plugin.applyArabicShaping=t.applyArabicShaping,e.plugin.processBidirectionalText=t.processBidirectionalText,e.plugin.processStyledBidirectionalText=t.processStyledBidirectionalText;};};return je.prototype.setReferrer=function(e,t){this.referrer=t;},je.prototype.setImages=function(e,t,r){for(var o in this.availableImages[e]=t,this.workerSources[e]){var i=this.workerSources[e][o];for(var n in i)i[n].availableImages=t;}r();},je.prototype.setLayers=function(e,t,r){this.getLayerIndex(e).replace(t),r();},je.prototype.updateLayers=function(e,t,r){this.getLayerIndex(e).update(t.layers,t.removedIds),r();},je.prototype.loadTile=function(e,t,r){this.getWorkerSource(e,t.type,t.source).loadTile(t,r);},je.prototype.loadDEMTile=function(e,t,r){this.getDEMWorkerSource(e,t.source).loadTile(t,r);},je.prototype.reloadTile=function(e,t,r){this.getWorkerSource(e,t.type,t.source).reloadTile(t,r);},je.prototype.abortTile=function(e,t,r){this.getWorkerSource(e,t.type,t.source).abortTile(t,r);},je.prototype.removeTile=function(e,t,r){this.getWorkerSource(e,t.type,t.source).removeTile(t,r);},je.prototype.removeDEMTile=function(e,t){this.getDEMWorkerSource(e,t.source).removeTile(t);},je.prototype.removeSource=function(e,t,r){if(this.workerSources[e]&&this.workerSources[e][t.type]&&this.workerSources[e][t.type][t.source]){var o=this.workerSources[e][t.type][t.source];delete this.workerSources[e][t.type][t.source],void 0!==o.removeSource?o.removeSource(t,r):r();}},je.prototype.loadWorkerSource=function(e,t,r){try{this.self.importScripts(t.url),r();}catch(e){r(e.toString());}},je.prototype.syncRTLPluginState=function(t,r,o){try{e.plugin.setState(r);var i=e.plugin.getPluginURL();if(e.plugin.isLoaded()&&!e.plugin.isParsed()&&null!=i){this.self.importScripts(i);var n=e.plugin.isParsed();o(n?void 0:new Error("RTL Text Plugin failed to import scripts from "+i),n);}}catch(e){o(e.toString());}},je.prototype.getAvailableImages=function(e){var t=this.availableImages[e];return t||(t=[]),t},je.prototype.getLayerIndex=function(e){var t=this.layerIndexes[e];return t||(t=this.layerIndexes[e]=new i),t},je.prototype.getWorkerSource=function(t,r,o,i){var n=this;this.workerSources[t]||(this.workerSources[t]={}),this.workerSources[t][r]||(this.workerSources[t][r]={});var s,a=!1;return i&&(a=i._id!==this._lastCRSId,this._lastCRSId=i._id,i.WKT?(e.proj4.defs(i.epsgCode,i.WKT),s=e.proj4(i.epsgCode)):s=e.proj4(i.epsgCode)),this.workerSources[t][r][o]?a&&(this.workerSources[t][r][o].projction=s):this.workerSources[t][r][o]=new this.workerSourceTypes[r]({send:function(e,r,o,i,s){n.actor.send(e,r,o,t,i,s);}},this.getLayerIndex(t),this.getAvailableImages(t),null,s),this.workerSources[t][r][o]},je.prototype.getDEMWorkerSource=function(e,t){return this.demWorkerSources[e]||(this.demWorkerSources[e]={}),this.demWorkerSources[e][t]||(this.demWorkerSources[e][t]=new p),this.demWorkerSources[e][t]},je.prototype.enforceCacheSizeLimit=function(t,r){e.enforceCacheSizeLimit(r);},"undefined"!=typeof WorkerGlobalScope&&"undefined"!=typeof self&&self instanceof WorkerGlobalScope&&(self.worker=new je(self)),je}));

define(["./shared"],(function(t){"use strict";var e=t.createCommonjsModule((function(t){function e(t){return !i(t)}function i(t){return "undefined"==typeof window||"undefined"==typeof document?"not a browser":Array.prototype&&Array.prototype.every&&Array.prototype.filter&&Array.prototype.forEach&&Array.prototype.indexOf&&Array.prototype.lastIndexOf&&Array.prototype.map&&Array.prototype.some&&Array.prototype.reduce&&Array.prototype.reduceRight&&Array.isArray?Function.prototype&&Function.prototype.bind?Object.keys&&Object.create&&Object.getPrototypeOf&&Object.getOwnPropertyNames&&Object.isSealed&&Object.isFrozen&&Object.isExtensible&&Object.getOwnPropertyDescriptor&&Object.defineProperty&&Object.defineProperties&&Object.seal&&Object.freeze&&Object.preventExtensions?"JSON"in window&&"parse"in JSON&&"stringify"in JSON?function(){if(!("Worker"in window&&"Blob"in window&&"URL"in window))return !1;var t,e,i=new Blob([""],{type:"text/javascript"}),o=URL.createObjectURL(i);try{e=new Worker(o),t=!0;}catch(e){t=!1;}return e&&e.terminate(),URL.revokeObjectURL(o),t}()?"Uint8ClampedArray"in window?ArrayBuffer.isView?function(){var t=document.createElement("canvas");t.width=t.height=1;var e=t.getContext("2d");if(!e)return !1;var i=e.getImageData(0,0,1,1);return i&&i.width===t.width}()?(void 0===o[i=t&&t.failIfMajorPerformanceCaveat]&&(o[i]=function(t){var i=function(t){var i=document.createElement("canvas"),o=Object.create(e.webGLContextAttributes);return o.failIfMajorPerformanceCaveat=t,i.probablySupportsContext?i.probablySupportsContext("webgl",o)||i.probablySupportsContext("experimental-webgl",o):i.supportsContext?i.supportsContext("webgl",o)||i.supportsContext("experimental-webgl",o):i.getContext("webgl",o)||i.getContext("experimental-webgl",o)}(t);if(!i)return !1;var o=i.createShader(i.VERTEX_SHADER);return !(!o||i.isContextLost())&&(i.shaderSource(o,"void main() {}"),i.compileShader(o),!0===i.getShaderParameter(o,i.COMPILE_STATUS))}(i)),o[i]?void 0:"insufficient WebGL support"):"insufficient Canvas/getImageData support":"insufficient ArrayBuffer support":"insufficient Uint8ClampedArray support":"insufficient worker support":"insufficient JSON support":"insufficient Object support":"insufficient Function support":"insufficent Array support";var i;}t.exports?t.exports=e:window&&(window.mapboxgl=window.mapboxgl||{},window.mapboxgl.supported=e,window.mapboxgl.notSupportedReason=i);var o={};e.webGLContextAttributes={antialias:!1,alpha:!0,stencil:!0,depth:!0};})),i={create:function(e,i,o){var r=t.window.document.createElement(e);return void 0!==i&&(r.className=i),o&&o.appendChild(r),r},createNS:function(e,i){return t.window.document.createElementNS(e,i)}},o=t.window.document&&t.window.document.documentElement.style;function r(t){if(!o)return t[0];for(var e=0;e<t.length;e++)if(t[e]in o)return t[e];return t[0]}var a,n=r(["userSelect","MozUserSelect","WebkitUserSelect","msUserSelect"]);i.disableDrag=function(){o&&n&&(a=o[n],o[n]="none");},i.enableDrag=function(){o&&n&&(o[n]=a);};var s=r(["transform","WebkitTransform"]);i.setTransform=function(t,e){t.style[s]=e;};var l=!1;try{var c=Object.defineProperty({},"passive",{get:function(){l=!0;}});t.window.addEventListener("test",c,c),t.window.removeEventListener("test",c,c);}catch(t){l=!1;}i.addEventListener=function(t,e,i,o){void 0===o&&(o={}),t.addEventListener(e,i,"passive"in o&&l?o:o.capture);},i.removeEventListener=function(t,e,i,o){void 0===o&&(o={}),t.removeEventListener(e,i,"passive"in o&&l?o:o.capture);};var h=function(e){e.preventDefault(),e.stopPropagation(),t.window.removeEventListener("click",h,!0);};function u(e,i,o){var r,a,n,s=t.browser.devicePixelRatio>1?"@2x":"",l=t.getJSON(i.transformRequest(i.normalizeSpriteURL(e,s,".json"),t.ResourceType.SpriteJSON),(function(t,e){l=null,n||(n=t,r=e,h());})),c=t.getImage(i.transformRequest(i.normalizeSpriteURL(e,s,".png"),t.ResourceType.SpriteImage),(function(t,e){c=null,n||(n=t,a=e,h());}));function h(){if(n)o(n);else if(r&&a){var e=t.browser.getImageData(a),i={};for(var s in r){var l=r[s],c=l.width,h=l.height,u=l.x,p=l.y,d=l.sdf,_=l.pixelRatio,f=l.stretchX,m=l.stretchY,g=l.content,v=new t.RGBAImage({width:c,height:h});t.RGBAImage.copy(e,v,{x:u,y:p},{x:0,y:0},{width:c,height:h}),i[s]={data:v,pixelRatio:_,sdf:d,stretchX:f,stretchY:m,content:g};}o(null,i);}}return {cancel:function(){l&&(l.cancel(),l=null),c&&(c.cancel(),c=null);}}}function p(t){var e=t.userImage;return !!(e&&e.render&&e.render())&&(t.data.replace(new Uint8Array(e.data.buffer)),!0)}i.suppressClick=function(){t.window.addEventListener("click",h,!0),t.window.setTimeout((function(){t.window.removeEventListener("click",h,!0);}),0);},i.mousePos=function(e,i){var o=e.getBoundingClientRect();return new t.Point(i.clientX-o.left-e.clientLeft,i.clientY-o.top-e.clientTop)},i.touchPos=function(e,i){for(var o=e.getBoundingClientRect(),r=[],a=0;a<i.length;a++)r.push(new t.Point(i[a].clientX-o.left-e.clientLeft,i[a].clientY-o.top-e.clientTop));return r},i.mouseButton=function(e){return void 0!==t.window.InstallTrigger&&2===e.button&&e.ctrlKey&&t.window.navigator.platform.toUpperCase().indexOf("MAC")>=0?0:e.button},i.remove=function(t){t.parentNode&&t.parentNode.removeChild(t);};var d=function(e){function i(){e.call(this),this.images={},this.updatedImages={},this.callbackDispatchedThisFrame={},this.loaded=!1,this.requestors=[],this.patterns={},this.atlasImage=new t.RGBAImage({width:1,height:1}),this.dirty=!0;}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.isLoaded=function(){return this.loaded},i.prototype.setLoaded=function(t){if(this.loaded!==t&&(this.loaded=t,t)){for(var e=0,i=this.requestors;e<i.length;e+=1){var o=i[e];this._notify(o.ids,o.callback);}this.requestors=[];}},i.prototype.getImage=function(t){return this.images[t]},i.prototype.addImage=function(t,e){this._validate(t,e)&&(this.images[t]=e);},i.prototype._validate=function(e,i){var o=!0;return this._validateStretch(i.stretchX,i.data&&i.data.width)||(this.fire(new t.ErrorEvent(new Error('Image "'+e+'" has invalid "stretchX" value'))),o=!1),this._validateStretch(i.stretchY,i.data&&i.data.height)||(this.fire(new t.ErrorEvent(new Error('Image "'+e+'" has invalid "stretchY" value'))),o=!1),this._validateContent(i.content,i)||(this.fire(new t.ErrorEvent(new Error('Image "'+e+'" has invalid "content" value'))),o=!1),o},i.prototype._validateStretch=function(t,e){if(!t)return !0;for(var i=0,o=0,r=t;o<r.length;o+=1){var a=r[o];if(a[0]<i||a[1]<a[0]||e<a[1])return !1;i=a[1];}return !0},i.prototype._validateContent=function(t,e){return !(t&&(4!==t.length||t[0]<0||e.data.width<t[0]||t[1]<0||e.data.height<t[1]||t[2]<0||e.data.width<t[2]||t[3]<0||e.data.height<t[3]||t[2]<t[0]||t[3]<t[1]))},i.prototype.updateImage=function(t,e){e.version=this.images[t].version+1,this.images[t]=e,this.updatedImages[t]=!0;},i.prototype.removeImage=function(t){var e=this.images[t];delete this.images[t],delete this.patterns[t],e.userImage&&e.userImage.onRemove&&e.userImage.onRemove();},i.prototype.listImages=function(){return Object.keys(this.images)},i.prototype.getImages=function(t,e){var i=!0;if(!this.isLoaded())for(var o=0,r=t;o<r.length;o+=1)this.images[r[o]]||(i=!1);this.isLoaded()||i?this._notify(t,e):this.requestors.push({ids:t,callback:e});},i.prototype._notify=function(e,i){for(var o={},r=0,a=e;r<a.length;r+=1){var n=a[r],s=this.images[n];!s&&this.defaultImageManger&&(s=this.defaultImageManger.getImage(n)),s||this.fire(new t.Event("styleimagemissing",{id:n})),s?o[n]={data:s.data.clone(),pixelRatio:s.pixelRatio,sdf:s.sdf,version:s.version,stretchX:s.stretchX,stretchY:s.stretchY,content:s.content,hasRenderCallback:Boolean(s.userImage&&s.userImage.render)}:t.warnOnce('Image "'+n+'" could not be loaded. Please make sure you have added the image with map.addImage() or a "sprite" property in your style. You can provide missing images by listening for the "styleimagemissing" map event.');}i(null,o);},i.prototype.getPixelSize=function(){var t=this.atlasImage;return {width:t.width,height:t.height}},i.prototype.getPattern=function(e){var i=this.patterns[e],o=this.getImage(e);if(!o)return null;if(i&&i.position.version===o.version)return i.position;if(i)i.position.version=o.version;else {var r={w:o.data.width+2,h:o.data.height+2,x:0,y:0},a=new t.ImagePosition(r,o);this.patterns[e]={bin:r,position:a};}return this._updatePatternAtlas(),this.patterns[e].position},i.prototype.bind=function(e){var i=e.gl;this.atlasTexture?this.dirty&&(this.atlasTexture.update(this.atlasImage),this.dirty=!1):this.atlasTexture=new t.Texture(e,this.atlasImage,i.RGBA),this.atlasTexture.bind(i.LINEAR,i.CLAMP_TO_EDGE);},i.prototype._updatePatternAtlas=function(){var e=[];for(var i in this.patterns)e.push(this.patterns[i].bin);var o=t.potpack(e),r=o.w,a=o.h,n=this.atlasImage;for(var s in n.resize({width:r||1,height:a||1}),this.patterns){var l=this.patterns[s].bin,c=l.x+1,h=l.y+1,u=this.images[s].data,p=u.width,d=u.height;t.RGBAImage.copy(u,n,{x:0,y:0},{x:c,y:h},{width:p,height:d}),t.RGBAImage.copy(u,n,{x:0,y:d-1},{x:c,y:h-1},{width:p,height:1}),t.RGBAImage.copy(u,n,{x:0,y:0},{x:c,y:h+d},{width:p,height:1}),t.RGBAImage.copy(u,n,{x:p-1,y:0},{x:c-1,y:h},{width:1,height:d}),t.RGBAImage.copy(u,n,{x:0,y:0},{x:c+p,y:h},{width:1,height:d});}this.dirty=!0;},i.prototype.beginFrame=function(){this.callbackDispatchedThisFrame={};},i.prototype.dispatchRenderCallbacks=function(t){for(var e=0,i=t;e<i.length;e+=1){var o=i[e];if(!this.callbackDispatchedThisFrame[o]){this.callbackDispatchedThisFrame[o]=!0;var r=this.images[o];p(r)&&this.updateImage(o,r);}}},i}(t.Evented),_=function(t){function e(){var t=new d;t.setEventedParent(this),this.imageManagers={image_manager_default:t},this.imageManagers.image_manager_default.setLoaded(!0);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getImage=function(t,e){return void 0===e&&(e="image_manager_default"),this._getImageManager(e).getImage(t)},e.prototype.addImage=function(t,e,i){if(void 0===i&&(i="image_manager_default"),!this.imageManagers[i]){var o=new d;o.setEventedParent(this),this.imageManagers[i]=o,"image_manager_default"!==i&&(this.imageManagers[i].defaultImageManger=this.imageManagers.image_manager_default);}this._getImageManager(i).addImage(t,e);},e.prototype.updateImage=function(t,e,i){if(void 0===i&&(i="image_manager_default"),i)this._getImageManager(i).updateImage(t,e);else for(var o in this.imageManagers)this.imageManagers[o].updateImage(t,e);},e.prototype.removeImage=function(t,e){void 0===e&&(e="image_manager_default"),this._getImageManager(e).removeImage(t);},e.prototype.listImages=function(t){var e=[];for(var i in this.imageManagers)e.push.apply(e,this.imageManagers[i].listImages());return e},e.prototype.getImages=function(t,e,i){void 0===i&&(i="image_manager_default"),this._getImageManager(i).getImages(t,e);},e.prototype.getPixelSize=function(t){return void 0===t&&(t="image_manager_default"),this._getImageManager(t).getPixelSize()},e.prototype.getPattern=function(t,e){return void 0===e&&(e="image_manager_default"),this._getImageManager(e).getPattern(t)},e.prototype.bind=function(t,e){void 0===e&&(e="image_manager_default"),this._getImageManager(e).bind(t);},e.prototype.isLoaded=function(t){return void 0===t&&(t="image_manager_default"),this._getImageManager(t).isLoaded()},e.prototype.isAllLoaded=function(){for(var t in this.imageManagers)if(!this.imageManagers[t].isLoaded())return !1;return !0},e.prototype.beginFrame=function(t){return void 0===t&&(t="image_manager_default"),this._getImageManager(t).beginFrame()},e.prototype.dispatchRenderCallbacks=function(t,e){return void 0===e&&(e="image_manager_default"),this._getImageManager(e).dispatchRenderCallbacks(t)},e.prototype.setLoaded=function(t,e){return void 0===e&&(e="image_manager_default"),this._getImageManager(e).setLoaded(t)},e.prototype._getImageManager=function(t){return this.imageManagers[t]?this.imageManagers[t]:this.imageManagers.image_manager_default},e}(t.Evented),f=1e20,m=function(t){void 0===t&&(t={});var e=t.fontSize;void 0===e&&(e=24);var i=t.buffer;void 0===i&&(i=3);var o=t.radius;void 0===o&&(o=8);var r=t.cutoff;void 0===r&&(r=.25);var a=t.fontFamily;void 0===a&&(a="sans-serif");var n=t.fontWeight;void 0===n&&(n="normal");var s=t.fontStyle;void 0===s&&(s="normal"),this.buffer=i,this.cutoff=r,this.radius=o;var l=this.size=e+4*i,c=this._createCanvas(l),h=this.ctx=c.getContext("2d",{willReadFrequently:!0});h.font=s+" "+n+" "+e+"px "+a,h.textBaseline="alphabetic",h.textAlign="left",h.fillStyle="black",this.gridOuter=new Float64Array(l*l),this.gridInner=new Float64Array(l*l),this.f=new Float64Array(l),this.z=new Float64Array(l+1),this.v=new Uint16Array(l);};function g(t,e,i,o,r,a,n,s,l){for(var c=e;c<e+o;c++)v(t,i*a+c,a,r,n,s,l);for(var h=i;h<i+r;h++)v(t,h*a+e,1,o,n,s,l);}function v(t,e,i,o,r,a,n){a[0]=0,n[0]=-f,n[1]=f,r[0]=t[e];for(var s=1,l=0,c=0;s<o;s++){r[s]=t[e+s*i];var h=s*s;do{var u=a[l];c=(r[s]-r[u]+h-u*u)/(s-u)/2;}while(c<=n[l]&&--l>-1);a[++l]=s,n[l]=c,n[l+1]=f;}for(var p=0,d=0;p<o;p++){for(;n[d+1]<p;)d++;var _=a[d],m=p-_;t[e+p*i]=r[_]+m*m;}}m.prototype._createCanvas=function(t){var e=document.createElement("canvas");return e.width=e.height=t,e},m.prototype.draw=function(t){var e=this.ctx.measureText(t),i=e.width,o=e.actualBoundingBoxDescent,r=e.actualBoundingBoxLeft,a=e.actualBoundingBoxRight,n=Math.ceil(e.actualBoundingBoxAscent),s=Math.max(0,Math.min(this.size-this.buffer,Math.ceil(a-r))),l=Math.min(this.size-this.buffer,n+Math.ceil(o)),c=s+2*this.buffer,h=l+2*this.buffer,u=Math.max(c*h,0),p=new Uint8ClampedArray(u),d={data:p,width:c,height:h,glyphWidth:s,glyphHeight:l,glyphTop:n,glyphLeft:0,glyphAdvance:i};if(0===s||0===l)return d;var _=this.ctx,m=this.buffer,v=this.gridInner,y=this.gridOuter;_.clearRect(m,m,s,l),_.fillText(t,m,m+n);var x=_.getImageData(m,m,s,l);y.fill(f,0,u),v.fill(0,0,u);for(var b=0;b<l;b++)for(var w=0;w<s;w++){var E=x.data[4*(b*s+w)+3]/255;if(0!==E){var T=(b+m)*c+w+m;if(1===E)y[T]=0,v[T]=f;else {var S=.5-E;y[T]=S>0?S*S:0,v[T]=S<0?S*S:0;}}}g(y,0,0,c,h,c,this.f,this.v,this.z),g(v,m,m,s,l,c,this.f,this.v,this.z);for(var I=0;I<u;I++){var P=Math.sqrt(y[I])-Math.sqrt(v[I]);p[I]=Math.round(255-255*(P/this.radius+this.cutoff));}return d};var y=function(t,e){this.requestManager=t,this.localIdeographFontFamily=e,this.entries={},this.localGlyphs={200:{},400:{},500:{},900:{}};};y.prototype.setURL=function(t){this.url=t;},y.prototype.getGlyphs=function(e,i){var o=this,r=[];for(var a in e)for(var n=0,s=e[a];n<s.length;n+=1)r.push({stack:a,id:s[n]});t.asyncAll(r,(function(t,e){var i=t.stack,r=t.id,a=o.entries[i];a||(a=o.entries[i]={glyphs:{},requests:{},ranges:{}});var n=a.glyphs[r];if(void 0===n){if(n=o._tinySDF(a,i,r))return a.glyphs[r]=n,void e(null,{stack:i,id:r,glyph:n});var s=Math.floor(r/256);if(256*s>65535)e(new Error("glyphs > 65535 not supported"));else if(a.ranges[s])e(null,{stack:i,id:r,glyph:n});else {var l=a.requests[s];l||(l=a.requests[s]=[],y.loadGlyphRange(i,s,o.url,o.requestManager,(function(t,e){if(e){for(var i in e)o._doesCharSupportLocalGlyph(+i)||(a.glyphs[+i]=e[+i]);a.ranges[s]=!0;}for(var r=0,n=l;r<n.length;r+=1)(0,n[r])(t,e);delete a.requests[s];}))),l.push((function(t,o){t?e(t):o&&e(null,{stack:i,id:r,glyph:o[r]||null});}));}}else e(null,{stack:i,id:r,glyph:n});}),(function(t,e){if(t)i(t);else if(e){for(var o={},r=0,a=e;r<a.length;r+=1){var n=a[r],s=n.stack,l=n.id,c=n.glyph;(o[s]||(o[s]={}))[l]=c&&{id:c.id,bitmap:c.bitmap.clone(),metrics:c.metrics};}i(null,o);}}));},y.prototype._doesCharSupportLocalGlyph=function(e){return !!this.localIdeographFontFamily&&(t.isChar["CJK Unified Ideographs"](e)||t.isChar["Hangul Syllables"](e)||t.isChar.Hiragana(e)||t.isChar.Katakana(e))},y.prototype._include=function(t,e){for(var i=0;i<t.length;i++)if(e.indexOf(t[i])>=0)return !0;return !1},y.prototype._tinySDF=function(e,i,o){var r=this.localIdeographFontFamily;if(r&&(this._include(r.split(","),i.split(","))||this._doesCharSupportLocalGlyph(o))){e.tinySDFs||(e.tinySDFs={});var a=e.tinySDFs[i];if(!a){var n="400";/bold/i.test(i)?n="900":/medium/i.test(i)?n="500":/light/i.test(i)&&(n="200"),a=new y.TinySDF({fontSize:48,buffer:6,radius:16,fontFamily:i,fontWeight:n}),e.tinySDFs[i]=a,a.fontWeight=n;}if(this.localGlyphs[a.fontWeight][i]||(this.localGlyphs[a.fontWeight][i]={}),this.localGlyphs[a.fontWeight][i][o])return this.localGlyphs[a.fontWeight][i][o];var s=String.fromCodePoint(o),l=a.draw(s),c=l.glyphWidth,h=l.glyphHeight,u=l.glyphLeft,p=l.glyphTop,d=l.glyphAdvance;return this.localGlyphs[a.fontWeight][i][o]={id:o,bitmap:new t.AlphaImage({width:l.width,height:l.height},l.data),metrics:{width:c/2,height:h/2,left:u/2+.5,top:p/2-27.5,advance:d/2,localGlyph:!0,isDoubleResolution:!0}}}},y.loadGlyphRange=function(e,i,o,r,a){var n=256*i,s=n+255;if(!o)throw new Error('use of "text-field" requires a style "glyphs" property for '+e);var l=r.transformRequest(r.normalizeGlyphsURL(o).replace("{fontstack}",e).replace("{range}",n+"-"+s),t.ResourceType.Glyphs);t.getArrayBuffer(l,(function(e,i){if(e)a(e);else if(i){for(var o={},r=0,n=t.parseGlyphPBF(i);r<n.length;r+=1){var s=n[r];o[s.id]=s;}a(null,o);}}));},y.TinySDF=m;var x=function(t,e){this.requestManager=t,this.localIdeographFontFamily=e,this.glyphManagers={image_manager_default:new y(this.requestManager,this.localIdeographFontFamily)};};x.prototype._getGlyphManager=function(t){return this.glyphManagers[t]?this.glyphManagers[t]:this.glyphManagers.image_manager_default},x.prototype.setURL=function(t,e){void 0===e&&(e="image_manager_default"),this.glyphManagers[e]||(this.glyphManagers[e]=new y(this.requestManager,this.localIdeographFontFamily)),this._getGlyphManager(e).setURL(t);},x.prototype.getGlyphs=function(t,e,i){void 0===i&&(i="image_manager_default"),this._getGlyphManager(i).getGlyphs(t,e);};var b=function(){this.specification=t.styleSpec.light.position;};b.prototype.possiblyEvaluate=function(e,i){return t.sphericalToCartesian(e.expression.evaluate(i))},b.prototype.interpolate=function(e,i,o){return {x:t.number(e.x,i.x,o),y:t.number(e.y,i.y,o),z:t.number(e.z,i.z,o)}};var w=new t.Properties({anchor:new t.DataConstantProperty(t.styleSpec.light.anchor),position:new b,color:new t.DataConstantProperty(t.styleSpec.light.color),intensity:new t.DataConstantProperty(t.styleSpec.light.intensity)}),E=function(e){function i(i){e.call(this),this._transitionable=new t.Transitionable(w),this.setLight(i),this._transitioning=this._transitionable.untransitioned();}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.getLight=function(){return this._transitionable.serialize()},i.prototype.setLight=function(e,i){if(void 0===i&&(i={}),!this._validate(t.validateLight,e,i))for(var o in e){var r=e[o];t.endsWith(o,"-transition")?this._transitionable.setTransition(o.slice(0,-"-transition".length),r):this._transitionable.setValue(o,r);}},i.prototype.updateTransitions=function(t){this._transitioning=this._transitionable.transitioned(t,this._transitioning);},i.prototype.hasTransition=function(){return this._transitioning.hasTransition()},i.prototype.recalculate=function(t){this.properties=this._transitioning.possiblyEvaluate(t);},i.prototype._validate=function(e,i,o){return (!o||!1!==o.validate)&&t.emitValidationErrors(this,e.call(t.validateStyle,t.extend({value:i,style:{glyphs:!0,sprite:!0},styleSpec:t.styleSpec})))},i}(t.Evented),T=function(t,e){this.width=t,this.height=e,this.nextRow=0,this.data=new Uint8Array(this.width*this.height),this.dashEntry={};};T.prototype.getDash=function(t,e){var i=t.join(",")+String(e);return this.dashEntry[i]||(this.dashEntry[i]=this.addDash(t,e)),this.dashEntry[i]},T.prototype.getDashRanges=function(t,e,i){var o=[],r=t.length%2==1?-t[t.length-1]*i:0,a=t[0]*i,n=!0;o.push({left:r,right:a,isDash:n,zeroLength:0===t[0]});for(var s=t[0],l=1;l<t.length;l++){var c=t[l];o.push({left:r=s*i,right:a=(s+=c)*i,isDash:n=!n,zeroLength:0===c});}return o},T.prototype.addRoundDash=function(t,e,i){for(var o=e/2,r=-i;r<=i;r++)for(var a=this.width*(this.nextRow+i+r),n=0,s=t[n],l=0;l<this.width;l++){l/s.right>1&&(s=t[++n]);var c=Math.abs(l-s.left),h=Math.abs(l-s.right),u=Math.min(c,h),p=void 0,d=r/i*(o+1);if(s.isDash){var _=o-Math.abs(d);p=Math.sqrt(u*u+_*_);}else p=o-Math.sqrt(u*u+d*d);this.data[a+l]=Math.max(0,Math.min(255,p+128));}},T.prototype.addRegularDash=function(t){for(var e=t.length-1;e>=0;--e){var i=t[e],o=t[e+1];i.zeroLength?t.splice(e,1):o&&o.isDash===i.isDash&&(o.left=i.left,t.splice(e,1));}var r=t[0],a=t[t.length-1];r.isDash===a.isDash&&(r.left=a.left-this.width,a.right=r.right+this.width);for(var n=this.width*this.nextRow,s=0,l=t[s],c=0;c<this.width;c++){c/l.right>1&&(l=t[++s]);var h=Math.abs(c-l.left),u=Math.abs(c-l.right),p=Math.min(h,u);this.data[n+c]=Math.max(0,Math.min(255,(l.isDash?p:-p)+128));}},T.prototype.addDash=function(e,i){var o=i?7:0,r=2*o+1;if(this.nextRow+r>this.height)return t.warnOnce("LineAtlas out of space"),null;for(var a=0,n=0;n<e.length;n++)a+=e[n];if(0!==a){var s=this.width/a,l=this.getDashRanges(e,this.width,s);i?this.addRoundDash(l,s,o):this.addRegularDash(l);}var c={y:(this.nextRow+o+.5)/this.height,height:2*o/this.height,width:a};return this.nextRow+=r,this.dirty=!0,c},T.prototype.bind=function(t){var e=t.gl;this.texture?(e.bindTexture(e.TEXTURE_2D,this.texture),this.dirty&&(this.dirty=!1,e.texSubImage2D(e.TEXTURE_2D,0,0,0,this.width,this.height,e.ALPHA,e.UNSIGNED_BYTE,this.data))):(this.texture=e.createTexture(),e.bindTexture(e.TEXTURE_2D,this.texture),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_S,e.REPEAT),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_WRAP_T,e.REPEAT),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MIN_FILTER,e.LINEAR),e.texParameteri(e.TEXTURE_2D,e.TEXTURE_MAG_FILTER,e.LINEAR),e.texImage2D(e.TEXTURE_2D,0,e.ALPHA,this.width,this.height,0,e.ALPHA,e.UNSIGNED_BYTE,this.data));};var S=function e(i,o){this.workerPool=i,this.actors=[],this.currentActor=0,this.id=t.uniqueId();for(var r=this.workerPool.acquire(this.id),a=0;a<r.length;a++){var n=new e.Actor(r[a],o,this.id);n.name="Worker "+a,this.actors.push(n);}};function I(e,i,o){var r=function(r,a){if(r)return o(r);if(a){var n=t.pick(t.extend(a,e),["tiles","minzoom","maxzoom","attribution","mapbox_logo","bounds","scheme","tileSize","encoding"]);a.vector_layers&&(n.vectorLayers=a.vector_layers,n.vectorLayerIds=n.vectorLayers.map((function(t){return t.id}))),n.tiles=i.canonicalizeTileset(n,e.url),o(null,n);}};return e.url?t.getJSON(i.transformRequest(i.normalizeSourceURL(e.url),t.ResourceType.Source),r):t.browser.frame((function(){return r(null,e)}))}S.prototype.broadcast=function(e,i,o){t.asyncAll(this.actors,(function(t,o){t.send(e,i,o);}),o=o||function(){});},S.prototype.getActor=function(){return this.currentActor=(this.currentActor+1)%this.actors.length,this.actors[this.currentActor]},S.prototype.remove=function(){this.actors.forEach((function(t){t.remove();})),this.actors=[],this.workerPool.release(this.id);},S.Actor=t.Actor;var P=function(e,i,o){this.bounds=t.LngLatBounds.convert(this.validateBounds(e)),this.minzoom=i||0,this.maxzoom=o||24;};P.prototype.validateBounds=function(t){return Array.isArray(t)&&4===t.length?[Math.max(-180,t[0]),Math.max(-90,t[1]),Math.min(180,t[2]),Math.min(90,t[3])]:[-180,-90,180,90]},P.prototype.contains=function(t,e,i,o,r,a){var n=Math.pow(2,t.z),s=this.bounds.getWest(),l=this.bounds.getNorth(),c=this.bounds.getEast(),h=this.bounds.getSouth(),u=this.bounds.getCenter();if(a)if(s<=-180&&l>=85.051129&&c>=180&&h<=-85.051129)s=a.extent[0],l=a.extent[3],c=a.extent[2],h=a.extent[1];else {var p=a.fromWGS84([s,u.lat])[0],d=a.fromWGS84([u.lng,l])[1],_=a.fromWGS84([c,u.lat])[0],f=a.fromWGS84([u.lng,h])[1];s=Math.max(a.extent[0],p),l=Math.min(a.extent[3],d),c=Math.min(a.extent[2],_),h=Math.max(a.extent[1],f);}var m=Math.floor((s-e)*n/o),g=Math.floor((i-l)*n/r),v=Math.ceil((c-e)*n/o),y=Math.ceil((i-h)*n/r);return t.x>=m&&t.x<v&&t.y>=g&&t.y<y};var C=function(e){function i(i,o,r,a){if(e.call(this),this.id=i,this.dispatcher=r,this.type="vector",this.minzoom=0,this.maxzoom=22,this.scheme="xyz",this.tileSize=512,this._scales=[],this._resolutions=[],this.reparseOverscaled=!0,this.isTileClipped=!0,this._loaded=!1,this.decryptOptions=null,this.options=o,t.extend(this,t.pick(o,["url","scheme","tileSize","promoteId"])),this._options=t.extend({type:"vector"},o),this._collectResourceTiming=o.collectResourceTiming,512!==this.tileSize)throw new Error("vector tile sources must have a tileSize of 512");this.setEventedParent(a);}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.beforeLoad=async function(t,e){},i.prototype.load=function(){var e=this;this._loaded=!1,this.fire(new t.Event("dataloading",{dataType:"source"})),this._tileJSONRequest=I(this._options,this.map._requestManager,(async function(i,o){await e.beforeLoad(e.id,e.options),e._tileJSONRequest=null,e._loaded=!0,i?e.fire(new t.ErrorEvent(i)):o&&(t.extend(e,o),o.bounds&&(e.tileBounds=new P(o.bounds,e.minzoom,e.maxzoom)),t.postTurnstileEvent(o.tiles,e.map._requestManager._customAccessToken),t.postMapLoadEvent(o.tiles,e.map._getMapId(),e.map._requestManager._skuToken,e.map._requestManager._customAccessToken),e.fire(new t.Event("data",{dataType:"source",sourceDataType:"metadata"})),e.fire(new t.Event("data",{dataType:"source",sourceDataType:"content"})));}));},i.prototype.loaded=function(){return this._loaded},i.prototype.hasTile=function(t){return !this.tileBounds||this.tileBounds.contains(t.canonical,this.originX,this.originY,this.worldWidth,this.worldHeight,this.map.getCRS())},i.prototype.onAdd=function(t){this.map=t,this.setCRS(),this.load();},i.prototype.setCRS=function(){var t=this.map.getCRS();this.worldWidth=t.getWidth(),this.worldHeight=t.getHeight(),this.originX=t.getOriginX(),this.originY=t.getOriginY(),this._scales=[],this._resolutions=[];},i.prototype.setSourceProperty=function(t){this._tileJSONRequest&&this._tileJSONRequest.cancel(),t(),this.map.style.sourceCaches[this.id].clearTiles(),this.load();},i.prototype.setTiles=function(t){var e=this;return this.setSourceProperty((function(){e._options.tiles=t;})),this},i.prototype.setUrl=function(t){var e=this;return this.setSourceProperty((function(){e.url=t,e._options.url=t;})),this},i.prototype.onRemove=function(){this._tileJSONRequest&&(this._tileJSONRequest.cancel(),this._tileJSONRequest=null);},i.prototype.serialize=function(){return t.extend({},this._options)},i.prototype.loadTile=function(e,i){var o=this.map._requestManager.normalizeTileURL(e.tileID.canonical.url(this.tiles,this.scheme,0,this.tileSize,this.getScale?this.getScale(e.tileID.canonical.z,this.tileSize):void 0),this.url,null),r={request:this.map._requestManager.transformRequest(o,t.ResourceType.Tile),uid:e.uid,tileID:e.tileID,zoom:e.tileID.overscaledZ,tileSize:this.tileSize*e.tileID.overscaleFactor(),type:this.type,source:this.id,decryptOptions:this.decryptOptions,pixelRatio:t.browser.devicePixelRatio,showCollisionBoxes:this.map.showCollisionBoxes,promoteId:this.promoteId};function a(o,r){return delete e.request,e.aborted?i(null):o&&404!==o.status?i(o):(r&&r.resourceTiming&&(e.resourceTiming=r.resourceTiming),this.map._refreshExpiredTiles&&r&&e.setExpiryData(r),e.loadVectorData(r,this.map.painter),t.cacheEntryPossiblyAdded(this.dispatcher),i(null),void(e.reloadCallback&&(this.loadTile(e,e.reloadCallback),e.reloadCallback=null)))}r.request.collectResourceTiming=this._collectResourceTiming,e.actor&&"expired"!==e.state?"loading"===e.state?e.reloadCallback=i:e.request=e.actor.send("reloadTile",r,a.bind(this)):(e.actor=this.dispatcher.getActor(),e.request=e.actor.send("loadTile",r,a.bind(this)));},i.prototype.abortTile=function(t){t.request&&(t.request.cancel(),delete t.request),t.actor&&t.actor.send("abortTile",{uid:t.uid,type:this.type,source:this.id},void 0);},i.prototype.unloadTile=function(t){t.unloadVectorData(),t.actor&&t.actor.send("removeTile",{uid:t.uid,type:this.type,source:this.id},void 0);},i.prototype.hasTransition=function(){return !1},i.prototype.getMeterPerMapUnit=function(t){var e=1;return "degree"===t||"degrees"===t||"d"===t?e=2*Math.PI*6378137/360:"kilometer"===t||"km"===t?e=.001:"inch"===t?e=1/.025399999918:"foot"===t&&(e=.3048),e},i.prototype.getResolution=function(t,e){return this._resolutions[t]||(this._resolutions[t]=this.worldWidth/Math.pow(2,t)/e),this._resolutions[t]},i.prototype.getScale=function(t,e){if(!this._scales[t]){var i=this.getResolution(t,e),o=this.getMeterPerMapUnit(this.map.getCRS().getUnit());this._scales[t]=1/(96*i*(1/.0254)*o);}return this._scales[t]},i}(t.Evented),z=function(e){function i(i,o,r,a){e.call(this),this.id=i,this.dispatcher=r,this.setEventedParent(a),this.type="raster",this.minzoom=0,this.maxzoom=22,this.roundZoom=!0,this.scheme="xyz",this.tileSize=512,this._loaded=!1,this._scales=[],this._resolutions=[],this.transparent=!0,this.rasterSource="",this.cacheEnabled=!0,this.redirect=!1,this.layersID=null,this.proxy=null,this.tileversion=null,this.rasterfunction=null,this.prjCoordSys=null,this.format="png",this._options=t.extend({type:"raster"},o),t.extend(this,t.pick(o,["url","scheme","tileSize","rasterSource","transparent","cacheEnabled","redirect","layersID","proxy","tileversion","rasterfunction","format","prjCoordSys"]));}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.load=function(){var e=this;this._loaded=!1,this.fire(new t.Event("dataloading",{dataType:"source"})),this._tileJSONRequest=I(this._options,this.map._requestManager,(function(i,o){e._tileJSONRequest=null,e._loaded=!0,i?e.fire(new t.ErrorEvent(i)):o&&(t.extend(e,o),o.bounds&&(e.tileBounds=new P(o.bounds,e.minzoom,e.maxzoom)),t.postTurnstileEvent(o.tiles),t.postMapLoadEvent(o.tiles,e.map._getMapId(),e.map._requestManager._skuToken),e.fire(new t.Event("data",{dataType:"source",sourceDataType:"metadata"})),e.fire(new t.Event("data",{dataType:"source",sourceDataType:"content"})));}));},i.prototype.loaded=function(){return this._loaded},i.prototype.onAdd=function(t){this.map=t,this.setCRS(),this.load();},i.prototype.setCRS=function(){var t=this.map.getCRS();this.worldWidth=t.getWidth(),this.worldHeight=t.getHeight(),this.originX=t.getOriginX(),this.originY=t.getOriginY(),this._scales=[],this._resolutions=[];},i.prototype.onRemove=function(){this._tileJSONRequest&&(this._tileJSONRequest.cancel(),this._tileJSONRequest=null);},i.prototype.serialize=function(){return t.extend({},this._options)},i.prototype.hasTile=function(t){return !this.tileBounds||this.tileBounds.contains(t.canonical,this.originX,this.originY,this.worldWidth,this.worldHeight,this.map.getCRS())},i.prototype.loadTile=function(e,i){var o=this,r=null;if("iserver"===this.rasterSource&&this.getScale){var a=this.getScale(e.tileID.canonical.z,this.tileSize),n=this.map._mapCRS.getOrigin(),s=(""+this.tiles[(e.tileID.canonical.x+e.tileID.canonical.y)%this.tiles.length]).split("?");r=s[0]+"/tileimage."+this.format+"?scale="+a+"&x="+e.tileID.canonical.x+"&y="+e.tileID.canonical.y+"&width="+this.tileSize+"&height="+this.tileSize+"&transparent="+this.transparent+"&redirect="+this.redirect+"&cacheEnabled="+this.cacheEnabled+"&origin="+encodeURIComponent(JSON.stringify({x:n[0],y:n[1]})),this.layersID&&(r=r+"&layersID="+this.layersID),this.tileversion&&(r=r+"&tileversion="+this.tileversion),this.rasterfunction&&(r=r+"&rasterfunction="+encodeURIComponent(JSON.stringify(this.rasterfunction))),this.prjCoordSys&&(r=r+"&prjCoordSys="+encodeURIComponent(JSON.stringify(this.prjCoordSys))),s[1]&&(r=r+"&"+s[1]);}else {var l=parseInt(this._options.zoomOffset)?parseInt(this._options.zoomOffset):0;r=this.map._requestManager.normalizeTileURL(e.tileID.canonical.url(this.tiles,this.scheme,l,this.tileSize,this.getScale?this.getScale(e.tileID.canonical.z,this.tileSize):void 0),this.url,this.tileSize);}this.proxy&&(r=""+this.proxy+encodeURIComponent(r)),e.request=t.getImage(this.map._requestManager.transformRequest(r,t.ResourceType.Tile),(function(r,a){if(delete e.request,e.aborted)e.state="unloaded",i(null);else if(r)e.state="errored",i(r);else if(a){o.map._refreshExpiredTiles&&e.setExpiryData(a),delete a.cacheControl,delete a.expires;var n=o.map.painter.context,s=n.gl;e.texture=o.map.painter.getTileTexture(a.width),e.texture?e.texture.update(a,{useMipmap:!0}):(e.texture=new t.Texture(n,a,s.RGBA,{useMipmap:!0}),e.texture.bind(s.LINEAR,s.CLAMP_TO_EDGE,s.LINEAR_MIPMAP_NEAREST),n.extTextureFilterAnisotropic&&s.texParameterf(s.TEXTURE_2D,n.extTextureFilterAnisotropic.TEXTURE_MAX_ANISOTROPY_EXT,n.extTextureFilterAnisotropicMax)),e.state="loaded",t.cacheEntryPossiblyAdded(o.dispatcher),i(null);}}));},i.prototype.abortTile=function(t,e){t.request&&(t.request.cancel(),delete t.request),e();},i.prototype.unloadTile=function(t,e){t.texture&&this.map.painter.saveTileTexture(t.texture),e();},i.prototype.hasTransition=function(){return !1},i.prototype.getMeterPerMapUnit=function(t){var e=1;return "degree"===t||"degrees"===t||"d"===t?e=2*Math.PI*6378137/360:"kilometer"===t||"km"===t?e=.001:"inch"===t?e=1/.025399999918:"foot"===t&&(e=.3048),e},i.prototype.getResolution=function(t,e){return this._resolutions[t]||(this._resolutions[t]=this.worldWidth/Math.pow(2,t)/e),this._resolutions[t]},i.prototype.getScale=function(t,e){if(!this._scales[t]){var i=this.getResolution(t,e),o=this.getMeterPerMapUnit(this.map.getCRS().getUnit());this._scales[t]=1/(96*i*(1/.0254)*o);}return this._scales[t]},i}(t.Evented),M=function(e){function i(i,o,r,a){e.call(this,i,o,r,a),this.type="raster-dem",this.maxzoom=22,this._options=t.extend({type:"raster-dem"},o),this.encoding=o.encoding||"mapbox";}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.serialize=function(){return {type:"raster-dem",url:this.url,tileSize:this.tileSize,tiles:this.tiles,bounds:this.bounds,encoding:this.encoding}},i.prototype.loadTile=function(e,i){var o=this.map._requestManager.normalizeTileURL(e.tileID.canonical.url(this.tiles,this.scheme),this.tileSize);function r(t,o){t&&(e.state="errored",i(t)),o&&(e.dem=o,e.needsHillshadePrepare=!0,e.state="loaded",i(null));}e.request=t.getImage(this.map._requestManager.transformRequest(o,t.ResourceType.Tile),function(o,a){if(delete e.request,e.aborted)e.state="unloaded",i(null);else if(o)e.state="errored",i(o);else if(a){this.map._refreshExpiredTiles&&e.setExpiryData(a),delete a.cacheControl,delete a.expires;var n=t.window.ImageBitmap&&a instanceof t.window.ImageBitmap&&t.offscreenCanvasSupported()?a:t.browser.getImageData(a,1),s={uid:e.uid,coord:e.tileID,source:this.id,rawImageData:n,encoding:this.encoding};e.actor&&"expired"!==e.state||(e.actor=this.dispatcher.getActor(),e.actor.send("loadDEMTile",s,r.bind(this)));}}.bind(this)),e.neighboringTiles=this._getNeighboringTiles(e.tileID);},i.prototype._getNeighboringTiles=function(e){var i=e.canonical,o=Math.pow(2,i.z),r=(i.x-1+o)%o,a=0===i.x?e.wrap-1:e.wrap,n=(i.x+1+o)%o,s=i.x+1===o?e.wrap+1:e.wrap,l={};return l[new t.OverscaledTileID(e.overscaledZ,a,i.z,r,i.y).key]={backfilled:!1},l[new t.OverscaledTileID(e.overscaledZ,s,i.z,n,i.y).key]={backfilled:!1},i.y>0&&(l[new t.OverscaledTileID(e.overscaledZ,a,i.z,r,i.y-1).key]={backfilled:!1},l[new t.OverscaledTileID(e.overscaledZ,e.wrap,i.z,i.x,i.y-1).key]={backfilled:!1},l[new t.OverscaledTileID(e.overscaledZ,s,i.z,n,i.y-1).key]={backfilled:!1}),i.y+1<o&&(l[new t.OverscaledTileID(e.overscaledZ,a,i.z,r,i.y+1).key]={backfilled:!1},l[new t.OverscaledTileID(e.overscaledZ,e.wrap,i.z,i.x,i.y+1).key]={backfilled:!1},l[new t.OverscaledTileID(e.overscaledZ,s,i.z,n,i.y+1).key]={backfilled:!1}),l},i.prototype.unloadTile=function(t){t.demTexture&&this.map.painter.saveTileTexture(t.demTexture),t.fbo&&(t.fbo.destroy(),delete t.fbo),t.dem&&delete t.dem,delete t.neighboringTiles,t.state="unloaded",t.actor&&t.actor.send("removeDEMTile",{uid:t.uid,source:this.id});},i}(z),L=function(e){function i(i,o,r,a){e.call(this),this.id=i,this.type="geojson",this.minzoom=0,this.maxzoom=18,this.tileSize=512,this.isTileClipped=!0,this.reparseOverscaled=!0,this._removed=!1,this._loaded=!1,this.actor=r.getActor(),this.setEventedParent(a),this._data=o.data,this._options=t.extend({},o),this._collectResourceTiming=o.collectResourceTiming,this._resourceTiming=[],void 0!==o.maxzoom&&(this.maxzoom=o.maxzoom),o.type&&(this.type=o.type),o.attribution&&(this.attribution=o.attribution),this.promoteId=o.promoteId;var n=t.EXTENT/this.tileSize;this.workerOptions=t.extend({source:this.id,cluster:o.cluster||!1,geojsonVtOptions:{buffer:(void 0!==o.buffer?o.buffer:128)*n,tolerance:(void 0!==o.tolerance?o.tolerance:.375)*n,extent:t.EXTENT,customprj:o.customprj,maxZoom:this.maxzoom,lineMetrics:o.lineMetrics||!1,generateId:o.generateId||!1},superclusterOptions:{maxZoom:void 0!==o.clusterMaxZoom?Math.min(o.clusterMaxZoom,this.maxzoom-1):this.maxzoom-1,minPoints:Math.max(2,o.clusterMinPoints||2),extent:t.EXTENT,customprj:o.customprj,radius:(o.clusterRadius||50)*n,log:!1,generateId:o.generateId||!1},clusterProperties:o.clusterProperties,filter:o.filter},o.workerOptions);}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.load=function(){var e=this;this.fire(new t.Event("dataloading",{dataType:"source"})),this._updateWorkerData((function(i){if(i)e.fire(new t.ErrorEvent(i));else {var o={dataType:"source",sourceDataType:"metadata"};e._collectResourceTiming&&e._resourceTiming&&e._resourceTiming.length>0&&(o.resourceTiming=e._resourceTiming,e._resourceTiming=[]),e.fire(new t.Event("data",o));}}));},i.prototype.onAdd=function(t){this.map=t,this.workerOptions.crs={epsgCode:this.map.getCRS().epsgCode,WKT:this.map.getCRS().getWKT(),_id:this.map.getCRS()._id},this.load();},i.prototype.setCustomprj=function(t){this._options.customprj=t,this.workerOptions.superclusterOptions.customprj=t,this.workerOptions.geojsonVtOptions.customprj=t,this.workerOptions.crs={epsgCode:this.map.getCRS().epsgCode,WKT:this.map.getCRS().getWKT(),_id:this.map.getCRS()._id},this.load();},i.prototype.setData=function(e){var i=this;return this._data=e,this.fire(new t.Event("dataloading",{dataType:"source"})),this._updateWorkerData((function(e){if(e)i.fire(new t.ErrorEvent(e));else {var o={dataType:"source",sourceDataType:"content"};i._collectResourceTiming&&i._resourceTiming&&i._resourceTiming.length>0&&(o.resourceTiming=i._resourceTiming,i._resourceTiming=[]),i.fire(new t.Event("data",o));}})),this},i.prototype.getData=function(){return this._originData?this._originData:"string"!=typeof this._data?this._data:void 0},i.prototype.getClusterExpansionZoom=function(t,e){return this.actor.send("geojson.getClusterExpansionZoom",{clusterId:t,source:this.id},e),this},i.prototype.getClusterChildren=function(t,e){return this.actor.send("geojson.getClusterChildren",{clusterId:t,source:this.id},e),this},i.prototype.getClusterLeaves=function(t,e,i,o){return this.actor.send("geojson.getClusterLeaves",{source:this.id,clusterId:t,limit:e,offset:i},o),this},i.prototype._updateWorkerData=function(e){var i=this;this._loaded=!1;var o=t.extend({},this.workerOptions),r=this._data;"string"==typeof r?(o.request=this.map._requestManager.transformRequest(t.browser.resolveURL(r),t.ResourceType.Source),o.request.collectResourceTiming=this._collectResourceTiming):o.data=JSON.stringify(r),this.actor.send(this.type+".loadData",o,(function(t,r){i._originData=r.data||null,i._removed||r&&r.abandoned||(i._loaded=!0,r&&r.resourceTiming&&r.resourceTiming[i.id]&&(i._resourceTiming=r.resourceTiming[i.id].slice(0)),i.actor.send(i.type+".coalesce",{source:o.source},null),e(t));}));},i.prototype.loaded=function(){return this._loaded},i.prototype.loadTile=function(e,i){var o=this,r=e.actor?"reloadTile":"loadTile";e.actor=this.actor,e.request=this.actor.send(r,{type:this.type,uid:e.uid,tileID:e.tileID,zoom:e.tileID.overscaledZ,maxZoom:this.maxzoom,tileSize:this.tileSize,source:this.id,pixelRatio:t.browser.devicePixelRatio,showCollisionBoxes:this.map.showCollisionBoxes,promoteId:this.promoteId},(function(t,a){return delete e.request,e.unloadVectorData(),e.aborted?i(null):t?i(t):(e.loadVectorData(a,o.map.painter,"reloadTile"===r),i(null))}));},i.prototype.abortTile=function(t){t.request&&(t.request.cancel(),delete t.request),t.aborted=!0;},i.prototype.unloadTile=function(t){t.unloadVectorData(),this.actor.send("removeTile",{uid:t.uid,type:this.type,source:this.id});},i.prototype.onRemove=function(){this._removed=!0,this.actor.send("removeSource",{type:this.type,source:this.id});},i.prototype.serialize=function(){return t.extend({},this._options,{type:this.type,data:this._data})},i.prototype.hasTransition=function(){return !1},i}(t.Evented),D=t.createLayout([{name:"a_pos",type:"Int16",components:2},{name:"a_texture_pos",type:"Int16",components:2}]),R=function(e){function i(t,i,o,r){e.call(this),this.id=t,this.dispatcher=o,this.coordinates=i.coordinates,this.type="image",this.minzoom=0,this.maxzoom=22,this.tileSize=512,this.tiles={},this._loaded=!1,this.setEventedParent(r),this.options=i;}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.load=function(e,i){var o=this;this._loaded=!1,this.fire(new t.Event("dataloading",{dataType:"source"})),this.url=this.options.url,t.getImage(this.map._requestManager.transformRequest(this.url,t.ResourceType.Image),(function(r,a){o._loaded=!0,r?o.fire(new t.ErrorEvent(r)):a&&(o.image=a,e&&(o.coordinates=e),i&&i(),o._finishLoading());}));},i.prototype.loaded=function(){return this._loaded},i.prototype.updateImage=function(t){var e=this;return this.image&&t.url?(this.options.url=t.url,this.load(t.coordinates,(function(){e.texture=null;})),this):this},i.prototype._finishLoading=function(){this.map&&(this.setCoordinates(this.coordinates),this.fire(new t.Event("data",{dataType:"source",sourceDataType:"metadata"})));},i.prototype.onAdd=function(t){this.map=t,this.load();},i.prototype.setCoordinates=function(e){var i=this;this.coordinates=e;var o=e.map((function(t){return i.map.getCRS().fromLngLat(t)}));this.tileID=function(e,i){for(var o=1/0,r=1/0,a=-1/0,n=-1/0,s=0,l=e;s<l.length;s+=1){var c=l[s];o=Math.min(o,c.x),r=Math.min(r,c.y),a=Math.max(a,c.x),n=Math.max(n,c.y);}var h=Math.max(a-o,n-r),u=Math.max(0,Math.floor(-Math.log(h)/Math.LN2)),p=Math.pow(2,u);return new t.CanonicalTileID(u,Math.floor((o+a)/2*p),Math.floor((r+n)/2*p),i)}(o,this.map.getCRS().getExtent()),this.minzoom=this.maxzoom=this.tileID.z;var r=o.map((function(t){return i.tileID.getTilePoint(t)._round()}));return this._boundsArray=new t.StructArrayLayout4i8,this._boundsArray.emplaceBack(r[0].x,r[0].y,0,0),this._boundsArray.emplaceBack(r[1].x,r[1].y,t.EXTENT,0),this._boundsArray.emplaceBack(r[3].x,r[3].y,0,t.EXTENT),this._boundsArray.emplaceBack(r[2].x,r[2].y,t.EXTENT,t.EXTENT),this.boundsBuffer&&(this.boundsBuffer.destroy(),delete this.boundsBuffer),this.fire(new t.Event("data",{dataType:"source",sourceDataType:"content"})),this},i.prototype.prepare=function(){if(0!==Object.keys(this.tiles).length&&this.image){var e=this.map.painter.context,i=e.gl;for(var o in this.boundsBuffer||(this.boundsBuffer=e.createVertexBuffer(this._boundsArray,D.members)),this.boundsSegments||(this.boundsSegments=t.SegmentVector.simpleSegment(0,0,4,2)),this.texture||(this.texture=new t.Texture(e,this.image,i.RGBA),this.texture.bind(i.LINEAR,i.CLAMP_TO_EDGE)),this.tiles){var r=this.tiles[o];"loaded"!==r.state&&(r.state="loaded",r.texture=this.texture);}}},i.prototype.loadTile=function(t,e){this.tileID&&this.tileID.equals(t.tileID.canonical)?(this.tiles[String(t.tileID.wrap)]=t,t.buckets={},e(null)):(t.state="errored",e(null));},i.prototype.serialize=function(){return {type:"image",url:this.options.url,coordinates:this.coordinates}},i.prototype.hasTransition=function(){return !1},i}(t.Evented),A=function(e){function i(t,i,o,r){e.call(this,t,i,o,r),this.roundZoom=!0,this.type="video",this.options=i;}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.load=function(){this._loaded=!1,this._acceptedVideo=!1;var e=this.options;this.urls=[];for(var i=0,o=e.urls;i<o.length;i+=1)this.urls.push(this.map._requestManager.transformRequest(o[i],t.ResourceType.Source).url);if(/^(http|https):\/\/.*/.test(this.urls[0]))t.getVideo(this.urls,this.initVideo.bind(this));else {this._acceptedVideo=!0;var r=document.getElementById(this.urls[0]);this.initVideo(!r&&new t.ValidationError("sources."+this.id,null,"video is not found"),r);}},i.prototype.initVideo=function(e,i){var o=this;o._manualFakePlay=!0,this._loaded=!0,e?this.fire(new t.ErrorEvent(e)):i&&(this.video=i,this._acceptedVideo&&!1===this.video.loop||(this.video.loop=!0),this.video.addEventListener("playing",(function(){o.map.triggerRepaint();})),this.video.addEventListener("timeupdate",(function(){o._firstFrameRendered&&o._manualFakePlay&&(o.video.autoplay||(o.video.currentTime=0,o.video.pause()),o._manualFakePlay=!1,o.fire(new Event("videoloaded")));})),this.map&&(this._acceptedVideo||(this.video.autoplay=!0),this.video.muted=!0,this.video.play()),this._finishLoading());},i.prototype.pause=function(){this.video&&this.video.pause();},i.prototype.play=function(){this.video&&this.video.play();},i.prototype.seek=function(e){if(this.video){var i=this.video.seekable;e<i.start(0)||e>i.end(0)?this.fire(new t.ErrorEvent(new t.ValidationError("sources."+this.id,null,"Playback for this video can be set only between the "+i.start(0)+" and "+i.end(0)+"-second mark."))):this.video.currentTime=e;}},i.prototype.getVideo=function(){return this.video},i.prototype.onAdd=function(t){this.map||(this.map=t,this.load(),this.video&&(this.video.play(),this.setCoordinates(this.coordinates)));},i.prototype.prepare=function(){if(!(0===Object.keys(this.tiles).length||this.video.readyState<2)){var e=this.map.painter.context,i=e.gl;this.boundsBuffer||(this.boundsBuffer=e.createVertexBuffer(this._boundsArray,D.members)),this.boundsSegments||(this.boundsSegments=t.SegmentVector.simpleSegment(0,0,4,2));var o=this.video,r=this.options.drawImageCallback;for(var a in r&&(o=r(this.captureImage(this.video))),this.texture?this.video.paused||(this.texture.bind(i.LINEAR,i.CLAMP_TO_EDGE),i.texSubImage2D(i.TEXTURE_2D,0,0,0,i.RGBA,i.UNSIGNED_BYTE,o),this._firstFrameRendered=!0):(this.texture=new t.Texture(e,o,i.RGBA),this.texture.bind(i.LINEAR,i.CLAMP_TO_EDGE)),this.tiles){var n=this.tiles[a];"loaded"!==n.state&&(n.state="loaded",n.texture=this.texture);}}},i.prototype.captureImage=function(t,e){void 0===t&&(t=this.video),void 0===e&&(e=1);var i=document.createElement("canvas"),o=i.getContext("2d");return i.width=t.videoWidth*e,i.height=t.videoHeight*e,o.drawImage(t,0,0,i.width,i.height),o.getImageData(0,0,i.width,i.height)},i.prototype.serialize=function(){return {type:"video",urls:this.urls,coordinates:this.coordinates}},i.prototype.hasTransition=function(){return this.video&&!this.video.paused},i}(R),k=function(e){function i(i,o,r,a){e.call(this,i,o,r,a),o.coordinates?Array.isArray(o.coordinates)&&4===o.coordinates.length&&!o.coordinates.some((function(t){return !Array.isArray(t)||2!==t.length||t.some((function(t){return "number"!=typeof t}))}))||this.fire(new t.ErrorEvent(new t.ValidationError("sources."+i,null,'"coordinates" property must be an array of 4 longitude/latitude array pairs'))):this.fire(new t.ErrorEvent(new t.ValidationError("sources."+i,null,'missing required property "coordinates"'))),o.animate&&"boolean"!=typeof o.animate&&this.fire(new t.ErrorEvent(new t.ValidationError("sources."+i,null,'optional "animate" property must be a boolean value'))),o.canvas?"string"==typeof o.canvas||o.canvas instanceof t.window.HTMLCanvasElement||this.fire(new t.ErrorEvent(new t.ValidationError("sources."+i,null,'"canvas" must be either a string representing the ID of the canvas element from which to read, or an HTMLCanvasElement instance'))):this.fire(new t.ErrorEvent(new t.ValidationError("sources."+i,null,'missing required property "canvas"'))),this.options=o,this.animate=void 0===o.animate||o.animate;}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.load=function(){this._loaded=!0,this.canvas||(this.canvas=this.options.canvas instanceof t.window.HTMLCanvasElement?this.options.canvas:t.window.document.getElementById(this.options.canvas)),this.width=this.canvas.width,this.height=this.canvas.height,this._hasInvalidDimensions()?this.fire(new t.ErrorEvent(new Error("Canvas dimensions cannot be less than or equal to zero."))):(this.play=function(){this._playing=!0,this.map.triggerRepaint();},this.pause=function(){this._playing&&(this.prepare(),this._playing=!1);},this._finishLoading());},i.prototype.getCanvas=function(){return this.canvas},i.prototype.onAdd=function(t){this.map=t,this.load(),this.canvas&&this.animate&&this.play();},i.prototype.onRemove=function(){this.pause();},i.prototype.prepare=function(){var e=!1;if(this.canvas.width!==this.width&&(this.width=this.canvas.width,e=!0),this.canvas.height!==this.height&&(this.height=this.canvas.height,e=!0),!this._hasInvalidDimensions()&&0!==Object.keys(this.tiles).length){var i=this.map.painter.context,o=i.gl;for(var r in this.boundsBuffer||(this.boundsBuffer=i.createVertexBuffer(this._boundsArray,D.members)),this.boundsSegments||(this.boundsSegments=t.SegmentVector.simpleSegment(0,0,4,2)),this.texture?(e||this._playing)&&this.texture.update(this.canvas,{premultiply:!0}):this.texture=new t.Texture(i,this.canvas,o.RGBA,{premultiply:!0}),this.tiles){var a=this.tiles[r];"loaded"!==a.state&&(a.state="loaded",a.texture=this.texture);}}},i.prototype.serialize=function(){return {type:"canvas",coordinates:this.coordinates}},i.prototype.hasTransition=function(){return this._playing},i.prototype._hasInvalidDimensions=function(){for(var t=0,e=[this.canvas.width,this.canvas.height];t<e.length;t+=1){var i=e[t];if(isNaN(i)||i<=0)return !0}return !1},i}(R),O={vector:C,raster:z,"raster-dem":M,geojson:L,video:A,image:R,canvas:k};function B(e,i){var o=t.identity([]);return t.translate(o,o,[1,1,0]),t.scale(o,o,[.5*e.width,.5*e.height,1]),t.multiply(o,o,e.calculatePosMatrix(i.toUnwrapped()))}function F(t,e,i,o,r,a){var n=function(t,e,i){if(t)for(var o=0,r=t;o<r.length;o+=1){var a=e[r[o]];if(a&&a.source===i&&"fill-extrusion"===a.type)return !0}else for(var n in e){var s=e[n];if(s.source===i&&"fill-extrusion"===s.type)return !0}return !1}(r&&r.layers,e,t.id),s=a.maxPitchScaleFactor(),l=t.tilesIn(o,s,n);l.sort(U);for(var c=[],h=0,u=l;h<u.length;h+=1){var p=u[h];c.push({wrappedTileID:p.tileID.wrapped().key,queryResults:p.tile.queryRenderedFeatures(e,i,t._state,p.queryGeometry,p.cameraQueryGeometry,p.scale,r,a,s,B(t.transform,p.tileID))});}var d=function(t){for(var e={},i={},o=0,r=t;o<r.length;o+=1){var a=r[o],n=a.queryResults,s=a.wrappedTileID,l=i[s]=i[s]||{};for(var c in n)for(var h=n[c],u=l[c]=l[c]||{},p=e[c]=e[c]||[],d=0,_=h;d<_.length;d+=1){var f=_[d];u[f.featureIndex]||(u[f.featureIndex]=!0,p.push(f));}}return e}(c);for(var _ in d)d[_].forEach((function(e){var i=e.feature,o=t.getFeatureState(i.layer["source-layer"],i.id);i.source=i.layer.source,i.layer["source-layer"]&&(i.sourceLayer=i.layer["source-layer"]),i.state=o;}));return d}function U(t,e){var i=t.tileID,o=e.tileID;return i.overscaledZ-o.overscaledZ||i.canonical.y-o.canonical.y||i.wrap-o.wrap||i.canonical.x-o.canonical.x}var N=function(t,e){this.max=t,this.onRemove=e,this.reset();};N.prototype.reset=function(){for(var t in this.data)for(var e=0,i=this.data[t];e<i.length;e+=1){var o=i[e];o.timeout&&clearTimeout(o.timeout),this.onRemove(o.value);}return this.data={},this.order=[],this},N.prototype.add=function(t,e,i){var o=this,r=t.wrapped().key;void 0===this.data[r]&&(this.data[r]=[]);var a={value:e,timeout:void 0};if(void 0!==i&&(a.timeout=setTimeout((function(){o.remove(t,a);}),i)),this.data[r].push(a),this.order.push(r),this.order.length>this.max){var n=this._getAndRemoveByKey(this.order[0]);n&&this.onRemove(n);}return this},N.prototype.has=function(t){return t.wrapped().key in this.data},N.prototype.getAndRemove=function(t){return this.has(t)?this._getAndRemoveByKey(t.wrapped().key):null},N.prototype._getAndRemoveByKey=function(t){var e=this.data[t].shift();return e.timeout&&clearTimeout(e.timeout),0===this.data[t].length&&delete this.data[t],this.order.splice(this.order.indexOf(t),1),e.value},N.prototype.getByKey=function(t){var e=this.data[t];return e?e[0].value:null},N.prototype.get=function(t){return this.has(t)?this.data[t.wrapped().key][0].value:null},N.prototype.remove=function(t,e){if(!this.has(t))return this;var i=t.wrapped().key,o=void 0===e?0:this.data[i].indexOf(e),r=this.data[i][o];return this.data[i].splice(o,1),r.timeout&&clearTimeout(r.timeout),0===this.data[i].length&&delete this.data[i],this.onRemove(r.value),this.order.splice(this.order.indexOf(i),1),this},N.prototype.setMaxSize=function(t){for(this.max=t;this.order.length>this.max;){var e=this._getAndRemoveByKey(this.order[0]);e&&this.onRemove(e);}return this},N.prototype.filter=function(t){var e=[];for(var i in this.data)for(var o=0,r=this.data[i];o<r.length;o+=1){var a=r[o];t(a.value)||e.push(a);}for(var n=0,s=e;n<s.length;n+=1){var l=s[n];this.remove(l.value.tileID,l);}};var j=function(t,e,i){this.context=t;var o=t.gl;this.buffer=o.createBuffer(),this.dynamicDraw=Boolean(i),this.context.unbindVAO(),t.bindElementBuffer.set(this.buffer),o.bufferData(o.ELEMENT_ARRAY_BUFFER,e.arrayBuffer,this.dynamicDraw?o.DYNAMIC_DRAW:o.STATIC_DRAW),this.dynamicDraw||delete e.arrayBuffer;};j.prototype.bind=function(){this.context.bindElementBuffer.set(this.buffer);},j.prototype.updateData=function(t){var e=this.context.gl;this.context.unbindVAO(),this.bind(),e.bufferSubData(e.ELEMENT_ARRAY_BUFFER,0,t.arrayBuffer);},j.prototype.destroy=function(){this.buffer&&(this.context.gl.deleteBuffer(this.buffer),delete this.buffer);};var G={Int8:"BYTE",Uint8:"UNSIGNED_BYTE",Int16:"SHORT",Uint16:"UNSIGNED_SHORT",Int32:"INT",Uint32:"UNSIGNED_INT",Float32:"FLOAT"},Z=function(t,e,i,o){this.length=e.length,this.attributes=i,this.itemSize=e.bytesPerElement,this.dynamicDraw=o,this.context=t;var r=t.gl;this.buffer=r.createBuffer(),t.bindVertexBuffer.set(this.buffer),r.bufferData(r.ARRAY_BUFFER,e.arrayBuffer,this.dynamicDraw?r.DYNAMIC_DRAW:r.STATIC_DRAW),this.dynamicDraw||delete e.arrayBuffer;};Z.prototype.bind=function(){this.context.bindVertexBuffer.set(this.buffer);},Z.prototype.updateData=function(t){var e=this.context.gl;this.bind(),e.bufferSubData(e.ARRAY_BUFFER,0,t.arrayBuffer);},Z.prototype.enableAttributes=function(t,e){for(var i=0;i<this.attributes.length;i++){var o=e.attributes[this.attributes[i].name];void 0!==o&&t.enableVertexAttribArray(o);}},Z.prototype.setVertexAttribPointers=function(t,e,i){for(var o=0;o<this.attributes.length;o++){var r=this.attributes[o],a=e.attributes[r.name];void 0!==a&&t.vertexAttribPointer(a,r.components,t[G[r.type]],!1,this.itemSize,r.offset+this.itemSize*(i||0));}},Z.prototype.destroy=function(){this.buffer&&(this.context.gl.deleteBuffer(this.buffer),delete this.buffer);};var q=function(t){this.gl=t.gl,this.default=this.getDefault(),this.current=this.default,this.dirty=!1;};q.prototype.get=function(){return this.current},q.prototype.set=function(t){},q.prototype.getDefault=function(){return this.default},q.prototype.setDefault=function(){this.set(this.default);};var V=function(e){function i(){e.apply(this,arguments);}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.getDefault=function(){return t.Color.transparent},i.prototype.set=function(t){var e=this.current;(t.r!==e.r||t.g!==e.g||t.b!==e.b||t.a!==e.a||this.dirty)&&(this.gl.clearColor(t.r,t.g,t.b,t.a),this.current=t,this.dirty=!1);},i}(q),W=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return 1},e.prototype.set=function(t){(t!==this.current||this.dirty)&&(this.gl.clearDepth(t),this.current=t,this.dirty=!1);},e}(q),X=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return 0},e.prototype.set=function(t){(t!==this.current||this.dirty)&&(this.gl.clearStencil(t),this.current=t,this.dirty=!1);},e}(q),H=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return [!0,!0,!0,!0]},e.prototype.set=function(t){var e=this.current;(t[0]!==e[0]||t[1]!==e[1]||t[2]!==e[2]||t[3]!==e[3]||this.dirty)&&(this.gl.colorMask(t[0],t[1],t[2],t[3]),this.current=t,this.dirty=!1);},e}(q),K=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return !0},e.prototype.set=function(t){(t!==this.current||this.dirty)&&(this.gl.depthMask(t),this.current=t,this.dirty=!1);},e}(q),Y=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return 255},e.prototype.set=function(t){(t!==this.current||this.dirty)&&(this.gl.stencilMask(t),this.current=t,this.dirty=!1);},e}(q),J=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return {func:this.gl.ALWAYS,ref:0,mask:255}},e.prototype.set=function(t){var e=this.current;(t.func!==e.func||t.ref!==e.ref||t.mask!==e.mask||this.dirty)&&(this.gl.stencilFunc(t.func,t.ref,t.mask),this.current=t,this.dirty=!1);},e}(q),Q=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){var t=this.gl;return [t.KEEP,t.KEEP,t.KEEP]},e.prototype.set=function(t){var e=this.current;(t[0]!==e[0]||t[1]!==e[1]||t[2]!==e[2]||this.dirty)&&(this.gl.stencilOp(t[0],t[1],t[2]),this.current=t,this.dirty=!1);},e}(q),$=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return !1},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;t?e.enable(e.STENCIL_TEST):e.disable(e.STENCIL_TEST),this.current=t,this.dirty=!1;}},e}(q),tt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return [0,1]},e.prototype.set=function(t){var e=this.current;(t[0]!==e[0]||t[1]!==e[1]||this.dirty)&&(this.gl.depthRange(t[0],t[1]),this.current=t,this.dirty=!1);},e}(q),et=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return !1},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;t?e.enable(e.DEPTH_TEST):e.disable(e.DEPTH_TEST),this.current=t,this.dirty=!1;}},e}(q),it=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return this.gl.LESS},e.prototype.set=function(t){(t!==this.current||this.dirty)&&(this.gl.depthFunc(t),this.current=t,this.dirty=!1);},e}(q),ot=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return !1},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;t?e.enable(e.BLEND):e.disable(e.BLEND),this.current=t,this.dirty=!1;}},e}(q),rt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){var t=this.gl;return [t.ONE,t.ZERO]},e.prototype.set=function(t){var e=this.current;(t[0]!==e[0]||t[1]!==e[1]||this.dirty)&&(this.gl.blendFunc(t[0],t[1]),this.current=t,this.dirty=!1);},e}(q),at=function(e){function i(){e.apply(this,arguments);}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.getDefault=function(){return t.Color.transparent},i.prototype.set=function(t){var e=this.current;(t.r!==e.r||t.g!==e.g||t.b!==e.b||t.a!==e.a||this.dirty)&&(this.gl.blendColor(t.r,t.g,t.b,t.a),this.current=t,this.dirty=!1);},i}(q),nt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return this.gl.FUNC_ADD},e.prototype.set=function(t){(t!==this.current||this.dirty)&&(this.gl.blendEquation(t),this.current=t,this.dirty=!1);},e}(q),st=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return !1},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;t?e.enable(e.CULL_FACE):e.disable(e.CULL_FACE),this.current=t,this.dirty=!1;}},e}(q),lt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return this.gl.BACK},e.prototype.set=function(t){(t!==this.current||this.dirty)&&(this.gl.cullFace(t),this.current=t,this.dirty=!1);},e}(q),ct=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return this.gl.CCW},e.prototype.set=function(t){(t!==this.current||this.dirty)&&(this.gl.frontFace(t),this.current=t,this.dirty=!1);},e}(q),ht=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return null},e.prototype.set=function(t){(t!==this.current||this.dirty)&&(this.gl.useProgram(t),this.current=t,this.dirty=!1);},e}(q),ut=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return this.gl.TEXTURE0},e.prototype.set=function(t){(t!==this.current||this.dirty)&&(this.gl.activeTexture(t),this.current=t,this.dirty=!1);},e}(q),pt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){var t=this.gl;return [0,0,t.drawingBufferWidth,t.drawingBufferHeight]},e.prototype.set=function(t){var e=this.current;(t[0]!==e[0]||t[1]!==e[1]||t[2]!==e[2]||t[3]!==e[3]||this.dirty)&&(this.gl.viewport(t[0],t[1],t[2],t[3]),this.current=t,this.dirty=!1);},e}(q),dt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return null},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;e.bindFramebuffer(e.FRAMEBUFFER,t),this.current=t,this.dirty=!1;}},e}(q),_t=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return null},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;e.bindRenderbuffer(e.RENDERBUFFER,t),this.current=t,this.dirty=!1;}},e}(q),ft=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return null},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;e.bindTexture(e.TEXTURE_2D,t),this.current=t,this.dirty=!1;}},e}(q),mt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return null},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;e.bindBuffer(e.ARRAY_BUFFER,t),this.current=t,this.dirty=!1;}},e}(q),gt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return null},e.prototype.set=function(t){var e=this.gl;e.bindBuffer(e.ELEMENT_ARRAY_BUFFER,t),this.current=t,this.dirty=!1;},e}(q),vt=function(t){function e(e){t.call(this,e),this.vao=e.extVertexArrayObject;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return null},e.prototype.set=function(t){this.vao&&(t!==this.current||this.dirty)&&(this.vao.bindVertexArrayOES(t),this.current=t,this.dirty=!1);},e}(q),yt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return 4},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;e.pixelStorei(e.UNPACK_ALIGNMENT,t),this.current=t,this.dirty=!1;}},e}(q),xt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return !1},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;e.pixelStorei(e.UNPACK_PREMULTIPLY_ALPHA_WEBGL,t),this.current=t,this.dirty=!1;}},e}(q),bt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return !1},e.prototype.set=function(t){if(t!==this.current||this.dirty){var e=this.gl;e.pixelStorei(e.UNPACK_FLIP_Y_WEBGL,t),this.current=t,this.dirty=!1;}},e}(q),wt=function(t){function e(e,i){t.call(this,e),this.context=e,this.parent=i;}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.getDefault=function(){return null},e}(q),Et=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.setDirty=function(){this.dirty=!0;},e.prototype.set=function(t){if(t!==this.current||this.dirty){this.context.bindFramebuffer.set(this.parent);var e=this.gl;e.framebufferTexture2D(e.FRAMEBUFFER,e.COLOR_ATTACHMENT0,e.TEXTURE_2D,t,0),this.current=t,this.dirty=!1;}},e}(wt),Tt=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.set=function(t){if(t!==this.current||this.dirty){this.context.bindFramebuffer.set(this.parent);var e=this.gl;e.framebufferRenderbuffer(e.FRAMEBUFFER,e.DEPTH_ATTACHMENT,e.RENDERBUFFER,t),this.current=t,this.dirty=!1;}},e}(wt),St=function(t,e,i,o){this.context=t,this.width=e,this.height=i;var r=this.framebuffer=t.gl.createFramebuffer();this.colorAttachment=new Et(t,r),o&&(this.depthAttachment=new Tt(t,r));};St.prototype.destroy=function(){var t=this.context.gl,e=this.colorAttachment.get();if(e&&t.deleteTexture(e),this.depthAttachment){var i=this.depthAttachment.get();i&&t.deleteRenderbuffer(i);}t.deleteFramebuffer(this.framebuffer);};var It=function(t,e,i){this.func=t,this.mask=e,this.range=i;};It.ReadOnly=!1,It.ReadWrite=!0,It.disabled=new It(519,It.ReadOnly,[0,1]);var Pt=function(t,e,i,o,r,a){this.test=t,this.ref=e,this.mask=i,this.fail=o,this.depthFail=r,this.pass=a;};Pt.disabled=new Pt({func:519,mask:0},0,0,7680,7680,7680);var Ct=function(t,e,i){this.blendFunction=t,this.blendColor=e,this.mask=i;};Ct.disabled=new Ct(Ct.Replace=[1,0],t.Color.transparent,[!1,!1,!1,!1]),Ct.unblended=new Ct(Ct.Replace,t.Color.transparent,[!0,!0,!0,!0]),Ct.alphaBlended=new Ct([1,771],t.Color.transparent,[!0,!0,!0,!0]);var zt=function(t,e,i){this.enable=t,this.mode=e,this.frontFace=i;};zt.disabled=new zt(!1,1029,2305),zt.backCCW=new zt(!0,1029,2305);var Mt=function(t){this.gl=t,this.extVertexArrayObject=this.gl.getExtension("OES_vertex_array_object"),this.clearColor=new V(this),this.clearDepth=new W(this),this.clearStencil=new X(this),this.colorMask=new H(this),this.depthMask=new K(this),this.stencilMask=new Y(this),this.stencilFunc=new J(this),this.stencilOp=new Q(this),this.stencilTest=new $(this),this.depthRange=new tt(this),this.depthTest=new et(this),this.depthFunc=new it(this),this.blend=new ot(this),this.blendFunc=new rt(this),this.blendColor=new at(this),this.blendEquation=new nt(this),this.cullFace=new st(this),this.cullFaceSide=new lt(this),this.frontFace=new ct(this),this.program=new ht(this),this.activeTexture=new ut(this),this.viewport=new pt(this),this.bindFramebuffer=new dt(this),this.bindRenderbuffer=new _t(this),this.bindTexture=new ft(this),this.bindVertexBuffer=new mt(this),this.bindElementBuffer=new gt(this),this.bindVertexArrayOES=this.extVertexArrayObject&&new vt(this),this.pixelStoreUnpack=new yt(this),this.pixelStoreUnpackPremultiplyAlpha=new xt(this),this.pixelStoreUnpackFlipY=new bt(this),this.extTextureFilterAnisotropic=t.getExtension("EXT_texture_filter_anisotropic")||t.getExtension("MOZ_EXT_texture_filter_anisotropic")||t.getExtension("WEBKIT_EXT_texture_filter_anisotropic"),this.extTextureFilterAnisotropic&&(this.extTextureFilterAnisotropicMax=t.getParameter(this.extTextureFilterAnisotropic.MAX_TEXTURE_MAX_ANISOTROPY_EXT)),this.extTextureHalfFloat=t.getExtension("OES_texture_half_float"),this.extTextureHalfFloat&&(t.getExtension("OES_texture_half_float_linear"),this.extRenderToTextureHalfFloat=t.getExtension("EXT_color_buffer_half_float")),this.extTimerQuery=t.getExtension("EXT_disjoint_timer_query"),this.maxTextureSize=t.getParameter(t.MAX_TEXTURE_SIZE);};Mt.prototype.setDefault=function(){this.unbindVAO(),this.clearColor.setDefault(),this.clearDepth.setDefault(),this.clearStencil.setDefault(),this.colorMask.setDefault(),this.depthMask.setDefault(),this.stencilMask.setDefault(),this.stencilFunc.setDefault(),this.stencilOp.setDefault(),this.stencilTest.setDefault(),this.depthRange.setDefault(),this.depthTest.setDefault(),this.depthFunc.setDefault(),this.blend.setDefault(),this.blendFunc.setDefault(),this.blendColor.setDefault(),this.blendEquation.setDefault(),this.cullFace.setDefault(),this.cullFaceSide.setDefault(),this.frontFace.setDefault(),this.program.setDefault(),this.activeTexture.setDefault(),this.bindFramebuffer.setDefault(),this.pixelStoreUnpack.setDefault(),this.pixelStoreUnpackPremultiplyAlpha.setDefault(),this.pixelStoreUnpackFlipY.setDefault();},Mt.prototype.setDirty=function(){this.clearColor.dirty=!0,this.clearDepth.dirty=!0,this.clearStencil.dirty=!0,this.colorMask.dirty=!0,this.depthMask.dirty=!0,this.stencilMask.dirty=!0,this.stencilFunc.dirty=!0,this.stencilOp.dirty=!0,this.stencilTest.dirty=!0,this.depthRange.dirty=!0,this.depthTest.dirty=!0,this.depthFunc.dirty=!0,this.blend.dirty=!0,this.blendFunc.dirty=!0,this.blendColor.dirty=!0,this.blendEquation.dirty=!0,this.cullFace.dirty=!0,this.cullFaceSide.dirty=!0,this.frontFace.dirty=!0,this.program.dirty=!0,this.activeTexture.dirty=!0,this.viewport.dirty=!0,this.bindFramebuffer.dirty=!0,this.bindRenderbuffer.dirty=!0,this.bindTexture.dirty=!0,this.bindVertexBuffer.dirty=!0,this.bindElementBuffer.dirty=!0,this.extVertexArrayObject&&(this.bindVertexArrayOES.dirty=!0),this.pixelStoreUnpack.dirty=!0,this.pixelStoreUnpackPremultiplyAlpha.dirty=!0,this.pixelStoreUnpackFlipY.dirty=!0;},Mt.prototype.createIndexBuffer=function(t,e){return new j(this,t,e)},Mt.prototype.createVertexBuffer=function(t,e,i){return new Z(this,t,e,i)},Mt.prototype.createRenderbuffer=function(t,e,i){var o=this.gl,r=o.createRenderbuffer();return this.bindRenderbuffer.set(r),o.renderbufferStorage(o.RENDERBUFFER,t,e,i),this.bindRenderbuffer.set(null),r},Mt.prototype.createFramebuffer=function(t,e,i){return new St(this,t,e,i)},Mt.prototype.clear=function(t){var e=t.color,i=t.depth,o=this.gl,r=0;e&&(r|=o.COLOR_BUFFER_BIT,this.clearColor.set(e),this.colorMask.set([!0,!0,!0,!0])),void 0!==i&&(r|=o.DEPTH_BUFFER_BIT,this.depthRange.set([0,1]),this.clearDepth.set(i),this.depthMask.set(!0)),o.clear(r);},Mt.prototype.setCullFace=function(t){!1===t.enable?this.cullFace.set(!1):(this.cullFace.set(!0),this.cullFaceSide.set(t.mode),this.frontFace.set(t.frontFace));},Mt.prototype.setDepthMode=function(t){t.func!==this.gl.ALWAYS||t.mask?(this.depthTest.set(!0),this.depthFunc.set(t.func),this.depthMask.set(t.mask),this.depthRange.set(t.range)):this.depthTest.set(!1);},Mt.prototype.setStencilMode=function(t){t.test.func!==this.gl.ALWAYS||t.mask?(this.stencilTest.set(!0),this.stencilMask.set(t.mask),this.stencilOp.set([t.fail,t.depthFail,t.pass]),this.stencilFunc.set({func:t.test.func,ref:t.ref,mask:t.test.mask})):this.stencilTest.set(!1);},Mt.prototype.setColorMode=function(e){t.deepEqual(e.blendFunction,Ct.Replace)?this.blend.set(!1):(this.blend.set(!0),this.blendFunc.set(e.blendFunction),this.blendColor.set(e.blendColor)),this.colorMask.set(e.mask);},Mt.prototype.unbindVAO=function(){this.extVertexArrayObject&&this.bindVertexArrayOES.set(null);};var Lt=function(e){function i(i,o,r){var a=this;e.call(this),this.id=i,this.dispatcher=r,this.on("data",(function(t){"source"===t.dataType&&"metadata"===t.sourceDataType&&(a._sourceLoaded=!0),a._sourceLoaded&&!a._paused&&"source"===t.dataType&&"content"===t.sourceDataType&&(a.reload(),a.transform&&a.update(a.transform));})),this.on("error",(function(){a._sourceErrored=!0;})),this._source=function(e,i,o,r){var a=new O[i.type](e,i,o,r);if(a.id!==e)throw new Error("Expected Source id to be "+e+" instead of "+a.id);return t.bindAll(["load","abort","unload","serialize","prepare"],a),a}(i,o,r,this),this._tiles={},this._cache=new N(0,this._unloadTile.bind(this)),this._timers={},this._cacheTimers={},this._maxTileCacheSize=null,this._loadedParentTiles={},this._coveredTiles={},this._state=new t.SourceFeatureState;}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.onAdd=function(t){this.map=t,this._maxTileCacheSize=t?t._maxTileCacheSize:null,this._source&&this._source.onAdd&&this._source.onAdd(t);},i.prototype.onRemove=function(t){this._source&&this._source.onRemove&&this._source.onRemove(t);},i.prototype.loaded=function(){if(this._sourceErrored)return !0;if(!this._sourceLoaded)return !1;if(!this._source.loaded())return !1;for(var t in this._tiles){var e=this._tiles[t];if("loaded"!==e.state&&"errored"!==e.state)return !1}return !0},i.prototype.getSource=function(){return this._source},i.prototype.pause=function(){this._paused=!0;},i.prototype.resume=function(){if(this._paused){var t=this._shouldReloadOnResume;this._paused=!1,this._shouldReloadOnResume=!1,t&&this.reload(),this.transform&&this.update(this.transform);}},i.prototype._loadTile=function(t,e){return this._source.loadTile(t,e)},i.prototype._unloadTile=function(t){if(this._source.unloadTile)return this._source.unloadTile(t,(function(){}))},i.prototype._abortTile=function(t){if(this._source.abortTile)return this._source.abortTile(t,(function(){}))},i.prototype.serialize=function(){return this._source.serialize()},i.prototype.prepare=function(t){for(var e in this._source.prepare&&this._source.prepare(),this._state.coalesceChanges(this._tiles,this.map?this.map.painter:null),this._tiles){var i=this._tiles[e];i.upload(t),i.prepare(this.map.style.imageManagerFactory._getImageManager(this.id));}},i.prototype.getIds=function(){return t.values(this._tiles).map((function(t){return t.tileID})).sort(Dt).map((function(t){return t.key}))},i.prototype.getRenderableIds=function(e){var i=this,o=[];for(var r in this._tiles)this._isIdRenderable(r,e)&&o.push(this._tiles[r]);return e?o.sort((function(e,o){var r=e.tileID,a=o.tileID,n=new t.Point(r.canonical.x,r.canonical.y)._rotate(i.transform.angle),s=new t.Point(a.canonical.x,a.canonical.y)._rotate(i.transform.angle);return r.overscaledZ-a.overscaledZ||s.y-n.y||s.x-n.x})).map((function(t){return t.tileID.key})):o.map((function(t){return t.tileID})).sort(Dt).map((function(t){return t.key}))},i.prototype.hasRenderableParent=function(t){var e=this.findLoadedParent(t,0);return !!e&&this._isIdRenderable(e.tileID.key)},i.prototype._isIdRenderable=function(t,e){return this._tiles[t]&&this._tiles[t].hasData()&&!this._coveredTiles[t]&&(e||!this._tiles[t].holdingForFade())},i.prototype.reload=function(){if(this._paused)this._shouldReloadOnResume=!0;else for(var t in this._cache.reset(),this._tiles)"errored"!==this._tiles[t].state&&this._reloadTile(t,"reloading");},i.prototype._reloadTile=function(t,e){var i=this._tiles[t];i&&("loading"!==i.state&&(i.state=e),this._loadTile(i,this._tileLoaded.bind(this,i,t,e)));},i.prototype._tileLoaded=function(e,i,o,r){if(r)return e.state="errored",void(404!==r.status?this._source.fire(new t.ErrorEvent(r,{tile:e})):this.update(this.transform));e.timeAdded=t.browser.now(),"expired"===o&&(e.refreshedUponExpiration=!0),this._setTileReloadTimer(i,e),"raster-dem"===this.getSource().type&&e.dem&&this._backfillDEM(e),this._state.initializeTileState(e,this.map?this.map.painter:null),this._source.fire(new t.Event("data",{dataType:"source",tile:e,coord:e.tileID}));},i.prototype._backfillDEM=function(t){for(var e=this.getRenderableIds(),i=0;i<e.length;i++){var o=e[i];if(t.neighboringTiles&&t.neighboringTiles[o]){var r=this.getTileByID(o);a(t,r),a(r,t);}}function a(t,e){t.needsHillshadePrepare=!0;var i=e.tileID.canonical.x-t.tileID.canonical.x,o=e.tileID.canonical.y-t.tileID.canonical.y,r=Math.pow(2,t.tileID.canonical.z),a=e.tileID.key;0===i&&0===o||Math.abs(o)>1||(Math.abs(i)>1&&(1===Math.abs(i+r)?i+=r:1===Math.abs(i-r)&&(i-=r)),e.dem&&t.dem&&(t.dem.backfillBorder(e.dem,i,o),t.neighboringTiles&&t.neighboringTiles[a]&&(t.neighboringTiles[a].backfilled=!0)));}},i.prototype.getTile=function(t){return this.getTileByID(t.key)},i.prototype.getTileByID=function(t){return this._tiles[t]},i.prototype._retainLoadedChildren=function(t,e,i,o){for(var r in this._tiles){var a=this._tiles[r];if(!(o[r]||!a.hasData()||a.tileID.overscaledZ<=e||a.tileID.overscaledZ>i)){for(var n=a.tileID;a&&a.tileID.overscaledZ>e+1;){var s=a.tileID.scaledTo(a.tileID.overscaledZ-1);(a=this._tiles[s.key])&&a.hasData()&&(n=s);}for(var l=n;l.overscaledZ>e;)if(t[(l=l.scaledTo(l.overscaledZ-1)).key]){o[n.key]=n;break}}}},i.prototype.findLoadedParent=function(t,e){if(t.key in this._loadedParentTiles){var i=this._loadedParentTiles[t.key];return i&&i.tileID.overscaledZ>=e?i:null}for(var o=t.overscaledZ-1;o>=e;o--){var r=t.scaledTo(o),a=this._getLoadedTile(r);if(a)return a}},i.prototype._getLoadedTile=function(t){var e=this._tiles[t.key];return e&&e.hasData()?e:this._cache.getByKey(t.wrapped().key)},i.prototype.updateCacheSize=function(t){var e=Math.ceil(t.width/this._source.tileSize)+1,i=Math.ceil(t.height/this._source.tileSize)+1,o=Math.floor(e*i*5),r="number"==typeof this._maxTileCacheSize?Math.min(this._maxTileCacheSize,o):o;this._cache.setMaxSize(r);},i.prototype.handleWrapJump=function(t){var e=Math.round((t-(void 0===this._prevLng?t:this._prevLng))/360);if(this._prevLng=t,e){var i={};for(var o in this._tiles){var r=this._tiles[o];r.tileID=r.tileID.unwrapTo(r.tileID.wrap+e),i[r.tileID.key]=r;}for(var a in this._tiles=i,this._timers)clearTimeout(this._timers[a]),delete this._timers[a];for(var n in this._tiles)this._setTileReloadTimer(n,this._tiles[n]);}},i.prototype.update=function(e){var o=this;if(this.transform=e,this._sourceLoaded&&!this._paused){var r;this.updateCacheSize(e),this.handleWrapJump(this.transform.center.lng),this._coveredTiles={},this.used?this._source.tileID?r=e.getVisibleUnwrappedCoordinates(this._source.tileID).map((function(e){return new t.OverscaledTileID(e.canonical.z,e.wrap,e.canonical.z,e.canonical.x,e.canonical.y,o.indexExtent)})):(r=e.coveringTiles({tileSize:this._source.tileSize,minzoom:this._source.minzoom,maxzoom:this._source.maxzoom,roundZoom:this._source.roundZoom,reparseOverscaled:this._source.reparseOverscaled}),this._source.hasTile&&(r=r.filter((function(t){return o._source.hasTile(t)})))):r=[];var a=e.coveringZoomLevel(this._source),n=Math.max(a-i.maxOverzooming,this._source.minzoom),s=Math.max(a+i.maxUnderzooming,this._source.minzoom),l=this._updateRetainedTiles(r,a);if(Rt(this._source.type)){for(var c={},h={},u=0,p=Object.keys(l);u<p.length;u+=1){var d=p[u],_=l[d],f=this._tiles[d];if(f&&!(f.fadeEndTime&&f.fadeEndTime<=t.browser.now())){var m=this.findLoadedParent(_,n);m&&(this._addTile(m.tileID),c[m.tileID.key]=m.tileID),h[d]=_;}}for(var g in this._retainLoadedChildren(h,a,s,l),c)l[g]||(this._coveredTiles[g]=!0,l[g]=c[g]);}for(var v in l)this._tiles[v].clearFadeHold();for(var y=0,x=t.keysDifference(this._tiles,l);y<x.length;y+=1){var b=x[y],w=this._tiles[b];w.hasSymbolBuckets&&!w.holdingForFade()?w.setHoldDuration(this.map._fadeDuration):w.hasSymbolBuckets&&!w.symbolFadeFinished()||this._removeTile(b);}this._updateLoadedParentTileCache();}},i.prototype.releaseSymbolFadeTiles=function(){for(var t in this._tiles)this._tiles[t].holdingForFade()&&this._removeTile(t);},i.prototype._updateRetainedTiles=function(t,e){for(var o={},r={},a=Math.max(e-i.maxOverzooming,this._source.minzoom),n=Math.max(e+i.maxUnderzooming,this._source.minzoom),s={},l=0,c=t;l<c.length;l+=1){var h=c[l],u=this._addTile(h);o[h.key]=h,u.hasData()||e<this._source.maxzoom&&(s[h.key]=h);}this._retainLoadedChildren(s,e,n,o);for(var p=0,d=t;p<d.length;p+=1){var _=d[p],f=this._tiles[_.key];if(!f.hasData()){if(e+1>this._source.maxzoom){var m=_.children(this._source.maxzoom)[0],g=this.getTile(m);if(g&&g.hasData()){o[m.key]=m;continue}}else {var v=_.children(this._source.maxzoom);if(o[v[0].key]&&o[v[1].key]&&o[v[2].key]&&o[v[3].key])continue}for(var y=f.wasRequested(),x=_.overscaledZ-1;x>=a;--x){var b=_.scaledTo(x);if(r[b.key])break;if(r[b.key]=!0,!(f=this.getTile(b))&&y&&(f=this._addTile(b)),f&&(o[b.key]=b,y=f.wasRequested(),f.hasData()))break}}}return o},i.prototype._updateLoadedParentTileCache=function(){for(var t in this._loadedParentTiles={},this._tiles){for(var e=[],i=void 0,o=this._tiles[t].tileID;o.overscaledZ>0;){if(o.key in this._loadedParentTiles){i=this._loadedParentTiles[o.key];break}e.push(o.key);var r=o.scaledTo(o.overscaledZ-1);if(i=this._getLoadedTile(r))break;o=r;}for(var a=0,n=e;a<n.length;a+=1)this._loadedParentTiles[n[a]]=i;}},i.prototype._addTile=function(e){var i=this._tiles[e.key];if(i)return i;(i=this._cache.getAndRemove(e))&&(this._setTileReloadTimer(e.key,i),i.tileID=e,this._state.initializeTileState(i,this.map?this.map.painter:null),this._cacheTimers[e.key]&&(clearTimeout(this._cacheTimers[e.key]),delete this._cacheTimers[e.key],this._setTileReloadTimer(e.key,i)));var o=Boolean(i);return o||(i=new t.Tile(e,this._source.tileSize*e.overscaleFactor()),this._loadTile(i,this._tileLoaded.bind(this,i,e.key,i.state))),i?(i.uses++,this._tiles[e.key]=i,o||this._source.fire(new t.Event("dataloading",{tile:i,coord:i.tileID,dataType:"source"})),i):null},i.prototype._setTileReloadTimer=function(t,e){var i=this;t in this._timers&&(clearTimeout(this._timers[t]),delete this._timers[t]);var o=e.getExpiryTimeout();o&&(this._timers[t]=setTimeout((function(){i._reloadTile(t,"expired"),delete i._timers[t];}),o));},i.prototype._removeTile=function(t){var e=this._tiles[t];e&&(e.uses--,delete this._tiles[t],this._timers[t]&&(clearTimeout(this._timers[t]),delete this._timers[t]),e.uses>0||(e.hasData()&&"reloading"!==e.state?this._cache.add(e.tileID,e,e.getExpiryTimeout()):(e.aborted=!0,this._abortTile(e),this._unloadTile(e))));},i.prototype.clearTiles=function(){for(var t in this._shouldReloadOnResume=!1,this._paused=!1,this._tiles)this._removeTile(t);this._cache.reset();},i.prototype.tilesIn=function(e,i,o){var r=this,a=[],n=this.transform;if(!n)return a;for(var s=o?n.getCameraQueryGeometry(e):e,l=e.map((function(t){return n.pointCoordinate(t)})),c=s.map((function(t){return n.pointCoordinate(t)})),h=this.getIds(),u=1/0,p=1/0,d=-1/0,_=-1/0,f=0,m=c;f<m.length;f+=1){var g=m[f];u=Math.min(u,g.x),p=Math.min(p,g.y),d=Math.max(d,g.x),_=Math.max(_,g.y);}for(var v=function(e){var o=r._tiles[h[e]];if(!o.holdingForFade()){var s=o.tileID,f=Math.pow(2,n.zoom-o.tileID.overscaledZ),m=i*o.queryPadding*t.EXTENT/o.tileSize/f,g=[s.getTilePoint(new t.MercatorCoordinate(u,p)),s.getTilePoint(new t.MercatorCoordinate(d,_))];if(g[0].x-m<t.EXTENT&&g[0].y-m<t.EXTENT&&g[1].x+m>=0&&g[1].y+m>=0){var v=l.map((function(t){return s.getTilePoint(t)})),y=c.map((function(t){return s.getTilePoint(t)}));a.push({tile:o,tileID:s,queryGeometry:v,cameraQueryGeometry:y,scale:f});}}},y=0;y<h.length;y++)v(y);return a},i.prototype.getVisibleCoordinates=function(t){for(var e=this,i=this.getRenderableIds(t).map((function(t){return e._tiles[t].tileID})),o=0,r=i;o<r.length;o+=1){var a=r[o];a.posMatrix=this.transform.calculatePosMatrix(a.toUnwrapped());}return i},i.prototype.hasTransition=function(){if(this._source.hasTransition())return !0;if(Rt(this._source.type))for(var e in this._tiles){var i=this._tiles[e];if(void 0!==i.fadeEndTime&&i.fadeEndTime>=t.browser.now())return !0}return !1},i.prototype.setFeatureState=function(t,e,i){this._state.updateState(t=t||"_geojsonTileLayer",e,i);},i.prototype.removeFeatureState=function(t,e,i){this._state.removeFeatureState(t=t||"_geojsonTileLayer",e,i);},i.prototype.getFeatureState=function(t,e){return this._state.getState(t=t||"_geojsonTileLayer",e)},i.prototype.setDependencies=function(t,e,i){var o=this._tiles[t];o&&o.setDependencies(e,i);},i.prototype.reloadTilesForDependencies=function(t,e){for(var i in this._tiles)this._tiles[i].hasDependency(t,e)&&this._reloadTile(i,"reloading");this._cache.filter((function(i){return !i.hasDependency(t,e)}));},i}(t.Evented);function Dt(t,e){var i=Math.abs(2*t.wrap)-+(t.wrap<0),o=Math.abs(2*e.wrap)-+(e.wrap<0);return t.overscaledZ-e.overscaledZ||o-i||e.canonical.y-t.canonical.y||e.canonical.x-t.canonical.x}function Rt(t){return "raster"===t||"image"===t||"video"===t}function At(){return new t.window.Worker(Qr.workerUrl)}Lt.maxOverzooming=10,Lt.maxUnderzooming=3;var kt="mapboxgl_preloaded_worker_pool",Ot=function(){this.active={};};Ot.prototype.acquire=function(t){if(!this.workers)for(this.workers=[];this.workers.length<Ot.workerCount;)this.workers.push(new At);return this.active[t]=!0,this.workers.slice()},Ot.prototype.release=function(t){delete this.active[t],0===this.numActive()&&(this.workers.forEach((function(t){t.terminate();})),this.workers=null);},Ot.prototype.isPreloaded=function(){return !!this.active[kt]},Ot.prototype.numActive=function(){return Object.keys(this.active).length};var Bt,Ft=Math.floor(t.browser.hardwareConcurrency/2);function Ut(){return Bt||(Bt=new Ot),Bt}function Nt(e,i){var o={};for(var r in e)"ref"!==r&&(o[r]=e[r]);return t.refProperties.forEach((function(t){t in i&&(o[t]=i[t]);})),o}function jt(t){t=t.slice();for(var e=Object.create(null),i=0;i<t.length;i++)e[t[i].id]=t[i];for(var o=0;o<t.length;o++)"ref"in t[o]&&(t[o]=Nt(t[o],e[t[o].ref]));return t}Ot.workerCount=Math.max(Math.min(Ft,6),1);var Gt={setStyle:"setStyle",addLayer:"addLayer",removeLayer:"removeLayer",setPaintProperty:"setPaintProperty",setLayoutProperty:"setLayoutProperty",setFilter:"setFilter",addSource:"addSource",removeSource:"removeSource",setGeoJSONSourceData:"setGeoJSONSourceData",setLayerZoomRange:"setLayerZoomRange",setLayerProperty:"setLayerProperty",setCenter:"setCenter",setZoom:"setZoom",setBearing:"setBearing",setPitch:"setPitch",setSprite:"setSprite",setGlyphs:"setGlyphs",setTransition:"setTransition",setLight:"setLight"};function Zt(t,e,i){i.push({command:Gt.addSource,args:[t,e[t]]});}function qt(t,e,i){e.push({command:Gt.removeSource,args:[t]}),i[t]=!0;}function Vt(t,e,i,o){qt(t,i,o),Zt(t,e,i);}function Wt(e,i,o){var r;for(r in e[o])if(e[o].hasOwnProperty(r)&&"data"!==r&&!t.deepEqual(e[o][r],i[o][r]))return !1;for(r in i[o])if(i[o].hasOwnProperty(r)&&"data"!==r&&!t.deepEqual(e[o][r],i[o][r]))return !1;return !0}function Xt(e,i,o,r,a,n){var s;for(s in i=i||{},e=e||{})e.hasOwnProperty(s)&&(t.deepEqual(e[s],i[s])||o.push({command:n,args:[r,s,i[s],a]}));for(s in i)i.hasOwnProperty(s)&&!e.hasOwnProperty(s)&&(t.deepEqual(e[s],i[s])||o.push({command:n,args:[r,s,i[s],a]}));}function Ht(t){return t.id}function Kt(t,e){return t[e.id]=e,t}var Yt=function(t,e){this.reset(t,e);};Yt.prototype.reset=function(t,e){this.points=t||[],this._distances=[0];for(var i=1;i<this.points.length;i++)this._distances[i]=this._distances[i-1]+this.points[i].dist(this.points[i-1]);this.length=this._distances[this._distances.length-1],this.padding=Math.min(e||0,.5*this.length),this.paddedLength=this.length-2*this.padding;},Yt.prototype.lerp=function(e){if(1===this.points.length)return this.points[0];e=t.clamp(e,0,1);for(var i=1,o=this._distances[i],r=e*this.paddedLength+this.padding;o<r&&i<this._distances.length;)o=this._distances[++i];var a=i-1,n=this._distances[a],s=o-n,l=s>0?(r-n)/s:0;return this.points[a].mult(1-l).add(this.points[i].mult(l))};var Jt=function(t,e,i){var o=this.boxCells=[],r=this.circleCells=[];this.xCellCount=Math.ceil(t/i),this.yCellCount=Math.ceil(e/i);for(var a=0;a<this.xCellCount*this.yCellCount;a++)o.push([]),r.push([]);this.circleKeys=[],this.boxKeys=[],this.bboxes=[],this.circles=[],this.width=t,this.height=e,this.xScale=this.xCellCount/t,this.yScale=this.yCellCount/e,this.boxUid=0,this.circleUid=0;};function Qt(e,i,o,r,a){var n=t.create();return i?(t.scale(n,n,[1/a,1/a,1]),o||t.rotateZ(n,n,r.angle)):t.multiply(n,r.labelPlaneMatrix,e),n}function $t(e,i,o,r,a){if(i){var n=t.clone(e);return t.scale(n,n,[a,a,1]),o||t.rotateZ(n,n,-r.angle),n}return r.glCoordMatrix}function te(e,i){var o=[e.x,e.y,0,1];ue(o,o,i);var r=o[3];return {point:new t.Point(o[0]/r,o[1]/r),signedDistanceFromCamera:r}}function ee(t,e){return .5+t/e*.5}function ie(t,e){var i=t[0]/t[3],o=t[1]/t[3];return i>=-e[0]&&i<=e[0]&&o>=-e[1]&&o<=e[1]}function oe(e,i,o,r,a,n,s,l){var c=r?e.textSizeData:e.iconSizeData,h=t.evaluateSizeForZoom(c,o.transform.zoom),u=[256/o.width*2+1,256/o.height*2+1],p=r?e.text.dynamicLayoutVertexArray:e.icon.dynamicLayoutVertexArray;p.clear();for(var d=e.lineVertexArray,_=r?e.text.placedSymbolArray:e.icon.placedSymbolArray,f=o.transform.width/o.transform.height,m=!1,g=0;g<_.length;g++){var v=_.get(g);if(v.hidden||v.writingMode===t.WritingMode.vertical&&!m)he(v.numGlyphs,p);else {m=!1;var y=[v.anchorX,v.anchorY,0,1];if(t.transformMat4(y,y,i),ie(y,u)){var x=ee(o.transform.cameraToCenterDistance,y[3]),b=t.evaluateSizeForFeature(c,h,v),w=s?b/x:b*x,E=new t.Point(v.anchorX,v.anchorY),T=te(E,a).point,S={},I=ne(v,w,!1,l,i,a,n,e.glyphOffsetArray,d,p,T,E,S,f);m=I.useVertical,(I.notEnoughRoom||m||I.needsFlipping&&ne(v,w,!0,l,i,a,n,e.glyphOffsetArray,d,p,T,E,S,f).notEnoughRoom)&&he(v.numGlyphs,p);}else he(v.numGlyphs,p);}}r?e.text.dynamicLayoutVertexBuffer.updateData(p):e.icon.dynamicLayoutVertexBuffer.updateData(p);}function re(t,e,i,o,r,a,n,s,l,c,h){var u=s.glyphStartIndex+s.numGlyphs,p=s.lineStartIndex,d=s.lineStartIndex+s.lineLength,_=e.getoffsetX(s.glyphStartIndex),f=e.getoffsetX(u-1),m=le(t*_,i,o,r,a,n,s.segment,p,d,l,c,h);if(!m)return null;var g=le(t*f,i,o,r,a,n,s.segment,p,d,l,c,h);return g?{first:m,last:g}:null}function ae(e,i,o,r){return e===t.WritingMode.horizontal&&Math.abs(o.y-i.y)>Math.abs(o.x-i.x)*r?{useVertical:!0}:(e===t.WritingMode.vertical?i.y<o.y:i.x>o.x)?{needsFlipping:!0}:null}function ne(e,i,o,r,a,n,s,l,c,h,u,p,d,_){var f,m=i/24,g=e.lineOffsetX*m,v=e.lineOffsetY*m;if(e.numGlyphs>1){var y=e.glyphStartIndex+e.numGlyphs,x=e.lineStartIndex,b=e.lineStartIndex+e.lineLength,w=re(m,l,g,v,o,u,p,e,c,n,d);if(!w)return {notEnoughRoom:!0};var E=te(w.first.point,s).point,T=te(w.last.point,s).point;if(r&&!o){var S=ae(e.writingMode,E,T,_);if(S)return S}f=[w.first];for(var I=e.glyphStartIndex+1;I<y-1;I++)f.push(le(m*l.getoffsetX(I),g,v,o,u,p,e.segment,x,b,c,n,d));f.push(w.last);}else {if(r&&!o){var P=te(p,a).point,C=e.lineStartIndex+e.segment+1,z=new t.Point(c.getx(C),c.gety(C)),M=te(z,a),L=M.signedDistanceFromCamera>0?M.point:se(p,z,P,1,a),D=ae(e.writingMode,P,L,_);if(D)return D}var R=le(m*l.getoffsetX(e.glyphStartIndex),g,v,o,u,p,e.segment,e.lineStartIndex,e.lineStartIndex+e.lineLength,c,n,d);if(!R)return {notEnoughRoom:!0};f=[R];}for(var A=0,k=f;A<k.length;A+=1){var O=k[A];t.addDynamicAttributes(h,O.point,O.angle);}return {}}function se(t,e,i,o,r){var a=te(t.add(t.sub(e)._unit()),r).point,n=i.sub(a);return i.add(n._mult(o/n.mag()))}function le(e,i,o,r,a,n,s,l,c,h,u,p){var d=r?e-i:e+i,_=d>0?1:-1,f=0;r&&(_*=-1,f=Math.PI),_<0&&(f+=Math.PI);for(var m=_>0?l+s:l+s+1,g=a,v=a,y=0,x=0,b=Math.abs(d),w=[];y+x<=b;){if((m+=_)<l||m>=c)return null;if(v=g,w.push(g),void 0===(g=p[m])){var E=new t.Point(h.getx(m),h.gety(m)),T=te(E,u);if(T.signedDistanceFromCamera>0)g=p[m]=T.point;else {var S=m-_;g=se(0===y?n:new t.Point(h.getx(S),h.gety(S)),E,v,b-y+1,u);}}y+=x,x=v.dist(g);}var I=(b-y)/x,P=g.sub(v),C=P.mult(I)._add(v);C._add(P._unit()._perp()._mult(o*_));var z=f+Math.atan2(g.y-v.y,g.x-v.x);return w.push(C),{point:C,angle:z,path:w}}Jt.prototype.keysLength=function(){return this.boxKeys.length+this.circleKeys.length},Jt.prototype.insert=function(t,e,i,o,r){this._forEachCell(e,i,o,r,this._insertBoxCell,this.boxUid++),this.boxKeys.push(t),this.bboxes.push(e),this.bboxes.push(i),this.bboxes.push(o),this.bboxes.push(r);},Jt.prototype.insertCircle=function(t,e,i,o){this._forEachCell(e-o,i-o,e+o,i+o,this._insertCircleCell,this.circleUid++),this.circleKeys.push(t),this.circles.push(e),this.circles.push(i),this.circles.push(o);},Jt.prototype._insertBoxCell=function(t,e,i,o,r,a){this.boxCells[r].push(a);},Jt.prototype._insertCircleCell=function(t,e,i,o,r,a){this.circleCells[r].push(a);},Jt.prototype._query=function(t,e,i,o,r,a){if(i<0||t>this.width||o<0||e>this.height)return !r&&[];var n=[];if(t<=0&&e<=0&&this.width<=i&&this.height<=o){if(r)return !0;for(var s=0;s<this.boxKeys.length;s++)n.push({key:this.boxKeys[s],x1:this.bboxes[4*s],y1:this.bboxes[4*s+1],x2:this.bboxes[4*s+2],y2:this.bboxes[4*s+3]});for(var l=0;l<this.circleKeys.length;l++){var c=this.circles[3*l],h=this.circles[3*l+1],u=this.circles[3*l+2];n.push({key:this.circleKeys[l],x1:c-u,y1:h-u,x2:c+u,y2:h+u});}return a?n.filter(a):n}return this._forEachCell(t,e,i,o,this._queryCell,n,{hitTest:r,seenUids:{box:{},circle:{}}},a),r?n.length>0:n},Jt.prototype._queryCircle=function(t,e,i,o,r){var a=t-i,n=t+i,s=e-i,l=e+i;if(n<0||a>this.width||l<0||s>this.height)return !o&&[];var c=[];return this._forEachCell(a,s,n,l,this._queryCellCircle,c,{hitTest:o,circle:{x:t,y:e,radius:i},seenUids:{box:{},circle:{}}},r),o?c.length>0:c},Jt.prototype.query=function(t,e,i,o,r){return this._query(t,e,i,o,!1,r)},Jt.prototype.hitTest=function(t,e,i,o,r){return this._query(t,e,i,o,!0,r)},Jt.prototype.hitTestCircle=function(t,e,i,o){return this._queryCircle(t,e,i,!0,o)},Jt.prototype._queryCell=function(t,e,i,o,r,a,n,s){var l=n.seenUids,c=this.boxCells[r];if(null!==c)for(var h=this.bboxes,u=0,p=c;u<p.length;u+=1){var d=p[u];if(!l.box[d]){l.box[d]=!0;var _=4*d;if(t<=h[_+2]&&e<=h[_+3]&&i>=h[_+0]&&o>=h[_+1]&&(!s||s(this.boxKeys[d]))){if(n.hitTest)return a.push(!0),!0;a.push({key:this.boxKeys[d],x1:h[_],y1:h[_+1],x2:h[_+2],y2:h[_+3]});}}}var f=this.circleCells[r];if(null!==f)for(var m=this.circles,g=0,v=f;g<v.length;g+=1){var y=v[g];if(!l.circle[y]){l.circle[y]=!0;var x=3*y;if(this._circleAndRectCollide(m[x],m[x+1],m[x+2],t,e,i,o)&&(!s||s(this.circleKeys[y]))){if(n.hitTest)return a.push(!0),!0;var b=m[x],w=m[x+1],E=m[x+2];a.push({key:this.circleKeys[y],x1:b-E,y1:w-E,x2:b+E,y2:w+E});}}}},Jt.prototype._queryCellCircle=function(t,e,i,o,r,a,n,s){var l=n.circle,c=n.seenUids,h=this.boxCells[r];if(null!==h)for(var u=this.bboxes,p=0,d=h;p<d.length;p+=1){var _=d[p];if(!c.box[_]){c.box[_]=!0;var f=4*_;if(this._circleAndRectCollide(l.x,l.y,l.radius,u[f+0],u[f+1],u[f+2],u[f+3])&&(!s||s(this.boxKeys[_])))return a.push(!0),!0}}var m=this.circleCells[r];if(null!==m)for(var g=this.circles,v=0,y=m;v<y.length;v+=1){var x=y[v];if(!c.circle[x]){c.circle[x]=!0;var b=3*x;if(this._circlesCollide(g[b],g[b+1],g[b+2],l.x,l.y,l.radius)&&(!s||s(this.circleKeys[x])))return a.push(!0),!0}}},Jt.prototype._forEachCell=function(t,e,i,o,r,a,n,s){for(var l=this._convertToXCellCoord(t),c=this._convertToYCellCoord(e),h=this._convertToXCellCoord(i),u=this._convertToYCellCoord(o),p=l;p<=h;p++)for(var d=c;d<=u;d++)if(r.call(this,t,e,i,o,this.xCellCount*d+p,a,n,s))return},Jt.prototype._convertToXCellCoord=function(t){return Math.max(0,Math.min(this.xCellCount-1,Math.floor(t*this.xScale)))},Jt.prototype._convertToYCellCoord=function(t){return Math.max(0,Math.min(this.yCellCount-1,Math.floor(t*this.yScale)))},Jt.prototype._circlesCollide=function(t,e,i,o,r,a){var n=o-t,s=r-e,l=i+a;return l*l>n*n+s*s},Jt.prototype._circleAndRectCollide=function(t,e,i,o,r,a,n){var s=(a-o)/2,l=Math.abs(t-(o+s));if(l>s+i)return !1;var c=(n-r)/2,h=Math.abs(e-(r+c));if(h>c+i)return !1;if(l<=s||h<=c)return !0;var u=l-s,p=h-c;return u*u+p*p<=i*i};var ce=new Float32Array([-1/0,-1/0,0,-1/0,-1/0,0,-1/0,-1/0,0,-1/0,-1/0,0]);function he(t,e){for(var i=0;i<t;i++){var o=e.length;e.resize(o+4),e.float32.set(ce,3*o);}}function ue(t,e,i){var o=e[0],r=e[1];return t[0]=i[0]*o+i[4]*r+i[12],t[1]=i[1]*o+i[5]*r+i[13],t[3]=i[3]*o+i[7]*r+i[15],t}var pe=function(t,e,i){void 0===e&&(e=new Jt(t.width+200,t.height+200,25)),void 0===i&&(i=new Jt(t.width+200,t.height+200,25)),this.transform=t,this.grid=e,this.ignoredGrid=i,this.pitchfactor=Math.cos(t._pitch)*t.cameraToCenterDistance,this.screenRightBoundary=t.width+100,this.screenBottomBoundary=t.height+100,this.gridRightBoundary=t.width+200,this.gridBottomBoundary=t.height+200;};function de(e,i,o){return i*(t.EXTENT/(e.tileSize*Math.pow(2,o-e.tileID.overscaledZ)))}pe.prototype.placeCollisionBox=function(t,e,i,o,r){var a=this.projectAndGetPerspectiveRatio(o,t.anchorPointX,t.anchorPointY),n=i*a.perspectiveRatio,s=t.x1*n+a.point.x,l=t.y1*n+a.point.y,c=t.x2*n+a.point.x,h=t.y2*n+a.point.y;return !this.isInsideGrid(s,l,c,h)||!e&&this.grid.hitTest(s,l,c,h,r)?{box:[],offscreen:!1}:{box:[s,l,c,h],offscreen:this.isOffscreen(s,l,c,h)}},pe.prototype.placeCollisionCircles=function(e,i,o,r,a,n,s,l,c,h,u,p,d){var _=[],f=new t.Point(i.anchorX,i.anchorY),m=te(f,n),g=ee(this.transform.cameraToCenterDistance,m.signedDistanceFromCamera),v=(h?a/g:a*g)/t.ONE_EM,y=te(f,s).point,x=re(v,r,i.lineOffsetX*v,i.lineOffsetY*v,!1,y,f,i,o,s,{}),b=!1,w=!1,E=!0;if(x){for(var T=.5*p*g+d,S=new t.Point(-100,-100),I=new t.Point(this.screenRightBoundary,this.screenBottomBoundary),P=new Yt,C=x.first,z=x.last,M=[],L=C.path.length-1;L>=1;L--)M.push(C.path[L]);for(var D=1;D<z.path.length;D++)M.push(z.path[D]);var R=2.5*T;if(l){var A=M.map((function(t){return te(t,l)}));M=A.some((function(t){return t.signedDistanceFromCamera<=0}))?[]:A.map((function(t){return t.point}));}var k=[];if(M.length>0){for(var O=M[0].clone(),B=M[0].clone(),F=1;F<M.length;F++)O.x=Math.min(O.x,M[F].x),O.y=Math.min(O.y,M[F].y),B.x=Math.max(B.x,M[F].x),B.y=Math.max(B.y,M[F].y);k=O.x>=S.x&&B.x<=I.x&&O.y>=S.y&&B.y<=I.y?[M]:B.x<S.x||O.x>I.x||B.y<S.y||O.y>I.y?[]:t.clipLine([M],S.x,S.y,I.x,I.y);}for(var U=0,N=k;U<N.length;U+=1){var j;P.reset(N[U],.25*T),j=P.length<=.5*T?1:Math.ceil(P.paddedLength/R)+1;for(var G=0;G<j;G++){var Z=G/Math.max(j-1,1),q=P.lerp(Z),V=q.x+100,W=q.y+100;_.push(V,W,T,0);var X=V-T,H=W-T,K=V+T,Y=W+T;if(E=E&&this.isOffscreen(X,H,K,Y),w=w||this.isInsideGrid(X,H,K,Y),!e&&this.grid.hitTestCircle(V,W,T,u)&&(b=!0,!c))return {circles:[],offscreen:!1,collisionDetected:b}}}}return {circles:!c&&b||!w?[]:_,offscreen:E,collisionDetected:b}},pe.prototype.queryRenderedSymbols=function(e){if(0===e.length||0===this.grid.keysLength()&&0===this.ignoredGrid.keysLength())return {};for(var i=[],o=1/0,r=1/0,a=-1/0,n=-1/0,s=0,l=e;s<l.length;s+=1){var c=l[s],h=new t.Point(c.x+100,c.y+100);o=Math.min(o,h.x),r=Math.min(r,h.y),a=Math.max(a,h.x),n=Math.max(n,h.y),i.push(h);}for(var u={},p={},d=0,_=this.grid.query(o,r,a,n).concat(this.ignoredGrid.query(o,r,a,n));d<_.length;d+=1){var f=_[d],m=f.key;if(void 0===u[m.bucketInstanceId]&&(u[m.bucketInstanceId]={}),!u[m.bucketInstanceId][m.featureIndex]){var g=[new t.Point(f.x1,f.y1),new t.Point(f.x2,f.y1),new t.Point(f.x2,f.y2),new t.Point(f.x1,f.y2)];t.polygonIntersectsPolygon(i,g)&&(u[m.bucketInstanceId][m.featureIndex]=!0,void 0===p[m.bucketInstanceId]&&(p[m.bucketInstanceId]=[]),p[m.bucketInstanceId].push(m.featureIndex));}}return p},pe.prototype.insertCollisionBox=function(t,e,i,o,r){(e?this.ignoredGrid:this.grid).insert({bucketInstanceId:i,featureIndex:o,collisionGroupID:r},t[0],t[1],t[2],t[3]);},pe.prototype.insertCollisionCircles=function(t,e,i,o,r){for(var a=e?this.ignoredGrid:this.grid,n={bucketInstanceId:i,featureIndex:o,collisionGroupID:r},s=0;s<t.length;s+=4)a.insertCircle(n,t[s],t[s+1],t[s+2]);},pe.prototype.projectAndGetPerspectiveRatio=function(e,i,o){var r=[i,o,0,1];return ue(r,r,e),{point:new t.Point((r[0]/r[3]+1)/2*this.transform.width+100,(-r[1]/r[3]+1)/2*this.transform.height+100),perspectiveRatio:.5+this.transform.cameraToCenterDistance/r[3]*.5}},pe.prototype.isOffscreen=function(t,e,i,o){return i<100||t>=this.screenRightBoundary||o<100||e>this.screenBottomBoundary},pe.prototype.isInsideGrid=function(t,e,i,o){return i>=0&&t<this.gridRightBoundary&&o>=0&&e<this.gridBottomBoundary},pe.prototype.getViewportMatrix=function(){var e=t.identity([]);return t.translate(e,e,[-100,-100,0]),e};var _e=function(t,e,i,o){this.opacity=t?Math.max(0,Math.min(1,t.opacity+(t.placed?e:-e))):o&&i?1:0,this.placed=i;};_e.prototype.isHidden=function(){return 0===this.opacity&&!this.placed};var fe=function(t,e,i,o,r){this.text=new _e(t?t.text:null,e,i,r),this.icon=new _e(t?t.icon:null,e,o,r);};fe.prototype.isHidden=function(){return this.text.isHidden()&&this.icon.isHidden()};var me=function(t,e,i){this.text=t,this.icon=e,this.skipFade=i;},ge=function(){this.invProjMatrix=t.create(),this.viewportMatrix=t.create(),this.circles=[];},ve=function(t,e,i,o,r){this.bucketInstanceId=t,this.featureIndex=e,this.sourceLayerIndex=i,this.bucketIndex=o,this.tileID=r;},ye=function(t){this.crossSourceCollisions=t,this.maxGroupID=0,this.collisionGroups={};};function xe(e,i,o,r,a){var n=t.getAnchorAlignment(e),s=-(n.horizontalAlign-.5)*i,l=-(n.verticalAlign-.5)*o,c=t.evaluateVariableOffset(e,r);return new t.Point(s+c[0]*a,l+c[1]*a)}function be(e,i,o,r,a,n){var s=e.x1,l=e.x2,c=e.y1,h=e.y2,u=e.anchorPointX,p=e.anchorPointY,d=new t.Point(i,o);return r&&d._rotate(a?n:-n),{x1:s+d.x,y1:c+d.y,x2:l+d.x,y2:h+d.y,anchorPointX:u,anchorPointY:p}}ye.prototype.get=function(t){if(this.crossSourceCollisions)return {ID:0,predicate:null};if(!this.collisionGroups[t]){var e=++this.maxGroupID;this.collisionGroups[t]={ID:e,predicate:function(t){return t.collisionGroupID===e}};}return this.collisionGroups[t]};var we=function(t,e,i,o){this.transform=t.clone(),this.collisionIndex=new pe(this.transform),this.placements={},this.opacities={},this.variableOffsets={},this.stale=!1,this.commitTime=0,this.fadeDuration=e,this.retainedQueryData={},this.collisionGroups=new ye(i),this.collisionCircleArrays={},this.prevPlacement=o,o&&(o.prevPlacement=void 0),this.placedOrientations={};};function Ee(t,e,i,o,r){t.emplaceBack(e?1:0,i?1:0,o||0,r||0),t.emplaceBack(e?1:0,i?1:0,o||0,r||0),t.emplaceBack(e?1:0,i?1:0,o||0,r||0),t.emplaceBack(e?1:0,i?1:0,o||0,r||0);}we.prototype.getBucketParts=function(e,i,o,r){var a=o.getBucket(i),n=o.latestFeatureIndex;if(a&&n&&i.id===a.layerIds[0]){var s=o.collisionBoxArray,l=a.layers[0].layout,c=Math.pow(2,this.transform.zoom-o.tileID.overscaledZ),h=o.tileSize/t.EXTENT,u=this.transform.calculatePosMatrix(o.tileID.toUnwrapped()),p="map"===l.get("text-pitch-alignment"),d="map"===l.get("text-rotation-alignment"),_=de(o,1,this.transform.zoom),f=Qt(u,p,d,this.transform,_),m=null;if(p){var g=$t(u,p,d,this.transform,_);m=t.multiply([],this.transform.labelPlaneMatrix,g);}this.retainedQueryData[a.bucketInstanceId]=new ve(a.bucketInstanceId,n,a.sourceLayerIndex,a.index,o.tileID);var v={bucket:a,layout:l,posMatrix:u,textLabelPlaneMatrix:f,labelToScreenMatrix:m,scale:c,textPixelRatio:h,holdingForFade:o.holdingForFade(),collisionBoxArray:s,partiallyEvaluatedTextSize:t.evaluateSizeForZoom(a.textSizeData,this.transform.zoom),collisionGroup:this.collisionGroups.get(a.sourceID)};if(r)for(var y=0,x=a.sortKeyRanges;y<x.length;y+=1){var b=x[y];e.push({sortKey:b.sortKey,symbolInstanceStart:b.symbolInstanceStart,symbolInstanceEnd:b.symbolInstanceEnd,parameters:v});}else e.push({symbolInstanceStart:0,symbolInstanceEnd:a.symbolInstances.length,parameters:v});}},we.prototype.attemptAnchorPlacement=function(t,e,i,o,r,a,n,s,l,c,h,u,p,d,_){var f,m=[u.textOffset0,u.textOffset1],g=xe(t,i,o,m,r),v=this.collisionIndex.placeCollisionBox(be(e,g.x,g.y,a,n,this.transform.angle),h,s,l,c.predicate);if(!_||0!==this.collisionIndex.placeCollisionBox(be(_,g.x,g.y,a,n,this.transform.angle),h,s,l,c.predicate).box.length)return v.box.length>0?(this.prevPlacement&&this.prevPlacement.variableOffsets[u.crossTileID]&&this.prevPlacement.placements[u.crossTileID]&&this.prevPlacement.placements[u.crossTileID].text&&(f=this.prevPlacement.variableOffsets[u.crossTileID].anchor),this.variableOffsets[u.crossTileID]={textOffset:m,width:i,height:o,anchor:t,textBoxScale:r,prevAnchor:f},this.markUsedJustification(p,t,u,d),p.allowVerticalPlacement&&(this.markUsedOrientation(p,d,u),this.placedOrientations[u.crossTileID]=d),{shift:g,placedGlyphBoxes:v}):void 0},we.prototype.placeLayerBucketPart=function(e,i,o){var r=this,a=e.parameters,n=a.bucket,s=a.layout,l=a.posMatrix,c=a.textLabelPlaneMatrix,h=a.labelToScreenMatrix,u=a.textPixelRatio,p=a.holdingForFade,d=a.collisionBoxArray,_=a.partiallyEvaluatedTextSize,f=a.collisionGroup,m=s.get("text-optional"),g=s.get("icon-optional"),v=s.get("text-allow-overlap"),y=s.get("icon-allow-overlap"),x="map"===s.get("text-rotation-alignment"),b="map"===s.get("text-pitch-alignment"),w="none"!==s.get("icon-text-fit"),E="viewport-y"===s.get("symbol-z-order"),T=v&&(y||!n.hasIconData()||g),S=y&&(v||!n.hasTextData()||m);!n.collisionArrays&&d&&n.deserializeCollisionBoxes(d);var I=function(e,a){if(!i[e.crossTileID])if(p)r.placements[e.crossTileID]=new me(!1,!1,!1);else {var d,E=!1,I=!1,P=!0,C=null,z={box:null,offscreen:null},M={box:null,offscreen:null},L=null,D=null,R=0,A=0,k=0;a.textFeatureIndex?R=a.textFeatureIndex:e.useRuntimeCollisionCircles&&(R=e.featureIndex),a.verticalTextFeatureIndex&&(A=a.verticalTextFeatureIndex);var O=a.textBox;if(O){var B=function(i){var o=t.WritingMode.horizontal;if(n.allowVerticalPlacement&&!i&&r.prevPlacement){var a=r.prevPlacement.placedOrientations[e.crossTileID];a&&(r.placedOrientations[e.crossTileID]=a,r.markUsedOrientation(n,o=a,e));}return o},F=function(i,o){if(n.allowVerticalPlacement&&e.numVerticalGlyphVertices>0&&a.verticalTextBox)for(var r=0,s=n.writingModes;r<s.length&&(s[r]===t.WritingMode.vertical?(z=o(),M=z):z=i(),!(z&&z.box&&z.box.length));r+=1);else z=i();};if(s.get("text-variable-anchor")){var U=s.get("text-variable-anchor");if(r.prevPlacement&&r.prevPlacement.variableOffsets[e.crossTileID]){var N=r.prevPlacement.variableOffsets[e.crossTileID];U.indexOf(N.anchor)>0&&(U=U.filter((function(t){return t!==N.anchor}))).unshift(N.anchor);}var j=function(t,i,o){for(var a=t.x2-t.x1,s=t.y2-t.y1,c=e.textBoxScale,h=w&&!y?i:null,p={box:[],offscreen:!1},d=v?2*U.length:U.length,_=0;_<d;++_){var m=r.attemptAnchorPlacement(U[_%U.length],t,a,s,c,x,b,u,l,f,_>=U.length,e,n,o,h);if(m&&(p=m.placedGlyphBoxes)&&p.box&&p.box.length){E=!0,C=m.shift;break}}return p};F((function(){return j(O,a.iconBox,t.WritingMode.horizontal)}),(function(){var i=a.verticalTextBox;return n.allowVerticalPlacement&&!(z&&z.box&&z.box.length)&&e.numVerticalGlyphVertices>0&&i?j(i,a.verticalIconBox,t.WritingMode.vertical):{box:null,offscreen:null}})),z&&(E=z.box,P=z.offscreen);var G=B(z&&z.box);if(!E&&r.prevPlacement){var Z=r.prevPlacement.variableOffsets[e.crossTileID];Z&&(r.variableOffsets[e.crossTileID]=Z,r.markUsedJustification(n,Z.anchor,e,G));}}else {var q=function(t,i){var o=r.collisionIndex.placeCollisionBox(t,v,u,l,f.predicate);return o&&o.box&&o.box.length&&(r.markUsedOrientation(n,i,e),r.placedOrientations[e.crossTileID]=i),o};F((function(){return q(O,t.WritingMode.horizontal)}),(function(){var i=a.verticalTextBox;return n.allowVerticalPlacement&&e.numVerticalGlyphVertices>0&&i?q(i,t.WritingMode.vertical):{box:null,offscreen:null}})),B(z&&z.box&&z.box.length);}}if(E=(d=z)&&d.box&&d.box.length>0,P=d&&d.offscreen,e.useRuntimeCollisionCircles){var V=n.text.placedSymbolArray.get(e.centerJustifiedTextSymbolIndex),W=t.evaluateSizeForFeature(n.textSizeData,_,V),X=s.get("text-padding");L=r.collisionIndex.placeCollisionCircles(v,V,n.lineVertexArray,n.glyphOffsetArray,W,l,c,h,o,b,f.predicate,e.collisionCircleDiameter,X),E=v||L.circles.length>0&&!L.collisionDetected,P=P&&L.offscreen;}if(a.iconFeatureIndex&&(k=a.iconFeatureIndex),a.iconBox){var H=function(t){var e=w&&C?be(t,C.x,C.y,x,b,r.transform.angle):t;return r.collisionIndex.placeCollisionBox(e,y,u,l,f.predicate)};I=M&&M.box&&M.box.length&&a.verticalIconBox?(D=H(a.verticalIconBox)).box.length>0:(D=H(a.iconBox)).box.length>0,P=P&&D.offscreen;}var K=m||0===e.numHorizontalGlyphVertices&&0===e.numVerticalGlyphVertices,Y=g||0===e.numIconVertices;if(K||Y?Y?K||(I=I&&E):E=I&&E:I=E=I&&E,E&&d&&d.box&&r.collisionIndex.insertCollisionBox(d.box,s.get("text-ignore-placement"),n.bucketInstanceId,M&&M.box&&A?A:R,f.ID),I&&D&&r.collisionIndex.insertCollisionBox(D.box,s.get("icon-ignore-placement"),n.bucketInstanceId,k,f.ID),L&&(E&&r.collisionIndex.insertCollisionCircles(L.circles,s.get("text-ignore-placement"),n.bucketInstanceId,R,f.ID),o)){var J=n.bucketInstanceId,Q=r.collisionCircleArrays[J];void 0===Q&&(Q=r.collisionCircleArrays[J]=new ge);for(var $=0;$<L.circles.length;$+=4)Q.circles.push(L.circles[$+0]),Q.circles.push(L.circles[$+1]),Q.circles.push(L.circles[$+2]),Q.circles.push(L.collisionDetected?1:0);}r.placements[e.crossTileID]=new me(E||T,I||S,P||n.justReloaded),i[e.crossTileID]=!0;}};if(E)for(var P=n.getSortedSymbolIndexes(this.transform.angle),C=P.length-1;C>=0;--C){var z=P[C];I(n.symbolInstances.get(z),n.collisionArrays[z]);}else for(var M=e.symbolInstanceStart;M<e.symbolInstanceEnd;M++)I(n.symbolInstances.get(M),n.collisionArrays[M]);if(o&&n.bucketInstanceId in this.collisionCircleArrays){var L=this.collisionCircleArrays[n.bucketInstanceId];t.invert(L.invProjMatrix,l),L.viewportMatrix=this.collisionIndex.getViewportMatrix();}n.justReloaded=!1;},we.prototype.markUsedJustification=function(e,i,o,r){var a;a=r===t.WritingMode.vertical?o.verticalPlacedTextSymbolIndex:{left:o.leftJustifiedTextSymbolIndex,center:o.centerJustifiedTextSymbolIndex,right:o.rightJustifiedTextSymbolIndex}[t.getAnchorJustification(i)];for(var n=0,s=[o.leftJustifiedTextSymbolIndex,o.centerJustifiedTextSymbolIndex,o.rightJustifiedTextSymbolIndex,o.verticalPlacedTextSymbolIndex];n<s.length;n+=1){var l=s[n];l>=0&&(e.text.placedSymbolArray.get(l).crossTileID=a>=0&&l!==a?0:o.crossTileID);}},we.prototype.markUsedOrientation=function(e,i,o){for(var r=i===t.WritingMode.horizontal||i===t.WritingMode.horizontalOnly?i:0,a=i===t.WritingMode.vertical?i:0,n=0,s=[o.leftJustifiedTextSymbolIndex,o.centerJustifiedTextSymbolIndex,o.rightJustifiedTextSymbolIndex];n<s.length;n+=1)e.text.placedSymbolArray.get(s[n]).placedOrientation=r;o.verticalPlacedTextSymbolIndex&&(e.text.placedSymbolArray.get(o.verticalPlacedTextSymbolIndex).placedOrientation=a);},we.prototype.commit=function(t){this.commitTime=t,this.zoomAtLastRecencyCheck=this.transform.zoom;var e=this.prevPlacement,i=!1;this.prevZoomAdjustment=e?e.zoomAdjustment(this.transform.zoom):0;var o=e?e.symbolFadeChange(t):1,r=e?e.opacities:{},a=e?e.variableOffsets:{},n=e?e.placedOrientations:{};for(var s in this.placements){var l=this.placements[s],c=r[s];c?(this.opacities[s]=new fe(c,o,l.text,l.icon),i=i||l.text!==c.text.placed||l.icon!==c.icon.placed):(this.opacities[s]=new fe(null,o,l.text,l.icon,l.skipFade),i=i||l.text||l.icon);}for(var h in r){var u=r[h];if(!this.opacities[h]){var p=new fe(u,o,!1,!1);p.isHidden()||(this.opacities[h]=p,i=i||u.text.placed||u.icon.placed);}}for(var d in a)this.variableOffsets[d]||!this.opacities[d]||this.opacities[d].isHidden()||(this.variableOffsets[d]=a[d]);for(var _ in n)this.placedOrientations[_]||!this.opacities[_]||this.opacities[_].isHidden()||(this.placedOrientations[_]=n[_]);i?this.lastPlacementChangeTime=t:"number"!=typeof this.lastPlacementChangeTime&&(this.lastPlacementChangeTime=e?e.lastPlacementChangeTime:t);},we.prototype.updateLayerOpacities=function(t,e){for(var i={},o=0,r=e;o<r.length;o+=1){var a=r[o],n=a.getBucket(t);n&&a.latestFeatureIndex&&t.id===n.layerIds[0]&&this.updateBucketOpacities(n,i,a.collisionBoxArray);}},we.prototype.updateBucketOpacities=function(e,i,o){var r=this;e.hasTextData()&&e.text.opacityVertexArray.clear(),e.hasIconData()&&e.icon.opacityVertexArray.clear(),e.hasIconCollisionBoxData()&&e.iconCollisionBox.collisionVertexArray.clear(),e.hasTextCollisionBoxData()&&e.textCollisionBox.collisionVertexArray.clear();var a=e.layers[0].layout,n=new fe(null,0,!1,!1,!0),s=a.get("text-allow-overlap"),l=a.get("icon-allow-overlap"),c=a.get("text-variable-anchor"),h="map"===a.get("text-rotation-alignment"),u="map"===a.get("text-pitch-alignment"),p="none"!==a.get("icon-text-fit"),d=new fe(null,0,s&&(l||!e.hasIconData()||a.get("icon-optional")),l&&(s||!e.hasTextData()||a.get("text-optional")),!0);!e.collisionArrays&&o&&(e.hasIconCollisionBoxData()||e.hasTextCollisionBoxData())&&e.deserializeCollisionBoxes(o);for(var _=function(t,e,i){for(var o=0;o<e/4;o++)t.opacityVertexArray.emplaceBack(i);},f=function(o){var a=e.symbolInstances.get(o),s=a.numHorizontalGlyphVertices,l=a.numVerticalGlyphVertices,f=a.crossTileID,m=r.opacities[f];i[f]?m=n:m||(r.opacities[f]=m=d),i[f]=!0;var g=a.numIconVertices>0,v=r.placedOrientations[a.crossTileID],y=v===t.WritingMode.vertical,x=v===t.WritingMode.horizontal||v===t.WritingMode.horizontalOnly;if(s>0||l>0){var b=Le(m.text);_(e.text,s,y?De:b),_(e.text,l,x?De:b);var w=m.text.isHidden();[a.rightJustifiedTextSymbolIndex,a.centerJustifiedTextSymbolIndex,a.leftJustifiedTextSymbolIndex].forEach((function(t){t>=0&&(e.text.placedSymbolArray.get(t).hidden=w||y?1:0);})),a.verticalPlacedTextSymbolIndex>=0&&(e.text.placedSymbolArray.get(a.verticalPlacedTextSymbolIndex).hidden=w||x?1:0);var E=r.variableOffsets[a.crossTileID];E&&r.markUsedJustification(e,E.anchor,a,v);var T=r.placedOrientations[a.crossTileID];T&&(r.markUsedJustification(e,"left",a,T),r.markUsedOrientation(e,T,a));}if(g){var S=Le(m.icon),I=!(p&&a.verticalPlacedIconSymbolIndex&&y);a.placedIconSymbolIndex>=0&&(_(e.icon,a.numIconVertices,I?S:De),e.icon.placedSymbolArray.get(a.placedIconSymbolIndex).hidden=m.icon.isHidden()),a.verticalPlacedIconSymbolIndex>=0&&(_(e.icon,a.numVerticalIconVertices,I?De:S),e.icon.placedSymbolArray.get(a.verticalPlacedIconSymbolIndex).hidden=m.icon.isHidden());}if(e.hasIconCollisionBoxData()||e.hasTextCollisionBoxData()){var P=e.collisionArrays[o];if(P){var C=new t.Point(0,0);if(P.textBox||P.verticalTextBox){var z=!0;if(c){var M=r.variableOffsets[f];M?(C=xe(M.anchor,M.width,M.height,M.textOffset,M.textBoxScale),h&&C._rotate(u?r.transform.angle:-r.transform.angle)):z=!1;}P.textBox&&Ee(e.textCollisionBox.collisionVertexArray,m.text.placed,!z||y,C.x,C.y),P.verticalTextBox&&Ee(e.textCollisionBox.collisionVertexArray,m.text.placed,!z||x,C.x,C.y);}var L=Boolean(!x&&P.verticalIconBox);P.iconBox&&Ee(e.iconCollisionBox.collisionVertexArray,m.icon.placed,L,p?C.x:0,p?C.y:0),P.verticalIconBox&&Ee(e.iconCollisionBox.collisionVertexArray,m.icon.placed,!L,p?C.x:0,p?C.y:0);}}},m=0;m<e.symbolInstances.length;m++)f(m);if(e.sortFeatures(this.transform.angle),this.retainedQueryData[e.bucketInstanceId]&&(this.retainedQueryData[e.bucketInstanceId].featureSortOrder=e.featureSortOrder),e.hasTextData()&&e.text.opacityVertexBuffer&&e.text.opacityVertexBuffer.updateData(e.text.opacityVertexArray),e.hasIconData()&&e.icon.opacityVertexBuffer&&e.icon.opacityVertexBuffer.updateData(e.icon.opacityVertexArray),e.hasIconCollisionBoxData()&&e.iconCollisionBox.collisionVertexBuffer&&e.iconCollisionBox.collisionVertexBuffer.updateData(e.iconCollisionBox.collisionVertexArray),e.hasTextCollisionBoxData()&&e.textCollisionBox.collisionVertexBuffer&&e.textCollisionBox.collisionVertexBuffer.updateData(e.textCollisionBox.collisionVertexArray),e.bucketInstanceId in this.collisionCircleArrays){var g=this.collisionCircleArrays[e.bucketInstanceId];e.placementInvProjMatrix=g.invProjMatrix,e.placementViewportMatrix=g.viewportMatrix,e.collisionCircleArray=g.circles,delete this.collisionCircleArrays[e.bucketInstanceId];}},we.prototype.symbolFadeChange=function(t){return 0===this.fadeDuration?1:(t-this.commitTime)/this.fadeDuration+this.prevZoomAdjustment},we.prototype.zoomAdjustment=function(t){return Math.max(0,(this.transform.zoom-t)/1.5)},we.prototype.hasTransitions=function(t){return this.stale||t-this.lastPlacementChangeTime<this.fadeDuration},we.prototype.stillRecent=function(t,e){var i=this.zoomAtLastRecencyCheck===e?1-this.zoomAdjustment(e):1;return this.zoomAtLastRecencyCheck=e,this.commitTime+this.fadeDuration*i>t},we.prototype.setStale=function(){this.stale=!0;};var Te=Math.pow(2,25),Se=Math.pow(2,24),Ie=Math.pow(2,17),Pe=Math.pow(2,16),Ce=Math.pow(2,9),ze=Math.pow(2,8),Me=Math.pow(2,1);function Le(t){if(0===t.opacity&&!t.placed)return 0;if(1===t.opacity&&t.placed)return 4294967295;var e=t.placed?1:0,i=Math.floor(127*t.opacity);return i*Te+e*Se+i*Ie+e*Pe+i*Ce+e*ze+i*Me+e}var De=0,Re=function(t){this._sortAcrossTiles="viewport-y"!==t.layout.get("symbol-z-order")&&void 0!==t.layout.get("symbol-sort-key").constantOr(1),this._currentTileIndex=0,this._currentPartIndex=0,this._seenCrossTileIDs={},this._bucketParts=[];};Re.prototype.continuePlacement=function(t,e,i,o,r){for(var a=this._bucketParts;this._currentTileIndex<t.length;)if(e.getBucketParts(a,o,t[this._currentTileIndex],this._sortAcrossTiles),this._currentTileIndex++,r())return !0;for(this._sortAcrossTiles&&(this._sortAcrossTiles=!1,a.sort((function(t,e){return t.sortKey-e.sortKey})));this._currentPartIndex<a.length;)if(e.placeLayerBucketPart(a[this._currentPartIndex],this._seenCrossTileIDs,i),this._currentPartIndex++,r())return !0;return !1};var Ae=function(t,e,i,o,r,a,n){this.placement=new we(t,r,a,n),this._currentPlacementIndex=e.length-1,this._forceFullPlacement=i,this._showCollisionBoxes=o,this._done=!1;};Ae.prototype.isDone=function(){return this._done},Ae.prototype.continuePlacement=function(e,i,o){for(var r=this,a=t.browser.now(),n=function(){var e=t.browser.now()-a;return !r._forceFullPlacement&&e>2};this._currentPlacementIndex>=0;){var s=i[e[this._currentPlacementIndex]],l=this.placement.collisionIndex.transform.zoom;if("symbol"===s.type&&(!s.minzoom||s.minzoom<=l)&&(!s.maxzoom||s.maxzoom>l)){if(this._inProgressLayer||(this._inProgressLayer=new Re(s)),this._inProgressLayer.continuePlacement(o[s.source],this.placement,this._showCollisionBoxes,s,n))return;delete this._inProgressLayer;}this._currentPlacementIndex--;}this._done=!0;},Ae.prototype.commit=function(t){return this.placement.commit(t),this.placement};var ke=512/t.EXTENT/2,Oe=function(t,e,i){this.tileID=t,this.indexedSymbolInstances={},this.bucketInstanceId=i;for(var o=0;o<e.length;o++){var r=e.get(o),a=r.key;this.indexedSymbolInstances[a]||(this.indexedSymbolInstances[a]=[]),this.indexedSymbolInstances[a].push({crossTileID:r.crossTileID,coord:this.getScaledCoordinates(r,t)});}};Oe.prototype.getScaledCoordinates=function(e,i){var o=ke/Math.pow(2,i.canonical.z-this.tileID.canonical.z);return {x:Math.floor((i.canonical.x*t.EXTENT+e.anchorX)*o),y:Math.floor((i.canonical.y*t.EXTENT+e.anchorY)*o)}},Oe.prototype.findMatches=function(t,e,i){for(var o=this.tileID.canonical.z<e.canonical.z?1:Math.pow(2,this.tileID.canonical.z-e.canonical.z),r=0;r<t.length;r++){var a=t.get(r);if(!a.crossTileID){var n=this.indexedSymbolInstances[a.key];if(n)for(var s=this.getScaledCoordinates(a,e),l=0,c=n;l<c.length;l+=1){var h=c[l];if(Math.abs(h.coord.x-s.x)<=o&&Math.abs(h.coord.y-s.y)<=o&&!i[h.crossTileID]){i[h.crossTileID]=!0,a.crossTileID=h.crossTileID;break}}}}};var Be=function(){this.maxCrossTileID=0;};Be.prototype.generate=function(){return ++this.maxCrossTileID};var Fe=function(){this.indexes={},this.usedCrossTileIDs={},this.lng=0;};Fe.prototype.handleWrapJump=function(t){var e=Math.round((t-this.lng)/360);if(0!==e)for(var i in this.indexes){var o=this.indexes[i],r={};for(var a in o){var n=o[a];n.tileID=n.tileID.unwrapTo(n.tileID.wrap+e),r[n.tileID.key]=n;}this.indexes[i]=r;}this.lng=t;},Fe.prototype.addBucket=function(t,e,i){if(this.indexes[t.overscaledZ]&&this.indexes[t.overscaledZ][t.key]){if(this.indexes[t.overscaledZ][t.key].bucketInstanceId===e.bucketInstanceId)return !1;this.removeBucketCrossTileIDs(t.overscaledZ,this.indexes[t.overscaledZ][t.key]);}for(var o=0;o<e.symbolInstances.length;o++)e.symbolInstances.get(o).crossTileID=0;this.usedCrossTileIDs[t.overscaledZ]||(this.usedCrossTileIDs[t.overscaledZ]={});var r=this.usedCrossTileIDs[t.overscaledZ];for(var a in this.indexes){var n=this.indexes[a];if(Number(a)>t.overscaledZ)for(var s in n){var l=n[s];l.tileID.isChildOf(t)&&l.findMatches(e.symbolInstances,t,r);}else {var c=n[t.scaledTo(Number(a)).key];c&&c.findMatches(e.symbolInstances,t,r);}}for(var h=0;h<e.symbolInstances.length;h++){var u=e.symbolInstances.get(h);u.crossTileID||(u.crossTileID=i.generate(),r[u.crossTileID]=!0);}return void 0===this.indexes[t.overscaledZ]&&(this.indexes[t.overscaledZ]={}),this.indexes[t.overscaledZ][t.key]=new Oe(t,e.symbolInstances,e.bucketInstanceId),!0},Fe.prototype.removeBucketCrossTileIDs=function(t,e){for(var i in e.indexedSymbolInstances)for(var o=0,r=e.indexedSymbolInstances[i];o<r.length;o+=1)delete this.usedCrossTileIDs[t][r[o].crossTileID];},Fe.prototype.removeStaleBuckets=function(t){var e=!1;for(var i in this.indexes){var o=this.indexes[i];for(var r in o)t[o[r].bucketInstanceId]||(this.removeBucketCrossTileIDs(i,o[r]),delete o[r],e=!0);}return e};var Ue=function(){this.layerIndexes={},this.crossTileIDs=new Be,this.maxBucketInstanceId=0,this.bucketsInCurrentPlacement={};};Ue.prototype.addLayer=function(t,e,i){var o=this.layerIndexes[t.id];void 0===o&&(o=this.layerIndexes[t.id]=new Fe);var r=!1,a={};o.handleWrapJump(i);for(var n=0,s=e;n<s.length;n+=1){var l=s[n],c=l.getBucket(t);c&&t.id===c.layerIds[0]&&(c.bucketInstanceId||(c.bucketInstanceId=++this.maxBucketInstanceId),o.addBucket(l.tileID,c,this.crossTileIDs)&&(r=!0),a[c.bucketInstanceId]=!0);}return o.removeStaleBuckets(a)&&(r=!0),r},Ue.prototype.pruneUnusedLayers=function(t){var e={};for(var i in t.forEach((function(t){e[t]=!0;})),this.layerIndexes)e[i]||delete this.layerIndexes[i];};var Ne=function(e,i){return t.emitValidationErrors(e,i&&i.filter((function(t){return "source.canvas"!==t.identifier})))},je=t.pick(Gt,["addLayer","removeLayer","setPaintProperty","setLayoutProperty","setFilter","addSource","removeSource","setLayerZoomRange","setLight","setTransition","setGeoJSONSourceData","setGlyphs","setSprite"]),Ge=t.pick(Gt,["setCenter","setZoom","setBearing","setPitch"]),Ze=function(){var e={},i=t.styleSpec.$version;for(var o in t.styleSpec.$root){var r,a=t.styleSpec.$root[o];if(a.required)null!=(r="version"===o?i:"array"===a.type?[]:{})&&(e[o]=r);}return e}(),qe=function(e){function i(o,r){var a=this;void 0===r&&(r={}),e.call(this),this.map=o,this.dispatcher=new S(Ut(),this),this._spriteRequests={},this.imageManagerFactory=new _,this.imageManagerFactory.setEventedParent(this),this.glyphManagerFactory=new x(o._requestManager,r.localIdeographFontFamily),this._sprites={},this._glyphs={},this.lineAtlas=new T(256,512),this.crossTileSymbolIndex=new Ue,this._layers={},this._serializedLayers={},this._order=[],this.sourceCaches={},this.zoomHistory=new t.ZoomHistory,this._loaded=!1,this._availableImages=[],this._resetUpdates(),this.dispatcher.broadcast("setReferrer",t.getReferrer());var n=this;this._rtlTextPluginCallback=i.registerForPluginStateChange((function(e){n.dispatcher.broadcast("syncRTLPluginState",{pluginStatus:e.pluginStatus,pluginURL:e.pluginURL},(function(e,i){if(t.triggerPluginCompletionEvent(e),i&&i.every((function(t){return t})))for(var o in n.sourceCaches)n.sourceCaches[o].reload();}));})),this.on("data",(function(t){if("source"===t.dataType&&"metadata"===t.sourceDataType){var e=a.sourceCaches[t.sourceId];if(e){var i=e.getSource();if(i&&i.vectorLayerIds)for(var o in a._layers){var r=a._layers[o];r.source===i.id&&a._validateLayer(r);}}}}));}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.loadURL=function(e,i){var o=this;void 0===i&&(i={}),this.fire(new t.Event("dataloading",{dataType:"style"}));var r="boolean"==typeof i.validate?i.validate:!t.isMapboxURL(e);e=this.map._requestManager.normalizeStyleURL(e,i.accessToken);var a=this.map._requestManager.transformRequest(e,t.ResourceType.Style);this._request=t.getJSON(a,(function(e,i){o._request=null,e?o.fire(new t.ErrorEvent(e)):i&&o._load(i,r);}));},i.prototype.loadJSON=function(e,i){var o=this;void 0===i&&(i={}),this.fire(new t.Event("dataloading",{dataType:"style"})),this._request=t.browser.frame((function(){o._request=null,o._load(e,!1!==i.validate);}));},i.prototype.loadEmpty=function(){this.fire(new t.Event("dataloading",{dataType:"style"})),this._load(Ze,!1);},i.prototype._load=function(e,i){if(!i||!Ne(this,t.validateStyle(e))){for(var o in this._loaded=!0,this.stylesheet=e,e.sources)this.addSource(o,e.sources[o],{validate:!1});if(e.sprite?this._loadSprite(e):this.imageManagerFactory.setLoaded(!0),"string"==typeof e.glyphs){var r={};for(var a in e.sources)r[a]=e.glyphs;r.image_manager_default=e.glyphs,e.glyphs=r;}for(var n in e.glyphs)this.glyphManagerFactory.setURL(e.glyphs[n],n),this._glyphs[n]=e.glyphs[n];var s=jt(this.stylesheet.layers);this._order=s.map((function(t){return t.id})),this._layers={},this._serializedLayers={};for(var l=0,c=s;l<c.length;l+=1){var h=c[l];(h=t.createStyleLayer(h)).setEventedParent(this,{layer:{id:h.id}}),this._layers[h.id]=h,this._serializedLayers[h.id]=h.serialize();}this.dispatcher.broadcast("setLayers",this._serializeLayers(this._order)),this.light=new E(this.stylesheet.light),this.fire(new t.Event("data",{dataType:"style"})),this.fire(new t.Event("style.load"));}},i.prototype._loadSprite=function(e){var i=this,o=function(o,r,a){if(i._sprites[o]="string"==typeof e.sprite?e.sprite:e.sprite[o],i._spriteRequests[o]=null,delete i._spriteRequests[o],a)i.fire(new t.ErrorEvent(a));else if(r)for(var n in r)i.imageManagerFactory.addImage(n,r[n],o);i.imageManagerFactory.setLoaded(!0,o),i._availableImages=i.imageManagerFactory.listImages(),i.dispatcher.broadcast("setImages",i._availableImages),i.fire(new t.Event("data",{dataType:"style"}));};if("string"!=typeof e.sprite){var r=function(t){var r=u(e.sprite[t],i.map._requestManager,(function(e,i){o(t,i,e);}));i._spriteRequests[t]=r;};for(var a in e.sprite)r(a);}else {var n=e.sprite,s=u(e.sprite,this.map._requestManager,(function(t,i){var r={image_manager_default:e.sprite};for(var a in o("image_manager_default",i,t),e.sources)r[a]=n,o(a,i,t);e.sprite=r;}));this._spriteRequests.image_manager_default=s;}},i.prototype.setSprite=function(t){for(var e in t)this.addSprite(e,t[e]);},i.prototype.addSpriteObject=function(e,i,o){var r=t.browser.getImageData(i),a={};for(var n in o){var s=o[n],l=s.width,c=s.height,h=s.x,u=s.y,p=s.sdf,d=s.pixelRatio,_=new t.RGBAImage({width:l,height:c});t.RGBAImage.copy(r,_,{x:h,y:u},{x:0,y:0},{width:l,height:c}),a[n]={data:_,pixelRatio:d,sdf:p};}for(var f in a)this.imageManagerFactory.addImage(f,a[f],e);},i.prototype.addSprite=function(e,i){var o=this;this.imageManagerFactory.imageManagers[e]||(this.imageManagerFactory.imageManagers[e]=new d,"image_manager_default"!==e&&(this.imageManagerFactory.imageManagers[e].defaultImageManger=this.imageManagerFactory.imageManagers.image_manager_default));var r=u(i,this.map._requestManager,(function(r,a){if(o._sprites[e]=i,o._spriteRequests[e]=null,delete o._spriteRequests[e],r)o.fire(new t.ErrorEvent(r));else if(a)for(var n in a)o.imageManagerFactory.addImage(n,a[n],e);o.imageManagerFactory.setLoaded(!0,e),o.fire(new t.Event("data",{dataType:"style"}));}));this._spriteRequests[e]=r;},i.prototype.setGlyphs=function(t){for(var e in t)this.addGlyphs(e,t[e]);},i.prototype.addGlyphs=function(t,e){this._glyphs[t]=e,this.glyphManagerFactory.setURL(e,t);},i.prototype._validateLayer=function(e){var i=this.sourceCaches[e.source];if(i){var o=e.sourceLayer;if(o){var r=i.getSource();("geojson"===r.type||r.vectorLayerIds&&-1===r.vectorLayerIds.indexOf(o))&&this.fire(new t.ErrorEvent(new Error('Source layer "'+o+'" does not exist on source "'+r.id+'" as specified by style layer "'+e.id+'"')));}}},i.prototype.loaded=function(){if(!this._loaded)return !1;if(Object.keys(this._updatedSources).length)return !1;for(var t in this.sourceCaches)if(!this.sourceCaches[t].loaded())return !1;return !!this.imageManagerFactory.isAllLoaded()},i.prototype._serializeLayers=function(t){for(var e=[],i=0,o=t;i<o.length;i+=1){var r=this._layers[o[i]];"custom"!==r.type&&e.push(r.serialize());}return e},i.prototype.hasTransitions=function(){if(this.light&&this.light.hasTransition())return !0;for(var t in this.sourceCaches)if(this.sourceCaches[t].hasTransition())return !0;for(var e in this._layers)if(this._layers[e].hasTransition())return !0;return !1},i.prototype._checkLoaded=function(){if(!this._loaded)throw new Error("Style is not done loading")},i.prototype.update=function(e){if(this._loaded){var i=this._changed;if(this._changed){var o=Object.keys(this._updatedLayers),r=Object.keys(this._removedLayers);for(var a in (o.length||r.length)&&this._updateWorkerLayers(o,r),this._updatedSources){var n=this._updatedSources[a];"reload"===n?this._reloadSource(a):"clear"===n&&this._clearSource(a);}for(var s in this._updateTilesForChangedImages(),this._updatedPaintProps)this._layers[s].updateTransitions(e);this.light.updateTransitions(e),this._resetUpdates();}for(var l in this.sourceCaches)this.sourceCaches[l].used=!1;for(var c=0,h=this._order;c<h.length;c+=1){var u=this._layers[h[c]];u.recalculate(e,this._availableImages),!u.isHidden(e.zoom)&&u.source&&(this.sourceCaches[u.source].used=!0);}this.light.recalculate(e),this.z=e.zoom,i&&this.fire(new t.Event("data",{dataType:"style"}));}},i.prototype._updateTilesForChangedImages=function(){var t=Object.keys(this._changedImages);if(t.length){for(var e in this.sourceCaches)this.sourceCaches[e].reloadTilesForDependencies(["icons","patterns"],t);this._changedImages={};}},i.prototype._updateWorkerLayers=function(t,e){this.dispatcher.broadcast("updateLayers",{layers:this._serializeLayers(t),removedIds:e});},i.prototype._resetUpdates=function(){this._changed=!1,this._updatedLayers={},this._removedLayers={},this._updatedSources={},this._updatedPaintProps={},this._changedImages={};},i.prototype.setState=function(e){var i=this;if(this._checkLoaded(),Ne(this,t.validateStyle(e)))return !1;(e=t.clone$1(e)).layers=jt(e.layers);var o=function(e,i){if(!e)return [{command:Gt.setStyle,args:[i]}];var o=[];try{if(!t.deepEqual(e.version,i.version))return [{command:Gt.setStyle,args:[i]}];t.deepEqual(e.center,i.center)||o.push({command:Gt.setCenter,args:[i.center]}),t.deepEqual(e.zoom,i.zoom)||o.push({command:Gt.setZoom,args:[i.zoom]}),t.deepEqual(e.bearing,i.bearing)||o.push({command:Gt.setBearing,args:[i.bearing]}),t.deepEqual(e.pitch,i.pitch)||o.push({command:Gt.setPitch,args:[i.pitch]}),t.deepEqual(e.sprite,i.sprite)||o.push({command:Gt.setSprite,args:[i.sprite]}),t.deepEqual(e.glyphs,i.glyphs)||o.push({command:Gt.setGlyphs,args:[i.glyphs]}),t.deepEqual(e.transition,i.transition)||o.push({command:Gt.setTransition,args:[i.transition]}),t.deepEqual(e.light,i.light)||o.push({command:Gt.setLight,args:[i.light]});var r={},a=[];!function(e,i,o,r){var a;for(a in i=i||{},e=e||{})e.hasOwnProperty(a)&&(i.hasOwnProperty(a)||qt(a,o,r));for(a in i)i.hasOwnProperty(a)&&(e.hasOwnProperty(a)?t.deepEqual(e[a],i[a])||("geojson"===e[a].type&&"geojson"===i[a].type&&Wt(e,i,a)?o.push({command:Gt.setGeoJSONSourceData,args:[a,i[a].data]}):Vt(a,i,o,r)):Zt(a,i,o));}(e.sources,i.sources,a,r);var n=[];e.layers&&e.layers.forEach((function(t){r[t.source]?o.push({command:Gt.removeLayer,args:[t.id]}):n.push(t);})),o=o.concat(a),function(e,i,o){i=i||[];var r,a,n,s,l,c,h,u=(e=e||[]).map(Ht),p=i.map(Ht),d=e.reduce(Kt,{}),_=i.reduce(Kt,{}),f=u.slice(),m=Object.create(null);for(r=0,a=0;r<u.length;r++)_.hasOwnProperty(n=u[r])?a++:(o.push({command:Gt.removeLayer,args:[n]}),f.splice(f.indexOf(n,a),1));for(r=0,a=0;r<p.length;r++)f[f.length-1-r]!==(n=p[p.length-1-r])&&(d.hasOwnProperty(n)?(o.push({command:Gt.removeLayer,args:[n]}),f.splice(f.lastIndexOf(n,f.length-a),1)):a++,o.push({command:Gt.addLayer,args:[_[n],c=f[f.length-r]]}),f.splice(f.length-r,0,n),m[n]=!0);for(r=0;r<p.length;r++)if(s=d[n=p[r]],l=_[n],!m[n]&&!t.deepEqual(s,l))if(t.deepEqual(s.source,l.source)&&t.deepEqual(s["source-layer"],l["source-layer"])&&t.deepEqual(s.type,l.type)){for(h in Xt(s.layout,l.layout,o,n,null,Gt.setLayoutProperty),Xt(s.paint,l.paint,o,n,null,Gt.setPaintProperty),t.deepEqual(s.filter,l.filter)||o.push({command:Gt.setFilter,args:[n,l.filter]}),t.deepEqual(s.minzoom,l.minzoom)&&t.deepEqual(s.maxzoom,l.maxzoom)||o.push({command:Gt.setLayerZoomRange,args:[n,l.minzoom,l.maxzoom]}),s)s.hasOwnProperty(h)&&"layout"!==h&&"paint"!==h&&"filter"!==h&&"metadata"!==h&&"minzoom"!==h&&"maxzoom"!==h&&(0===h.indexOf("paint.")?Xt(s[h],l[h],o,n,h.slice(6),Gt.setPaintProperty):t.deepEqual(s[h],l[h])||o.push({command:Gt.setLayerProperty,args:[n,h,l[h]]}));for(h in l)l.hasOwnProperty(h)&&!s.hasOwnProperty(h)&&"layout"!==h&&"paint"!==h&&"filter"!==h&&"metadata"!==h&&"minzoom"!==h&&"maxzoom"!==h&&(0===h.indexOf("paint.")?Xt(s[h],l[h],o,n,h.slice(6),Gt.setPaintProperty):t.deepEqual(s[h],l[h])||o.push({command:Gt.setLayerProperty,args:[n,h,l[h]]}));}else o.push({command:Gt.removeLayer,args:[n]}),c=f[f.lastIndexOf(n)+1],o.push({command:Gt.addLayer,args:[l,c]});}(n,i.layers,o);}catch(t){console.warn("Unable to compute style diff:",t),o=[{command:Gt.setStyle,args:[i]}];}return o}(this.serialize(),e).filter((function(t){return !(t.command in Ge)}));if(0===o.length)return !1;var r=o.filter((function(t){return !(t.command in je)}));if(r.length>0)throw new Error("Unimplemented: "+r.map((function(t){return t.command})).join(", ")+".");return o.forEach((function(t){"setTransition"!==t.command&&i[t.command].apply(i,t.args);})),this.stylesheet=e,!0},i.prototype.addImage=function(e,i,o){if(this.getImage(e))return this.fire(new t.ErrorEvent(new Error("An image with this name already exists.")));this.imageManagerFactory.addImage(e,i,o),this._afterImageUpdated(e);},i.prototype.updateImage=function(t,e,i){this.imageManagerFactory.updateImage(t,e,i);},i.prototype.getImage=function(t,e){return this.imageManagerFactory.getImage(t,e)},i.prototype.removeImage=function(e,i){if(!this.getImage(e))return this.fire(new t.ErrorEvent(new Error("No image with this name exists.")));this.imageManagerFactory.removeImage(e,i),this._afterImageUpdated(e);},i.prototype._afterImageUpdated=function(e){this._availableImages=this.imageManagerFactory.listImages(),this._changedImages[e]=!0,this._changed=!0,this.dispatcher.broadcast("setImages",this._availableImages),this.fire(new t.Event("data",{dataType:"style"}));},i.prototype.listImages=function(t){return this._checkLoaded(),this.imageManagerFactory.listImages(t)},i.prototype.addSource=function(e,i,o){var r=this;if(void 0===o&&(o={}),this._checkLoaded(),void 0!==this.sourceCaches[e])throw new Error("There is already a source with this ID");if(!i.type)throw new Error("The type property must be defined, but only the following properties were given: "+Object.keys(i).join(", ")+".");if(this.map._mapCRS&&"geojson"===i.type&&i.data&&!i.data.customprj&&!i.customprj&&(i.customprj=this.map.customConvertPoint),!(["vector","raster","geojson","video","image"].indexOf(i.type)>=0&&this._validate(t.validateStyle.source,"sources."+e,i,null,o))){this.map&&this.map._collectResourceTiming&&(i.collectResourceTiming=!0);var a=this.sourceCaches[e]=new Lt(e,i,this.dispatcher);a.style=this,a.setEventedParent(this,(function(){return {isSourceLoaded:r.loaded(),source:a.serialize(),sourceId:e}})),a.onAdd(this.map),this._changed=!0;}},i.prototype.removeSource=function(e){if(this._checkLoaded(),void 0===this.sourceCaches[e])throw new Error("There is no source with this ID");for(var i in this._layers)if(this._layers[i].source===e)return this.fire(new t.ErrorEvent(new Error('Source "'+e+'" cannot be removed while layer "'+i+'" is using it.')));var o=this.sourceCaches[e];delete this.sourceCaches[e],delete this._updatedSources[e],o.fire(new t.Event("data",{sourceDataType:"metadata",dataType:"source",sourceId:e})),o.setEventedParent(null),o.clearTiles(),o.onRemove&&o.onRemove(this.map),this._changed=!0;},i.prototype.setGeoJSONSourceData=function(t,e){this._checkLoaded(),this.sourceCaches[t].getSource().setData(e),this._changed=!0;},i.prototype.getSource=function(t){return this.sourceCaches[t]&&this.sourceCaches[t].getSource()},i.prototype.addLayer=function(e,i,o){void 0===o&&(o={}),this._checkLoaded();var r=e.id;if(this.getLayer(r))this.fire(new t.ErrorEvent(new Error('Layer with id "'+r+'" already exists on this map')));else {var a;if("custom"===e.type){if(Ne(this,t.validateCustomStyleLayer(e)))return;a=t.createStyleLayer(e);}else {if("object"==typeof e.source&&(this.addSource(r,e.source),e=t.clone$1(e),e=t.extend(e,{source:r})),this._validate(t.validateStyle.layer,"layers."+r,e,{arrayIndex:-1},o))return;a=t.createStyleLayer(e),this._validateLayer(a),a.setEventedParent(this,{layer:{id:r}}),this._serializedLayers[a.id]=a.serialize();}var n=i?this._order.indexOf(i):this._order.length;if(i&&-1===n)this.fire(new t.ErrorEvent(new Error('Layer with id "'+i+'" does not exist on this map.')));else {if(this._order.splice(n,0,r),this._layerOrderChanged=!0,this._layers[r]=a,this._removedLayers[r]&&a.source&&"custom"!==a.type){var s=this._removedLayers[r];delete this._removedLayers[r],s.type!==a.type?this._updatedSources[a.source]="clear":(this._updatedSources[a.source]="reload",this.sourceCaches[a.source].pause());}this._updateLayer(a),a.onAdd&&a.onAdd(this.map);}}},i.prototype.moveLayer=function(e,i){if(this._checkLoaded(),this._changed=!0,this._layers[e]){if(e!==i){var o=this._order.indexOf(e);this._order.splice(o,1);var r=i?this._order.indexOf(i):this._order.length;i&&-1===r?this.fire(new t.ErrorEvent(new Error('Layer with id "'+i+'" does not exist on this map.'))):(this._order.splice(r,0,e),this._layerOrderChanged=!0);}}else this.fire(new t.ErrorEvent(new Error("The layer '"+e+"' does not exist in the map's style and cannot be moved.")));},i.prototype.removeLayer=function(e){this._checkLoaded();var i=this._layers[e];if(i){i.setEventedParent(null);var o=this._order.indexOf(e);this._order.splice(o,1),this._layerOrderChanged=!0,this._changed=!0,this._removedLayers[e]=i,delete this._layers[e],delete this._serializedLayers[e],delete this._updatedLayers[e],delete this._updatedPaintProps[e],i.onRemove&&i.onRemove(this.map);}else this.fire(new t.ErrorEvent(new Error("The layer '"+e+"' does not exist in the map's style and cannot be removed.")));},i.prototype.getLayer=function(t){return this._layers[t]},i.prototype.hasLayer=function(t){return t in this._layers},i.prototype.setLayerZoomRange=function(e,i,o){this._checkLoaded();var r=this.getLayer(e);r?r.minzoom===i&&r.maxzoom===o||(null!=i&&(r.minzoom=i),null!=o&&(r.maxzoom=o),this._updateLayer(r)):this.fire(new t.ErrorEvent(new Error("The layer '"+e+"' does not exist in the map's style and cannot have zoom extent.")));},i.prototype.setFilter=function(e,i,o){void 0===o&&(o={}),this._checkLoaded();var r=this.getLayer(e);if(r){if(!t.deepEqual(r.filter,i))return null==i?(r.filter=void 0,void this._updateLayer(r)):void(this._validate(t.validateStyle.filter,"layers."+r.id+".filter",i,null,o)||(r.filter=t.clone$1(i),this._updateLayer(r)))}else this.fire(new t.ErrorEvent(new Error("The layer '"+e+"' does not exist in the map's style and cannot be filtered.")));},i.prototype.getFilter=function(e){return t.clone$1(this.getLayer(e).filter)},i.prototype.setLayoutProperty=function(e,i,o,r){void 0===r&&(r={}),this._checkLoaded();var a=this.getLayer(e);a?t.deepEqual(a.getLayoutProperty(i),o)||(a.setLayoutProperty(i,o,r),this._updateLayer(a)):this.fire(new t.ErrorEvent(new Error("The layer '"+e+"' does not exist in the map's style and cannot be styled.")));},i.prototype.getLayoutProperty=function(e,i){var o=this.getLayer(e);if(o)return o.getLayoutProperty(i);this.fire(new t.ErrorEvent(new Error("The layer '"+e+"' does not exist in the map's style.")));},i.prototype.setPaintProperty=function(e,i,o,r){void 0===r&&(r={}),this._checkLoaded();var a=this.getLayer(e);a?t.deepEqual(a.getPaintProperty(i),o)||(a.setPaintProperty(i,o,r)&&this._updateLayer(a),this._changed=!0,this._updatedPaintProps[e]=!0):this.fire(new t.ErrorEvent(new Error("The layer '"+e+"' does not exist in the map's style and cannot be styled.")));},i.prototype.getPaintProperty=function(t,e){return this.getLayer(t).getPaintProperty(e)},i.prototype.setFeatureState=function(e,i){this._checkLoaded();var o=e.source,r=e.sourceLayer,a=this.sourceCaches[o];if(void 0!==a){var n=a.getSource().type;"geojson"===n&&r?this.fire(new t.ErrorEvent(new Error("GeoJSON sources cannot have a sourceLayer parameter."))):"vector"!==n||r?(void 0===e.id&&this.fire(new t.ErrorEvent(new Error("The feature id parameter must be provided."))),a.setFeatureState(r,e.id,i)):this.fire(new t.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));}else this.fire(new t.ErrorEvent(new Error("The source '"+o+"' does not exist in the map's style.")));},i.prototype.removeFeatureState=function(e,i){this._checkLoaded();var o=e.source,r=this.sourceCaches[o];if(void 0!==r){var a=r.getSource().type,n="vector"===a?e.sourceLayer:void 0;"vector"!==a||n?i&&"string"!=typeof e.id&&"number"!=typeof e.id?this.fire(new t.ErrorEvent(new Error("A feature id is required to remove its specific state property."))):r.removeFeatureState(n,e.id,i):this.fire(new t.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));}else this.fire(new t.ErrorEvent(new Error("The source '"+o+"' does not exist in the map's style.")));},i.prototype.getFeatureState=function(e){this._checkLoaded();var i=e.source,o=e.sourceLayer,r=this.sourceCaches[i];if(void 0!==r){if("vector"!==r.getSource().type||o)return void 0===e.id&&this.fire(new t.ErrorEvent(new Error("The feature id parameter must be provided."))),r.getFeatureState(o,e.id);this.fire(new t.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));}else this.fire(new t.ErrorEvent(new Error("The source '"+i+"' does not exist in the map's style.")));},i.prototype.getTransition=function(){return t.extend({duration:300,delay:0},this.stylesheet&&this.stylesheet.transition)},i.prototype.serialize=function(){return t.filterObject({version:this.stylesheet.version,name:this.stylesheet.name,metadata:this.stylesheet.metadata,light:this.stylesheet.light,center:this.stylesheet.center,zoom:this.stylesheet.zoom,bearing:this.stylesheet.bearing,pitch:this.stylesheet.pitch,sprite:this._sprites,glyphs:this._glyphs,transition:this.stylesheet.transition,sources:t.mapObject(this.sourceCaches,(function(t){return t.serialize()})),layers:this._serializeLayers(this._order)},(function(t){return void 0!==t}))},i.prototype._updateLayer=function(t){this._updatedLayers[t.id]=!0,t.source&&!this._updatedSources[t.source]&&"raster"!==this.sourceCaches[t.source].getSource().type&&(this._updatedSources[t.source]="reload",this.sourceCaches[t.source].pause()),this._changed=!0;},i.prototype._flattenAndSortRenderedFeatures=function(t){for(var e=this,i=function(t){return "fill-extrusion"===e._layers[t].type},o={},r=[],a=this._order.length-1;a>=0;a--){var n=this._order[a];if(i(n)){o[n]=a;for(var s=0,l=t;s<l.length;s+=1){var c=l[s][n];if(c)for(var h=0,u=c;h<u.length;h+=1)r.push(u[h]);}}}r.sort((function(t,e){return e.intersectionZ-t.intersectionZ}));for(var p=[],d=this._order.length-1;d>=0;d--){var _=this._order[d];if(i(_))for(var f=r.length-1;f>=0;f--){var m=r[f].feature;if(o[m.layer.id]<d)break;p.push(m),r.pop();}else for(var g=0,v=t;g<v.length;g+=1){var y=v[g][_];if(y)for(var x=0,b=y;x<b.length;x+=1)p.push(b[x].feature);}}return p},i.prototype.queryRenderedFeatures=function(e,i,o){i&&i.filter&&this._validate(t.validateStyle.filter,"queryRenderedFeatures.filter",i.filter,null,i);var r={};if(i&&i.layers){if(!Array.isArray(i.layers))return this.fire(new t.ErrorEvent(new Error("parameters.layers must be an Array."))),[];for(var a=0,n=i.layers;a<n.length;a+=1){var s=n[a],l=this._layers[s];if(!l)return this.fire(new t.ErrorEvent(new Error("The layer '"+s+"' does not exist in the map's style and cannot be queried for features."))),[];r[l.source]=!0;}}var c=[];for(var h in i.availableImages=this._availableImages,this.sourceCaches)i.layers&&!r[h]||c.push(F(this.sourceCaches[h],this._layers,this._serializedLayers,e,i,o));return this.placement&&c.push(function(t,e,i,o,r,a,n,s){for(var l={},c=a.queryRenderedSymbols(o),h=[],u=0,p=Object.keys(c).map(Number);u<p.length;u+=1)h.push(n[p[u]]);h.sort(U);for(var d=function(){var i=f[_],o=i.featureIndex.lookupSymbolFeatures(c[i.bucketInstanceId],e,i.bucketIndex,i.sourceLayerIndex,r.filter,r.layers,r.availableImages,t,s);for(var a in o){var n=l[a]=l[a]||[],h=o[a];h.sort((function(t,e){var o=i.featureSortOrder;if(o){var r=o.indexOf(t.featureIndex);return o.indexOf(e.featureIndex)-r}return e.featureIndex-t.featureIndex}));for(var u=0,p=h;u<p.length;u+=1)n.push(p[u]);}},_=0,f=h;_<f.length;_+=1)d();var m=function(e){l[e].forEach((function(o){var r=o.feature,a=i[t[e].source].getFeatureState(r.layer["source-layer"],r.id);r.source=r.layer.source,r.layer["source-layer"]&&(r.sourceLayer=r.layer["source-layer"]),r.state=a;}));};for(var g in l)m(g);return l}(this._layers,this._serializedLayers,this.sourceCaches,e,i,this.placement.collisionIndex,this.placement.retainedQueryData,o.crs)),this._flattenAndSortRenderedFeatures(c)},i.prototype.querySourceFeatures=function(e,i,o){i&&i.filter&&this._validate(t.validateStyle.filter,"querySourceFeatures.filter",i.filter,null,i);var r=this.sourceCaches[e];return r?function(t,e,i){for(var o=t.getRenderableIds().map((function(e){return t.getTileByID(e)})),r=[],a={},n=0;n<o.length;n++){var s=o[n],l=s.tileID.canonical.key;a[l]||(a[l]=!0,s.querySourceFeatures(r,e,i));}return r}(r,i,o):[]},i.prototype.addSourceType=function(t,e,o){return i.getSourceType(t)?o(new Error('A source type called "'+t+'" already exists.')):(i.setSourceType(t,e),e.workerSourceURL?void this.dispatcher.broadcast("loadWorkerSource",{name:t,url:e.workerSourceURL},o):o(null,null))},i.prototype.getLight=function(){return this.light.getLight()},i.prototype.setLight=function(e,i){void 0===i&&(i={}),this._checkLoaded();var o=this.light.getLight(),r=!1;for(var a in e)if(!t.deepEqual(e[a],o[a])){r=!0;break}if(r){var n={now:t.browser.now(),transition:t.extend({duration:300,delay:0},this.stylesheet.transition)};this.light.setLight(e,i),this.light.updateTransitions(n);}},i.prototype._validate=function(e,i,o,r,a){return void 0===a&&(a={}),(!a||!1!==a.validate)&&Ne(this,e.call(t.validateStyle,t.extend({key:i,style:this.serialize(),value:o,styleSpec:t.styleSpec},r)))},i.prototype._remove=function(){for(var e in this._request&&(this._request.cancel(),this._request=null),this._spriteRequests)this._spriteRequests[e].cancel(),delete this._spriteRequests[e];for(var i in this._spriteRequests={},t.evented.off("pluginStateChange",this._rtlTextPluginCallback),this._layers)this._layers[i].setEventedParent(null);for(var o in this.sourceCaches)this.sourceCaches[o].clearTiles(),this.sourceCaches[o].setEventedParent(null);this.imageManagerFactory.setEventedParent(null),this.setEventedParent(null),this.dispatcher.remove();},i.prototype._clearSource=function(t){this.sourceCaches[t].clearTiles();},i.prototype._reloadSource=function(t){this.sourceCaches[t].resume(),this.sourceCaches[t].reload();},i.prototype._updateSources=function(t){for(var e in this.sourceCaches)this.sourceCaches[e].update(t);},i.prototype._generateCollisionBoxes=function(){for(var t in this.sourceCaches)this._reloadSource(t);},i.prototype._updatePlacement=function(e,i,o,r,a){void 0===a&&(a=!1);for(var n=!1,s=!1,l={},c=0,h=this._order;c<h.length;c+=1){var u=this._layers[h[c]];if("symbol"===u.type){if(!l[u.source]){var p=this.sourceCaches[u.source];l[u.source]=p.getRenderableIds(!0).map((function(t){return p.getTileByID(t)})).sort((function(t,e){return e.tileID.overscaledZ-t.tileID.overscaledZ||(t.tileID.isLessThan(e.tileID)?-1:1)}));}var d=this.crossTileSymbolIndex.addLayer(u,l[u.source],e.center.lng);n=n||d;}}if(this.crossTileSymbolIndex.pruneUnusedLayers(this._order),((a=a||this._layerOrderChanged||0===o)||!this.pauseablePlacement||this.pauseablePlacement.isDone()&&!this.placement.stillRecent(t.browser.now(),e.zoom))&&(this.pauseablePlacement=new Ae(e,this._order,a,i,o,r,this.placement),this._layerOrderChanged=!1),this.pauseablePlacement.isDone()?this.placement.setStale():(this.pauseablePlacement.continuePlacement(this._order,this._layers,l),this.pauseablePlacement.isDone()&&(this.placement=this.pauseablePlacement.commit(t.browser.now()),s=!0),n&&this.pauseablePlacement.placement.setStale()),s||n)for(var _=0,f=this._order;_<f.length;_+=1){var m=this._layers[f[_]];"symbol"===m.type&&this.placement.updateLayerOpacities(m,l[m.source]);}return !this.pauseablePlacement.isDone()||this.placement.hasTransitions(t.browser.now())},i.prototype._releaseSymbolFadeTiles=function(){for(var t in this.sourceCaches)this.sourceCaches[t].releaseSymbolFadeTiles();},i.prototype.getImages=function(t,e,i,o){this.imageManagerFactory.getImages(e.icons,i,o),this._updateTilesForChangedImages();var r=this.sourceCaches[e.source];r&&r.setDependencies(e.tileID.key,e.type,e.icons);},i.prototype.getGlyphs=function(t,e,i,o){this.glyphManagerFactory.getGlyphs(e.stacks,i,o);},i.prototype.getResource=function(e,i,o){return t.makeRequest(i,o)},i}(t.Evented);qe.getSourceType=function(t){return O[t]},qe.setSourceType=function(t,e){O[t]=e;},qe.registerForPluginStateChange=t.registerForPluginStateChange;var Ve=t.createLayout([{name:"a_pos",type:"Int16",components:2}]),We=vi("#ifdef GL_ES\nprecision mediump float;\n#else\n#if !defined(lowp)\n#define lowp\n#endif\n#if !defined(mediump)\n#define mediump\n#endif\n#if !defined(highp)\n#define highp\n#endif\n#endif","#ifdef GL_ES\nprecision highp float;\n#else\n#if !defined(lowp)\n#define lowp\n#endif\n#if !defined(mediump)\n#define mediump\n#endif\n#if !defined(highp)\n#define highp\n#endif\n#endif\nvec2 unpack_float(const float packedValue) {int packedIntValue=int(packedValue);int v0=packedIntValue/256;return vec2(v0,packedIntValue-v0*256);}vec2 unpack_opacity(const float packedOpacity) {int intOpacity=int(packedOpacity)/2;return vec2(float(intOpacity)/127.0,mod(packedOpacity,2.0));}vec4 decode_color(const vec2 encodedColor) {return vec4(unpack_float(encodedColor[0])/255.0,unpack_float(encodedColor[1])/255.0\n);}float unpack_mix_vec2(const vec2 packedValue,const float t) {return mix(packedValue[0],packedValue[1],t);}vec4 unpack_mix_color(const vec4 packedColors,const float t) {vec4 minColor=decode_color(vec2(packedColors[0],packedColors[1]));vec4 maxColor=decode_color(vec2(packedColors[2],packedColors[3]));return mix(minColor,maxColor,t);}vec2 get_pattern_pos(const vec2 pixel_coord_upper,const vec2 pixel_coord_lower,const vec2 pattern_size,const float tile_units_to_pixels,const vec2 pos) {vec2 offset=mod(mod(mod(pixel_coord_upper,pattern_size)*256.0,pattern_size)*256.0+pixel_coord_lower,pattern_size);return (tile_units_to_pixels*pos+offset)/pattern_size;}"),Xe=vi("uniform vec4 u_color;uniform float u_opacity;void main() {gl_FragColor=u_color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}"),He=vi("uniform vec2 u_pattern_tl_a;uniform vec2 u_pattern_br_a;uniform vec2 u_pattern_tl_b;uniform vec2 u_pattern_br_b;uniform vec2 u_texsize;uniform float u_mix;uniform float u_opacity;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(u_pattern_tl_a/u_texsize,u_pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(u_pattern_tl_b/u_texsize,u_pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);gl_FragColor=mix(color1,color2,u_mix)*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_pattern_size_a;uniform vec2 u_pattern_size_b;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_scale_a;uniform float u_scale_b;uniform float u_tile_units_to_pixels;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_a*u_pattern_size_a,u_tile_units_to_pixels,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_b*u_pattern_size_b,u_tile_units_to_pixels,a_pos);}"),Ke=vi("varying vec3 v_data;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=v_data.xy;float extrude_length=length(extrude);lowp float antialiasblur=v_data.z;float antialiased_blur=-max(blur,antialiasblur);float opacity_t=smoothstep(0.0,antialiased_blur,extrude_length-1.0);float color_t=stroke_width < 0.01 ? 0.0 : smoothstep(antialiased_blur,0.0,extrude_length-radius/(radius+stroke_width));gl_FragColor=opacity_t*mix(color*opacity,stroke_color*stroke_opacity,color_t);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform bool u_scale_with_map;uniform bool u_pitch_with_map;uniform vec2 u_extrude_scale;uniform lowp float u_device_pixel_ratio;uniform highp float u_camera_to_center_distance;attribute vec2 a_pos;varying vec3 v_data;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main(void) {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=vec2(mod(a_pos,2.0)*2.0-1.0);vec2 circle_center=floor(a_pos*0.5);if (u_pitch_with_map) {vec2 corner_position=circle_center;if (u_scale_with_map) {corner_position+=extrude*(radius+stroke_width)*u_extrude_scale;} else {vec4 projected_center=u_matrix*vec4(circle_center,0,1);corner_position+=extrude*(radius+stroke_width)*u_extrude_scale*(projected_center.w/u_camera_to_center_distance);}gl_Position=u_matrix*vec4(corner_position,0,1);} else {gl_Position=u_matrix*vec4(circle_center,0,1);if (u_scale_with_map) {gl_Position.xy+=extrude*(radius+stroke_width)*u_extrude_scale*u_camera_to_center_distance;} else {gl_Position.xy+=extrude*(radius+stroke_width)*u_extrude_scale*gl_Position.w;}}lowp float antialiasblur=1.0/u_device_pixel_ratio/(radius+stroke_width);v_data=vec3(extrude.x,extrude.y,antialiasblur);}"),Ye=vi("void main() {gl_FragColor=vec4(1.0);}","attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}"),Je=vi("uniform highp float u_intensity;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#define GAUSS_COEF 0.3989422804014327\nvoid main() {\n#pragma mapbox: initialize highp float weight\nfloat d=-0.5*3.0*3.0*dot(v_extrude,v_extrude);float val=weight*u_intensity*GAUSS_COEF*exp(d);gl_FragColor=vec4(val,1.0,1.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform float u_extrude_scale;uniform float u_opacity;uniform float u_intensity;attribute vec2 a_pos;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#pragma mapbox: define mediump float radius\nconst highp float ZERO=1.0/255.0/16.0;\n#define GAUSS_COEF 0.3989422804014327\nvoid main(void) {\n#pragma mapbox: initialize highp float weight\n#pragma mapbox: initialize mediump float radius\nvec2 unscaled_extrude=vec2(mod(a_pos,2.0)*2.0-1.0);float S=sqrt(-2.0*log(ZERO/weight/u_intensity/GAUSS_COEF))/3.0;v_extrude=S*unscaled_extrude;vec2 extrude=v_extrude*radius*u_extrude_scale;vec4 pos=vec4(floor(a_pos*0.5)+extrude,0,1);gl_Position=u_matrix*pos;}"),Qe=vi("uniform sampler2D u_image;uniform sampler2D u_color_ramp;uniform float u_opacity;varying vec2 v_pos;void main() {float t=texture2D(u_image,v_pos).r;vec4 color=texture2D(u_color_ramp,vec2(t,0.5));gl_FragColor=color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(0.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_world;attribute vec2 a_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos*u_world,0,1);v_pos.x=a_pos.x;v_pos.y=1.0-a_pos.y;}"),$e=vi("varying float v_placed;varying float v_notUsed;void main() {float alpha=0.5;gl_FragColor=vec4(1.0,0.0,0.0,1.0)*alpha;if (v_placed > 0.5) {gl_FragColor=vec4(0.0,0.0,1.0,0.5)*alpha;}if (v_notUsed > 0.5) {gl_FragColor*=.1;}}","attribute vec2 a_pos;attribute vec2 a_anchor_pos;attribute vec2 a_extrude;attribute vec2 a_placed;attribute vec2 a_shift;uniform mat4 u_matrix;uniform vec2 u_extrude_scale;uniform float u_camera_to_center_distance;varying float v_placed;varying float v_notUsed;void main() {vec4 projectedPoint=u_matrix*vec4(a_anchor_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float collision_perspective_ratio=clamp(0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);gl_Position=u_matrix*vec4(a_pos,0.0,1.0);gl_Position.xy+=(a_extrude+a_shift)*u_extrude_scale*gl_Position.w*collision_perspective_ratio;v_placed=a_placed.x;v_notUsed=a_placed.y;}"),ti=vi("varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;void main() {float alpha=0.5*min(v_perspective_ratio,1.0);float stroke_radius=0.9*max(v_perspective_ratio,1.0);float distance_to_center=length(v_extrude);float distance_to_edge=abs(distance_to_center-v_radius);float opacity_t=smoothstep(-stroke_radius,0.0,-distance_to_edge);vec4 color=mix(vec4(0.0,0.0,1.0,0.5),vec4(1.0,0.0,0.0,1.0),v_collision);gl_FragColor=color*alpha*opacity_t;}","attribute vec2 a_pos;attribute float a_radius;attribute vec2 a_flags;uniform mat4 u_matrix;uniform mat4 u_inv_matrix;uniform vec2 u_viewport_size;uniform float u_camera_to_center_distance;varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;vec3 toTilePosition(vec2 screenPos) {vec4 rayStart=u_inv_matrix*vec4(screenPos,-1.0,1.0);vec4 rayEnd  =u_inv_matrix*vec4(screenPos, 1.0,1.0);rayStart.xyz/=rayStart.w;rayEnd.xyz  /=rayEnd.w;highp float t=(0.0-rayStart.z)/(rayEnd.z-rayStart.z);return mix(rayStart.xyz,rayEnd.xyz,t);}void main() {vec2 quadCenterPos=a_pos;float radius=a_radius;float collision=a_flags.x;float vertexIdx=a_flags.y;vec2 quadVertexOffset=vec2(mix(-1.0,1.0,float(vertexIdx >=2.0)),mix(-1.0,1.0,float(vertexIdx >=1.0 && vertexIdx <=2.0)));vec2 quadVertexExtent=quadVertexOffset*radius;vec3 tilePos=toTilePosition(quadCenterPos);vec4 clipPos=u_matrix*vec4(tilePos,1.0);highp float camera_to_anchor_distance=clipPos.w;highp float collision_perspective_ratio=clamp(0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);float padding_factor=1.2;v_radius=radius;v_extrude=quadVertexExtent*padding_factor;v_perspective_ratio=collision_perspective_ratio;v_collision=collision;gl_Position=vec4(clipPos.xyz/clipPos.w,1.0)+vec4(quadVertexExtent*padding_factor/u_viewport_size*2.0,0.0,0.0);}"),ei=vi("uniform highp vec4 u_color;uniform sampler2D u_overlay;varying vec2 v_uv;void main() {vec4 overlay_color=texture2D(u_overlay,v_uv);gl_FragColor=mix(u_color,overlay_color,overlay_color.a);}","attribute vec2 a_pos;varying vec2 v_uv;uniform mat4 u_matrix;uniform float u_overlay_scale;void main() {v_uv=a_pos/8192.0;gl_Position=u_matrix*vec4(a_pos*u_overlay_scale,0,1);}"),ii=vi("#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_FragColor=color*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","attribute vec2 a_pos;uniform mat4 u_matrix;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);}"),oi=vi("varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);gl_FragColor=outline_color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","attribute vec2 a_pos;uniform mat4 u_matrix;uniform vec2 u_world;varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;}"),ri=vi("uniform vec2 u_texsize;uniform sampler2D u_image;uniform float u_fade;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);float dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);gl_FragColor=mix(color1,color2,u_fade)*alpha*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_world;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;gl_Position=u_matrix*vec4(a_pos,0,1);vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,a_pos);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;}"),ai=vi("uniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);gl_FragColor=mix(color1,color2,u_fade)*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileZoomRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileZoomRatio,a_pos);}"),ni=vi("varying vec4 v_color;void main() {gl_FragColor=v_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;uniform float u_vertical_gradient;uniform lowp float u_opacity;attribute vec2 a_pos;attribute vec4 a_normal_ed;varying vec4 v_color;\n#pragma mapbox: define highp float base\n#pragma mapbox: define highp float height\n#pragma mapbox: define highp vec4 color\nvoid main() {\n#pragma mapbox: initialize highp float base\n#pragma mapbox: initialize highp float height\n#pragma mapbox: initialize highp vec4 color\nvec3 normal=a_normal_ed.xyz;base=max(0.0,base);height=max(0.0,height);float t=mod(normal.x,2.0);gl_Position=u_matrix*vec4(a_pos,t > 0.0 ? height : base,1);float colorvalue=color.r*0.2126+color.g*0.7152+color.b*0.0722;v_color=vec4(0.0,0.0,0.0,1.0);vec4 ambientlight=vec4(0.03,0.03,0.03,1.0);color+=ambientlight;float directional=clamp(dot(normal/16384.0,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((1.0-colorvalue+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=((1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}v_color.r+=clamp(color.r*directional*u_lightcolor.r,mix(0.0,0.3,1.0-u_lightcolor.r),1.0);v_color.g+=clamp(color.g*directional*u_lightcolor.g,mix(0.0,0.3,1.0-u_lightcolor.g),1.0);v_color.b+=clamp(color.b*directional*u_lightcolor.b,mix(0.0,0.3,1.0-u_lightcolor.b),1.0);v_color*=u_opacity;}"),si=vi("uniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);vec4 mixedColor=mix(color1,color2,u_fade);gl_FragColor=mixedColor*v_lighting;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_height_factor;uniform vec3 u_scale;uniform float u_vertical_gradient;uniform lowp float u_opacity;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;attribute vec2 a_pos;attribute vec4 a_normal_ed;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec3 normal=a_normal_ed.xyz;float edgedistance=a_normal_ed.w;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;base=max(0.0,base);height=max(0.0,height);float t=mod(normal.x,2.0);float z=t > 0.0 ? height : base;gl_Position=u_matrix*vec4(a_pos,z,1);vec2 pos=normal.x==1.0 && normal.y==0.0 && normal.z==16384.0\n? a_pos\n: vec2(edgedistance,z*u_height_factor);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,pos);v_lighting=vec4(0.0,0.0,0.0,1.0);float directional=clamp(dot(normal/16383.0,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((0.5+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=((1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}v_lighting.rgb+=clamp(directional*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_lighting*=u_opacity;}"),li=vi("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_dimension;uniform float u_zoom;uniform vec4 u_unpack;float getElevation(vec2 coord,float bias) {vec4 data=texture2D(u_image,coord)*255.0;data.a=-1.0;return dot(data,u_unpack)/4.0;}void main() {vec2 epsilon=1.0/u_dimension;float a=getElevation(v_pos+vec2(-epsilon.x,-epsilon.y),0.0);float b=getElevation(v_pos+vec2(0,-epsilon.y),0.0);float c=getElevation(v_pos+vec2(epsilon.x,-epsilon.y),0.0);float d=getElevation(v_pos+vec2(-epsilon.x,0),0.0);float e=getElevation(v_pos,0.0);float f=getElevation(v_pos+vec2(epsilon.x,0),0.0);float g=getElevation(v_pos+vec2(-epsilon.x,epsilon.y),0.0);float h=getElevation(v_pos+vec2(0,epsilon.y),0.0);float i=getElevation(v_pos+vec2(epsilon.x,epsilon.y),0.0);float exaggerationFactor=u_zoom < 2.0 ? 0.4 : u_zoom < 4.5 ? 0.35 : 0.3;float exaggeration=u_zoom < 15.0 ? (u_zoom-15.0)*exaggerationFactor : 0.0;vec2 deriv=vec2((c+f+f+i)-(a+d+d+g),(g+h+h+i)-(a+b+b+c))/pow(2.0,exaggeration+(19.2562-u_zoom));gl_FragColor=clamp(vec4(deriv.x/2.0+0.5,deriv.y/2.0+0.5,1.0,1.0),0.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_dimension;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);highp vec2 epsilon=1.0/u_dimension;float scale=(u_dimension.x-2.0)/u_dimension.x;v_pos=(a_texture_pos/8192.0)*scale+epsilon;}"),ci=vi("uniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_latrange;uniform vec2 u_light;uniform vec4 u_shadow;uniform vec4 u_highlight;uniform vec4 u_accent;\n#define PI 3.141592653589793\nvoid main() {vec4 pixel=texture2D(u_image,v_pos);vec2 deriv=((pixel.rg*2.0)-1.0);float scaleFactor=cos(radians((u_latrange[0]-u_latrange[1])*(1.0-v_pos.y)+u_latrange[1]));float slope=atan(1.25*length(deriv)/scaleFactor);float aspect=deriv.x !=0.0 ? atan(deriv.y,-deriv.x) : PI/2.0*(deriv.y > 0.0 ? 1.0 :-1.0);float intensity=u_light.x;float azimuth=u_light.y+PI;float base=1.875-intensity*1.75;float maxValue=0.5*PI;float scaledSlope=intensity !=0.5 ? ((pow(base,slope)-1.0)/(pow(base,maxValue)-1.0))*maxValue : slope;float accent=cos(scaledSlope);vec4 accent_color=(1.0-accent)*u_accent*clamp(intensity*2.0,0.0,1.0);float shade=abs(mod((aspect+azimuth)/PI+0.5,2.0)-1.0);vec4 shade_color=mix(u_shadow,u_highlight,shade)*sin(scaledSlope)*clamp(intensity*2.0,0.0,1.0);gl_FragColor=accent_color*(1.0-shade_color.a)+shade_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos=a_texture_pos/8192.0;}"),hi=vi("uniform lowp float u_device_pixel_ratio;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform vec2 u_units_to_pixels;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp float v_linesofar;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;v_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*2.0;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;float extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;v_width2=vec2(outset,inset);}"),ui=vi("uniform lowp float u_device_pixel_ratio;uniform sampler2D u_image;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;varying highp vec2 v_uv;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);vec4 color=texture2D(u_image,v_uv);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;attribute float a_uv_x;attribute float a_split_index;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;uniform vec2 u_units_to_pixels;uniform float u_image_height;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp vec2 v_uv;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;highp float texel_height=1.0/u_image_height;highp float half_texel_height=0.5*texel_height;v_uv=vec2(a_uv_x,a_split_index*texel_height-half_texel_height);vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;float extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;v_width2=vec2(outset,inset);}"),pi=vi("uniform lowp float u_device_pixel_ratio;\r\nuniform vec2 u_texsize;\r\nuniform float u_fade;\r\nuniform mediump vec3 u_scale;\r\nuniform sampler2D u_image;\r\nvarying vec2 v_normal;\r\nvarying vec2 v_width2;\r\nvarying float v_linesofar;\r\nvarying float v_gamma_scale;\r\nvarying float v_width;\r\n#pragma mapbox: define lowp vec4 pattern_from\r\n#pragma mapbox: define lowp vec4 pattern_to\r\n#pragma mapbox: define lowp float pixel_ratio_from\r\n#pragma mapbox: define lowp float pixel_ratio_to\r\n#pragma mapbox: define lowp float blur\r\n#pragma mapbox: define lowp float opacity\r\nvoid main() {\r\n#pragma mapbox: initialize mediump vec4 pattern_from\r\n#pragma mapbox: initialize mediump vec4 pattern_to\r\n#pragma mapbox: initialize lowp float pixel_ratio_from\r\n#pragma mapbox: initialize lowp float pixel_ratio_to\r\n#pragma mapbox: initialize lowp float blur\r\n#pragma mapbox: initialize lowp float opacity\r\nvec2 pattern_tl_a=pattern_from.xy;\r\nvec2 pattern_br_a=pattern_from.zw;\r\nvec2 pattern_tl_b=pattern_to.xy;\r\nvec2 pattern_br_b=pattern_to.zw;\r\nfloat tileZoomRatio=u_scale.x;\r\nfloat fromScale=u_scale.y;\r\nfloat toScale=u_scale.z;\r\nvec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;\r\nvec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;\r\nvec2 pattern_size_a=vec2(display_size_a.x*fromScale/tileZoomRatio,display_size_a.y);\r\nvec2 pattern_size_b=vec2(display_size_b.x*toScale/tileZoomRatio,display_size_b.y);\r\nfloat aspect_a=display_size_a.y/v_width;\r\nfloat aspect_b=display_size_b.y/v_width;float dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;\r\nfloat alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);\r\nfloat x_a=mod(v_linesofar/pattern_size_a.x*aspect_a,1.0);\r\nfloat x_b=mod(v_linesofar/pattern_size_b.x*aspect_b,1.0);\r\nfloat y=0.5*v_normal.y+0.5;\r\nvec2 texel_size=1.0/u_texsize;\r\nvec2 pos_a=mix(pattern_tl_a*texel_size-texel_size,pattern_br_a*texel_size+texel_size,vec2(x_a,y));\r\nvec2 pos_b=mix(pattern_tl_b*texel_size-texel_size,pattern_br_b*texel_size+texel_size,vec2(x_b,y));\r\nvec4 color=mix(texture2D(u_image,pos_a),texture2D(u_image,pos_b),u_fade);\r\ngl_FragColor=color*alpha*opacity;\r\n#ifdef OVERDRAW_INSPECTOR\r\ngl_FragColor=vec4(1.0);\r\n#endif\r\n}","\n#define scale 0.015873016\n#define LINE_DISTANCE_SCALE 2.0\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform vec2 u_units_to_pixels;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;float a_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*LINE_DISTANCE_SCALE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;float extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;v_linesofar=a_linesofar;v_width2=vec2(outset,inset);v_width=floorwidth;}"),di=vi("uniform lowp float u_device_pixel_ratio;uniform sampler2D u_image;uniform float u_sdfgamma;uniform float u_mix;varying vec2 v_normal;varying vec2 v_width2;varying vec2 v_tex_a;varying vec2 v_tex_b;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float sdfdist_a=texture2D(u_image,v_tex_a).a;float sdfdist_b=texture2D(u_image,v_tex_b).a;float sdfdist=mix(sdfdist_a,sdfdist_b,u_mix);alpha*=smoothstep(0.5-u_sdfgamma/floorwidth,0.5+u_sdfgamma/floorwidth,sdfdist);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","\n#define scale 0.015873016\n#define LINE_DISTANCE_SCALE 2.0\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;uniform vec2 u_patternscale_a;uniform float u_tex_y_a;uniform vec2 u_patternscale_b;uniform float u_tex_y_b;uniform vec2 u_units_to_pixels;varying vec2 v_normal;varying vec2 v_width2;varying vec2 v_tex_a;varying vec2 v_tex_b;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;float a_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*LINE_DISTANCE_SCALE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;float extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;v_tex_a=vec2(a_linesofar*u_patternscale_a.x/floorwidth,normal.y*u_patternscale_a.y+u_tex_y_a);v_tex_b=vec2(a_linesofar*u_patternscale_b.x/floorwidth,normal.y*u_patternscale_b.y+u_tex_y_b);v_width2=vec2(outset,inset);}"),_i=vi("uniform float u_fade_t;uniform float u_opacity;uniform sampler2D u_image0;uniform sampler2D u_image1;varying vec2 v_pos0;varying vec2 v_pos1;uniform float u_brightness_low;uniform float u_brightness_high;uniform float u_saturation_factor;uniform float u_contrast_factor;uniform vec3 u_spin_weights;void main() {vec4 color0=texture2D(u_image0,v_pos0);vec4 color1=texture2D(u_image1,v_pos1);if (color0.a > 0.0) {color0.rgb=color0.rgb/color0.a;}if (color1.a > 0.0) {color1.rgb=color1.rgb/color1.a;}vec4 color=mix(color0,color1,u_fade_t);color.a*=u_opacity;vec3 rgb=color.rgb;rgb=vec3(dot(rgb,u_spin_weights.xyz),dot(rgb,u_spin_weights.zxy),dot(rgb,u_spin_weights.yzx));float average=(color.r+color.g+color.b)/3.0;rgb+=(average-rgb)*u_saturation_factor;rgb=(rgb-0.5)*u_contrast_factor+0.5;vec3 u_high_vec=vec3(u_brightness_low,u_brightness_low,u_brightness_low);vec3 u_low_vec=vec3(u_brightness_high,u_brightness_high,u_brightness_high);gl_FragColor=vec4(mix(u_high_vec,u_low_vec,rgb)*color.a,color.a);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","uniform mat4 u_matrix;uniform vec2 u_tl_parent;uniform float u_scale_parent;uniform float u_buffer_scale;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos0;varying vec2 v_pos1;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos0=(((a_texture_pos/8192.0)-0.5)/u_buffer_scale )+0.5;v_pos1=(v_pos0*u_scale_parent)+u_tl_parent;}"),fi=vi("uniform sampler2D u_texture;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nlowp float alpha=opacity*v_fade_opacity;gl_FragColor=texture2D(u_texture,v_tex)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec4 a_pixeloffset;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform highp float u_camera_to_center_distance;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform float u_fade_change;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform vec2 u_texsize;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;vec2 a_minFontScale=a_pixeloffset.zw/256.0;highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),0,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,0.0,1.0);gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*max(a_minFontScale,fontScale)+a_pxoffset/16.0),0.0,1.0);v_tex=a_tex/u_texsize;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;v_fade_opacity=max(0.0,min(1.0,fade_opacity[0]+fade_change));}"),mi=vi("#define SDF_PX 8.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;uniform bool u_is_text;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat EDGE_GAMMA=0.105/u_device_pixel_ratio;vec2 tex=v_data0.xy;float gamma_scale=v_data1.x;float size=v_data1.y;float fade_opacity=v_data1[2];float fontScale=u_is_text ? size/24.0 : size;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec4 a_pixeloffset;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),0,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,0.0,1.0);gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*fontScale+a_pxoffset),0.0,1.0);float gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(1.0,fade_opacity[0]+fade_change));v_data0=a_tex/u_texsize;v_data1=vec3(gamma_scale,size,interpolated_fade_opacity);}"),gi=vi("#define SDF_PX 8.0\n#define SDF 1.0\n#define ICON 0.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform sampler2D u_texture_icon;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat fade_opacity=v_data1[2];if (v_data1.w==ICON) {vec2 tex_icon=v_data0.zw;lowp float alpha=opacity*fade_opacity;gl_FragColor=texture2D(u_texture_icon,tex_icon)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nreturn;}vec2 tex=v_data0.xy;float EDGE_GAMMA=0.105/u_device_pixel_ratio;float gamma_scale=v_data1.x;float size=v_data1.y;float fontScale=size/24.0;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}","const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;uniform vec2 u_texsize_icon;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);float is_sdf=a_size[0]-2.0*a_size_min;highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=size/24.0;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),0,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,0.0,1.0);gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*fontScale),0.0,1.0);float gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(1.0,fade_opacity[0]+fade_change));v_data0.xy=a_tex/u_texsize;v_data0.zw=a_tex/u_texsize_icon;v_data1=vec4(gamma_scale,size,interpolated_fade_opacity,is_sdf);}");function vi(t,e){var i=/#pragma mapbox: ([\w]+) ([\w]+) ([\w]+) ([\w]+)/g,o=e.match(/attribute ([\w]+) ([\w]+)/g),r=t.match(/uniform ([\w]+) ([\w]+)([\s]*)([\w]*)/g),a=e.match(/uniform ([\w]+) ([\w]+)([\s]*)([\w]*)/g),n=a?a.concat(r):r,s={};return {fragmentSource:t=t.replace(i,(function(t,e,i,o,r){return s[r]=!0,"define"===e?"\n#ifndef HAS_UNIFORM_u_"+r+"\nvarying "+i+" "+o+" "+r+";\n#else\nuniform "+i+" "+o+" u_"+r+";\n#endif\n":"\n#ifdef HAS_UNIFORM_u_"+r+"\n    "+i+" "+o+" "+r+" = u_"+r+";\n#endif\n"})),vertexSource:e=e.replace(i,(function(t,e,i,o,r){var a="float"===o?"vec2":"vec4",n=r.match(/color/)?"color":a;return s[r]?"define"===e?"\n#ifndef HAS_UNIFORM_u_"+r+"\nuniform lowp float u_"+r+"_t;\nattribute "+i+" "+a+" a_"+r+";\nvarying "+i+" "+o+" "+r+";\n#else\nuniform "+i+" "+o+" u_"+r+";\n#endif\n":"vec4"===n?"\n#ifndef HAS_UNIFORM_u_"+r+"\n    "+r+" = a_"+r+";\n#else\n    "+i+" "+o+" "+r+" = u_"+r+";\n#endif\n":"\n#ifndef HAS_UNIFORM_u_"+r+"\n    "+r+" = unpack_mix_"+n+"(a_"+r+", u_"+r+"_t);\n#else\n    "+i+" "+o+" "+r+" = u_"+r+";\n#endif\n":"define"===e?"\n#ifndef HAS_UNIFORM_u_"+r+"\nuniform lowp float u_"+r+"_t;\nattribute "+i+" "+a+" a_"+r+";\n#else\nuniform "+i+" "+o+" u_"+r+";\n#endif\n":"vec4"===n?"\n#ifndef HAS_UNIFORM_u_"+r+"\n    "+i+" "+o+" "+r+" = a_"+r+";\n#else\n    "+i+" "+o+" "+r+" = u_"+r+";\n#endif\n":"\n#ifndef HAS_UNIFORM_u_"+r+"\n    "+i+" "+o+" "+r+" = unpack_mix_"+n+"(a_"+r+", u_"+r+"_t);\n#else\n    "+i+" "+o+" "+r+" = u_"+r+";\n#endif\n"})),staticAttributes:o,staticUniforms:n}}var yi=Object.freeze({__proto__:null,prelude:We,background:Xe,backgroundPattern:He,circle:Ke,clippingMask:Ye,heatmap:Je,heatmapTexture:Qe,collisionBox:$e,collisionCircle:ti,debug:ei,fill:ii,fillOutline:oi,fillOutlinePattern:ri,fillPattern:ai,fillExtrusion:ni,fillExtrusionPattern:si,hillshadePrepare:li,hillshade:ci,line:hi,lineGradient:ui,linePattern:pi,lineSDF:di,raster:_i,symbolIcon:fi,symbolSDF:mi,symbolTextAndIcon:gi}),xi=function(){this.boundProgram=null,this.boundLayoutVertexBuffer=null,this.boundPaintVertexBuffers=[],this.boundIndexBuffer=null,this.boundVertexOffset=null,this.boundDynamicVertexBuffer=null,this.vao=null;};function bi(t){for(var e=[],i=0;i<t.length;i++)if(null!==t[i]){var o=t[i].split(" ");e.push(o.pop());}return e}xi.prototype.bind=function(t,e,i,o,r,a,n,s){this.context=t;for(var l=this.boundPaintVertexBuffers.length!==o.length,c=0;!l&&c<o.length;c++)this.boundPaintVertexBuffers[c]!==o[c]&&(l=!0);t.extVertexArrayObject&&this.vao&&this.boundProgram===e&&this.boundLayoutVertexBuffer===i&&!l&&this.boundIndexBuffer===r&&this.boundVertexOffset===a&&this.boundDynamicVertexBuffer===n&&this.boundDynamicVertexBuffer2===s?(t.bindVertexArrayOES.set(this.vao),n&&n.bind(),r&&r.dynamicDraw&&r.bind(),s&&s.bind()):this.freshBind(e,i,o,r,a,n,s);},xi.prototype.freshBind=function(t,e,i,o,r,a,n){var s,l=t.numAttributes,c=this.context,h=c.gl;if(c.extVertexArrayObject)this.vao&&this.destroy(),this.vao=c.extVertexArrayObject.createVertexArrayOES(),c.bindVertexArrayOES.set(this.vao),s=0,this.boundProgram=t,this.boundLayoutVertexBuffer=e,this.boundPaintVertexBuffers=i,this.boundIndexBuffer=o,this.boundVertexOffset=r,this.boundDynamicVertexBuffer=a,this.boundDynamicVertexBuffer2=n;else {s=c.currentNumAttributes||0;for(var u=l;u<s;u++)h.disableVertexAttribArray(u);}e.enableAttributes(h,t);for(var p=0,d=i;p<d.length;p+=1)d[p].enableAttributes(h,t);a&&a.enableAttributes(h,t),n&&n.enableAttributes(h,t),e.bind(),e.setVertexAttribPointers(h,t,r);for(var _=0,f=i;_<f.length;_+=1){var m=f[_];m.bind(),m.setVertexAttribPointers(h,t,r);}a&&(a.bind(),a.setVertexAttribPointers(h,t,r)),o&&o.bind(),n&&(n.bind(),n.setVertexAttribPointers(h,t,r)),c.currentNumAttributes=l;},xi.prototype.destroy=function(){this.vao&&(this.context.extVertexArrayObject.deleteVertexArrayOES(this.vao),this.vao=null);};var wi=function(t,e,i,o,r,a){var n=t.gl;this.program=n.createProgram();for(var s=bi(i.staticAttributes),l=o?o.getBinderAttributes():[],c=s.concat(l),h=i.staticUniforms?bi(i.staticUniforms):[],u=o?o.getBinderUniforms():[],p=[],d=0,_=h.concat(u);d<_.length;d+=1){var f=_[d];p.indexOf(f)<0&&p.push(f);}var m=o?o.defines():[];a&&m.push("#define OVERDRAW_INSPECTOR;");var g=m.concat(We.fragmentSource,i.fragmentSource).join("\n"),v=m.concat(We.vertexSource,i.vertexSource).join("\n"),y=n.createShader(n.FRAGMENT_SHADER);if(n.isContextLost())this.failedToCreate=!0;else {n.shaderSource(y,g),n.compileShader(y),n.attachShader(this.program,y);var x=n.createShader(n.VERTEX_SHADER);if(n.isContextLost())this.failedToCreate=!0;else {n.shaderSource(x,v),n.compileShader(x),n.attachShader(this.program,x),this.attributes={};var b={};this.numAttributes=c.length;for(var w=0;w<this.numAttributes;w++)c[w]&&(n.bindAttribLocation(this.program,w,c[w]),this.attributes[c[w]]=w);n.linkProgram(this.program),n.deleteShader(x),n.deleteShader(y);for(var E=0;E<p.length;E++){var T=p[E];if(T&&!b[T]){var S=n.getUniformLocation(this.program,T);S&&(b[T]=S);}}this.fixedUniforms=r(t,b),this.binderUniforms=o?o.getUniforms(t,b):[];}}};function Ei(t,e,i){var o=1/de(i,1,e.transform.tileZoom),r=Math.pow(2,i.tileID.overscaledZ),a=i.tileSize*Math.pow(2,e.transform.tileZoom)/r,n=a*(i.tileID.canonical.x+i.tileID.wrap*r),s=a*i.tileID.canonical.y;return {u_image:0,u_texsize:i.imageAtlasTexture.size,u_scale:[o,t.fromScale,t.toScale],u_fade:t.t,u_pixel_coord_upper:[n>>16,s>>16],u_pixel_coord_lower:[65535&n,65535&s]}}wi.prototype.draw=function(t,e,i,o,r,a,n,s,l,c,h,u,p,d,_,f){var m,g=t.gl;if(!this.failedToCreate){for(var v in t.program.set(this.program),t.setDepthMode(i),t.setStencilMode(o),t.setColorMode(r),t.setCullFace(a),this.fixedUniforms)this.fixedUniforms[v].set(n[v]);d&&d.setUniforms(t,this.binderUniforms,u,{zoom:p});for(var y=(m={},m[g.LINES]=2,m[g.TRIANGLES]=3,m[g.LINE_STRIP]=1,m)[e],x=0,b=h.get();x<b.length;x+=1){var w=b[x],E=w.vaos||(w.vaos={});(E[s]||(E[s]=new xi)).bind(t,this,l,d?d.getPaintVertexBuffers():[],c,w.vertexOffset,_,f),g.drawElements(e,w.primitiveLength*y,g.UNSIGNED_SHORT,w.primitiveOffset*y*2);}}};var Ti=function(e,i,o,r){var a=i.style.light,n=a.properties.get("position"),s=[n.x,n.y,n.z],l=t.create$1();"viewport"===a.properties.get("anchor")&&t.fromRotation(l,-i.transform.angle),t.transformMat3(s,s,l);var c=a.properties.get("color");return {u_matrix:e,u_lightpos:s,u_lightintensity:a.properties.get("intensity"),u_lightcolor:[c.r,c.g,c.b],u_vertical_gradient:+o,u_opacity:r}},Si=function(e,i,o,r,a,n,s){return t.extend(Ti(e,i,o,r),Ei(n,i,s),{u_height_factor:-Math.pow(2,a.overscaledZ)/s.tileSize/8})},Ii=function(t){return {u_matrix:t}},Pi=function(e,i,o,r){return t.extend(Ii(e),Ei(o,i,r))},Ci=function(t,e){return {u_matrix:t,u_world:e}},zi=function(e,i,o,r,a){return t.extend(Pi(e,i,o,r),{u_world:a})},Mi=function(e,i,o,r){var a,n,s=e.transform;if("map"===r.paint.get("circle-pitch-alignment")){var l=de(o,1,s.zoom);a=!0,n=[l,l];}else a=!1,n=s.pixelsToGLUnits;return {u_camera_to_center_distance:s.cameraToCenterDistance,u_scale_with_map:+("map"===r.paint.get("circle-pitch-scale")),u_matrix:e.translatePosMatrix(i.posMatrix,o,r.paint.get("circle-translate"),r.paint.get("circle-translate-anchor")),u_pitch_with_map:+a,u_device_pixel_ratio:t.browser.devicePixelRatio,u_extrude_scale:n}},Li=function(t,e,i){var o=de(i,1,e.zoom),r=Math.pow(2,e.zoom-i.tileID.overscaledZ),a=i.tileID.overscaleFactor();return {u_matrix:t,u_camera_to_center_distance:e.cameraToCenterDistance,u_pixels_to_tile_units:o,u_extrude_scale:[e.pixelsToGLUnits[0]/(o*r),e.pixelsToGLUnits[1]/(o*r)],u_overscale_factor:a}},Di=function(t,e,i){return {u_matrix:t,u_inv_matrix:e,u_camera_to_center_distance:i.cameraToCenterDistance,u_viewport_size:[i.width,i.height]}},Ri=function(t,e,i){return void 0===i&&(i=1),{u_matrix:t,u_color:e,u_overlay:0,u_overlay_scale:i}},Ai=function(t){return {u_matrix:t}},ki=function(t,e,i,o){return {u_matrix:t,u_extrude_scale:de(e,1,i),u_intensity:o}},Oi=function(e,i,o){var r=e.transform;return {u_matrix:ji(e,i,o),u_ratio:1/de(i,1,r.zoom),u_device_pixel_ratio:t.browser.devicePixelRatio,u_units_to_pixels:[1/r.pixelsToGLUnits[0],1/r.pixelsToGLUnits[1]]}},Bi=function(e,i,o,r){return t.extend(Oi(e,i,o),{u_image:0,u_image_height:r})},Fi=function(e,i,o,r){var a=e.transform,n=Ni(i,a);return {u_matrix:ji(e,i,o),u_texsize:i.imageAtlasTexture.size,u_ratio:1/de(i,1,a.zoom),u_device_pixel_ratio:t.browser.devicePixelRatio,u_image:0,u_scale:[n,r.fromScale,r.toScale],u_fade:r.t,u_units_to_pixels:[1/a.pixelsToGLUnits[0],1/a.pixelsToGLUnits[1]]}},Ui=function(e,i,o,r,a){var n=e.lineAtlas,s=Ni(i,e.transform),l="round"===o.layout.get("line-cap"),c=n.getDash(r.from,l),h=n.getDash(r.to,l),u=c.width*a.fromScale,p=h.width*a.toScale;return t.extend(Oi(e,i,o),{u_patternscale_a:[s/u,-c.height/2],u_patternscale_b:[s/p,-h.height/2],u_sdfgamma:n.width/(256*Math.min(u,p)*t.browser.devicePixelRatio)/2,u_image:0,u_tex_y_a:c.y,u_tex_y_b:h.y,u_mix:a.t})};function Ni(t,e){return 1/de(t,1,e.tileZoom)}function ji(t,e,i){return t.translatePosMatrix(e.tileID.posMatrix,e,i.paint.get("line-translate"),i.paint.get("line-translate-anchor"))}var Gi=function(t,e,i,o,r){return {u_matrix:t,u_tl_parent:e,u_scale_parent:i,u_buffer_scale:1,u_fade_t:o.mix,u_opacity:o.opacity*r.paint.get("raster-opacity"),u_image0:0,u_image1:1,u_brightness_low:r.paint.get("raster-brightness-min"),u_brightness_high:r.paint.get("raster-brightness-max"),u_saturation_factor:(n=r.paint.get("raster-saturation"),n>0?1-1/(1.001-n):-n),u_contrast_factor:(a=r.paint.get("raster-contrast"),a>0?1/(1-a):1+a),u_spin_weights:Zi(r.paint.get("raster-hue-rotate"))};var a,n;};function Zi(t){t*=Math.PI/180;var e=Math.sin(t),i=Math.cos(t);return [(2*i+1)/3,(-Math.sqrt(3)*e-i+1)/3,(Math.sqrt(3)*e-i+1)/3]}var qi,Vi=function(t,e,i,o,r,a,n,s,l,c){var h=r.transform;return {u_is_size_zoom_constant:+("constant"===t||"source"===t),u_is_size_feature_constant:+("constant"===t||"camera"===t),u_size_t:e?e.uSizeT:0,u_size:e?e.uSize:0,u_camera_to_center_distance:h.cameraToCenterDistance,u_pitch:h.pitch/360*2*Math.PI,u_rotate_symbol:+i,u_aspect_ratio:h.width/h.height,u_fade_change:r.options.fadeDuration?r.symbolFadeChange:1,u_matrix:a,u_label_plane_matrix:n,u_coord_matrix:s,u_is_text:+l,u_pitch_with_map:+o,u_texsize:c,u_texture:0}},Wi=function(e,i,o,r,a,n,s,l,c,h,u){var p=a.transform;return t.extend(Vi(e,i,o,r,a,n,s,l,c,h),{u_gamma_scale:r?Math.cos(p._pitch)*p.cameraToCenterDistance:1,u_device_pixel_ratio:t.browser.devicePixelRatio,u_is_halo:+u})},Xi=function(e,i,o,r,a,n,s,l,c,h){return t.extend(Wi(e,i,o,r,a,n,s,l,!0,c,!0),{u_texsize_icon:h,u_texture_icon:1})},Hi=function(t,e,i){return {u_matrix:t,u_opacity:e,u_color:i}},Ki=function(e,i,o,r,a,n){return t.extend(function(t,e,i,o){var r=i.imageManagerFactory.getPattern(t.from.toString()),a=i.imageManagerFactory.getPattern(t.to.toString()),n=i.imageManagerFactory.getPixelSize(),s=n.width,l=n.height,c=Math.pow(2,o.tileID.overscaledZ),h=o.tileSize*Math.pow(2,i.transform.tileZoom)/c,u=h*(o.tileID.canonical.x+o.tileID.wrap*c),p=h*o.tileID.canonical.y;return {u_image:0,u_pattern_tl_a:r.tl,u_pattern_br_a:r.br,u_pattern_tl_b:a.tl,u_pattern_br_b:a.br,u_texsize:[s,l],u_mix:e.t,u_pattern_size_a:r.displaySize,u_pattern_size_b:a.displaySize,u_scale_a:e.fromScale,u_scale_b:e.toScale,u_tile_units_to_pixels:1/de(o,1,i.transform.tileZoom),u_pixel_coord_upper:[u>>16,p>>16],u_pixel_coord_lower:[65535&u,65535&p]}}(r,n,o,a),{u_matrix:e,u_opacity:i})},Yi={fillExtrusion:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_lightpos:new t.Uniform3f(e,i.u_lightpos),u_lightintensity:new t.Uniform1f(e,i.u_lightintensity),u_lightcolor:new t.Uniform3f(e,i.u_lightcolor),u_vertical_gradient:new t.Uniform1f(e,i.u_vertical_gradient),u_opacity:new t.Uniform1f(e,i.u_opacity)}},fillExtrusionPattern:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_lightpos:new t.Uniform3f(e,i.u_lightpos),u_lightintensity:new t.Uniform1f(e,i.u_lightintensity),u_lightcolor:new t.Uniform3f(e,i.u_lightcolor),u_vertical_gradient:new t.Uniform1f(e,i.u_vertical_gradient),u_height_factor:new t.Uniform1f(e,i.u_height_factor),u_image:new t.Uniform1i(e,i.u_image),u_texsize:new t.Uniform2f(e,i.u_texsize),u_pixel_coord_upper:new t.Uniform2f(e,i.u_pixel_coord_upper),u_pixel_coord_lower:new t.Uniform2f(e,i.u_pixel_coord_lower),u_scale:new t.Uniform3f(e,i.u_scale),u_fade:new t.Uniform1f(e,i.u_fade),u_opacity:new t.Uniform1f(e,i.u_opacity)}},fill:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix)}},fillPattern:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_image:new t.Uniform1i(e,i.u_image),u_texsize:new t.Uniform2f(e,i.u_texsize),u_pixel_coord_upper:new t.Uniform2f(e,i.u_pixel_coord_upper),u_pixel_coord_lower:new t.Uniform2f(e,i.u_pixel_coord_lower),u_scale:new t.Uniform3f(e,i.u_scale),u_fade:new t.Uniform1f(e,i.u_fade)}},fillOutline:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_world:new t.Uniform2f(e,i.u_world)}},fillOutlinePattern:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_world:new t.Uniform2f(e,i.u_world),u_image:new t.Uniform1i(e,i.u_image),u_texsize:new t.Uniform2f(e,i.u_texsize),u_pixel_coord_upper:new t.Uniform2f(e,i.u_pixel_coord_upper),u_pixel_coord_lower:new t.Uniform2f(e,i.u_pixel_coord_lower),u_scale:new t.Uniform3f(e,i.u_scale),u_fade:new t.Uniform1f(e,i.u_fade)}},circle:function(e,i){return {u_camera_to_center_distance:new t.Uniform1f(e,i.u_camera_to_center_distance),u_scale_with_map:new t.Uniform1i(e,i.u_scale_with_map),u_pitch_with_map:new t.Uniform1i(e,i.u_pitch_with_map),u_extrude_scale:new t.Uniform2f(e,i.u_extrude_scale),u_device_pixel_ratio:new t.Uniform1f(e,i.u_device_pixel_ratio),u_matrix:new t.UniformMatrix4f(e,i.u_matrix)}},collisionBox:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_camera_to_center_distance:new t.Uniform1f(e,i.u_camera_to_center_distance),u_pixels_to_tile_units:new t.Uniform1f(e,i.u_pixels_to_tile_units),u_extrude_scale:new t.Uniform2f(e,i.u_extrude_scale),u_overscale_factor:new t.Uniform1f(e,i.u_overscale_factor)}},collisionCircle:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_inv_matrix:new t.UniformMatrix4f(e,i.u_inv_matrix),u_camera_to_center_distance:new t.Uniform1f(e,i.u_camera_to_center_distance),u_viewport_size:new t.Uniform2f(e,i.u_viewport_size)}},debug:function(e,i){return {u_color:new t.UniformColor(e,i.u_color),u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_overlay:new t.Uniform1i(e,i.u_overlay),u_overlay_scale:new t.Uniform1f(e,i.u_overlay_scale)}},clippingMask:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix)}},heatmap:function(e,i){return {u_extrude_scale:new t.Uniform1f(e,i.u_extrude_scale),u_intensity:new t.Uniform1f(e,i.u_intensity),u_matrix:new t.UniformMatrix4f(e,i.u_matrix)}},heatmapTexture:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_world:new t.Uniform2f(e,i.u_world),u_image:new t.Uniform1i(e,i.u_image),u_color_ramp:new t.Uniform1i(e,i.u_color_ramp),u_opacity:new t.Uniform1f(e,i.u_opacity)}},hillshade:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_image:new t.Uniform1i(e,i.u_image),u_latrange:new t.Uniform2f(e,i.u_latrange),u_light:new t.Uniform2f(e,i.u_light),u_shadow:new t.UniformColor(e,i.u_shadow),u_highlight:new t.UniformColor(e,i.u_highlight),u_accent:new t.UniformColor(e,i.u_accent)}},hillshadePrepare:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_image:new t.Uniform1i(e,i.u_image),u_dimension:new t.Uniform2f(e,i.u_dimension),u_zoom:new t.Uniform1f(e,i.u_zoom),u_unpack:new t.Uniform4f(e,i.u_unpack)}},line:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_ratio:new t.Uniform1f(e,i.u_ratio),u_device_pixel_ratio:new t.Uniform1f(e,i.u_device_pixel_ratio),u_units_to_pixels:new t.Uniform2f(e,i.u_units_to_pixels)}},lineGradient:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_ratio:new t.Uniform1f(e,i.u_ratio),u_device_pixel_ratio:new t.Uniform1f(e,i.u_device_pixel_ratio),u_units_to_pixels:new t.Uniform2f(e,i.u_units_to_pixels),u_image:new t.Uniform1i(e,i.u_image),u_image_height:new t.Uniform1f(e,i.u_image_height)}},linePattern:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_texsize:new t.Uniform2f(e,i.u_texsize),u_ratio:new t.Uniform1f(e,i.u_ratio),u_device_pixel_ratio:new t.Uniform1f(e,i.u_device_pixel_ratio),u_image:new t.Uniform1i(e,i.u_image),u_units_to_pixels:new t.Uniform2f(e,i.u_units_to_pixels),u_scale:new t.Uniform3f(e,i.u_scale),u_fade:new t.Uniform1f(e,i.u_fade)}},lineSDF:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_ratio:new t.Uniform1f(e,i.u_ratio),u_device_pixel_ratio:new t.Uniform1f(e,i.u_device_pixel_ratio),u_units_to_pixels:new t.Uniform2f(e,i.u_units_to_pixels),u_patternscale_a:new t.Uniform2f(e,i.u_patternscale_a),u_patternscale_b:new t.Uniform2f(e,i.u_patternscale_b),u_sdfgamma:new t.Uniform1f(e,i.u_sdfgamma),u_image:new t.Uniform1i(e,i.u_image),u_tex_y_a:new t.Uniform1f(e,i.u_tex_y_a),u_tex_y_b:new t.Uniform1f(e,i.u_tex_y_b),u_mix:new t.Uniform1f(e,i.u_mix)}},raster:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_tl_parent:new t.Uniform2f(e,i.u_tl_parent),u_scale_parent:new t.Uniform1f(e,i.u_scale_parent),u_buffer_scale:new t.Uniform1f(e,i.u_buffer_scale),u_fade_t:new t.Uniform1f(e,i.u_fade_t),u_opacity:new t.Uniform1f(e,i.u_opacity),u_image0:new t.Uniform1i(e,i.u_image0),u_image1:new t.Uniform1i(e,i.u_image1),u_brightness_low:new t.Uniform1f(e,i.u_brightness_low),u_brightness_high:new t.Uniform1f(e,i.u_brightness_high),u_saturation_factor:new t.Uniform1f(e,i.u_saturation_factor),u_contrast_factor:new t.Uniform1f(e,i.u_contrast_factor),u_spin_weights:new t.Uniform3f(e,i.u_spin_weights)}},symbolIcon:function(e,i){return {u_is_size_zoom_constant:new t.Uniform1i(e,i.u_is_size_zoom_constant),u_is_size_feature_constant:new t.Uniform1i(e,i.u_is_size_feature_constant),u_size_t:new t.Uniform1f(e,i.u_size_t),u_size:new t.Uniform1f(e,i.u_size),u_camera_to_center_distance:new t.Uniform1f(e,i.u_camera_to_center_distance),u_pitch:new t.Uniform1f(e,i.u_pitch),u_rotate_symbol:new t.Uniform1i(e,i.u_rotate_symbol),u_aspect_ratio:new t.Uniform1f(e,i.u_aspect_ratio),u_fade_change:new t.Uniform1f(e,i.u_fade_change),u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_label_plane_matrix:new t.UniformMatrix4f(e,i.u_label_plane_matrix),u_coord_matrix:new t.UniformMatrix4f(e,i.u_coord_matrix),u_is_text:new t.Uniform1i(e,i.u_is_text),u_pitch_with_map:new t.Uniform1i(e,i.u_pitch_with_map),u_texsize:new t.Uniform2f(e,i.u_texsize),u_texture:new t.Uniform1i(e,i.u_texture)}},symbolSDF:function(e,i){return {u_is_size_zoom_constant:new t.Uniform1i(e,i.u_is_size_zoom_constant),u_is_size_feature_constant:new t.Uniform1i(e,i.u_is_size_feature_constant),u_size_t:new t.Uniform1f(e,i.u_size_t),u_size:new t.Uniform1f(e,i.u_size),u_camera_to_center_distance:new t.Uniform1f(e,i.u_camera_to_center_distance),u_pitch:new t.Uniform1f(e,i.u_pitch),u_rotate_symbol:new t.Uniform1i(e,i.u_rotate_symbol),u_aspect_ratio:new t.Uniform1f(e,i.u_aspect_ratio),u_fade_change:new t.Uniform1f(e,i.u_fade_change),u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_label_plane_matrix:new t.UniformMatrix4f(e,i.u_label_plane_matrix),u_coord_matrix:new t.UniformMatrix4f(e,i.u_coord_matrix),u_is_text:new t.Uniform1i(e,i.u_is_text),u_pitch_with_map:new t.Uniform1i(e,i.u_pitch_with_map),u_texsize:new t.Uniform2f(e,i.u_texsize),u_texture:new t.Uniform1i(e,i.u_texture),u_gamma_scale:new t.Uniform1f(e,i.u_gamma_scale),u_device_pixel_ratio:new t.Uniform1f(e,i.u_device_pixel_ratio),u_is_halo:new t.Uniform1i(e,i.u_is_halo)}},symbolTextAndIcon:function(e,i){return {u_is_size_zoom_constant:new t.Uniform1i(e,i.u_is_size_zoom_constant),u_is_size_feature_constant:new t.Uniform1i(e,i.u_is_size_feature_constant),u_size_t:new t.Uniform1f(e,i.u_size_t),u_size:new t.Uniform1f(e,i.u_size),u_camera_to_center_distance:new t.Uniform1f(e,i.u_camera_to_center_distance),u_pitch:new t.Uniform1f(e,i.u_pitch),u_rotate_symbol:new t.Uniform1i(e,i.u_rotate_symbol),u_aspect_ratio:new t.Uniform1f(e,i.u_aspect_ratio),u_fade_change:new t.Uniform1f(e,i.u_fade_change),u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_label_plane_matrix:new t.UniformMatrix4f(e,i.u_label_plane_matrix),u_coord_matrix:new t.UniformMatrix4f(e,i.u_coord_matrix),u_is_text:new t.Uniform1i(e,i.u_is_text),u_pitch_with_map:new t.Uniform1i(e,i.u_pitch_with_map),u_texsize:new t.Uniform2f(e,i.u_texsize),u_texsize_icon:new t.Uniform2f(e,i.u_texsize_icon),u_texture:new t.Uniform1i(e,i.u_texture),u_texture_icon:new t.Uniform1i(e,i.u_texture_icon),u_gamma_scale:new t.Uniform1f(e,i.u_gamma_scale),u_device_pixel_ratio:new t.Uniform1f(e,i.u_device_pixel_ratio),u_is_halo:new t.Uniform1i(e,i.u_is_halo)}},background:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_opacity:new t.Uniform1f(e,i.u_opacity),u_color:new t.UniformColor(e,i.u_color)}},backgroundPattern:function(e,i){return {u_matrix:new t.UniformMatrix4f(e,i.u_matrix),u_opacity:new t.Uniform1f(e,i.u_opacity),u_image:new t.Uniform1i(e,i.u_image),u_pattern_tl_a:new t.Uniform2f(e,i.u_pattern_tl_a),u_pattern_br_a:new t.Uniform2f(e,i.u_pattern_br_a),u_pattern_tl_b:new t.Uniform2f(e,i.u_pattern_tl_b),u_pattern_br_b:new t.Uniform2f(e,i.u_pattern_br_b),u_texsize:new t.Uniform2f(e,i.u_texsize),u_mix:new t.Uniform1f(e,i.u_mix),u_pattern_size_a:new t.Uniform2f(e,i.u_pattern_size_a),u_pattern_size_b:new t.Uniform2f(e,i.u_pattern_size_b),u_scale_a:new t.Uniform1f(e,i.u_scale_a),u_scale_b:new t.Uniform1f(e,i.u_scale_b),u_pixel_coord_upper:new t.Uniform2f(e,i.u_pixel_coord_upper),u_pixel_coord_lower:new t.Uniform2f(e,i.u_pixel_coord_lower),u_tile_units_to_pixels:new t.Uniform1f(e,i.u_tile_units_to_pixels)}}};function Ji(e,i,o,r,a,n,s){for(var l=e.context,c=l.gl,h=e.useProgram("collisionBox"),u=[],p=0,d=0,_=0;_<r.length;_++){var f=r[_],m=i.getTile(f),g=m.getBucket(o);if(g){var v=f.posMatrix;0===a[0]&&0===a[1]||(v=e.translatePosMatrix(f.posMatrix,m,a,n));var y=s?g.textCollisionBox:g.iconCollisionBox,x=g.collisionCircleArray;if(x.length>0){var b=t.create(),w=v;t.mul(b,g.placementInvProjMatrix,e.transform.glCoordMatrix),t.mul(b,b,g.placementViewportMatrix),u.push({circleArray:x,circleOffset:d,transform:w,invTransform:b}),d=p+=x.length/4;}y&&h.draw(l,c.LINES,It.disabled,Pt.disabled,e.colorModeForRenderPass(),zt.disabled,Li(v,e.transform,m),o.id,y.layoutVertexBuffer,y.indexBuffer,y.segments,null,e.transform.zoom,null,null,y.collisionVertexBuffer);}}if(s&&u.length){var E=e.useProgram("collisionCircle"),T=new t.StructArrayLayout2f1f2i16;T.resize(4*p),T._trim();for(var S=0,I=0,P=u;I<P.length;I+=1)for(var C=P[I],z=0;z<C.circleArray.length/4;z++){var M=4*z,L=C.circleArray[M+0],D=C.circleArray[M+1],R=C.circleArray[M+2],A=C.circleArray[M+3];T.emplace(S++,L,D,R,A,0),T.emplace(S++,L,D,R,A,1),T.emplace(S++,L,D,R,A,2),T.emplace(S++,L,D,R,A,3);}(!qi||qi.length<2*p)&&(qi=function(e){var i=2*e,o=new t.StructArrayLayout3ui6;o.resize(i),o._trim();for(var r=0;r<i;r++){var a=6*r;o.uint16[a+0]=4*r+0,o.uint16[a+1]=4*r+1,o.uint16[a+2]=4*r+2,o.uint16[a+3]=4*r+2,o.uint16[a+4]=4*r+3,o.uint16[a+5]=4*r+0;}return o}(p));for(var k=l.createIndexBuffer(qi,!0),O=l.createVertexBuffer(T,t.collisionCircleLayout.members,!0),B=0,F=u;B<F.length;B+=1){var U=F[B],N=Di(U.transform,U.invTransform,e.transform);E.draw(l,c.TRIANGLES,It.disabled,Pt.disabled,e.colorModeForRenderPass(),zt.disabled,N,o.id,O,k,t.SegmentVector.simpleSegment(0,2*U.circleOffset,U.circleArray.length,U.circleArray.length/2),null,e.transform.zoom,null,null,null);}O.destroy(),k.destroy();}}var Qi=t.identity(new Float32Array(16));function $i(e,i,o,r,a,n){var s=t.getAnchorAlignment(e),l=-(s.horizontalAlign-.5)*i,c=-(s.verticalAlign-.5)*o,h=t.evaluateVariableOffset(e,r);return new t.Point((l/a+h[0])*n,(c/a+h[1])*n)}function to(e,i,o,r,a,n,s,l,c,h,u){var p=e.text.placedSymbolArray,d=e.text.dynamicLayoutVertexArray,_=e.icon.dynamicLayoutVertexArray,f={};d.clear();for(var m=0;m<p.length;m++){var g=p.get(m),v=g.hidden||!g.crossTileID||e.allowVerticalPlacement&&!g.placedOrientation?null:r[g.crossTileID];if(v){var y=new t.Point(g.anchorX,g.anchorY),x=te(y,o?l:s),b=ee(n.cameraToCenterDistance,x.signedDistanceFromCamera),w=a.evaluateSizeForFeature(e.textSizeData,h,g)*b/t.ONE_EM;o&&(w*=e.tilePixelRatio/c);for(var E=$i(v.anchor,v.width,v.height,v.textOffset,v.textBoxScale,w),T=o?te(y.add(E),s).point:x.point.add(i?E.rotate(-n.angle):E),S=e.allowVerticalPlacement&&g.placedOrientation===t.WritingMode.vertical?Math.PI/2:0,I=0;I<g.numGlyphs;I++)t.addDynamicAttributes(d,T,S);u&&g.associatedIconIndex>=0&&(f[g.associatedIconIndex]={shiftedAnchor:T,angle:S});}else he(g.numGlyphs,d);}if(u){_.clear();for(var P=e.icon.placedSymbolArray,C=0;C<P.length;C++){var z=P.get(C);if(z.hidden)he(z.numGlyphs,_);else {var M=f[C];if(M)for(var L=0;L<z.numGlyphs;L++)t.addDynamicAttributes(_,M.shiftedAnchor,M.angle);else he(z.numGlyphs,_);}}e.icon.dynamicLayoutVertexBuffer.updateData(_);}e.text.dynamicLayoutVertexBuffer.updateData(d);}function eo(t,e,i){return i.iconsInText&&e?"symbolTextAndIcon":t?"symbolSDF":"symbolIcon"}function io(e,i,o,r,a,n,s,l,c,h,u,p){for(var d=e.context,_=d.gl,f=e.transform,m="map"===l,g="map"===c,v=m&&"point"!==o.layout.get("symbol-placement"),y=m&&!g&&!v,x=void 0!==o.layout.get("symbol-sort-key").constantOr(1),b=e.depthModeForSublayer(0,It.ReadOnly),w=o.layout.get("text-variable-anchor"),E=[],T=0,S=r;T<S.length;T+=1){var I=S[T],P=i.getTile(I),C=P.getBucket(o);if(C){var z=a?C.text:C.icon;if(z&&z.segments.get().length){var M=z.programConfigurations.get(o.id),L=a||C.sdfIcons,D=a?C.textSizeData:C.iconSizeData,R=g||0!==f.pitch,A=e.useProgram(eo(L,a,C),M),k=t.evaluateSizeForZoom(D,f.zoom),O=void 0,B=[0,0],F=void 0,U=void 0,N=null,j=void 0;if(a)F=P.glyphAtlasTexture,U=_.LINEAR,O=P.glyphAtlasTexture.size,C.iconsInText&&(B=P.imageAtlasTexture.size,N=P.imageAtlasTexture,j=R||e.options.rotating||e.options.zooming||"composite"===D.kind||"camera"===D.kind?_.LINEAR:_.NEAREST);else {var G=1!==o.layout.get("icon-size").constantOr(0)||C.iconsNeedLinear;F=P.imageAtlasTexture,U=L||e.options.rotating||e.options.zooming||G||R?_.LINEAR:_.NEAREST,O=P.imageAtlasTexture.size;}var Z=de(P,1,e.transform.zoom),q=Qt(I.posMatrix,g,m,e.transform,Z),V=$t(I.posMatrix,g,m,e.transform,Z),W=w&&C.hasTextData(),X="none"!==o.layout.get("icon-text-fit")&&W&&C.hasIconData();v&&oe(C,I.posMatrix,e,a,q,V,g,h);var H=e.translatePosMatrix(I.posMatrix,P,n,s),K=v||a&&w||X?Qi:q,Y=e.translatePosMatrix(V,P,n,s,!0),J=L&&0!==o.paint.get(a?"text-halo-width":"icon-halo-width").constantOr(1),Q={program:A,buffers:z,uniformValues:L?C.iconsInText?Xi(D.kind,k,y,g,e,H,K,Y,O,B):Wi(D.kind,k,y,g,e,H,K,Y,a,O,!0):Vi(D.kind,k,y,g,e,H,K,Y,a,O),atlasTexture:F,atlasTextureIcon:N,atlasInterpolation:U,atlasInterpolationIcon:j,isSDF:L,hasHalo:J};if(x)for(var $=0,tt=z.segments.get();$<tt.length;$+=1){var et=tt[$];E.push({segments:new t.SegmentVector([et]),sortKey:et.sortKey,state:Q});}else E.push({segments:z.segments,sortKey:0,state:Q});}}}x&&E.sort((function(t,e){return t.sortKey-e.sortKey}));for(var it=0,ot=E;it<ot.length;it+=1){var rt=ot[it],at=rt.state;if(d.activeTexture.set(_.TEXTURE0),at.atlasTexture.bind(at.atlasInterpolation,_.CLAMP_TO_EDGE),at.atlasTextureIcon&&(d.activeTexture.set(_.TEXTURE1),at.atlasTextureIcon&&at.atlasTextureIcon.bind(at.atlasInterpolationIcon,_.CLAMP_TO_EDGE)),at.isSDF){var nt=at.uniformValues;at.hasHalo&&(nt.u_is_halo=1,oo(at.buffers,rt.segments,o,e,at.program,b,u,p,nt)),nt.u_is_halo=0;}oo(at.buffers,rt.segments,o,e,at.program,b,u,p,at.uniformValues);}}function oo(t,e,i,o,r,a,n,s,l){var c=o.context;r.draw(c,c.gl.TRIANGLES,a,n,s,zt.disabled,l,i.id,t.layoutVertexBuffer,t.indexBuffer,e,i.paint,o.transform.zoom,t.programConfigurations.get(i.id),t.dynamicLayoutVertexBuffer,t.opacityVertexBuffer);}function ro(t,e,i,o,r,a,n){var s,l,c,h,u,p=t.context.gl,d=i.paint.get("fill-pattern"),_=d&&d.constantOr(1),f=i.getCrossfadeParameters();n?(l=_&&!i.getPaintProperty("fill-outline-color")?"fillOutlinePattern":"fillOutline",s=p.LINES):(l=_?"fillPattern":"fill",s=p.TRIANGLES);for(var m=0,g=o;m<g.length;m+=1){var v=g[m],y=e.getTile(v);if(!_||y.patternsLoaded()){var x=y.getBucket(i);if(x){var b=x.programConfigurations.get(i.id),w=t.useProgram(l,b);_&&(t.context.activeTexture.set(p.TEXTURE0),y.imageAtlasTexture.bind(p.LINEAR,p.CLAMP_TO_EDGE),b.updatePaintBuffers(f));var E=d.constantOr(null);if(E&&y.imageAtlas){var T=y.imageAtlas,S=T.patternPositions[E.to.toString()],I=T.patternPositions[E.from.toString()];S&&I&&b.setConstantPatternPositions(S,I);}var P=t.translatePosMatrix(v.posMatrix,y,i.paint.get("fill-translate"),i.paint.get("fill-translate-anchor"));if(n){h=x.indexBuffer2,u=x.segments2;var C=[p.drawingBufferWidth,p.drawingBufferHeight];c="fillOutlinePattern"===l&&_?zi(P,t,f,y,C):Ci(P,C);}else h=x.indexBuffer,u=x.segments,c=_?Pi(P,t,f,y):Ii(P);w.draw(t.context,s,r,t.stencilModeForClipping(v),a,zt.disabled,c,i.id,x.layoutVertexBuffer,h,u,i.paint,t.transform.zoom,b);}}}}function ao(t,e,i,o,r,a,n){for(var s=t.context,l=s.gl,c=i.paint.get("fill-extrusion-pattern"),h=c.constantOr(1),u=i.getCrossfadeParameters(),p=i.paint.get("fill-extrusion-opacity"),d=0,_=o;d<_.length;d+=1){var f=_[d],m=e.getTile(f),g=m.getBucket(i);if(g){var v=g.programConfigurations.get(i.id),y=t.useProgram(h?"fillExtrusionPattern":"fillExtrusion",v);h&&(t.context.activeTexture.set(l.TEXTURE0),m.imageAtlasTexture.bind(l.LINEAR,l.CLAMP_TO_EDGE),v.updatePaintBuffers(u));var x=c.constantOr(null);if(x&&m.imageAtlas){var b=m.imageAtlas,w=b.patternPositions[x.to.toString()],E=b.patternPositions[x.from.toString()];w&&E&&v.setConstantPatternPositions(w,E);}var T=t.translatePosMatrix(f.posMatrix,m,i.paint.get("fill-extrusion-translate"),i.paint.get("fill-extrusion-translate-anchor")),S=i.paint.get("fill-extrusion-vertical-gradient"),I=h?Si(T,t,S,p,f,u,m):Ti(T,t,S,p);y.draw(s,s.gl.TRIANGLES,r,a,n,zt.backCCW,I,i.id,g.layoutVertexBuffer,g.indexBuffer,g.segments,i.paint,t.transform.zoom,v);}}}function no(e,i,o,r,a,n){var s=e.context,l=s.gl,c=i.fbo;if(c){var h=e.useProgram("hillshade");s.activeTexture.set(l.TEXTURE0),l.bindTexture(l.TEXTURE_2D,c.colorAttachment.get());var u=function(e,i,o){var r=o.paint.get("hillshade-shadow-color"),a=o.paint.get("hillshade-highlight-color"),n=o.paint.get("hillshade-accent-color"),s=o.paint.get("hillshade-illumination-direction")*(Math.PI/180);"viewport"===o.paint.get("hillshade-illumination-anchor")&&(s-=e.transform.angle);var l,c,h,u=!e.options.moving;return {u_matrix:e.transform.calculatePosMatrix(i.tileID.toUnwrapped(),u),u_image:0,u_latrange:(l=i.tileID,c=Math.pow(2,l.canonical.z),h=l.canonical.y,[new t.MercatorCoordinate(0,h/c).toLngLat().lat,new t.MercatorCoordinate(0,(h+1)/c).toLngLat().lat]),u_light:[o.paint.get("hillshade-exaggeration"),s],u_shadow:r,u_highlight:a,u_accent:n}}(e,i,o);h.draw(s,l.TRIANGLES,r,a,n,zt.disabled,u,o.id,e.rasterBoundsBuffer,e.quadTriangleIndexBuffer,e.rasterBoundsSegments);}}function so(e,i,o,r,a,n){var s=e.context,l=s.gl,c=i.dem;if(c&&c.data){var h=c.dim,u=c.stride,p=c.getPixels();if(s.activeTexture.set(l.TEXTURE1),s.pixelStoreUnpackPremultiplyAlpha.set(!1),i.demTexture=i.demTexture||e.getTileTexture(u),i.demTexture){var d=i.demTexture;d.update(p,{premultiply:!1}),d.bind(l.NEAREST,l.CLAMP_TO_EDGE);}else i.demTexture=new t.Texture(s,p,l.RGBA,{premultiply:!1}),i.demTexture.bind(l.NEAREST,l.CLAMP_TO_EDGE);s.activeTexture.set(l.TEXTURE0);var _=i.fbo;if(!_){var f=new t.Texture(s,{width:h,height:h,data:null},l.RGBA);f.bind(l.LINEAR,l.CLAMP_TO_EDGE),(_=i.fbo=s.createFramebuffer(h,h,!0)).colorAttachment.set(f.texture);}s.bindFramebuffer.set(_.framebuffer),s.viewport.set([0,0,h,h]),e.useProgram("hillshadePrepare").draw(s,l.TRIANGLES,r,a,n,zt.disabled,function(e,i){var o=i.stride,r=t.create();return t.ortho(r,0,t.EXTENT,-t.EXTENT,0,0,1),t.translate(r,r,[0,-t.EXTENT,0]),{u_matrix:r,u_image:1,u_dimension:[o,o],u_zoom:e.overscaledZ,u_unpack:i.getUnpackVector()}}(i.tileID,c),o.id,e.rasterBoundsBuffer,e.quadTriangleIndexBuffer,e.rasterBoundsSegments),i.needsHillshadePrepare=!1;}}function lo(e,i,o,r,a){var n=r.paint.get("raster-fade-duration");if(n>0){var s=t.browser.now(),l=(s-e.timeAdded)/n,c=i?(s-i.timeAdded)/n:-1,h=o.getSource(),u=a.coveringZoomLevel({tileSize:h.tileSize,roundZoom:h.roundZoom}),p=!i||Math.abs(i.tileID.overscaledZ-u)>Math.abs(e.tileID.overscaledZ-u),d=p&&e.refreshedUponExpiration?1:t.clamp(p?l:1-c,0,1);return e.refreshedUponExpiration&&l>=1&&(e.refreshedUponExpiration=!1),i?{opacity:1,mix:1-d}:{opacity:d,mix:0}}return {opacity:1,mix:0}}var co=new t.Color(1,0,0,1),ho=new t.Color(0,1,0,1),uo=new t.Color(0,0,1,1),po=new t.Color(1,0,1,1),_o=new t.Color(0,1,1,1);function fo(t,e,i,o){go(t,0,e+i/2,t.transform.width,i,o);}function mo(t,e,i,o){go(t,e-i/2,0,i,t.transform.height,o);}function go(e,i,o,r,a,n){var s=e.context,l=s.gl;l.enable(l.SCISSOR_TEST),l.scissor(i*t.browser.devicePixelRatio,o*t.browser.devicePixelRatio,r*t.browser.devicePixelRatio,a*t.browser.devicePixelRatio),s.clear({color:n}),l.disable(l.SCISSOR_TEST);}function vo(e,i,o){var r=e.context,a=r.gl,n=o.posMatrix,s=e.useProgram("debug"),l=It.disabled,c=Pt.disabled,h=e.colorModeForRenderPass();r.activeTexture.set(a.TEXTURE0),e.emptyTexture.bind(a.LINEAR,a.CLAMP_TO_EDGE),s.draw(r,a.LINE_STRIP,l,c,h,zt.disabled,Ri(n,t.Color.red),"$debug",e.debugBuffer,e.tileBorderIndexBuffer,e.debugSegments);var u=i.getTileByID(o.key).latestRawTileData,p=Math.floor((u&&u.byteLength||0)/1024),d=i.getTile(o).tileSize,_=512/Math.min(d,512)*(o.overscaledZ/e.transform.zoom)*.5,f=o.canonical.toString();o.overscaledZ!==o.canonical.z&&(f+=" => "+o.overscaledZ),function(t,e){t.initDebugOverlayCanvas();var i=t.debugOverlayCanvas,o=t.context.gl,r=t.debugOverlayCanvas.getContext("2d");r.clearRect(0,0,i.width,i.height),r.shadowColor="white",r.shadowBlur=2,r.lineWidth=1.5,r.strokeStyle="white",r.textBaseline="top",r.font="bold 36px Open Sans, sans-serif",r.fillText(e,5,5),r.strokeText(e,5,5),t.debugOverlayTexture.update(i),t.debugOverlayTexture.bind(o.LINEAR,o.CLAMP_TO_EDGE);}(e,f+" "+p+"kb"),s.draw(r,a.TRIANGLES,l,c,Ct.alphaBlended,zt.disabled,Ri(n,t.Color.transparent,_),"$debug",e.debugBuffer,e.quadTriangleIndexBuffer,e.debugSegments);}var yo={symbol:function(e,i,o,r,a){if("translucent"===e.renderPass){var n=Pt.disabled,s=e.colorModeForRenderPass();o.layout.get("text-variable-anchor")&&function(e,i,o,r,a,n,s){for(var l=i.transform,c="map"===a,h="map"===n,u=0,p=e;u<p.length;u+=1){var d=p[u],_=r.getTile(d),f=_.getBucket(o);if(f&&f.text&&f.text.segments.get().length){var m=t.evaluateSizeForZoom(f.textSizeData,l.zoom),g=de(_,1,i.transform.zoom),v=Qt(d.posMatrix,h,c,i.transform,g),y="none"!==o.layout.get("icon-text-fit")&&f.hasIconData();if(m){var x=Math.pow(2,l.zoom-_.tileID.overscaledZ);to(f,c,h,s,t.symbolSize,l,v,d.posMatrix,x,m,y);}}}}(r,e,o,i,o.layout.get("text-rotation-alignment"),o.layout.get("text-pitch-alignment"),a),0!==o.paint.get("icon-opacity").constantOr(1)&&io(e,i,o,r,!1,o.paint.get("icon-translate"),o.paint.get("icon-translate-anchor"),o.layout.get("icon-rotation-alignment"),o.layout.get("icon-pitch-alignment"),o.layout.get("icon-keep-upright"),n,s),0!==o.paint.get("text-opacity").constantOr(1)&&io(e,i,o,r,!0,o.paint.get("text-translate"),o.paint.get("text-translate-anchor"),o.layout.get("text-rotation-alignment"),o.layout.get("text-pitch-alignment"),o.layout.get("text-keep-upright"),n,s),i.map.showCollisionBoxes&&(Ji(e,i,o,r,o.paint.get("text-translate"),o.paint.get("text-translate-anchor"),!0),Ji(e,i,o,r,o.paint.get("icon-translate"),o.paint.get("icon-translate-anchor"),!1));}},circle:function(e,i,o,r){if("translucent"===e.renderPass){var a=o.paint.get("circle-opacity"),n=o.paint.get("circle-stroke-width"),s=o.paint.get("circle-stroke-opacity"),l=void 0!==o.layout.get("circle-sort-key").constantOr(1);if(0!==a.constantOr(1)||0!==n.constantOr(1)&&0!==s.constantOr(1)){for(var c=e.context,h=c.gl,u=e.depthModeForSublayer(0,It.ReadOnly),p=Pt.disabled,d=e.colorModeForRenderPass(),_=[],f=0;f<r.length;f++){var m=r[f],g=i.getTile(m),v=g.getBucket(o);if(v){var y=v.programConfigurations.get(o.id),x={programConfiguration:y,program:e.useProgram("circle",y),layoutVertexBuffer:v.layoutVertexBuffer,indexBuffer:v.indexBuffer,uniformValues:Mi(e,m,g,o)};if(l)for(var b=0,w=v.segments.get();b<w.length;b+=1){var E=w[b];_.push({segments:new t.SegmentVector([E]),sortKey:E.sortKey,state:x});}else _.push({segments:v.segments,sortKey:0,state:x});}}l&&_.sort((function(t,e){return t.sortKey-e.sortKey}));for(var T=0,S=_;T<S.length;T+=1){var I=S[T],P=I.state;P.program.draw(c,h.TRIANGLES,u,p,d,zt.disabled,P.uniformValues,o.id,P.layoutVertexBuffer,P.indexBuffer,I.segments,o.paint,e.transform.zoom,P.programConfiguration);}}}},heatmap:function(e,i,o,r){if(0!==o.paint.get("heatmap-opacity"))if("offscreen"===e.renderPass){var a=e.context,n=a.gl,s=Pt.disabled,l=new Ct([n.ONE,n.ONE],t.Color.transparent,[!0,!0,!0,!0]);!function(t,e,i){var o=t.gl;t.activeTexture.set(o.TEXTURE1),t.viewport.set([0,0,e.width/4,e.height/4]);var r=i.heatmapFbo;if(r)o.bindTexture(o.TEXTURE_2D,r.colorAttachment.get()),t.bindFramebuffer.set(r.framebuffer);else {var a=o.createTexture();o.bindTexture(o.TEXTURE_2D,a),o.texParameteri(o.TEXTURE_2D,o.TEXTURE_WRAP_S,o.CLAMP_TO_EDGE),o.texParameteri(o.TEXTURE_2D,o.TEXTURE_WRAP_T,o.CLAMP_TO_EDGE),o.texParameteri(o.TEXTURE_2D,o.TEXTURE_MIN_FILTER,o.LINEAR),o.texParameteri(o.TEXTURE_2D,o.TEXTURE_MAG_FILTER,o.LINEAR),r=i.heatmapFbo=t.createFramebuffer(e.width/4,e.height/4,!1),function(t,e,i,o){var r=t.gl;r.texImage2D(r.TEXTURE_2D,0,r.RGBA,e.width/4,e.height/4,0,r.RGBA,t.extRenderToTextureHalfFloat?t.extTextureHalfFloat.HALF_FLOAT_OES:r.UNSIGNED_BYTE,null),o.colorAttachment.set(i);}(t,e,a,r);}}(a,e,o),a.clear({color:t.Color.transparent});for(var c=0;c<r.length;c++){var h=r[c];if(!i.hasRenderableParent(h)){var u=i.getTile(h),p=u.getBucket(o);if(p){var d=p.programConfigurations.get(o.id);e.useProgram("heatmap",d).draw(a,n.TRIANGLES,It.disabled,s,l,zt.disabled,ki(h.posMatrix,u,e.transform.zoom,o.paint.get("heatmap-intensity")),o.id,p.layoutVertexBuffer,p.indexBuffer,p.segments,o.paint,e.transform.zoom,d);}}}a.viewport.set([0,0,e.width,e.height]);}else "translucent"===e.renderPass&&(e.context.setColorMode(e.colorModeForRenderPass()),function(e,i){var o=e.context,r=o.gl,a=i.heatmapFbo;if(a){o.activeTexture.set(r.TEXTURE0),r.bindTexture(r.TEXTURE_2D,a.colorAttachment.get()),o.activeTexture.set(r.TEXTURE1);var n=i.colorRampTexture;n||(n=i.colorRampTexture=new t.Texture(o,i.colorRamp,r.RGBA)),n.bind(r.LINEAR,r.CLAMP_TO_EDGE),e.useProgram("heatmapTexture").draw(o,r.TRIANGLES,It.disabled,Pt.disabled,e.colorModeForRenderPass(),zt.disabled,function(e,i,o,r){var a=t.create();t.ortho(a,0,e.width,e.height,0,0,1);var n=e.context.gl;return {u_matrix:a,u_world:[n.drawingBufferWidth,n.drawingBufferHeight],u_image:0,u_color_ramp:1,u_opacity:i.paint.get("heatmap-opacity")}}(e,i),i.id,e.viewportBuffer,e.quadTriangleIndexBuffer,e.viewportSegments,i.paint,e.transform.zoom);}}(e,o));},line:function(e,i,o,r){if("translucent"===e.renderPass){var a=o.paint.get("line-opacity"),n=o.paint.get("line-width");if(0!==a.constantOr(1)&&0!==n.constantOr(1))for(var s=e.depthModeForSublayer(0,It.ReadOnly),l=e.colorModeForRenderPass(),c=o.paint.get("line-dasharray"),h=o.paint.get("line-pattern"),u=h.constantOr(1),p=o.paint.get("line-gradient"),d=o.getCrossfadeParameters(),_=u?"linePattern":c?"lineSDF":p?"lineGradient":"line",f=e.context,m=f.gl,g=!0,v=0,y=r;v<y.length;v+=1){var x=y[v],b=i.getTile(x);if(!u||b.patternsLoaded()){var w=b.getBucket(o);if(w){var E=w.programConfigurations.get(o.id),T=e.context.program.get(),S=e.useProgram(_,E),I=g||S.program!==T,P=h.constantOr(null);if(P&&b.imageAtlas){var C=b.imageAtlas,z=C.patternPositions[P.to.toString()],M=C.patternPositions[P.from.toString()];z&&M&&E.setConstantPatternPositions(z,M);}var L=u?Fi(e,b,o,d):c?Ui(e,b,o,c,d):p?Bi(e,b,o,w.lineClipsArray.length):Oi(e,b,o);if(u)f.activeTexture.set(m.TEXTURE0),b.imageAtlasTexture.bind(m.LINEAR,m.CLAMP_TO_EDGE),E.updatePaintBuffers(d);else if(c&&(I||e.lineAtlas.dirty))f.activeTexture.set(m.TEXTURE0),e.lineAtlas.bind(f);else if(p){var D=w.gradients[o.id],R=D.texture;if(o.gradientVersion!==D.version){var A=256;if(o.stepInterpolant){var k=i.getSource().maxzoom,O=x.canonical.z===k?Math.ceil(1<<e.transform.maxZoom-x.canonical.z):1;A=t.clamp(t.nextPowerOfTwo(w.maxLineLength/t.EXTENT*1024*O),256,f.maxTextureSize);}D.gradient=t.renderColorRamp({expression:o.gradientExpression(),evaluationKey:"lineProgress",resolution:A,image:D.gradient||void 0,clips:w.lineClipsArray}),D.texture?D.texture.update(D.gradient):D.texture=new t.Texture(f,D.gradient,m.RGBA),D.version=o.gradientVersion,R=D.texture;}f.activeTexture.set(m.TEXTURE0),R.bind(o.stepInterpolant?m.NEAREST:m.LINEAR,m.CLAMP_TO_EDGE);}S.draw(f,m.TRIANGLES,s,e.stencilModeForClipping(x),l,zt.disabled,L,o.id,w.layoutVertexBuffer,w.indexBuffer,w.segments,o.paint,e.transform.zoom,E,w.layoutVertexBuffer2),g=!1;}}}}},fill:function(e,i,o,r){var a=o.paint.get("fill-color"),n=o.paint.get("fill-opacity");if(0!==n.constantOr(1)){var s=e.colorModeForRenderPass(),l=o.paint.get("fill-pattern"),c=e.opaquePassEnabledForLayer()&&!l.constantOr(1)&&1===a.constantOr(t.Color.transparent).a&&1===n.constantOr(0)?"opaque":"translucent";if(e.renderPass===c){var h=e.depthModeForSublayer(1,"opaque"===e.renderPass?It.ReadWrite:It.ReadOnly);ro(e,i,o,r,h,s,!1);}if("translucent"===e.renderPass&&o.paint.get("fill-antialias")){var u=e.depthModeForSublayer(o.getPaintProperty("fill-outline-color")?2:0,It.ReadOnly);ro(e,i,o,r,u,s,!0);}}},"fill-extrusion":function(t,e,i,o){var r=i.paint.get("fill-extrusion-opacity");if(0!==r&&"translucent"===t.renderPass){var a=new It(t.context.gl.LEQUAL,It.ReadWrite,t.depthRangeFor3D);if(1!==r||i.paint.get("fill-extrusion-pattern").constantOr(1))ao(t,e,i,o,a,Pt.disabled,Ct.disabled),ao(t,e,i,o,a,t.stencilModeFor3D(),t.colorModeForRenderPass());else {var n=t.colorModeForRenderPass();ao(t,e,i,o,a,Pt.disabled,n);}}},hillshade:function(t,e,i,o){if("offscreen"===t.renderPass||"translucent"===t.renderPass){for(var r=t.context,a=t.depthModeForSublayer(0,It.ReadOnly),n=t.colorModeForRenderPass(),s="translucent"===t.renderPass?t.stencilConfigForOverlap(o):[{},o],l=s[0],c=0,h=s[1];c<h.length;c+=1){var u=h[c],p=e.getTile(u);p.needsHillshadePrepare&&"offscreen"===t.renderPass?so(t,p,i,a,Pt.disabled,n):"translucent"===t.renderPass&&no(t,p,i,a,l[u.overscaledZ],n);}r.viewport.set([0,0,t.width,t.height]);}},raster:function(t,e,i,o){if("translucent"===t.renderPass&&0!==i.paint.get("raster-opacity")&&o.length)for(var r=t.context,a=r.gl,n=e.getSource(),s=t.useProgram("raster"),l=t.colorModeForRenderPass(),c=n instanceof R?[{},o]:t.stencilConfigForOverlap(o),h=c[0],u=c[1],p=u[u.length-1].overscaledZ,d=!t.options.moving,_=0,f=u;_<f.length;_+=1){var m=f[_],g=t.depthModeForSublayer(m.overscaledZ-p,1===i.paint.get("raster-opacity")?It.ReadWrite:It.ReadOnly,a.LESS),v=e.getTile(m),y=t.transform.calculatePosMatrix(m.toUnwrapped(),d);v.registerFadeDuration(i.paint.get("raster-fade-duration"));var x=e.findLoadedParent(m,0),b=lo(v,x,e,i,t.transform),w=void 0,E=void 0,T="nearest"===i.paint.get("raster-resampling")?a.NEAREST:a.LINEAR;r.activeTexture.set(a.TEXTURE0),v.texture.bind(T,a.CLAMP_TO_EDGE,a.LINEAR_MIPMAP_NEAREST),r.activeTexture.set(a.TEXTURE1),x?(x.texture.bind(T,a.CLAMP_TO_EDGE,a.LINEAR_MIPMAP_NEAREST),w=Math.pow(2,x.tileID.overscaledZ-v.tileID.overscaledZ),E=[v.tileID.canonical.x*w%1,v.tileID.canonical.y*w%1]):v.texture.bind(T,a.CLAMP_TO_EDGE,a.LINEAR_MIPMAP_NEAREST);var S=Gi(y,E||[0,0],w||1,b,i);n instanceof R?s.draw(r,a.TRIANGLES,g,Pt.disabled,l,zt.disabled,S,i.id,n.boundsBuffer,t.quadTriangleIndexBuffer,n.boundsSegments):s.draw(r,a.TRIANGLES,g,h[m.overscaledZ],l,zt.disabled,S,i.id,t.rasterBoundsBuffer,t.quadTriangleIndexBuffer,t.rasterBoundsSegments);}},background:function(t,e,i){var o=i.paint.get("background-color"),r=i.paint.get("background-opacity");if(0!==r){var a=t.context,n=a.gl,s=t.transform,l=s.tileSize,c=i.paint.get("background-pattern");if(!t.isPatternMissing(c)){var h=!c&&1===o.a&&1===r&&t.opaquePassEnabledForLayer()?"opaque":"translucent";if(t.renderPass===h){var u=Pt.disabled,p=t.depthModeForSublayer(0,"opaque"===h?It.ReadWrite:It.ReadOnly),d=t.colorModeForRenderPass(),_=t.useProgram(c?"backgroundPattern":"background"),f=s.coveringTiles({tileSize:l});c&&(a.activeTexture.set(n.TEXTURE0),t.imageManagerFactory.bind(t.context));for(var m=i.getCrossfadeParameters(),g=0,v=f;g<v.length;g+=1){var y=v[g],x=t.transform.calculatePosMatrix(y.toUnwrapped()),b=c?Ki(x,r,t,c,{tileID:y,tileSize:l},m):Hi(x,r,o);_.draw(a,n.TRIANGLES,p,u,d,zt.disabled,b,i.id,t.tileExtentBuffer,t.quadTriangleIndexBuffer,t.tileExtentSegments);}}}}},debug:function(t,e,i){for(var o=0;o<i.length;o++)vo(t,e,i[o]);},custom:function(t,e,i){var o=t.context,r=i.implementation;if("offscreen"===t.renderPass){var a=r.prerender;a&&(t.setCustomLayerDefaults(),o.setColorMode(t.colorModeForRenderPass()),a.call(r,o.gl,t.transform.customLayerMatrix()),o.setDirty(),t.setBaseState());}else if("translucent"===t.renderPass){t.setCustomLayerDefaults(),o.setColorMode(t.colorModeForRenderPass()),o.setStencilMode(Pt.disabled);var n="3d"===r.renderingMode?new It(t.context.gl.LEQUAL,It.ReadWrite,t.depthRangeFor3D):t.depthModeForSublayer(0,It.ReadOnly);o.setDepthMode(n),r.render(o.gl,t.transform.customLayerMatrix()),o.setDirty(),t.setBaseState(),o.bindFramebuffer.set(null);}}},xo=function(t,e){this.context=new Mt(t),this.transform=e,this._tileTextures={},this.setup(),this.numSublayers=Lt.maxUnderzooming+Lt.maxOverzooming+1,this.depthEpsilon=1/Math.pow(2,16),this.crossTileSymbolIndex=new Ue,this.gpuTimers={};};xo.prototype.resize=function(e,i){if(this.width=e*t.browser.devicePixelRatio,this.height=i*t.browser.devicePixelRatio,this.context.viewport.set([0,0,this.width,this.height]),this.style)for(var o=0,r=this.style._order;o<r.length;o+=1)this.style._layers[r[o]].resize();},xo.prototype.setup=function(){var e=this.context,i=new t.StructArrayLayout2i4;i.emplaceBack(0,0),i.emplaceBack(t.EXTENT,0),i.emplaceBack(0,t.EXTENT),i.emplaceBack(t.EXTENT,t.EXTENT),this.tileExtentBuffer=e.createVertexBuffer(i,Ve.members),this.tileExtentSegments=t.SegmentVector.simpleSegment(0,0,4,2);var o=new t.StructArrayLayout2i4;o.emplaceBack(0,0),o.emplaceBack(t.EXTENT,0),o.emplaceBack(0,t.EXTENT),o.emplaceBack(t.EXTENT,t.EXTENT),this.debugBuffer=e.createVertexBuffer(o,Ve.members),this.debugSegments=t.SegmentVector.simpleSegment(0,0,4,5);var r=new t.StructArrayLayout4i8;r.emplaceBack(0,0,0,0),r.emplaceBack(t.EXTENT,0,t.EXTENT,0),r.emplaceBack(0,t.EXTENT,0,t.EXTENT),r.emplaceBack(t.EXTENT,t.EXTENT,t.EXTENT,t.EXTENT),this.rasterBoundsBuffer=e.createVertexBuffer(r,D.members),this.rasterBoundsSegments=t.SegmentVector.simpleSegment(0,0,4,2);var a=new t.StructArrayLayout2i4;a.emplaceBack(0,0),a.emplaceBack(1,0),a.emplaceBack(0,1),a.emplaceBack(1,1),this.viewportBuffer=e.createVertexBuffer(a,Ve.members),this.viewportSegments=t.SegmentVector.simpleSegment(0,0,4,2);var n=new t.StructArrayLayout1ui2;n.emplaceBack(0),n.emplaceBack(1),n.emplaceBack(3),n.emplaceBack(2),n.emplaceBack(0),this.tileBorderIndexBuffer=e.createIndexBuffer(n);var s=new t.StructArrayLayout3ui6;s.emplaceBack(0,1,2),s.emplaceBack(2,1,3),this.quadTriangleIndexBuffer=e.createIndexBuffer(s),this.emptyTexture=new t.Texture(e,{width:1,height:1,data:new Uint8Array([0,0,0,0])},e.gl.RGBA);var l=this.context.gl;this.stencilClearMode=new Pt({func:l.ALWAYS,mask:0},0,255,l.ZERO,l.ZERO,l.ZERO);},xo.prototype.clearStencil=function(){var e=this.context,i=e.gl;this.nextStencilID=1,this.currentStencilSource=void 0;var o=t.create();t.ortho(o,0,this.width,this.height,0,0,1),t.scale(o,o,[i.drawingBufferWidth,i.drawingBufferHeight,0]),this.useProgram("clippingMask").draw(e,i.TRIANGLES,It.disabled,this.stencilClearMode,Ct.disabled,zt.disabled,Ai(o),"$clipping",this.viewportBuffer,this.quadTriangleIndexBuffer,this.viewportSegments);},xo.prototype._renderTileClippingMasks=function(t,e){if(this.currentStencilSource!==t.source&&t.isTileClipped()&&e&&e.length){this.currentStencilSource=t.source;var i=this.context,o=i.gl;this.nextStencilID+e.length>256&&this.clearStencil(),i.setColorMode(Ct.disabled),i.setDepthMode(It.disabled);var r=this.useProgram("clippingMask");this._tileClippingMaskIDs={};for(var a=0,n=e;a<n.length;a+=1){var s=n[a],l=this._tileClippingMaskIDs[s.key]=this.nextStencilID++;r.draw(i,o.TRIANGLES,It.disabled,new Pt({func:o.ALWAYS,mask:0},l,255,o.KEEP,o.KEEP,o.REPLACE),Ct.disabled,zt.disabled,Ai(s.posMatrix),"$clipping",this.tileExtentBuffer,this.quadTriangleIndexBuffer,this.tileExtentSegments);}}},xo.prototype.stencilModeFor3D=function(){this.currentStencilSource=void 0,this.nextStencilID+1>256&&this.clearStencil();var t=this.nextStencilID++,e=this.context.gl;return new Pt({func:e.NOTEQUAL,mask:255},t,255,e.KEEP,e.KEEP,e.REPLACE)},xo.prototype.stencilModeForClipping=function(t){var e=this.context.gl;return new Pt({func:e.EQUAL,mask:255},this._tileClippingMaskIDs[t.key],0,e.KEEP,e.KEEP,e.REPLACE)},xo.prototype.stencilConfigForOverlap=function(t){var e,i=this.context.gl,o=t.sort((function(t,e){return e.overscaledZ-t.overscaledZ})),r=o[o.length-1].overscaledZ,a=o[0].overscaledZ-r+1;if(a>1){this.currentStencilSource=void 0,this.nextStencilID+a>256&&this.clearStencil();for(var n={},s=0;s<a;s++)n[s+r]=new Pt({func:i.GEQUAL,mask:255},s+this.nextStencilID,255,i.KEEP,i.KEEP,i.REPLACE);return this.nextStencilID+=a,[n,o]}return [(e={},e[r]=Pt.disabled,e),o]},xo.prototype.colorModeForRenderPass=function(){var e=this.context.gl;return this._showOverdrawInspector?new Ct([e.CONSTANT_COLOR,e.ONE],new t.Color(1/8,1/8,1/8,0),[!0,!0,!0,!0]):"opaque"===this.renderPass?Ct.unblended:Ct.alphaBlended},xo.prototype.depthModeForSublayer=function(t,e,i){if(!this.opaquePassEnabledForLayer())return It.disabled;var o=1-((1+this.currentLayer)*this.numSublayers+t)*this.depthEpsilon;return new It(i||this.context.gl.LEQUAL,e,[o,o])},xo.prototype.opaquePassEnabledForLayer=function(){return this.currentLayer<this.opaquePassCutoff},xo.prototype.render=function(e,i){var o=this;this.style=e,this.options=i,this.lineAtlas=e.lineAtlas,this.imageManagerFactory=e.imageManagerFactory,this.glyphManager=e.glyphManager,this.symbolFadeChange=e.placement.symbolFadeChange(t.browser.now()),this.imageManagerFactory.beginFrame();var r=this.style._order,a=this.style.sourceCaches;for(var n in a){var s=a[n];s.used&&s.prepare(this.context);}var l,c,h={},u={},p={};for(var d in a){var _=a[d];h[d]=_.getVisibleCoordinates(),u[d]=h[d].slice().reverse(),p[d]=_.getVisibleCoordinates(!0).reverse();}this.opaquePassCutoff=1/0;for(var f=0;f<r.length;f++)if(this.style._layers[r[f]].is3D()){this.opaquePassCutoff=f;break}this.renderPass="offscreen";for(var m=0,g=r;m<g.length;m+=1){var v=this.style._layers[g[m]];if(v.hasOffscreenPass()&&!v.isHidden(this.transform.zoom)){var y=u[v.source];("custom"===v.type||y.length)&&this.renderLayer(this,a[v.source],v,y);}}for(this.context.bindFramebuffer.set(null),this.context.clear({color:i.showOverdrawInspector?t.Color.black:t.Color.transparent,depth:1}),this.clearStencil(),this._showOverdrawInspector=i.showOverdrawInspector,this.depthRangeFor3D=[0,1-(e._order.length+2)*this.numSublayers*this.depthEpsilon],this.renderPass="opaque",this.currentLayer=r.length-1;this.currentLayer>=0;this.currentLayer--){var x=this.style._layers[r[this.currentLayer]],b=a[x.source],w=h[x.source];this._renderTileClippingMasks(x,w),this.renderLayer(this,b,x,w);}for(this.renderPass="translucent",this.currentLayer=0;this.currentLayer<r.length;this.currentLayer++){var E=this.style._layers[r[this.currentLayer]],T=a[E.source],S=("symbol"===E.type?p:u)[E.source];this._renderTileClippingMasks(E,h[E.source]),this.renderLayer(this,T,E,S);}this.options.showTileBoundaries&&(t.values(this.style._layers).forEach((function(t){t.source&&!t.isHidden(o.transform.zoom)&&(t.source!==(c&&c.id)&&(c=o.style.sourceCaches[t.source]),(!l||l.getSource().maxzoom<c.getSource().maxzoom)&&(l=c));})),l&&yo.debug(this,l,l.getVisibleCoordinates())),this.options.showPadding&&function(t){var e=t.transform.padding;fo(t,t.transform.height-(e.top||0),3,co),fo(t,e.bottom||0,3,ho),mo(t,e.left||0,3,uo),mo(t,t.transform.width-(e.right||0),3,po);var i=t.transform.centerPoint;!function(t,e,i,o){go(t,e-1,i-10,2,20,o),go(t,e-10,i-1,20,2,o);}(t,i.x,t.transform.height-i.y,_o);}(this),this.context.setDefault();},xo.prototype.renderLayer=function(t,e,i,o){i.isHidden(this.transform.zoom)||("background"===i.type||"custom"===i.type||o.length)&&(this.id=i.id,this.gpuTimingStart(i),yo[i.type](t,e,i,o,this.style.placement.variableOffsets),this.gpuTimingEnd());},xo.prototype.gpuTimingStart=function(t){if(this.options.gpuTiming){var e=this.context.extTimerQuery,i=this.gpuTimers[t.id];i||(i=this.gpuTimers[t.id]={calls:0,cpuTime:0,query:e.createQueryEXT()}),i.calls++,e.beginQueryEXT(e.TIME_ELAPSED_EXT,i.query);}},xo.prototype.gpuTimingEnd=function(){if(this.options.gpuTiming){var t=this.context.extTimerQuery;t.endQueryEXT(t.TIME_ELAPSED_EXT);}},xo.prototype.collectGpuTimers=function(){var t=this.gpuTimers;return this.gpuTimers={},t},xo.prototype.queryGpuTimers=function(t){var e={};for(var i in t){var o=t[i],r=this.context.extTimerQuery,a=r.getQueryObjectEXT(o.query,r.QUERY_RESULT_EXT)/1e6;r.deleteQueryEXT(o.query),e[i]=a;}return e},xo.prototype.translatePosMatrix=function(e,i,o,r,a){if(!o[0]&&!o[1])return e;var n=a?"map"===r?this.transform.angle:0:"viewport"===r?-this.transform.angle:0;if(n){var s=Math.sin(n),l=Math.cos(n);o=[o[0]*l-o[1]*s,o[0]*s+o[1]*l];}var c=[a?o[0]:de(i,o[0],this.transform.zoom),a?o[1]:de(i,o[1],this.transform.zoom),0],h=new Float32Array(16);return t.translate(h,e,c),h},xo.prototype.saveTileTexture=function(t){var e=this._tileTextures[t.size[0]];e?e.push(t):this._tileTextures[t.size[0]]=[t];},xo.prototype.getTileTexture=function(t){var e=this._tileTextures[t];return e&&e.length>0?e.pop():null},xo.prototype.isPatternMissing=function(t){if(!t)return !1;if(!t.from||!t.to)return !0;var e=this.imageManagerFactory.getPattern(t.from.toString()),i=this.imageManagerFactory.getPattern(t.to.toString());return !e||!i},xo.prototype.useProgram=function(t,e){this.cache=this.cache||{};var i=""+t+(e?e.cacheKey:"")+(this._showOverdrawInspector?"/overdraw":"");return this.cache[i]||(this.cache[i]=new wi(this.context,t,yi[t],e,Yi[t],this._showOverdrawInspector)),this.cache[i]},xo.prototype.setCustomLayerDefaults=function(){this.context.unbindVAO(),this.context.cullFace.setDefault(),this.context.activeTexture.setDefault(),this.context.pixelStoreUnpack.setDefault(),this.context.pixelStoreUnpackPremultiplyAlpha.setDefault(),this.context.pixelStoreUnpackFlipY.setDefault();},xo.prototype.setBaseState=function(){var t=this.context.gl;this.context.cullFace.set(!1),this.context.viewport.set([0,0,this.width,this.height]),this.context.blendEquation.set(t.FUNC_ADD);},xo.prototype.initDebugOverlayCanvas=function(){null==this.debugOverlayCanvas&&(this.debugOverlayCanvas=t.window.document.createElement("canvas"),this.debugOverlayCanvas.width=512,this.debugOverlayCanvas.height=512,this.debugOverlayTexture=new t.Texture(this.context,this.debugOverlayCanvas,this.context.gl.RGBA));},xo.prototype.destroy=function(){this.emptyTexture.destroy(),this.debugOverlayTexture&&this.debugOverlayTexture.destroy();};var bo=function(t,e){this.points=t,this.planes=e;};bo.fromInvProjectionMatrix=function(e,i,o){var r=Math.pow(2,o),a=[[-1,1,-1,1],[1,1,-1,1],[1,-1,-1,1],[-1,-1,-1,1],[-1,1,1,1],[1,1,1,1],[1,-1,1,1],[-1,-1,1,1]].map((function(i){return t.transformMat4([],i,e)})).map((function(e){return t.scale$1([],e,1/e[3]/i*r)})),n=[[0,1,2],[6,5,4],[0,3,7],[2,1,5],[3,2,6],[0,4,5]].map((function(e){var i=t.sub([],a[e[0]],a[e[1]]),o=t.sub([],a[e[2]],a[e[1]]),r=t.normalize([],t.cross([],i,o)),n=-t.dot(r,a[e[1]]);return r.concat(n)}));return new bo(a,n)};var wo=function(e,i){this.min=e,this.max=i,this.center=t.scale$2([],t.add([],this.min,this.max),.5);};wo.prototype.quadrant=function(e){for(var i=[e%2==0,e<2],o=t.clone$2(this.min),r=t.clone$2(this.max),a=0;a<i.length;a++)o[a]=i[a]?this.min[a]:this.center[a],r[a]=i[a]?this.center[a]:this.max[a];return r[2]=this.max[2],new wo(o,r)},wo.prototype.distanceX=function(t){return Math.max(Math.min(this.max[0],t[0]),this.min[0])-t[0]},wo.prototype.distanceY=function(t){return Math.max(Math.min(this.max[1],t[1]),this.min[1])-t[1]},wo.prototype.intersects=function(e){for(var i=[[this.min[0],this.min[1],0,1],[this.max[0],this.min[1],0,1],[this.max[0],this.max[1],0,1],[this.min[0],this.max[1],0,1]],o=!0,r=0;r<e.planes.length;r++){for(var a=e.planes[r],n=0,s=0;s<i.length;s++)n+=t.dot$1(a,i[s])>=0;if(0===n)return 0;n!==i.length&&(o=!1);}if(o)return 2;for(var l=0;l<3;l++){for(var c=Number.MAX_VALUE,h=-Number.MAX_VALUE,u=0;u<e.points.length;u++){var p=e.points[u][l]-this.min[l];c=Math.min(c,p),h=Math.max(h,p);}if(h<0||c>this.max[l]-this.min[l])return 0}return 1};var Eo=function(t,e,i,o){if(void 0===t&&(t=0),void 0===e&&(e=0),void 0===i&&(i=0),void 0===o&&(o=0),isNaN(t)||t<0||isNaN(e)||e<0||isNaN(i)||i<0||isNaN(o)||o<0)throw new Error("Invalid value for edge-insets, top, bottom, left and right must all be numbers");this.top=t,this.bottom=e,this.left=i,this.right=o;};Eo.prototype.interpolate=function(e,i,o){return null!=i.top&&null!=e.top&&(this.top=t.number(e.top,i.top,o)),null!=i.bottom&&null!=e.bottom&&(this.bottom=t.number(e.bottom,i.bottom,o)),null!=i.left&&null!=e.left&&(this.left=t.number(e.left,i.left,o)),null!=i.right&&null!=e.right&&(this.right=t.number(e.right,i.right,o)),this},Eo.prototype.getCenter=function(e,i){var o=t.clamp((this.left+e-this.right)/2,0,e),r=t.clamp((this.top+i-this.bottom)/2,0,i);return new t.Point(o,r)},Eo.prototype.equals=function(t){return this.top===t.top&&this.bottom===t.bottom&&this.left===t.left&&this.right===t.right},Eo.prototype.clone=function(){return new Eo(this.top,this.bottom,this.left,this.right)},Eo.prototype.toJSON=function(){return {top:this.top,bottom:this.bottom,left:this.left,right:this.right}};var To=function(e,i,o,r,a,n,s){this.tileSize=512,this.maxValidLatitude=85.051129,this._renderWorldCopies=void 0===a||a,this._minZoom=e||0,this._maxZoom=i||22,this._minPitch=null==o?0:o,this._maxPitch=null==r?60:r,this.setMaxBounds(),s&&this.setCRS(s),this.width=0,this.height=0,this._center=new t.LngLat(0,0),this.zoom=0,this.angle=0,this._fov=.6435011087932844,this._pitch=0,this._unmodified=!0,this._edgeInsets=new Eo,this._posMatrixCache={},this._alignedPosMatrixCache={};},So={minZoom:{configurable:!0},maxZoom:{configurable:!0},minPitch:{configurable:!0},maxPitch:{configurable:!0},renderWorldCopies:{configurable:!0},worldSize:{configurable:!0},centerOffset:{configurable:!0},size:{configurable:!0},bearing:{configurable:!0},pitch:{configurable:!0},fov:{configurable:!0},zoom:{configurable:!0},center:{configurable:!0},padding:{configurable:!0},centerPoint:{configurable:!0},unmodified:{configurable:!0},point:{configurable:!0}};To.prototype.clone=function(){var t=new To(this._minZoom,this._maxZoom,this._minPitch,this.maxPitch,this._renderWorldCopies,null,this.crs);return t.tileSize=this.tileSize,t.latRange=this.latRange,t.width=this.width,t.height=this.height,t._center=this._center,t.zoom=this.zoom,t.angle=this.angle,t._fov=this._fov,t._pitch=this._pitch,t._unmodified=this._unmodified,t._edgeInsets=this._edgeInsets.clone(),t._calcMatrices(),t},To.prototype.getCRS=function(){return this.crs},To.prototype.setCRS=function(t){this.crs=t,this.indexExtent=t.getExtent(),this.worldWidth=this.indexExtent[2]-this.indexExtent[0],this.worldHeight=this.indexExtent[3]-this.indexExtent[1],this.centerX=(this.indexExtent[2]+this.indexExtent[0])/2,this.centerY=(this.indexExtent[3]+this.indexExtent[1])/2,this.originX=this.indexExtent[0],this.originY=this.indexExtent[3],this.crs.renderWorldCopies=this.renderWorldCopies;},So.minZoom.get=function(){return this._minZoom},So.minZoom.set=function(t){this._minZoom!==t&&(this._minZoom=t,this.zoom=Math.max(this.zoom,t));},So.maxZoom.get=function(){return this._maxZoom},So.maxZoom.set=function(t){this._maxZoom!==t&&(this._maxZoom=t,this.zoom=Math.min(this.zoom,t));},So.minPitch.get=function(){return this._minPitch},So.minPitch.set=function(t){this._minPitch!==t&&(this._minPitch=t,this.pitch=Math.max(this.pitch,t));},So.maxPitch.get=function(){return this._maxPitch},So.maxPitch.set=function(t){this._maxPitch!==t&&(this._maxPitch=t,this.pitch=Math.min(this.pitch,t));},So.renderWorldCopies.get=function(){return this._renderWorldCopies},So.renderWorldCopies.set=function(t){void 0===t?t=!0:null===t&&(t=!1),this._renderWorldCopies=t;},So.worldSize.get=function(){return this.tileSize*this.scale},So.centerOffset.get=function(){return this.centerPoint._sub(this.size._div(2))},So.size.get=function(){return new t.Point(this.width,this.height)},So.bearing.get=function(){return -this.angle/Math.PI*180},So.bearing.set=function(e){var i=-t.wrap(e,-180,180)*Math.PI/180;this.angle!==i&&(this._unmodified=!1,this.angle=i,this._calcMatrices(),this.rotationMatrix=t.create$2(),t.rotate(this.rotationMatrix,this.rotationMatrix,this.angle));},So.pitch.get=function(){return this._pitch/Math.PI*180},So.pitch.set=function(e){var i=t.clamp(e,this.minPitch,this.maxPitch)/180*Math.PI;this._pitch!==i&&(this._unmodified=!1,this._pitch=i,this._calcMatrices());},So.fov.get=function(){return this._fov/Math.PI*180},So.fov.set=function(t){t=Math.max(.01,Math.min(60,t)),this._fov!==t&&(this._unmodified=!1,this._fov=t/180*Math.PI,this._calcMatrices());},So.zoom.get=function(){return this._zoom},So.zoom.set=function(t){var e=Math.min(Math.max(t,this.minZoom),this.maxZoom);this._zoom!==e&&(this._unmodified=!1,this._zoom=e,this.scale=this.zoomScale(e),this.tileZoom=Math.floor(e),this.zoomFraction=e-this.tileZoom,this._constrain(),this._calcMatrices());},So.center.get=function(){return this._center},So.center.set=function(t){t.lat===this._center.lat&&t.lng===this._center.lng||(this._unmodified=!1,this._center=t,this._constrain(),this._calcMatrices());},So.padding.get=function(){return this._edgeInsets.toJSON()},So.padding.set=function(t){this._edgeInsets.equals(t)||(this._unmodified=!1,this._edgeInsets.interpolate(this._edgeInsets,t,1),this._calcMatrices());},So.centerPoint.get=function(){return this._edgeInsets.getCenter(this.width,this.height)},To.prototype.isPaddingEqual=function(t){return this._edgeInsets.equals(t)},To.prototype.interpolatePadding=function(t,e,i){this._unmodified=!1,this._edgeInsets.interpolate(t,e,i),this._constrain(),this._calcMatrices();},To.prototype.coveringZoomLevel=function(t){var e=(t.roundZoom?Math.round:Math.floor)(this.zoom+this.scaleZoom(this.tileSize/t.tileSize));return Math.max(0,e)},To.prototype.getVisibleUnwrappedCoordinates=function(e){var i=[new t.UnwrappedTileID(0,e)];if(this._renderWorldCopies)for(var o=this.pointCoordinate(new t.Point(0,0)),r=this.pointCoordinate(new t.Point(this.width,0)),a=this.pointCoordinate(new t.Point(this.width,this.height)),n=this.pointCoordinate(new t.Point(0,this.height)),s=Math.floor(Math.min(o.x,r.x,a.x,n.x)),l=Math.floor(Math.max(o.x,r.x,a.x,n.x)),c=s-1;c<=l+1;c++)0!==c&&i.push(new t.UnwrappedTileID(c,e));return i},To.prototype.coveringTiles=function(e){var i=this.coveringZoomLevel(e),o=i;if(void 0!==e.minzoom&&i<e.minzoom)return [];void 0!==e.maxzoom&&i>e.maxzoom&&(i=e.maxzoom);var r=this.crs.fromLngLat(this.center),a=Math.pow(2,i),n=[a*r.x,a*r.y,0],s=bo.fromInvProjectionMatrix(this.invProjMatrix,this.worldSize,i),l=e.minzoom||0;this.pitch<=60&&this._edgeInsets.top<.1&&(l=i);var c=function(t){return {aabb:new wo([t*a,0,0],[(t+1)*a,a,0]),zoom:0,x:0,y:0,wrap:t,fullyVisible:!1}},h=[],u=[],p=i,d=e.reparseOverscaled?o:i;if(this._renderWorldCopies)for(var _=1;_<=3;_++)h.push(c(-_)),h.push(c(_));for(h.push(c(0));h.length>0;){var f=h.pop(),m=f.x,g=f.y,v=f.fullyVisible;if(!v){var y=f.aabb.intersects(s);if(0===y)continue;v=2===y;}var x=f.aabb.distanceX(n),b=f.aabb.distanceY(n),w=Math.max(Math.abs(x),Math.abs(b));if(f.zoom===p||w>3+(1<<p-f.zoom)-2&&f.zoom>=l)u.push({tileID:new t.OverscaledTileID(f.zoom===p?d:f.zoom,f.wrap,f.zoom,m,g,this.indexExtent),distanceSq:t.sqrLen([n[0]-.5-m,n[1]-.5-g])});else for(var E=0;E<4;E++){var T=(m<<1)+E%2,S=(g<<1)+(E>>1);h.push({aabb:f.aabb.quadrant(E),zoom:f.zoom+1,x:T,y:S,wrap:f.wrap,fullyVisible:v});}}return u.sort((function(t,e){return t.distanceSq-e.distanceSq})).map((function(t){return t.tileID}))},To.prototype.resize=function(t,e){this.width=t,this.height=e,this.pixelsToGLUnits=[2/t,-2/e],this._constrain(),this._calcMatrices();},So.unmodified.get=function(){return this._unmodified},To.prototype.zoomScale=function(t){return Math.pow(2,t)},To.prototype.scaleZoom=function(t){return Math.log(t)/Math.LN2},To.prototype.project=function(e){var i=this.latRange?t.clamp(e.lat,-this.maxValidLatitude,this.maxValidLatitude):e.lat,o=this.lngLatXY(e.lng,i);return new t.Point(o[0],o[1])},To.prototype.unproject=function(e){var i=this.xYLngLat(e.x,e.y);return new t.LngLat(i[0],i[1])},So.point.get=function(){return this.project(this.center)},To.prototype.lngLatXY=function(t,e){var i=this.crs.fromWGS84([t,e]);return [(i[0]-this.originX)*this.worldSize/this.worldWidth,(this.originY-i[1])*this.worldSize/this.worldHeight]},To.prototype.lngX=function(t){return this.lngLatXY(t,this.center.lat)[0]},To.prototype.latY=function(t){return this.lngLatXY(this.center.lng,t)[1]},To.prototype.xYLngLat=function(t,e){return this.crs.toWGS84([t*this.worldWidth/this.worldSize+this.originX,this.originY-e*this.worldHeight/this.worldSize])},To.prototype.xLng=function(t){var e=this.center,i=this.lngLatXY(e.lng,e.lat);return this.xYLngLat(t,i[1])[0]},To.prototype.yLat=function(t){var e=this.center,i=this.lngLatXY(e.lng,e.lat);return this.xYLngLat(i[0],t)[1]},To.prototype.setLocationAtPoint=function(e,i){var o=this.pointCoordinate(i),r=this.pointCoordinate(this.centerPoint),a=this.locationCoordinate(e),n=new t.MercatorCoordinate(a.x-(o.x-r.x),a.y-(o.y-r.y));this.center=this.coordinateLocation(n),this._renderWorldCopies&&(this.center=this.center.wrap());},To.prototype.locationPoint=function(t){return this.coordinatePoint(this.locationCoordinate(t))},To.prototype.pointLocation=function(t){return this.coordinateLocation(this.pointCoordinate(t))},To.prototype.locationCoordinate=function(t){return this.crs.fromLngLat(t)},To.prototype.coordinateLocation=function(t){return this.crs.toLngLat(t.x,t.y)},To.prototype.pointCoordinate=function(e){var i=[e.x,e.y,0,1],o=[e.x,e.y,1,1];t.transformMat4(i,i,this.pixelMatrixInverse),t.transformMat4(o,o,this.pixelMatrixInverse);var r=i[3],a=o[3],n=i[1]/r,s=o[1]/a,l=i[2]/r,c=o[2]/a,h=l===c?0:(0-l)/(c-l);return new t.MercatorCoordinate(t.number(i[0]/r,o[0]/a,h)/this.worldSize,t.number(n,s,h)/this.worldSize)},To.prototype.coordinatePoint=function(e){var i=[e.x*this.worldSize,e.y*this.worldSize,0,1];return t.transformMat4(i,i,this.pixelMatrix),new t.Point(i[0]/i[3],i[1]/i[3])},To.prototype.getBounds=function(){return (new t.LngLatBounds).extend(this.pointLocation(new t.Point(0,0))).extend(this.pointLocation(new t.Point(this.width,0))).extend(this.pointLocation(new t.Point(this.width,this.height))).extend(this.pointLocation(new t.Point(0,this.height)))},To.prototype.getMaxBounds=function(){return this.latRange&&2===this.latRange.length&&this.lngRange&&2===this.lngRange.length?new t.LngLatBounds([this.lngRange[0],this.latRange[0]],[this.lngRange[1],this.latRange[1]]):null},To.prototype.setMaxBounds=function(t){t?(this.lngRange=[t.getWest(),t.getEast()],this.latRange=[t.getSouth(),t.getNorth()],this._constrain()):(this.lngRange=null,this.latRange=[-this.maxValidLatitude,this.maxValidLatitude]);},To.prototype.calculatePosMatrix=function(e,i){void 0===i&&(i=!1);var o=e.key,r=i?this._alignedPosMatrixCache:this._posMatrixCache;if(r[o])return r[o];var a=e.canonical,n=this.worldSize/this.zoomScale(a.z),s=a.x+Math.pow(2,a.z)*e.wrap,l=t.identity(new Float64Array(16));return t.translate(l,l,[s*n,a.y*n,0]),t.scale(l,l,[n/t.EXTENT,n/t.EXTENT,1]),t.multiply(l,i?this.alignedProjMatrix:this.projMatrix,l),r[o]=new Float32Array(l),r[o]},To.prototype.customLayerMatrix=function(){return this.mercatorMatrix.slice()},To.prototype._constrain=function(){if(this.center&&this.width&&this.height&&!this._constraining){this._constraining=!0;var e,i,o,r,a=-90,n=90,s=-180,l=180,c=this.size,h=this._unmodified;if(this.latRange){var u=this.latRange;a=this.latY(u[1]),e=(n=this.latY(u[0]))-a<c.y?c.y/(n-a):0;}if(this.lngRange){var p=this.lngRange;s=this.lngX(p[0]),i=(l=this.lngX(p[1]))-s<c.x?c.x/(l-s):0;}var d=this.point,_=Math.max(i||0,e||0);if(_)return this.center=this.unproject(new t.Point(i?(l+s)/2:d.x,e?(n+a)/2:d.y)),this.zoom+=this.scaleZoom(_),this._unmodified=h,void(this._constraining=!1);if(this.latRange){var f=d.y,m=c.y/2;f-m<a&&(r=a+m),f+m>n&&(r=n-m);}if(this.lngRange){var g=d.x,v=c.x/2;g-v<s&&(o=s+v),g+v>l&&(o=l-v);}void 0===o&&void 0===r||(this.center=this.unproject(new t.Point(void 0!==o?o:d.x,void 0!==r?r:d.y))),this._unmodified=h,this._constraining=!1;}},To.prototype._calcMatrices=function(){if(this.height){var e=this.centerOffset;this.cameraToCenterDistance=.5/Math.tan(this._fov/2)*this.height;var i=Math.PI/2+this._pitch,o=this._fov*(.5+e.y/this.height),r=Math.sin(o)*this.cameraToCenterDistance/Math.sin(t.clamp(Math.PI-i-o,.01,Math.PI-.01)),a=this.point,n=a.x,s=a.y,l=1.01*(Math.cos(Math.PI/2-this._pitch)*r+this.cameraToCenterDistance),c=this.height/50,h=new Float64Array(16);t.perspective(h,this._fov,this.width/this.height,c,l),h[8]=2*-e.x/this.width,h[9]=2*e.y/this.height,t.scale(h,h,[1,-1,1]),t.translate(h,h,[0,0,-this.cameraToCenterDistance]),t.rotateX(h,h,this._pitch),t.rotateZ(h,h,this.angle),t.translate(h,h,[-n,-s,0]),this.mercatorMatrix=t.scale([],h,[this.worldSize,this.worldSize,this.worldSize]);var u=this.worldSize/(2*Math.PI*6378137*Math.abs(Math.cos(this.center.lat*(Math.PI/180))));"m"!==this.units&&"meter"!==this.units||(u=this.crs?this.worldSize/(this.crs.extent[3]-this.crs.extent[1]):this.worldSize/(this.latRange[1]-this.latRange[0])),t.scale(h,h,[1,1,u,1]),this.projMatrix=h,this.invProjMatrix=t.invert([],this.projMatrix);var p=this.width%2/2,d=this.height%2/2,_=Math.cos(this.angle),f=Math.sin(this.angle),m=n-Math.round(n)+_*p+f*d,g=s-Math.round(s)+_*d+f*p,v=new Float64Array(h);if(t.translate(v,v,[m>.5?m-1:m,g>.5?g-1:g,0]),this.alignedProjMatrix=v,h=t.create(),t.scale(h,h,[this.width/2,-this.height/2,1]),t.translate(h,h,[1,-1,0]),this.labelPlaneMatrix=h,h=t.create(),t.scale(h,h,[1,-1,1]),t.translate(h,h,[-1,-1,0]),t.scale(h,h,[2/this.width,2/this.height,1]),this.glCoordMatrix=h,this.pixelMatrix=t.multiply(new Float64Array(16),this.labelPlaneMatrix,this.projMatrix),!(h=t.invert(new Float64Array(16),this.pixelMatrix)))throw new Error("failed to invert matrix");this.pixelMatrixInverse=h,this._posMatrixCache={},this._alignedPosMatrixCache={};}},To.prototype.maxPitchScaleFactor=function(){if(!this.pixelMatrixInverse)return 1;var e=this.pointCoordinate(new t.Point(0,0)),i=[e.x*this.worldSize,e.y*this.worldSize,0,1];return t.transformMat4(i,i,this.pixelMatrix)[3]/this.cameraToCenterDistance},To.prototype.getCameraPoint=function(){var e=Math.tan(this._pitch)*(this.cameraToCenterDistance||1);return this.centerPoint.add(new t.Point(0,e))},To.prototype.getCameraQueryGeometry=function(e){var i=this.getCameraPoint();if(1===e.length)return [e[0],i];for(var o=i.x,r=i.y,a=i.x,n=i.y,s=0,l=e;s<l.length;s+=1){var c=l[s];o=Math.min(o,c.x),r=Math.min(r,c.y),a=Math.max(a,c.x),n=Math.max(n,c.y);}return [new t.Point(o,r),new t.Point(a,r),new t.Point(a,n),new t.Point(o,n),new t.Point(o,r)]},Object.defineProperties(To.prototype,So);var Io=function(e){var i,o,r,a;this._hashName=e&&encodeURIComponent(e),t.bindAll(["_getCurrentHash","_onHashChange","_updateHash"],this),this._updateHash=(i=this._updateHashUnthrottled.bind(this),o=!1,r=null,a=function(){r=null,o&&(i(),r=setTimeout(a,300),o=!1);},function(){return o=!0,r||a(),r});};Io.prototype.addTo=function(e){return this._map=e,t.window.addEventListener("hashchange",this._onHashChange,!1),this._map.on("moveend",this._updateHash),this},Io.prototype.remove=function(){return t.window.removeEventListener("hashchange",this._onHashChange,!1),this._map.off("moveend",this._updateHash),clearTimeout(this._updateHash()),delete this._map,this},Io.prototype.getHashString=function(e){var i=this._map.getCenter(),o=Math.round(100*this._map.getZoom())/100,r=Math.ceil((o*Math.LN2+Math.log(512/360/.5))/Math.LN10),a=Math.pow(10,r),n=Math.round(i.lng*a)/a,s=Math.round(i.lat*a)/a,l=this._map.getBearing(),c=this._map.getPitch(),h="";if(h+=e?"/"+n+"/"+s+"/"+o:o+"/"+s+"/"+n,(l||c)&&(h+="/"+Math.round(10*l)/10),c&&(h+="/"+Math.round(c)),this._hashName){var u=this._hashName,p=!1,d=t.window.location.hash.slice(1).split("&").map((function(t){var e=t.split("=")[0];return e===u?(p=!0,e+"="+h):t})).filter((function(t){return t}));return p||d.push(u+"="+h),"#"+d.join("&")}return "#"+h},Io.prototype._getCurrentHash=function(){var e,i=this,o=t.window.location.hash.replace("#","");return this._hashName?(o.split("&").map((function(t){return t.split("=")})).forEach((function(t){t[0]===i._hashName&&(e=t);})),(e&&e[1]||"").split("/")):o.split("/")},Io.prototype._onHashChange=function(){var t=this._getCurrentHash();if(t.length>=3&&!t.some((function(t){return isNaN(t)}))){var e=this._map.dragRotate.isEnabled()&&this._map.touchZoomRotate.isEnabled()?+(t[3]||0):this._map.getBearing();return this._map.jumpTo({center:[+t[2],+t[1]],zoom:+t[0],bearing:e,pitch:+(t[4]||0)}),!0}return !1},Io.prototype._updateHashUnthrottled=function(){var e=this.getHashString();try{t.window.history.replaceState(t.window.history.state,"",e);}catch(t){}};var Po={linearity:.3,easing:t.bezier(0,0,.3,1)},Co=t.extend({deceleration:2500,maxSpeed:1400},Po),zo=t.extend({deceleration:20,maxSpeed:1400},Po),Mo=t.extend({deceleration:1e3,maxSpeed:360},Po),Lo=t.extend({deceleration:1e3,maxSpeed:90},Po),Do=function(t){this._map=t,this.clear();};function Ro(t,e){(!t.duration||t.duration<e.duration)&&(t.duration=e.duration,t.easing=e.easing);}function Ao(e,i,o){var r=o.maxSpeed,a=o.linearity,n=o.deceleration,s=t.clamp(e*a/(i/1e3),-r,r),l=Math.abs(s)/(n*a);return {easing:o.easing,duration:1e3*l,amount:s*(l/2)}}Do.prototype.clear=function(){this._inertiaBuffer=[];},Do.prototype.record=function(e){this._drainInertiaBuffer(),this._inertiaBuffer.push({time:t.browser.now(),settings:e});},Do.prototype._drainInertiaBuffer=function(){for(var e=this._inertiaBuffer,i=t.browser.now();e.length>0&&i-e[0].time>160;)e.shift();},Do.prototype._onMoveEnd=function(e){if(this._drainInertiaBuffer(),!(this._inertiaBuffer.length<2)){for(var i={zoom:0,bearing:0,pitch:0,pan:new t.Point(0,0),pinchAround:void 0,around:void 0},o=0,r=this._inertiaBuffer;o<r.length;o+=1){var a=r[o].settings;i.zoom+=a.zoomDelta||0,i.bearing+=a.bearingDelta||0,i.pitch+=a.pitchDelta||0,a.panDelta&&i.pan._add(a.panDelta),a.around&&(i.around=a.around),a.pinchAround&&(i.pinchAround=a.pinchAround);}var n=this._inertiaBuffer[this._inertiaBuffer.length-1].time-this._inertiaBuffer[0].time,s={};if(i.pan.mag()){var l=Ao(i.pan.mag(),n,t.extend({},Co,e||{}));s.offset=i.pan.mult(l.amount/i.pan.mag()),s.center=this._map.transform.center,Ro(s,l);}if(i.zoom){var c=Ao(i.zoom,n,zo);s.zoom=this._map.transform.zoom+c.amount,Ro(s,c);}if(i.bearing){var h=Ao(i.bearing,n,Mo);s.bearing=this._map.transform.bearing+t.clamp(h.amount,-179,179),Ro(s,h);}if(i.pitch){var u=Ao(i.pitch,n,Lo);s.pitch=this._map.transform.pitch+u.amount,Ro(s,u);}if(s.zoom||s.bearing){var p=void 0===i.pinchAround?i.around:i.pinchAround;s.around=p?this._map.unproject(p):this._map.getCenter();}return this.clear(),t.extend(s,{noMoveStart:!0})}};var ko=function(e){function o(o,r,a,n){void 0===n&&(n={});var s=i.mousePos(r.getCanvasContainer(),a),l=r.unproject(s);e.call(this,o,t.extend({point:s,lngLat:l,originalEvent:a},n)),this._defaultPrevented=!1,this.target=r;}e&&(o.__proto__=e),(o.prototype=Object.create(e&&e.prototype)).constructor=o;var r={defaultPrevented:{configurable:!0}};return o.prototype.preventDefault=function(){this._defaultPrevented=!0;},r.defaultPrevented.get=function(){return this._defaultPrevented},Object.defineProperties(o.prototype,r),o}(t.Event),Oo=function(e){function o(o,r,a){var n="touchend"===o?a.changedTouches:a.touches,s=i.touchPos(r.getCanvasContainer(),n),l=s.map((function(t){return r.unproject(t)})),c=s.reduce((function(t,e,i,o){return t.add(e.div(o.length))}),new t.Point(0,0)),h=r.unproject(c);e.call(this,o,{points:s,point:c,lngLats:l,lngLat:h,originalEvent:a}),this._defaultPrevented=!1;}e&&(o.__proto__=e),(o.prototype=Object.create(e&&e.prototype)).constructor=o;var r={defaultPrevented:{configurable:!0}};return o.prototype.preventDefault=function(){this._defaultPrevented=!0;},r.defaultPrevented.get=function(){return this._defaultPrevented},Object.defineProperties(o.prototype,r),o}(t.Event),Bo=function(t){function e(e,i,o){t.call(this,e,{originalEvent:o}),this._defaultPrevented=!1;}t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e;var i={defaultPrevented:{configurable:!0}};return e.prototype.preventDefault=function(){this._defaultPrevented=!0;},i.defaultPrevented.get=function(){return this._defaultPrevented},Object.defineProperties(e.prototype,i),e}(t.Event),Fo=function(t,e){this._map=t,this._clickTolerance=e.clickTolerance;};Fo.prototype.reset=function(){delete this._mousedownPos;},Fo.prototype.wheel=function(t){return this._firePreventable(new Bo(t.type,this._map,t))},Fo.prototype.mousedown=function(t,e){return this._mousedownPos=e,this._firePreventable(new ko(t.type,this._map,t))},Fo.prototype.mouseup=function(t){this._map.fire(new ko(t.type,this._map,t));},Fo.prototype.click=function(t,e){this._mousedownPos&&this._mousedownPos.dist(e)>=this._clickTolerance||this._map.fire(new ko(t.type,this._map,t));},Fo.prototype.dblclick=function(t){return this._firePreventable(new ko(t.type,this._map,t))},Fo.prototype.mouseover=function(t){this._map.fire(new ko(t.type,this._map,t));},Fo.prototype.mouseout=function(t){this._map.fire(new ko(t.type,this._map,t));},Fo.prototype.touchstart=function(t){return this._firePreventable(new Oo(t.type,this._map,t))},Fo.prototype.touchmove=function(t){this._map.fire(new Oo(t.type,this._map,t));},Fo.prototype.touchend=function(t){this._map.fire(new Oo(t.type,this._map,t));},Fo.prototype.touchcancel=function(t){this._map.fire(new Oo(t.type,this._map,t));},Fo.prototype._firePreventable=function(t){if(this._map.fire(t),t.defaultPrevented)return {}},Fo.prototype.isEnabled=function(){return !0},Fo.prototype.isActive=function(){return !1},Fo.prototype.enable=function(){},Fo.prototype.disable=function(){};var Uo=function(t){this._map=t;};Uo.prototype.reset=function(){this._delayContextMenu=!1,delete this._contextMenuEvent;},Uo.prototype.mousemove=function(t){this._map.fire(new ko(t.type,this._map,t));},Uo.prototype.mousedown=function(){this._delayContextMenu=!0;},Uo.prototype.mouseup=function(){this._delayContextMenu=!1,this._contextMenuEvent&&(this._map.fire(new ko("contextmenu",this._map,this._contextMenuEvent)),delete this._contextMenuEvent);},Uo.prototype.contextmenu=function(t){this._delayContextMenu?this._contextMenuEvent=t:this._map.fire(new ko(t.type,this._map,t)),this._map.listens("contextmenu")&&t.preventDefault();},Uo.prototype.isEnabled=function(){return !0},Uo.prototype.isActive=function(){return !1},Uo.prototype.enable=function(){},Uo.prototype.disable=function(){};var No=function(t,e){this._map=t,this._el=t.getCanvasContainer(),this._container=t.getContainer(),this._clickTolerance=e.clickTolerance||1;};function jo(t,e){for(var i={},o=0;o<t.length;o++)i[t[o].identifier]=e[o];return i}No.prototype.isEnabled=function(){return !!this._enabled},No.prototype.isActive=function(){return !!this._active},No.prototype.enable=function(){this.isEnabled()||(this._enabled=!0);},No.prototype.disable=function(){this.isEnabled()&&(this._enabled=!1);},No.prototype.mousedown=function(t,e){this.isEnabled()&&t.shiftKey&&0===t.button&&(i.disableDrag(),this._startPos=this._lastPos=e,this._active=!0);},No.prototype.mousemoveWindow=function(t,e){if(this._active){var o=e;if(!(this._lastPos.equals(o)||!this._box&&o.dist(this._startPos)<this._clickTolerance)){var r=this._startPos;this._lastPos=o,this._box||(this._box=i.create("div","mapboxgl-boxzoom",this._container),this._container.classList.add("mapboxgl-crosshair"),this._fireEvent("boxzoomstart",t));var a=Math.min(r.x,o.x),n=Math.max(r.x,o.x),s=Math.min(r.y,o.y),l=Math.max(r.y,o.y);i.setTransform(this._box,"translate("+a+"px,"+s+"px)"),this._box.style.width=n-a+"px",this._box.style.height=l-s+"px";}}},No.prototype.mouseupWindow=function(e,o){var r=this;if(this._active&&0===e.button){var a=this._startPos,n=o;if(this.reset(),i.suppressClick(),a.x!==n.x||a.y!==n.y)return this._map.fire(new t.Event("boxzoomend",{originalEvent:e})),{cameraAnimation:function(t){return t.fitScreenCoordinates(a,n,r._map.getBearing(),{linear:!0})}};this._fireEvent("boxzoomcancel",e);}},No.prototype.keydown=function(t){this._active&&27===t.keyCode&&(this.reset(),this._fireEvent("boxzoomcancel",t));},No.prototype.reset=function(){this._active=!1,this._container.classList.remove("mapboxgl-crosshair"),this._box&&(i.remove(this._box),this._box=null),i.enableDrag(),delete this._startPos,delete this._lastPos;},No.prototype._fireEvent=function(e,i){return this._map.fire(new t.Event(e,{originalEvent:i}))};var Go=function(t){this.reset(),this.numTouches=t.numTouches;};Go.prototype.reset=function(){delete this.centroid,delete this.startTime,delete this.touches,this.aborted=!1;},Go.prototype.touchstart=function(e,i,o){(this.centroid||o.length>this.numTouches)&&(this.aborted=!0),this.aborted||(void 0===this.startTime&&(this.startTime=e.timeStamp),o.length===this.numTouches&&(this.centroid=function(e){for(var i=new t.Point(0,0),o=0,r=e;o<r.length;o+=1)i._add(r[o]);return i.div(e.length)}(i),this.touches=jo(o,i)));},Go.prototype.touchmove=function(t,e,i){if(!this.aborted&&this.centroid){var o=jo(i,e);for(var r in this.touches){var a=o[r];(!a||a.dist(this.touches[r])>30)&&(this.aborted=!0);}}},Go.prototype.touchend=function(t,e,i){if((!this.centroid||t.timeStamp-this.startTime>500)&&(this.aborted=!0),0===i.length){var o=!this.aborted&&this.centroid;if(this.reset(),o)return o}};var Zo=function(t){this.singleTap=new Go(t),this.numTaps=t.numTaps,this.reset();};Zo.prototype.reset=function(){this.lastTime=1/0,delete this.lastTap,this.count=0,this.singleTap.reset();},Zo.prototype.touchstart=function(t,e,i){this.singleTap.touchstart(t,e,i);},Zo.prototype.touchmove=function(t,e,i){this.singleTap.touchmove(t,e,i);},Zo.prototype.touchend=function(t,e,i){var o=this.singleTap.touchend(t,e,i);if(o){var r=t.timeStamp-this.lastTime<500,a=!this.lastTap||this.lastTap.dist(o)<30;if(r&&a||this.reset(),this.count++,this.lastTime=t.timeStamp,this.lastTap=o,this.count===this.numTaps)return this.reset(),o}};var qo=function(){this._zoomIn=new Zo({numTouches:1,numTaps:2}),this._zoomOut=new Zo({numTouches:2,numTaps:1}),this.reset();};qo.prototype.reset=function(){this._active=!1,this._zoomIn.reset(),this._zoomOut.reset();},qo.prototype.touchstart=function(t,e,i){this._zoomIn.touchstart(t,e,i),this._zoomOut.touchstart(t,e,i);},qo.prototype.touchmove=function(t,e,i){this._zoomIn.touchmove(t,e,i),this._zoomOut.touchmove(t,e,i);},qo.prototype.touchend=function(t,e,i){var o=this,r=this._zoomIn.touchend(t,e,i),a=this._zoomOut.touchend(t,e,i);return r?(this._active=!0,t.preventDefault(),setTimeout((function(){return o.reset()}),0),{cameraAnimation:function(e){return e.easeTo({duration:300,zoom:e.getZoom()+1,around:e.unproject(r)},{originalEvent:t})}}):a?(this._active=!0,t.preventDefault(),setTimeout((function(){return o.reset()}),0),{cameraAnimation:function(e){return e.easeTo({duration:300,zoom:e.getZoom()-1,around:e.unproject(a)},{originalEvent:t})}}):void 0},qo.prototype.touchcancel=function(){this.reset();},qo.prototype.enable=function(){this._enabled=!0;},qo.prototype.disable=function(){this._enabled=!1,this.reset();},qo.prototype.isEnabled=function(){return this._enabled},qo.prototype.isActive=function(){return this._active};var Vo={0:1,2:2},Wo=function(t){this.reset(),this._clickTolerance=t.clickTolerance||1;};Wo.prototype.reset=function(){this._active=!1,this._moved=!1,delete this._lastPoint,delete this._eventButton;},Wo.prototype._correctButton=function(t,e){return !1},Wo.prototype._move=function(t,e){return {}},Wo.prototype.mousedown=function(t,e){if(!this._lastPoint){var o=i.mouseButton(t);this._correctButton(t,o)&&(this._lastPoint=e,this._eventButton=o);}},Wo.prototype.mousemoveWindow=function(t,e){var i=this._lastPoint;if(i)if(t.preventDefault(),function(t,e){var i=Vo[e];return void 0===t.buttons||(t.buttons&i)!==i}(t,this._eventButton))this.reset();else if(this._moved||!(e.dist(i)<this._clickTolerance))return this._moved=!0,this._lastPoint=e,this._move(i,e)},Wo.prototype.mouseupWindow=function(t){this._lastPoint&&i.mouseButton(t)===this._eventButton&&(this._moved&&i.suppressClick(),this.reset());},Wo.prototype.enable=function(){this._enabled=!0;},Wo.prototype.disable=function(){this._enabled=!1,this.reset();},Wo.prototype.isEnabled=function(){return this._enabled},Wo.prototype.isActive=function(){return this._active};var Xo=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.mousedown=function(e,i){t.prototype.mousedown.call(this,e,i),this._lastPoint&&(this._active=!0);},e.prototype._correctButton=function(t,e){return 0===e&&!t.ctrlKey},e.prototype._move=function(t,e){return {around:e,panDelta:e.sub(t)}},e}(Wo),Ho=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._correctButton=function(t,e){return 0===e&&t.ctrlKey||2===e},e.prototype._move=function(t,e){var i=.8*(e.x-t.x);if(i)return this._active=!0,{bearingDelta:i}},e.prototype.contextmenu=function(t){t.preventDefault();},e}(Wo),Ko=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype._correctButton=function(t,e){return 0===e&&t.ctrlKey||2===e},e.prototype._move=function(t,e){var i=-.5*(e.y-t.y);if(i)return this._active=!0,{pitchDelta:i}},e.prototype.contextmenu=function(t){t.preventDefault();},e}(Wo),Yo=function(t){this._minTouches=1,this._clickTolerance=t.clickTolerance||1,this.reset();};Yo.prototype.reset=function(){this._active=!1,this._touches={},this._sum=new t.Point(0,0);},Yo.prototype.touchstart=function(t,e,i){return this._calculateTransform(t,e,i)},Yo.prototype.touchmove=function(t,e,i){if(this._active&&!(i.length<this._minTouches))return t.preventDefault(),this._calculateTransform(t,e,i)},Yo.prototype.touchend=function(t,e,i){this._calculateTransform(t,e,i),this._active&&i.length<this._minTouches&&this.reset();},Yo.prototype.touchcancel=function(){this.reset();},Yo.prototype._calculateTransform=function(e,i,o){o.length>0&&(this._active=!0);var r=jo(o,i),a=new t.Point(0,0),n=new t.Point(0,0),s=0;for(var l in r){var c=r[l],h=this._touches[l];h&&(a._add(c),n._add(c.sub(h)),s++,r[l]=c);}if(this._touches=r,!(s<this._minTouches)&&n.mag()){var u=n.div(s);if(this._sum._add(u),!(this._sum.mag()<this._clickTolerance))return {around:a.div(s),panDelta:u}}},Yo.prototype.enable=function(){this._enabled=!0;},Yo.prototype.disable=function(){this._enabled=!1,this.reset();},Yo.prototype.isEnabled=function(){return this._enabled},Yo.prototype.isActive=function(){return this._active};var Jo=function(){this.reset();};function Qo(t,e,i){for(var o=0;o<t.length;o++)if(t[o].identifier===i)return e[o]}function $o(t,e){return Math.log(t/e)/Math.LN2}Jo.prototype.reset=function(){this._active=!1,delete this._firstTwoTouches;},Jo.prototype._start=function(t){},Jo.prototype._move=function(t,e,i){return {}},Jo.prototype.touchstart=function(t,e,i){this._firstTwoTouches||i.length<2||(this._firstTwoTouches=[i[0].identifier,i[1].identifier],this._start([e[0],e[1]]));},Jo.prototype.touchmove=function(t,e,i){if(this._firstTwoTouches){t.preventDefault();var o=this._firstTwoTouches,r=o[1],a=Qo(i,e,o[0]),n=Qo(i,e,r);if(a&&n){var s=this._aroundCenter?null:a.add(n).div(2);return this._move([a,n],s,t)}}},Jo.prototype.touchend=function(t,e,o){if(this._firstTwoTouches){var r=this._firstTwoTouches,a=r[1],n=Qo(o,e,r[0]),s=Qo(o,e,a);n&&s||(this._active&&i.suppressClick(),this.reset());}},Jo.prototype.touchcancel=function(){this.reset();},Jo.prototype.enable=function(t){this._enabled=!0,this._aroundCenter=!!t&&"center"===t.around;},Jo.prototype.disable=function(){this._enabled=!1,this.reset();},Jo.prototype.isEnabled=function(){return this._enabled},Jo.prototype.isActive=function(){return this._active};var tr=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.reset=function(){t.prototype.reset.call(this),delete this._distance,delete this._startDistance;},e.prototype._start=function(t){this._startDistance=this._distance=t[0].dist(t[1]);},e.prototype._move=function(t,e){var i=this._distance;if(this._distance=t[0].dist(t[1]),this._active||!(Math.abs($o(this._distance,this._startDistance))<.1))return this._active=!0,{zoomDelta:$o(this._distance,i),pinchAround:e}},e}(Jo);function er(t,e){return 180*t.angleWith(e)/Math.PI}var ir=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.reset=function(){t.prototype.reset.call(this),delete this._minDiameter,delete this._startVector,delete this._vector;},e.prototype._start=function(t){this._startVector=this._vector=t[0].sub(t[1]),this._minDiameter=t[0].dist(t[1]);},e.prototype._move=function(t,e){var i=this._vector;if(this._vector=t[0].sub(t[1]),this._active||!this._isBelowThreshold(this._vector))return this._active=!0,{bearingDelta:er(this._vector,i),pinchAround:e}},e.prototype._isBelowThreshold=function(t){this._minDiameter=Math.min(this._minDiameter,t.mag());var e=25/(Math.PI*this._minDiameter)*360,i=er(t,this._startVector);return Math.abs(i)<e},e}(Jo);function or(t){return Math.abs(t.y)>Math.abs(t.x)}var rr=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e.prototype.reset=function(){t.prototype.reset.call(this),this._valid=void 0,delete this._firstMove,delete this._lastPoints;},e.prototype._start=function(t){this._lastPoints=t,or(t[0].sub(t[1]))&&(this._valid=!1);},e.prototype._move=function(t,e,i){var o=t[0].sub(this._lastPoints[0]),r=t[1].sub(this._lastPoints[1]);if(this._valid=this.gestureBeginsVertically(o,r,i.timeStamp),this._valid)return this._lastPoints=t,this._active=!0,{pitchDelta:(o.y+r.y)/2*-.5}},e.prototype.gestureBeginsVertically=function(t,e,i){if(void 0!==this._valid)return this._valid;var o=t.mag()>=2,r=e.mag()>=2;if(o||r){if(!o||!r)return void 0===this._firstMove&&(this._firstMove=i),i-this._firstMove<100&&void 0;var a=t.y>0==e.y>0;return or(t)&&or(e)&&a}},e}(Jo),ar={panStep:100,bearingStep:15,pitchStep:10},nr=function(){var t=ar;this._panStep=t.panStep,this._bearingStep=t.bearingStep,this._pitchStep=t.pitchStep;};function sr(t){return t*(2-t)}nr.prototype.reset=function(){this._active=!1;},nr.prototype.keydown=function(t){var e=this;if(!(t.altKey||t.ctrlKey||t.metaKey)){var i=0,o=0,r=0,a=0,n=0;switch(t.keyCode){case 61:case 107:case 171:case 187:i=1;break;case 189:case 109:case 173:i=-1;break;case 37:t.shiftKey?o=-1:(t.preventDefault(),a=-1);break;case 39:t.shiftKey?o=1:(t.preventDefault(),a=1);break;case 38:t.shiftKey?r=1:(t.preventDefault(),n=-1);break;case 40:t.shiftKey?r=-1:(t.preventDefault(),n=1);break;default:return}return {cameraAnimation:function(s){var l=s.getZoom();s.easeTo({duration:300,easeId:"keyboardHandler",easing:sr,zoom:i?Math.round(l)+i*(t.shiftKey?2:1):l,bearing:s.getBearing()+o*e._bearingStep,pitch:s.getPitch()+r*e._pitchStep,offset:[-a*e._panStep,-n*e._panStep],center:s.getCenter()},{originalEvent:t});}}}},nr.prototype.enable=function(){this._enabled=!0;},nr.prototype.disable=function(){this._enabled=!1,this.reset();},nr.prototype.isEnabled=function(){return this._enabled},nr.prototype.isActive=function(){return this._active};var lr=function(e,i){this._map=e,this._el=e.getCanvasContainer(),this._handler=i,this._delta=0,this._defaultZoomRate=.01,this._wheelZoomRate=1/450,t.bindAll(["_onTimeout"],this);};lr.prototype.setZoomRate=function(t){this._defaultZoomRate=t;},lr.prototype.setWheelZoomRate=function(t){this._wheelZoomRate=t;},lr.prototype.isEnabled=function(){return !!this._enabled},lr.prototype.isActive=function(){return !!this._active||void 0!==this._finishTimeout},lr.prototype.isZooming=function(){return !!this._zooming},lr.prototype.enable=function(t){this.isEnabled()||(this._enabled=!0,this._aroundCenter=t&&"center"===t.around);},lr.prototype.disable=function(){this.isEnabled()&&(this._enabled=!1);},lr.prototype.wheel=function(e){if(this.isEnabled()){var i=e.deltaMode===t.window.WheelEvent.DOM_DELTA_LINE?40*e.deltaY:e.deltaY,o=t.browser.now(),r=o-(this._lastWheelEventTime||0);this._lastWheelEventTime=o,0!==i&&i%4.000244140625==0?this._type="wheel":0!==i&&Math.abs(i)<4?this._type="trackpad":r>400?(this._type=null,this._lastValue=i,this._timeout=setTimeout(this._onTimeout,40,e)):this._type||(this._type=Math.abs(r*i)<200?"trackpad":"wheel",this._timeout&&(clearTimeout(this._timeout),this._timeout=null,i+=this._lastValue)),e.shiftKey&&i&&(i/=4),this._type&&(this._lastWheelEvent=e,this._delta-=i,this._active||this._start(e)),e.preventDefault();}},lr.prototype._onTimeout=function(t){this._type="wheel",this._delta-=this._lastValue,this._active||this._start(t);},lr.prototype._start=function(e){if(this._delta){this._frameId&&(this._frameId=null),this._active=!0,this.isZooming()||(this._zooming=!0),this._finishTimeout&&(clearTimeout(this._finishTimeout),delete this._finishTimeout);var o=i.mousePos(this._el,e);this._around=t.LngLat.convert(this._aroundCenter?this._map.getCenter():this._map.unproject(o)),this._aroundPoint=this._map.transform.locationPoint(this._around),this._frameId||(this._frameId=!0,this._handler._triggerRenderFrame());}},lr.prototype.renderFrame=function(){var e=this;if(this._frameId&&(this._frameId=null,this.isActive())){var i=this._map.transform;if(0!==this._delta){var o="wheel"===this._type&&Math.abs(this._delta)>4.000244140625?this._wheelZoomRate:this._defaultZoomRate,r=2/(1+Math.exp(-Math.abs(this._delta*o)));this._delta<0&&0!==r&&(r=1/r);var a="number"==typeof this._targetZoom?i.zoomScale(this._targetZoom):i.scale;this._targetZoom=Math.min(i.maxZoom,Math.max(i.minZoom,i.scaleZoom(a*r))),"wheel"===this._type&&(this._startZoom=i.zoom,this._easing=this._smoothOutEasing(200)),this._delta=0;}var n,s="number"==typeof this._targetZoom?this._targetZoom:i.zoom,l=this._startZoom,c=this._easing,h=!1;if("wheel"===this._type&&l&&c){var u=Math.min((t.browser.now()-this._lastWheelEventTime)/200,1),p=c(u);n=t.number(l,s,p),u<1?this._frameId||(this._frameId=!0):h=!0;}else n=s,h=!0;return this._active=!0,h&&(this._active=!1,this._finishTimeout=setTimeout((function(){e._zooming=!1,e._handler._triggerRenderFrame(),delete e._targetZoom,delete e._finishTimeout;}),200)),{noInertia:!0,needsRenderFrame:!h,zoomDelta:n-i.zoom,around:this._aroundPoint,originalEvent:this._lastWheelEvent}}},lr.prototype._smoothOutEasing=function(e){var i=t.ease;if(this._prevEase){var o=this._prevEase,r=(t.browser.now()-o.start)/o.duration,a=o.easing(r+.01)-o.easing(r),n=.27/Math.sqrt(a*a+1e-4)*.01,s=Math.sqrt(.0729-n*n);i=t.bezier(n,s,.25,1);}return this._prevEase={start:t.browser.now(),duration:e,easing:i},i},lr.prototype.reset=function(){this._active=!1;};var cr=function(t,e){this._clickZoom=t,this._tapZoom=e;};cr.prototype.enable=function(){this._clickZoom.enable(),this._tapZoom.enable();},cr.prototype.disable=function(){this._clickZoom.disable(),this._tapZoom.disable();},cr.prototype.isEnabled=function(){return this._clickZoom.isEnabled()&&this._tapZoom.isEnabled()},cr.prototype.isActive=function(){return this._clickZoom.isActive()||this._tapZoom.isActive()};var hr=function(){this.reset();};hr.prototype.reset=function(){this._active=!1;},hr.prototype.dblclick=function(t,e){return t.preventDefault(),{cameraAnimation:function(i){i.easeTo({duration:300,zoom:i.getZoom()+(t.shiftKey?-1:1),around:i.unproject(e)},{originalEvent:t});}}},hr.prototype.enable=function(){this._enabled=!0;},hr.prototype.disable=function(){this._enabled=!1,this.reset();},hr.prototype.isEnabled=function(){return this._enabled},hr.prototype.isActive=function(){return this._active};var ur=function(){this._tap=new Zo({numTouches:1,numTaps:1}),this.reset();};ur.prototype.reset=function(){this._active=!1,delete this._swipePoint,delete this._swipeTouch,delete this._tapTime,this._tap.reset();},ur.prototype.touchstart=function(t,e,i){this._swipePoint||(this._tapTime&&t.timeStamp-this._tapTime>500&&this.reset(),this._tapTime?i.length>0&&(this._swipePoint=e[0],this._swipeTouch=i[0].identifier):this._tap.touchstart(t,e,i));},ur.prototype.touchmove=function(t,e,i){if(this._tapTime){if(this._swipePoint){if(i[0].identifier!==this._swipeTouch)return;var o=e[0],r=o.y-this._swipePoint.y;return this._swipePoint=o,t.preventDefault(),this._active=!0,{zoomDelta:r/128}}}else this._tap.touchmove(t,e,i);},ur.prototype.touchend=function(t,e,i){this._tapTime?this._swipePoint&&0===i.length&&this.reset():this._tap.touchend(t,e,i)&&(this._tapTime=t.timeStamp);},ur.prototype.touchcancel=function(){this.reset();},ur.prototype.enable=function(){this._enabled=!0;},ur.prototype.disable=function(){this._enabled=!1,this.reset();},ur.prototype.isEnabled=function(){return this._enabled},ur.prototype.isActive=function(){return this._active};var pr=function(t,e,i){this._el=t,this._mousePan=e,this._touchPan=i;};pr.prototype.enable=function(t){this._inertiaOptions=t||{},this._mousePan.enable(),this._touchPan.enable(),this._el.classList.add("mapboxgl-touch-drag-pan");},pr.prototype.disable=function(){this._mousePan.disable(),this._touchPan.disable(),this._el.classList.remove("mapboxgl-touch-drag-pan");},pr.prototype.isEnabled=function(){return this._mousePan.isEnabled()&&this._touchPan.isEnabled()},pr.prototype.isActive=function(){return this._mousePan.isActive()||this._touchPan.isActive()};var dr=function(t,e,i){this._pitchWithRotate=t.pitchWithRotate,this._mouseRotate=e,this._mousePitch=i;};dr.prototype.enable=function(){this._mouseRotate.enable(),this._pitchWithRotate&&this._mousePitch.enable();},dr.prototype.disable=function(){this._mouseRotate.disable(),this._mousePitch.disable();},dr.prototype.isEnabled=function(){return this._mouseRotate.isEnabled()&&(!this._pitchWithRotate||this._mousePitch.isEnabled())},dr.prototype.isActive=function(){return this._mouseRotate.isActive()||this._mousePitch.isActive()};var _r=function(t,e,i,o){this._el=t,this._touchZoom=e,this._touchRotate=i,this._tapDragZoom=o,this._rotationDisabled=!1,this._enabled=!0;};_r.prototype.enable=function(t){this._touchZoom.enable(t),this._rotationDisabled||this._touchRotate.enable(t),this._tapDragZoom.enable(),this._el.classList.add("mapboxgl-touch-zoom-rotate");},_r.prototype.disable=function(){this._touchZoom.disable(),this._touchRotate.disable(),this._tapDragZoom.disable(),this._el.classList.remove("mapboxgl-touch-zoom-rotate");},_r.prototype.isEnabled=function(){return this._touchZoom.isEnabled()&&(this._rotationDisabled||this._touchRotate.isEnabled())&&this._tapDragZoom.isEnabled()},_r.prototype.isActive=function(){return this._touchZoom.isActive()||this._touchRotate.isActive()||this._tapDragZoom.isActive()},_r.prototype.disableRotation=function(){this._rotationDisabled=!0,this._touchRotate.disable();},_r.prototype.enableRotation=function(){this._rotationDisabled=!1,this._touchZoom.isEnabled()&&this._touchRotate.enable();};var fr=function(t){return t.zoom||t.drag||t.pitch||t.rotate},mr=function(t){function e(){t.apply(this,arguments);}return t&&(e.__proto__=t),(e.prototype=Object.create(t&&t.prototype)).constructor=e,e}(t.Event);function gr(t){return t.panDelta&&t.panDelta.mag()||t.zoomDelta||t.bearingDelta||t.pitchDelta}var vr=function(e,o){this._map=e,this._el=this._map.getCanvasContainer(),this._handlers=[],this._handlersById={},this._changes=[],this._inertia=new Do(e),this._bearingSnap=o.bearingSnap,this._previousActiveHandlers={},this._eventsInProgress={},this._addDefaultHandlers(o),t.bindAll(["handleEvent","handleWindowEvent"],this);var r=this._el;this._listeners=[[r,"touchstart",{passive:!0}],[r,"touchmove",{passive:!1}],[r,"touchend",void 0],[r,"touchcancel",void 0],[r,"mousedown",void 0],[r,"mousemove",void 0],[r,"mouseup",void 0],[t.window.document,"mousemove",{capture:!0}],[t.window.document,"mouseup",void 0],[r,"mouseover",void 0],[r,"mouseout",void 0],[r,"dblclick",void 0],[r,"click",void 0],[r,"keydown",{capture:!1}],[r,"keyup",void 0],[r,"wheel",{passive:!1}],[r,"contextmenu",void 0],[t.window,"blur",void 0]];for(var a=0,n=this._listeners;a<n.length;a+=1){var s=n[a],l=s[0];i.addEventListener(l,s[1],l===t.window.document?this.handleWindowEvent:this.handleEvent,s[2]);}};vr.prototype.destroy=function(){for(var e=0,o=this._listeners;e<o.length;e+=1){var r=o[e],a=r[0];i.removeEventListener(a,r[1],a===t.window.document?this.handleWindowEvent:this.handleEvent,r[2]);}},vr.prototype._addDefaultHandlers=function(t){var e=this._map,i=e.getCanvasContainer();this._add("mapEvent",new Fo(e,t));var o=e.boxZoom=new No(e,t);this._add("boxZoom",o);var r=new qo,a=new hr;e.doubleClickZoom=new cr(a,r),this._add("tapZoom",r),this._add("clickZoom",a);var n=new ur;this._add("tapDragZoom",n);var s=e.touchPitch=new rr;this._add("touchPitch",s);var l=new Ho(t),c=new Ko(t);e.dragRotate=new dr(t,l,c),this._add("mouseRotate",l,["mousePitch"]),this._add("mousePitch",c,["mouseRotate"]);var h=new Xo(t),u=new Yo(t);e.dragPan=new pr(i,h,u),this._add("mousePan",h),this._add("touchPan",u,["touchZoom","touchRotate"]);var p=new ir,d=new tr;e.touchZoomRotate=new _r(i,d,p,n),this._add("touchRotate",p,["touchPan","touchZoom"]),this._add("touchZoom",d,["touchPan","touchRotate"]);var _=e.scrollZoom=new lr(e,this);this._add("scrollZoom",_,["mousePan"]);var f=e.keyboard=new nr;this._add("keyboard",f),this._add("blockableMapEvent",new Uo(e));for(var m=0,g=["boxZoom","doubleClickZoom","tapDragZoom","touchPitch","dragRotate","dragPan","touchZoomRotate","scrollZoom","keyboard"];m<g.length;m+=1){var v=g[m];t.interactive&&t[v]&&e[v].enable(t[v]);}},vr.prototype._add=function(t,e,i){this._handlers.push({handlerName:t,handler:e,allowed:i}),this._handlersById[t]=e;},vr.prototype.stop=function(t){if(!this._updatingCamera){for(var e=0,i=this._handlers;e<i.length;e+=1)i[e].handler.reset();this._inertia.clear(),this._fireEvents({},{},t),this._changes=[];}},vr.prototype.isActive=function(){for(var t=0,e=this._handlers;t<e.length;t+=1)if(e[t].handler.isActive())return !0;return !1},vr.prototype.isZooming=function(){return !!this._eventsInProgress.zoom||this._map.scrollZoom.isZooming()},vr.prototype.isRotating=function(){return !!this._eventsInProgress.rotate},vr.prototype.isMoving=function(){return Boolean(fr(this._eventsInProgress))||this.isZooming()},vr.prototype._blockedByActive=function(t,e,i){for(var o in t)if(o!==i&&(!e||e.indexOf(o)<0))return !0;return !1},vr.prototype.handleWindowEvent=function(t){this.handleEvent(t,t.type+"Window");},vr.prototype._getMapTouches=function(t){for(var e=[],i=0,o=t;i<o.length;i+=1){var r=o[i];this._el.contains(r.target)&&e.push(r);}return e},vr.prototype.handleEvent=function(t,e){if("blur"!==t.type){this._updatingCamera=!0;for(var o="renderFrame"===t.type?void 0:t,r={needsRenderFrame:!1},a={},n={},s=t.touches?this._getMapTouches(t.touches):void 0,l=s?i.touchPos(this._el,s):i.mousePos(this._el,t),c=0,h=this._handlers;c<h.length;c+=1){var u=h[c],p=u.handlerName,d=u.handler,_=u.allowed;if(d.isEnabled()){var f=void 0;this._blockedByActive(n,_,p)?d.reset():d[e||t.type]&&(f=d[e||t.type](t,l,s),this.mergeHandlerResult(r,a,f,p,o),f&&f.needsRenderFrame&&this._triggerRenderFrame()),(f||d.isActive())&&(n[p]=d);}}var m={};for(var g in this._previousActiveHandlers)n[g]||(m[g]=o);this._previousActiveHandlers=n,(Object.keys(m).length||gr(r))&&(this._changes.push([r,a,m]),this._triggerRenderFrame()),(Object.keys(n).length||gr(r))&&this._map._stop(!0),this._updatingCamera=!1;var v=r.cameraAnimation;v&&(this._inertia.clear(),this._fireEvents({},{},!0),this._changes=[],v(this._map));}else this.stop(!0);},vr.prototype.mergeHandlerResult=function(e,i,o,r,a){if(o){t.extend(e,o);var n={handlerName:r,originalEvent:o.originalEvent||a};void 0!==o.zoomDelta&&(i.zoom=n),void 0!==o.panDelta&&(i.drag=n),void 0!==o.pitchDelta&&(i.pitch=n),void 0!==o.bearingDelta&&(i.rotate=n);}},vr.prototype._applyChanges=function(){for(var e={},i={},o={},r=0,a=this._changes;r<a.length;r+=1){var n=a[r],s=n[0],l=n[1],c=n[2];s.panDelta&&(e.panDelta=(e.panDelta||new t.Point(0,0))._add(s.panDelta)),s.zoomDelta&&(e.zoomDelta=(e.zoomDelta||0)+s.zoomDelta),s.bearingDelta&&(e.bearingDelta=(e.bearingDelta||0)+s.bearingDelta),s.pitchDelta&&(e.pitchDelta=(e.pitchDelta||0)+s.pitchDelta),void 0!==s.around&&(e.around=s.around),void 0!==s.pinchAround&&(e.pinchAround=s.pinchAround),s.noInertia&&(e.noInertia=s.noInertia),t.extend(i,l),t.extend(o,c);}this._updateMapTransform(e,i,o),this._changes=[];},vr.prototype._updateMapTransform=function(t,e,i){var o=this._map,r=o.transform;if(!gr(t))return this._fireEvents(e,i,!0);var a=t.panDelta,n=t.zoomDelta,s=t.bearingDelta,l=t.pitchDelta,c=t.around,h=t.pinchAround;void 0!==h&&(c=h),o._stop(!0),c=c||o.transform.centerPoint;var u=r.pointLocation(a?c.sub(a):c);s&&(r.bearing+=s),l&&(r.pitch+=l),n&&(r.zoom+=n),r.setLocationAtPoint(u,c),this._map._update(),t.noInertia||this._inertia.record(t),this._fireEvents(e,i,!0);},vr.prototype._fireEvents=function(e,i,o){var r=this,a=fr(this._eventsInProgress),n=fr(e),s={};for(var l in e)this._eventsInProgress[l]||(s[l+"start"]=e[l].originalEvent),this._eventsInProgress[l]=e[l];for(var c in !a&&n&&this._fireEvent("movestart",n.originalEvent),s)this._fireEvent(c,s[c]);for(var h in n&&this._fireEvent("move",n.originalEvent),e)this._fireEvent(h,e[h].originalEvent);var u,p={};for(var d in this._eventsInProgress){var _=this._eventsInProgress[d],f=_.handlerName,m=_.originalEvent;this._handlersById[f].isActive()||(delete this._eventsInProgress[d],p[d+"end"]=u=i[f]||m);}for(var g in p)this._fireEvent(g,p[g]);var v=fr(this._eventsInProgress);if(o&&(a||n)&&!v){this._updatingCamera=!0;var y=this._inertia._onMoveEnd(this._map.dragPan._inertiaOptions),x=function(t){return 0!==t&&-r._bearingSnap<t&&t<r._bearingSnap};y?(x(y.bearing||this._map.getBearing())&&(y.bearing=0),this._map.easeTo(y,{originalEvent:u})):(this._map.fire(new t.Event("moveend",{originalEvent:u})),x(this._map.getBearing())&&this._map.resetNorth()),this._updatingCamera=!1;}},vr.prototype._fireEvent=function(e,i){this._map.fire(new t.Event(e,i?{originalEvent:i}:{}));},vr.prototype._requestFrame=function(){var t=this;return this._map.triggerRepaint(),this._map._renderTaskQueue.add((function(e){delete t._frameId,t.handleEvent(new mr("renderFrame",{timeStamp:e})),t._applyChanges();}))},vr.prototype._triggerRenderFrame=function(){void 0===this._frameId&&(this._frameId=this._requestFrame());};var yr=function(e){function i(i,o){e.call(this),this._moving=!1,this._zooming=!1,this.transform=i,this._bearingSnap=o.bearingSnap,t.bindAll(["_renderFrameCallback"],this);}return e&&(i.__proto__=e),(i.prototype=Object.create(e&&e.prototype)).constructor=i,i.prototype.getCenter=function(){return new t.LngLat(this.transform.center.lng,this.transform.center.lat)},i.prototype.setCenter=function(t,e){return this.jumpTo({center:t},e)},i.prototype.panBy=function(e,i,o){return e=t.Point.convert(e).mult(-1),this.panTo(this.transform.center,t.extend({offset:e},i),o)},i.prototype.panTo=function(e,i,o){return this.easeTo(t.extend({center:e},i),o)},i.prototype.getZoom=function(){return this.transform.zoom},i.prototype.setZoom=function(t,e){return this.jumpTo({zoom:t},e),this},i.prototype.zoomTo=function(e,i,o){return this.easeTo(t.extend({zoom:e},i),o)},i.prototype.zoomIn=function(t,e){return this.zoomTo(this.getZoom()+1,t,e),this},i.prototype.zoomOut=function(t,e){return this.zoomTo(this.getZoom()-1,t,e),this},i.prototype.getBearing=function(){return this.transform.bearing},i.prototype.setBearing=function(t,e){return this.jumpTo({bearing:t},e),this},i.prototype.getPadding=function(){return this.transform.padding},i.prototype.setPadding=function(t,e){return this.jumpTo({padding:t},e),this},i.prototype.rotateTo=function(e,i,o){return this.easeTo(t.extend({bearing:e},i),o)},i.prototype.resetNorth=function(e,i){return this.rotateTo(0,t.extend({duration:1e3},e),i),this},i.prototype.resetNorthPitch=function(e,i){return this.easeTo(t.extend({bearing:0,pitch:0,duration:1e3},e),i),this},i.prototype.snapToNorth=function(t,e){return Math.abs(this.getBearing())<this._bearingSnap?this.resetNorth(t,e):this},i.prototype.getPitch=function(){return this.transform.pitch},i.prototype.setPitch=function(t,e){return this.jumpTo({pitch:t},e),this},i.prototype.cameraForBounds=function(e,i){return e=t.LngLatBounds.convert(e),this._cameraForBoxAndBearing(e.getNorthWest(),e.getSouthEast(),0,i)},i.prototype._cameraForBoxAndBearing=function(e,i,o,r){var a={top:0,bottom:0,right:0,left:0};if("number"==typeof(r=t.extend({padding:a,offset:[0,0],maxZoom:this.transform.maxZoom},r)).padding){var n=r.padding;r.padding={top:n,bottom:n,right:n,left:n};}r.padding=t.extend(a,r.padding);var s=this.transform,l=s.padding,c=s.project(t.LngLat.convert(e)),h=s.project(t.LngLat.convert(i)),u=c.rotate(-o*Math.PI/180),p=h.rotate(-o*Math.PI/180),d=new t.Point(Math.max(u.x,p.x),Math.max(u.y,p.y)),_=new t.Point(Math.min(u.x,p.x),Math.min(u.y,p.y)),f=d.sub(_),m=(s.width-(l.left+l.right+r.padding.left+r.padding.right))/f.x,g=(s.height-(l.top+l.bottom+r.padding.top+r.padding.bottom))/f.y;if(!(g<0||m<0)){var v=Math.min(s.scaleZoom(s.scale*Math.min(m,g)),r.maxZoom),y=t.Point.convert(r.offset),x=new t.Point(y.x+(r.padding.left-r.padding.right)/2,y.y+(r.padding.top-r.padding.bottom)/2).mult(s.scale/s.zoomScale(v));return {center:s.unproject(c.add(h).div(2).sub(x)),zoom:v,bearing:o}}t.warnOnce("Map cannot fit within canvas with the given bounds, padding, and/or offset.");},i.prototype.fitBounds=function(t,e,i){return this._fitInternal(this.cameraForBounds(t,e),e,i)},i.prototype.fitScreenCoordinates=function(e,i,o,r,a){return this._fitInternal(this._cameraForBoxAndBearing(this.transform.pointLocation(t.Point.convert(e)),this.transform.pointLocation(t.Point.convert(i)),o,r),r,a)},i.prototype._fitInternal=function(e,i,o){return e?(delete(i=t.extend(e,i)).padding,i.linear?this.easeTo(i,o):this.flyTo(i,o)):this},i.prototype.jumpTo=function(e,i){this.stop();var o=this.transform,r=!1,a=!1,n=!1;return "zoom"in e&&o.zoom!==+e.zoom&&(r=!0,o.zoom=+e.zoom),void 0!==e.center&&(o.center=t.LngLat.convert(e.center)),"bearing"in e&&o.bearing!==+e.bearing&&(a=!0,o.bearing=+e.bearing),"pitch"in e&&o.pitch!==+e.pitch&&(n=!0,o.pitch=+e.pitch),null==e.padding||o.isPaddingEqual(e.padding)||(o.padding=e.padding),this.fire(new t.Event("movestart",i)).fire(new t.Event("move",i)),r&&this.fire(new t.Event("zoomstart",i)).fire(new t.Event("zoom",i)).fire(new t.Event("zoomend",i)),a&&this.fire(new t.Event("rotatestart",i)).fire(new t.Event("rotate",i)).fire(new t.Event("rotateend",i)),n&&this.fire(new t.Event("pitchstart",i)).fire(new t.Event("pitch",i)).fire(new t.Event("pitchend",i)),this.fire(new t.Event("moveend",i))},i.prototype.easeTo=function(e,i){var o=this;this._stop(!1,e.easeId),(!1===(e=t.extend({offset:[0,0],duration:500,easing:t.ease},e)).animate||!e.essential&&t.browser.prefersReducedMotion)&&(e.duration=0);var r=this.transform,a=this.getZoom(),n=this.getBearing(),s=this.getPitch(),l=this.getPadding(),c="zoom"in e?+e.zoom:a,h="bearing"in e?this._normalizeBearing(e.bearing,n):n,u="pitch"in e?+e.pitch:s,p="padding"in e?e.padding:r.padding,d=t.Point.convert(e.offset),_=r.centerPoint.add(d),f=r.pointLocation(_),m=t.LngLat.convert(e.center||f);this._normalizeCenter(m);var g,v,y=r.project(f),x=r.project(m).sub(y),b=r.zoomScale(c-a);e.around&&(g=t.LngLat.convert(e.around),v=r.locationPoint(g));var w={moving:this._moving,zooming:this._zooming,rotating:this._rotating,pitching:this._pitching};return this._zooming=this._zooming||c!==a,this._rotating=this._rotating||n!==h,this._pitching=this._pitching||u!==s,this._padding=!r.isPaddingEqual(p),this._easeId=e.easeId,this._prepareEase(i,e.noMoveStart,w),this._ease((function(e){if(o._zooming&&(r.zoom=t.number(a,c,e)),o._rotating&&(r.bearing=t.number(n,h,e)),o._pitching&&(r.pitch=t.number(s,u,e)),o._padding&&(r.interpolatePadding(l,p,e),_=r.centerPoint.add(d)),g)r.setLocationAtPoint(g,v);else {var f=r.zoomScale(r.zoom-a),m=c>a?Math.min(2,b):Math.max(.5,b),w=Math.pow(m,1-e),E=r.unproject(y.add(x.mult(e*w)).mult(f));r.setLocationAtPoint(r.renderWorldCopies?E.wrap():E,_);}o._fireMoveEvents(i);}),(function(t){o._afterEase(i,t);}),e),this},i.prototype._prepareEase=function(e,i,o){void 0===o&&(o={}),this._moving=!0,i||o.moving||this.fire(new t.Event("movestart",e)),this._zooming&&!o.zooming&&this.fire(new t.Event("zoomstart",e)),this._rotating&&!o.rotating&&this.fire(new t.Event("rotatestart",e)),this._pitching&&!o.pitching&&this.fire(new t.Event("pitchstart",e));},i.prototype._fireMoveEvents=function(e){this.fire(new t.Event("move",e)),this._zooming&&this.fire(new t.Event("zoom",e)),this._rotating&&this.fire(new t.Event("rotate",e)),this._pitching&&this.fire(new t.Event("pitch",e));},i.prototype._afterEase=function(e,i){if(!this._easeId||!i||this._easeId!==i){delete this._easeId;var o=this._zooming,r=this._rotating,a=this._pitching;this._moving=!1,this._zooming=!1,this._rotating=!1,this._pitching=!1,this._padding=!1,o&&this.fire(new t.Event("zoomend",e)),r&&this.fire(new t.Event("rotateend",e)),a&&this.fire(new t.Event("pitchend",e)),this.fire(new t.Event("moveend",e));}},i.prototype.flyTo=function(e,i){var o=this;if(!e.essential&&t.browser.prefersReducedMotion){var r=t.pick(e,["center","zoom","bearing","pitch","around"]);return this.jumpTo(r,i)}this.stop(),e=t.extend({offset:[0,0],speed:1.2,curve:1.42,easing:t.ease},e);var a=this.transform,n=this.getZoom(),s=this.getBearing(),l=this.getPitch(),c=this.getPadding(),h="zoom"in e?t.clamp(+e.zoom,a.minZoom,a.maxZoom):n,u="bearing"in e?this._normalizeBearing(e.bearing,s):s,p="pitch"in e?+e.pitch:l,d="padding"in e?e.padding:a.padding,_=a.zoomScale(h-n),f=t.Point.convert(e.offset),m=a.centerPoint.add(f),g=a.pointLocation(m),v=t.LngLat.convert(e.center||g);this._normalizeCenter(v);var y=a.project(g),x=a.project(v).sub(y),b=e.curve,w=Math.max(a.width,a.height),E=w/_,T=x.mag();if("minZoom"in e){var S=t.clamp(Math.min(e.minZoom,n,h),a.minZoom,a.maxZoom),I=w/a.zoomScale(S-n);b=Math.sqrt(I/T*2);}var P=b*b;function C(t){var e=(E*E-w*w+(t?-1:1)*P*P*T*T)/(2*(t?E:w)*P*T);return Math.log(Math.sqrt(e*e+1)-e)}function z(t){return (Math.exp(t)-Math.exp(-t))/2}function M(t){return (Math.exp(t)+Math.exp(-t))/2}var L=C(0),D=function(t){return M(L)/M(L+b*t)},R=function(t){return w*((M(L)*(z(e=L+b*t)/M(e))-z(L))/P)/T;var e;},A=(C(1)-L)/b;if(Math.abs(T)<1e-6||!isFinite(A)){if(Math.abs(w-E)<1e-6)return this.easeTo(e,i);var k=E<w?-1:1;A=Math.abs(Math.log(E/w))/b,R=function(){return 0},D=function(t){return Math.exp(k*b*t)};}return e.duration="duration"in e?+e.duration:1e3*A/("screenSpeed"in e?+e.screenSpeed/b:+e.speed),e.maxDuration&&e.duration>e.maxDuration&&(e.duration=0),this._zooming=!0,this._rotating=s!==u,this._pitching=p!==l,this._padding=!a.isPaddingEqual(d),this._prepareEase(i,!1),this._ease((function(e){var r=e*A,_=1/D(r);a.zoom=1===e?h:n+a.scaleZoom(_),o._rotating&&(a.bearing=t.number(s,u,e)),o._pitching&&(a.pitch=t.number(l,p,e)),o._padding&&(a.interpolatePadding(c,d,e),m=a.centerPoint.add(f));var g=1===e?v:a.unproject(y.add(x.mult(R(r))).mult(_));a.setLocationAtPoint(a.renderWorldCopies?g.wrap():g,m),o._fireMoveEvents(i);}),(function(){return o._afterEase(i)}),e),this},i.prototype.isEasing=function(){return !!this._easeFrameId},i.prototype.stop=function(){return this._stop()},i.prototype._stop=function(t,e){if(this._easeFrameId&&(this._cancelRenderFrame(this._easeFrameId),delete this._easeFrameId,delete this._onEaseFrame),this._onEaseEnd){var i=this._onEaseEnd;delete this._onEaseEnd,i.call(this,e);}if(!t){var o=this.handlers;o&&o.stop(!1);}return this},i.prototype._ease=function(e,i,o){!1===o.animate||0===o.duration?(e(1),i()):(this._easeStart=t.browser.now(),this._easeOptions=o,this._onEaseFrame=e,this._onEaseEnd=i,this._easeFrameId=this._requestRenderFrame(this._renderFrameCallback));},i.prototype._renderFrameCallback=function(){var e=Math.min((t.browser.now()-this._easeStart)/this._easeOptions.duration,1);this._onEaseFrame(this._easeOptions.easing(e)),e<1?this._easeFrameId=this._requestRenderFrame(this._renderFrameCallback):this.stop();},i.prototype._normalizeBearing=function(e,i){e=t.wrap(e,-180,180);var o=Math.abs(e-i);return Math.abs(e-360-i)<o&&(e-=360),Math.abs(e+360-i)<o&&(e+=360),e},i.prototype._normalizeCenter=function(t){var e=this.transform;if(e.renderWorldCopies&&!e.lngRange){var i=t.lng-e.center.lng;t.lng+=i>180?-360:i<-180?360:0;}},i}(t.Evented),xr=function(e){void 0===e&&(e={}),this.options=e,t.bindAll(["_updateEditLink","_updateData","_updateCompact"],this);};xr.prototype.getDefaultPosition=function(){return "bottom-right"},xr.prototype.onAdd=function(t){var e=this.options&&this.options.compact;return this._map=t,this._container=i.create("div","mapboxgl-ctrl mapboxgl-ctrl-attrib"),this._innerContainer=i.create("div","mapboxgl-ctrl-attrib-inner",this._container),e&&this._container.classList.add("mapboxgl-compact"),this._updateAttributions(),this._updateEditLink(),this._map.on("styledata",this._updateData),this._map.on("sourcedata",this._updateData),this._map.on("moveend",this._updateEditLink),void 0===e&&(this._map.on("resize",this._updateCompact),this._updateCompact()),this._container},xr.prototype.onRemove=function(){i.remove(this._container),this._map.off("styledata",this._updateData),this._map.off("sourcedata",this._updateData),this._map.off("moveend",this._updateEditLink),this._map.off("resize",this._updateCompact),this._map=void 0,this._attribHTML=void 0;},xr.prototype._updateEditLink=function(){var e=this._editLink;e||(e=this._editLink=this._container.querySelector(".mapbox-improve-map"));var i=[{key:"owner",value:this.styleOwner},{key:"id",value:this.styleId},{key:"access_token",value:this._map._requestManager._customAccessToken||t.config.ACCESS_TOKEN}];if(e){var o=i.reduce((function(t,e,o){return e.value&&(t+=e.key+"="+e.value+(o<i.length-1?"&":"")),t}),"?");e.href=t.config.FEEDBACK_URL+"/"+o+(this._map._hash?this._map._hash.getHashString(!0):""),e.rel="noopener nofollow";}},xr.prototype._updateData=function(t){!t||"metadata"!==t.sourceDataType&&"style"!==t.dataType||(this._updateAttributions(),this._updateEditLink());},xr.prototype._updateAttributions=function(){if(this._map.style){var t=[];if(this.options.customAttribution&&(Array.isArray(this.options.customAttribution)?t=t.concat(this.options.customAttribution.map((function(t){return "string"!=typeof t?"":t}))):"string"==typeof this.options.customAttribution&&t.push(this.options.customAttribution)),this._map.style.stylesheet){var e=this._map.style.stylesheet;this.styleOwner=e.owner,this.styleId=e.id;}var i=this._map.style.sourceCaches;for(var o in i){var r=i[o];if(r.used){var a=r.getSource();a.attribution&&t.indexOf(a.attribution)<0&&t.push(a.attribution);}}t.sort((function(t,e){return t.length-e.length}));var n=(t=t.filter((function(e,i){for(var o=i+1;o<t.length;o++)if(t[o].indexOf(e)>=0)return !1;return !0}))).join(" | ");n!==this._attribHTML&&(this._attribHTML=n,t.length?(this._innerContainer.innerHTML=n,this._container.classList.remove("mapboxgl-attrib-empty")):this._container.classList.add("mapboxgl-attrib-empty"),this._editLink=null);}},xr.prototype._updateCompact=function(){this._map.getCanvasContainer().offsetWidth<=640?this._container.classList.add("mapboxgl-compact"):this._container.classList.remove("mapboxgl-compact");};var br=function(){t.bindAll(["_updateLogo"],this),t.bindAll(["_updateCompact"],this);};br.prototype.onAdd=function(t){this._map=t,this._container=i.create("div","mapboxgl-ctrl");var e=i.create("a","mapboxgl-ctrl-logo");return e.target="_blank",e.rel="noopener nofollow",e.href="https://www.mapbox.com/",e.setAttribute("aria-label",this._map._getUIString("LogoControl.Title")),e.setAttribute("rel","noopener nofollow"),this._container.appendChild(e),this._container.style.display="none",this._map.on("sourcedata",this._updateLogo),this._updateLogo(),this._map.on("resize",this._updateCompact),this._updateCompact(),this._container},br.prototype.onRemove=function(){i.remove(this._container),this._map.off("sourcedata",this._updateLogo),this._map.off("resize",this._updateCompact);},br.prototype.getDefaultPosition=function(){return "bottom-left"},br.prototype._updateLogo=function(t){t&&"metadata"!==t.sourceDataType||(this._container.style.display=this._logoRequired()?"block":"none");},br.prototype._logoRequired=function(){if(this._map.style){var t=this._map.style.sourceCaches;for(var e in t)if(t[e].getSource().mapbox_logo)return !0;return !1}},br.prototype._updateCompact=function(){var t=this._container.children;if(t.length){var e=t[0];this._map.getCanvasContainer().offsetWidth<250?e.classList.add("mapboxgl-compact"):e.classList.remove("mapboxgl-compact");}};var wr=function(){this._queue=[],this._id=0,this._cleared=!1,this._currentlyRunning=!1;};wr.prototype.add=function(t){var e=++this._id;return this._queue.push({callback:t,id:e,cancelled:!1}),e},wr.prototype.remove=function(t){for(var e=this._currentlyRunning,i=0,o=e?this._queue.concat(e):this._queue;i<o.length;i+=1){var r=o[i];if(r.id===t)return void(r.cancelled=!0)}},wr.prototype.run=function(t){void 0===t&&(t=0);var e=this._currentlyRunning=this._queue;this._queue=[];for(var i=0,o=e;i<o.length;i+=1){var r=o[i];if(!r.cancelled&&(r.callback(t),this._cleared))break}this._cleared=!1,this._currentlyRunning=!1;},wr.prototype.clear=function(){this._currentlyRunning&&(this._cleared=!0),this._queue=[];};var Er=[];function Tr(t){Er.push.apply(Er,t.names||[]);}Tr(t.tmerc),Tr(t.etmerc),Tr(t.utm),Tr(t.sterea),Tr(t.stere),Tr(t.somerc),Tr(t.omerc),Tr(t.lcc),Tr(t.krovak),Tr(t.cass),Tr(t.laea),Tr(t.aea),Tr(t.gnom),Tr(t.cea),Tr(t.eqc),Tr(t.poly),Tr(t.nzmg),Tr(t.mill),Tr(t.sinu),Tr(t.moll),Tr(t.eqdc),Tr(t.vandg),Tr(t.aeqd),Tr(t.ortho$1),Tr(t.qsc),Tr(t.robin),Tr(t.geocent),Tr(t.tpers),Tr(t.geos);var Sr=function e(i,o,r){var a;this.epsgCode=i,this.extent=r,this.renderWorldCopies=!0,Array.isArray(o)&&(this.extent=o,o=null),-180===this.extent[0]&&180===this.extent[2]&&90===this.extent[3]&&(this.extent[1]=Math.max(this.extent[1],-90)),this.WKT=o||e.defaultWKTs[i],this.WKT&&("object"!=typeof(a=t.parseCode(this.WKT))&&console.error("The projection defs value is not valid"),t.proj4.Proj.projections.get(a.projName)||console.error("The projection name "+a.projName+" is not supported.Perhaps values are "+function(t){for(var e=t.split(/[\s_-]+/),i=new Set,o=0;o<Er.length;o++)for(var r=Er[o],a=0;a<e.length;a++)r.toLowerCase().indexOf(e[a].toLowerCase())>=0&&i.add(r);return i.size>0?Array.from(i):Er}(a.projName).join(",")),t.proj4.defs(i,this.WKT));var n=t.proj4.defs(i);if(!n)throw new Error(i+" was not defined,make sure the WKT param was not null");this.unit=n.units||"degree",this.proj4Projection=t.proj4(i);var s=this.toWGS84([this.extent[0],this.extent[1]]),l=this.toWGS84([this.extent[2],this.extent[3]]);if(this.lngLatExtent=s.concat(l),s[0]>=l[0]||s[1]>=l[1]){if(-180===this.extent[0]&&-90===this.extent[1]&&180===this.extent[2]&&90===this.extent[3])return void(this.lngLatExtent=this.extent);t.warnOnce("The extent of this CRS "+this.extent+" is incorrect. Please set the correct extent.");var c=this.toWGS84([this.extent[0],this.extent[1]]),h=this.toWGS84([this.extent[2],this.extent[3]]),u=this.toWGS84([this.extent[0],this.extent[3]]),p=this.toWGS84([this.extent[2],this.extent[1]]),d=Math.min(c[0],h[0],u[0],p[0]),_=Math.max(c[0],h[0],u[0],p[0]),f=Math.min(c[1],h[1],u[1],p[1]),m=Math.max(c[1],h[1],u[1],p[1]);this.lngLatExtent=[d,f,_,m];}this._id=t.uniqueId(),e.set(this);};Sr.prototype.getExtent=function(){if(!this._rectifyExtent){var t=this.extent[2]-this.extent[0],e=this.extent[3]-this.extent[1];if(t===e)this._rectifyExtent=[this.extent[0],this.extent[1],this.extent[2],this.extent[3]];else {var i=Math.max(t,e);this._rectifyExtent=[this.extent[0],this.extent[3]-i,this.extent[0]+i,this.extent[3]];}}return this._rectifyExtent},Sr.prototype.getLngLatCenter=function(){return [this.lngLatExtent[2]-(this.lngLatExtent[2]-this.lngLatExtent[0])/2,this.lngLatExtent[3]-(this.lngLatExtent[3]-this.lngLatExtent[1])/2]},Sr.prototype.getLngLatExtent=function(){if(!this._rectifyLngLatExtent){var t=this.lngLatExtent[2]-this.lngLatExtent[0],e=this.lngLatExtent[3]-this.lngLatExtent[1];if(t===e)this._rectifyLngLatExtent=[].concat(this.lngLatExtent);else {var i=Math.max(t,e);this._rectifyLngLatExtent=[this.lngLatExtent[0],this.lngLatExtent[3]-i,this.lngLatExtent[0]+i,this.lngLatExtent[3]];}}return this._rectifyLngLatExtent},Sr.prototype.getOrigin=function(){return [this.extent[0],this.extent[3]]},Sr.prototype.getEpsgCode=function(){return this.epsgCode},Sr.prototype.getUnit=function(){return this.unit},Sr.prototype.getWKT=function(){return this.WKT},Sr.prototype.getWidth=function(){return this._rectifyExtent[2]-this._rectifyExtent[0]},Sr.prototype.getHeight=function(){return this._rectifyExtent[3]-this._rectifyExtent[1]},Sr.prototype.getOriginX=function(){return this._rectifyExtent[0]},Sr.prototype.getOriginY=function(){return this._rectifyExtent[3]},Sr.prototype.toWGS84=function(t){return this.proj4Projection.inverse(t)},Sr.prototype.fromWGS84=function(t){return this.proj4Projection.forward(t)},Sr.prototype.fromLngLat=function(e){var i=t.LngLat.convert(e),o=this.renderWorldCopies?i.lng:t.clamp(i.lng,-180,180),r=this.fromWGS84([o,i.lat]);return {x:(r[0]-this.getOriginX())/this.getWidth(),y:(this.getOriginY()-r[1])/this.getHeight(),z:0}},Sr.prototype.toLngLat=function(e,i){var o=this.renderWorldCopies?t.wrap(e,0,1):t.clamp(e,0,1),r=t.clamp(this.getOriginY()-i*this.getHeight(),this.extent[1],this.extent[3]),a=o*this.getWidth()+this.getOriginX(),n=this.toWGS84([a,r]),s=n[0],l=n[1];return new t.LngLat(this.renderWorldCopies?t.unWrapLng(s,e,o,1):s,l)},Sr.get=function(t){for(var e in Sr)if(Sr.hasOwnProperty(e)&&Sr[e].getEpsgCode&&Sr[e].getEpsgCode()===t)return Sr[e];return null},Sr.set=function(t){var e=t.getEpsgCode().replace(":","").toUpperCase();Sr[e]=t;},Sr.defaultWKTs={"EPSG:4490":'GEOGCS["China Geodetic Coordinate System 2000",DATUM["China_2000",SPHEROID["CGCS2000",6378137,298.257222101,AUTHORITY["EPSG","1024"]],AUTHORITY["EPSG","1043"]],PRIMEM["Greenwich",0,AUTHORITY["EPSG","8901"]],UNIT["degree",0.0174532925199433,AUTHORITY["EPSG","9122"]],AUTHORITY["EPSG","4490"]]',"EPSG:4214":'GEOGCS["Beijing 1954",DATUM["Beijing_1954",SPHEROID["Krassowsky 1940",6378245,298.3],TOWGS84[15.8,-154.4,-82.3,0,0,0,0]],PRIMEM["Greenwich",0,AUTHORITY["EPSG","8901"]],UNIT["degree",0.0174532925199433,AUTHORITY["EPSG","9122"]],AUTHORITY["EPSG","4214"]]',"EPSG:4610":'GEOGCS["Xian 1980",DATUM["Xian_1980",SPHEROID["IAG 1975",6378140,298.257,AUTHORITY["EPSG","7049"]],AUTHORITY["EPSG","6610"]],PRIMEM["Greenwich",0,AUTHORITY["EPSG","8901"]],UNIT["degree",0.0174532925199433,AUTHORITY["EPSG","9122"]],AUTHORITY["EPSG","4610"]]'},Sr.EPSG4326=new Sr("EPSG:4326",[-180,-90,180,90]),Sr.EPSG4490=new Sr("EPSG:4490",[-180,-90,180,90]),Sr.EPSG4214=new Sr("EPSG:4214",[-180,-90,180,90]),Sr.EPSG4610=new Sr("EPSG:4610",[-180,-90,180,90]),Sr.EPSG3857=new Sr("EPSG:3857",[-20037508.3427892,-20037508.3427892,20037508.3427892,20037508.3427892]);var Ir={"FullscreenControl.Enter":"Enter fullscreen","FullscreenControl.Exit":"Exit fullscreen","GeolocateControl.FindMyLocation":"Find my location","GeolocateControl.LocationNotAvailable":"Location not available","LogoControl.Title":"Mapbox logo","NavigationControl.ResetBearing":"Reset bearing to north","NavigationControl.ZoomIn":"Zoom in","NavigationControl.ZoomOut":"Zoom out","ScaleControl.Feet":"ft","ScaleControl.Meters":"m","ScaleControl.Kilometers":"km","ScaleControl.Miles":"mi","ScaleControl.NauticalMiles":"nm"},Pr=t.window.HTMLImageElement,Cr=t.window.HTMLElement,zr=t.window.ImageBitmap,Mr={center:[0,0],zoom:0,bearing:0,pitch:0,minZoom:-2,maxZoom:22,minPitch:0,maxPitch:60,interactive:!0,scrollZoom:!0,boxZoom:!0,dragRotate:!0,dragPan:!0,keyboard:!0,doubleClickZoom:!0,touchZoomRotate:!0,touchPitch:!0,bearingSnap:7,clickTolerance:3,pitchWithRotate:!0,hash:!1,attributionControl:!0,failIfMajorPerformanceCaveat:!1,preserveDrawingBuffer:!1,trackResize:!0,renderWorldCopies:!0,refreshExpiredTiles:!0,maxTileCacheSize:null,localIdeographFontFamily:"sans-serif",transformRequest:null,accessToken:null,fadeDuration:300,crossSourceCollisions:!0},Lr=function(o){function r(e){var i=this;if(null!=(e=t.extend({},Mr,e)).minZoom&&null!=e.maxZoom&&e.minZoom>e.maxZoom)throw new Error("maxZoom must be greater than or equal to minZoom");if(null!=e.minPitch&&null!=e.maxPitch&&e.minPitch>e.maxPitch)throw new Error("maxPitch must be greater than or equal to minPitch");if(null!=e.minPitch&&e.minPitch<0)throw new Error("minPitch must be greater than or equal to 0");if(null!=e.maxPitch&&e.maxPitch>60)throw new Error("maxPitch must be less than or equal to 60");var r=new To(e.minZoom,e.maxZoom,e.minPitch,e.maxPitch,e.renderWorldCopies);if(o.call(this,r,e),this.transform=r,this.crs=this.toCRS(e.crs),this.initCRS(this.crs),this._interactive=e.interactive,this._maxTileCacheSize=e.maxTileCacheSize,this._failIfMajorPerformanceCaveat=e.failIfMajorPerformanceCaveat,this._preserveDrawingBuffer=e.preserveDrawingBuffer,this._antialias=e.antialias,this._trackResize=e.trackResize,this._bearingSnap=e.bearingSnap,this._refreshExpiredTiles=e.refreshExpiredTiles,this._fadeDuration=e.fadeDuration,this._crossSourceCollisions=e.crossSourceCollisions,this._crossFadingFactor=1,this._collectResourceTiming=e.collectResourceTiming,this._renderTaskQueue=new wr,this._controls=[],this._markersCache=[],this._mapId=t.uniqueId(),this._locale=t.extend({},Ir,e.locale),this._requestManager=new t.RequestManager(e.transformRequest,e.accessToken),"string"==typeof e.container){if(this._container=t.window.document.getElementById(e.container),!this._container)throw new Error("Container '"+e.container+"' not found.")}else {if(!(e.container instanceof Cr))throw new Error("Invalid type: 'container' must be a String or HTMLElement.");this._container=e.container;}if(e.maxBounds&&this.setMaxBounds(e.maxBounds),t.bindAll(["_onWindowOnline","_onWindowResize","_contextLost","_contextRestored"],this),this._setupContainer(),this._setupPainter(),void 0===this.painter)throw new Error("Failed to initialize WebGL.");this.on("move",(function(){return i._update(!1)})),this.on("moveend",(function(){return i._update(!1)})),this.on("zoom",(function(){return i._update(!0)})),void 0!==t.window&&(t.window.addEventListener("online",this._onWindowOnline,!1),t.window.addEventListener("resize",this._onWindowResize,!1),t.window.addEventListener("orientationchange",this._onWindowResize,!1)),this.handlers=new vr(this,e),this._hash=e.hash&&new Io("string"==typeof e.hash&&e.hash||void 0).addTo(this),this._hash&&this._hash._onHashChange()||(this.jumpTo({center:e.center,zoom:e.zoom,bearing:e.bearing,pitch:e.pitch}),e.bounds&&(this.resize(),this.fitBounds(e.bounds,t.extend({},e.fitBoundsOptions,{duration:0})))),this.resize(),this._localIdeographFontFamily=e.localIdeographFontFamily,e.style&&this.setStyle(e.style,{localIdeographFontFamily:e.localIdeographFontFamily}),e.attributionControl&&this.addControl(new xr({customAttribution:e.customAttribution})),this.addControl(new br,e.logoPosition),this.on("style.load",(function(){i.transform.unmodified&&i.jumpTo(i.style.stylesheet);})),this.on("data",(function(e){i._update("style"===e.dataType),i.fire(new t.Event(e.dataType+"data",e));})),this.on("dataloading",(function(e){i.fire(new t.Event(e.dataType+"dataloading",e));}));}o&&(r.__proto__=o),(r.prototype=Object.create(o&&o.prototype)).constructor=r;var a={showTileBoundaries:{configurable:!0},showPadding:{configurable:!0},showCollisionBoxes:{configurable:!0},showOverdrawInspector:{configurable:!0},repaint:{configurable:!0},vertices:{configurable:!0},version:{configurable:!0}};return r.prototype.toCRS=function(t){if(t&&"string"==typeof t&&!(t=Sr.get(t)))throw new Error("crs "+t+" is not define");return t||Sr.EPSG3857},r.prototype.getCRS=function(){return this.crs},r.prototype._getMapId=function(){return this._mapId},r.prototype.addControl=function(e,i){if(void 0===i&&e.getDefaultPosition&&(i=e.getDefaultPosition()),void 0===i&&(i="top-right"),!e||!e.onAdd)return this.fire(new t.ErrorEvent(new Error("Invalid argument to map.addControl(). Argument must be a control with onAdd and onRemove methods.")));var o=e.onAdd(this);this._controls.push(e);var r=this._controlPositions[i];return -1!==i.indexOf("bottom")?r.insertBefore(o,r.firstChild):r.appendChild(o),this},r.prototype.removeControl=function(e){if(!e||!e.onRemove)return this.fire(new t.ErrorEvent(new Error("Invalid argument to map.removeControl(). Argument must be a control with onAdd and onRemove methods.")));var i=this._controls.indexOf(e);return i>-1&&this._controls.splice(i,1),e.onRemove(this),this},r.prototype.resize=function(e){var i=this._containerDimensions(),o=i[0],r=i[1];this._resizeCanvas(o,r),this.transform.resize(o,r),this.painter.resize(o,r);var a=!this._moving;return a&&(this.stop(),this.fire(new t.Event("movestart",e)).fire(new t.Event("move",e))),this.fire(new t.Event("resize",e)),a&&this.fire(new t.Event("moveend",e)),this},r.prototype.getBounds=function(){return this.transform.getBounds()},r.prototype.getMaxBounds=function(){return this.transform.getMaxBounds()},r.prototype.setMaxBounds=function(e){return this.transform.setMaxBounds(t.LngLatBounds.convert(e)),this._update()},r.prototype.setMinZoom=function(t){if((t=null==t?-2:t)>=-2&&t<=this.transform.maxZoom)return this.transform.minZoom=t,this._update(),this.getZoom()<t&&this.setZoom(t),this;throw new Error("minZoom must be between -2 and the current maxZoom, inclusive")},r.prototype.getMinZoom=function(){return this.transform.minZoom},r.prototype.setMaxZoom=function(t){if((t=null==t?22:t)>=this.transform.minZoom)return this.transform.maxZoom=t,this._update(),this.getZoom()>t&&this.setZoom(t),this;throw new Error("maxZoom must be greater than the current minZoom")},r.prototype.getMaxZoom=function(){return this.transform.maxZoom},r.prototype.setMinPitch=function(t){if((t=null==t?0:t)<0)throw new Error("minPitch must be greater than or equal to 0");if(t>=0&&t<=this.transform.maxPitch)return this.transform.minPitch=t,this._update(),this.getPitch()<t&&this.setPitch(t),this;throw new Error("minPitch must be between 0 and the current maxPitch, inclusive")},r.prototype.getMinPitch=function(){return this.transform.minPitch},r.prototype.setMaxPitch=function(t){if((t=null==t?60:t)>60)throw new Error("maxPitch must be less than or equal to 60");if(t>=this.transform.minPitch)return this.transform.maxPitch=t,this._update(),this.getPitch()>t&&this.setPitch(t),this;throw new Error("maxPitch must be greater than the current minPitch")},r.prototype.getMaxPitch=function(){return this.transform.maxPitch},r.prototype.getRenderWorldCopies=function(){return this.transform.renderWorldCopies},r.prototype.setRenderWorldCopies=function(t){var e=this._mapCRS&&this._mapCRS.getLngLatExtent();return Math.abs(e[0]+180)>1e-6&&Math.abs(e[2]-180)>1e-6||(this.transform.renderWorldCopies=t,this.crs.renderWorldCopies=t),this._update()},r.prototype.project=function(e){return this.transform.locationPoint(t.LngLat.convert(e))},r.prototype.unproject=function(e){return this.transform.pointLocation(t.Point.convert(e))},r.prototype.isMoving=function(){return this._moving||this.handlers.isMoving()},r.prototype.isZooming=function(){return this._zooming||this.handlers.isZooming()},r.prototype.isRotating=function(){return this._rotating||this.handlers.isRotating()},r.prototype._createDelegatedListener=function(t,e,i){var o,r=this;if("mouseenter"===t||"mouseover"===t){var a=!1;return {layer:e,listener:i,delegates:{mousemove:function(o){var n=r.getLayer(e)?r.queryRenderedFeatures(o.point,{layers:[e]}):[];n.length?a||(a=!0,i.call(r,new ko(t,r,o.originalEvent,{features:n}))):a=!1;},mouseout:function(){a=!1;}}}}if("mouseleave"===t||"mouseout"===t){var n=!1;return {layer:e,listener:i,delegates:{mousemove:function(o){(r.getLayer(e)?r.queryRenderedFeatures(o.point,{layers:[e]}):[]).length?n=!0:n&&(n=!1,i.call(r,new ko(t,r,o.originalEvent)));},mouseout:function(e){n&&(n=!1,i.call(r,new ko(t,r,e.originalEvent)));}}}}return {layer:e,listener:i,delegates:(o={},o[t]=function(t){var o=r.getLayer(e)?r.queryRenderedFeatures(t.point,{layers:[e]}):[];o.length&&(t.features=o,i.call(r,t),delete t.features);},o)}},r.prototype.on=function(t,e,i){if(void 0===i)return o.prototype.on.call(this,t,e);var r=this._createDelegatedListener(t,e,i);for(var a in this._delegatedListeners=this._delegatedListeners||{},this._delegatedListeners[t]=this._delegatedListeners[t]||[],this._delegatedListeners[t].push(r),r.delegates)this.on(a,r.delegates[a]);return this},r.prototype.once=function(t,e,i){if(void 0===i)return o.prototype.once.call(this,t,e);var r=this._createDelegatedListener(t,e,i);for(var a in r.delegates)this.once(a,r.delegates[a]);return this},r.prototype.off=function(t,e,i){var r=this;return void 0===i?o.prototype.off.call(this,t,e):(this._delegatedListeners&&this._delegatedListeners[t]&&function(o){for(var a=o[t],n=0;n<a.length;n++){var s=a[n];if(s.layer===e&&s.listener===i){for(var l in s.delegates)r.off(l,s.delegates[l]);return a.splice(n,1),r}}}(this._delegatedListeners),this)},r.prototype.queryRenderedFeatures=function(e,i){if(!this.style)return [];var o;if(void 0!==i||void 0===e||e instanceof t.Point||Array.isArray(e)||(i=e,e=void 0),i=i||{},(e=e||[[0,0],[this.transform.width,this.transform.height]])instanceof t.Point||"number"==typeof e[0])o=[t.Point.convert(e)];else {var r=t.Point.convert(e[0]),a=t.Point.convert(e[1]);o=[r,new t.Point(a.x,r.y),a,new t.Point(r.x,a.y),r];}return this.style.queryRenderedFeatures(o,i,this.transform)},r.prototype.querySourceFeatures=function(t,e){return this.style.querySourceFeatures(t,e,this.crs)},r.prototype.setStyle=function(e,i){return !1!==(i=t.extend({},{localIdeographFontFamily:this._localIdeographFontFamily},i)).diff&&i.localIdeographFontFamily===this._localIdeographFontFamily&&this.style&&e?(this._diffStyle(e,i),this):(this._localIdeographFontFamily=i.localIdeographFontFamily,this._updateStyle(e,i))},r.prototype._getUIString=function(t){var e=this._locale[t];if(null==e)throw new Error("Missing UI string '"+t+"'");return e},r.prototype._updateStyle=function(t,e){return this.style&&(this.style.setEventedParent(null),this.style._remove()),t?(this.style=new qe(this,e||{}),this.style.setEventedParent(this,{style:this.style}),"string"==typeof t?this.style.loadURL(t):this.style.loadJSON(t),this):(delete this.style,this)},r.prototype._lazyInitEmptyStyle=function(){this.style||(this.style=new qe(this,{}),this.style.setEventedParent(this,{style:this.style}),this.style.loadEmpty());},r.prototype._diffStyle=function(e,i){var o=this;if("string"==typeof e){var r=this._requestManager.normalizeStyleURL(e),a=this._requestManager.transformRequest(r,t.ResourceType.Style);t.getJSON(a,(function(e,r){e?o.fire(new t.ErrorEvent(e)):r&&o._updateDiff(r,i);}));}else "object"==typeof e&&this._updateDiff(e,i);},r.prototype._updateDiff=function(e,i){var o=e.sources;if("string"==typeof e.sprite){var r={};for(var a in o)r[a]=e.sprite;e.sprite=r;}if("string"==typeof e.glyphs){var n={};for(var s in o)n[s]=e.glyphs;e.glyphs=n;}try{this.style.setState(e)&&this._update(!0);}catch(o){t.warnOnce("Unable to perform style diff: "+(o.message||o.error||o)+".  Rebuilding the style from scratch."),this._updateStyle(e,i);}},r.prototype.addStyle=function(e,i,o,r){var a=this;if("string"==typeof e){this.fire(new t.Event("dataloading",{dataType:"style"}));var n=this._requestManager.transformRequest(this._requestManager.normalizeStyleURL(e),t.ResourceType.Style);t.getJSON(n,(function(e,n){e?a.fire(new t.ErrorEvent(e)):n&&a._loadByAdd(n,i,o,r);}));}else this._loadByAdd(JSON.parse(JSON.stringify(e)),i,o,r);},r.prototype._loadByAdd=function(t,e,i,o){var r=this,a=t.layers,n=t.sources,s=t.sprite,l=t.glyphs||{};for(var c in n)this.addSource(c,n[c]),"string"==typeof l?this.style.addGlyphs(c,l):l[c]&&this.style.addGlyphs(c,l[c]);s&&this.style._loadSprite(t),(a||[]).forEach((function(t){"background"!=t.type&&(r.addLayer(t,e),isNaN(i)&&isNaN(o)||r.setLayerZoomRange(t.id,i,o));}));},r.prototype.getStyle=function(){if(this.style)return this.style.serialize()},r.prototype.isStyleLoaded=function(){return this.style?this.style.loaded():t.warnOnce("There is no style added to the map.")},r.prototype.addSource=function(t,e){return this._mapCRS&&"geojson"==e.type&&e.data&&!e.data.customprj&&(e.customprj=this.customConvertPoint),this._lazyInitEmptyStyle(),this.style.addSource(t,e),this._update(!0)},r.prototype.isSourceLoaded=function(e){var i=this.style&&this.style.sourceCaches[e];if(void 0!==i)return i.loaded();this.fire(new t.ErrorEvent(new Error("There is no source with ID '"+e+"'")));},r.prototype.areTilesLoaded=function(){var t=this.style&&this.style.sourceCaches;for(var e in t){var i=t[e]._tiles;for(var o in i){var r=i[o];if("loaded"!==r.state&&"errored"!==r.state)return !1}}return !0},r.prototype.addSourceType=function(t,e,i){return this._lazyInitEmptyStyle(),this.style.addSourceType(t,e,i)},r.prototype.removeSource=function(t){return this.style.removeSource(t),this._update(!0)},r.prototype.getSource=function(t){return this.style.getSource(t)},r.prototype.addImage=function(e,i,o){void 0===o&&(o={});var r=o.pixelRatio;void 0===r&&(r=1);var a=o.sdf;void 0===a&&(a=!1);var n=o.stretchX,s=o.stretchY,l=o.content;if(this._lazyInitEmptyStyle(),i instanceof Pr||zr&&i instanceof zr){var c=t.browser.getImageData(i);this.style.addImage(e,{data:new t.RGBAImage({width:c.width,height:c.height},c.data),pixelRatio:r,stretchX:n,stretchY:s,content:l,sdf:a,version:0});}else {if(void 0===i.width||void 0===i.height)return this.fire(new t.ErrorEvent(new Error("Invalid arguments to map.addImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`")));var h=i;this.style.addImage(e,{data:new t.RGBAImage({width:i.width,height:i.height},new Uint8Array(i.data)),pixelRatio:r,stretchX:n,stretchY:s,content:l,sdf:a,version:0,userImage:h}),h.onAdd&&h.onAdd(this,e);}},r.prototype.updateImage=function(e,i){var o=this.style.getImage(e);if(!o)return this.fire(new t.ErrorEvent(new Error("The map has no image with that id. If you are adding a new image use `map.addImage(...)` instead.")));var r=i instanceof Pr||zr&&i instanceof zr?t.browser.getImageData(i):i,a=r.width,n=r.height,s=r.data;return void 0===a||void 0===n?this.fire(new t.ErrorEvent(new Error("Invalid arguments to map.updateImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`"))):a!==o.data.width||n!==o.data.height?this.fire(new t.ErrorEvent(new Error("The width and height of the updated image must be that same as the previous version of the image"))):(o.data.replace(s,!(i instanceof Pr||zr&&i instanceof zr)),void this.style.updateImage(e,o))},r.prototype.hasImage=function(e){return e?!!this.style.getImage(e):(this.fire(new t.ErrorEvent(new Error("Missing required image id"))),!1)},r.prototype.removeImage=function(t){this.style.removeImage(t);},r.prototype.loadImage=function(e,i){t.getImage(this._requestManager.transformRequest(e,t.ResourceType.Image),i);},r.prototype.listImages=function(){return this.style.listImages()},r.prototype.listMarkers=function(){return this._markersCache},r.prototype.addLayer=function(t,e){return "object"==typeof t.source&&this._mapCRS&&t.source&&"geojson"==t.source.type&&t.source.data&&!t.source.data.customprj&&(t.source.customprj=this.customConvertPoint),this._lazyInitEmptyStyle(),this.style.addLayer(t,e),this._update(!0)},r.prototype.moveLayer=function(t,e){return this.style.moveLayer(t,e),this._update(!0)},r.prototype.removeLayer=function(t){return this.style.removeLayer(t),this._update(!0)},r.prototype.getLayer=function(t){return this.style.getLayer(t)},r.prototype.setLayerZoomRange=function(t,e,i){return this.style.setLayerZoomRange(t,e,i),this._update(!0)},r.prototype.setFilter=function(t,e,i){return void 0===i&&(i={}),this.style.setFilter(t,e,i),this._update(!0)},r.prototype.getFilter=function(t){return this.style.getFilter(t)},r.prototype.setPaintProperty=function(t,e,i,o){return void 0===o&&(o={}),this.style.setPaintProperty(t,e,i,o),this._update(!0)},r.prototype.getPaintProperty=function(t,e){return this.style.getPaintProperty(t,e)},r.prototype.setLayoutProperty=function(t,e,i,o){return void 0===o&&(o={}),this.style.setLayoutProperty(t,e,i,o),this._update(!0)},r.prototype.getLayoutProperty=function(t,e){return this.style.getLayoutProperty(t,e)},r.prototype.setLight=function(t,e){return void 0===e&&(e={}),this._lazyInitEmptyStyle(),this.style.setLight(t,e),this._update(!0)},r.prototype.getLight=function(){return this.style.getLight()},r.prototype.setFeatureState=function(t,e){return this.style.setFeatureState(t,e),this._update()},r.prototype.removeFeatureState=function(t,e){return this.style.removeFeatureState(t,e),this._update()},r.prototype.getFeatureState=function(t){return this.style.getFeatureState(t)},r.prototype.getContainer=function(){return this._container},r.prototype.getCanvasContainer=function(){return this._canvasContainer},r.prototype.getCanvas=function(){return this._canvas},r.prototype._containerDimensions=function(){var t=0,e=0;return this._container&&(t=this._container.clientWidth||400,e=this._container.clientHeight||300),[t,e]},r.prototype._detectMissingCSS=function(){"rgb(250, 128, 114)"!==t.window.getComputedStyle(this._missingCSSCanary).getPropertyValue("background-color")&&t.warnOnce("This page appears to be missing CSS declarations for Mapbox GL JS, which may cause the map to display incorrectly. Please ensure your page includes mapbox-gl.css, as described in https://www.mapbox.com/mapbox-gl-js/api/.");},r.prototype._setupContainer=function(){var t=this._container;t.classList.add("mapboxgl-map"),(this._missingCSSCanary=i.create("div","mapboxgl-canary",t)).style.visibility="hidden",this._detectMissingCSS();var e=this._canvasContainer=i.create("div","mapboxgl-canvas-container",t);this._interactive&&e.classList.add("mapboxgl-interactive"),this._canvas=i.create("canvas","mapboxgl-canvas",e),this._canvas.addEventListener("webglcontextlost",this._contextLost,!1),this._canvas.addEventListener("webglcontextrestored",this._contextRestored,!1),this._canvas.setAttribute("tabindex","0"),this._canvas.setAttribute("aria-label","Map");var o=this._containerDimensions();this._resizeCanvas(o[0],o[1]);var r=this._controlContainer=i.create("div","mapboxgl-control-container",t),a=this._controlPositions={};["top-left","top-right","bottom-left","bottom-right"].forEach((function(t){a[t]=i.create("div","mapboxgl-ctrl-"+t,r);}));},r.prototype._resizeCanvas=function(e,i){var o=t.browser.devicePixelRatio||1;this._canvas.width=o*e,this._canvas.height=o*i,this._canvas.style.width=e+"px",this._canvas.style.height=i+"px";},r.prototype._setupPainter=function(){var i=t.extend({},e.webGLContextAttributes,{failIfMajorPerformanceCaveat:this._failIfMajorPerformanceCaveat,preserveDrawingBuffer:this._preserveDrawingBuffer,antialias:this._antialias||!1}),o=this._canvas.getContext("webgl",i)||this._canvas.getContext("experimental-webgl",i);o?(this.painter=new xo(o,this.transform),t.webpSupported.testSupport(o)):this.fire(new t.ErrorEvent(new Error("Failed to initialize WebGL")));},r.prototype._contextLost=function(e){e.preventDefault(),this._frame&&(this._frame.cancel(),this._frame=null),this.fire(new t.Event("webglcontextlost",{originalEvent:e}));},r.prototype._contextRestored=function(e){this._setupPainter(),this.resize(),this._update(),this.fire(new t.Event("webglcontextrestored",{originalEvent:e}));},r.prototype.loaded=function(){return !this._styleDirty&&!this._sourcesDirty&&!!this.style&&this.style.loaded()},r.prototype._update=function(t){return this.style?(this._styleDirty=this._styleDirty||t,this._sourcesDirty=!0,this.triggerRepaint(),this):this},r.prototype._requestRenderFrame=function(t){return this._update(),this._renderTaskQueue.add(t)},r.prototype._cancelRenderFrame=function(t){this._renderTaskQueue.remove(t);},r.prototype._render=function(e){var i,o=this,r=0,a=this.painter.context.extTimerQuery;if(this.listens("gpu-timing-frame")&&(i=a.createQueryEXT(),a.beginQueryEXT(a.TIME_ELAPSED_EXT,i),r=t.browser.now()),this.painter.context.setDirty(),this.painter.setBaseState(),this._renderTaskQueue.run(e),!this._removed){var n=!1;if(this.style&&this._styleDirty){this._styleDirty=!1;var s=this.transform.zoom,l=t.browser.now();this.style.zoomHistory.update(s,l);var c=new t.EvaluationParameters(s,{now:l,fadeDuration:this._fadeDuration,zoomHistory:this.style.zoomHistory,transition:this.style.getTransition()}),h=c.crossFadingFactor();1===h&&h===this._crossFadingFactor||(n=!0,this._crossFadingFactor=h),this.style.update(c);}if(this.style&&this._sourcesDirty&&(this._sourcesDirty=!1,this.style._updateSources(this.transform)),this._placementDirty=this.style&&this.style._updatePlacement(this.painter.transform,this.showCollisionBoxes,this._fadeDuration,this._crossSourceCollisions),this.painter.render(this.style,{showTileBoundaries:this.showTileBoundaries,showOverdrawInspector:this._showOverdrawInspector,rotating:this.isRotating(),zooming:this.isZooming(),moving:this.isMoving(),fadeDuration:this._fadeDuration,showPadding:this.showPadding,gpuTiming:!!this.listens("gpu-timing-layer")}),this.fire(new t.Event("render")),this.loaded()&&!this._loaded&&(this._loaded=!0,this.fire(new t.Event("load"))),this.style&&(this.style.hasTransitions()||n)&&(this._styleDirty=!0),this.style&&!this._placementDirty&&this.style._releaseSymbolFadeTiles(),this.listens("gpu-timing-frame")){var u=t.browser.now()-r;a.endQueryEXT(a.TIME_ELAPSED_EXT,i),setTimeout((function(){var e=a.getQueryObjectEXT(i,a.QUERY_RESULT_EXT)/1e6;a.deleteQueryEXT(i),o.fire(new t.Event("gpu-timing-frame",{cpuTime:u,gpuTime:e}));}),50);}if(this.listens("gpu-timing-layer")){var p=this.painter.collectGpuTimers();setTimeout((function(){var e=o.painter.queryGpuTimers(p);o.fire(new t.Event("gpu-timing-layer",{layerTimes:e}));}),50);}var d=this._sourcesDirty||this._styleDirty||this._placementDirty;return d||this._repaint?this.triggerRepaint():!this.isMoving()&&this.loaded()&&this.fire(new t.Event("idle")),!this._loaded||this._fullyLoaded||d||(this._fullyLoaded=!0),this}},r.prototype.remove=function(){this._hash&&this._hash.remove();for(var e=0,i=this._controls;e<i.length;e+=1)i[e].onRemove(this);this._controls=[],this._markersCache=[],this._frame&&(this._frame.cancel(),this._frame=null),this._renderTaskQueue.clear(),this.painter.destroy(),this.handlers.destroy(),delete this.handlers,this.setStyle(null),void 0!==t.window&&(t.window.removeEventListener("resize",this._onWindowResize,!1),t.window.removeEventListener("orientationchange",this._onWindowResize,!1),t.window.removeEventListener("online",this._onWindowOnline,!1));var o=this.painter.context.gl.getExtension("WEBGL_lose_context");o&&o.loseContext(),Dr(this._canvasContainer),Dr(this._controlContainer),Dr(this._missingCSSCanary),this._container.classList.remove("mapboxgl-map"),this._removed=!0,this.fire(new t.Event("remove"));},r.prototype.triggerRepaint=function(){var e=this;this.style&&!this._frame&&(this._frame=t.browser.frame((function(t){e._frame=null,e._render(t);})));},r.prototype._onWindowOnline=function(){this._update();},r.prototype._onWindowResize=function(t){this._trackResize&&this.resize({originalEvent:t})._update();},a.showTileBoundaries.get=function(){return !!this._showTileBoundaries},a.showTileBoundaries.set=function(t){this._showTileBoundaries!==t&&(this._showTileBoundaries=t,this._update());},a.showPadding.get=function(){return !!this._showPadding},a.showPadding.set=function(t){this._showPadding!==t&&(this._showPadding=t,this._update());},a.showCollisionBoxes.get=function(){return !!this._showCollisionBoxes},a.showCollisionBoxes.set=function(t){this._showCollisionBoxes!==t&&(this._showCollisionBoxes=t,t?this.style._generateCollisionBoxes():this._update());},a.showOverdrawInspector.get=function(){return !!this._showOverdrawInspector},a.showOverdrawInspector.set=function(t){this._showOverdrawInspector!==t&&(this._showOverdrawInspector=t,this._update());},a.repaint.get=function(){return !!this._repaint},a.repaint.set=function(t){this._repaint!==t&&(this._repaint=t,this.triggerRepaint());},a.vertices.get=function(){return !!this._vertices},a.vertices.set=function(t){this._vertices=t,this._update();},r.prototype._setCacheLimits=function(e,i){t.setCacheLimits(e,i);},r.prototype.setCRS=function(t){this.crs=this.toCRS(t),this.initCRS(this.crs);var e=this.style&&this.style.sourceCaches;if(e)for(var i in e){var o=e[i]._source;this._mapCRS&&"geojson"==o.type&&this.style.getSource(i).setCustomprj(this.customConvertPoint),o.setCRS&&o.setCRS();}this._sourcesDirty=!0,this._canvas&&this.resize(),this._update(!0);},r.prototype.initCRS=function(e){this._mapCRS=e;var i=e.getLngLatExtent();Math.abs(i[0]+180)>1e-6&&Math.abs(i[2]-180)>1e-6&&(this.renderWorldCopies=!1,this.transform.renderWorldCopies=this.renderWorldCopies),this.transform.setCRS(e),this._tileExtent=e.getExtent();var o=this._tileExtent[2]-this._tileExtent[0],r=this._tileExtent[3]-this._tileExtent[1],a=(this._tileExtent[2]+this._tileExtent[0])/2,n=(this._tileExtent[3]+this._tileExtent[1])/2,s=this._tileExtent[0],l=this._tileExtent[3];t.Feature.yLat=function(t,e){return l-t*r/e},t.Feature.toLngLat=function(t,i){var o=e.toLngLat(t,i);return [o.lng,o.lat]},this.mercatorZfromAltitude=t.mercatorZfromAltitude,this.updateTransformByCRS(e.getUnit(),s,l,a,n,o,r);},r.prototype.updateTransformByCRS=function(e,i,o,r,a,n,s){this.transform.units=e;var l=function(t,e,i){var o="";for(var r in t)Object.hasOwnProperty.call(t,r)&&(o+=r+":"+t[r]+",");for(var a in i)if(Object.hasOwnProperty.call(i,a)){var n="("+i[a]+")";o=o.replace(new RegExp('"'+a+'"',"g"),n);}return "customConvertPoint={"+o+"}"}({toLngLat:function(t,e,i){return i.inverse(["__width"*t+"__originX","__originY"-"__height"*e])},projectXY:function(t,e,i){var o=i.forward([t,e]);return [(o[0]-"__originX")/"__width",("__originY"-o[1])/"__height"]},projectX:function(t){return (t-"__centerX")/"__width"+.5},projectY:function(t){return (t=.5-(t-"__centerY")/"__height")<0?0:t>1?1:t},toY:function(t){return "__height"*(.5-t)+"__centerY"}},0,{__width:n,__height:s,__centerX:r,__centerY:a,__originY:o,__originX:i});this.customConvertPoint=t.window.URL.createObjectURL(new Blob([l],{type:"text/javascript"}));},a.version.get=function(){return t.version},Object.defineProperties(r.prototype,a),r}(yr);function Dr(t){t.parentNode&&t.parentNode.removeChild(t);}var Rr={showCompass:!0,showZoom:!0,visualizePitch:!1},Ar=function(e){var o=this;this.options=t.extend({},Rr,e),this._container=i.create("div","mapboxgl-ctrl mapboxgl-ctrl-group"),this._container.addEventListener("contextmenu",(function(t){return t.preventDefault()})),this.options.showZoom&&(t.bindAll(["_setButtonTitle","_updateZoomButtons"],this),this._zoomInButton=this._createButton("mapboxgl-ctrl-zoom-in",(function(t){return o._map.zoomIn({},{originalEvent:t})})),i.create("span","mapboxgl-ctrl-icon",this._zoomInButton).setAttribute("aria-hidden",!0),this._zoomOutButton=this._createButton("mapboxgl-ctrl-zoom-out",(function(t){return o._map.zoomOut({},{originalEvent:t})})),i.create("span","mapboxgl-ctrl-icon",this._zoomOutButton).setAttribute("aria-hidden",!0)),this.options.showCompass&&(t.bindAll(["_rotateCompassArrow"],this),this._compass=this._createButton("mapboxgl-ctrl-compass",(function(t){o.options.visualizePitch?o._map.resetNorthPitch({},{originalEvent:t}):o._map.resetNorth({},{originalEvent:t});})),this._compassIcon=i.create("span","mapboxgl-ctrl-icon",this._compass),this._compassIcon.setAttribute("aria-hidden",!0));};Ar.prototype._updateZoomButtons=function(){var t=this._map.getZoom();this._zoomInButton.disabled=t===this._map.getMaxZoom(),this._zoomOutButton.disabled=t===this._map.getMinZoom();},Ar.prototype._rotateCompassArrow=function(){var t=this.options.visualizePitch?"rotateX("+this._map.transform.pitch+"deg) rotateZ("+this._map.transform.angle*(180/Math.PI)+"deg)":"rotate("+this._map.transform.angle+"deg)";this._compassIcon.style.transform=t;},Ar.prototype.onAdd=function(t){return this._map=t,this.options.showZoom&&(this._setButtonTitle(this._zoomInButton,"ZoomIn"),this._setButtonTitle(this._zoomOutButton,"ZoomOut"),this._map.on("zoom",this._updateZoomButtons),this._updateZoomButtons()),this.options.showCompass&&(this._setButtonTitle(this._compass,"ResetBearing"),this.options.visualizePitch&&this._map.on("pitch",this._rotateCompassArrow),this._map.on("rotate",this._rotateCompassArrow),this._rotateCompassArrow(),this._handler=new kr(this._map,this._compass,this.options.visualizePitch)),this._container},Ar.prototype.onRemove=function(){i.remove(this._container),this.options.showZoom&&this._map.off("zoom",this._updateZoomButtons),this.options.showCompass&&(this.options.visualizePitch&&this._map.off("pitch",this._rotateCompassArrow),this._map.off("rotate",this._rotateCompassArrow),this._handler.off(),delete this._handler),delete this._map;},Ar.prototype._createButton=function(t,e){var o=i.create("button",t,this._container);return o.type="button",o.addEventListener("click",e),o},Ar.prototype._setButtonTitle=function(t,e){var i=this._map._getUIString("NavigationControl."+e);t.title=i,t.setAttribute("aria-label",i);};var kr=function(e,o,r){void 0===r&&(r=!1),this._clickTolerance=10,this.element=o,this.mouseRotate=new Ho({clickTolerance:e.dragRotate._mouseRotate._clickTolerance}),this.map=e,r&&(this.mousePitch=new Ko({clickTolerance:e.dragRotate._mousePitch._clickTolerance})),t.bindAll(["mousedown","mousemove","mouseup","touchstart","touchmove","touchend","reset"],this),i.addEventListener(o,"mousedown",this.mousedown),i.addEventListener(o,"touchstart",this.touchstart,{passive:!1}),i.addEventListener(o,"touchmove",this.touchmove),i.addEventListener(o,"touchend",this.touchend),i.addEventListener(o,"touchcancel",this.reset);};function Or(e,i,o){if(e=new t.LngLat(e.lng,e.lat),i){var r=new t.LngLat(e.lng-360,e.lat),a=new t.LngLat(e.lng+360,e.lat),n=o.locationPoint(e).distSqr(i);o.locationPoint(r).distSqr(i)<n?e=r:o.locationPoint(a).distSqr(i)<n&&(e=a);}for(;Math.abs(e.lng-o.center.lng)>180;){var s=o.locationPoint(e);if(s.x>=0&&s.y>=0&&s.x<=o.width&&s.y<=o.height)break;e.lng>o.center.lng?e.lng-=360:e.lng+=360;}return e}kr.prototype.down=function(t,e){this.mouseRotate.mousedown(t,e),this.mousePitch&&this.mousePitch.mousedown(t,e),i.disableDrag();},kr.prototype.move=function(t,e){var i=this.map,o=this.mouseRotate.mousemoveWindow(t,e);if(o&&o.bearingDelta&&i.setBearing(i.getBearing()+o.bearingDelta),this.mousePitch){var r=this.mousePitch.mousemoveWindow(t,e);r&&r.pitchDelta&&i.setPitch(i.getPitch()+r.pitchDelta);}},kr.prototype.off=function(){var t=this.element;i.removeEventListener(t,"mousedown",this.mousedown),i.removeEventListener(t,"touchstart",this.touchstart,{passive:!1}),i.removeEventListener(t,"touchmove",this.touchmove),i.removeEventListener(t,"touchend",this.touchend),i.removeEventListener(t,"touchcancel",this.reset),this.offTemp();},kr.prototype.offTemp=function(){i.enableDrag(),i.removeEventListener(t.window,"mousemove",this.mousemove),i.removeEventListener(t.window,"mouseup",this.mouseup);},kr.prototype.mousedown=function(e){this.down(t.extend({},e,{ctrlKey:!0,preventDefault:function(){return e.preventDefault()}}),i.mousePos(this.element,e)),i.addEventListener(t.window,"mousemove",this.mousemove),i.addEventListener(t.window,"mouseup",this.mouseup);},kr.prototype.mousemove=function(t){this.move(t,i.mousePos(this.element,t));},kr.prototype.mouseup=function(t){this.mouseRotate.mouseupWindow(t),this.mousePitch&&this.mousePitch.mouseupWindow(t),this.offTemp();},kr.prototype.touchstart=function(t){1!==t.targetTouches.length?this.reset():(this._startPos=this._lastPos=i.touchPos(this.element,t.targetTouches)[0],this.down({type:"mousedown",button:0,ctrlKey:!0,preventDefault:function(){return t.preventDefault()}},this._startPos));},kr.prototype.touchmove=function(t){1!==t.targetTouches.length?this.reset():(this._lastPos=i.touchPos(this.element,t.targetTouches)[0],this.move({preventDefault:function(){return t.preventDefault()}},this._lastPos));},kr.prototype.touchend=function(t){0===t.targetTouches.length&&this._startPos&&this._lastPos&&this._startPos.dist(this._lastPos)<this._clickTolerance&&this.element.click(),this.reset();},kr.prototype.reset=function(){this.mouseRotate.reset(),this.mousePitch&&this.mousePitch.reset(),delete this._startPos,delete this._lastPos,this.offTemp();};var Br={center:"translate(-50%,-50%)",top:"translate(-50%,0)","top-left":"translate(0,0)","top-right":"translate(-100%,0)",bottom:"translate(-50%,-100%)","bottom-left":"translate(0,-100%)","bottom-right":"translate(-100%,-100%)",left:"translate(0,-50%)",right:"translate(-100%,-50%)"};function Fr(t,e,i){var o=t.classList;for(var r in Br)o.remove("mapboxgl-"+i+"-anchor-"+r);o.add("mapboxgl-"+i+"-anchor-"+e);}var Ur,Nr=function(e){function o(o,r){var a=this;if(e.call(this),(o instanceof t.window.HTMLElement||r)&&(o=t.extend({element:o},r)),t.bindAll(["_update","_onMove","_onUp","_addDragHandler","_onMapClick","_onKeyPress"],this),this._anchor=o&&o.anchor||"center",this._color=o&&o.color||"#3FB1CE",this._scale=o&&o.scale||1,this._draggable=o&&o.draggable||!1,this._state="inactive",this._rotation=o&&o.rotation||0,this._rotationAlignment=o&&o.rotationAlignment||"auto",this._pitchAlignment=o&&o.pitchAlignment&&"auto"!==o.pitchAlignment?o.pitchAlignment:this._rotationAlignment,o&&o.element)this._element=o.element,this._offset=t.Point.convert(o&&o.offset||[0,0]);else {this._defaultMarker=!0,this._element=i.create("div"),this._element.setAttribute("aria-label","Map marker");var n=i.createNS("http://www.w3.org/2000/svg","svg");n.setAttributeNS(null,"display","block"),n.setAttributeNS(null,"height","41px"),n.setAttributeNS(null,"width","27px"),n.setAttributeNS(null,"viewBox","0 0 27 41");var s=i.createNS("http://www.w3.org/2000/svg","g");s.setAttributeNS(null,"stroke","none"),s.setAttributeNS(null,"stroke-width","1"),s.setAttributeNS(null,"fill","none"),s.setAttributeNS(null,"fill-rule","evenodd");var l=i.createNS("http://www.w3.org/2000/svg","g");l.setAttributeNS(null,"fill-rule","nonzero");var c=i.createNS("http://www.w3.org/2000/svg","g");c.setAttributeNS(null,"transform","translate(3.0, 29.0)"),c.setAttributeNS(null,"fill","#000000");for(var h=0,u=[{rx:"10.5",ry:"5.25002273"},{rx:"10.5",ry:"5.25002273"},{rx:"9.5",ry:"4.77275007"},{rx:"8.5",ry:"4.29549936"},{rx:"7.5",ry:"3.81822308"},{rx:"6.5",ry:"3.34094679"},{rx:"5.5",ry:"2.86367051"},{rx:"4.5",ry:"2.38636864"}];h<u.length;h+=1){var p=u[h],d=i.createNS("http://www.w3.org/2000/svg","ellipse");d.setAttributeNS(null,"opacity","0.04"),d.setAttributeNS(null,"cx","10.5"),d.setAttributeNS(null,"cy","5.80029008"),d.setAttributeNS(null,"rx",p.rx),d.setAttributeNS(null,"ry",p.ry),c.appendChild(d);}var _=i.createNS("http://www.w3.org/2000/svg","g");_.setAttributeNS(null,"fill",this._color);var f=i.createNS("http://www.w3.org/2000/svg","path");f.setAttributeNS(null,"d","M27,13.5 C27,19.074644 20.250001,27.000002 14.75,34.500002 C14.016665,35.500004 12.983335,35.500004 12.25,34.500002 C6.7499993,27.000002 0,19.222562 0,13.5 C0,6.0441559 6.0441559,0 13.5,0 C20.955844,0 27,6.0441559 27,13.5 Z"),_.appendChild(f);var m=i.createNS("http://www.w3.org/2000/svg","g");m.setAttributeNS(null,"opacity","0.25"),m.setAttributeNS(null,"fill","#000000");var g=i.createNS("http://www.w3.org/2000/svg","path");g.setAttributeNS(null,"d","M13.5,0 C6.0441559,0 0,6.0441559 0,13.5 C0,19.222562 6.7499993,27 12.25,34.5 C13,35.522727 14.016664,35.500004 14.75,34.5 C20.250001,27 27,19.074644 27,13.5 C27,6.0441559 20.955844,0 13.5,0 Z M13.5,1 C20.415404,1 26,6.584596 26,13.5 C26,15.898657 24.495584,19.181431 22.220703,22.738281 C19.945823,26.295132 16.705119,30.142167 13.943359,33.908203 C13.743445,34.180814 13.612715,34.322738 13.5,34.441406 C13.387285,34.322738 13.256555,34.180814 13.056641,33.908203 C10.284481,30.127985 7.4148684,26.314159 5.015625,22.773438 C2.6163816,19.232715 1,15.953538 1,13.5 C1,6.584596 6.584596,1 13.5,1 Z"),m.appendChild(g);var v=i.createNS("http://www.w3.org/2000/svg","g");v.setAttributeNS(null,"transform","translate(6.0, 7.0)"),v.setAttributeNS(null,"fill","#FFFFFF");var y=i.createNS("http://www.w3.org/2000/svg","g");y.setAttributeNS(null,"transform","translate(8.0, 8.0)");var x=i.createNS("http://www.w3.org/2000/svg","circle");x.setAttributeNS(null,"fill","#000000"),x.setAttributeNS(null,"opacity","0.25"),x.setAttributeNS(null,"cx","5.5"),x.setAttributeNS(null,"cy","5.5"),x.setAttributeNS(null,"r","5.4999962");var b=i.createNS("http://www.w3.org/2000/svg","circle");b.setAttributeNS(null,"fill","#FFFFFF"),b.setAttributeNS(null,"cx","5.5"),b.setAttributeNS(null,"cy","5.5"),b.setAttributeNS(null,"r","5.4999962"),y.appendChild(x),y.appendChild(b),l.appendChild(c),l.appendChild(_),l.appendChild(m),l.appendChild(v),l.appendChild(y),n.appendChild(l),n.setAttributeNS(null,"height",41*this._scale+"px"),n.setAttributeNS(null,"width",27*this._scale+"px"),this._element.appendChild(n),this._offset=t.Point.convert(o&&o.offset||[0,-14]);}this._element.classList.add("mapboxgl-marker"),this._element.addEventListener("dragstart",(function(t){t.preventDefault();})),this._element.addEventListener("mousedown",(function(t){t.preventDefault();})),this._element.addEventListener("focus",(function(){var t=a._map.getContainer();t.scrollTop=0,t.scrollLeft=0;})),Fr(this._element,this._anchor,"marker"),this._popup=null;}return e&&(o.__proto__=e),(o.prototype=Object.create(e&&e.prototype)).constructor=o,o.prototype.addTo=function(t){return this.remove(),this._map=t,t.getCanvasContainer().appendChild(this._element),t.on("move",this._update),t.on("moveend",this._update),this.setDraggable(this._draggable),this._update(),this._map.on("click",this._onMapClick),this._map._markersCache&&this._map._markersCache.push(this),this},o.prototype.remove=function(){if(this._map){this._map.off("click",this._onMapClick),this._map.off("move",this._update),this._map.off("moveend",this._update),this._map.off("mousedown",this._addDragHandler),this._map.off("touchstart",this._addDragHandler),this._map.off("mouseup",this._onUp),this._map.off("touchend",this._onUp),this._map.off("mousemove",this._onMove),this._map.off("touchmove",this._onMove);var t=this._map._markersCache.indexOf(this);t>-1&&this._map._markersCache.splice(t,1),delete this._map;}return i.remove(this._element),this._popup&&this._popup.remove(),this},o.prototype.getLngLat=function(){return this._lngLat},o.prototype.setLngLat=function(e){return this._lngLat=t.LngLat.convert(e),this._pos=null,this._popup&&this._popup.setLngLat(this._lngLat),this._update(),this},o.prototype.getElement=function(){return this._element},o.prototype.setPopup=function(t){if(this._popup&&(this._popup.remove(),this._popup=null,this._element.removeEventListener("keypress",this._onKeyPress),this._originalTabIndex||this._element.removeAttribute("tabindex")),t){if(!("offset"in t.options)){var e=Math.sqrt(Math.pow(13.5,2)/2);t.options.offset=this._defaultMarker?{top:[0,0],"top-left":[0,0],"top-right":[0,0],bottom:[0,-38.1],"bottom-left":[e,-1*(24.6+e)],"bottom-right":[-e,-1*(24.6+e)],left:[13.5,-24.6],right:[-13.5,-24.6]}:this._offset;}this._popup=t,this._lngLat&&this._popup.setLngLat(this._lngLat),this._originalTabIndex=this._element.getAttribute("tabindex"),this._originalTabIndex||this._element.setAttribute("tabindex","0"),this._element.addEventListener("keypress",this._onKeyPress);}return this},o.prototype._onKeyPress=function(t){var e=t.code,i=t.charCode||t.keyCode;"Space"!==e&&"Enter"!==e&&32!==i&&13!==i||this.togglePopup();},o.prototype._onMapClick=function(t){var e=t.originalEvent.target,i=this._element;this._popup&&(e===i||i.contains(e))&&this.togglePopup();},o.prototype.getPopup=function(){return this._popup},o.prototype.togglePopup=function(){var t=this._popup;return t?(t.isOpen()?t.remove():t.addTo(this._map),this):this},o.prototype._update=function(t){if(this._map){this._map.transform.renderWorldCopies&&(this._lngLat=Or(this._lngLat,this._pos,this._map.transform)),this._pos=this._map.project(this._lngLat)._add(this._offset);var e="";"viewport"===this._rotationAlignment||"auto"===this._rotationAlignment?e="rotateZ("+this._rotation+"deg)":"map"===this._rotationAlignment&&(e="rotateZ("+(this._rotation-this._map.getBearing())+"deg)");var o="";"viewport"===this._pitchAlignment||"auto"===this._pitchAlignment?o="rotateX(0deg)":"map"===this._pitchAlignment&&(o="rotateX("+this._map.getPitch()+"deg)"),t&&"moveend"!==t.type||(this._pos=this._pos.round()),i.setTransform(this._element,Br[this._anchor]+" translate("+this._pos.x+"px, "+this._pos.y+"px) "+o+" "+e);}},o.prototype.getOffset=function(){return this._offset},o.prototype.setOffset=function(e){return this._offset=t.Point.convert(e),this._update(),this},o.prototype._onMove=function(e){this._pos=e.point.sub(this._positionDelta),this._lngLat=this._map.unproject(this._pos),this.setLngLat(this._lngLat),this._element.style.pointerEvents="none","pending"===this._state&&(this._state="active",this.fire(new t.Event("dragstart"))),this.fire(new t.Event("drag"));},o.prototype._onUp=function(){this._element.style.pointerEvents="auto",this._positionDelta=null,this._map.off("mousemove",this._onMove),this._map.off("touchmove",this._onMove),"active"===this._state&&this.fire(new t.Event("dragend")),this._state="inactive";},o.prototype._addDragHandler=function(t){this._element.contains(t.originalEvent.target)&&(t.preventDefault(),this._positionDelta=t.point.sub(this._pos).add(this._offset),this._state="pending",this._map.on("mousemove",this._onMove),this._map.on("touchmove",this._onMove),this._map.once("mouseup",this._onUp),this._map.once("touchend",this._onUp));},o.prototype.setDraggable=function(t){return this._draggable=!!t,this._map&&(t?(this._map.on("mousedown",this._addDragHandler),this._map.on("touchstart",this._addDragHandler)):(this._map.off("mousedown",this._addDragHandler),this._map.off("touchstart",this._addDragHandler))),this},o.prototype.isDraggable=function(){return this._draggable},o.prototype.setRotation=function(t){return this._rotation=t||0,this._update(),this},o.prototype.getRotation=function(){return this._rotation},o.prototype.setRotationAlignment=function(t){return this._rotationAlignment=t||"auto",this._update(),this},o.prototype.getRotationAlignment=function(){return this._rotationAlignment},o.prototype.setPitchAlignment=function(t){return this._pitchAlignment=t&&"auto"!==t?t:this._rotationAlignment,this._update(),this},o.prototype.getPitchAlignment=function(){return this._pitchAlignment},o}(t.Evented),jr={positionOptions:{enableHighAccuracy:!1,maximumAge:0,timeout:6e3},fitBoundsOptions:{maxZoom:15},trackUserLocation:!1,showAccuracyCircle:!0,showUserLocation:!0},Gr=0,Zr=!1,qr=function(e){function o(i){e.call(this),this.options=t.extend({},jr,i),t.bindAll(["_onSuccess","_onError","_onZoom","_finish","_setupUI","_updateCamera","_updateMarker"],this);}return e&&(o.__proto__=e),(o.prototype=Object.create(e&&e.prototype)).constructor=o,o.prototype.onAdd=function(e){var o;return this._map=e,this._container=i.create("div","mapboxgl-ctrl mapboxgl-ctrl-group"),o=this._setupUI,void 0!==Ur?o(Ur):void 0!==t.window.navigator.permissions?t.window.navigator.permissions.query({name:"geolocation"}).then((function(t){o(Ur="denied"!==t.state);})):o(Ur=!!t.window.navigator.geolocation),this._container},o.prototype.onRemove=function(){void 0!==this._geolocationWatchID&&(t.window.navigator.geolocation.clearWatch(this._geolocationWatchID),this._geolocationWatchID=void 0),this.options.showUserLocation&&this._userLocationDotMarker&&this._userLocationDotMarker.remove(),this.options.showAccuracyCircle&&this._accuracyCircleMarker&&this._accuracyCircleMarker.remove(),i.remove(this._container),this._map.off("zoom",this._onZoom),this._map=void 0,Gr=0,Zr=!1;},o.prototype._isOutOfMapMaxBounds=function(t){var e=this._map.getMaxBounds(),i=t.coords;return e&&(i.longitude<e.getWest()||i.longitude>e.getEast()||i.latitude<e.getSouth()||i.latitude>e.getNorth())},o.prototype._setErrorState=function(){switch(this._watchState){case"WAITING_ACTIVE":this._watchState="ACTIVE_ERROR",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error");break;case"ACTIVE_LOCK":this._watchState="ACTIVE_ERROR",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting");break;case"BACKGROUND":this._watchState="BACKGROUND_ERROR",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background-error"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting");}},o.prototype._onSuccess=function(e){if(this._map){if(this._isOutOfMapMaxBounds(e))return this._setErrorState(),this.fire(new t.Event("outofmaxbounds",e)),this._updateMarker(),void this._finish();if(this.options.trackUserLocation)switch(this._lastKnownPosition=e,this._watchState){case"WAITING_ACTIVE":case"ACTIVE_LOCK":case"ACTIVE_ERROR":this._watchState="ACTIVE_LOCK",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");break;case"BACKGROUND":case"BACKGROUND_ERROR":this._watchState="BACKGROUND",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background");}this.options.showUserLocation&&"OFF"!==this._watchState&&this._updateMarker(e),this.options.trackUserLocation&&"ACTIVE_LOCK"!==this._watchState||this._updateCamera(e),this.options.showUserLocation&&this._dotElement.classList.remove("mapboxgl-user-location-dot-stale"),this.fire(new t.Event("geolocate",e)),this._finish();}},o.prototype._updateCamera=function(e){var i=new t.LngLat(e.coords.longitude,e.coords.latitude),o=e.coords.accuracy,r=this._map.getBearing(),a=t.extend({bearing:r},this.options.fitBoundsOptions);this._map.fitBounds(i.toBounds(o),a,{geolocateSource:!0});},o.prototype._updateMarker=function(e){if(e){var i=new t.LngLat(e.coords.longitude,e.coords.latitude);this._accuracyCircleMarker.setLngLat(i).addTo(this._map),this._userLocationDotMarker.setLngLat(i).addTo(this._map),this._accuracy=e.coords.accuracy,this.options.showUserLocation&&this.options.showAccuracyCircle&&this._updateCircleRadius();}else this._userLocationDotMarker.remove(),this._accuracyCircleMarker.remove();},o.prototype._updateCircleRadius=function(){var t=this._map._container.clientHeight/2,e=this._map.unproject([0,t]),i=this._map.unproject([1,t]),o=e.distanceTo(i),r=Math.ceil(2*this._accuracy/o);this._circleElement.style.width=r+"px",this._circleElement.style.height=r+"px";},o.prototype._onZoom=function(){this.options.showUserLocation&&this.options.showAccuracyCircle&&this._updateCircleRadius();},o.prototype._onError=function(e){if(this._map){if(this.options.trackUserLocation)if(1===e.code){this._watchState="OFF",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"),this._geolocateButton.disabled=!0;var i=this._map._getUIString("GeolocateControl.LocationNotAvailable");this._geolocateButton.title=i,this._geolocateButton.setAttribute("aria-label",i),void 0!==this._geolocationWatchID&&this._clearWatch();}else {if(3===e.code&&Zr)return;this._setErrorState();}"OFF"!==this._watchState&&this.options.showUserLocation&&this._dotElement.classList.add("mapboxgl-user-location-dot-stale"),this.fire(new t.Event("error",e)),this._finish();}},o.prototype._finish=function(){this._timeoutId&&clearTimeout(this._timeoutId),this._timeoutId=void 0;},o.prototype._setupUI=function(e){var o=this;if(this._container.addEventListener("contextmenu",(function(t){return t.preventDefault()})),this._geolocateButton=i.create("button","mapboxgl-ctrl-geolocate",this._container),i.create("span","mapboxgl-ctrl-icon",this._geolocateButton).setAttribute("aria-hidden",!0),this._geolocateButton.type="button",!1===e){t.warnOnce("Geolocation support is not available so the GeolocateControl will be disabled.");var r=this._map._getUIString("GeolocateControl.LocationNotAvailable");this._geolocateButton.disabled=!0,this._geolocateButton.title=r,this._geolocateButton.setAttribute("aria-label",r);}else {var a=this._map._getUIString("GeolocateControl.FindMyLocation");this._geolocateButton.title=a,this._geolocateButton.setAttribute("aria-label",a);}this.options.trackUserLocation&&(this._geolocateButton.setAttribute("aria-pressed","false"),this._watchState="OFF"),this.options.showUserLocation&&(this._dotElement=i.create("div","mapboxgl-user-location-dot"),this._userLocationDotMarker=new Nr(this._dotElement),this._circleElement=i.create("div","mapboxgl-user-location-accuracy-circle"),this._accuracyCircleMarker=new Nr({element:this._circleElement,pitchAlignment:"map"}),this.options.trackUserLocation&&(this._watchState="OFF"),this._map.on("zoom",this._onZoom)),this._geolocateButton.addEventListener("click",this.trigger.bind(this)),this._setup=!0,this.options.trackUserLocation&&this._map.on("movestart",(function(e){e.geolocateSource||"ACTIVE_LOCK"!==o._watchState||e.originalEvent&&"resize"===e.originalEvent.type||(o._watchState="BACKGROUND",o._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background"),o._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"),o.fire(new t.Event("trackuserlocationend")));}));},o.prototype.trigger=function(){if(!this._setup)return t.warnOnce("Geolocate control triggered before added to a map"),!1;if(this.options.trackUserLocation){switch(this._watchState){case"OFF":this._watchState="WAITING_ACTIVE",this.fire(new t.Event("trackuserlocationstart"));break;case"WAITING_ACTIVE":case"ACTIVE_LOCK":case"ACTIVE_ERROR":case"BACKGROUND_ERROR":Gr--,Zr=!1,this._watchState="OFF",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"),this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"),this.fire(new t.Event("trackuserlocationend"));break;case"BACKGROUND":this._watchState="ACTIVE_LOCK",this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"),this._lastKnownPosition&&this._updateCamera(this._lastKnownPosition),this.fire(new t.Event("trackuserlocationstart"));}switch(this._watchState){case"WAITING_ACTIVE":this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");break;case"ACTIVE_LOCK":this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");break;case"ACTIVE_ERROR":this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error");break;case"BACKGROUND":this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background");break;case"BACKGROUND_ERROR":this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background-error");}if("OFF"===this._watchState&&void 0!==this._geolocationWatchID)this._clearWatch();else if(void 0===this._geolocationWatchID){var e;this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.setAttribute("aria-pressed","true"),++Gr>1?(e={maximumAge:6e5,timeout:0},Zr=!0):(e=this.options.positionOptions,Zr=!1),this._geolocationWatchID=t.window.navigator.geolocation.watchPosition(this._onSuccess,this._onError,e);}}else t.window.navigator.geolocation.getCurrentPosition(this._onSuccess,this._onError,this.options.positionOptions),this._timeoutId=setTimeout(this._finish,1e4);return !0},o.prototype._clearWatch=function(){t.window.navigator.geolocation.clearWatch(this._geolocationWatchID),this._geolocationWatchID=void 0,this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"),this._geolocateButton.setAttribute("aria-pressed","false"),this.options.showUserLocation&&this._updateMarker(null);},o}(t.Evented),Vr={maxWidth:100,unit:"metric"},Wr=function(e){this.options=t.extend({},Vr,e),t.bindAll(["_onMove","setUnit"],this);};function Xr(t,e,i){var o=i&&i.maxWidth||100,r=(t.project(t.crs.getLngLatCenter()),t._container.clientHeight/2),a=t._container.clientWidth/2,n=t.unproject([a,r]),s=t.unproject([a+o,r]);s.lng===n.lng&&(s=t.unproject([a-o,r]));var l=n.distanceTo(s);if(i&&"imperial"===i.unit){var c=3.2808*l;c>5280?Hr(e,o,c/5280,t._getUIString("ScaleControl.Miles")):Hr(e,o,c,t._getUIString("ScaleControl.Feet"));}else i&&"nautical"===i.unit?Hr(e,o,l/1852,t._getUIString("ScaleControl.NauticalMiles")):l>=1e3?Hr(e,o,l/1e3,t._getUIString("ScaleControl.Kilometers")):Hr(e,o,l,t._getUIString("ScaleControl.Meters"));}function Hr(t,e,i,o){var r,a,n,s=(r=i,(a=Math.pow(10,(""+Math.floor(r)).length-1))*(n=(n=r/a)>=10?10:n>=5?5:n>=3?3:n>=2?2:n>=1?1:function(t){var e=Math.pow(10,Math.ceil(-Math.log(t)/Math.LN10));return Math.round(t*e)/e}(n)));t.style.width=e*(s/i)+"px",t.innerHTML=s+"&nbsp;"+o;}Wr.prototype.getDefaultPosition=function(){return "bottom-left"},Wr.prototype._onMove=function(){Xr(this._map,this._container,this.options);},Wr.prototype.onAdd=function(t){return this._map=t,this._container=i.create("div","mapboxgl-ctrl mapboxgl-ctrl-scale",t.getContainer()),this._map.on("move",this._onMove),this._onMove(),this._container},Wr.prototype.onRemove=function(){i.remove(this._container),this._map.off("move",this._onMove),this._map=void 0;},Wr.prototype.setUnit=function(t){this.options.unit=t,Xr(this._map,this._container,this.options);};var Kr=function(e){this._fullscreen=!1,e&&e.container&&(e.container instanceof t.window.HTMLElement?this._container=e.container:t.warnOnce("Full screen control 'container' must be a DOM element.")),t.bindAll(["_onClickFullscreen","_changeIcon"],this),"onfullscreenchange"in t.window.document?this._fullscreenchange="fullscreenchange":"onmozfullscreenchange"in t.window.document?this._fullscreenchange="mozfullscreenchange":"onwebkitfullscreenchange"in t.window.document?this._fullscreenchange="webkitfullscreenchange":"onmsfullscreenchange"in t.window.document&&(this._fullscreenchange="MSFullscreenChange");};Kr.prototype.onAdd=function(e){return this._map=e,this._container||(this._container=this._map.getContainer()),this._controlContainer=i.create("div","mapboxgl-ctrl mapboxgl-ctrl-group"),this._checkFullscreenSupport()?this._setupUI():(this._controlContainer.style.display="none",t.warnOnce("This device does not support fullscreen mode.")),this._controlContainer},Kr.prototype.onRemove=function(){i.remove(this._controlContainer),this._map=null,t.window.document.removeEventListener(this._fullscreenchange,this._changeIcon);},Kr.prototype._checkFullscreenSupport=function(){return !!(t.window.document.fullscreenEnabled||t.window.document.mozFullScreenEnabled||t.window.document.msFullscreenEnabled||t.window.document.webkitFullscreenEnabled)},Kr.prototype._setupUI=function(){var e=this._fullscreenButton=i.create("button","mapboxgl-ctrl-fullscreen",this._controlContainer);i.create("span","mapboxgl-ctrl-icon",e).setAttribute("aria-hidden",!0),e.type="button",this._updateTitle(),this._fullscreenButton.addEventListener("click",this._onClickFullscreen),t.window.document.addEventListener(this._fullscreenchange,this._changeIcon);},Kr.prototype._updateTitle=function(){var t=this._getTitle();this._fullscreenButton.setAttribute("aria-label",t),this._fullscreenButton.title=t;},Kr.prototype._getTitle=function(){return this._map._getUIString(this._isFullscreen()?"FullscreenControl.Exit":"FullscreenControl.Enter")},Kr.prototype._isFullscreen=function(){return this._fullscreen},Kr.prototype._changeIcon=function(){(t.window.document.fullscreenElement||t.window.document.mozFullScreenElement||t.window.document.webkitFullscreenElement||t.window.document.msFullscreenElement)===this._container!==this._fullscreen&&(this._fullscreen=!this._fullscreen,this._fullscreenButton.classList.toggle("mapboxgl-ctrl-shrink"),this._fullscreenButton.classList.toggle("mapboxgl-ctrl-fullscreen"),this._updateTitle());},Kr.prototype._onClickFullscreen=function(){this._isFullscreen()?t.window.document.exitFullscreen?t.window.document.exitFullscreen():t.window.document.mozCancelFullScreen?t.window.document.mozCancelFullScreen():t.window.document.msExitFullscreen?t.window.document.msExitFullscreen():t.window.document.webkitCancelFullScreen&&t.window.document.webkitCancelFullScreen():this._container.requestFullscreen?this._container.requestFullscreen():this._container.mozRequestFullScreen?this._container.mozRequestFullScreen():this._container.msRequestFullscreen?this._container.msRequestFullscreen():this._container.webkitRequestFullscreen&&this._container.webkitRequestFullscreen();};var Yr={closeButton:!0,closeOnClick:!0,className:"",maxWidth:"240px",showArrow:!0,contentClass:null},Jr=function(e){function o(i){e.call(this),this.options=t.extend(Object.create(Yr),i),t.bindAll(["_update","_onClose","remove","_onMouseMove","_onMouseUp","_onDrag"],this);}return e&&(o.__proto__=e),(o.prototype=Object.create(e&&e.prototype)).constructor=o,o.prototype.addTo=function(e){return this._map&&this.remove(),this._map=e,this.options.closeOnClick&&this._map.on("click",this._onClose),this.options.closeOnMove&&this._map.on("move",this._onClose),this._map.on("remove",this.remove),this._update(),this._trackPointer?(this._map.on("mousemove",this._onMouseMove),this._map.on("mouseup",this._onMouseUp),this._container&&this._container.classList.add("mapboxgl-popup-track-pointer"),this._map._canvasContainer.classList.add("mapboxgl-track-pointer")):this._map.on("move",this._update),this.fire(new t.Event("open")),this},o.prototype.isOpen=function(){return !!this._map},o.prototype.remove=function(){return this._content&&i.remove(this._content),this._container&&(i.remove(this._container),delete this._container),this._map&&(this._map.off("move",this._update),this._map.off("move",this._onClose),this._map.off("click",this._onClose),this._map.off("remove",this.remove),this._map.off("mousemove",this._onMouseMove),this._map.off("mouseup",this._onMouseUp),this._map.off("drag",this._onDrag),delete this._map),this.fire(new t.Event("close")),this},o.prototype.getLngLat=function(){return this._lngLat},o.prototype.setLngLat=function(e){return this._lngLat=t.LngLat.convert(e),this._pos=null,this._trackPointer=!1,this._update(),this._map&&(this._map.on("move",this._update),this._map.off("mousemove",this._onMouseMove),this._container&&this._container.classList.remove("mapboxgl-popup-track-pointer"),this._map._canvasContainer.classList.remove("mapboxgl-track-pointer")),this},o.prototype.trackPointer=function(){return this._trackPointer=!0,this._pos=null,this._update(),this._map&&(this._map.off("move",this._update),this._map.on("mousemove",this._onMouseMove),this._map.on("drag",this._onDrag),this._container&&this._container.classList.add("mapboxgl-popup-track-pointer"),this._map._canvasContainer.classList.add("mapboxgl-track-pointer")),this},o.prototype.getElement=function(){return this._container},o.prototype.setText=function(e){return this.setDOMContent(t.window.document.createTextNode(e))},o.prototype.setHTML=function(e){var i,o=t.window.document.createDocumentFragment(),r=t.window.document.createElement("body");for(r.innerHTML=e;i=r.firstChild;)o.appendChild(i);return this.setDOMContent(o)},o.prototype.getMaxWidth=function(){return this._container&&this._container.style.maxWidth},o.prototype.setMaxWidth=function(t){return this.options.maxWidth=t,this._update(),this},o.prototype.setDOMContent=function(t){return this._createContent(),this._content.appendChild(t),this._update(),this},o.prototype.addClassName=function(t){this._container&&this._container.classList.add(t);},o.prototype.removeClassName=function(t){this._container&&this._container.classList.remove(t);},o.prototype.toggleClassName=function(t){if(this._container)return this._container.classList.toggle(t)},o.prototype._createContent=function(){this._content&&i.remove(this._content),this._content=i.create("div","mapboxgl-popup-content"+(this.options.contentClass?" "+this.options.contentClass:""),this._container),this.options.closeButton&&(this._closeButton=i.create("button","mapboxgl-popup-close-button",this._content),this._closeButton.type="button",this._closeButton.setAttribute("aria-label","Close popup"),this._closeButton.innerHTML="&#215;",this._closeButton.addEventListener("click",this._onClose));},o.prototype._onMouseUp=function(t){this._update(t.point);},o.prototype._onMouseMove=function(t){this._update(t.point);},o.prototype._onDrag=function(t){this._update(t.point);},o.prototype._update=function(e){var o=this;if(this._map&&(this._lngLat||this._trackPointer)&&this._content&&(this._container||(this._container=i.create("div","mapboxgl-popup",this._map.getContainer()),this._tip=i.create("div","mapboxgl-popup-tip",this._container),this._container.appendChild(this._content),this.options.className&&this.options.className.split(" ").forEach((function(t){return o._container.classList.add(t)})),this._trackPointer&&this._container.classList.add("mapboxgl-popup-track-pointer")),this.options.maxWidth&&this._container.style.maxWidth!==this.options.maxWidth&&(this._container.style.maxWidth=this.options.maxWidth),this._map.transform.renderWorldCopies&&!this._trackPointer&&(this._lngLat=Or(this._lngLat,this._pos,this._map.transform)),!this._trackPointer||e)){var r=this._pos=this._trackPointer&&e?e:this._map.project(this._lngLat),a=this.options.anchor,n=function e(i){if(i){if("number"==typeof i){var o=Math.round(Math.sqrt(.5*Math.pow(i,2)));return {center:new t.Point(0,0),top:new t.Point(0,i),"top-left":new t.Point(o,o),"top-right":new t.Point(-o,o),bottom:new t.Point(0,-i),"bottom-left":new t.Point(o,-o),"bottom-right":new t.Point(-o,-o),left:new t.Point(i,0),right:new t.Point(-i,0)}}if(i instanceof t.Point||Array.isArray(i)){var r=t.Point.convert(i);return {center:r,top:r,"top-left":r,"top-right":r,bottom:r,"bottom-left":r,"bottom-right":r,left:r,right:r}}return {center:t.Point.convert(i.center||[0,0]),top:t.Point.convert(i.top||[0,0]),"top-left":t.Point.convert(i["top-left"]||[0,0]),"top-right":t.Point.convert(i["top-right"]||[0,0]),bottom:t.Point.convert(i.bottom||[0,0]),"bottom-left":t.Point.convert(i["bottom-left"]||[0,0]),"bottom-right":t.Point.convert(i["bottom-right"]||[0,0]),left:t.Point.convert(i.left||[0,0]),right:t.Point.convert(i.right||[0,0])}}return e(new t.Point(0,0))}(this.options.offset);if(!a){var s,l=this._container.offsetWidth,c=this._container.offsetHeight;s=r.y+n.bottom.y<c?["top"]:r.y>this._map.transform.height-c?["bottom"]:[],r.x<l/2?s.push("left"):r.x>this._map.transform.width-l/2&&s.push("right"),a=0===s.length?"bottom":s.join("-");}var h=r.add(n[a]).round();i.setTransform(this._container,Br[a]+" translate("+h.x+"px,"+h.y+"px)"),Fr(this._container,a,"popup");}},o.prototype._onClose=function(){this.remove();},o}(t.Evented),Qr={mapbox:{VectorTileLayer:t.VectorTileLayer,VectorTile:t.VectorTile},proj4:t.proj4,version:t.version,supported:e,setRTLTextPlugin:t.setRTLTextPlugin,getRTLTextPluginStatus:t.getRTLTextPluginStatus,VectorTileSource:C,Map:Lr,NavigationControl:Ar,GeolocateControl:qr,AttributionControl:xr,ScaleControl:Wr,FullscreenControl:Kr,Popup:Jr,Marker:Nr,Style:qe,CRS:Sr,LngLat:t.LngLat,LngLatBounds:t.LngLatBounds,Point:t.Point,MercatorCoordinate:t.MercatorCoordinate,Evented:t.Evented,config:t.config,prewarm:function(){Ut().acquire(kt);},clearPrewarmedResources:function(){var t=Bt;t&&(t.isPreloaded()&&1===t.numActive()?(t.release(kt),Bt=null):console.warn("Could not clear WebWorkers since there are active Map instances that still reference it. The pre-warmed WebWorker pool can only be cleared when all map instances have been removed with map.remove()"));},get accessToken(){return t.config.ACCESS_TOKEN},set accessToken(e){t.config.ACCESS_TOKEN=e;},get baseApiUrl(){return t.config.API_URL},set baseApiUrl(e){t.config.API_URL=e;},get workerCount(){return Ot.workerCount},set workerCount(t){Ot.workerCount=t;},get maxParallelImageRequests(){return t.config.MAX_PARALLEL_IMAGE_REQUESTS},set maxParallelImageRequests(e){t.config.MAX_PARALLEL_IMAGE_REQUESTS=e;},clearStorage:function(e){t.clearTileCache(e);},workerUrl:""};return Qr}));

//

if (window) {
    window.mapboxgl =mapboxgl;
}

return mapboxgl;

})));
//# sourceMappingURL=mapbox-gl-enhance.js.map
